let base64 = new Base64();


let interface1 = axios.create({
    'Access-Control-Allow-Origin': '*',
    baseURL: url,
    timeout: 10000
});
let interface3 = axios.create({
    'Access-Control-Allow-Origin': '*',
    baseURL: url,
    timeout: 10000
});
let loadingCount = 0;
let loading;
const startLoading = () => {
    vant.Toast.loading({
        message: '加载中...',
        forbidClick: true,
        duration: 10000
    });
};
const endLoading = () => {
    vant.Toast.clear()
};
const showLoading = () => {
    if (loadingCount === 0) {
        startLoading();
    }
    loadingCount += 1;
};
const hideLoading = () => {
    if (loadingCount <= 0) {
        return;
    }
    loadingCount -= 1;
    if (loadingCount === 0) {
        endLoading();
    }
};
//入参增加权限转换，默认需要
let isPermissionControl = true;
//权限等级参数设置，普元页面注入的方法
let permissionLevel = '01';
let permissionCode = '100000';
function getAccountPermission(level,code){
	if(code == '000000'){
		code = '100000';
	}
	permissionLevel = level;
	permissionCode = code;
}
function getAccountLevel(){
	return permissionLevel;
}
function getAccountCode(){
	return permissionCode;
}

function fixedEncodeURIComponent (str) {
	return encodeURIComponent(str).replace(/[!'()*]/g, function(c) {
		return '%' + c.charCodeAt(0).toString(16);
	});
}
/**
 * 根据下钻层级，返回最终传给后台的区域等级
 * areaLevel 1：全国，2：省，3：地市，4：区县
 * permissionLevel 01：集团，02：全国，03：省，04：地市，05：县，06：机构
 * @param level 下钻层级
 */
function getLevelFromPermission(level){
	if(permissionLevel == '01' || permissionLevel == '02'){
		return level;
	}else if(permissionLevel == '03'){
		return level + 1;
	}else if(permissionLevel == '04'){
		return level + 2;
	}else{
		return level + 3;
	}
}
/**
 * 根据下钻层级返回区域等级名称
 */
function getNameFromPermission(level,ignore3 = true){
	let lv = getLevelFromPermission(level);
	if(lv == 3 && ignore3){
		//部分页面地市直接下钻到机构，这里默认忽略了区县级
		lv = 4;
	}
	if(lv == 1){
		return '省份';
	}else if(lv == 2){
		return '地市';
	}else if(lv == 3){
		return '区县';
	}else{
		return '机构';
	}
}

interface1.interceptors.request.use(
    config => {
        showLoading();
        // config.headers['Content-Type'] = 'text/plain'
        config.headers['Content-Type'] = 'application/x-www-form-urlencoded;charset=UTF-8'

        // `transformRequest` 允许在向服务器发送前，修改请求数据（只能用在 'PUT', 'POST' 和 'PATCH' 这几个请求方法）
        // 此处post由json换成form表单提交方式，因为后台参数接收方式不支持json接收

        // 只有本地模拟数据，不用后台验签
            // 后台验签使用
            // 1.获取参数，并生成msgBody字符串
            let msgBody = {}
            if (config.method === 'post' || config.method == 'POST') {
                if (config.data) {
                    if (config.data.msgBody) {
                        // 删除上次请求的参数
                        delete config.data.msgBody
                    }
                }
                msgBody = config.data ? config.data : {}
                msgBody = JSON.stringify(msgBody)
            } else {
                if (config.params) {
                    if (config.params.msgBody) {
                        delete config.params.msgBody
                    }
                }
                msgBody = config.params ? config.params : {}

                //接口附加权限控制的level和code字段，如果涉及下钻，根据权限转换下钻层级
                if(isPermissionControl && permissionLevel){
                    msgBody.level = permissionLevel;
                    msgBody.code = permissionCode;
                    if(msgBody.areaLevel){
                    	msgBody.areaLevel = getLevelFromPermission(Number(msgBody.areaLevel));
                        if(!msgBody.areaCode){
                        	msgBody.areaCode = permissionCode;
                        }
                    }
                }

                msgBody = JSON.stringify(msgBody)
            }
            // 2.按规则生成签名
            const sendID = '00000001'
            const key = '83d7b121e335'
            const timestamp = dayjs().format('YYYY-MM-DD HH:mm:ss');
            const dataDigest = base64.encode(hex_md5(msgBody + key + timestamp))
            // 3.将验签内容，已参数形式传向后台
            // 插入验签内容(get形式)
            if (config.method == 'post' || config.method == 'POST') {
                config.data = {}
                config.data['sendID'] = sendID
                config.data['timestamp'] = timestamp
                config.data['msgBody'] = msgBody
                config.data['dataDigest'] = dataDigest
            } else {
                config.params = {}
                config.params['sendID'] = sendID
                config.params['timestamp'] = timestamp
                config.params['msgBody'] = msgBody
                config.params['dataDigest'] = dataDigest
            }
        return config
    },
    error => {
        // do something with request error
        return Promise.reject(error).catch((e) => {})
    },
    defaults => {}
);

interface1.interceptors.response.use(
    data => {
        hideLoading();
       /* if(data.data.flag && data.data.data !== 'null' && data.data.data !== '[]'){
        	return data.data;
        }else{
        	return "";
        }*/
      return data;
    },  
    error => {
        hideLoading();
        return Promise.reject(error)
    }
);



	let interface2 = axios.create({
    	'Access-Control-Allow-Origin': '*',
    	baseURL: url,
    	timeout: 10000
	});
	interface2.interceptors.request.use(
	    config => {
	        showLoading();
	        // config.headers['Content-Type'] = 'text/plain'
	        config.headers['Content-Type'] = 'application/x-www-form-urlencoded;charset=UTF-8'

	        // `transformRequest` 允许在向服务器发送前，修改请求数据（只能用在 'PUT', 'POST' 和 'PATCH' 这几个请求方法）
	        // 此处post由json换成form表单提交方式，因为后台参数接收方式不支持json接收


	        // 只有本地模拟数据，不用后台验签
	            // 后台验签使用
	            // 1.获取参数，并生成msgBody字符串
	            let msgBody = {}
	            if (config.method === 'post' || config.method == 'POST') {
	                if (config.data) {
	                    if (config.data.msgBody) {
	                        // 删除上次请求的参数
	                        delete config.data.msgBody
	                    }
	                }
	                msgBody = config.data ? config.data : {}
	                msgBody = JSON.stringify(msgBody)
	            } else {
	                if (config.params) {
	                    if (config.params.msgBody) {
	                        delete config.params.msgBody
	                    }
	                }
	                msgBody = config.params ? config.params : {}

	                //接口附加权限控制的level和code字段，如果涉及下钻，根据权限转换下钻层级
	                if(permissionLevel){
	                    msgBody.level = permissionLevel;
	                    msgBody.code = permissionCode;
	                    if(msgBody.areaLevel){
	                    	msgBody.areaLevel = getLevelFromPermission(Number(msgBody.areaLevel));
	                        if(!msgBody.areaCode){
	                        	msgBody.areaCode = permissionCode;
	                        }
	                    }
	                }

	                msgBody = JSON.stringify(msgBody)

	            }
	            // 2.按规则生成签名
	            const sendID = '00000001'
	            const key = '83d7b121e335'
	            const timestamp = dayjs().format('YYYY-MM-DD HH:mm:ss');
	            const dataDigest = base64.encode(hex_md5(msgBody + key + timestamp))
	            // 3.将验签内容，已参数形式传向后台
	            // 插入验签内容(get形式)
	            if (config.method == 'post' || config.method == 'POST') {
	                config.data = {}
	                config.data['sendID'] = sendID
	                config.data['timestamp'] = timestamp
	                config.data['msgBody'] = msgBody
	                config.data['dataDigest'] = dataDigest
	            } else {
	                config.params = {}
	                config.params['sendID'] = sendID
	                config.params['timestamp'] = timestamp
	                config.params['msgBody'] = msgBody
	                config.params['dataDigest'] = dataDigest
	            }
	        return config
	    },

	    error => {
	        // do something with request error
	        return Promise.reject(error).catch((e) => {})
	    },
	    defaults => {
	    }
	);

	interface2.interceptors.response.use(
	    data => {
	        hideLoading();
	        return data.data;
	    },
	    error => {
	        hideLoading();
	        return Promise.reject(error)
	    }
	);

interface3.interceptors.request.use(
    config => {
        showLoading();
    // config.headers['Content-Type'] = 'text/plain'
    config.headers['Content-Type'] = 'application/x-www-form-urlencoded;charset=UTF-8'

    // `transformRequest` 允许在向服务器发送前，修改请求数据（只能用在 'PUT', 'POST' 和 'PATCH' 这几个请求方法）
    // 此处post由json换成form表单提交方式，因为后台参数接收方式不支持json接收


    // 只有本地模拟数据，不用后台验签
    // 后台验签使用
    // 1.获取参数，并生成msgBody字符串
    let msgBody = {}
    if (config.method === 'post' || config.method == 'POST') {
        if (config.data) {
            if (config.data.msgBody) {
                // 删除上次请求的参数
                delete config.data.msgBody
            }
        }
        msgBody = config.data ? config.data : {}
        msgBody = JSON.stringify(msgBody)
    } else {
        if (config.params) {
            if (config.params.msgBody) {
                delete config.params.msgBody
            }
        }
        msgBody = config.params ? config.params : {}

        //接口附加权限控制的level和code字段，如果涉及下钻，根据权限转换下钻层级
        if(isPermissionControl && permissionLevel){
            msgBody.level = permissionLevel;
            msgBody.code = permissionCode;
            if(msgBody.areaLevel){
                // msgBody.areaLevel = getLevelFromPermission(Number(msgBody.areaLevel));
                if(!msgBody.areaCode){
                    msgBody.areaCode = permissionCode;
                }
            }
        }

        msgBody = JSON.stringify(msgBody)
    }
    // 2.按规则生成签名
    const sendID = '00000001'
    const key = '83d7b121e335'
    const timestamp = dayjs().format('YYYY-MM-DD HH:mm:ss');
    const dataDigest = base64.encode(hex_md5(msgBody + key + timestamp))
    // 3.将验签内容，已参数形式传向后台
    // 插入验签内容(get形式)
    if (config.method == 'post' || config.method == 'POST') {
        config.data = {}
        config.data['sendID'] = sendID
        config.data['timestamp'] = timestamp
        config.data['msgBody'] = fixedEncodeURIComponent(msgBody);
        config.data['dataDigest'] = dataDigest
    } else {
        config.params = {}
        config.params['sendID'] = sendID
        config.params['timestamp'] = timestamp
        config.params['msgBody'] = fixedEncodeURIComponent(msgBody);
        config.params['dataDigest'] = dataDigest
    }
    return config
    },
    error => {
        // do something with request error
        return Promise.reject(error).catch((e) => {})
    },
    defaults => {
    }
);

interface3.interceptors.response.use(
    data => {
    hideLoading();
    return data;
},
    error => {
    hideLoading();
    return Promise.reject(error)
}
);
