let server = {
	requestDefaultPeriod: function(params){
		return new Promise(function(resolve, reject){
		    let value = {
		    	success: true,
	       		result: "2020-11",
	    	}
		    resolve(value);
		});
	},
	requestTableData: function(params){
		return new Promise(function(resolve, reject){
		    let value = {
		    	success: true,
	       		result: [
				    {
				        "ITEM_CODE":"CTMS101",
				        "ITEM_NAME":"收寄",
				        "CURRENT_VAL":"1.82",
				        "COMPARE_VAL":"0.7%",
				        "COMPARE_VAL_COLOR":1,
				        "COMPARE_VAL_ARROW":-1,
				        "ARRIVE_PROC_NUM":11
				    },
				    {
				        "ITEM_CODE":"CTMS201",
				        "ITEM_NAME":"内部处理",
				        "CURRENT_VAL":"0.43",
				        "COMPARE_VAL":"1.8%",
				        "COMPARE_VAL_COLOR":1,
				        "COMPARE_VAL_ARROW":-1,
				        "ARRIVE_PROC_NUM":18
				    },
				],
	    	}
		    resolve(value);
		});
	},
	requestMapData: function(params){
		if(params.orgId != 'M-P'){
			return new Promise(function(resolve, reject){
			    let value = {
			    	success: true,
		       		result: [
					    {
					        "ORGCODE":"M1507-P",
					        "ORGNAME":"赤峰市",
					        "CNT":5
					    },
					    {
					        "ORGCODE":"M1513-P",
					        "ORGNAME":"兴安盟",
					        "CNT":2
					    }
					   ],
		    	}
			    resolve(value);
			});
		}
		
		return new Promise(function(resolve, reject){
		    let value = {
		    	success: true,
	       		result: [
				    {
				        "ORGCODE":"M15-P",
				        "ORGNAME":"内蒙古",
				        "CNT":5
				    },
				    {
				        "ORGCODE":"M34-P",
				        "ORGNAME":"安徽",
				        "CNT":4
				    }
				   ],
	    	}
		    resolve(value);
		});
	},
	requestRadarData: function(params){
		return new Promise(function(resolve, reject){
		    let value = {
		    	success: true,
	       		result: {
	       			"oldData": {
	       	            "chartData": [
	       	                {
	       	                    "name": "全国平均",
	       	                    "value": [
	       	                        "1.79",
	       	                        "0.75",
	       	                        "2.42",
	       	                        "0.96",
	       	                        "0.45"
	       	                    ]
	       	                },
	       	                {
	       	                    "name": "全国最优",
	       	                    "value": [
	       	                        "1.16",
	       	                        "0.32",
	       	                        "1.60",
	       	                        "0.63",
	       	                        "0.33"
	       	                    ]
	       	                },
	       	                {
	       	                    "name": "行业电商",
	       	                    "value": [
	       	                        "0.66",
	       	                        "0.03",
	       	                        "1.34",
	       	                        "0.82",
	       	                        "0.24"
	       	                    ]
	       	                }
	       	            ],
	       	            "chartDataLn": [
	       	                {
	       	                    "name": "全国平均",
	       	                    "value": [
	       	                        "2.0",
	       	                        "4.1",
	       	                        "1.6",
	       	                        "1.2",
	       	                        "1.6"
	       	                    ]
	       	                },
	       	                {
	       	                    "name": "全国最优",
	       	                    "value": [
	       	                        "1.6",
	       	                        "3.3",
	       	                        "1.2",
	       	                        "0.7",
	       	                        "1.3"
	       	                    ]
	       	                },
	       	                {
	       	                    "name": "行业电商",
	       	                    "value": [
	       	                        "1.0",
	       	                        "1.0",
	       	                        "1.0",
	       	                        "1.0",
	       	                        "1.0"
	       	                    ]
	       	                }
	       	            ],
	       	            "tipData": {
	       	                "行业电商": [
	       	                    "0.66",
	       	                    "0.03",
	       	                    "1.34",
	       	                    "0.82",
	       	                    "0.24"
	       	                ],
	       	                "全国最优": [
	       	                    "1.16",
	       	                    "0.32",
	       	                    "1.60",
	       	                    "0.63",
	       	                    "0.33"
	       	                ],
	       	                "全国平均": [
	       	                    "1.79",
	       	                    "0.75",
	       	                    "2.42",
	       	                    "0.96",
	       	                    "0.45"
	       	                ]
	       	            }
	       	        },
	       	        "newData": {
	       	            "S1": {				// 收寄
	       	                "AOC": {				// 全国平均
	       	                    "costAvg": "1.79",		//件均成本
	       	                    "industryMyltiple": 2.8 	//行业倍数
	       	                },
	       	                "BOC": {				// 全国最优
	       	                    "costAvg": "1.16",
	       	                    "industryMyltiple": 1.8
	       	                },
	       	                "I": {				// 行业电商
	       	                    "costAvg": "0.66",
	       	                    "industryMyltiple": 1.0
	       	                }
	       	            },
	       	            "S5": {				// 管理支撑
	       	            },
	       	            "S4": {				// 投递
	       	            },
	       	            "S3": {				// 运输
	       	            },
	       	            "S2": {				// 内部处理
	       	            }
	       	        }
	       	    },
	    	}
		    resolve(value);
		});
	},
	requestRadarDataPro: function(params){
		return new Promise(function(resolve, reject){
		    let value = {
		    	success: true,
	       		result: [
			        {
			            "ITEM_NAME": "收寄",
			            "ITEM_CODE": "CTMS101",
			            "SOY_VAL": "3.78",
			            "SOY_TARGET_MYLTIPLE": "1.0",
			            "LAST_YEAR_VAL": "3.79",
			            "LAST_YEAR_TARGET_MYLTIPLE": "1.0",
			            "T_VAL": "3.71",
			            "T_TARGET_MYLTIPLE": "1.0"
			        },
			        {
			            "ITEM_NAME": "投递",
			            "ITEM_CODE": "CTMS401",
			            "SOY_VAL": "5.78",
			            "SOY_TARGET_MYLTIPLE": "0.8",
			            "LAST_YEAR_VAL": "3.1",
			            "LAST_YEAR_TARGET_MYLTIPLE": "1.3",
			            "T_VAL": "3.1",
			            "T_TARGET_MYLTIPLE": "1.5"
			        }
			    ],
	    	}
		    resolve(value);
		});
	},
	requestLineData: function(params){
		return new Promise(function(resolve, reject){
		    let value = {
		    	success: true,
	       		result: {
				    "S3":[
				        {
				            "val":"1.15",
				            "month":"12月"
				        },
				        {
				            "val":"0.57",
				            "month":"1月"
				        }
				    ],
				    "S4":[
				          {
				            "val":"1.7",
				            "month":"12月"
				        },
				        {
				            "val":"0.7",
				            "month":"1月"
				        }],
				    "S5":[],
				    "S1":[],
				    "S2":[]
				},
	    	}
		    resolve(value);
		});
	},
	requestLineDataPro: function(params){
		return new Promise(function(resolve, reject){
		    let value = {
		    	success: true,
	       		result: {
			        "S3": [ // 运输
			            {
			                "val": "0.97",
			                "month": "01月",
			                "year": "2020年"
			            },
			            {
			                "val": "0.7",
			                "month": "02月",
			                "year": "2020年"
			            },
			        ],
			        "S4": [ ],//投递
			        "S5": [ ],//管理支撑
			        "S1": [ ],//收寄
			        "S2": [ ]//内部处理
			    },
	    	}
		    resolve(value);
		});
	},
	
	requestTableDataProv: function(params){
		return new Promise(function(resolve, reject){
		    let value = {
		    	success: true,
	       		result: {
	       		    "dataDescList": [
			            "内部处理环节-中心局及地市处理中心集包及发家的我说的金粉世家发的是率-天津市汇总:本月收寄端集包率大幅提升，中心局集包率略有下降，但较19年仍提高了6.8个百分点，增幅200%。",
			            "运输环节-中心局及地市处理中心集包率-天津市汇总:本月收寄端集包率大幅提升，中心局集包率略有下降，但较19年仍提高了6.8个百分点，傲娇佛那就哦佛的搜救发动机爱的激发dfjd增幅200%。",
						"内部处理环节-中心局及地市处理中心集包率-天津市汇总:本月收寄端集包率大幅提升，中心局集包率略有下降，但较19年仍提高了6.8个百分点，增幅200%。",
			            "运输环节-中心局及地市处理中心集包率-天津市汇总:本月收寄端集包率大幅提升，中心局集包率略有下降，但较19年仍提高了6.8个百分点，增幅200%。",
						"内部处理环节-中心局及地市处理中心集包率-天津市汇总:本月收寄端集包率大幅提升，中心局集包率略有下降，但较19年仍提高了6.8个百分点，增幅200%。",
			            "运输环节-中心局及地市处理中心集包率-天津市汇总:本月收寄端集包率大幅提升，中心局集包率略有下降，但较19年仍提高了6.8个百分点，增幅200%。"
			        ],
			        "dataDescSize": 2,
			        "tableData": [
			            {
			                "ITEM_CODE": "CTMS501",
			                "ITEM_NAME": "人均投递件数",
			                "CURRENT_VAL": "1.35",
			                "COMPARE_VAL": "0.3%",
			                "COMPARE_VAL_COLOR": 1,
			                "COMPARE_VAL_ARROW": -1,
			                "COMPARE_T_VAL": "87.7%",
			                "COMPARE_T_VAL_COLOR": 1,
			                "COMPARE_T_VAL_ARROW": -1,
			                "PROVICE_RANK": 28
			            },
						{
					 		"ITEM_CODE":"CTMS201",
					        "ITEM_NAME":"内部处理",
					        "CURRENT_VAL":"0.43",
					        "COMPARE_VAL":"1.8%",
					        "COMPARE_VAL_COLOR":1,
					        "COMPARE_VAL_ARROW":-1,
					        "COMPARE_T_VAL": "87.7%",
					        "COMPARE_T_VAL_COLOR": 1,
					        "COMPARE_T_VAL_ARROW": -1,
					        "PROVICE_RANK": 28
						},
						{
							 "ITEM_CODE":"CTMS201",
						     "ITEM_NAME":"内部处理",
							 "CURRENT_VAL":"0.43",
							 "COMPARE_VAL":"1.8%",
							 "COMPARE_VAL_COLOR":1,
							 "COMPARE_VAL_ARROW":-1,
							 "COMPARE_T_VAL": "87.7%",
							 "COMPARE_T_VAL_COLOR": 1,
							 "COMPARE_T_VAL_ARROW": -1,
							 "PROVICE_RANK": 28
						},
			        ],
			   
			    },
	    	};
		    resolve(value);
		});
	},
	requestSegmentTableDataProv: function(params){
		return new Promise(function(resolve, reject){
		    let value = {
		    	success: true,
	       		result: [
					   	   {
						            "ITEM_CODE": "CTMS101",
						            "CURRENT_VAL": "3.40",
						            "MEAS_NAME": "元/件",
						            "BEST_TYPE": "1",
						            "COMPUTE_ARROW": 1,
						            "COMPUTE_COLOR": 0,
						            "COMPUTE_RATE": "1.6%",
						            "LOWEST_VALUE": "1.83",
						            "LOWEST_VALUE_ORG_NAME": "北京房山",
						            "LOWEST_COLOR": 1,
						            "HIGHEST_VALUE": "6.62",
						            "HIGHEST_VALUE_ORG_NAME": "北京物流分公司",
						            "HIGHEST_COLOR": 0,
						            "NATION_RANKING": 29,
						            "T_COMPUTE_VAL": "96.6%",
						            "T_COMPUTE_COLOR": 1,
						            "T_COMPUTE_ARROW": -1,
						            "REMARK": null
						        }
					
					
						]
	    	}
		    resolve(value);
		});
	},
	requestItemDescData: function(params){
		return new Promise(function(resolve, reject){
		    let value = {
		    	success: true,
	       		result: [
					   	   {
						            "ITEM_CODE": "CTMS101",
						            "CURRENT_VAL": "3.40",
						            "MEAS_NAME": "元/件",
						            "BEST_TYPE": "1",
						            "COMPUTE_ARROW": 1,
						            "COMPUTE_COLOR": 0,
						            "COMPUTE_RATE": "1.6%",
						            "LOWEST_VALUE": "1.83",
						            "LOWEST_VALUE_ORG_NAME": "北京房山",
						            "LOWEST_COLOR": 1,
						            "HIGHEST_VALUE": "6.62",
						            "HIGHEST_VALUE_ORG_NAME": "北京物流分公司",
						            "HIGHEST_COLOR": 0,
						            "NATION_RANKING": 29,
						            "T_COMPUTE_VAL": "96.6%",
						            "T_COMPUTE_COLOR": 1,
						            "T_COMPUTE_ARROW": -1,
						            "REMARK": null
						        }
					
					
						]
	    	}
		    resolve(value);
		});
	},
	
	
};