const DimItem = {
	CTMS101: '收寄',
	CTMS201: '内部处理',
	CTMS301: '运输',
	CTMS401: '投递',
	CTMS501: '管理支撑',
	CTMS111: '人均收寄件数',
	CTMS112: '散件揽收提成',
	CTMS113: '外包单价',
	CTMS114: '收寄端集包率',
	CTMS211: '人均处理件数',
	CTMS212: '外包单价',
	CTMS213: '中心局及地市处理中心集包率',
	CTMS214: '分拣设备实际处理效率',
	CTMS311: '装载率',
	CTMS312: '单边邮路占比',
	CTMS313: '大车发车量占比',
	CTMS411: '人均投递件数',
	CTMS412: '计件薪酬',
	CTMS413: '揽投人均薪酬',
	CTMS414: '外包单价',
	CTMS415: '快递包裹自提代投比例',
	CTMS416: '快递包裹自提代投单价',
	CTMS512: '管理支撑环节人员占比',
	CTMS513: '中心局管理支撑环节人员占比',
	CTMS323: '国内航空单位成本',
	CTMS305: '委办吨公里单价',
};

const DimItemLine = {
	CTMS101: 'S1',
	CTMS201: 'S2',
	CTMS301: 'S3',
	CTMS401: 'S4',
	CTMS501: 'S5',
};
//获取选中的月份
function getMonth(date) {
	let month = date.substr(5, 2);
	if(month[0] == '0') {
		month = month.substr(1, 1);
	}
	return month;
}

const MAPNAME = {

	"安徽": "anhui",

	"澳门": "aomen",

	"北京": "beijing",

	"重庆": "chongqing",

	"福建": "fujian",

	"甘肃": "gansu",

	"广东": "guangdong",

	"广西": "guangxi",

	"贵州": "guizhou",

	"海南": "hainan",

	"河北": "hebei",

	"黑龙江": "heilongjiang",

	"河南": "henan",

	"湖北": "hubei",

	"湖南": "hunan",

	"江苏": "jiangsu",

	"江西": "jiangxi",

	"吉林": "jilin",

	"辽宁": "liaoning",

	"内蒙古": "neimenggu",

	"宁夏": "ningxia",

	"青海": "qinghai",

	"山东": "shandong",

	"上海": "shanghai",

	"山西": "shanxi",

	"陕西": "shanxi1",

	"四川": "sichuan",

	"台湾": "taiwan",

	"天津": "tianjin",

	"香港": "xianggang",

	"新疆": "xinjiang",

	"西藏": "xizang",

	"云南": "yunnan",

	"浙江": "zhejiang",

};
//指标说明弹窗
function tooltip(title, data) {
	let tooltipHtml = '<div class="tooltip">' +
		'<div class="tooltip_box">' +
		'<div class="tooltip_title">' + title + '</div>' +
		'<div class="tooltip_content">' +
		'<div class="tooltip_row">' +
		'<p class="tooltip_row_name">指标业务口径：</p>' +
		'<p class="tooltip_row_value">' + data.itemDesc + '</p>' +
		'</div>' +
		'<div class="tooltip_row">' +
		'<p class="tooltip_row_name">补充说明：</p>' +
		'<p class="tooltip_row_value">' + formatData(data.remark) + '</p>' +
		'</div>' +
		'<div class="tooltip_row">' +
		'<span class="tooltip_row_name">单位：</span>' +
		'<span class="tooltip_row_value">' + data.measName + '</span>' +
		'</div>' +
		'<div class="tooltip_row">' +
		'<span class="tooltip_row_name">来源：</span>' +
		'<span class="tooltip_row_value">' + data.itemSrc + '</span>' +
		'</div>' +
		'</div>' +
		'</div>' +
		'<div class="tooltip_close" onclick="closeTooltip()"></div>' +
		'</div>';
	return tooltipHtml;
};

function closeTooltip() {
	$('.tooltip').remove();
};

function noData() {
	let nohtml = '<div class="noData">暂无数据</div>';
	return nohtml;
};

function formatData(data,unit){
	if(data==0){
		return data;
	}else if(data==''||data==null||data=='undefined'||data=='%'){
		return '-';
	}
	if(unit){
		return data + unit;
	}
	return data;
}
function formaDataName(data,name,unit){
	if(data==0){
		data=data;
	}else if(data==''||data==null||data=='undefined'||data=='%'){
		data= '-';
	}
	if(name==''||name==null||name=='undefined'||name=='%'){
		name='-';
	}
	if(data=='-'&&name=='-'){
		return '-';
	}
	if(unit){
		return data+unit+'('+name+')';
	}
	return data+'('+name+')';
}

function notEmpty(arg){
	return arg !== null && arg !== undefined && arg !== '';
}