Vue.component('detail', {
	data() {
		return {
			show: false, // 确认框
			labelWidth: '110px',
			info:{}
			// info格式
			// info = {
			// 	title: '我是给app测试的',
			// 	fileNum: '222',
			// 	name: '333',
			// 	category: '44',
			// 	isOnlook: '',
			// 	isSign: '',
			// 	state: '',
			// 	startTime: '',
			// 	endTime: ''
			// }
		}
	},
	props:{
		isSend:{
			type: Boolean,
			default: true
		},
		// 详情信息
		info: {
			type: Object,
			default: ()=>{
				return {
					title: '',
					fileNum: '',
					categoryName: '',
					category: '',
					isOnlook: '',
					isSign: '',
					state: '',
				}
			}
		},
		// 推送进入的详情
		isPushCome: {
			type: Boolean,
			default: false
		}
	},
	created() {
		
	},
	methods:{
		
		
		// 签收
		sign() {
			this.$emit('sign')
		},
		
		
		
		
		// 拼接下载链接
		makeDownloadUrl(item) {
			// return 'http://cn.createpdfonline.org/pdffiles/qw(20211026164043).pdf';
			
			return getDownloadUrl({
				fileName: item.fileName,
				fileRealname: item.fileRealname
			})
			
		},
		
		// 下载
		download(item) {
			const url = getDownloadUrl({
				fileName: item.fileName,
				fileRealname: item.fileRealname
			});
			const url1 =  encodeURI(url)
			try{
				Emp.execute(`download('${url1}')`)
			}catch(e){
				console.log(e)
			}
		}
	},
	template:`
		<div>
			<van-field v-model="info.title" label="通知标题" :label-width="labelWidth" readonly  />
					
			<van-field v-model="info.categoryName" label="通知类型" :label-width="labelWidth" readonly />
			
			<van-field v-model="info.fileNum" label="文号" :label-width="labelWidth" readonly />
			
			<van-field v-model="info.publishUnit" label="发文单位" :label-width="labelWidth" readonly />
			
			<van-field v-model="info.stateName" label="通知状态" :label-width="labelWidth" readonly />
			
			<van-field :value="info.publishTime | formatTime" label="发布/草稿时间" :label-width="labelWidth" readonly />
			
			<van-field v-model="info.publishPerson" label="发布人姓名" :label-width="labelWidth" readonly />	
			
			<van-field v-model="info.isOverseeName" label="是否督办" :label-width="labelWidth" readonly />
			
			<van-field v-if="!isSend" v-model="info.isFeedbackName" label="是否反馈" :label-width="labelWidth" readonly />
			
			<van-field v-if="!isSend" v-model="info.isSignName" label="是否签收" :label-width="labelWidth" readonly>
				<template slot="input">
						<div style="width:100%;display:flex;">
							<span style="flex:2;">{{ info.isSignName }}</span>
							<span v-if="info.receiveFlag == 0 && info.isSign == 0" @click="show = true" style="flex:1.5;color:blue;cursor: pointer;">签收</span>
						<div>
				</template>
			</van-field>
			
			<van-overlay :show="show" :z-index="99999" @click="show = false">
				<van-dialog
					v-model="show"
					title="确定签收此通知?"
					show-cancel-button
					@confirm="sign"></van-dialog>
			</van-overlay>
			
			<van-field v-if="isSend" v-model="info.isSignOverName" label="是否签收完毕" :label-width="labelWidth" readonly />
		
			<van-field v-if="isSend" v-model="info.signRate" label="签收率" :label-width="labelWidth" readonly />
			
			<van-field v-if="info.fileList" label="附件" :label-width="labelWidth">
			  <template slot="input">
					<div>
						<div v-for="(item, key) in info.fileList" :key="key">
							<span  @click="download(item)" style="color:blue;">{{ item.fileRealname }} </span>
							<van-divider v-show="key != info.fileList.length - 1" />
						</div>
					<div>
			  </template>
			</van-field>
			
			<van-field
			  v-if="!isSend && info.feedbackContent"
			  v-model="info.feedbackContent"
			  :label-width="labelWidth"
			  autosize
			  label="反馈内容"
			  type="textarea"
			  readonly>
			</van-field>
			
		</div>
	`
})




