Vue.component('feedback', {
	data(){
		return {

		}
	},
	props:{
		// 反馈内容
		message: {
			type: String,
			default: ''
		},
		
		// 是否可编辑
		disabled: {
			type: Boolean,
			default: false
		}
	},
	methods:{
		// 取消搜索
		cancel() {
			this.$emit('close')
		},
		
		// 确认搜索
		confirm() {
			if(this.message === '') {
				vant.Toast({
					type: 'fail',
					message: '反馈内容不能为空',
					className: 'inexa'
				})
				return false
			}
			this.disabled = true
			this.$emit('confirm', this.message)
		},
	},
	template: `
		<div>
			<van-field
			  v-model="message"
			  rows="5"
			  autosize
			  label="反馈内容"
			  type="textarea"
			  maxlength="800"
			  placeholder="请输入反馈内容"
			  show-word-limit
			  :disabled="disabled"
			  style="margin:50px 0;"
			/>
			
			<div style="margin-top:50px; display:flex;">
				<van-button round type="warning" size="small" @click="cancel" style="flex:1;margin:0 10px;" >取消</van-button>
				<van-button round type="info" size="small" @click="confirm" style="flex:1;margin:0 10px;">提交</van-button>
			</div>
		
		</div>
	`
})