Vue.component('filter-options-box',{
	data() {
		return {
			options0: {
				text: '全部',
				value: 0
			}, 
			checkedOptionsText: '', // 选中的选项名，形如：'选项1，选项2'
			checkedOptionsValue: '', // 选中的选项value，形如：'1，2'
		}
	},
	props: {
	
		// 控制选项框显示
		show: {
			type: Boolean,
			default: false
		},

		// 是否单选
		radio: {
			type: Boolean,
			default: false
		},
		
		// 选项
		options: {
			type: Array,
			default: ()=>{
				return []
			}
		},
		
		// 已选中的选项id，形如："1,2,3"
		checkedOptions: {
			type: Array,
			default: []
		},
		
		
	},
	created() {
		if(!this.radio){
			// 多选情况，插入全部分类
			this.options.unshift(this.options0);
		}
		
	},
	
	methods: {
		
		// 选择此选项
		// value num 选项编号
		checkOption(value) {
			
			
			if(value == this.options0.value) {
				// ? 全取消 : 全选;
				this.checkedOptions = this.isChecked(value) ? [] : this.options.map(item => item.value); 
				
			} else {
				// this.isChecked(value) ? this.checkedOptions = this.checkedOptions.filter(item => item != value) : this.checkedOptions.push(value); 
				
				// ? 取消 : 选中;
				if(this.isChecked(value)) {
					this.checkedOptions = this.checkedOptions.filter(item => item != value)
				} else {
					// this.checkedOptions.push(value)
					// ? 单选替换 : 多选追加;
					this.radio ? this.checkedOptions = `${value}` : this.checkedOptions.push(value);
					
					
				}
				
			}
			
			
			// 当全选时，选择全部
			if(!this.radio &&  this.checkedOptions.length == this.options.length - 1) {
				const index = this.checkedOptions.indexOf(this.options0.value); // 获取索引index
				// ? 选择全选 : 去掉全选;
				index == -1 ? this.checkedOptions.push(this.options0.value) : this.checkedOptions.splice(index,1);
			}
			
			// 
			const checkOptions = this.options.filter(item => this.isChecked(item.value));
			this.checkedOptionsText = checkOptions.map(item => item.text).join(',');
			this.checkedOptionsValue = checkOptions.map(item => item.value).join(',');
			
			
		},
		
		// 判断是否被选中
		isChecked(value) {
			return this.checkedOptions.includes(value);
		},
		
		// 取消操作
		cancelOptionsBox() {
			this.$emit('update:show', false)
		},
		
		// 确认操作
		comfirmOptionsBox() {
			
			this.$emit('put-checked-options', {
				texts: this.checkedOptionsText,
				values: this.checkedOptionsValue,
			})
			
			this.$emit('update:show', false)
		},
		
	},
	
	template:
	`
		<div v-show="show" class="filter-option-alert">
			<div class="chosen-option">已选分类：<span> {{ checkedOptionsText }} </span></div>
			<div 
				v-for="(item,key) in options" 
				:key="key" 
				class="option-item"
				:class="{checked: isChecked(item.value),'option-item-radio': radio}" 
				@click="checkOption(item.value)">
				{{ item.value }}-{{ item.text }}
			</div>
			
			<div class="filter-box-action options-box-action">
				<span class="cancel bg-color-gray " @click="cancelOptionsBox"> 取消</span>
				<span class="comfirm bg-color-green" @click="comfirmOptionsBox">确定</span>
			</div>
		</div>
	`
})