Vue.component('sign-rate', {
	data() {
		return {
			labelWidth: '110px',
			pageNo: 1,
		}
	},
	props:{
		// 详情信息
		info: {
			type: Object,
			default: () => {
				return {
					title: '',
					publishTime: '',
					needSignOrgNum: '',
					hadSignOrgNum: '',
					signRate: '',
				}
			}
		},
		// 列表数据
		// 格式如下:
		// [{
		// 	needSignOrgName: '中国邮政集团公司',
		// 	needSignJob: '省寄递运营管理部负责人',
		// 	realSignOrgName: '中国邮政集团公司',
		// 	realSignPerson: '00000100ADMIN35389',
		// 	realSignTime: 25641265,
		// 	needSignTime: 42213,
		// 	feedbackPerson: '测试反馈人',
		// 	feedbackInfo: '测试反馈信息测试反馈信息测试反馈信息',
		// 	feedbackTime: 454546122,
		// 	needFeedbackTime: 1445614661
		// }]
		list: {
			type: Array,
			default: () => {
				return []
			}
		},
		
		
		
		
	},
	created() {
		console.log(123)
	},
	methods:{
		load() {
			
			console.log(333333333333)
			
			this.$emit('load-more', true)
		}
	},
	template:`
		<div style="height:100vh;display: flex;flex-direction: column;">
				<van-field v-model="info.title" label="通知标题" :label-width="labelWidth" readonly  />
						
				<van-field :value="info.publishTime | formatTime" label="发布时间" :label-width="labelWidth" readonly />
				
				<van-field v-model="info.needSignOrgNum" label="应签收机构数" :label-width="labelWidth" readonly />
				
				<van-field v-model="info.hadSignOrgNum" label="已签收机构数" :label-width="labelWidth" readonly />
				
				<van-field v-model="info.signRate" label="签收率" :label-width="labelWidth" readonly />
				
				<el-table
					:data="list"
					border
					stripe
					fit
					height="100%"
					v-loadmore="load"
					style="width: 100%;flex:1;">
					
					<el-table-column
					  label="序号"
					   type="index"
					   width="50"
					   align="center"
					   fixed
					></el-table-column>
					
					<el-table-column
						prop="needSignOrgName"
						label="应签收机构"
						align="center"
					></el-table-column>
					
					<el-table-column
						prop="needSignJob"
						label="应签收岗位"
						align="center"
					></el-table-column>
					
					<el-table-column
						prop="realSignOrgName"
						label="实际签收机构"
						align="center"
					></el-table-column>
					
					<el-table-column
						prop="realSignPerson"
						label="签收人"
						align="center"
					></el-table-column>
				
					<el-table-column
						label="签收时间"
						align="center"
					>
						<template slot-scope="scope">
							<div>{{ scope.row.realSignTime | formatTime }}</div>
						</template>
					</el-table-column>
					
					<el-table-column
						label="规定签收时间"
						align="center"
					>
						<template slot-scope="scope">
							<div>{{ scope.row.needSignTime | formatTime }}</div>
						</template>
					</el-table-column>
					
					<el-table-column
						prop="feedbackPerson"
						label="反馈人"
						align="center"
					></el-table-column>
					
					<el-table-column
						prop="feedbackInfo"
						label="反馈信息"
						align="center"
					></el-table-column>
					
					<el-table-column
						label="反馈时间"
						align="center"
					>
						<template slot-scope="scope">
							<div>{{ scope.row.feedbackTime | formatTime }}</div>
						</template>
					</el-table-column>
					
					<el-table-column
						label="规定反馈时间"
						align="center"
					>
						<template slot-scope="scope">
							<div>{{ scope.row.needFeedbackTime | formatTime }}</div>
						</template>
					</el-table-column>
				
				</el-table>
			
		</div>
	`
})