var panel = {
	props: ['isShow', 'panelArr', 'panelData', 'countDate','noData','noDatato'],
	data() {
		return {
			
            //弹框
            isShowDialog: false,
            dialogTitle: '',
            dialogList: {},
		}
	},
	template: `
		<div class="topTab">
			<div v-if="!noData" class="panelCardBox">
				<div 
					class="panelCard radiu-shadow"
					v-for="item in panelArr" :key="item.id"
					v-show="panelData[item.dataKey]"
					
				>
					<p class="panelTitle">
						<img class="titleImg" :src="item.imgUrl" :alt="item.title" />
						<span>{{item.title}}</span>
						<img src="../../image/description_icon.png" alt="注释"  @click="openDialog(item)" />
					</p>
					<div class="panelContent" @click="goToDetail(item)">
					<div class="panelContentLeft">
						<p class="textCenter color333">实绩</p>
						<p class="textCenter ratio">{{formatNum(panelData[item.dataKey], 'achievements',item.dataKey)}}<span class="unit">{{item.unit}}</span></p>
						<p class="textCenter color333">较上月累计:
							<span  v-if="item.indextext=='0'" :class="panelData[item.dataKey].achievementsto ==null ? 'fontBold color333' : ( panelData[item.dataKey] && panelData[item.dataKey].achievementsto > 0  ? 'fontBold colorUp' : 'fontBold colorDown')">{{formatNum(panelData[item.dataKey], 'achievementsto',item.dataKey)}}</span>
							<span  v-if="item.indextext=='1'" :class="panelData[item.dataKey].achievementsto ==null ? 'fontBold color333' : ( panelData[item.dataKey] && panelData[item.dataKey].achievementsto < 0  ? 'fontBold colorUp' : 'fontBold colorDown')">{{formatNum(panelData[item.dataKey], 'achievementsto',item.dataKey)}}</span>
							<span class="unit">{{item.unit}}</span>
							</p>
							
					</div>
					
					<div class="panelContentRight">
						<p class="textCenter color333">目标值</p>
						<p class="textCenter ratio">{{formatNum(panelData[item.dataKey], 'target',item.dataKey)}}<span class="unit">{{item.unit}}</span></p>
						<p class="textCenter color333" >较目标值:
							<span  v-if="item.indextext=='0'" :class="panelData[item.dataKey] && panelData[item.dataKey].targetto > 0  ? 'fontBold colorUp' : 'fontBold colorDown'">{{formatNum(panelData[item.dataKey], 'targetto',item.dataKey)}}</span>
							<span  v-if="item.indextext=='1'" :class="panelData[item.dataKey] && panelData[item.dataKey].targetto < 0  ? 'fontBold colorUp' : 'fontBold colorDown'">{{formatNum(panelData[item.dataKey], 'targetto',item.dataKey)}}</span>
							<span class="unit">{{item.unit}}</span>
							</p>
					</div>
					
					</div>
	
				</div>
			
			
				<!-- 注释弹框 -->
				<xk-dialog @func="closeDialog" :visible='isShowDialog' :title="dialogTitle" :data-list="dialogList"></xk-dialog>
			</div>
			
			
		</div>
	`,
	watch: {
		
	},
	methods: {
        // 跳转到详情页
        goToDetail(item) {
            let param = {
                indexType: item.id,
                title: item.title,
                countDate: this.countDate
            };
            param = JSON.stringify(param);
            console.log(item)
            Emp.execute('goToDetail('+param+')');
            
        },
        // 数据格式化
        formatNum(data, key,datakey) {
        	
        	let nameArr = ['achievements', 'target', 'achievementsto', 'targetto'];

        	if(datakey==0||datakey==1||datakey==4||datakey==5||datakey==6||datakey==7){
        		return data ? (data[key] ? Number(data[key]*1).toFixed(2) + "%" : '--%') : '--%';
        	}
        	if(datakey==2||datakey==3||datakey==8||datakey==9||datakey==10||datakey==11||datakey==12||datakey==13||datakey==14){
        		return data ? (data[key] ? Number(data[key]*1).toFixed(2) : '--') : '--';
        	}
            if ( nameArr.indexOf(key) !== -1) {
                return data ? data[key] : '';
            } else {
                return data ? (data[key] ? Number(data[key]*100).toFixed(2) + "" : '--%') : '--%';
            }

        },
        // 打开注释弹框
        openDialog(item) {
            this.dialogTitle = item.dialogTitle;
            this.dialogList = item.dialog;
            this.isShowDialog = true;
        },
        // 关闭注释弹框
        closeDialog() {
            this.isShowDialog = false;
        },
        // 关闭提示
        close() {
            this.tipShow = false;
        }
	}

};
