/**
 * 接口请求: 五大看板-市场-营销
 */

/*
 * 活跃客户汇总
 */
const requestActiveGlobal = (data) => {
    return interface1({
        url: '/fiveboard/customerIndustry/getCustomerIndustryStatics',
        method: 'get',
        params: data,
    });
};
/*
 * 预警客户汇总
 */
const requestWarnGlobal = (data) => {
    return interface1({
        url: '/fiveboard/customerStat/getWarnCustomerStatics',
        method: 'get',
        params: data,
    });
};

/*
 * 活跃客户-按行业-饼图，表格
 */
const requestActivePieTableByIndustry = (data) => {
    return interface1({
        url: '/fiveboard/customerIndustry/getCustomerDetailByIndustryGradeOne',
        method: 'get',
        params: data,
    });
};
/*
 * 活跃客户-按等级-饼图，表格
 */
const requestActivePieTableByLevel = (data) => {
    return interface1({
        url: '/fiveboard/customer/selectActiveCustomerDetailByStatDateAndClassify',
        method: 'get',
        params: data,
    });
};
/*
 * 活跃客户-按行业-数量占比饼图下钻页面
 */
const requestActiveDrillByIndustryPieNumber = (data) => {
    return interface1({
        url: '/fiveboard/customerIndustry/selectActiveCustomerDetailByDistribute',
        method: 'get',
        params: data,
    });
};
/*
 * 活跃客户-按行业-收入占比饼图下钻页面
 */
const requestActiveDrillByIndustryPieIncome = (data) => {
    return interface1({
        url: '/fiveboard/customerIndustry/selectActiveCustomerDetailByIncome',
        method: 'get',
        params: data,
    });
};
/*
 * 活跃客户-按等级-数量占比饼图下钻页面
 */
const requestActiveDrillByLevelPieNumber = (data) => {
    return interface1({
        url: '/fiveboard/customer/selectCustomerDistribution',
        method: 'get',
        params: data,
    });
};
/*
 * 活跃客户-按等级-收入占比饼图下钻页面
 */
const requestActiveDrillByLevelPieIncome = (data) => {
    return interface1({
        url: '/fiveboard/customer/selectCustomerIncome',
        method: 'get',
        params: data,
    });
};
/*
 * 活跃客户-按行业表格下钻-按二级行业
 */
const requestActiveDrillByIndustry2 = (data) => {
    return interface1({
        url: '/fiveboard/customerIndustry/getCustomerDetailByIndustryGradeTwo',
        method: 'get',
        params: data,
    });
};
/*
 * 活跃客户-按行业表格下钻-按省份
 */
const requestActiveDrillByIndustryPro = (data) => {
    return interface1({
        url: '/fiveboard/customerIndustry/selectActiveCustomerDetailByIndustry',
        method: 'get',
        params: data,
    });
};
/*
 * 活跃客户-按行业表格下钻-按省份-趋势
 */
const requestActiveDrillTrendByIndustryPro = (data) => {
    return interface1({
        url: '/fiveboard/customerIndustry/selectCustomerIndustryTrendByDate',
        method: 'get',
        params: data,
    });
};
/*
 * 活跃客户-按等级表格下钻
 */
const requestActiveDrillByLevel = (data) => {
    return interface1({
        url: '/fiveboard/customer/selectCustomerDetailByAreaCode',
        method: 'get',
        params: data,
    });
};
/*
 * 活跃客户-按等级表格下钻-趋势
 */
const requestActiveDrillTrendByLevel = (data) => {
    return interface1({
        url: '/fiveboard/customer/selectCustomerDetailTrendByAreaCode',
        method: 'get',
        params: data,
    });
};
/*
 * 活跃客户-按行业-排行榜
 */
const requestActiveSortPage = (data) => {
    return interface1({
        url: '/fiveboard/customerIndustry/getActiveCustomerRankByIndustry',
        method: 'get',
        params: data,
    });
};
/*
 * 活跃客户-按等级-排行榜
 */
const requestActiveSortPageByLevel = (data) => {
    return interface1({
        url: '/fiveboard/customer/getActiveCustomerRankByGrade',
        method: 'get',
        params: data,
    });
};
/*
 * 整体预警
 */
const queryWholeWarn = (data) => {
    return interface1({
        url: '/fiveboard/customerStat/queryWholeWarn',
        method: 'get',
        params: data,
    });
}
/*
 * 疑似流失
 */
const queryLossCustomer = (data) => {
    return interface1({
        url: '/fiveboard/loss/selectWarnCustomerDataByAreaCode',
        method: 'get',
        params: data,
    });
}
/*
 * 疑似流失特级客户明细
 */
const queryLossCustomerDetail = (data) => {
    return interface1({
        url: '/fiveboard/loss/selectWarnCustomerDetailByAreaCode',
        method: 'get',
        params: data,
    });
}
/*
 * 等级预警
 */
const queryLevelWarn = (data) => {
    return interface1({
        url: '/fiveboard/loss/selectLevelWarningByAreaCode',
        method: 'get',
        params: data,
    });
}
/*
 * 等级预警特级客户明细
 */
const queryLevelWarnDetail = (data) => {
    return interface1({
        url: '/fiveboard/loss/selectLevelWarningDetailByAreaCode',
        method: 'get',
        params: data,
    });
}
/*
 * 现费客户汇总
 */
const requestFeeGlobal = (data) => {
    return interface1({
        url: '/fiveboard/feeCustomer/getFeeCustomerStatics',
        method: 'get',
        params: data,
    });
};
/*
 * 现费客户-饼图,表格
 */
const requestFeePieTable = (data) => {
    return interface1({
        url: '/fiveboard/feeCustomer/getFeeCustomerPieAndDetail',
        method: 'get',
        params: data,
    });
};

/*
 * 现费客户二级页面——echart
 */
const getFeeCustomerTrend = (data) => {
    return interface1({
        url: '/fiveboard/feeCustomer/getFeeCustomerTrend',
        method: 'get',
        params: data,
    });
};
/*
 * 现费客户二级页面——table
 */
const getFeeCustomerDetailByProduct = (data) => {
    return interface1({
        url: '/fiveboard/feeCustomer/getFeeCustomerDetailByProduct',
        method: 'get',
        params: data,
    });
};
/*
 * 现费客户-排行榜
 */
const requestFeeSortPage = (data) => {
    return interface1({
        url: '/fiveboard/feeCustomer/getFeeCustomerRank',
        method: 'get',
        params: data,
    });
};