/**
 * yy
 */
//指标下钻
Vue.component('lineBarBox', {
    data() {
        return {
        }
    },
    props: {
    	list: [],
        specialName: {
            Array,
            default: () => {
                return ['总计','其他']
            }
        },
        legend: [],
        valueName:{
	        Array,
	        default: () => {
	            return ['增幅(%)','客户数(万)']
	        }
	    },
        echartName:'',
    },
    computed: {
    },
    methods: {
    	initDefault() {
            document.documentElement.scrollIntoView();
            const newList = this.list.sort((i, n) => {
                return Number(i.nameCode) - Number(n.nameCode)
            });
            const arr = newList.filter(e => this.specialName.indexOf(e.name) < 0)
            const xData = arr.map(i => i.name);
            const yData = arr.map(i => i.value);
            const y2Data = arr.map(i => i.value2);
            this.initEcharts2(xData, yData, y2Data);
        },
        initEcharts2(xData, yData, y2Data) {
            const _this = this
            let mychart2 = echarts.init(this.$refs.chart2);
            let legend = {
            	data: _this.legend,
            	right: 10,
            };
            //解决title超长覆盖图例的问题
            const w = document.documentElement.clientWidth || document.body.clientWidth;
            let s = w * 0.37 / _this.echartName.length.toFixed(0);
            s = s >= 17 ? 17 : s;
            s = s <= 8 ? 8 : s;
            let option2 = {
                title: {
                    text: _this.echartName,
                    textStyle: {
                        fontSize: s,
                    },
                },
                color: ['#0199FF'],
                tooltip: {
                    trigger: 'axis',
                    axisPointer: { // 坐标轴指示器，坐标轴触发有效
                        type: 'shadow' // 默认为直线，可选为：'line' | 'shadow'
                    },
                    formatter:function(param){
                    	let arr = param.filter(e => e.value || e.value == 0);
                    	if(!arr || arr.length <= 0){
                    		 return '';
                    	}
                    	let x = arr[0].name;
                    	if(x){
                    		let n9 = Math.floor(x.length / 9);
                    		for(let n=n9;n>0;n--){
                    			x = x.slice(0, n*9) + '<br/>' + x.slice(n*9);
                    		}
                    		//如果是整倍数，需要移除最后一个换行符...
                    		if(x.substr('<br/>'.length * -1) == '<br/>'){
                    			x = x.slice(0,x.length - '<br/>'.length);
                    		}
                    	}
                    	arr.forEach((e,i) => {
                    		let unit;
                    		let v = _this.valueName[0];
                    		//隐藏某个图例后，valueName数组和param的数组索引不会对应
                    		_this.valueName.forEach(it => {
                    			if(it.indexOf(e.seriesName) >= 0){
                    				v = it;
                    			}
                    		});
                        	let l = v.indexOf('(');
                        	let r = v.indexOf(')');
                        	if(l + r > 1){
                                unit = v.substring(l+1,r);
                        	}
                    		x += '<br/>' + e.marker + e.seriesName + ' : ' + e.value;
                    		if(unit){
                                x += unit;
                    		}
                    	});
                    	return x;
                    },
                },
                legend: legend,
                grid: {
                    top: '20%',
                    left: '4%',
                    right: '4%',
                    bottom: '15%',
                    containLabel: true
                },
                xAxis: [{
                    type: 'category',
                    nameGap: 30,
                    data: xData,
                    "axisLine": {
                        lineStyle: {
                            color: '#90979c'
                        }
                    },
                    "splitLine": {
                        "show": false
                    },
                    "axisTick": {
                        "show": false
                    },
                    "splitArea": {
                        "show": false
                    },
                    "axisLabel": {
                        interval: 0,
                        rotate: 40,
                        formatter: (val) => {
                            if (val.length > 8) return val.substring(0, 8) + '...'
                            else return val
                        }

                    }
                }],
                yAxis: [{
                    type: 'value',
                    name: _this.valueName[0],
                    nameTextStyle: {
                    	fontSize: 11,
                    	padding: [0, 0, 10, 40],
                    },
                    axisLine: {
                        show: false
                    },
                    axisTick: {
                        show: false
                    },
                    axisLabel: {
                        formatter: (val) => {
                            if (Number(val) >= 10000) return (Number(val) / 10000).toFixed(1) + '万'
                            else return val
                        }

                    }
                },{
                    type: 'value',
                    name: _this.valueName[1],
                    nameTextStyle: {
                    	fontSize: 11,
                    	padding: [0, 40, 10, 0],
                    },
                    axisLine: {
                        show: false
                    },
                    axisTick: {
                        show: false
                    },
                    splitLine: {
                        show: false
                    },
                    axisLabel: {
                        formatter: (val) => {
                            if (Number(val) >= 10000) return (Number(val) / 10000).toFixed(1) + '万'
                            else return val
                        }
                    }
                }],
                dataZoom: [{
                    "show": true,
                    "height": 30,
                    "xAxisIndex": [
                        0
                    ],
                    bottom: 10,
                    startValue: 0,
                    endValue: yData.length > 6 ? 6 : yData.length - 1,
                    maxValueSpan: 6,
                    mixValueSpan: 6,
                    handleIcon: 'path://M306.1,413c0,2.2-1.8,4-4,4h-59.8c-2.2,0-4-1.8-4-4V200.8c0-2.2,1.8-4,4-4h59.8c2.2,0,4,1.8,4,4V413z',
                    handleSize: '110%',
                    handleStyle: {
                        color: "#d3dee5",
                    },
                    textStyle: {
                        color: "#0199FF"
                    },
                    borderColor: "#90979c"
                }, {
                    "type": "inside",
                    "show": true,
                    "height": 15,
                    "start": 1,
                    "end": 0
                }],
                series: [{
                    name: legend.data[0],
                    type: 'line',
                    barWidth: 30,
                    barGap: 20,
                    color: '#FF0101',
                    data: yData,
                    label: {
                        normal: {
                            show: true,
                            position: 'top',
                            fontSize: 10,
                        }
                    },
                },{
                    name: legend.data[1],
                    type: 'bar',
                    barWidth: 30,
                    barGap: 20,
                    color: '#0199FF',
                    yAxisIndex: 1,
                    label: {
                        show: true,
                        position: 'inside'
                    },
                    data: y2Data,
                },],
            }
            mychart2.setOption(option2, true);
        },
    },
    mounted() {
        const h = document.documentElement.clientHeight || document.body.clientHeight;
        this.$refs.chart2.style.height = h / 2 + 'px';
    },
    template: `<div style="padding: 10px 5px; position: relative">
					<div ref="chart2" style="background-color: #FFF; width: 100%"></div>
	           </div>`
});