// 欠费账龄tab
var oweTheAging = {
    components: {
        'tab-btn-box': tabBtnBox
    },
    props: ['isShow', 'type', 'month'],
    data() {
        return {
			// 当前页面地区
            areaCode: '',
            // 上一级页面地区
            beforeAreaCode: '',
            // 页面层级 1-全国 2-省/市 3-市/区
            level: 1,
            maxLevel: 3,
            // 无数据
            noData: false,
            // tabBtn
			tabBtn:[
				{
					id: 1,
                    name: "欠费总额",
                    barName: "欠费总额",
                    barKey: "arrearsBalance",
                    tableColumn: ["欠费总额(万元)"],
                    columnKey: ["arrearsBalance"]
				},
				{
					id: 2,
					name: "当月欠费",
                    barName: "当月欠费额",
                    barKey: "curArrearsBalance",
                    tableColumn: ["欠费总额(万元)", "当月欠费(万元)"],
                    columnKey: ["arrearsBalance", "curArrearsBalance"]
                },
                {
					id: 3,
					name: "一个月以内",
                    barName: "一个月以内欠费额",
                    barKey: "oneArrearsBalance",
                    tableColumn: ["欠费总额(万元)", "一个月以内欠费(万元)"],
                    columnKey: ["arrearsBalance", "oneArrearsBalance"]
				},
				{
					id: 4,
					name: "1~2月",
                    barName: "1~2月欠费额",
                    barKey: "oneTwoArrearsBalance",
                    tableColumn: ["欠费总额(万元)", "1~2月欠费(万元)"],
                    columnKey: ["arrearsBalance", "oneTwoArrearsBalance"]
                },
                {
					id: 5,
					name: "2~3月",
                    barName: "2~3月欠费额",
                    barKey: "twoThreeArrearsBalance",
                    tableColumn: ["欠费总额(万元)", "2~3月欠费(万元)"],
                    columnKey: ["arrearsBalance", "twoThreeArrearsBalance"]
				},
                {
					id: 6,
					name: "3~12月",
                    barName: "3~12月欠费额",
                    barKey: "threeTwelveArrearsBalance",
                    tableColumn: ["欠费总额(万元)", "3~12月欠费(万元)"],
                    columnKey: ["arrearsBalance", "threeTwelveArrearsBalance"]
				},
                {
					id: 7,
					name: "12~24月",
                    barName: "12~24月欠费额",
                    barKey: "tewlveTwentyFourArrearsBalance",
                    tableColumn: ["欠费总额(万元)", "12~24月欠费(万元)"],
                    columnKey: ["arrearsBalance", "tewlveTwentyFourArrearsBalance"]
				},
                {
					id: 8,
					name: "24月以上",
                    barName: "24月以上欠费额",
                    barKey: "twentyFourArrearsBalance",
                    tableColumn: ["欠费总额(万元)", "24月以上欠费(万元)"],
                    columnKey: ["arrearsBalance", "twentyFourArrearsBalance"]
				}
            ],
            // 当前选中的tabBtn
            activeBtn: {},
            // -------柱状图数据
            barKey: ["arrearsBalance", "curArrearsBalance", "oneArrearsBalance", "oneTwoArrearsBalance", "twoThreeArrearsBalance", "threeTwelveArrearsBalance", "tewlveTwentyFourArrearsBalance", "twentyFourArrearsBalance"],
            xValue:[],
            barObj: {},
            // -------表格相关
            tableHeight: null,
            // 第一列名称
            title: '省份',
            // 表头
            tableColumn: [],
            // 表格数据
            tableData:[],
            // 缓存数据
            cacheData: {},
            // top5数据
            sortData: {}
        }
    },
    template: `
    <div>
        <div v-if="!noData">
            <tab-btn-box :tab-btn="tabBtn" @choose-tab-btn="chooseTabBtn"></tab-btn-box>
            <div class="chart" ref="bar"></div>
            <drill-down-box 
                id="oweTable2"
                ref="echarts"
                :tableHeight="tableHeight"
                :is-no="false"
                :list="tableData"
                :title="title" 
                :is-drill-down="isDrillDown"
                :divideCode="areaCode"
                :tablecolumn="tableColumn"
                @sortList="sortTableData"
                @drilldown="drillDown" />
        </div>
        <div class="noData" v-if="noData">
            <img src="../../image/nodata.png" alt="暂无数据" />
            <h3>暂无数据</h3>
        </div>
    </div>
    `,
    watch: {
    	// 监控是否显示
        isShow: function (val, oldVal) {
            if (val && this.month && this.tableData.length == 0) {
                this.title = getNameFromPermission(this.level, false);
            	this.initColumn();
                this.getData();
                this.handleScroll();
            }
        },
        month: function(val, oldVal) {
        	if (val && this.isShow) {
        		this.initColumn();
                this.getData();
                this.handleScroll();
            }
        },
        level: function(val) {
            this.title = getNameFromPermission(val, false);
        }
    },
    computed: {
        isDrillDown: function(){
            return Number(this.level) < Number(this.maxLevel);
        }
    },
    mounted() {
        this.activeBtn = this.tabBtn[0];
    },
    methods: {
        handleScroll() {
            let dom = document.getElementsByClassName('tabContent')[2];
            let tabsHeight = document.getElementsByClassName('tabs')[0].clientHeight;
            let topHeight = document.getElementById('oweTable2').getBoundingClientRect().top - tabsHeight;
            let windowHeight = (document.documentElement.clientHeight || document.body.clientHeight) - tabsHeight;
            // 滚动监控
            dom.addEventListener('scroll', () => {
                let scrollTop = dom.scrollTop;
                if (Math.floor(scrollTop) >= Math.floor(topHeight)) {
                    dom.scrollTop = topHeight;
                    this.tableHeight = windowHeight;
                } else if (Math.floor(scrollTop) < Math.floor(topHeight)) {
                    this.tableHeight = null;
                }
            })
        },
        chooseTabBtn: function(item) {
            this.activeBtn = item;
            //柱状图
            let json = {
                name: this.activeBtn.barName,
                yName: "金额(万元）",
                xValue: this.barObj[this.activeBtn.barKey+'_x'],
                yValue: this.barObj[this.activeBtn.barKey]
            }
            this.getBarChart('bar', json);
            // 更改表头
            this.initColumn();
        },
        // 获取数据
        getData: function() {
            let params = {
                statMonth: this.month,
                productType: this.type,
                areaLevel: String(this.level),
                areaCode: this.areaCode
            };
            
            let sortData = {
                advanceBalance: [],
                arrearsBalance: [],

                curArrearsBalance: [],
                oneArrearsBalance: [],

                oneTwoArrearsBalance: [],
                twoThreeArrearsBalance: [],

                threeTwelveArrearsBalance: [],
                tewlveTwentyFourArrearsBalance: [],
                twentyFourArrearsBalance: []
            };
            this.sortData = {};
            this.xValue = [];
            this.barObj = {};
            queryTimesArrearsBalance(params).then(({data}) => {
                if(!data || data == '[]' ) {
                    this.noData = true;
                    return;
                }
                this.noData = false;
                data = JSON.parse(data);
                // 数据排序
                data.forEach((item, index) => {
                    item.advanceBalance = item.advanceBalance === null ? '' : Math.round(item.advanceBalance / 10000);
                    item.arrearsBalance = item.arrearsBalance === null ? '' :  Math.round(item.arrearsBalance / 10000);

                    item.curArrearsBalance = item.curArrearsBalance === null ? '' :  Math.round(item.curArrearsBalance / 10000);
                    item.oneArrearsBalance = item.oneArrearsBalance === null ? '' :  Math.round(item.oneArrearsBalance / 10000);
                    
                    item.oneTwoArrearsBalance = item.oneTwoArrearsBalance === null ? '' :  Math.round(item.oneTwoArrearsBalance / 10000);
                    item.twoThreeArrearsBalance = item.twoThreeArrearsBalance === null ? '' :  Math.round(item.twoThreeArrearsBalance / 10000);
                    
                    item.threeTwelveArrearsBalance = item.threeTwelveArrearsBalance === null ? '' :  Math.round(item.threeTwelveArrearsBalance / 10000);
                    item.tewlveTwentyFourArrearsBalance = item.tewlveTwentyFourArrearsBalance === null ? '' :  Math.round(item.tewlveTwentyFourArrearsBalance / 10000);
                    item.twentyFourArrearsBalance = item.twentyFourArrearsBalance === null ? '' :  Math.round(item.twentyFourArrearsBalance / 10000);
                    
                    if (index > 0) {
                        item.advanceBalance === '' ? '' : sortData.advanceBalance.push(item.advanceBalance);
                        item.arrearsBalance === '' ? '' : sortData.arrearsBalance.push(item.arrearsBalance);

                        item.curArrearsBalance === '' ? '' : sortData.curArrearsBalance.push(item.curArrearsBalance);
                        item.oneArrearsBalance === '' ? '' : sortData.oneArrearsBalance.push(item.oneArrearsBalance);

                        item.oneTwoArrearsBalance === '' ? '' : sortData.oneTwoArrearsBalance.push(item.oneTwoArrearsBalance);
                        item.twoThreeArrearsBalance === '' ? '' : sortData.twoThreeArrearsBalance.push(item.twoThreeArrearsBalance);

                        item.threeTwelveArrearsBalance === '' ? '' : sortData.threeTwelveArrearsBalance.push(item.threeTwelveArrearsBalance);
                        item.tewlveTwentyFourArrearsBalance === '' ? '' : sortData.tewlveTwentyFourArrearsBalance.push(item.tewlveTwentyFourArrearsBalance);
                        item.twentyFourArrearsBalance === '' ? '' : sortData.twentyFourArrearsBalance.push(item.twentyFourArrearsBalance);
                    }
                })
                
                sortData.advanceBalance = sortData.advanceBalance.length > 5 ? sortData.advanceBalance.sort((a,b) => b-a).slice(0,5) : sortData.advanceBalance;
                sortData.arrearsBalance = sortData.arrearsBalance.length > 5 ? sortData.arrearsBalance.sort((a,b) => b-a).slice(0,5) : sortData.arrearsBalance;

                sortData.curArrearsBalance = sortData.curArrearsBalance.length > 5 ? sortData.curArrearsBalance.sort((a,b) => b-a).slice(0,5) : sortData.curArrearsBalance;
                sortData.oneArrearsBalance = sortData.oneArrearsBalance.length > 5 ? sortData.oneArrearsBalance.sort((a,b) => b-a).slice(0,5) : sortData.oneArrearsBalance;

                sortData.oneTwoArrearsBalance = sortData.oneTwoArrearsBalance.length > 5 ? sortData.oneTwoArrearsBalance.sort((a,b) => b-a).slice(0,5) : sortData.oneTwoArrearsBalance;
                sortData.twoThreeArrearsBalance = sortData.twoThreeArrearsBalance.length > 5 ? sortData.twoThreeArrearsBalance.sort((a,b) => b-a).slice(0,5) : sortData.twoThreeArrearsBalance;

                sortData.threeTwelveArrearsBalance = sortData.threeTwelveArrearsBalance.length > 5 ? sortData.threeTwelveArrearsBalance.sort((a,b) => b-a).slice(0,5) : sortData.threeTwelveArrearsBalance;
                sortData.tewlveTwentyFourArrearsBalance = sortData.tewlveTwentyFourArrearsBalance.length > 5 ? sortData.tewlveTwentyFourArrearsBalance.sort((a,b) => b-a).slice(0,5) : sortData.tewlveTwentyFourArrearsBalance;
                sortData.twentyFourArrearsBalance = sortData.twentyFourArrearsBalance.length > 5 ? sortData.twentyFourArrearsBalance.sort((a,b) => b-a).slice(0,5) : sortData.twentyFourArrearsBalance;
                
                this.sortData = sortData;
                 // 整理数据
                let tableData = [];
                data = data.sort((a, b) => {
                    return a['areaCode'] - b['areaCode'];
                })
                data.forEach((item,index) => {
                    item.areaName = item.areaSname ? item.areaSname : (item.areaName ? item.areaName : '其他');
                    item.name = item.areaName;
                    item.value = item.areaName;

                    if(index > 0) {
                        item.advanceBalanceIsTop5 = this.isTop5('advanceBalance', item.advanceBalance, this.sortData.advanceBalance);
                        item.arrearsBalanceIsTop5 = this.isTop5('arrearsBalance', item.arrearsBalance, this.sortData.arrearsBalance);

                        item.curArrearsBalanceIsTop5 = this.isTop5('curArrearsBalance', item.curArrearsBalance, this.sortData.curArrearsBalance);
                        item.oneArrearsBalanceIsTop5 = this.isTop5('oneArrearsBalance', item.oneArrearsBalance, this.sortData.oneArrearsBalance);

                        item.oneTwoArrearsBalanceIsTop5 = this.isTop5('oneTwoArrearsBalance', item.oneTwoArrearsBalance, this.sortData.oneTwoArrearsBalance);
                        item.twoThreeArrearsBalanceIsTop5 = this.isTop5('twoThreeArrearsBalance', item.twoThreeArrearsBalance, this.sortData.twoThreeArrearsBalance);

                        item.threeTwelveArrearsBalanceIsTop5 = this.isTop5('threeTwelveArrearsBalance', item.threeTwelveArrearsBalance, this.sortData.threeTwelveArrearsBalance);
                        item.tewlveTwentyFourArrearsBalanceIsTop5 = this.isTop5('tewlveTwentyFourArrearsBalance', item.tewlveTwentyFourArrearsBalance, this.sortData.tewlveTwentyFourArrearsBalance);
                        item.twentyFourArrearsBalanceIsTop5 = this.isTop5('twentyFourArrearsBalance', item.twentyFourArrearsBalance, this.sortData.twentyFourArrearsBalance);
                    }

                    if(index == 0) {
                        this.areaCode = this.areaCode ? this.areaCode : item.areaCode;
                        this.beforeAreaCode = item.pAreaCode ? item.pAreaCode : '100000';
                    }
                    tableData.push(item);
                })

                // 柱状图排序
                this.xValue = [];
                this.barObj = {};
                let filterData = data.filter(item => {
                    if(item.areaCode != this.areaCode || data.length == 1) {
                        return item;
                    }
                });
                // ["arrearsBalance", "curArrearsBalance",
                // "oneArrearsBalance", "oneTwoArrearsBalance",
                // "twoThreeArrearsBalance", "threeTwelveArrearsBalance",
                //  "tewlveTwentyFourArrearsBalance", "twentyFourArrearsBalance"],
            
                filterData = this.filterData(filterData, 'arrearsBalance');
                this.barObj['arrearsBalance_x'] = this.getMappingValueArrayOfKey(filterData, 'areaName');
                this.barObj['arrearsBalance'] = this.getMappingValueArrayOfKey(filterData, 'arrearsBalance');

                filterData = this.filterData(filterData, 'curArrearsBalance');
                this.barObj['curArrearsBalance_x'] = this.getMappingValueArrayOfKey(filterData, 'areaName');
                this.barObj['curArrearsBalance'] = this.getMappingValueArrayOfKey(filterData, 'curArrearsBalance');

                filterData = this.filterData(filterData, 'oneArrearsBalance');
                this.barObj['oneArrearsBalance_x'] = this.getMappingValueArrayOfKey(filterData, 'areaName');
                this.barObj['oneArrearsBalance'] = this.getMappingValueArrayOfKey(filterData, 'oneArrearsBalance');

                filterData = this.filterData(filterData, 'oneTwoArrearsBalance');
                this.barObj['oneTwoArrearsBalance_x'] = this.getMappingValueArrayOfKey(filterData, 'areaName');
                this.barObj['oneTwoArrearsBalance'] = this.getMappingValueArrayOfKey(filterData, 'oneTwoArrearsBalance');

                filterData = this.filterData(filterData, 'twoThreeArrearsBalance');
                this.barObj['twoThreeArrearsBalance_x'] = this.getMappingValueArrayOfKey(filterData, 'areaName');
                this.barObj['twoThreeArrearsBalance'] = this.getMappingValueArrayOfKey(filterData, 'twoThreeArrearsBalance');

                filterData = this.filterData(filterData, 'threeTwelveArrearsBalance');
                this.barObj['threeTwelveArrearsBalance_x'] = this.getMappingValueArrayOfKey(filterData, 'areaName');
                this.barObj['threeTwelveArrearsBalance'] = this.getMappingValueArrayOfKey(filterData, 'threeTwelveArrearsBalance');

                filterData = this.filterData(filterData, 'tewlveTwentyFourArrearsBalance');
                this.barObj['tewlveTwentyFourArrearsBalance_x'] = this.getMappingValueArrayOfKey(filterData, 'areaName');
                this.barObj['tewlveTwentyFourArrearsBalance'] = this.getMappingValueArrayOfKey(filterData, 'tewlveTwentyFourArrearsBalance');

                filterData = this.filterData(filterData, 'twentyFourArrearsBalance');
                this.barObj['twentyFourArrearsBalance_x'] = this.getMappingValueArrayOfKey(filterData, 'areaName');
                this.barObj['twentyFourArrearsBalance'] = this.getMappingValueArrayOfKey(filterData, 'twentyFourArrearsBalance');

                this.renderPage(tableData);
                // 存储数据
                if(Object.keys(this.cacheData).length > 10) {
                    this.cacheData.shift();
                }
                this.cacheData[this.areaCode] = {
                    "beforeAreaCode": this.beforeAreaCode,
                    "tableData": tableData,
                    "xValue": this.xValue,
                    "barObj": this.barObj
                }
            }).catch(err => {
                this.noData = true;
            })
        },
        // 渲染页面
        renderPage(tableData) {
            // 表格
            this.tableData = tableData;
            this.$refs.echarts.$refs.tableOwe.clearSort();

            //柱状图
            let json = {
                name: this.activeBtn.barName,
                yName: "金额(万元）",
                xValue: this.barObj[this.activeBtn.barKey+'_x'],
                yValue: this.barObj[this.activeBtn.barKey]
            }
            this.$nextTick(() => {this.getBarChart('bar', json)});
        },
        // 柱状图
        getBarChart: function (refs, json) {
            let myChart = echarts.init(this.$refs[refs]);
            let option = barOption(['#F74627'], json);
            myChart.setOption(option, true);
            myChart.on('legendselectchanged', function (params) {
                let option = this.getOption();
                if (!params.selected[params.name]) {
                    // false 的时候
                    let isTure = [];
                    for(var item in params.selected){
                        if (params.selected[item]) {
                            isTure.push(item)
                        };
                    }
                    if (isTure.length > 0) {
                        option.legend[0].selected[params.name] = false;
                    } else {
                        option.legend[0].selected[params.name] = true;
                    }
                } else {
                    // true 的时候
                    option.legend[0].selected[params.name] = true;
                }
                this.setOption(option)
            });
        },
        // 表格列
        initColumn: function (){
            let tableColumn = [];
            this.activeBtn.tableColumn.forEach((item, index) => {
                tableColumn.push({
                    label: item,
                    key: this.activeBtn.columnKey[index],
                    sortable: 'custom',
                    isDrillDown: false,
                    isNumber: true,
                    align: 'right'
                });
            });
            this.tableColumn = tableColumn;
        },
        // 下钻接口
        drillDown: function (data){
            const item = data.item;
            this.areaCode = item.areaCode;
            this.level = this.level + 1;
            const cacheData = this.cacheData[item.areaCode];
            // 获取数据，重新渲染页面
            if(cacheData) {
                this.beforeAreaCode = cacheData.beforeAreaCode;
                this.xValue = cacheData.xValue;
                this.barObj = cacheData.barObj;
                this.renderPage(cacheData.tableData);
            } else {
                this.getData();
            }
        },
        // 返回上一级
        upLevel() {
            if (this.level == 1) {
                Emp.execute("goBack()");
            } else {
                this.level = this.level - 1;
                this.areaCode = this.beforeAreaCode;
                const cacheData = this.cacheData[this.areaCode];
                // 获取数据，重新渲染页面
                if(cacheData) {
                    this.beforeAreaCode = cacheData.beforeAreaCode;
                    this.xValue = cacheData.xValue;
                    this.barObj = cacheData.barObj;
                    this.renderPage(cacheData.tableData, cacheData.xValue, cacheData.yValue);
                } else {
                    this.getData();
                }
            }
        },
        // 表格数据排序
        sortTableData(data) {
            this.tableData = data;
        },
        // 数据是否TOP5
        isTop5(key, val, sortList) {
            let isTop5  = sortList.indexOf(val);
            if (isTop5 > -1) {
                this.sortData[key].splice(isTop5,1);
                return true;
            } else {
                return false;
            }
        },
        filterData(data, key) {
            let filterData = [];
            filterData = data.sort((a, b) => {
                let aVal = a[key];
                let bVal = b[key];
                return bVal - aVal;
            })
            return filterData;
        },
        getMappingValueArrayOfKey(array,keyName) {
            if(Object.prototype.toString.call(array)=='[object Array]'){
                return array.map(item => {
                    return item[keyName]
                })
            }
            return '';
        }
    }
};