var secondaryPageTab = {
	props: ['isShow', 'id', 'pageTitle', 'dateType', 'countDate', 'businessTypes', 'importRcportType', 'areaCode', 'level'],
	data() {
		return {
			// echart相关
			yName: ['数量（件）','金额（万元）'],
			noData: false,
			// 下钻层级控制
			maxLevel: 3,
			isMaxLevel: false,
			// 表格相关
			tableHeight: null,
			// 数据
			isGetData: true,
			dataList: '',
			isSetting: false,
			pageparam:1,
            pageNo: 1,
            pageSize: 100,
            pageNoMax: 100,
            pageSizeMax: 100,
		}
	},
	computed: {
		// 表格相关
		tableColumnList: function () {
			console.log(tableColumn)
			let tableColumnList = [];
			let pageTitle = this.pageTitle;
			if (pageTitle.includes('亏损客户明细')) {
//				if(getAccountLevel() == '04'){
					tableColumn['亏损客户明细'].forEach((item=>{
						if(item.sortable){
							item.sortable=true;
						}
					}));
//				}
				tableColumnList = tableColumn['亏损客户明细']



			} else if (pageTitle.includes('重量稽核')) {
				tableColumn['重量稽核'].forEach((item=>{
					if(item.sortable){
						item.sortable=true;
					}
				}));
				tableColumnList = tableColumn['重量稽核'][this.id]
				console.log(tableColumnList)
			} else if (pageTitle.includes('赔偿客户')) {
				tableColumn['赔偿客户'].forEach((item=>{
					if(item.sortable){
						item.sortable=true;
					}
				}));
				tableColumnList = tableColumn['赔偿客户']
			}

			return tableColumnList;
		}
	},
	template: `
		<secondary-page
			ref="page"
			:no-data="noData"
			:area-code="areaCode"
			:count-date="countDate"
			:is-max-level="isMaxLevel"
			:table-column-list="tableColumnList"
			:table-height="tableHeight"
			:y-name="yName"
			:data-list="dataList"
			:is-setting="isSetting"
			:page-title="pageTitle"
			:id="id"
			:page-no="pageNo"
			:page-size="pageSize"
			:page-no-max="pageNoMax"
			:page-size-max="pageSizeMax"
			@getPageNoParams="getPageNoParams"
			@change-level="changeLevel"
			@change-area-code="changeAreaCode"
		>
		</secondary-page>
	`,
	watch: {
		// 监控是否显示
        isShow: function (val) {
			// 时间或地区更改
			if(val) {
				// let areaLevel = getLevelFromPermission(this.level);
				let cacheData = this.$refs.page.cacheData[this.areaCode + this.countDate + areaLevel];
				if(cacheData) {
					this.dataList = cacheData.dataList;
					this.noData = false;
				} else {
					this.getData();
				}
			}
        },
		// 监控当时间变化时, 重新请求
		countDate: function(val) {
			if (val && this.isShow) {
				if(this.level == 1) {
					let userLevel = getAccountLevel();
					let userCode = getAccountCode();
					switch (userLevel) {
						case '01':
						case '02':
							this.maxLevel = 4;
							break;
						case '03':
							this.maxLevel = this.isCen(userCode) ? 2 : 3;
							break;
						case '04':
							this.maxLevel = this.isCen(userCode) ? 1 : 2;
							break;
						default:
							this.maxLevel = 1;
							break;
					}
					// this.isMaxLevel = this.level == this.maxLevel ? true : false;
					this.isMaxLevel = true // 禁止下钻
					// this.tableColumnList[0].label = this.isMaxLevel ? '机构' : getNameFromPermission(this.level, false);
					this.$refs.page.$refs.tableBox.isShow = false;
					this.$nextTick(() => {
						this.$refs.page.$refs.tableBox.isShow = true;
					});
				}
				this.getData();
			}
		},
		level: function(val) {
			this.isMaxLevel = true // 禁止下钻
			this.tableColumnList[0].label = this.isMaxLevel ? '机构' : getNameFromPermission(val, false);
			this.$refs.page.$refs.tableBox.isShow = false;
			this.$nextTick(() => {
				this.$refs.page.$refs.tableBox.isShow = true;
			});
		},
		areaCode: function(val) {
			// let areaLevel = getLevelFromPermission(this.level);
			let cacheData = this.$refs.page.cacheData[this.areaCode + this.countDate];
			if (val && this.isShow) {
				if (cacheData) {
					this.noData = false;
					this.dataList = cacheData.dataList;
				}
			}
		}
	},
	mounted() {
		this.handleScroll();
		if(this.countDate && this.isShow) {
			let userLevel = getAccountLevel();
			let userCode = getAccountCode();
			switch (userLevel) {
				case '01':
				case '02':
					this.maxLevel = 4;
					break;
				case '03':
					this.maxLevel = this.isCen(userCode) ? 2 : 3;
					break;
				case '04':
					this.maxLevel = this.isCen(userCode) ? 1 : 2;
					break;
				default:
					this.maxLevel = 1;
					break;
			}
			// this.isMaxLevel = this.level == this.maxLevel ? true : false;
			this.isMaxLevel = true // 禁止下钻
			this.tableColumnList[0].label = this.isMaxLevel ? '机构' : getNameFromPermission(this.level, false);
		}
	},
	methods: {
        getPageNoParams(pagenoparam){
            this.pageparam=pagenoparam;
            this.getData()
		},
		// 监控页面滚动体
		handleScroll() {
			let dom = this.$parent.$refs.tabContent;
            console.log(this.$parent.$refs.tabContent)
			// let topHeight = document.getElementsByClassName('echart')[0].clientHeight;
			dom.addEventListener('scroll', () => {
				// let scrollTop = dom.scrollTop;
				// if (Math.floor(scrollTop) >= -1) {
                //     dom.scrollTop = topHeight;
                //     this.tableHeight = dom.clientHeight;
                // } else if (Math.floor(scrollTop) < (Math.floor(topHeight)- 1)) {
                //     this.tableHeight = null;
                // }
			})
			this.tableHeight = dom.clientHeight
		},
		// 获取数据
		getData() {
			let countDate = this.dateType == 'W' ? this.countDate.split('-')[0] + this.countDate.split(' ')[1] : this.countDate;

			let params = {
				statMonth: countDate,
				productType: this.businessTypes,
				areaCode: this.areaCode,
				// areaLevel: this.level-1
                areaLevel:this.level,
                pageNo: this.pageparam,
                pageSize: this.pageSize,
			}

			switch(this.pageTitle) {
				case '亏损客户明细':
                    queryLossCustomDetail(params).then(({data}) => {
                        this.setData(data);
						// alert(JSON.stringify(data));
                    }).catch(err => {
                        this.noData = true;
                    })
					break;
				case '赔偿客户':
                    selectCompensateCustomersVoByDate(params).then(({data}) => {
						//alert(JSON.stringify(111));
                        this.setData(data);
                    }).catch(err => {
                        this.noData = true;
                    })
					break;
			}
		},
		setData(data1) {
            let data = JSON.parse(data1);
            if(!data.items || data.items == '[]' ) {
                console.log(data);
                this.noData = true;
				this.dataList = '';
				return;
            }
            this.noData = false;
            this.pageNoMax = data.pageCount;
            this.pageNo = data.pageNo;
			this.dataList = data.items;
			console.log(this.noData)
			console.log(this.dataList)
            this.areaCode = this.areaCode ? this.areaCode : JSON.parse(data1.items)[0].areaCode;
            this.$emit("change-area", this.areaCode, this.level);
		},
		// 表格下钻
		changeLevel(row, isGetData) {
			this.areaCode = row.areaCode;
			this.level = this.level;
			this.isGetData = isGetData;
			this.noData = isGetData == false ? false : this.noData;
			this.$emit("change-area", this.areaCode, this.level);
			if (this.isCen(row.areaCode) && getAccountLevel() < 3) {
				this.isMaxLevel = this.level == this.maxLevel - 1 ? true : false;
			} else {
				this.isMaxLevel = this.level == this.maxLevel ? true : false;
			}
		},
		// 页面返回上一层
		upLevel() {
			console.log(this.dataList)
			this.level = this.level - 1;
			this.isMaxLevel = false;
			this.$refs.page.upLevel();
		},
		// 返回上一层时更改areaCode
		changeAreaCode(areaCode, isGetData) {
			this.areaCode = areaCode;
			this.isGetData = isGetData;
			this.noData = isGetData == false ? false : this.noData;
			this.$emit("change-area", this.areaCode, this.level);
		},
		// 是否为直辖市
		isCen(areaCode){
			let code = areaCode.slice(0,2);
			return code == '11' || code == '12' || code == '31' || code == '50';
		}
	}

};
