var secondaryPage = {
	props: ['noData', 'areaCode', 'countDate', 'isMaxLevel', 'tableColumnList', 'tableHeight', 'isSetting', 'yName', 'dataList', 'customTable', 'pageTitle', 'id','pageNo','pageSize','pageNoMax','pageSizeMax'],
	data() {
		return {
			tipShow: false,
			msg: '当前日期的数据暂未更新呢！',
			areaLevel: '',
			beforeAreaCode: '',
			tableData: [],
			// 缓存数据
            cacheData: {},
			cacheAreaCode: {},
			list:[],

		}
	},
	template: `
		<div>
			<div v-show="!noData">
				<table-box
					ref="tableBox"
					:table-column-list="tableColumnList"
					:table-data="tableData"
					:table-height="tableHeight"
					:is-setting="isSetting"
					:divide-code="areaCode"
					:divide-code-level="areaLevel"
					:pageTitle="pageTitle"
					:is-max-level="isMaxLevel"
					:provided-drill-down="providedDrillDown"
					:is-load-more="true"
					@sort-list="sortTableData"
					@change-table-column="changeTableColumn"
					@load-more="loadMore"
				>
				</table-box>
			</div>
			<!-- 暂无数据 -->
			<div v-show="noData">
				<run-text img-url="../../" :msg="msg" :is-show="tipShow" @close="close"></run-text>
				<div class="noData">
					<img src="../../image/nodata.png" alt="暂无数据" />
					<h3>暂无数据</h3>
				</div>
			</div>
		</div>
	`,
	watch: {
		noData(val) {
			this.tipShow = val;
			if (val) {
				this.beforeAreaCode = '';
			}
		},
		dataList(val) {
			if (val) {
				this.setData();
			}
		}
	},
	methods: {
		// 数据处理
		setData() {
            console.log(11);
            // 数据预处理
			// let sortData = JSON.parse(this.dataList);
			// let sortObj = {};
			// this.tableColumnList.forEach(columnItem => {
			// 	if (columnItem.isProgress) {
			// 		// 从小到大排序
			// 		sortData.sort((a, b) => {
			// 			return Number(a[columnItem.prop]) - Number(b[columnItem.prop]);
			// 		})
			// 		sortObj[columnItem.prop] = {
			// 			min: sortData[0][columnItem.prop] ? sortData[0][columnItem.prop] : 0,
			// 			max: sortData[sortData.length-1][columnItem.prop] ? sortData[sortData.length-1][columnItem.prop] : 0
			// 		}
			// 	}
			// })
			// echart相关
			let average = 0;
			let barJson = {
				yName: this.yName,
				xValue: [],
				barValue: [],
				lineValue: []
			};
			// 数据判空
			// 处理表格数据
			let data = this.dataList;
			if (this.dataList) {
				data.forEach((item, index) => {
					this.tableColumnList.forEach(columnItem => {
						let prop = columnItem.prop;
						if(prop == 'areaName') {
							item[prop] = item[prop] ? item[prop] : '其它';
						} else if (columnItem.is10thousand) {
							item[prop] = item[prop] === null ? '' : ((item[prop] ? item[prop] / 10000 : 0)).toFixed(2);
						}
					})
					if (index == 0) {
						barJson.title = item.areaName;
						this.areaLevel = item.areaLevel;
						// 解决获取beforeAreaCode问题
						this.cacheAreaCode[this.areaLevel] = item.areaCode
						console.log(this.cacheAreaCode)
						if (this.areaLevel == 1) {
							this.beforeAreaCode = '999999'
						} else {
							this.beforeAreaCode = this.cacheAreaCode[this.areaLevel-1]
						}
						console.log(this.beforeAreaCode)
					}
				});
                this.$nextTick(() => {
                    if(this.pageNo == 1){
                    this.list = data;
                }else{
                    this.list.push(...data);
                }
            });
			}
			if(this.pageNo == 1){
                this.renderPage(data);
			}else{
                this.renderPage(this.list);
			}

			// 缓存数据
			this.cacheData[this.areaCode + this.countDate + this.areaLevel] = {
				"beforeAreaCode": this.beforeAreaCode,
				"areaLevel" : this.areaLevel,
				"tableData": data,
				"dataList": this.dataList
			}
		},
		// 渲染页面
		renderPage(data) {
			console.log(data)
			// 表格
			this.tableData = data;
			this.$refs.tableBox.$refs.table.clearSort();
			// // 柱状图
			// this.$nextTick(() => {
			// 	this.getBarChart(barJson);
			// 	this.$refs.tableBox.$refs.table.doLayout();
			// });
		},
		// 表格下钻
        providedDrillDown(row, prop) {
			let areaCode = row.areaCode;
			let areaLevel = row.areaLevel;
			const cacheData = this.cacheData[areaCode + this.countDate + areaLevel];
			console.log('缓存的数据',cacheData)
			// 获取数据，重新渲染页面
			if(cacheData) {
				this.beforeAreaCode = cacheData.beforeAreaCode;
				this.areaLevel = cacheData.areaLevel;
				if (prop == 'areaName') {
					this.$emit('change-level', row, false);
					this.renderPage(cacheData.tableData);
				}
			} else {
				this.beforeAreaCode = this.areaCode;
				if (prop == 'areaName') {
					this.$emit('change-level', row, true);
				}
			}
			this.$refs.tableBox.$refs.table.clearSort();
		},
		// 返回上一层
		upLevel() {
			// 如果没有，应该去取另外一个tab里的beforeAreaCode
			// alert("beforeAreaCode"+this.beforeAreaCode)
			if(!this.beforeAreaCode){
				let pageTab = this.$parent.$parent.$refs.pageTab;
				for(var i = 0; i < pageTab.length; i++) {
					console.log(pageTab[i].$refs.page.beforeAreaCode)
					if (pageTab[i].$refs.page.beforeAreaCode) {
						this.areaCode = pageTab[i].$refs.page.beforeAreaCode;
						this.areaLevel = pageTab[i].$refs.page.areaLevel - 1;
						break;
					}
				}
				if (this.id == 2) {
					let name = getNameFromPermission(this.areaLevel, false);
					console.log(name)
					this.$parent.$parent.switchTabNav({id: 1, name})
				}
				this.getCacheData();
			} else {
				this.areaCode = this.beforeAreaCode;
				this.areaLevel = this.areaLevel - 1;
				if (this.id == 2) {
					let name = getNameFromPermission(val, false);
					console.log(name)
					// this.$parent.$parent.switchTabNav()
				}
				this.getCacheData();
			}
		},
		getCacheData() {

			const cacheData = this.cacheData[this.areaCode + this.countDate + this.areaLevel];
			console.log(this.cacheData, this.areaCode, this.countDate, this.areaLevel)
			console.log(cacheData)
			// 获取数据，重新渲染页面
			if(cacheData) {
				this.beforeAreaCode = cacheData.beforeAreaCode;
				this.areaLevel = cacheData.areaLevel;
				this.$emit('change-area-code', this.areaCode, false);
				this.renderPage(cacheData.tableData);
			} else {
				this.beforeAreaCode = this.areaCode;
				this.$emit('change-area-code', this.areaCode, true);
			}
			this.$refs.tableBox.$refs.table.clearSort();
		},
		// 表格数据排序
		sortTableData(data) {
			this.tableData = data;
		},
		// 表格列表设置
		changeTableColumn(data) {
			this.tableColumnList = data;
			this.$emit("change-table-column", data);
		},
		// 关闭提示
		close() {
			this.tipShow = false;
		},
		// 是否为直辖市
		isCen(areaCode){
			let code = areaCode.slice(0,2);
			return code == '11' || code == '12' || code == '31' || code == '50';
		},
		//下拉分页
        loadMore: function(){
            console.log("加载更多...");
            if(this.pageNo >= this.pageNoMax){
                return;
            }
            this.$refs.tableBox.$refs.table.clearSort();
            this.pageNo++;
            this.$emit('getPageNoParams',this.pageNo)
        },
	}

};
