var secondaryPage = {
	props: ['noData', 'areaCode', 'countDate', 'isMaxLevel', 'tableColumnList', 'tableHeight', 'isSetting', 'barTitle', 'yName', 'dataList', 'customTable', 'pageTitle', 'businessTypes', 'id'],
	data() {
		return {
			tipShow: false,
			msg: '当前日期的数据暂未更新呢！',
			areaLevel: '',
			beforeAreaCode: '',
			tableData: [],
			// 缓存数据
            cacheData: {},
			cacheAreaCode: {},
			beforeAreaCodeAndLevel:{}
		}
	},
	template: `
		<div>
			<div v-show="!noData">
				<div class="echart" ref="echart"></div>
				<table-box
					ref="tableBox"
					:table-column-list="tableColumnList"
					:table-data="tableData"
					:table-height="tableHeight"
					:is-setting="isSetting"
					:divide-code="areaCode"
					:divide-code-level="areaLevel"
					:is-max-level="isMaxLevel"
					:pageTitle="pageTitle"
					:provided-drill-down="providedDrillDown"
					@sort-list="sortTableData"
					@change-table-column="changeTableColumn"
				>
				</table-box>
			</div>
			<!-- 暂无数据 -->
			<div v-show="noData">
				<run-text img-url="../../" :msg="msg" :is-show="tipShow" @close="close"></run-text>
				<div class="noData" style="background-color: #FFFFFF">
					<img src="../../image/nodata.png" alt="暂无数据" />
					<h3>暂无数据</h3>
				</div>
			</div>
		</div>
	`,
	watch: {
		noData(val) {
			this.tipShow = val;
			if (val) {
				this.beforeAreaCode = '';
			}
		},
		dataList(val) {
			if (val) {
				this.setData();
			}
		}
	},
	methods: {
		// 数据处理
		setData() {
			// 数据预处理
			// echart相关
			let barJson = {
				yName: this.yName,
				xValue: [],
				barValue: [],
				lineValue: []
			};
			console.log(barJson)
			// 数据判空
			// 处理表格数据
			let data = [];
			let TemData = [];
			barJson.title = this.barTitle
			if (this.dataList[1]) {
				data = JSON.parse(this.dataList[1]);
				(TemData=data.items?data.items:data).forEach((item, index) => {
					// if(this.isCen(item.areaCode) && item.regionalLevel == 4) {
					// 	item.areaLevel = 3;
					// } else {
					// 	item.areaLevel = item.regionalLevel;
					// }

					this.tableColumnList.forEach(columnItem => {
						let prop = columnItem.prop;
						if(prop == 'areaName') {
							item[prop] = item[prop] ? item[prop] : '其它';
						} else if (columnItem.is10thousand) {
							item[prop] = item[prop] === null ? '' : ((item[prop] ? item[prop] / 10000 : 0)).toFixed(2);
						}else if (columnItem.is10thousandto) {
							item[prop] = item[prop] === null ? '' : ((item[prop] ? item[prop] / 1 : 0)).toFixed(2);
						}else if (columnItem.isRanking) {
                            item[prop] = item[prop] ? item[prop] : '--';
                        }
					})

					if (index == 0) {
						// average = item.timeLimit ? item.timeLimit : item.infoLimit;
						if (this.id == 1) {
							barJson.title = item.areaName;
							this.$emit('change-bar-title', item.areaName)
						}
						// barJson.average = item.timeLimit ? item.timeLimit : item.infoLimit;

						this.areaLevel = item.areaLevel;
						// 解决获取beforeAreaCode问题
						this.cacheAreaCode[this.areaLevel] = item.areaCode
						if (this.areaLevel == 1) {
							this.beforeAreaCode = '999999'
						} else {
							this.beforeAreaCode = this.cacheAreaCode[this.areaLevel-1]
						}
						// this.beforeAreaCode = item.areaCode ? item.areaCode : '999999'; // ???????
					}
				})
			}else {
				if(permissionLevel == '01'||permissionLevel == '02'){
					this.$emit('change-bar-title', "全国")
				}
			}
			//// 处理图表数据
			let echartData = JSON.parse(this.dataList[0]);
			let pageTitle = this.pageTitle;
			if (pageTitle.includes('边际贡献率')) {
				barJson.lineValue[0] = []
				barJson.lineValue[1] = []
				echartData.forEach((item, index) => {
					barJson.xValue.push(item.statMonth);
					barJson.lineValue[0].push(item.mcRate);
				})
			} else if (pageTitle.includes('亏损客户') && !pageTitle.includes('亏损客户明细')) {
				echartData.forEach((item, index) => {
					barJson.xValue.push(item.statMonth);
					if (item.conMoney < 0){
                        barJson.barValue.push(item.customAmount);
                        conMoney = item.conMoney.substr(1,item.conMoney.length);
                        barJson.lineValue.push(conMoney);
                    }
					if (item.conMoney >= 0){
                        barJson.barValue.push(item.customAmount);
                        barJson.lineValue.push(item.conMoney);
					}
            })

			} else if (pageTitle.includes('重量稽核')) {
				echartData.forEach((item, index) => {
					barJson.xValue.push(item.statMonth);
					barJson.barValue.push(item.mailAmount);
					barJson.lineValue.push(item.assessAmount);
				})

			} else if (pageTitle.includes('赔偿客户')) {

			} else if (pageTitle.includes('无收寄')) {
				echartData.forEach((item, index) => {
					barJson.xValue.push(item.statMonth);
					barJson.barValue.push(item.mailAmount);
					barJson.lineValue.push(item.assessAmount);
				})
			}else if (pageTitle.includes('单价情况')) {
				barJson.lineValue[0] = []
				barJson.lineValue[1] = []
				echartData.forEach((item, index) => {
					barJson.xValue.push(item.statMonth);
					barJson.lineValue[0].push(item.unitPrice);
					barJson.lineValue[1].push(item.weightPrice);
				})
			}
			
			this.renderPage(TemData?TemData:data, barJson);

			// 缓存数据
			console.log(this.areaCode + this.countDate + this.areaLevel)

			this.cacheData[this.areaCode + this.countDate + (this.areaLevel?this.areaLevel:'2')] = {
				"beforeAreaCode": this.beforeAreaCode,
				"areaLevel" : this.areaLevel?this.areaLevel:'2',
				"tableData": TemData?TemData:data,
				"barJson": barJson,
				"dataList": this.dataList
			}
			let storageCache = JSON.stringify(this.cacheData)
			localStorage.setItem('cacheData', storageCache)
		},
		// 渲染页面
		renderPage(data, barJson) {
			console.log(data, barJson)
			console.log("4545646465666",barJson)
			// 表格
			this.tableData = data;
			this.$refs.tableBox.$refs.table.clearSort();
			// 柱状图
			this.$nextTick(() => {
				console.log(barJson)
				this.getBarChart(barJson);
				this.$refs.tableBox.$refs.table.doLayout();
			});
		},
		// 表格下钻
        providedDrillDown(row, prop) {
			let areaCode = row.areaCode;
			let areaLevel = row.areaLevel;
			console.log(areaCode, areaLevel)
			const cacheData = JSON.parse(localStorage.getItem('cacheData'))[areaCode + this.countDate + areaLevel];
			// 获取数据，重新渲染页面
			if(cacheData) {
				if (prop == 'areaName') {
					this.beforeAreaCode = cacheData.beforeAreaCode;
					this.areaLevel = cacheData.areaLevel;
					this.$emit('change-level', row, false);
					this.renderPage(cacheData.tableData, cacheData.barJson);
				} else {
					// this.$emit('change-level', row, false);
					let url = "/fiveSystemKanban/marketSystem/feesPage/secondaryCustomPage.html"
					let p = {
						areaCode,
						areaLevel,
						countDate: this.countDate,
						pageTitle: this.pageTitle,
						businessTypes: this.businessTypes
					}
					Emp.execute("$M.page.goTo('"+url+"','"+JSON.stringify(p)+"', false)");
				}
			} else {
				if (prop == 'areaName') {
					this.$emit('change-level', row, true);
					this.beforeAreaCodeAndLevel = {
						beforeAreaCode: this.areaCode,
						beforeareaLevel: this.areaLevel
					}
					localStorage.setItem('beforeAreaCodeAndLevel', JSON.stringify(this.beforeAreaCodeAndLevel))
				} else {
					// this.$emit('change-level', row, true);
					let url = "/fiveSystemKanban/marketSystem/feesPage/secondaryCustomPage.html"
					let p = {
						areaCode,
						areaLevel,
						countDate: this.countDate,
						pageTitle: this.pageTitle,
						businessTypes: this.businessTypes
					}
					Emp.execute("$M.page.goTo('"+url+"','"+JSON.stringify(p)+"', false)");
				}
			}
			this.$refs.tableBox.$refs.table.clearSort();
		},
		// 返回上一层
		upLevel() {
			// 如果没有，应该去取另外一个tab里的beforeAreaCode
			// alert("beforeAreaCode"+this.beforeAreaCode)
			if(!this.beforeAreaCode){
					this.areaCode = JSON.parse(localStorage.getItem('beforeAreaCodeAndLevel')).beforeAreaCode
						this.areaLevel =JSON.parse(localStorage.getItem('beforeAreaCodeAndLevel')).beforeareaLevel
				if (this.id == 2) {
					let name = getNameFromPermission(this.areaLevel, false);
					this.$parent.$parent.switchTabNav({id: 1, name})
				}
				this.getCacheData();
				localStorage.removeItem('cacheData')
				localStorage.removeItem('beforeAreaCodeAndLevel')
			} else {
				this.areaCode = this.beforeAreaCode;
				this.areaLevel = this.areaLevel - 1;
				if (this.id == 2) {
					let name = getNameFromPermission(this.areaLevel, false);
					console.log(name)
					this.$parent.$parent.switchTabNav({id: 1, name})
				}
				this.getCacheData();
				localStorage.removeItem('cacheData')
				localStorage.removeItem('beforeAreaCodeAndLevel')
			}
		},
		getCacheData() {
			const cacheData = JSON.parse(localStorage.getItem('cacheData'))[this.areaCode + this.countDate + this.areaLevel];
			console.log(this.cacheData, this.areaCode, this.countDate, this.areaLevel)
			console.log(cacheData)
			// alert(this.areaLevel+'---'+this.areaCode)
			// 获取数据，重新渲染页面
			if(cacheData) {
				this.beforeAreaCode = cacheData.beforeAreaCode;
				this.areaLevel = cacheData.areaLevel;
				this.$emit('change-area-code', this.areaCode, false);
				this.renderPage(cacheData.tableData, cacheData.barJson);
			} else {
				this.beforeAreaCode = this.areaCode;
				this.$emit('change-area-code', this.areaCode, true);
			}
			this.$refs.tableBox.$refs.table.clearSort();
		},
		clearSort(){
			this.$refs.tableBox.$refs.table.clearSort();
		},
		// 表格数据排序
		sortTableData(data) {
			this.tableData = data;
		},
		// 表格列表设置
		changeTableColumn(data) {
			this.tableColumnList = data;
			this.$emit("change-table-column", data);
		},
		// 柱状图
        getBarChart(data) {
			console.log(data)
			// let json = {
			// 	title: data.title,
			// 	// legendData: [
			// 	// {
			// 	// 	name: '平均值'
			// 	// }, {
			// 	// 	name: '实际值',
			// 	// 	// icon: 'image://data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAFAAAAAoAQMAAABTru9CAAAABlBMVEUAxIL3RidNALHZAAAAE0lEQVQY02NgAIH/IMAwyhw6TABNs8c5rOzZTgAAAABJRU5ErkJggg=='
			// 	// }],
			// 	legendData: ['平均值', '实际值'],
			// 	yName: data.yName,
			// 	average: data.average,
			// 	xValue: data.xValue,
			// 	barName: '实际值',
			// 	barValue: data.barValue,
			// 	lineName: '平均值',
			// 	lineValue: data.lineValue,
			// 	filterMode: 'empty'
			// };
			let json = {}
			let option = {}
			let pageTitle = this.pageTitle;
			if (pageTitle.includes('边际贡献率')) {
				tableColumnList = tableColumn['边际贡献率']
				json = {
					title: data.title,
					legendData: ['边际贡献率'],
					yName: data.yName,
					xValue: data.xValue,
					lineValue: data.lineValue
				};
				option = this.getLineOption(json.lineValue, json.xValue, json.title, json.legendData, json.yName)
			} else if (pageTitle.includes('亏损客户') && !pageTitle.includes('亏损客户明细')) {

				json = {
					title: data.title,
					legendData: ['亏损金额', '亏损客户'],

					yName: data.yName,
					xValue: data.xValue,
					barValue: data.barValue,
					lineValue: data.lineValue

				};
				option = this.getLineBarOption(json.xValue, json.lineValue, json.barValue, json.title, json.legendData, json.yName);
			} else if (pageTitle.includes('重量稽核')) {
				json = {
					title: data.title,
					legendData: ['考核金额', '重量稽核'],
					yName: data.yName,
					xValue: data.xValue,
					barValue: data.barValue,
					lineValue: data.lineValue

				};
				option = this.getLineBarOption(json.xValue, json.lineValue, json.barValue, json.title, json.legendData, json.yName);

			} else if (pageTitle.includes('赔偿客户')) {
				tableColumnList = tableColumn['赔偿客户']
			} else if (pageTitle.includes('无收寄')) {

				json = {
					title: data.title,
					legendData: ['考核金额', '邮件量'],
					yName: data.yName,
					xValue: data.xValue,
					barValue: data.barValue,
					lineValue: data.lineValue

				};
				option = this.getLineBarOption(json.xValue, json.lineValue, json.barValue, json.title, json.legendData, json.yName);
			}else if (pageTitle.includes('单价情况')) {
				tableColumnList = tableColumn['单价情况']
				json = {
					title: data.title,
					legendData: ['平均单价', '重量单价'],
					yName: data.yName,
					xValue: data.xValue,
					lineValue: data.lineValue

				};
				option = this.getLineOption(json.lineValue, json.xValue, json.title, json.legendData, json.yName)
			}
			let myChart = echarts.init(this.$refs.echart);
            myChart.setOption(option, true);
            myChart.on('legendselectchanged', function (params) {
				let option = this.getOption();
				let name = params.name;
                if (!params.selected[name]) {
                    // false 的时候
                    let isTure = [];
                    for(var item in params.selected){
                        if (params.selected[item]) {
                            isTure.push(item)
                        };
                    }
                    if (isTure.length > 0) {
                        option.legend[0].selected[name] = false;
                    } else {
                        option.legend[0].selected[name] = true;
                    }
                } else {
                    // true 的时候
                    option.legend[0].selected[name] = true;
				}
				if (name == '实际值' && option.legend[0].selected['实际值']) {
					option.legend[0].data[1].icon = 'image://data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAFAAAAAoAQMAAABTru9CAAAABlBMVEUAxIL3RidNALHZAAAAE0lEQVQY02NgAIH/IMAwyhw6TABNs8c5rOzZTgAAAABJRU5ErkJggg==';
				} else if (name == '实际值' && !option.legend[0].selected['实际值']) {
					option.legend[0].data[1].icon = 'image://data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAFAAAAAoAQMAAABTru9CAAAABlBMVEXMzMzv7++Y3rQzAAAAE0lEQVQY02P4DwL2IIJhlDl0mADDfHCAiQlelgAAAABJRU5ErkJggg==';
				}
                this.setOption(option)
            });
		},
		getLineOption(arr, xData, title, legend, yName) {
			console.log(arr)
			document.documentElement.scrollIntoView();
            // const newList = this.list.sort((i, n) => {
            //     return Number(i.nameCode) - Number(n.nameCode)
            // });

            //解决title超长覆盖图例的问题
            const w = document.documentElement.clientWidth || document.body.clientWidth;
            let s = w * 0.37
            // let s = w * 0.37 / title.length.toFixed(0);
            s = s >= 17 ? 17 : s;
            s = s <= 8 ? 8 : s;
            let option = {
				title: {
                    text: title,
                    textStyle: {
                        fontSize: s,
                    },
                },
            	color: ['#F74627','#FFB444','#0F987A','#0197FF','#00C482','#CC0065','#A23FEB','#FF7D00'],
                tooltip: {
                    trigger: 'axis',
                    axisPointer: { // 坐标轴指示器，坐标轴触发有效
                        type: 'shadow' // 默认为直线，可选为：'line' | 'shadow'
                    },
                    position: ['20%', '20%'],
                    formatter:function(param){
                    	let arr = param.filter(e => e.value);
                    	if(!arr || arr.length <= 0){
                    		 return '';
                    	}
                    	let x = arr[0].name;
                    	if(x){
                    		//x轴名称过长时，tootip需要换行显示
                    		let n9 = Math.floor(x.length / 9);
                    		for(let n=n9;n>0;n--){
                    			x = x.slice(0, n*9) + '<br/>' + x.slice(n*9);
                    		}
                    		//如果是整倍数，需要移除最后一个换行符
                    		if(x.substr('<br/>'.length * -1) == '<br/>'){
                    			x = x.slice(0,x.length - '<br/>'.length);
                    		}
                    	}
                    	// if(x && _this.tooltipSuffix){
                    	// 	x += _this.tooltipSuffix;
                    	// }
                    	arr.forEach((e,i) => {
                    		let unit;
                    		let v = yName;
                        	let l = v.indexOf('(');
                        	let r = v.indexOf(')');
                        	if(l + r > 1){
                        		unit = v.substring(l+1,r);
                        	}
                    		x += '<br/>' + e.marker + e.seriesName + ' : ' + e.value;
                    		if(unit){
                    			x += unit;
                    		}
                    	});
                    	return x;
                    },
                },
                grid: {
                    top: title ? 65 : 45,
					left: 16,
					right: 16,
                    containLabel: true
                },
                xAxis: [{
                    type: 'category',
                    nameGap: 30,
                    data: xData,
                    "axisLine": {
                        lineStyle: {
                            color: '#90979c'
                        }
                    },
                    "splitLine": {
                        "show": false
                    },
                    "axisTick": {
                        "show": false
                    },
                    "splitArea": {
                        "show": false
                    },
                    "axisLabel": {
                        interval: 0,
                        rotate: 40,
                        formatter: (val) => {
                            if (val.length > 8) return val.substring(0, 8) + '...'
                            else return val
                        }

                    }
                }],
                yAxis: [{
                    type: 'value',
                    name: yName,
                    nameTextStyle: {
                    	fontSize: 11,
                    	padding: [0, 0, 10, 35],
                    },
                    axisLine: {
                        show: false
                    },
                    axisTick: {
                        show: false
                    },
                    axisLabel: {
                        formatter: (val) => {
                            if (Number(val) >= 10000) return (Number(val) / 10000).toFixed(1) + '万'
                            else return val
                        }

                    }
                }],
				dataZoom: [{
                    "show": true,
                    "height": 30,
                    "xAxisIndex": [
                        0
                    ],
                    bottom: 10,
                    startValue: 0,
                    endValue: xData.length > 6 ? 6 : xData.length - 1,
                    maxValueSpan: 6,
                    mixValueSpan: 6,
                    handleIcon: 'path://M306.1,413c0,2.2-1.8,4-4,4h-59.8c-2.2,0-4-1.8-4-4V200.8c0-2.2,1.8-4,4-4h59.8c2.2,0,4,1.8,4,4V413z',
                    handleSize: '110%',
                    handleStyle: {
                        color: "#d3dee5",
                    },
                    textStyle: {
                        color: "#0199FF"
                    },
                    borderColor: "#90979c"
                }, {
                    "type": "inside",
                    "show": true,
                    "height": 15,
                    "start": 1,
                    "end": 0
                }],
            }
            let legendOption = {
            	data: legend,
            	top: 10,
            	right: 5,
            	itemWidth: 21,
            	itemGap: 7,
            	textStyle: {
            		fontSize: 11,
            	},
            	formatter: function(arg){
            		return arg;
            	},
            };
            let series = [];
            arr.forEach((e,i) => {
				console.log(e)
            	let le = {
                        name: legendOption.data[i],
                        type: 'line',
                        barWidth: 30,
                        barGap: 20,
                        data: e,
                        label: {
                            normal: {
                                show: false,
                                position: 'top',
                                fontSize: 10,
                            }
                        },
                    };
            	series.push(le);
            });
            option.legend = legendOption;
            option.series = series;
			return option
		},
		getLineBarOption(xData, yData, y2Data, title, legend, yName) {
			console.log(xData, yData)
            //解决title超长覆盖图例的问题
            const w = document.documentElement.clientWidth || document.body.clientWidth;
            // let s = w * 0.37 / title.length.toFixed(0);
            let s = w * 0.37;
            s = s >= 17 ? 17 : s;
            s = s <= 8 ? 8 : s;
            let option2 = {
                title: {
                    text: title,
                    textStyle: {
                        fontSize: s,
                    },
                },
                color: ['#0199FF'],
                tooltip: {
                    trigger: 'axis',
                    axisPointer: { // 坐标轴指示器，坐标轴触发有效
                        type: 'shadow' // 默认为直线，可选为：'line' | 'shadow'
                    },
                    formatter:function(param){
                    	let arr = param.filter(e => e.value || e.value == 0);
                    	if(!arr || arr.length <= 0){
                    		 return '';
                    	}
                    	let x = arr[0].name;
                    	if(x){
                    		let n9 = Math.floor(x.length / 9);
                    		for(let n=n9;n>0;n--){
                    			x = x.slice(0, n*9) + '<br/>' + x.slice(n*9);
                    		}
                    		//如果是整倍数，需要移除最后一个换行符...
                    		if(x.substr('<br/>'.length * -1) == '<br/>'){
                    			x = x.slice(0,x.length - '<br/>'.length);
                    		}
                    	}
                    	arr.forEach((e,i) => {
                    		let unit;
                    		let v = legend[0];
                    		//隐藏某个图例后，valueName数组和param的数组索引不会对应
                    		legend.forEach(it => {
                    			if(it.indexOf(e.seriesName) >= 0){
                    				v = it;
                    			}
                    		});
                        	let l = v.indexOf('(');
                        	let r = v.indexOf(')');
                        	if(l + r > 1){
                                unit = v.substring(l+1,r);
                        	}
                    		x += '<br/>' + e.marker + e.seriesName + ' : ' + e.value;
                    		if(unit){
                                x += unit;
                    		}
                    	});
                    	return  (x+ '').replace(/(\d{1,3})(?=(\d{3})+(?:$|\.))/g,'$1,');
                    },
                },
                legend: {
					data: legend,
					right: 10,
				},
                grid: {
                    top: '20%',
                    left: '4%',
                    right: '4%',
                    bottom: '15%',
                    containLabel: true
                },
                xAxis: [{
                    type: 'category',
                    nameGap: 30,
                    data: xData,
                    "axisLine": {
                        lineStyle: {
                            color: '#90979c'
                        }
                    },
                    "splitLine": {
                        "show": false
                    },
                    "axisTick": {
                        "show": false
                    },
                    "splitArea": {
                        "show": false
                    },
                    "axisLabel": {
                        interval: 0,
                        rotate: 40,
                        formatter: (val) => {
                            if (val.length > 8) return val.substring(0, 8) + '...'
                            else return val
                        }

                    }
                }],
                yAxis: [{
                    type: 'value',
                    name: yName[0],
                    nameTextStyle: {
                    	fontSize: 11,
                    	padding: [0, 0, 10, 40],
                    },
                    axisLine: {
                        show: false
                    },
                    axisTick: {
                        show: false
                    },
                    axisLabel: {
                        formatter: (val) => {
                            if (Number(val) >= 10000) return (Number(val) / 10000).toFixed(1) + '万'
                            else return val
                        }

                    },
                },{
                    type: 'value',
                    name: yName[1],
                    nameTextStyle: {
                    	fontSize: 11,
                    	padding: [0, 60, 10, 0],
                    },
                    axisLine: {
                        show: false
                    },
                    axisTick: {
                        show: false
                    },
                    splitLine: {
                        show: false
                    },
                    axisLabel: {
                        formatter: (val) => {
                            if (Number(val) >= 10000) return (Number(val) / 10000).toFixed(1) + '万'
                            else return val
                        }
                    }
                }],
                dataZoom: [{
                    "show": true,
                    "height": 30,
                    "xAxisIndex": [
                        0
                    ],
                    bottom: 10,
                    startValue: 0,
                    endValue: yData.length > 6 ? 6 : yData.length - 1,
                    maxValueSpan: 6,
                    mixValueSpan: 6,
                    handleIcon: 'path://M306.1,413c0,2.2-1.8,4-4,4h-59.8c-2.2,0-4-1.8-4-4V200.8c0-2.2,1.8-4,4-4h59.8c2.2,0,4,1.8,4,4V413z',
                    handleSize: '110%',
                    handleStyle: {
                        color: "#d3dee5",
                    },
                    textStyle: {
                        color: "#0199FF"
                    },
                    borderColor: "#90979c"
                }, {
                    "type": "inside",
                    "show": true,
                    "height": 15,
                    "start": 1,
                    "end": 0
                }],
                series: [{
                    name: legend[0],
                    type: 'line',
                    barWidth: 30,
                    barGap: 20,
                    color: '#FF0101',
                    data: yData,
                    label: {
                        normal: {
                            show: true,
                            position: 'top',
                            fontSize: 10,
                        }
                    },
                },{
                    name: legend[1],
                    type: 'bar',
                    barWidth: 30,
                    barGap: 20,
                    color: '#0199FF',
                    yAxisIndex: 1,
                    label: {
                        show: true,
                        position: 'insideBottom'
                    },
                    data: y2Data,
                },],
            }
			return option2
        },
		// 关闭提示
		close() {
			this.tipShow = false;
		},
		// 是否为直辖市
		isCen(areaCode){
			let code = areaCode.slice(0,2);
			return code == '11' || code == '12' || code == '31' || code == '50';
		}
	}

};
