var secondaryPageTab = {
	props: ['isShow', 'id', 'barTitle', 'pageTitle', 'dateType', 'countDate', 'businessTypes', 'areaCode', 'level'],
	data() {
		return {
			// echart相关
			barTitle: '',
			yName: ['数量（件）','金额（万元）'],
			noData: false,
			// 下钻层级控制
			maxLevel: 3,
			isMaxLevel: false,
			// 表格相关
			tableHeight: null,
			// 数据
			isGetData: true,
			dataList: '',
			isSetting: false,
			headerStatus:false
		}
	},
	computed: {
		// 表格相关
		tableColumnList: function () {
			let tableColumnList = [];
			let rankColumn = {
				label: '排名',
				prop: 'ranking',
				isRanking: true,
				width: 45
			}
			let permissionLevel = getAccountLevel()
			let pageTitle = this.pageTitle;
			if (pageTitle.includes('边际贡献率')) {
				tableColumnList = tableColumn['边际贡献率']
				if (permissionLevel == '04') { // 市级用户
					sortColumn['边际贡献率'].unshift(rankColumn)
					tableColumnList = sortColumn['边际贡献率']
				}
				this.isSetting = false
				this.yName = '贡献率（%）'
			} else if (pageTitle.includes('亏损客户') && !pageTitle.includes('亏损客户明细')) {
				tableColumnList = tableColumn['亏损客户']
				if (permissionLevel == '04') { // 市级用户
					sortColumn['亏损客户'].unshift(rankColumn)
					tableColumnList = sortColumn['亏损客户']
					console.log(tableColumnList)
				}
				this.isSetting = false
				this.yName = ['数量（个）','金额（万元）']
			} else if (pageTitle.includes('重量稽核')) {
				tableColumnList = tableColumn['重量稽核'][this.id]
				if (permissionLevel == '04') { // 市级用户
					sortColumn['重量稽核'].unshift(rankColumn)
					tableColumnList = sortColumn['重量稽核']
				}
				if (permissionLevel == '03') { // 省级用户
					tableColumnList.forEach(columnItem => {
						columnItem.isRank=false;
					})
				}
				this.isSetting = false
				this.yName = ['数量（件）','金额（万元）']
			} else if (pageTitle.includes('赔偿客户')) {
				tableColumnList = tableColumn['赔偿客户']
				// if (permissionLevel == '04') { // 市级用户
				// 	sortColumn.unshift(rankColumn)
				// 	tableColumnList = sortColumn
				// }
				this.isSetting = false
			} else if (pageTitle.includes('无收寄')) {
				tableColumnList = tableColumn['无收寄']
				if (permissionLevel == '04') { // 市级用户
					sortColumn['无收寄信息邮件'].unshift(rankColumn)
					tableColumnList = sortColumn['无收寄信息邮件']
				}
				this.isSetting = false
				this.yName = ['邮件量（件）','考核金额（万元）']
			}else if (pageTitle.includes('单价情况')) {
				tableColumnList = tableColumn['单价情况']
				if (permissionLevel == '04') { // 市级用户
					sortColumn['单价情况'].unshift(rankColumn)
					tableColumnList = sortColumn['单价情况']
				}
				this.isSetting = false
				this.yName = ''
			}
			
			return tableColumnList;
		}
	},
	template: `
		<secondary-page
			ref="page"
			:no-data="noData"
			:area-code="areaCode"
			:count-date="countDate"
			:is-max-level="isMaxLevel"
			:table-column-list="tableColumnList"
			:table-height="tableHeight"
			:y-name="yName"
			:bar-title="barTitle"
			:data-list="dataList"
			:is-setting="isSetting"
			:page-title="pageTitle"
			:business-types="businessTypes"
			:id="id"
			@change-level="changeLevel"
			@change-area-code="changeAreaCode"
			@change-bar-title="changeBarTitle"
		>
		</secondary-page>
	`,
	watch: {
		// 监控是否显示
        isShow: function (val) {
			// 时间或地区更改
			if(val) {
				let areaLevel = getLevelFromPermission(this.level);
				console.log(areaLevel)
				let cacheData = this.$refs.page.cacheData[this.areaCode + this.countDate + areaLevel];
				if(cacheData) {
					this.dataList = cacheData.dataList;
					this.noData = false;
				} else {
					this.getData();
				}
			}
        },
		// 监控当时间变化时, 重新请求
		countDate: function(val) {
			if (val && this.isShow) {
				if(this.level == 1) {
					let userLevel = getAccountLevel();
					let userCode = getAccountCode();
					switch (userLevel) {
						case '01':
						case '02':
							// this.maxLevel = 4;
							this.maxLevel = 2;
							break;
						case '03':
							// this.maxLevel = this.isCen(userCode) ? 2 : 3;
							this.maxLevel = 1;
							break;
						case '04':
							// this.maxLevel = this.isCen(userCode) ? 1 : 2;
							this.maxLevel = 1;
							break;
						default:
							// this.maxLevel = 1;
							break;
					}
					this.isMaxLevel = this.level == this.maxLevel ? true : false;
					// this.tableColumnList[0].label = this.isMaxLevel ? '机构' : getNameFromPermission(this.level, false);
					this.tableColumnList.forEach(column => {
						if (column.prop == 'areaName' && this.id == 1) {
							column.label = getNameFromPermission(this.level, false)
							if(column.label==='区县'){
								column.label='地市'
							}
						}
					});
					this.$refs.page.$refs.tableBox.isShow = false;
					this.$nextTick(() => {
						this.$refs.page.$refs.tableBox.isShow = true;
					});
				}
				this.getData();
			}
		},
		level: function(val) {
			this.isMaxLevel = val == this.maxLevel ? true : false;
			// this.tableColumnList[0].label = this.isMaxLevel ? '机构' : getNameFromPermission(val, false);
			this.tableColumnList.forEach(column => {
				if (column.prop == 'areaName' && this.id == 1) {
					column.label = getNameFromPermission(this.level, false)
					if(column.label==='区县'){
						alert(column.label)
						column.label='地市'
					}
				}
			});
			this.$refs.page.$refs.tableBox.isShow = false;
			this.$nextTick(() => {
				this.$refs.page.$refs.tableBox.isShow = true;
			});
		},
		areaCode: function(val) {
			let areaLevel = getLevelFromPermission(this.level);
			console.log(this.level)
			let cacheData = this.$refs.page.cacheData[this.areaCode + this.countDate + areaLevel];
			if (val && this.isShow) {
				if (cacheData) {
					this.noData = false;
					this.dataList = cacheData.dataList;
				} else {
					this.getData();
				}
			}
		}
	},
	mounted() {
		this.handleScroll();
		if(this.countDate && this.isShow) {
			let userLevel = getAccountLevel();
			let userCode = getAccountCode();
			switch (userLevel) {
				case '01':
				case '02':
					// this.maxLevel = 4;
					this.maxLevel = 2;
					break;
				case '03':
					// this.maxLevel = this.isCen(userCode) ? 2 : 3;
					this.maxLevel = 1;
					break;
				case '04':
					// this.maxLevel = this.isCen(userCode) ? 1 : 2;
					this.maxLevel = 1;
					break;
				default:
					// this.maxLevel = 1;
					break;
			}
			this.isMaxLevel = this.level == this.maxLevel ? true : false;
			// this.tableColumnList[0].label = this.isMaxLevel ? '机构' : getNameFromPermission(this.level, false);
			this.tableColumnList.forEach(column => {
				if (column.prop == 'areaName' && this.id == 1) {
					column.label = getNameFromPermission(this.level, false)
				}
			});
			this.getData();
		}
	},
	methods: {
		// 监控页面滚动体
		handleScroll() {
			let windowScrollTop = document.getElementsByClassName('tableBox')[0].getBoundingClientRect().top;
			let fullTabNav = document.getElementsByClassName('fullTabNav')[0]
			window.onscroll = () =>{
				let dom = document.getElementsByClassName('tableBox')[0];
				let windowHeight = document.documentElement.clientHeight || document.body.clientHeight;
				let scrollTop = dom.getBoundingClientRect().top;
				let tabNavHeight = 0;
				if (fullTabNav) {
					tabNavHeight = fullTabNav.getBoundingClientRect().height
				}
				if (Math.floor(scrollTop) <= tabNavHeight) {
					if (fullTabNav) {
						window.scrollTo(0, windowScrollTop);
					}
					this.tableHeight = windowHeight - tabNavHeight;
				} else if (Math.floor(scrollTop) > tabNavHeight) {
					this.tableHeight = null;
				}
			}
		},
		// 获取数据
		getData() {
			let countDate = this.dateType == 'W' ? this.countDate.split('-')[0] + this.countDate.split(' ')[1] : this.countDate;
			let pageTitle = this.pageTitle
			let apiMap = {}
			if (pageTitle.includes('边际贡献率')) {
				apiMap = {
					'trendLine': getMarginalContributeRateTrend,
					'table': getAccountLevel() == '04'? getMarginalContributeRateRank : getMarginalContributeRateDetail
				}
			} else if (pageTitle.includes('亏损客户') && !pageTitle.includes('亏损客户明细')) {
				apiMap = {
					'trendLine': queryLossCustomTrend,
					'table': getAccountLevel() == '04'? queryLossCustomRank : queryLossCustomByArea
				}
			} else if (pageTitle.includes('重量稽核') && this.id == 1) {
				apiMap = {
					'trendLine': selectWeightAuditTrendVoByDate,
					'table': getAccountLevel() == '04'? selectWeightAuditRankVoByDate : selectWeightAuditVoByDate
				}
			}  else if (pageTitle.includes('重量稽核') && this.id == 2) {
				apiMap = {
					'trendLine': selectWeightAuditTrendVoByDate,
					'table': selectCompensateCustomersVoByDate
				}
			} else if (pageTitle.includes('无收寄')) {
				apiMap = {
					'trendLine': getNoPostInfoMailTrendByArea,
					'table': getAccountLevel() == '04'? getNoPostInfoMailRankByArea : getNoPostInfoMailDetailByArea
				}
			}else if (pageTitle.includes('单价情况')) {
				console.log(232323)
				apiMap = {
					'trendLine': queryUnitPriceTrend,
					'table': getAccountLevel() == '04'? queryUnitPriceRank : queryUnitPriceByArea
				}
			}
			// 趋势图
			let p1 = new Promise((resolve, reject)=>{
				let params = {
					statMonth: countDate,
					productType: this.businessTypes,
					areaCode: this.areaCode,
					areaLevel: this.level
				}
				console.log('params:',params)
				apiMap['trendLine'](params).then(({data}) => {
					// this.setData(data);
					resolve(data)
				}).catch(err => {
					// this.noData = true;
					reject(err)
				})
			})
			// 表格
			let p2 = new Promise((resolve, reject)=>{
				let params = {
					statMonth: countDate,
					productType: this.businessTypes,
					areaCode: this.areaCode,
					areaLevel: this.level
				}
				console.log('params:',params)
				apiMap['table'](params).then(({data}) => {
					// this.setData(data);
					resolve(data)
				}).catch(err => {
					// this.noData = true;
					reject(err)
				})
			})
			Promise.all([p1, p2]).then(data => {
				this.setData(data)
			}).catch(err => {
				console.log(err)
				this.noData = true;
				this.dataList = '';
			})
		},
		setData(data) {
			if (!data[0] && !data[1]) {
				this.noData = true;
				this.dataList = '';
				return;
			}
			this.noData = false;
			this.dataList = data;
			console.log(this.dataList)
			if (data[1]) { 
				this.areaCode = this.areaCode ? this.areaCode : JSON.parse(data[1])[0].areaCode;
				this.$emit("change-area", this.areaCode, this.level);
			}
		},
		// 表格下钻
		changeLevel(row, isGetData) {
			this.areaCode = row.areaCode;
			this.level = this.level + 1;
			this.isGetData = isGetData;
			this.noData = isGetData == false ? false : this.noData;
			this.$emit("change-area", this.areaCode, this.level);
			if (this.isCen(row.areaCode) && getAccountLevel() < 3) {
				this.isMaxLevel = this.level == this.maxLevel - 1 ? true : false;
			} else {
				this.isMaxLevel = this.level == this.maxLevel ? true : false;
			}
		},
		// 页面返回上一层
		upLevel() {
			console.log(this.dataList)
			this.level = this.level - 1;
			this.isMaxLevel = false;
			this.$refs.page.upLevel();
		},
		// 返回上一层时更改areaCode
		changeAreaCode(areaCode, isGetData) {
			this.areaCode = areaCode;
			this.isGetData = isGetData;
			this.noData = isGetData == false ? false : this.noData;
			this.$emit("change-area", this.areaCode, this.level);
		},
		// 设置柱状图name
		changeBarTitle(title) {
			this.$emit('change-bar-title', title)
		},
		// 是否为直辖市
		isCen(areaCode){
			let code = areaCode.slice(0,2);
			return code == '11' || code == '12' || code == '31' || code == '50';
		},
		// 清除默认排序
		clearSort() {
			this.$refs.page.clearSort();
			this.getData()
		}
	}

};