var secondaryPage = {
	props: ['noData', 'areaCode', 'isMaxLevel', 'tableColumnList', 'tableHeight', 'isSetting', 'dataList','indexType'],
	data() {
		return {
			tipShow: false,
			msg: '当前日期的数据暂未更新呢！',
			beforeAreaCode: '',
			tableData: [],
			// 缓存数据
            cacheData: {},
            pageNo: 1,
            pageSize: 100,
            pageNoMax: 100,
            pageSizeMax: 100,
		}
	},
	template: `
		<div>
			<div v-show="!noData"  class="table2222">
				<table-box
					ref="tableBox"
					:table-column-list="tableColumnList"
					:table-data="tableData"
					:table-height="tableHeight"
					@load-more="loadMore"
				>
				</table-box>
			</div>
			<!-- 暂无数据 -->
			<div v-show="noData">
				<run-text img-url="../../" :msg="msg" :is-show="tipShow" @close="close"></run-text>
				<div class="noData">
					<img src="../../../image/nodata.png" alt="暂无数据" />
					<h3>暂无数据</h3>
				</div>
			</div>
		</div>
	`,
	watch: {
		noData(val) {
			this.tipShow = val;
		},
		dataList(val) {
			if (val) {
				this.setData();
			}
		}
	},
    mounted() {
        this.handleScroll();
    },
	methods: {
		// 监控页面滚动体
        handleScroll() {
            window.onscroll = () => {
                let dom = document.getElementsByClassName('tableBox')[0];
                let windowHeight = document.documentElement.clientHeight || document.body.clientHeight;

                let scrollTop = dom.getBoundingClientRect().top;
                if (Math.floor(scrollTop) <= 0) {
                    this.tableHeight = windowHeight;
                } else if (Math.floor(scrollTop) > 0) {
                    this.tableHeight = null;
                }
            }
        },
		// 数据处理
		setData() {
            console.log(this.$refs.tableBox)
            console.log(this.indexType);
            if(this.indexType=='1' || this.indexType == '5'){

            }else
            if(this.indexType=='2'){

            }else
            if(this.indexType=='3'){

            }else
            if(this.indexType=='4'){

            }else
            {
            }
			// 数据判空
            // 处理表格数据
            let data = this.dataList;
            if (this.dataList) {
                data.forEach((item, index) => {
                    this.tableColumnList.forEach(columnItem => {
                    })
                });
                //将分页数据合并到一起
                this.$nextTick(() => {
                    if(this.pageNo == 1){
                        this.list = data;
                    }else{
                        this.list.push(...data);
                    }
                });
            }
            if(this.pageNo == 1){
                this.renderPage(data);
            }else{
                this.renderPage(this.list);
            }
		},
		// 渲染页面
		renderPage(data) {
			// 表格
			this.tableData = data;

			this.$refs.tableBox.$refs.table.clearSort();
		},

        // 关闭提示
        close() {
            this.tipShow = false;
        },
        //下拉分页
        loadMore: function(){
            console.log("加载更多...");
            if(this.pageNo >= this.pageNoMax){
                return;
            }
            this.$refs.table.$refs.tableActive.clearSort();
            this.pageNo++;
            this.$emit('getPageNoParams',this.pageNo)
        },
	},
};
