var imp = {
	components: {
	},
	props: ['show','month','monthType','scopeServices','productType','type','id'],
	data(){
		return {
		   	noData:false,
		   	list: [],
		   	specialName: [],
		   	tablecolumn: [],
            pageNo: 1,
            pageSize: 100,
            pageNoMax: 100,
            pageSizeMax: 100,
		};
	},
	watch: {
		show: function(val){
			if(this.show && (this.list.length == 0 || this.noData)){
				this.initData();
			}
		},
		month: function(){
			this.initData();
		},
	},
	computed: {
    	tableHeight: function(){
            console.log(this.id);
            let w = document.documentElement.clientWidth || document.body.clientWidth;
    		let h = document.documentElement.clientHeight || document.body.clientHeight;
        	return h - (w*100) / 375 * 0.8;
    	},
	},
	methods: {

        // 监控页面滚动体
        handleScroll() {
            window.onscroll = () =>{
                let windowHeight = document.documentElement.clientHeight || document.body.clientHeight;
                this.tableHeight = windowHeight-40;
            }

        },
		initColumn(){
			let w = document.documentElement.clientWidth || document.body.clientWidth;
			w -= 4;
			w /= 10;
			this.tablecolumn = [
                {
                    label: '序号',
                    key: 'name',
                    width: 70,
                    fixed : true
                },
                {
                    label: '法定层客户名称',
                    isDrillDown: true,
                    key: 'mastCustomerName',
                    isMaxLevel:true,
                    align: 'center'
                },
                {
                    label: '月收入（万元）',
                    key: 'income',
                    isNumber: true,
                    align: 'center'
                },
                {
                    label: '月收入增幅（%）',
                    key: 'samePeriodIncrease',
                    // key: 'disAverRate',
                    isNumber: true,
                    align: 'center',
                },
                {
                    label: '月业务量（万件）',
                    key: 'declineAmount',
                    // key: 'disAverRate',
                    isNumber: true,
                    align: 'center',
                },
                {
                    label: '月业务量增幅（%）',
                    key: 'customerName',
                    // key: 'disAverRate',
                    isNumber: true,
                    align: 'center',
                },
                {
                    label: '年收入（万元）',
                    key: 'customerName',
                    // key: 'disAverRate',
                    isNumber: true,
                    align: 'center',
                },
                {
                    label: '年收入增幅（%）',
                    key: 'link',
                    // key: 'disAverRate',
                    isNumber: true,
                    align: 'center',
                },
                {
                    label: '年业务量（万件）',
                    key: 'link',
                    // key: 'disAverRate',
                    isNumber: true,
                    align: 'center',
                },
                {
                    label: '年业务量增幅（%）',
                    key: 'link',
                    // key: 'disAverRate',
                    isNumber: true,
                    align: 'center',
                }
            ]
		},
	    initData(){
 	    	if(this.type == 'imp'){
 	    		this.initImpData();
 	    	}
	    },
	    initImpData(){
            this.noData = false;
 	    	let params = {
 	    			/*dateType: this.monthType,
 	    			countDate: this.month,
 	    			scopeServices: this.scopeServices,
 	    			baseProductCode:this.productType*/
                    districtId:"100000",
                    districtLevel:"60",
                    statisticalPeriod:"YEAR",
                    statisticsMonth:"202010",
                    sortItem:3,
                    top:10,
                    sortRule:"DESC"
 			}
            getIncomeDeclineCustomerAnalysis(params).then(({data}) => {
                // JSON.stringify(data)
                console.log(data);
                if(!data){
 	 			   		this.noData = true;
 	 					return;
 	 			   	}
 	 			   /*	let list = JSON.parse(data);
 	 			   	list.forEach(e => {
 	 			   		e.name = this.convertToName(e.importCityName);
 	 			   		e.sxzsl = this.convertToRate(e.limitOntimerate);
 	 			   		e.hb = this.convertToRate(e.roundRate);
 	 			   	});*/

 	 			   	// this.list = list;
 	 			   	this.list = data.top.businessEnterprise;
                console.log(this.list);
                this.noData = false;
 	 			}).catch(err => {
 	 			  	this.noData = true;
 	 			  	console.log(err);
 	 			});
	    },
        setData() {
            // 处理表格数据
            let data = this.dataList;
            if (this.dataList) {
                data.forEach((item, index) => {
                    this.tableColumnList.forEach(columnItem => {
                    })
                });
                //将分页数据合并到一起
                this.$nextTick(() => {
                    if(this.pageNo == 1){
                        this.list = data;
                    }else{
                        this.list.push(...data);
                    }
                });
            }
            if(this.pageNo == 1){
                this.renderPage(data);
            }else{
                this.renderPage(this.list);
            }
        },
        renderPage(data) {
            console.log(data)
            // 表格
            this.tableData = data;
            this.$refs.table.$refs.tableActive.clearSort();
        },
        notEmpty(arg){
        	if(arg === undefined || arg === '' || arg == null){
        		return false;
        	}else{
        		return true;
        	}
        },
        convertToName(arg){
        	return this.notEmpty(arg) ? arg : '其他';
        },
        convertToRate(arg){
        	return this.notEmpty(arg) ? (arg * 1).toFixed(2) : '-';
        },
        //页面下钻
        changeLevel (row){
		    let param = {

            }
            let url = "/fiveSystemKanban/marketSystem/KeyCustomers/CustomersTOP20/CustomerTOP20Detailed.html"
            Emp.execute("go('"+url+"','"+JSON.stringify(param)+"', false)");
        },
        //下拉分页
        loadMore: function(){
            console.log("加载更多...");
            if(this.pageNo >= this.pageNoMax){
                return;
            }
            this.$refs.table.$refs.tableActive.clearSort();
            this.pageNo++;
            this.initImpData();
        },
	},
	created() {
	},
	mounted() {
        this.handleScroll();
		this.initColumn();
		if(this.show){
			this.initData();
		}
	},
    template: `
    	<div>
			<drill-down-box
					ref="table"
					:list="list"
					:tablecolumn="tablecolumn"
					:table-height="tableHeight"
					:special-name="specialName"
					@drilldown="changeLevel"
					@load-more="loadMore"
					>
				</drill-down-box>
			<div class="noData" v-if="noData">
				<img src="../../../image/nodata.png" alt="暂无数据"/>
				<h3>暂无数据</h3>
			</div>
    	</div>
    `,
};
