var impExportTab = {
	props: ['show', 'month', 'monthType', 'productType', 'scopeServices'],
	data() {
		return {
			active: 0,
			activeBtn: {},
			tabBtn: [
				{
					id: 1,
					name: "月累计",
					type: 'imp',
				}, {
					id: 2,
					name: "年累计",
					type: 'imp',
				}
			],
			id : 1,
		};
	},
	components: {
		'tab-btn-box': tabBtnBox,
	},
	watch: {
		show: function (val) {
			if (val && !this.activeBtn && !this.activeBtn.type) {
				this.active = 0;
				this.activeBtn = {
                    id: 1,
                    name: "月累计",
                    type: 'imp',
				}
			}
		},
	},
	methods: {
		chooseTabBtn: function (item) {
			this.activeBtn = item;
			this.active = item.id - 1;
            this.id = item.id;
		},
	},
	created() {
	},
	mounted() {
	},
	template: `
    	<div style="background: #FFF;">
			<div style="height:0.4rem;background:#FFF;box-shadow: 0px 1px 4px 0px rgba(187, 182, 182, 0.5);">
				<tab-btn-box :tab-btn="tabBtn" @choose-tab-btn="chooseTabBtn"></tab-btn-box>
			</div>
			<div class="tab">
					<imp
						ref="imp"
						v-show="show && active==0"
						:show="show && active == 0"
						:month="month"
						:month-type="monthType"
						:scope-services="scopeServices"
						:product-type="productType"
						type="imp"
						:id ="id"
					/>
					<imp
						ref="imp"
						v-show="show && active==1"
						:show="show && active == 1"
						:month="month"
						:month-type="monthType"
						:scope-services="scopeServices"
						:product-type="productType"
						type="imp"
						:id ="id"
					/>
				
					<imp
						ref="imp"
						v-show="show && active==2"
						:show="show && active == 2"
						:month="month"
						:month-type="monthType"
						:scope-services="scopeServices"
						:product-type="productType"
						type="imp"
						:id ="id"
					/>
			</div>
    	</div>
    `,
};

