var baseCompentsub = {
    props: ['isShow', 'isMax', 'echartShow', 'myMixin', 'pageTitle', 'dateType', 'countDate', 'businessTypes', 'tabName', 'importRcportType', 'level', 'areaCode','activeNavId','customerDetail'],
    data() {
        return {
            // echart相关
            yName: ["完成率情况(%)", '达标情况'],
            noData: false,
            // 下钻层级控制
            // level: 1,
            maxLevel: 3,
            isMaxLevel: false,
            // 当前页面地区
            // areaCode: '',
            // 表格相关
            tableHeight: null,
            // 数据
            dataCountDate: '',
            dataList: '',
            currentType: '',
            onlyTable: false,
            echartData: '',
            pdaTitle: '',
            headerStatus:false,
            cacheRow:'',
            cacheCode:'',
            titleRow:'',
        }
    },
    computed: {
        // 表格相关
        tableColumnList: function (val) {
            let userLevel = getAccountLevel();
            console.log(this.pageTitle)
            console.log(this.level)
            //  console.log(this.tableColumnList[0].label)
            // console.log('tableColumnList',tableColumn[this.pageTitle+'-'+this.tabName])
            var subTitle = this.currentType !== '' ? this.currentType : this.tabName
            var arr = [...tableColumn[this.pageTitle + '-' + subTitle]]
            console.log(arr)
           
                return tableColumn[this.pageTitle + '-' + subTitle]
        }
    },
    template: `
        <base-compent
            ref="page"
            :no-data="noData"
            :area-code="areaCode"
            :is-max-level="isMaxLevel"
            :table-column-list="tableColumnList"
            :table-height="tableHeight"
            :y-name="yName"
            :data-list="dataList"
            :line-title="pageTitle"
            :pda-title="pdaTitle"
            :echart-show='echartShow'
            :cacheCode = 'cacheCode'
            :only-table = 'onlyTable'
            @change-level="changeLevel"
            @change-area-code="changeAreaCode"
            :customer-detail='customerDetail'
        >
        </base-compent>
	`,
    watch: {
        // 监控是否显示
        isShow: function (val) {
            console.log(val)
            if (val && this.countDate && (!this.dataList || (this.dataCountDate && this.dataCountDate != this.countDate))) {
                this.getData();
            }
        },
        //禁止下钻单独表格
        isMax: function (val) {
            if (val) {
                this.isMaxLevel = true
            } else {
                this.isMaxLevel = false
            }
        },
        // 监控当时间变化时, 重新请求
        countDate: function (val) {
            if (val) {
                if (this.level == 1) {
                    let userLevel = getAccountLevel();
                    let userCode = getAccountCode();
                    switch (userLevel) {
                        case '01':
                        case '02':
                            this.maxLevel = 3;
                            break;
                        case '03':
                            this.maxLevel =  2;
                            break;
                        case '04':
                            if (this.tabName == '重点管控投诉' || this.tabName == '重点管控异常'){
                                this.maxLevel =  2;
                            } else {
                            this.maxLevel =  1;
                            }
                            break;
                        default:
                            this.maxLevel = 1;
                            break;
                    }
                    this.isMaxLevel = this.level == this.maxLevel ? true : false;
                    this.changeTableColumnLable()
                    // this.tableColumnList[0].label = this.isMaxLevel ? '机构' : getNameFromPermission(this.level, false);
                    this.$refs.page.$refs.tableBox.isShow = false;
                    this.$nextTick(() => {
                        this.$refs.page.$refs.tableBox.isShow = true;
                    });
                }
                this.getData();
                this.setTableDown()
            }
        },
        level: function (val) {
            console.log('-----------', val)
            // this.tableColumnList[0].label = this.isMaxLevel ? '机构' : getNameFromPermission(val, false);
            this.changeTableColumnLable()
            this.$refs.page.$refs.tableBox.isShow = false;
            this.$nextTick(() => {
                this.$refs.page.$refs.tableBox.isShow = true;
            });
        }
    },
    mounted() {
        console.log('-------------------------------'+this.customerDetail);
        this.handleScroll()
        this.setTableDown()

    },
    methods: {
        normalDown() {
            if (this.countDate && this.isShow) {
                let userLevel = getAccountLevel();
                let userCode = getAccountCode();
                console.log('userLevel', userLevel)
                switch (userLevel) {
                    case '01':
                    case '02':
                        if (this.pageTitle == '问题邮件一次及时解决率' || this.pageTitle == '理赔及时率') {
                            this.maxLevel = 2;
                        } else {
                            this.maxLevel = 3;
                        }
                        break;
                    case '03':
                        this.maxLevel = 2;
                        break;
                    case '04':
                        this.maxLevel = 1;
                        break;
                    default:
                        this.maxLevel = 1;
                        break;
                }
                console.log('normalDownnormalDown', this.isMaxLevel)
                this.isMaxLevel = this.level == this.maxLevel ? true : false;
                this.changeTableColumnLable()
                // this.getData();
            }
        },
        disableDown() {
            this.isMaxLevel = true
            //this.maxLevel = 1
            //this.isMaxLevel = this.level == this.maxLevel ? true : false;
            this.changeTableColumnLable()
            // this.getData();
        },
        twoCenDown() {
            console.log('twoCenDown', this.level)
            this.maxLevel = 2
            // this.isMaxLevel = this.level == this.maxLevel ? true : false;
            console.log('--------------', this.isMaxLevel)
            this.changeTableColumnLable()
            // this.getData();
        },
        twoDown() {
            this.maxLevel = 2
            // this.getData()
        },
        //改变表头第一列内容
        changeTableColumnLable() {
            // if(this.tabName == 'PDA直派率' && this.level > 1){
            //     alert(1122)
            //     this.tableColumnList[0].label = '区域'
            // }
        },
        // 监控页面滚动体备注
        // handleScroll() {
        //     let topHeight = document.getElementsByClassName('el-row')[0].clientHeight
        //     alert(1)
        //     window.onscroll = function(){
        //         let tableHeight = document.documentElement.clientHeight - topHeight
        //         let dom = document.getElementsByClassName('tableBox')[0];
        //         //到顶部的距离
        //         let scrollTop = dom.getBoundingClientRect().top;
        //         console.log(scrollTop)
        //         console.log(topHeight)
        //         if ((scrollTop-1) <= topHeight) {
        //             if (!this.headerStatus) {

        //                 this.headerStatus = true;
        //                 this.tableHeight = tableHeight;
        //                 // setTimeout(() => {
        //                 //     this.$refs.page.$refs.tableBox.$refs.table.doLayout()
        //                 // }, 300);
        //             }
        //         } else{

        //             this.headerStatus = false;
        //             this.tableHeight = null;
        //         }
        //     }
        // },

        // 监控页面滚动体 (监听dom)
            handleScroll() {
	    		window.onscroll = () =>{
	    			let windowHeight = document.documentElement.clientHeight || document.body.clientHeight;
					this.tableHeight = windowHeight-42; 
				}
	    		
			},


        // 根据不同title获取不同数据
        getData(type,row) {
            console.log('查询'+this.level+this.areaCode)
            this.dataCountDate = this.countDate;
            this.handleType(type,row) //根据标题处理逻辑

        },

        getPageAllData(apiMap, trendApi, p, detailApi,cacheRow) {
            //获取趋势
            console.log('当前查询的areaCode',this.areaCode)
            let p1 = new Promise((resolve, reject) => {
                console.log('this.areaCode---',this.areaCode)
                let temp = {
                    countDate: this.countDate,
                    areaCode: this.areaCode,
                    areaLevel: this.level
                }
                var params = {}
                if(p !== 'undefined') {
                    params = Object.assign(temp,p);
                }else{
                    params = p
                }
                console.log('----p-',params)
                trendApi(params).then(({ data }) => {
                    resolve(data)
                }).catch(err => {
                    reject(err)
                })

            })
             //获取表格
            let p2 = new Promise((resolve, reject) => {
                let temp = {
                    countDate: this.countDate,
                    areaCode: this.areaCode,
                    areaLevel: this.level
                }
                console.log('cacheRow',cacheRow)
                if(cacheRow){
                    temp.reason = cacheRow.reason
                    temp.part = cacheRow.part
                }
                var params = {}
                if(p !== 'undefined') {
                    params = Object.assign(temp,p);
                }else{
                    params = p
                }
                console.log('detailApi---------',detailApi)
                if(detailApi){
                    console.log('detailApi',detailApi)
                    apiMap[detailApi](params).then(({ data }) => {
                        resolve(data)
                   }).catch(err => {
                       reject(err)
                   })
                }else{
                    apiMap[this.tabName](params).then(({ data }) => {
                        resolve(data)
                   }).catch(err => {
                       reject(err)
                   })
                }
            })
            Promise.all([p1, p2]).then((result) => {
                var data = {}
                if(result[1]){
                    data.tableList = result[1]
                }else{
                    data.tableList = '无数据'
                    console.log('tableList无数据')
                }
                if(result[0]){
                    data.echartData = result[0]
                }else{
                    data.echartData = '无数据'
                    console.log('echartData无数据')
                }
                console.log(data)
                this.setData(data)

            }).catch((error) => {
                // alert(error)
                console.log(error)
                this.noData = true;
            })
        },
        handleType(type,cacheRow) {
            var params = {}
            console.log('根据标题处理数据：标题name',this.pageTitle)
            switch (this.pageTitle) {
                case '客户投诉率':
                    params.importRcportType = this.importRcportType;
                    var apiMap = {
                        '区域': selectCustomcomplainVoByDate,
                        '最差处理中心': selectWorstHandleComplainVoByDate,
                        '最差揽投部': selectWorstCollectComplainVoByDate,
                        '重点管控投诉': selectKeyControlComplainVoByDate,
                        '最差处理中心详情': getComplainPointTop10ByHandleCenter,
                        '最差揽投部详情': getComplainPointTop10ByDept,
                        '重点管控投诉详情': selectKeyControlLinksByDate,
                    }
                    var trendApi = selectCustomcomplainTrendVoByDate
                    this.getPageAllData(apiMap, trendApi, params,type,cacheRow)
                    break;
                default:
                    break;
            }
        },
        getDownType(type) { //获取下钻类型
            if (type == 1) {
                if (this.tabName == '区域') {
                    this.normalDown()
                } else {
                    this.disableDown()
                }
            } else if (type == 2) {
                if (this.tabName == '区域') {
                    this.normalDown()
                } else {
                    this.twoCenDown()
                }

            } else if (type == 3) {
                if (this.tabName == '区域') {
                    this.normalDown()
                } else if (this.tabName == '重点管控投诉' || this.tabName == '重点管控环节') {
                    this.twoDown()
                } else {
                    this.disableDown()
                }
            }
            this.getData();
        },
        setTableDown() {
            switch (this.pageTitle) {
                // Type = 1 //区域下钻 ，其他tab禁止下钻
                // Type = 2 //区域下钻，其他tab下钻一层 到只留table
                // Type = 3 //区域下钻，重点管控投诉，重点管控环节下钻一层
                case '客户投诉率':
                    this.getDownType(2)
                    break;
                default:
                    break;
            }
        },

        setData(data) {
            //忽略只有表格的echart 空数据判断
            if(!this.onlyTable){
                if (!data || (data.tableList == '无数据' || data.echartData == '无数据')) {
                    this.noData = true;
                    return;
                }
            }else{//只有表格 处理table 无数据 显示无数据
                if (data.tableList == '无数据') {
                    this.noData = true;
                    return;
                }else{
                    data.echartData = '无数据'
                }
            }

            if (JSON.stringify(data) !== '{}') {
                this.noData = false;
                this.dataList = data;
                console.log(this.dataList)
                this.areaCode = this.areaCode ? this.areaCode : getAccountCode();

            }
        },
        // 表格下钻
        changeLevel(row, isGetData) {
            this.titleRow = row;
            // alert('下钻'+row.areaCode)
            // this.areaCode = row.areaCode
            //1-defaultStateList - 区域下钻 其他不变
            //2-secondStateList - 区域下钻 其他下钻只留表格
            //3-internationalList - 区域下钻 重点管控环节、重点管控投诉下钻只保留表格
            var internationalList = ['智能跟单异常发生率-国际EMS','智能跟单异常发生率-国际包裹','客户投诉率']
            var wentiandlipeiSecondStateList = ['问题邮件一次及时解决率','理赔及时率'];
            // 3
            if(internationalList.includes(this.pageTitle)){
                if (this.tabName == '最差处理中心' || this.tabName == '最差揽投部') {
                    //触发watch变更tableColumnList
                    this.tableColumnList = tableColumn['重点管控投诉']
                    this.currentType = '重点管控投诉'
                    //只保留表格
                    this.areaCode = row.areaCode;
                    this.level = this.level + 1;
                    console.log('要下钻', this.level)
                    this.isMaxLevel = true
                    var type = this.tabName +'详情'

                    this.handleType(type,row)
                }else if(this.tabName == '重点管控环节' || this.tabName == '重点管控投诉'){
                    this.tableColumnList = tableColumn['最差处理中心']
                    this.currentType = '最差处理中心'
                    console.log(row)
                    this.areaCode = row.areaCode;
                    // 只留表格level 不加+1
                    // this.level = this.level + 1;
                    this.isMaxLevel = true
                    var type = this.tabName +'详情'
                    console.log('----------'+type,row)
                    this.handleType(type,row)
                }else {
                    this.areaCode = row.areaCode;
                    this.level = this.level + 1;
                    this.isMaxLevel = this.level == this.maxLevel ? true : false;
                    if (isGetData) {
                        this.getData();
                       
                    }
                }
              

            }

        },
        
        // 返回上一层时更改areaCode
        changeAreaCode(areaCode, isGetData) {
            console.log('返回上一层时更改areaCode',areaCode)
            this.areaCode = areaCode;
            if (isGetData) {
                this.getData();
            }
        },
        // 是否为直辖市
        isCen(areaCode) {
            console.log('-----------------areaCode', areaCode)
            let code = areaCode.slice(0, 2);
            return code == '11' || code == '12' || code == '31' || code == '50';
        }
    }

};
