var globalDetail = {
	data(){
		return {
			noData: false,
			level: 1,
			code: '',
	        list: [],
	        cacheList: {},
	        specialName: [],
	        cacheSpecialName: {},
	        barList: [],
	        barListCache: {},
	        legend: ['增幅', '客户数'],
			valueName: ['增幅(%)','客户数(万)'],
			echartsName: '',
			cacheEchartsName: {},
			tableHeight: null,
			syncTag: false,
			tablecolumn: this.initColumn(),
		}
	},
	props: ['month','classify','industryLevel','industryCode','industryName','customLevel','customName'],
    watch: {
        month: function(val, oldVal) {
	    	this.initData(this.code);
        },
        level: function(val,oldVal) {
        	if(this.tablecolumn && this.tablecolumn.length > 0){
        		this.tablecolumn[0].label = getNameFromPermission(val,false);
        	}
        },
    },
	methods:{
		initColumn(){
			return [
	 	    	 	{
	 		    		label: '区域',
	 		    	    key: 'name',
	 		    	    fixed: true,
	 		    	    width: 80,
	 		    	    isDrillDown: true,
	 		    	},{
	 		    		label: '活跃客户数(个)',
	 		    	    key: 'khs',
	 		    	    width: 100,
	 		    	    sortable: 'custom',
	 		    	    align: 'right',
	 		    	    isNumber: true,
	 		    	},{
	 		    		label: '活跃客户增幅(%)',
	 		    	    key: 'khzf',
	 		    	    width: 100,
	 		    	    sortable: 'custom',
	 		    	    align: 'right',
	 		    	    isNumber: true,
	 		    	    subByZero: true,
	 		    	},{ 
	 		    		label: '客户收入|(万元)',
	 		    	    key: 'khsr',
	 		    	    sortable: 'custom',
	 		    	    width: 100,
	 		    	    align: 'right',
	 		    	    isNumber: true,
	 		    	},{
	 		    		label: '收入增幅|(%)',
	 		    	    key: 'srzf',
	 		    	    sortable: 'custom',
	 		    	    width: 100,
	 		    	    align: 'right',
	 		    	    isNumber: true,
	 		    	    subByZero: true,
	 		    	}
	 	    	];
		},
        drillDown: function (data){
        	this.level += 1;
        	this.$refs.table.$refs.tableActive.clearSort();
        	this.initData(data.row.nameCode);
        },
        sortList: function(list){
        	this.list = list;
        },
        goBack(){
            if (this.level == 1){
            	 return;
            }
            this.level -= 1;
            this.$refs.table.$refs.tableActive.clearSort();
            this.list = this.cacheList[this.level];
            this.specialName = this.cacheSpecialName[this.level];
            //为什么delete，2个接口同步可能会有问题
            delete this.cacheSpecialName[this.level + 1];
            this.barList = this.barListCache[this.level];
            this.echartsName = this.cacheEchartsName[this.level];
            this.$nextTick(() => {
                this.$refs.linebar.initDefault();
            });
            this.noData = false;
        },
        registerListener() {
        	let dom = document.getElementById('container');
        	let windowHeight = document.documentElement.clientHeight || document.body.clientHeight;
        	let overHeight = windowHeight / 2 + 20;
			window.onscroll = () =>{
				let scrollTop = dom.getBoundingClientRect().top;
				if (Math.floor(scrollTop) <= overHeight * -1) {
					this.tableHeight = windowHeight;
				} else {
					this.tableHeight = null;
				}
			}
        },
	    initData(code){
        	this.syncTag = false;
        	//industryLevel为空时，是活跃客户的总体概况请求时需要传0
        	let params1 = {
            		statDate: this.month,
            		customGrade: this.customLevel,
            		industryGrade: this.industryLevel ? this.industryLevel : '0',
            		industryCode: this.industryCode ? this.industryCode : '',
            		classify: this.classify,
            		areaLevel: this.level,
            		areaCode: code,
		    }
        	let params2 = {
            		statDate: this.month,
            		customGrade: this.customLevel,
            		industryGrade: this.industryLevel ? this.industryLevel : '0',
            		industryCode: this.industryCode ? this.industryCode : '',
            		classify: this.classify,
            		areaLevel: this.level,
            		areaCode: code,
		    }
        	if(this.customName){
        		//从活跃客户按等级页面表格下钻跳过来，查按表格的表
            	this.setTrendData(requestActiveDrillTrendByLevel(params2),this.customName);
            	this.setData(requestActiveDrillByLevel(params1),this.customName);
        	}else{
        		//访问按行业表的接口
            	this.setData(requestActiveDrillByIndustryPro(params1),this.industryName);
            	this.setTrendData(requestActiveDrillTrendByIndustryPro(params2),this.industryName);
        	}
	    },
	    setData(promise,echartsName){
	    	if(!echartsName){
	    		//总体概况行业是A无值，所以置空
	    		echartsName = "";
	    	}
	    	promise.then(({data}) => {
	    		if(!data || data == '[]'){
		    		this.noData = true;
		       		return;
		       	}
		       	let list = JSON.parse(data);
		       	this.specialName = [];
		       	list.forEach((e,i) => {
			   		if(e.areaName == '全国' || e.areaName == '总部直属' || e.areaName == '省直属' || e.areaName == '省直辖'){
			   			e.name = e.areaName;
			   		}else{
			   			e.name = this.convertToName(e.areaSname);
			   		}
		    		e.nameCode = e.areaCode;
		    		e.khs = e.curMonthTotalCustomer;
		    		e.khzf = this.convertToRate(e.curMonthTotalCustomerRate);
		    		e.khsr = this.convertToW(e.curMonthTotalBusinessIncome);
		    		e.srzf = this.convertToRate(e.curMonthTotalIncomeRate);
		    		
		    		if(getLevelFromPermission(this.level) >= 2){
		    			e.notDrill = true;
		    		}
		    		
		       		if(i == 0){
		       			this.specialName.push(e.name);
		       		}
		      	})
		      	this.list = list;
	            this.cacheList[this.level] = list;
	            this.cacheSpecialName[this.level] = this.specialName;
	            this.tablecolumn[0].label = getNameFromPermission(this.level,false);
	            this.noData = false;
       			if(this.syncTag){
       				this.syncTag = false;
       				this.echartsName = this.specialName[0] + echartsName;
       				this.cacheEchartsName[this.level] = this.echartsName;
		            this.$nextTick(() => {
		                this.$refs.linebar.initDefault();
		            });
       			}else{
       				this.syncTag = true;
       			}
		    }).catch(err => {
		    	this.noData = true;
		    });
	    },
	    setTrendData(promise,echartsName){
	    	if(!echartsName){
	    		//总体概况行业是A无值，所以置空
	    		echartsName = "";
	    	}
	    	promise.then(({data}) => {
	    		if(!data || data == '[]'){
		       		return;
		       	}
	    		let list = JSON.parse(data);
	    		list.forEach((e,i) => {
	    			e.name = e.statDate ? e.statDate : '';
		    		e.value = this.convertToRate(e.curMonthTotalCustomerRate);
		    		e.value2 = this.convertToW(e.curMonthTotalCustomer);
	    		})
	    		this.barList = list;
	    		this.barListCache[this.level] = list;
	    		if(this.syncTag){
	    			this.syncTag = false;
	    			this.echartsName = this.specialName[0] + echartsName;
	    			this.cacheEchartsName[this.level] = this.echartsName;
		            this.$nextTick(() => {
		                this.$refs.linebar.initDefault();
		            });
	    		}else{
	    			this.syncTag = true;
	    		}
		    }).catch(err => {
		    	console.log(err)
		    });
	    },
        notEmpty(arg){
        	if(arg === undefined || arg === '' || arg == null){
        		return false;
        	}else{
        		return true;
        	}
        },
        convertToName(arg){
        	return this.notEmpty(arg) ? arg : '其他';
        },
        convertToRate(arg){
        	return this.notEmpty(arg) ? (arg * 100).toFixed(2) : '-';
        },
        convertToW(arg){
        	return this.notEmpty(arg) ? Math.round(arg / 10000) : '-';
        },
	},
	created(){
		window['goBack'] = () => {
	           if (this.level == 1) {
	                  console.log('返回普元');
	                try {
	                    Emp.execute('goBack()');
	                } catch (e) {
	
	                }
	                return
	            }
	           this.goBack();
	        };
	},
	mounted(){
		this.registerListener();
		if(this.month){
			this.initData(this.code);
		}
	},
	template: `
    	<div>
			<div id="container" v-show="!noData" style="background: #FFF;">
				<div>
					<line-bar-box
					ref="linebar"
					:list="barList"
					:legend="legend"
					:value-name="valueName"
					:echart-name="echartsName"
					/>
				</div>
				<div>
					<drill-down-box
					ref="table"
					:list="list"
					:tablecolumn="tablecolumn"
					:table-height="tableHeight"
					:special-name="specialName"
					@drilldown="drillDown"
					@sortList="sortList"
					/>
				</div>
			</div>
			<div class="noData" v-if="noData">
				<img src="../../image/nodata.png" alt="暂无数据" />
				<h3>暂无数据</h3>
			</div>
		</div>
    `,
}