// 扫码支付tab页
var scanTab = {
	props: ['level', 'areaCode', 'beforeAreaCode', 'name', 'active', 'date', 'type', 'legend', 'valueName', 'echartName', 'tableColumnList', 'isSetting', 'mergeSpan'],
    data() {
		return {
			tipShow: false,
			msg: '当前日期的数据暂未更新呢！',
			
			maxLevel: 3,
			isMaxLevel: false,
			noData: false,
			tableHeight: {
				'A' : null,
				'Y' : null,
				'J' : null
			},
			tableData: [],
			// 缓存数据
            cacheData: {},
			// 当前页面地区
            
            // 上一级页面地区
			beforeAreaCode: '',
			list: []
		}
	},
	template: `
		<div>
			<div id="container" v-show="!noData">
				<line-bar-box 
					v-if="type != 'B'"
					:ref="name" 
					:list="list" 
					:legend="legend" 
					:value-name="valueName"
					:echart-name="echartName"
				>
				</line-bar-box>
				<div ref="tableBoxDiv">
					<table-box
						ref="tableBox"
						:table-column-list="tableColumnList"
						:table-data="tableData"
						:is-setting="isSetting"
						:table-height="tableHeight[name]"
						:divide-code="areaCode"
						:is-max-level="isMaxLevel"
						:provided-drill-down="providedDrillDown"
						@sort-list="sortTableData"
						@change-table-column="changeTableColumn"
					>
					</table-box>
				</div>
			</div>
			<div v-if="noData">
				<run-text img-url="../../" :msg="msg" :is-show="tipShow" @close="close"></run-text>
				<div class="noData">
					<img src="../../image/nodata.png" alt="暂无数据" />
					<h3>暂无数据</h3>
				</div>
			</div>
		</div>
	`,
	watch: {
		// 监控当时间变化时, 重新请求
		date: function(val) {
			// this.handleScroll();
			if(!val) {
				this.noData = true;
				this.tipShow = true;
			}
			let userLevel = getAccountLevel();
			if (userLevel == '01' || userLevel == '02') {
				this.maxLevel = 3
			} else if(userLevel == '03'){
				this.maxLevel = 2
			} else if(userLevel == '04'){
				this.maxLevel = 1
			}
			this.isMaxLevel = this.level < this.maxLevel ? false : true;
			// this.echartName = getNameFromPermission(this.level);
			this.tableColumnList[0].label = getNameFromPermission(this.level);
			if (getNameFromPermission(this.level) == '机构') {
				this.tableColumnList[0].width = 154
			} else {
				this.tableColumnList[0].width = 80
			}
			this.getData();
		},
		level: function(val) {
        	if(this.tableColumnList && this.tableColumnList.length > 0){
				if (this.$refs.tableBox) {
					this.$refs.tableBox.isShow = false;
				}
				// this.echartName = getNameFromPermission(val);
				this.tableColumnList[0].label = getNameFromPermission(val);
				if (getNameFromPermission(val) == '机构') {
					this.tableColumnList[0].width = 154
				} else {
					this.tableColumnList[0].width = 80
				}
				this.$nextTick(() => {
					if (this.$refs.tableBox) {
						this.$refs.tableBox.isShow = true;
					}
				});
			}
			this.isMaxLevel = this.level < this.maxLevel ? false : true;
			const cacheData = this.cacheData[this.name + this.areaCode + this.level + this.date];
			// 获取数据，重新渲染页面
			if(cacheData) {
				this.beforeAreaCode = cacheData.beforeAreaCode;
				this.list = cacheData.echartData;
				this.tableData = cacheData.tableData;
				this.noData = !this.tableData && !this.tableData.length
				this.echartName = cacheData.tableData[0].areaSname
				this.$nextTick(() => {
					this.$refs[this.name].initDefault()
				})
			} else {
				this.getData();
			}
			Emp.execute("setTitle('"+this.echartName+"')")
			this.$emit("synclevel",{level: val, areaCode: this.areaCode, beforeAreaCode: this.beforeAreaCode, echartName: this.echartName});
		}
	},
	mounted() {
		// this.handleScroll();
		// 第一次显示的时候
		if (this.date) {
			let userLevel = getAccountLevel();
			if (userLevel == '01' || userLevel == '02') {
				this.maxLevel = 3
			} else if(userLevel == '03'){
				this.maxLevel = 2
			} else if(userLevel == '04'){
				this.maxLevel = 1
			}
			this.isMaxLevel = this.level < this.maxLevel ? false : true;
			this.tableColumnList[0].label = getNameFromPermission(this.level);
			if (getNameFromPermission(this.level) == '机构') {
				this.tableColumnList[0].width = 154
			} else {
				this.tableColumnList[0].width = 80
			}
			this.getData();
			setTimeout(() => {
				if (this.$refs.tableBox) {
					this.$refs.tableBox.isShow = false;
				}
			}, 10);
			setTimeout(() => {
				if (this.$refs.tableBox) {
					this.$refs.tableBox.isShow = true;
				}
			}, 10);
		}
		// 计算表格高度
		setTimeout(()=>{
			// 距离body的高度
			let offsetTop = document.getElementsByClassName('van-tabs__content')[0].offsetTop;
			// body的高度
			let windowHeight = document.documentElement.clientHeight || document.body.clientHeight;
			this.tableHeight[this.name] = windowHeight - offsetTop;
			
		}, 0)
	},
	methods: {
		// 获取数据
		getData() {
			let params = {
				statDate: this.date,
				dateType: 'W',
				belong: this.name,
				areaCode: this.areaCode,
				areaLevel: String(this.level)
			};
			if (this.type == 'A') {
				// 投递支付收款情况 - 全部 / 邮政 / 寄递
				queryDeliveryPay(params).then(({data}) => {
					this.setData(data); 
				}).catch(err => {
					this.noData = true
					this.tipShow = true;
				})
			} else if(this.type == 'B') {
				// 现金收款缴存情况 - 全部 / 邮政 / 寄递
				queryCollectionPay(params).then(({data}) => {
					this.setData(data); 
				}).catch(err => {
					this.noData = true
					this.tipShow = true;
				})
			} else if(this.type == 'C'){
				// 现金妥投缴款概率 - 全部 / 邮政 / 寄递
				queryVotePay(params).then(({data}) => {
					this.setData(data); 
				}).catch(err => {
					this.noData = true
					this.tipShow = true;
				})
			}
		},
		// 整理数据
		setData(data) {
			// alert(data)
			if(!data || data == '[]' ) {
				this.noData = true;
				this.tipShow = true;
				return;
			}
			this.noData = false;
			this.tipShow = false;
			data = JSON.parse(data);
			
			// 数据判空
			data.forEach((item, index) => {
				if (item.belong == "Y") {
					item.belong = "邮政"
				} else if (item.belong == "J") {
					item.belong = "寄递"
				}
				if(index == 0) {
					this.areaCode = this.areaCode ? this.areaCode : item.areaCode;
					this.beforeAreaCode = item.pAreaCode ? item.pAreaCode : '100000';
					this.mergeSpan = item.areaCode;
				}
				this.tableColumnList.forEach(columnItem => {
					if (columnItem.children) {
						columnItem.children.forEach(e=>{
							if (e.is10Thousand) {
								item[e.prop] = item[e.prop] === null ? '' : (item[e.prop] / 10000).toFixed(2)
							} else if (e.isRate) {
								item[e.prop] = item[e.prop] === null ? '' : (item[e.prop] * 100).toFixed(2)
							}
						})
					} else {
						if (columnItem.prop == 'areaSname') {
							item[columnItem.prop] = !item[columnItem.prop] ? '其他' : item[columnItem.prop]
						}
						if (columnItem.is10Thousand) {
							item[columnItem.prop] = item[columnItem.prop] === null ? '' : (item[columnItem.prop] / 10000).toFixed(2)
						} else if (columnItem.isRate) {
							item[columnItem.prop] = item[columnItem.prop] === null ? '' : (item[columnItem.prop] * 100).toFixed(2)
						}
					}
					
				})
			})
			if (this.type == 'A') {
				data.forEach((item, index)=>{
					item.name = item.areaSname
					item.nameCode = item.areaCode
					item.value = item.polyPayRate ? item.polyPayRate : "--"
					item.value2 = item.polyPayMoney ? item.polyPayMoney : "--"
				})
			} else if(this.type == 'C') {
				data.forEach((item, index)=>{
					item.name = item.areaSname
					item.nameCode = item.areaCode
					item.value = item.paymentRate ? item.paymentRate : "--"
					item.value2 = item.cashPayMoney ? item.cashPayMoney : "--"
				})
			}
			this.echartName = data[0].areaSname
			Emp.execute("setTitle('"+this.echartName+"')")
			this.tableData = data
			this.list = data.slice(1)
			this.$refs.tableBox.$refs.table.doLayout();
			if (this.type != 'B') {
				this.$nextTick(()=>{
					this.$refs[this.name].initDefault()
				})
			}
			this.$emit("synclevel",{level: this.level, areaCode: this.areaCode, beforeAreaCode: this.beforeAreaCode, echartName: this.echartName});
			// 缓存数据
			this.cacheData[this.name + this.areaCode + this.level + this.date] = {
				"beforeAreaCode": this.beforeAreaCode,
				"tableData": data,
				"echartData": this.list
			}
		},
		// 表格下钻
        providedDrillDown(row, prop) {
			if(prop == 'areaSname') {
				this.level = this.level + 1;
				this.areaCode = row.areaCode;
				this.beforeAreaCode = row.pAreaCode
				this.isMaxLevel = this.level == this.maxLevel ? true : false;
				const cacheData = this.cacheData[this.name + this.areaCode + this.level + this.date];
                // 获取数据，重新渲染页面
                if(cacheData) {
					this.beforeAreaCode = cacheData.beforeAreaCode;
					this.list = cacheData.echartData;
					this.tableData = cacheData.tableData;
					this.$nextTick(() => {
						this.$refs[this.name].initDefault()
					})
                } else {
                    this.getData();
                }
			}
		},
		// 表格数据排序
		sortTableData(data) {
			this.tableData = data;
		},
		changeTableColumn(data) {
			this.tableColumnList = data;
			this.$emit("change-table-column", this.name, data);
		},
		// 返回上一级
        upLevel() {
            if (this.level == 1) {
                Emp.execute("goBack()");
            } else {
                this.level = this.level - 1;
				this.areaCode = this.beforeAreaCode;
				this.isMaxLevel = this.level == this.maxLevel ? true : false;
                const cacheData = this.cacheData[this.name + this.areaCode + this.level + this.date];
				// 获取数据，重新渲染页面
                if(cacheData) {
					this.beforeAreaCode = cacheData.beforeAreaCode;
					this.list = cacheData.echartData;
					this.tableData = cacheData.tableData;
					this.noData = !this.tableData && !this.tableData.length
					this.$nextTick(() => {
						this.$refs[this.name].initDefault()
						
					})
                } else {
                    this.getData();
                }
            }
		},
		close() {
			this.tipShow = false;
		},
		// 监控页面滚动体
		handleScroll() {
			let windowScrollTop = this.$refs.tableBoxDiv.getBoundingClientRect().top;
			window.onscroll = () =>{
				let scrollTop = this.$refs.tableBoxDiv.getBoundingClientRect().top;
				let windowHeight = document.documentElement.clientHeight || document.body.clientHeight;
				if (Math.floor(scrollTop) < 30) {
					window.scrollTo(0, windowScrollTop);
					this.tableHeight[this.active] = windowHeight - 30;
				} else if (Math.floor(scrollTop) >= 30) {
					this.tableHeight[this.active] = null;
				}
			}
		}
	}
}