/**
 * yy
 */
//指标下钻
Vue.component('trendLineBox', {
    data() {
        return {
            style1: {
                color: '#0199FF'
            },
            style2: {
                color: '#000000'
            },
            sortType: true,
            upColor: 'red', // 上升颜色
            downColor: 'green' // 下降颜色
        }
    },
    props: {
        tablecolumn: {
            Array,
            default: () => {
                return []
            }
        },
        tableHeight: {
        	Number,
        	default: null
        },
        legend: {
        	Object,
            default: () => {
                return {}
            }
        },
        title: {
            String,
            default: '省份'
        },
        yName: {
            String,
            default: '收入增幅趋势'
        },
        trendList: {
        	Array,
	        default: () => {
	            return []
	        }
        },
        trafficList: {
        	Array,
	        default: () => {
	            return []
	        }
        },
        goalRate: {
            Number,
            default: 0
        },
        list: {
            Array,
            default: () => {
                return []
            }
        },
        isDrillDown: {
            Boolean,
            default: true
        },
        isNo: {
            Boolean,
            default: true
        },
        notReverse: {
            Boolean,
            default: true
        },
        defaultSort: {
            Object,
            default: () => {
                return {
                    prop: 'locCode',
                    order: 'ascending'
                }
            }
        },
        echartName: {
            String,
            default: ''
        },
        isShowLine: {
            Boolean,
            default: false
        },
        valueMax: {
            String,
            default: null
        },
        specialName: {
            Array,
            default: () => {
                return ['总计','其他']
            }
        }
    },
    computed: {
        // x_data() {
        //     const newList = this.list.sort((i, n) => {
        //         return Number(i.locCode) - Number(n.locCode)
        //     });
        //     const arr = this.list.filter(e => e.areaName !== '总计')
        //     return arr.map(i => i.areaName);
        // },
        // value_data() {
        //     console.log(this.list);
        //     const newList = this.list.sort((i, n) => {
        //         return Number(i.locCode) - Number(n.locCode)
        //     });
        //     const arr = this.list.filter(e => e.areaName !== '总计')
        //     return arr.map(i => i.areaName);
        // }
    },
    methods: {
        getColor(val) {
            if (val === '-' || parseFloat(val) == 0) return '';
            if (this.notReverse) {
                if (parseFloat(val) < 0) return this.downColor;
                if (parseFloat(val) > 0) return this.upColor;
            } else {
                if (parseFloat(val) < 0) return this.upColor;
                if (parseFloat(val) > 0) return this.downColor;
            }
        },
        getValue(val,compareKey,isRate, subKey) {
            if (val === undefined || val === '' || val == null) {
            	res = '-'
            } else {
                res = val
            }
            return res
        },
        xiazuan(item, key) {
            if (key === 'areaName') {
                if (!this.isDrillDown || !this.filterDrillDown(item.name)) return;
                this.$emit('drilldown', {
                    item: item,
                    key: key
                })
            } else {
                if (key.isDrillDown && item[key.key] != 0) {
                    this.$emit('drilldown', {
                        item: item,
                        key: key.key
                    })
                }
            }
        },
        initDefault() {
            document.documentElement.scrollIntoView();
            const xDataArr = this.trendList.map(i => i.dateCode);
            const item = new Set(xDataArr);
            const xDataCode = Array.from(item);
            const xData = xDataCode.map(item => {
                let newitem = item.slice(4, 6)
                if (Number(newitem)<10) {
                    return Number(newitem) + '月'
                } else {
                    return newitem + '月'
                }
            })
            const lineData0 = this.trendList.filter(i => i.prodType == 'A').map(i => i.fRateM);
            const lineData1 = this.trendList.filter(i => i.prodType == 'B').map(i => i.fRateM);
            const lineData2 = this.trendList.filter(i => i.prodType == 'K').map(i => i.fRateM);
            const lineData3 = this.trendList.filter(i => i.prodType == 'G').map(i => i.fRateM);
            const lineData4 = this.trendList.filter(i => i.prodType == 'W').map(i => i.fRateM);
            // console.log(lineData0, lineData1, lineData3, lineData4)
            // this.initEcharts2(xData,valueData,valueData1,valueData2,valueData3,lineData);
            this.initEcharts2(xData,lineData0,lineData1,lineData2,lineData3,lineData4);
        },
        initEcharts2(xData,lineData0,lineData1,lineData2,lineData3,lineData4) {
            const _this = this
            let mychart2 = echarts.init(document.getElementById('chart2'));
            let option2 = {
                color: ['#0199FF'],
                legend: {
                    data:_this.legend.data,
                    top: 24
                },
                tooltip: {
                    trigger: 'axis',
                    axisPointer: { // 坐标轴指示器，坐标轴触发有效
                        type: 'shadow' // 默认为直线，可选为：'line' | 'shadow'
                    },
                    formatter: function (params) {
                        let tars = [];
                    	params.forEach(item => {
                    		if(item.value != '-'){
                    			tars.push(item);
                    		}
                    	})
                    	let tip;
                    	if(tars){
                    		tip = tars[0].name;
                    	}
                    	tars.forEach(tar => {
                    		tip += '<br/>' + tar.marker + tar.seriesName + ' : ' + tar.value;
                    	})
                    	return tip ? tip : '-';
                    },
                },
                grid: {
                   
                    bottom: '-8',
                    containLabel: true
                },
                xAxis: [{
                    type: 'category',
                    nameGap: 30,
                    data: xData,
                    "axisLine": {
                        lineStyle: {
                            color: '#90979c'
                        }
                    },
                    "splitLine": {
                        "show": false
                    },
                    "axisTick": {
                        "show": false
                    },
                    "splitArea": {
                        "show": false
                    },
                    "axisLabel": {
                        interval: 0,
                        rotate: 40,
                        formatter: (val) => {
                            if (val.length > 6) return val.substring(0, 6) + '...'
                            else return val
                        }

                    }
                }],
                yAxis: [{
                    type: 'value',
                    name: _this.yName,
                    max: _this.valueMax,
                    axisLine: {
                        show: false
                    },
                    axisTick: {
                        show: false
                    },
                    axisLabel: {
                        formatter: (val) => {
                            if (Number(val) >= 10000) return (Number(val) / 10000).toFixed(1) + '万'
                            else return val
                        },
                        textStyle: {
                            color: '#666666',
                        }
                    },
                    nameTextStyle: {
                        color:"#333333", 
                        padding: [30, 0, 30, 0]    // 四个数字分别为上右下左与原位置距离
                    }
                }],

                series: [
                // {
                // 	name: _this.legend[1],
                // 	type: 'bar',
                // 	barWidth: 30,
                // 	barGap: 20,
                // 	color: '#F74627',
                // 	data: valueData1,
                // 	stack: '1',
                // 	label: {
                // 		normal: {
                // 			show: 'true',
                // 			position: 'inside',
                // 			rotate: 0,
                // 			fontSize: 10,
                // 			color: "#FFFFFF"
                // 		}
                // 	},
                // },
                // {
                //     name: _this.legend[1],
                //     type: 'bar',
                //     barWidth: 30,
                //     barGap: 20,
                //     color: '#0197FF',
                //     data: valueData2,
                //     stack: '1',
                //     label: {
                //         normal: {
                //             show: 'true',
                //             position: 'inside',
                //             rotate: 0,
                //             fontSize: 10,
                //             color: "#FFFFFF"
                //         }
                //     },
                // },
                // {
                //     name: _this.legend[1],
                //     type: 'bar',
                //     barWidth: 30,
                //     barGap: 20,
                //     color: '#00C482',
                //     data: valueData3,
                //     stack: '1',
                //     label: {
                //         normal: {
                //             show: 'true',
                //             position: 'inside',
                //             rotate: 0,
                //             fontSize: 10,
                //             color: "#FFFFFF"
                //         }
                //     },
                // },
                    {
                        name: _this.legend.data[0],
                        type: 'line',
                        color: '#FFA91F',
                        label: {
                            normal: {
                                show: 'true',
                                position: 'top',
                                rotate: 0,
                                fontSize: 10,
                            }
                        },
                        data: lineData0,
                    },
                    {
                        name: _this.legend.data[1],
                        type: 'line',
                        color: '#EC4863',
                        data: lineData1,
                    },
                    {
                        name: _this.legend.data[2],
                        type: 'line',
                        color: '#13CAD6',
                        data: lineData2,
                    },
                    {
                        name: _this.legend.data[3],
                        type: 'line',
                        color: '#4169E1',
                        data: lineData3,
                    },
                    {
                        name: _this.legend.data[4],
                        type: 'line',
                        color: '#008000',
                        data: lineData4,
                    }
                ],
            }
            mychart2.setOption(option2, true);
            mychart2.on('legendselectchanged', function (params) {
                let option = this.getOption();
                if (!params.selected[params.name]) {
                    // false 的时候
                    let isTure = [];
                    for(var item in params.selected){
                        if (params.selected[item]) {
                            isTure.push(item)
                        };
                    }
                    if (isTure.length > 0) {
                        option.legend[0].selected[params.name] = false;
                    } else {
                        option.legend[0].selected[params.name] = true;
                    }
                } else {
                    // true 的时候
                    option.legend[0].selected[params.name] = true;
                }
                this.setOption(option)
            });
        },
        setWidth() {
            const width = this.title.length > 2 ? 120 : 80;
            if (this.tablecolumn.length === 1) return null;
            else return width
        },
        setColumnWidth(text){
    		if(!text){
    			return 80;
    		}
    		const len = text.length;
    		if(len <= 2){
    			return 80;
    		}else{
    			return 80 + 10 * (len - 2);
    		}
        },
        // 对比昨天，获取颜色
        getColorByCompareYest(row, item) {
            // 检验昨日值字段
            if (!item.compareYestKey) {
            	return ''
            }
            if(row[item.compareYestKey] == 0){
            	return ''
            }
            return row[item.compareYestKey] > 0 ? this.upColor : this.downColor
        },
        // 将值分段，赋给不同颜色
        
        // 设置表格样式
        cellStyle({row, column, rowIndex, columnIndex}){
            let value = row[column.property]
            if (column['property'] == 'areaSname') {
                return 'background: #F5F5F5; color: #333'
            } else if(value < 0){
                return 'background: #FC836E; color: #333'
            } else if(value == 0){
                return 'background: #FFF; color: #333'
            }
            if(column.property == 'totalRate'){ 
                if(!value){   
                    return 'background: #FFF; color: #333'
                }
                if (value <= row['totalGoalRate']) {
                    return 'background: #FFF; color: #333'
                } else if (value > row['totalGoalRate']) {
                    return 'background: #58DEB6; color: #333'
                }
            } else if (column.property == 'expressRate'){
                if(!value){   
                    return 'background: #FFF; color: #333'
                }
                if (value <= row['expressGoalRate']) {
                    return 'background: #FFF; color: #333'
                } else if (value > row['expressGoalRate']) {
                    return 'background: #58DEB6; color: #333'
                }
            } else if (column.property == 'packageRate'){
                if(!value){   
                    return 'background: #FFF; color: #333'
                }
                if (value <= row['packageGoalRate']) {
                    return 'background: #FFF; color: #333'
                } else if (value > row['packageGoalRate']) {
                    return 'background: #58DEB6; color: #333'
                }
            } else if (column.property == 'internationalRate'){
                if(!value){   
                    return 'background: #FFF; color: #333'
                }
                if (value <= row['internationalGoalRate']) {
                    return 'background: #FFF; color: #333'
                } else if (value > row['internationalGoalRate']) {
                    return 'background: #58DEB6; color: #333'
                } 
            } else if (column.property == 'logisticsRate'){
                if(!value){   
                    return 'background: #FFF; color: #333'
                }
                if (value <= row['logisticsGoalRate']) {
                    return 'background: #FFF; color: #333'
                } else if (value > row['logisticsGoalRate']) {
                    return 'background: #58DEB6; color: #333'
                } 
            } 
        },
        getColorStyle(row, item) {
            // if (item.subKey && item.isRate) {
            //     return this.getColorBySub(row, item)
            // } else {
            //     return this.style2
            // }
        },
        getPaddingRight(scope, item) {
        	if(!item.width && item.align == 'right') {
                let width = (scope.column.realWidth - scope.column.label.length * 12) / 2;
        		if(item.sortable){
        			width += 12;
        		}
            	return width + 8 +'px';
        	} else {
        		if(item.sortable && item.align == 'right') {
        			return '30px';
                }
        		return '32px';
        	}
        },
        // 表头换行
        renderHeader(h, { column, $index }) {
        	var lab = column.label;
        	if(lab.indexOf("|") < 0){
        		return h('span',{},lab)
        	}else{
        		var arr = lab.split('|')
        		const list = [];
        		arr.forEach(item => {
        			list.push(h('span', {}, item));
                    list.push(h('br'));
        		})
        		list.pop()
        		return h('span', {}, list)
        	}
        },
        //特殊名字过滤
        filterDrillDown(name){
            if (this.specialName.indexOf(name) < 0) return true;
            else return false
        },
    },
    mounted() {
        const h = document.documentElement.clientHeight || document.body.clientHeight;
        document.getElementById('chart2').style.height = h / 2 + 'px';
    },
    template: `<div>
                <div style="box-sizing: border-box">
                    <div style=" position: relative;  border-bottom: 1px dashed #E2E3E5;" v-show="isShowLine">
                        <div id="chart2" style="background-color: #FFF; width: 100%"></div>
                    </div>
                    <div style="display: flex; color: #666666; padding: 8px 0; font-size: 12px">
                        <div style="display: flex; align-items: center; margin-right: 15px">
                            <div style="width: 15px; height: 15px; margin-right: 5px; background: #FF6347; border: 1px solid #535353;"></div>
                            <div>负值</div>
                        </div>
                        <div style="display: flex; align-items: center; margin-right: 15px">
                            <div style="width: 15px; height: 15px; margin-right: 5px; background: #FFFFFF; border: 1px solid #535353;"></div>
                            <div>>0%<目标值</div>
                            </div>
                        <div style="display: flex; align-items: center; margin-right: 15px">
                            <div style="width: 15px; height: 15px; margin-right: 5px; background: #58DEB6; border: 1px solid #535353;"></div>
                            <div>大于目标值</div>
                        </div>
                    </div>
                    <div id="trendTable">
                        <el-table
                                :data="trafficList"
                                border
                                :header-cell-style="{background:'#0199FF',color:'#FFF', height: '30px', 'text-align': 'center', fontSize: '12px', fontWeight: 'normal'}"
                                :row-style="{height:'30px',fontSize: '12px'}"
                                :default-sort="defaultSort"
                                style="width: 100%"
                                :cell-style="cellStyle"
                                :height="tableHeight"
                        >
                            <el-table-column
                                    v-if="isNo"
                                    type="index"
                                    label="序号"
                                    align="center"
                                    fixed
                                    width="50"
                            >
                            </el-table-column>
                            <el-table-column
                                    prop="areaSname"
                                    :label="title"
                                    fixed
                                    :width="setWidth()"
                                    align="left">
                                <template slot-scope="scope">
                                    <span>{{scope.row.areaSname}}</span>
                                </template>
                            </el-table-column>
                            <el-table-column
                                    v-for="item in tablecolumn"
                                    :key="item.key"
                                    :prop="item.key"
                                    :label="item.label"
                                    label-class-name="headerClass"
                                    :render-header="renderHeader"
                                    :sortable="item.sortable"
                                    :width="item.width ? item.width : setColumnWidth(item.label)"
                                    :align="!item.align ? 'center' : item.align">
                                <template slot-scope="scope">
                                <!--如果是率-->
                                <span v-if="!item.isDrillDown" :class="item.sortable ? 'paddingR24' : ''" :style="{color: getColorStyle(scope.row,item),fontWeight:item.isNumber ? 600 : 'normal',paddingRight: getPaddingRight(scope, item)}" >
                                    {{getValue(scope.row[item.key],scope.row[item.compareYestKey],item.isRate,scope.row[item.subKey])}}
                                </span>
                                <!--其他-->
                                <span v-else @click="xiazuan(scope.row, item)" :class="item.sortable ? 'paddingR24' : ''" :style="[item.isDrillDown && scope.row[item.key] != 0 ? style1 : style2 ]">
                                    {{getValue(scope.row[item.key],scope.row[item.compareYestKey])}}
                                </span>
                                </template>
                            </el-table-column>
                        </el-table>
                    </div>
                </div>
</div>`
});