var cardA = {
    data() {
        return {
        	normalColor: '#333',
            upColor: '#009900',
            downColor: '#FA2525',
        }
    },
    props: {
    	item:{
    		Object,
    		default: () => {
    			return {
    				desc: '指标描述',
    				name: '',
    				image: '../image/timeLimit/icon_csj.png',
    				sjz: 0,
    				mbz: 0,
    				hb: 0,
    				zjmc: '-',
    				zj: 0,
    				zcmc: '-',
    				zc: 0,
    				rank: '',
    			};
    		},
    	},
    },
    computed: {
    },
    methods: {
    	descClick(){
    		this.$emit('desc-click',this.item);
    	},
    	itemClick(){
    		this.$emit('item-click',this.item);
    	},
		getColorByTrend(arg){
			if(arg){
				let i = arg;
				if(i > 0){
					return '#009900';
				}else if(i < 0){
					return '#FA2525';
				}
			}
			return null;
		},
		getRankName(){
        	let lv = getLevelFromPermission(1);
        	if(lv == 2) return '全网';
        	if(lv == 3) return '全省';
        	if(lv == 4) return '全市';
        	return '';
        },
		notEmpty(arg){
        	if(arg === undefined || arg === '' || arg == null){
        		return false;
        	}else{
        		return true;
        	}
        },
        convertToName(arg){
        	return this.notEmpty(arg) ? arg : '-';
        },
        convertToRate(arg){
        	return this.notEmpty(arg) ? (arg * 1).toFixed(2) + '%' : '-%';
        },
        convertToW(arg){
        	return this.notEmpty(arg) ? Math.round(arg / 10000) + '万元' : '-万元';
        },
    },
    mounted() {

    },
    template: `
    	<div style="background:#FFF;padding:0px 8px 6px 8px;margin-bottom: 0.12rem;border-radius:5px;" @click.stop="itemClick">
    		<div style="height:0.36rem">
    			<span style="font-size:0.16rem;font-weight: bold;">{{this.convertToName(item.name)}}</span>
    			<span style="padding:0px 6px;" @click.stop="descClick">
	    			<img style="width:0.16rem; height:0.16rem" src="../image/description_icon.png"/>
    			</span>
    			<span v-show="item.rank" style="float:right;display: flex;align-items: center;height:0.2rem;line-height:0.2rem;margin-top:0.06rem;background: #F9F6F4;border-radius: 0.1rem 0 0 0.1rem;">
	                <img style="width:0.12rem; height:0.12rem;margin-left:0.08rem" src="../image/trophy.png" >    
	                <span style="font-size: 0.12rem;line-height:0.2rem;color:#9F7933;font-weight: 400;margin:0 0.06rem 0 0.02rem;">{{getRankName() + '第' + item.rank + '名'}}</span>
	            </span>
    		</div>
    		<div style="display:flex;">
    			<div>
    				<img style="width: 0.79rem;height: 0.79rem;" v-bind:src="item.image"/>
    			</div>
    			<div style="display:flex;flex-direction:column;margin-left:0.16rem;width:100%">
	    			<div style="display:flex;height:0.51rem;">
		    			<div style="width:40%;display:flex;flex-direction:column;justify-content:space-evenly;align-items:center;">
							<p style="font-size: 0.12rem;color: #333;">实际完成</p>
							<p style="font-size: 0.18rem;color: #3377FF;font-weight: bold;">{{this.convertToRate(item.sjz)}}</p>
						</div>
						<div style="width:50%;display:flex;flex-direction:column;justify-content:space-evenly;align-items:center;">
							<p style="font-size: 0.12rem;color: #333;">目标值</p>
							<p style="font-size: 0.18rem;color: #3377FF;font-weight: bold;">{{this.convertToRate(item.mbz)}}</p>
						</div>
	    			</div>
	    			<p style="line-height:0.12rem;font-size: 0.12rem;">
		    			<span style="color: #666;">环比</span>
						<span :style="{fontWeight: 'bold',color: getColorByTrend(item.hb)}">{{this.convertToRate(item.hb)}}</span>
	    			</p>
	    			<div style="display:flex;margin-top:0.03rem;">
			    		<div style="display:flex;width:50%;line-height:0.18rem;font-size: 0.12rem;">
			    			<div style="width:0.29rem">
				    			<span style="color: #666;">最佳</span>
				    		</div>
				    		<div>
								<span style="font-weight: bold;color: #333;">{{this.convertToName(item.zjmc)}}</span>
								<span style="font-weight: bold;color: #009900;">{{this.convertToRate(item.zj)}}</span>
							</div>
			    		</div>
			    		<div style="display:flex;width:50%;line-height:0.18rem;font-size: 0.12rem;">
			    			<div style="width:0.29rem">
								<span style="color: #666;">最差</span>
							</div>
							<div>
								<span style="font-weight: bold;color: #333;">{{this.convertToName(item.zcmc)}}</span>
								<span style="font-weight: bold;color: #FA2525;">{{this.convertToRate(item.zc)}}</span>
							</div>
			    		</div>
	    			</div>
    			</div>
    		</div>
    	</div>
    `,
};