/**
 * yy
 */
var lineBox = {
	data() {
	    return {
	    }
	},
    props: {
    	xlist: [],
        legend: {
        	Array,
        	default: () => {
        		return ['增幅', '客户数'];
        	}
        },
        legendSimple: null,
        valueName: {
        	String,
        	default: () => {
        		return '';
        	},
        },
        tooltipPrefix: '',
        tooltipSuffix: '',
        colors: {
        	Array,
        	default: () => {
        		return ['#F74627','#0F987A','#FFB444','#0197FF','#00C482','#CC0065','#A23FEB','#FF7D00'];
        	},
        },
    },
    computed: {
    },
    methods: {
    	initDefault(arr) {
            document.documentElement.scrollIntoView();
            const _this = this
            let option = {
            	color: _this.colors,
                tooltip: {
                    trigger: 'axis',
                    axisPointer: { // 坐标轴指示器，坐标轴触发有效
                        type: 'shadow' // 默认为直线，可选为：'line' | 'shadow'
                    },
                    formatter:function(param){
                    	let arr = param.filter(e => e.value);
                    	if(!arr || arr.length <= 0){
                    		 return '';
                    	}
                    	let x = arr[0].name;
                    	if(x){
                    		//x轴名称过长时，tootip需要换行显示
                    		let n9 = Math.floor(x.length / 9);
                    		for(let n=n9;n>0;n--){
                    			x = x.slice(0, n*9) + '<br/>' + x.slice(n*9);
                    		}
                    		//如果是整倍数，需要移除最后一个换行符
                    		if(x.substr('<br/>'.length * -1) == '<br/>'){
                    			x = x.slice(0,x.length - '<br/>'.length);
                    		}
                    	}
                    	if(x && _this.tooltipPrefix){
                    		x = _this.tooltipPrefix + '(' + x + ')';
                    	}
                    	if(x && _this.tooltipSuffix){
                    		x += _this.tooltipSuffix;
                    	}
                    	arr.forEach((e,i) => {
                    		let unit;
                    		let v = _this.valueName;
                        	let l = v.indexOf('(');
                        	let r = v.indexOf(')');
                        	if(l + r > 1){
                        		unit = v.substring(l+1,r);
                        	}
                    		x += '<br/>' + e.marker + e.seriesName + ' : ' + e.value;
                    		if(unit){
                    			x += unit;
                    		}
                    	});
                    	return x;
                    },
                },
                grid: {
                    top: '15%',
                    left: '4%',
                    right: '4%',
                    bottom: '5%',
                    containLabel: true
                },
                xAxis: [{
                    type: 'category',
                    nameGap: 30,
                    data: _this.xlist,
                    axisLine: {
                        lineStyle: {
                            color: '#90979c'
                        }
                    },
                    splitLine: {
                        show: false
                    },
                    axisTick: {
                        show: false
                    },
                    splitArea: {
                        show: false
                    },
                    axisLabel: {
                        interval: 0,
                        rotate: 30,
                        formatter: (val) => {
                            if (val.length > 8) return val.substring(0, 8) + '...'
                            else return val
                        }

                    }
                }],
                yAxis: [{
                    type: 'value',
                    name: _this.valueName,
                    nameTextStyle: {
                    	fontSize: 11,
                    	padding: [0, 0, 10, 35],
                    },
                    axisLine: {
                        show: false
                    },
                    axisTick: {
                        show: false
                    },
                }],
            }
            let legend = {
            	data: _this.legend,
            	right: 10,
            	top: 10,
            	formatter: function(arg){
            		if(_this.legendSimple){
            			return _this.legendSimple[_this.legend.indexOf(arg)];
            		}
            		return arg;
            	},
            };
            let series = [];
            arr.forEach((e,i) => {
            	let le = {
                        name: legend.data[i],
                        smooth: false,
                        type: 'line',
                        barWidth: 30,
                        barGap: 20,
                        data: e,
                        label: {
                            normal: {
                                show: false,
                                position: 'top',
                                fontSize: 10,
                            }
                        },
                    };
            	series.push(le);
            });
            option.legend = legend;
            option.series = series;
            let mychart = echarts.init(this.$refs.chart);
            mychart.setOption(option, true);
        },
    },
    mounted() {
        const h = document.documentElement.clientHeight || document.body.clientHeight;
        this.$refs.chart.style.height = h / 2 + 'px';
    },
    template: `<div style="padding: 0px 0px; position: relative">
					<div ref="chart" style="background-color: #FFF; width: 100%"></div>
	           </div>`
};