var pieBox = {
	    data() {
	        return {
	            total: 0
	        }
	    },
	    props: {
	    	echartName: {
	            String,
            	default: ''
	    	},
	    	boxHeight: {
	            String,
	            default: '130px',
	        },
	        marginTop: {
	            Number,
	            default: 0,
	        },
	    },
	    mounted() {
//	    	let list = [
//	    	            {
//	    	            	name: "A",
//	    	            	value: 5,
//	    	            },
//	    	            {
//	    	            	name: "B",
//	    	            	value: 3,
//	    	            }
//	    		];
	    },
	    methods: {
	    	initEcharts(list){
	    		if(!list){
	    			return;
	    		}
	    		this.initPie(list);
	    	},
	    	initPie(data = []) {
	            const _this = this;
	    		let colors = ['#0197FF','#FEC441','#2AF5BC','#65E6F1','#FF6834','#FFF46B'];
	    		let global = 0;
	    		data.forEach((e,i) => {
	    			global += e.value;
	            });
	    		let map = {};
	    		data.forEach((e,i) => {
	                e.color = colors[i];
	                let ratio = (e.value / global * 100).toFixed(2);
	                map[e.name] = e.value + ' (' + ratio + '%) ';
	            });
	            let colorData = [];
	            let mychart = echarts.init(this.$refs.pie);
	            var option = {
	                legend: {
	                	type: 'scroll',
	                    orient: 'vertical',
	                    top: 'middle',
	                    right: 15,
	                    padding: [8,25,1,5],
	                    data: data.map((e) => {
	                        colorData.push(e.color)
	                        return e.name;
	                    }),
	                    formatter: function (name) {
	                        return name + " " + map[name];
	                    },
	                },
	                tooltip: {
	                    trigger: 'item',
	                    confine: true,
	                    formatter: '{a} <br/>{b}: {c}'
	                },
	                series: [{
	                    name: _this.echartName,
	                    type: 'pie',
		                labelLine: {
		                    show: false
		                },
		                label: {
		                    show: false
		                },
	                    radius: ['30%', '80%'],
	                    center: ['27%', '50%'],
	                    color: colorData,
	                    data: data,
	                }]
	            };
	            mychart.setOption(option, true);
	        },
	    },
	    template: `
		    <div style="width:100%">
		    	<div ref="pie" :style="{'width': '100%', 'height': boxHeight}"></div>
		    </div>
		`,
	};