var billIndustry = {
	components: {
	},
	props: ['show','month','areaLevel','areaCode'],
	data(){
		return {
		   	noData:false,
		   	tablecolumn: [],
		   	list: [],
		};
	},
	computed: {
		tableHeight: function(){
			let w = document.documentElement.clientWidth || document.body.clientWidth;
    		let h = document.documentElement.clientHeight || document.body.clientHeight;
        	return h - (w*100) / 375 * 0.4;
		},
	},
	watch: {
		show: function(){
			if(this.show && (this.list.length == 0 || this.noData)){
				this.initData();
			}
		},
		month: function(val,oldVal){
			this.level = 1;
			if(!this.show){
				this.list = [];
				return;
			}
			if(oldVal){
				this.initData();
			}
		},
		areaCode: function(val,oldVal){
			if(!this.show){
				this.list = [];
				return;
			}
			if(oldVal){
				this.initData();
			}
		},
	},
	methods: {
		initColumn(){
			let w = document.documentElement.clientWidth || document.body.clientWidth;
			w -= 4;
			w /= 10;
			return [
	 	    	 	{
	 		    		label: '行业',
	 		    	    key: 'name',
	 		    	    fixed: true,
	 		    	    width: w * 2.6,
	 		    	    isDrillDown: true,
	 		    	},{
	 		    		label: '电子面单|使用率(%)',
	 		    	    key: 'syl',
	 		    	    width: w * 2.7,
	 		    	    sortable: true,
	 		    	    align: 'right',
	 		    	    paddingRight: 36,
	 		    	    isNumber: true,
	 		    	    subByTarget: 'mbz',
	 		    	},{
	 		    		label: '目标值|(%)',
	 		    	    key: 'mbz',
	 		    	    width: w * 2.2,
	 		    	    sortable: true,
	 		    	    align: 'right',
	 		    	    paddingRight: 36,
	 		    	    isNumber: true,
	 		    	},{ 
	 		    		label: '环比改善|(%)',
	 		    	    key: 'hbgs',
	 		    	    sortable: true,
	 		    	    width: w * 2.5,
	 		    	    align: 'right',
	 		    	    paddingRight: 36,
	 		    	    isNumber: true,
	 		    	    subDown: 0,
	 		    	}
	 	    	];
		},
	    initData(){
			let params = {
			   	countDate: this.month,
			   	areaLevel: this.areaLevel,
			   	areaCode: this.areaCode,
			}
			requestElectronicBillByProductAll(params).then(({data}) => {
			   	if(!data){
			  		this.noData = true;
			   		return;
			   	}
			   	let list = JSON.parse(data);
			   	console.log(list)
			   	list.forEach(e => {
			   		e.name = e.industryCustomerType;
					e.nameCode = e.industryCustomerType;
					e.syl = this.convertToRate(e.rate);
					e.mbz = this.convertToRate(e.target);
					e.hbgs =this.convertToRate(e.link);
			    })
				this.list = list;
				this.noData = false;
			}).catch(err => {
			  	this.noData = true;
			  	console.log(err);
			});
	    },
	    drillDown: function (data){
        	this.$refs.table.$refs.tableActive.clearSort();
        	let url = "/fiveSystemKanban/technologyPower/electronicBill/billBy.html";
			let p = {
				month: this.month,
				industryCode: data.row.nameCode,
				industryName: data.row.name,
				areaLevel: this.areaLevel,
				areaCode: this.areaCode,
			};
         	Emp.execute("$M.page.goTo('"+url+"','"+JSON.stringify(p)+"', false)");
        },
	    notEmpty(arg){
        	if(arg === undefined || arg === '' || arg == null){
        		return false;
        	}else{
        		return true;
        	}
        },
        convertToName(arg){
        	return this.notEmpty(arg) ? arg : '其他';
        },
        convertToRate(arg){
        	return this.notEmpty(arg) ? (arg * 1).toFixed(2) : '-';
        },
        convertToW(arg){
        	return this.notEmpty(arg) ? Math.round(arg / 10000) : '-';
        },
	},
	created() {
	},
	mounted() {
		this.tablecolumn = this.initColumn();
		if(this.show){
			this.initData();
		}
	},
    template: `
    	<div>
			<div v-show="!noData">
				<drill-down-box
					ref="table"
					:list="list"
					:tablecolumn="tablecolumn"
					:table-height="tableHeight"
					@drilldown="drillDown"
					/>
			</div>
			<div v-if="noData" class="noData" v-if="noData">
				<img src="../../image/nodata.png" alt="暂无数据"/>
				<h3>暂无数据</h3>
			</div>
    	</div>
    `,
};