var billPaper = {
	components: {
	},
	props: ['show','month','productCode','productName','industryCode','industryName','areaLevel','areaCode'],
	data(){
		return {
		   	noData:false,
		   	tablecolumn: this.initColumn(),
		   	level: 1,
			code: '',
		   	list: [],
		};
	},
	computed: {
		tableHeight: function(){
			let w = document.documentElement.clientWidth || document.body.clientWidth;
    		let h = document.documentElement.clientHeight || document.body.clientHeight;
        	return h - (w*100) / 375 * 0.4;
		},
	},
	watch: {
		show: function(){
			if(this.show && (this.list.length == 0 || this.noData)){
				this.initData();
			}
		},
		month: function(val,oldVal){
			this.level = 1;
			if(!this.show){
				this.list = [];
				return;
			}
			if(oldVal){
				this.initData();
			}
		},
		areaCode: function(val,oldVal){
			if(!this.show){
				this.list = [];
				return;
			}
			if(oldVal){
				this.initData();
			}
		},
	},
	methods: {
		initColumn(){
			return [
	 	    	 	{
	 		    		label: '排名',
	 		    	    key: 'pm',
	 		    	    fixed: true,
	 		    	    width: 50,
	 		    	},{
	 		    		label: '客户名称',
	 		    	    key: 'khmc',
	 		    	    align: 'left',
	 		    	},{ 
	 		    		label: '纸质面单数',
	 		    	    key: 'zzmds',
	 		    	    width: 70,
	 		    	    align: 'right',
	 		    	    paddingRight: 12,
	 		    	    isNumber: true,
	 		    	}
	 	    	];
		},
	    initData(){
 	    	let params = {
	 	    	countDate: this.month,
	 	    	areaLevel: this.areaLevel,
			   	areaCode: this.areaCode,
	 	    	businessProdductCode: this.productCode,
	 		}
 	    	requestPaperBillTop10(params).then(({data}) => {
			   	if(!data){
			  		this.noData = true;
			   		return;
			   	}
			   	let list = JSON.parse(data);
			   	list.forEach(e => {
					e.pm = e.top;
					e.khmc = this.convertToName(e.senderName);
					e.zzmds = this.notEmpty(e.userNum) ? e.userNum : '-';
			    })
				this.list = list;
				this.noData = false;
			}).catch(err => {
			  	this.noData = true;
			  	console.log(err);
			});
	    },
	    drillDown: function (data){
        	this.$refs.table.$refs.tableActive.clearSort();
        	let url = "/fiveSystemKanban/technologyPower/electronicBill/billBy.html";
			let p = {
				month: this.month,
				productCode: data.row.nameCode,
				productName: data.row.name,
			};
         	Emp.execute("$M.page.goTo('"+url+"','"+JSON.stringify(p)+"', false)");
        },
	    notEmpty(arg){
        	if(arg === undefined || arg === '' || arg == null){
        		return false;
        	}else{
        		return true;
        	}
        },
        convertToName(arg){
        	return this.notEmpty(arg) ? arg : '其他';
        },
        convertToRate(arg){
        	return this.notEmpty(arg) ? (arg * 100).toFixed(2) : '-';
        },
        convertToW(arg){
        	return this.notEmpty(arg) ? Math.round(arg / 10000) : '-';
        },
	},
	created() {
	},
	mounted() {
		if(this.show){
			this.initData();
		}
	},
    template: `
    	<div>
			<div v-show="!noData">
				<drill-down-box
					ref="table"
					:list="list"
					:tablecolumn="tablecolumn"
					:table-height="tableHeight"
					@drilldown="drillDown"
					/>
			</div>
			<div v-if="noData" class="noData" v-if="noData">
				<img src="../../image/nodata.png" alt="暂无数据"/>
				<h3>暂无数据</h3>
			</div>
    	</div>
    `,
};