var billRegion = {
	components: {
	},
	props: ['show','month','productCode','industryCode','areaLevel','areaCode','simple'],
	data(){
		return {
		   	noData:false,
		   	tablecolumn: [],
		   	list: [],
		   	cacheCode: {},
	        cacheList: {},
	        width: 0,
	        defaultWidth: 0,
		};
	},
	computed: {
		tableHeight: function(){
			let w = document.documentElement.clientWidth || document.body.clientWidth;
    		let h = document.documentElement.clientHeight || document.body.clientHeight;
    		if(this.simple){
    			//按行业下钻时，页面没有tab，不需要减0.4rem
    			return h;
    		}else{
    			return h - (w*100) / 375 * 0.4;
    		}
		},
	},
	watch: {
		show: function(){
			if(this.show && this.month && (this.list.length == 0 || this.noData)){
				this.initData();
			}
		},
		month: function(val,oldVal){
			if(oldVal){
				//如果之前有日期，切换日期后清楚缓存
				this.cacheList = {};
			}
			if(!this.show){
				//如果当前页面未展示，切换日期后先清空数据，等展示后再重新加载
				this.list = [];
				return;
			}
			this.initData();
		},
	},
	methods: {
		initColumn(){
			let w = document.documentElement.clientWidth || document.body.clientWidth;
			w -= 4;
			w /= 10;
			this.defaultWidth = w * 2.6;
			this.width = w * 2.6;
			return [
	 	    	 	{
	 		    		label: '省份',
	 		    	    key: 'name',
	 		    	    fixed: false,
	 		    	    width: this.width,
	 		    	    isDrillDown: true,
	 		    	},{
	 		    		label: '电子面单|使用率(%)',
	 		    	    key: 'syl',
	 		    	    width: w * 2.7,
	 		    	    sortable: 'custom',
	 		    	    align: 'right',
	 		    	    paddingRight: 36,
	 		    	    isNumber: true,
	 		    	    subByTarget: 'mbz',
	 		    	},{
	 		    		label: '目标值|(%)',
	 		    	    key: 'mbz',
	 		    	    width: w * 2.2,
	 		    	    sortable: 'custom',
	 		    	    align: 'right',
	 		    	    paddingRight: 30,
	 		    	    isNumber: true,
	 		    	},{ 
	 		    		label: '环比改善|(%)',
	 		    	    key: 'hbgs',
	 		    	    sortable: 'custom',
	 		    	    width: w * 2.5,
	 		    	    align: 'right',
	 		    	    paddingRight: 36,
	 		    	    isNumber: true,
	 		    	    subDown: 0,
	 		    	}
	 	    	];
		},
	    initData(code){
			let ud = {
				areaLevel: this.areaLevel,
				areaCode: this.areaCode,
			}
			this.$emit('update-drill',ud);
			
			let params = {
		 	   	countDate: this.month,
		 	   	areaLevel: this.areaLevel,
		 	   	areaCode: this.areaCode,
		 	    industryCustomerType: this.industryCode,
		 	    businessProdductCode: this.productCode,
		 	}
			if(this.industryCode){
				this.setData(requestElectronicBillByIndustry(params),this.areaCode);
			}else{
				this.setData(requestElectronicBillByRegion(params),this.areaCode);
			}
		},
	    setData(promise,code){
	    	promise.then(({data}) => {
			   	if(!data){
			  		this.noData = true;
			   		return;
			   	}
			   	let list = JSON.parse(data);
			   	let max = 0;
			   	list.forEach(e => {
			   		e.name = this.convertToName(e.orgName);
					e.nameCode = e.orgCode;
					e.syl = this.convertToRate(e.rate);
					e.mbz = this.convertToRate(e.target);
					e.hbgs = this.convertToRate(e.link);
					
					max = max > e.name.length ? max : e.name.length;
			    })
				this.list = list;
				this.noData = false;
				
				this.updateColumn(this.isCen(code ? code : getAccountCode()),max);
				if(this.industryCode || this.productCode){
					//按行业和按产品二级页无下钻
					this.tablecolumn[0].isDrillDown = false;
				}
				
			}).catch(err => {
			  	this.noData = true;
			  	console.log(err);
			});
	    },
	    drillDown: function (data){
	    	this.$refs.table.$refs.tableActive.clearSort();
	    	this.cacheList[this.areaLevel] = this.list;
	    	this.cacheCode[this.areaLevel] = this.areaCode;
	    	this.areaLevel += 1;
	    	this.areaCode = data.row.nameCode;
        	this.initData(data.row.nameCode);
        },
        sortList: function(list){
        	this.list = list;
        },
        goBack(){
            if (this.areaLevel == 1){
            	 return;
            }
            this.$refs.table.$refs.tableActive.clearSort();
            this.areaLevel -= 1;
            this.areaCode = this.cacheCode[this.areaLevel];
            this.list = this.cacheList[this.areaLevel];
            if(this.list && this.list.length > 0){
            	this.noData = false;
                this.updateColumn(false);
    			let ud = {
    				areaLevel: this.areaLevel,
    				areaCode: this.areaCode,
    			}
    			this.$emit('update-drill',ud);
            }else{
            	this.initData();
            }
        },
        updateColumn(cen,max){
        	let label = getNameFromPermission(this.areaLevel,cen);
        	let notDrill = label === '机构';
        	this.tablecolumn[0].label = label;
        	this.$emit('update-tab',label);
        	this.tablecolumn[0].isDrillDown = !notDrill;
        	let w = max ? max * 12 + 10 : 120;
        	w = w < 240 ? w : 240;
        	w = w < this.defaultWidth ? this.defaultWidth : w;
        	this.tablecolumn[0].width = !notDrill ? this.width : w;
        	this.tablecolumn[0].align = !notDrill ? 'center' : 'left';
        },
        isCen(areaCode){
        	let code = areaCode.slice(0,2);
        	return code == '11' || code == '12' || code == '31' || code == '50';
        },
	    notEmpty(arg){
        	if(arg === undefined || arg === '' || arg == null){
        		return false;
        	}else{
        		return true;
        	}
        },
        convertToName(arg){
        	return this.notEmpty(arg) ? arg : '其他';
        },
        convertToRate(arg){
        	return this.notEmpty(arg) ? (arg * 1).toFixed(2) : '-';
        },
        convertToW(arg){
        	return this.notEmpty(arg) ? Math.round(arg / 10000) : '-';
        },
	},
	created() {
		window['goBack'] = () => {
	           if (this.areaLevel == 1 || !this.show) {
	                  console.log('返回普元');
	                try {
	                    Emp.execute('goBack()');
	                } catch (e) {
	
	                }
	                return
	            }
	           this.goBack();
	        };
	},
	mounted() {
		this.tablecolumn = this.initColumn();
		if(this.show && this.month){
			this.initData();
		}
	},
    template: `
    	<div>
			<div v-show="!noData">
				<drill-down-box
					ref="table"
					:list="list"
					:tablecolumn="tablecolumn"
					:table-height="tableHeight"
					@drilldown="drillDown"
					@sort-list="sortList"
					/>
			</div>
			<div v-if="noData" class="noData" v-if="noData">
				<img src="../../image/nodata.png" alt="暂无数据"/>
				<h3>暂无数据</h3>
			</div>
    	</div>
    `,
};