var hotKanban = {
		props: ['show','month','monthType','currentTab'],
		components: {
		},
		data(){
			return {
			   	noData:false,
			   	titles: ['所有看板'],
			   	titleIndex: 0,
			   	treeOpened: false,
			   	active: 0,
			   	isShowDialog:false,
			   	dialogTitle: '',
			   	dialogList: [],
			   	list: [],
			   	echartHeight: '720px',
			   	level: '1',
			   	tabs: ['看板访问量','看板人均访问量'],
			   	color: [['#DDF1FF','#0197FF'],['#E1F8F0','#00C482']],
			   	data: [
			          	{name: '重点区域提速',visit: 4753,user: 7690,per: 2.79},
			          	{name: '环节看板',visit: 4953,user: 7690,per: 2.79},
			          	{name: '赶超竞品路线',visit: 9753,user: 7690,per: 2.79},
			          	{name: '线路看板',visit: 9453,user: 7690,per: 2.79},
			          	{name: '成本体系',visit: 7553,user: 7690,per: 2.79},
			          	{name: '服务体系',visit: 4753,user: 7690,per: 2.79},
			          	{name: '总体量收',visit: 4253,user: 7690,per: 2.79},
			          	{name: '重点市场',visit: 1753,user: 7690,per: 2.79},
			          	{name: '自费管理',visit: 4753,user: 7690,per: 2.79},
			          	{name: '速递欠费',visit: 4753,user: 7690,per: 2.79},
			          	{name: '客户',visit: 453,user: 7690,per: 2.79},
			          	{name: '科技赋能',visit: 753,user: 7690,per: 2.79},
			          ],
			     treeItems: [],
			     treeActive1: 0,
			     treeActive2: 0,
			};
		},
		watch: {
			show: function(val){
				if(this.show && (this.noData || this.list.length == 0)){
					this.initData();
				}
			},
			month: function(val,oldVal){
				if(!this.show){
					this.list = [];
					return;
				}
				this.initData();
			},
			currentTab: function(){
				if(this.currentTab != 1){
					this.treeOpened = false;
				}
			},
			treeOpened: function(){
			    if(this.treeOpened){ //禁止滚动
			        document.body.addEventListener('touchmove', this.bodyScroll, { passive: false});
			    }else{ //开启滚动
			        document.body.removeEventListener('touchmove',this.bodyScroll, {passive: false});
			    }
			},
		},
		methods: {
			titleChanged(){
				this.treeOpened = false;
			},
			treeEmptyClick(){
				this.treeOpened = false;
			},
			treeResetClick(){
				this.treeActive1 = 0;
				this.treeActive2 = 0;
				this.titleIndex = 0;
				this.treeOpened = false;
			},
			treeSubmitClick(){
				this.titleIndex = this.treeActive2;
				this.treeOpened = false;
			},
			moreClick(){
				this.treeOpened = !this.treeOpened;
				if(this.treeOpened){
					this.treeActive2 = this.titleIndex;
				}
			},
		    closeDialog(){
		    	this.isShowDialog = false
		    	Emp.execute('setAlertState(2)');
		    },
		    activeUserDescClick(){
				this.dialogTitle = "活跃用户数";
				this.dialogList = {'des': ['统计日期内访问看板的用户数'],'from': ['寄递业务看板系统'],'totle': ['日/\月'],'update': ['实时']};
				this.isShowDialog = true;
				let method = 'closeUseTrendDialog' + this.level;
		    	Emp.execute("setAlertState(1,'"+method+"')");
		    },
		    usePerDescClick(){
				this.dialogTitle = "人均日访问量";
				this.dialogList = {'des': ['看板访问量/\看板活跃用户数/\天数'],'from': ['寄递业务看板系统'],'totle': ['日/\月'],'update': ['实时']};
				this.isShowDialog = true;
				let method = 'closeUseTrendDialog' + this.level;
		    	Emp.execute("setAlertState(1,'"+method+"')");
		    },
			selectTab(i){
				this.active = i;
				//切换后再给echart赋值
			    this.initData();
			},
		    initData(){
				let titles = [];
				let treeItems = [];
				let id = 0;
				for(let i=0;i<3;i++){
					let prefix = '全国';
					let suffix = '(总)';
					if(i === 1){
						prefix = '省';
						suffix = '(省)';
					}else if(i === 2){
						prefix = '市';
						suffix = '(市)';
					}
					titles.push('所有看板' + suffix);
					
					let children = [];
					children.push({
						text: '所有看板',
						id: id++,
					});
					this.data.forEach((e,j) => {
						titles.push(e.name + suffix);
						children.push({
							text: e.name + suffix,
							id: id++,
						});
					});
					
					treeItems.push({
						text: prefix,
						children: children,
					});
				}
				this.titles = titles;
				this.treeItems = treeItems;
				
				
				let barList = [];
		    	barList.push({name: '集团公司',value: 102});
		    	barList.push({name: '市场部',value: 35});
		    	barList.push({name: '服务质量管理人员',value: 30});
		    	barList.push({name: '信息管理人员',value: 15});
		    	barList.push({name: '集团公司',value: 102});
		    	barList.push({name: '市场部',value: 35});
		    	barList.push({name: '服务质量管理人员',value: 30});
		    	barList.push({name: '集团公司',value: 102});
		    	barList.push({name: '市场部',value: 35});
		    	barList.push({name: '服务质量管理人员',value: 30});
		    	barList.push({name: '集团公司',value: 102});
		    	barList.push({name: '市场部',value: 35});
		    	barList.push({name: '服务质量管理人员',value: 30});
		    	barList.push({name: '信息管理人员',value: 15});
		    	barList.push({name: '集团公司',value: 102});
		    	barList.push({name: '市场部',value: 35});
		    	barList.push({name: '服务质量管理人员',value: 30});
		    	barList.push({name: '集团公司',value: 102});
		    	barList.push({name: '市场部',value: 35});
		    	barList.push({name: '服务质量管理人员',value: 30});
		    	barList.push({name: '集团公司',value: 102});
		    	barList.push({name: '市场部',value: 35});
		    	barList.push({name: '服务质量管理人员',value: 30});
		    	barList.push({name: '信息管理人员',value: 15});
		    	barList.push({name: '集团公司',value: 102});
		    	barList.push({name: '市场部',value: 35});
		    	barList.push({name: '服务质量管理人员',value: 30});
		    	barList.push({name: '集团公司',value: 102});
		    	barList.push({name: '市场部',value: 35});
		    	barList.push({name: '服务质量管理人员',value: 30});
		    	barList.push({name: '集团公司',value: 102});
		    	barList.push({name: '市场部',value: 35});
		    	barList.push({name: '服务质量管理人员',value: 30});
		    	barList.push({name: '信息管理人员',value: 15});
		    	barList.push({name: '集团公司',value: 102});
		    	barList.push({name: '市场部',value: 35});
		    	this.list = barList;
			    this.$nextTick(() => {
	 		    	this.$refs.bar[this.active].initEcharts(barList);
			    });
		    },
		    getMT(){
	    		if(this.monthType === 'day') return 'D';
	    		if(this.monthType === 'month') return 'M';
	    		if(this.monthType === 'week') return 'W';
	    		if(this.monthType === 'sevenDay') return 'W';
	    		return this.monthType;
		    },
		    isCen(areaCode){
	        	let code = areaCode.slice(0,2);
	        	return code == '11' || code == '12' || code == '31' || code == '50';
	        },
		    notEmpty(arg){
	        	if(arg === undefined || arg === '' || arg == null){
	        		return false;
	        	}else{
	        		return true;
	        	}
	        },
	        convertToName(arg){
	        	return this.notEmpty(arg) ? arg : '其他';
	        },
	        convertToRate(arg){
	        	return this.notEmpty(arg) ? (arg * 1).toFixed(2) : '-';
	        },
	        convertToW(arg){
	        	return this.notEmpty(arg) ? Math.round(arg / 10000) : '-';
	        },
		},
		created() {
			let method = 'closeUseTrendDialog' + this.level;
			window[method] = () => {
				this.closeDialog();
			};
			window['goBack'] = () => {
				if(this.treeOpened){
					this.treeOpened = false;
				}else{
					Emp.execute('goBack()');
				}
		    };
		},
		mounted() {
			let w = document.documentElement.clientWidth || document.body.clientWidth;
    		let h = document.documentElement.clientHeight || document.body.clientHeight;
        	let dh = h - (w*100) / 375 * 2.4;
			this.$refs.barParent[0].style.height = dh + "px";
			this.$refs.barParent[1].style.height = dh + "px";
//			let doms = document.getElementsByClassName("barParent");
//			doms[0].style.height = dh + "px";
//			doms[1].style.height = dh + "px";
			
			
			if(this.show && this.month){
				this.initData();
			}
		},
	    template: `
	    	<div>
				<div v-show="!noData">
					<div style="position:relative">
						<van-tabs style="margin-right: 0.4rem" :class="[currentTab === 1 ? 'blue-van-tabs' : 'blue-no']" v-model="titleIndex" @change="titleChanged">
							<van-tab v-for="(item,i) in titles" :title="item">
							</van-tab>
						</van-tabs>
						<div v-show="currentTab === 1" style="text-align: center;background:rgba(0,0,0,0);height:0.4rem;width:0.4rem;position:absolute;top:0px;right:0px;" @click="moreClick">
							<img style="width:0.16rem; height:0.16rem;margin-top:0.06rem;" :src="!treeOpened ? '../../image/tab_nav_down_white.png' : '../../image/tab_nav_up_white.png'" :alt="treeOpened ? '展开' : '收起'"/>
						</div>
						<div v-show="treeOpened" style="width:100%;height:100%;display:flex;flex-direction:column;position:absolute;top:0.4rem;left:0px;z-index:10;">
							<div>
								<van-tree-select
									style="height:2.94rem;"
								  	:items="treeItems"
								  	:active-id.sync="treeActive2"
								  	:main-active-index.sync="treeActive1"
								/>
								<div style="display:flex;justify-content:space-around;align-items:center;height: 0.76rem;background:#FFF;">
									<div style="display:flex;flex-direction:column;justify-content:center;align-items: center;height:100%;width:0.21rem" @click="treeResetClick">
										<img style="width:0.21rem; height:0.21rem;" src="../../image/technologyPower/icon_clean_dark.png"/>
										<p style="font-size:0.09rem;font-weight:400;color:#333333;margin-top:3px;">重置</p>
									</div>
								  	<el-button type="primary" style="width:2.94rem;height:0.4rem;background-color:#3377FF" @click="treeSubmitClick">确定</el-button>
								</div>
							</div>
							<div style="height:100%;background:rgba(19, 31, 50, 0.6);" @click="treeEmptyClick"></div>
						</div>
					<div>
					<div style="display:flex;height: 1.18rem;">
						<div style="width: 33%;padding: 0.28rem 0 0 0.25rem">
							<span class="keyText">总访问量</span>
							<p style="margin-top: 2px">
								<span class="valueText">553290</span>
								<span class="keyText">次</span>
							</p>
						</div>
						<div style="width: 1px;height: 0.28rem;margin-top:0.45rem;background-color: #BBDCFE"></div>
						<div style="width: 28%;padding: 0.28rem 0 0 0.15rem">
							<span class="keyText">活跃用户</span>
							<img style="width:0.16rem; height:0.16rem;margin-top: 0.04rem" src="../../image/technologyPower/icon_tip_white.png" @click="activeUserDescClick"/>
							<p style="margin-top: 2px">
								<span class="valueText">7839</span>
								<span class="keyText">户</span>
							</p>
						</div>
						<div style="width: 1px;height: 0.28rem;margin-top:0.45rem;background-color: #BBDCFE"></div>
						<div style="width: 39%;padding: 0.28rem 0 0 0.15rem">
							<span class="keyText">人均日访问量</span>
							<img style="width:0.16rem; height:0.16rem;margin-top: 0.04rem" src="../../image/technologyPower/icon_tip_white.png" @click="usePerDescClick"/>
							<p style="margin-top: 2px;">
								<span class="valueText">2.71</span>
								<span class="keyText">次/人/日</span>
							</p>
						</div>
					</div>
					<div style="background: #F6F6F6;padding-top:0.12rem;">
						<div style="background: #FFF">
							<p style="display: inline-block;font-size: 0.16rem;font-weight: 500;color: #333333;margin-left: 0.14rem;margin-top: 0.14rem">看板访问量统计(全国/省/市)</p>
							<p style="display: flex;margin-top: 0.11rem;padding-left: 0.06rem;padding-right: 0.14rem;">
								<span :class="[active === 0 ? 'trendSelected' : 'trendUnselected']" @click="selectTab(0)">
									看板访问量
								</span>
								<span :class="[active === 1 ? 'trendSelected' : 'trendUnselected']" @click="selectTab(1)">
									看板人均访问量
								</span>
								<span style="width: 100%;"></span>
							</p>
							<div ref="barParent" v-for="(e,i) in tabs" v-show="i === active" style="overflow-y: scroll;">
								<horizontal-bar
									ref="bar"
									:box-height="echartHeight"
									:echart-name="tabs[i]"
									:color="color[i]"
									/>
							</div>
						</div>
					</div>
					<xk-dialog @func="closeDialog" :visible='isShowDialog' :title="dialogTitle" :data-list="dialogList"></xk-dialog>
				</div>
				<div v-if="noData" class="noData" v-if="noData">
					<img src="../../image/nodata.png" alt="暂无数据"/>
					<h3>暂无数据</h3>
				</div>
	    	</div>
	    `,
	};