var trend = {
	props: ['show','month','monthType','level'],
	components: {
		'line-box': lineBox,
	},
	data(){
		return {
		   	noData:false,
		   	active: 0,
		   	isShowDialog:false,
		   	dialogTitle: '',
		   	dialogList: [],
		   	list: [],
		   	legend: ['总部','省','市'],
		   	colors: ['#0197FF','#FFB444','#00C482'],
		   	tabs: ['看板访问量趋势','活跃用户趋势','人均访问量趋势'],
		   	valueName: ['/万次','/千户','/次'],
		};
	},
	watch: {
		show: function(val){
			if(this.show && (this.noData || this.list.length == 0)){
				this.initData();
			}
		},
		month: function(val,oldVal){
			if(!this.show){
				this.list = [];
				return;
			}
			this.initData();
		},
	},
	methods: {
	    closeDialog(){
	    	this.isShowDialog = false
	    	Emp.execute('setAlertState(2)');
	    },
	    activeUserDescClick(){
			this.dialogTitle = "活跃用户数";
			this.dialogList = {'des': ['统计日期内访问看板的用户数'],'from': ['寄递业务看板系统'],'totle': ['日/\月'],'update': ['实时']};
			this.isShowDialog = true;
			let method = 'closeUseTrendDialog' + this.level;
	    	Emp.execute("setAlertState(1,'"+method+"')");
	    },
	    usePerDescClick(){
			this.dialogTitle = "人均日访问量";
			this.dialogList = {'des': ['看板访问量/\看板活跃用户数/\天数'],'from': ['寄递业务看板系统'],'totle': ['日/\月'],'update': ['实时']};
			this.isShowDialog = true;
			let method = 'closeUseTrendDialog' + this.level;
	    	Emp.execute("setAlertState(1,'"+method+"')");
	    },
		selectTab(i){
			this.active = i;
			this.initData();
		},
	    initData(){
	    	let list = [];
	    	list.push({name: '202007'});
	    	list.push({name: '202007'});
	    	list.push({name: '202007'});
	    	list.push({name: '202007'});
	    	list.push({name: '202007'});
	    	list.push({name: '202007'});
	    	list.push({name: '202007'});
	    	this.list = list;
	    	
	    	if(this.active === 1){
	    		this.initData1();
	    		return;
	    	}
	    	if(this.active === 2){
	    		this.initData2();
	    		return;
	    	}
	    	
	    	let arr = [];
	    	arr.push([13455,33455,41441,24442,64444,52222,22222,31444]);
	    	arr.push([43455,13455,33455,13455,23455,33455,43455,63455]);
	    	arr.push([23455,23455,43455,33455,43455,63455,13455,23455]);
		    this.$nextTick(() => {
 		    	this.$refs.line[this.active].initDefault(arr);
		    });
	    },
	    initData1(){
	    	let arr = [];
	    	arr.push([33455,33455,41441,24442,64444,52222,22222,31444]);
	    	arr.push([43455,13455,33455,13455,23455,33455,43455,63455]);
	    	arr.push([23455,23455,43455,33455,43455,63455,13455,23455]);
		    this.$nextTick(() => {
 		    	this.$refs.line[this.active].initDefault(arr);
		    });
	    },
	    initData2(){
	    	let arr = [];
	    	arr.push([53455,33455,41441,24442,64444,52222,22222,31444]);
	    	arr.push([43455,13455,33455,13455,23455,33455,43455,63455]);
	    	arr.push([23455,23455,43455,33455,43455,63455,13455,23455]);
		    this.$nextTick(() => {
 		    	this.$refs.line[this.active].initDefault(arr);
		    });
	    },
	    getMT(){
    		if(this.monthType === 'day') return 'D';
    		if(this.monthType === 'month') return 'M';
    		if(this.monthType === 'week') return 'W';
    		if(this.monthType === 'sevenDay') return 'W';
    		return this.monthType;
	    },
	    isCen(areaCode){
        	let code = areaCode.slice(0,2);
        	return code == '11' || code == '12' || code == '31' || code == '50';
        },
	    notEmpty(arg){
        	if(arg === undefined || arg === '' || arg == null){
        		return false;
        	}else{
        		return true;
        	}
        },
        convertToName(arg){
        	return this.notEmpty(arg) ? arg : '其他';
        },
        convertToRate(arg){
        	return this.notEmpty(arg) ? (arg * 1).toFixed(2) : '-';
        },
        convertToW(arg){
        	return this.notEmpty(arg) ? Math.round(arg / 10000) : '-';
        },
	},
	created() {
		let method = 'closeUseTrendDialog' + this.level;
		window[method] = () => {
			this.closeDialog();
		}
	},
	mounted() {
		if(this.show && this.month){
			this.initData();
		}
	},
    template: `
    	<div>
			<div v-show="!noData">
				<div style="display:flex;height: 1.18rem;">
					<div style="width: 33%;padding: 0.28rem 0 0 0.25rem">
						<span class="keyText">总访问量</span>
						<p style="margin-top: 2px">
							<span class="valueText">553290</span>
							<span class="keyText">次</span>
						</p>
					</div>
					<div style="width: 1px;height: 0.28rem;margin-top:0.45rem;background-color: #BBDCFE"></div>
					<div style="width: 28%;padding: 0.28rem 0 0 0.15rem">
						<span class="keyText">活跃用户</span>
						<img style="width:0.16rem; height:0.16rem;margin-top: 0.04rem" src="../../image/technologyPower/icon_tip_white.png" @click="activeUserDescClick"/>
						<p style="margin-top: 2px">
							<span class="valueText">7839</span>
							<span class="keyText">户</span>
						</p>
					</div>
					<div style="width: 1px;height: 0.28rem;margin-top:0.45rem;background-color: #BBDCFE"></div>
					<div style="width: 39%;padding: 0.28rem 0 0 0.15rem">
						<span class="keyText">人均日访问量</span>
						<img style="width:0.16rem; height:0.16rem;margin-top: 0.04rem" src="../../image/technologyPower/icon_tip_white.png" @click="usePerDescClick"/>
						<p style="margin-top: 2px;">
							<span class="valueText">2.71</span>
							<span class="keyText">次/人/日</span>
						</p>
					</div>
				</div>
				<div style="background: #F6F6F6;padding-top:0.12rem;">
					<div style="background: #FFF">
						<p style="display: inline-block;font-size: 0.16rem;font-weight: 500;color: #333333;margin-left: 0.14rem;margin-top: 0.14rem">趋势统计</p>
						<p style="display: flex;margin-top: 0.11rem;padding-left: 0.06rem;padding-right: 0.14rem;">
							<span :class="[active === 0 ? 'trendSelected' : 'trendUnselected']" @click="selectTab(0)">
								看板访问量趋势
							</span>
							<span :class="[active === 1 ? 'trendSelected' : 'trendUnselected']" @click="selectTab(1)">
								活跃用户趋势
							</span>
							<span :class="[active === 2 ? 'trendSelected' : 'trendUnselected']" @click="selectTab(2)">
								人均访问量趋势
							</span>
						</p>
						<div v-for="(e,i) in tabs" v-show="i === active">
							<line-box
								ref="line"
								:list="list"
								:legend="legend"
								:value-name="valueName[i]"
								smooth=true
								:colors="colors"
								:tooltip-prefix="e"
								>
							</line-box>
						</div>
					</div>
				</div>
				<xk-dialog @func="closeDialog" :visible='isShowDialog' :title="dialogTitle" :data-list="dialogList"></xk-dialog>
			</div>
			<div v-if="noData" class="noData" v-if="noData">
				<img src="../../image/nodata.png" alt="暂无数据"/>
				<h3>暂无数据</h3>
			</div>
    	</div>
    `,
};