var analyse = {
	props: ['show','month','monthType','level'],
	data(){
		return {
		   	noData:false,
		   	list: [],
		   	valueName: ['/户'],
		   	echartName: '角色用户数',
		   	color: ['#24B4FE','#7184F7'],
		   	chartHeight: '200px',
		};
	},
	watch: {
		show: function(val){
			if(this.show && (this.noData || this.list.length == 0)){
				this.initData();
			}
		},
		month: function(val,oldVal){
			if(!this.show){
				this.list = [];
				return;
			}
			this.initData();
		},
	},
	methods: {
	    initData(){
	    	let barList = [];
	    	barList.push({name: '集团公司',value: 102});
	    	barList.push({name: '市场部',value: 35});
	    	barList.push({name: '服务质量管理人员',value: 30});
	    	barList.push({name: '信息管理人员',value: 15});
	    	barList.push({name: '集团公司',value: 102});
	    	barList.push({name: '市场部',value: 35});
	    	barList.push({name: '服务质量管理人员',value: 30});
	    	barList.push({name: '集团公司',value: 102});
	    	barList.push({name: '市场部',value: 35});
	    	barList.push({name: '服务质量管理人员',value: 30});
//	    	this.chartHeight = (10 * 20) + 'px';
	    	this.$refs.bar.initEcharts(barList);
	    	
	    	let pieList = [];
	    	pieList.push({name: '总部',value: 534});
	    	pieList.push({name: '省',value: 4501});
	    	pieList.push({name: '市',value: 14187});
	    	this.$refs.pie.initEcharts(pieList);
	    },
	    getMT(){
    		if(this.monthType === 'day') return 'D';
    		if(this.monthType === 'month') return 'M';
    		if(this.monthType === 'week') return 'W';
    		if(this.monthType === 'sevenDay') return 'W';
    		return this.monthType;
	    },
	    isCen(areaCode){
        	let code = areaCode.slice(0,2);
        	return code == '11' || code == '12' || code == '31' || code == '50';
        },
	    notEmpty(arg){
        	if(arg === undefined || arg === '' || arg == null){
        		return false;
        	}else{
        		return true;
        	}
        },
        convertToName(arg){
        	return this.notEmpty(arg) ? arg : '其他';
        },
        convertToRate(arg){
        	return this.notEmpty(arg) ? (arg * 1).toFixed(2) : '-';
        },
        convertToW(arg){
        	return this.notEmpty(arg) ? Math.round(arg / 10000) : '-';
        },
	},
	created() {
		window['goBack'] = () => {
			Emp.execute('goBack()');
	    };
	},
	mounted() {
		if(this.show && this.month){
			this.initData();
		}
	},
    template: `
    	<div>
			<div v-show="!noData">
				<div style="display:flex;height: 1.18rem;">
					<div style="width: 32%;padding: 0.28rem 0 0 0.25rem">
						<span class="keyText">总用户数</span>
						<p style="margin-top: 2px">
							<span class="valueText">24197</span>
							<span class="keyText">户</span>
						</p>
					</div>
					<div style="width: 1px;height: 0.28rem;margin-top:0.45rem;background-color: #BBDCFE"></div>
					<div style="width: 23%;padding: 0.28rem 0 0 0.15rem">
						<span class="keyText">角色数</span>
						<p style="margin-top: 2px">
							<span class="valueText">197</span>
							<span class="keyText">户</span>
						</p>
					</div>
					<div style="width: 1px;height: 0.28rem;margin-top:0.45rem;background-color: #BBDCFE"></div>
					<div style="width: 45%;padding: 0.28rem 0 0 0.15rem">
						<span class="keyText">角色均用户数</span>
						<p style="margin-top: 2px">
							<span class="valueText">24.71</span>
							<span class="keyText">户/角色</span>
						</p>
					</div>
				</div>
				<div style="background: #F6F6F6;padding-top:0.12rem;">
					<div style="background: #FFF">
						<p style="display: inline-block;line-height: 0.16rem;font-size: 0.16rem;font-weight: 500;color: #333333;margin-left: 0.14rem;margin-top: 0.14rem">用户数层级分布</p>
						<pie-box
							ref="pie"
							box-height="150px"
							echart-name="用户数"
						>
						</pie-box>
					</div>
					<div style="margin-top:0.12rem;background: #FFF">
						<p style="display: inline-block;line-height: 0.16rem;font-size: 0.16rem;font-weight: 500;color: #333333;margin-left: 0.14rem;margin-top: 0.14rem">角色用户数TOP10</p>
						<horizontal-bar
							ref="bar"
							:box-height="chartHeight"
							:value-name="valueName"
							:echart-name="echartName"
							:color="color"
							radius=true
							tooltip=true
							/>
					</div>
				</div>
			</div>
			<div v-if="noData" class="noData" v-if="noData">
				<img src="../../image/nodata.png" alt="暂无数据"/>
				<h3>暂无数据</h3>
			</div>
    	</div>
    `,
};