var regional = {
	props: ['show','month','monthType'],
	components: {
		'map-box': mapBox,
	},
	data(){
		return {
		   	noData:false,
		   	active: 0,
		   	isShowDialog:false,
		   	dialogTitle: '',
		   	dialogList: [],
		   	headerData: {},
		   	list: [],
		   	areaLevel: 1,
		   	areaCode: '',
		   	tableHeight: null,
		   	cacheCode: {},
	        cacheList: {},
	        specialName: [],
	        cacheSpecialName: {},
		   	tablecolumn:[],
		};
	},
	watch: {
		show: function(val){
			if(this.show && this.month && (this.noData || this.list.length == 0)){
				this.initData();
			}
		},
		month: function(val,oldVal){
			if(oldVal){
				//如果之前有日期，切换日期后需要清除缓存
				this.cacheList = {};
			}
			this.headerData = {};
			if(!this.show){
				this.noData = true;
				this.list = [];
				return;
			}
			this.initData();
		},
	},
	methods: {
		changeDate(){
			Emp.execute("openDateView('" + this.month + "','" + this.monthType + "')");
		},
	    closeDialog(){
	    	this.isShowDialog = false
	    	Emp.execute('setAlertState(2)');
	    },
	    usePerDescClick(){
			this.dialogTitle = "人均日访问量";
			this.dialogList = {'des': ['总访问量/\注册用户数/\天数（按月统计时，天数去除节假日）'],'from': ['中邮寄递管理APP'],'totle': ['日/\月'],'update': ['当天更新T-1数据']};
			this.isShowDialog = true;
			let method = 'closeRegionalHotDialog' + this.monthType;
	    	Emp.execute("setAlertState(1,'"+method+"')");
	    },
		initColumn(){
			let w = document.documentElement.clientWidth || document.body.clientWidth;
			w -= 4;
			w /= 35;
			return [
	 	    	 	{
	 		    		label: '省份',
	 		    	    key: 'name',
	 		    	    fixed: false,
	 		    	    width: w * 5,
	 		    	    isDrillDown: true,
	 		    	},{
	 		    		label: '注册用户',
	 		    	    key: 'zcyh',
	 		    	    width: w * 7,
	 		    	    sortable: 'custom',
	 		    	    align: 'right',
	 		    	    paddingRight: 20,
	 		    	},{
	 		    		label: '活跃用户',
	 		    	    key: 'hyyh',
	 		    	    width: w * 7,
	 		    	    sortable: 'custom',
	 		    	    align: 'right',
	 		    	    paddingRight: 20,
	 		    	},{ 
	 		    		label: '访问量',
	 		    	    key: 'fwl',
	 		    	    sortable: 'custom',
	 		    	    width: w * 6,
	 		    	    align: 'right',
	 		    	    paddingRight: 10,
	 		    	},{ 
	 		    		label: '人均日访问量',
	 		    	    key: 'value',
	 		    	    sortable: 'custom',
	 		    	    width: w * 10,
	 		    	    align: 'right',
	 		    	    paddingRight: 40,
	 		    	}
	 	    	];
		},
	    initData(){
			this.getHeaderData();
			this.getTableData();
	    },
	    getHeaderData: function(){
	    	let params = {
				countDate: this.month,
				dateType: this.getMT(),
				areaLevel: '1',
			};
			requestRegionalUseDetail(params).then(({data}) => {
				if(!data){
					return;
				}
				data = JSON.parse(data);
				if(!data){
					return;
				}
				data.pv = this.convertToSafe(data.pv);
				this.headerData = data;
			}).catch(err => {
			  	console.log(err);
			});
	    },
	    getTableData: function(){
	    	let params = {
				countDate: this.month,
				dateType: this.getMT(),
				areaLevel: this.areaLevel,
				areaCode: this.areaCode,
			};
			requestRegionalHot(params).then(({data}) => {
				if(!data){
					if(this.areaLevel == 1){
						this.noData = true;
					}
					return;
				}
				data = JSON.parse(data);
//				console.log(data)
				this.specialName = [];
				let mapData = [];
//				let canAreaDrill = getLevelFromPermission(this.areaLevel) >= 2;
				let canAreaDrill = this.areaLevel < 2;
				data.forEach((e,i) => {
					e.name = this.convertToName(e.areaName);
					e.nameCode = e.areaCode;
					e.value = this.notEmpty(e.perPv) ? e.perPv.toFixed(2) : '-';
					e.zcyh = this.convertToSafe(e.registUserAmount);
					e.hyyh = this.convertToSafe(e.activeUserAmount);
					e.fwl = this.convertToSafe(e.pv);
			   		e.notDrill = !canAreaDrill;
			   		
			   		if(i == 0){
			   			this.specialName.push(e.name);
			   		}else{
			   			mapData.push(e);
			   		}
				});
				this.list = data;
				if(this.areaLevel == 1){
					this.$nextTick(() => {
						this.$refs.refMap.init(mapData);
				    });
				}
				this.noData = false;
			}).catch(err => {
				if(this.areaLevel == 1){
					this.noData = true;
				}
			  	console.log(err);
			});
	    },
        registerListener() {
        	let dom = this.$refs.refRH;
        	let w = document.documentElement.clientWidth || document.body.clientWidth;
        	let h = document.documentElement.clientHeight || document.body.clientHeight;
//        	let overHeight = h - (w*100) / 375 * 0.45;
//			window.onscroll = () =>{
//				let scrollTop = dom.getBoundingClientRect().top;
//				if (Math.floor(scrollTop) <= overHeight * -1) {
//					this.tableHeight = h;
//				} else {
//					this.tableHeight = null;
//				}
//			}
        	let topHeight = (w*100) / 375 * 1.5 + 263;
        	let th = h - (w*100) / 375 * 0.98;
            dom.addEventListener('scroll', () => {
                let scrollTop = dom.scrollTop;
                if (scrollTop + 1 >= topHeight) {
                    dom.scrollTop = topHeight;
                    this.tableHeight = th;
                }else{
                    this.tableHeight = null;
                }
            })
        },
	    drillDown: function(data){
	    	this.$refs.table.$refs.tableActive.clearSort();
	    	this.cacheList[this.areaLevel] = this.list;
	    	this.cacheCode[this.areaLevel] = this.areaCode;
	    	this.cacheSpecialName[this.areaLevel] = this.specialName;
	    	this.areaLevel += 1;
	    	this.areaCode = data.row.nameCode;
//	    	this.tablecolumn[0].label = getNameFromPermission(this.areaLevel,false);
	    	this.tablecolumn[0].label = this.areaLevel == 1 ? '省份' : '地市';
        	this.getTableData();
        },
        sortList: function(list){
        	this.list = list;
        },
        goBack(){
            if (this.areaLevel == 1){
            	 return;
            }
            this.$refs.table.$refs.tableActive.clearSort();
            this.areaLevel -= 1;
            this.list = this.cacheList[this.areaLevel];
            this.areaCode = this.cacheCode[this.areaLevel];
            this.specialName = this.cacheSpecialName[this.areaLevel];
//            this.tablecolumn[0].label = getNameFromPermission(this.areaLevel,false);
            this.tablecolumn[0].label = this.areaLevel == 1 ? '省份' : '地市';
            if(this.list && this.list.length > 0){
            	this.noData = false;
            }else{
            	this.getTableData();
            }
        },
	    getMT(){
    		if(this.monthType === 'day') return 'D';
    		if(this.monthType === 'month') return 'M';
    		if(this.monthType === 'week') return 'W';
    		if(this.monthType === 'sevenDay') return 'W';
    		return this.monthType;
	    },
	    isCen(areaCode){
        	let code = areaCode.slice(0,2);
        	return code == '11' || code == '12' || code == '31' || code == '50';
        },
	    notEmpty(arg){
        	if(arg === undefined || arg === '' || arg == null){
        		return false;
        	}else{
        		return true;
        	}
        },
        convertToName(arg){
        	return this.notEmpty(arg) ? arg : '其他';
        },
        convertToSafe(arg){
        	return this.notEmpty(arg) ? arg : '-';
        },
        convertToRate(arg){
        	return this.notEmpty(arg) ? (arg * 100).toFixed(2) : '-';
        },
        convertToW(arg){
        	return this.notEmpty(arg) ? Math.round(arg / 10000) : '-';
        },
	},
	created() {
		let method = 'closeRegionalHotDialog' + this.monthType;
		window[method] = () => {
			this.closeDialog();
		};
		let m = 'goBack' + this.monthType;
		window[m] = () => {
			if(!this.show) return;
	        if (this.areaLevel == 1) {
	        	console.log('返回普元');
	            try {
	                Emp.execute('goBack()');
	            } catch (e) {
	            }
	            return
	        }
	        this.goBack();
	    };
	},
	mounted() {
		let w = document.documentElement.clientWidth || document.body.clientWidth;
		let h = document.documentElement.clientHeight || document.body.clientHeight;
		h -= (w*100) / 375 * 0.45;
		this.$refs.refRH.style.height = h + 'px';
		
		this.registerListener();
		
		this.tablecolumn = this.initColumn();
		if(this.show && this.month){
			this.initData();
		}
	},
    template: `
    	<div>
			<div ref="refRH" style="overflow-y: auto;">
				<div style="height:0.1rem;background-color:#F6F6F6;"></div>
				<div style="display:flex;height:0.7rem;margin: 0.1rem 0.15rem 0 0.15rem;">
					<div class="cardLeft" style="background-color:#14A496;"></div>
					<div class="cardRight" style="background-color:#F4FBF1;border-radius: 4px;">
						<span style="font-size: 0.12rem;color: #333333;font-weight: 300;text-align: center;">全国当{{monthType == 'day' ? '日' : '月'}}看板访问总量</span>
						<p style="font-size:1px;margin-top:0.1rem;text-align: center;">
							<span style="font-size: 0.25rem;font-weight: 400;color: #333333;">{{convertToSafe(headerData.pv)}}</span>
							<span class="textCardUnit">次</span>
						</p>
					</div>
				</div>
				<div style="display:flex;justify-content: space-between;padding: 0.08rem 0.15rem;">
					<div style="">
						<span style="color:#2A200B;font-size: 0.14rem;font-weight: 600;">人均日访问量</span>
						<img style="width:0.16rem; height:0.16rem;margin-top: 0.05rem;" src="../../image/technologyPower/icon_tip_blue.png" @click="usePerDescClick"/>
					</div>
					<div class="changeDate" @click="changeDate()">
						<span class="textNormal">{{month}}</span>
						<img style="width:0.18rem;height:0.18rem;" src="../../image/icon_calendar_green.png"/>
					</div>
				</div>
				<div v-show="!noData">
					<div style="height:263px;background-color:#F6F6F6;">
						<map-box
							ref="refMap"
							box-height="263px"
							value-name="看板热度"
							zoom-control="true"
							>
						</map-box>
					</div>
					<div style="margin-top:0.1rem;">
						<drill-down-box
							ref="table"
							:list="list"
							:tablecolumn="tablecolumn"
							:table-height="tableHeight"
							@drilldown="drillDown"
							@sort-list="sortList"
							default-color="#14A496"
							:special-name="specialName"
							/>
					</div>
					<div style="height:0.53rem"></div>
					<xk-dialog @func="closeDialog" :visible='isShowDialog' :title="dialogTitle" :data-list="dialogList"></xk-dialog>
				</div>
				<div v-if="noData" class="noData">
					<img src="../../image/nodata.png" alt="暂无数据"/>
					<h3>暂无数据</h3>
				</div>
			</div>
    	</div>
    `,
};