var trend = {
	props: ['show','month','monthType','options','option'],
	components: {
		'line-box': lineBox,
	},
	data(){
		return {
		   	noData:false,
		   	active: 0,
		   	isShowDialog:false,
		   	dialogTitle: '',
		   	dialogList: [],
		   	headerData:{},
		   	list: [],
		   	xlist: [],
		   	legend: ['总部','省','市'],
		   	colors: ['#0197FF','#FFB444','#00C482'],
		   	tabs: ['访问量趋势','活跃用户趋势','人均日访问量趋势'],
		   	valueName: ['次','个','次/人/日'],
		};
	},
	watch: {
		show: function(val){
			if(this.show && this.month && (this.noData || this.list.length == 0)){
				this.initData();
			}
			if(this.show && this.month && JSON.stringify(this.headerData) == '{}'){
				this.getHeaderData();
			}
		},
		month: function(val,oldVal){
			this.headerData = {};
			if(!this.show){
				this.noData = true;
				this.list = [];
				return;
			}
			this.initData();
		},
		option: function(){
			this.headerData = {};
			if(!this.show){
				return;
			}
			this.getHeaderData();
		},
	},
	methods: {
		changeDate(){
			Emp.execute("openDateView('" + this.month + "','" + this.monthType + "')");
		},
		lvchanged(arg){
			this.$emit('lvchanged', arg);
		},
	    closeDialog(){
	    	this.isShowDialog = false
	    	Emp.execute('setAlertState(2)');
	    },
	    activeUserDescClick(){
			this.dialogTitle = "活跃用户数";
			this.dialogList = {'des': ['统计日期内访问看板的用户数'],'from': ['中邮寄递管理APP'],'totle': ['日/\月'],'update': ['当天更新T-1数据']};
			this.isShowDialog = true;
			let method = 'closeUseTrendDialog' + this.monthType;
	    	Emp.execute("setAlertState(1,'"+method+"')");
	    },
	    usePerDescClick(){
			this.dialogTitle = "人均日访问量";
			this.dialogList = {'des': ['总访问量/\注册用户数/\天数（按月统计时，天数去除节假日）'],'from': ['中邮寄递管理APP'],'totle': ['日/\月'],'update': ['当天更新T-1数据']};
			this.isShowDialog = true;
			let method = 'closeUseTrendDialog' + this.monthType;
	    	Emp.execute("setAlertState(1,'"+method+"')");
	    },
		selectTab(i){
			this.active = i;
		    this.$nextTick(() => {
	 	    	this.$refs.line[this.active].initDefault(this.list[this.active]);
		    });
		},
	    initData(){
			this.getHeaderData();
			this.getTrendData();
	    },
	    getHeaderData(){
			let params = {
				countDate: this.month,
				dateType: this.getMT(),
				areaLevel: this.option.value,
			};
			requestRegionalUseDetail(params).then(({data}) => {
				if(!data){
					return;
				}
				data = JSON.parse(data);
				data.zfwl = this.convertToSafe(data.pv);
				data.hyyh = this.convertToSafe(data.activeUserAmount);
				data.rjrfwl = this.convertToSafe(data.perPv);
				this.headerData = data;
			}).catch(err => {
			  	console.log(err);
			});
	    },
	    getTrendData(){
	    	let params = {
				countDate: this.month,
				dateType: this.getMT(),
			};
	    	requestUseTrend(params).then(({data}) => {
				if(!data){
					this.noData = true;
					return;
				}
				data = JSON.parse(data);
				let xlist = [];
				let arr1 = [[],[],[]];
				let arr2 = [[],[],[]];
				let arr3 = [[],[],[]];
				data.allData.forEach(e => {
					arr1[0].push(e.pv);
					arr2[0].push(e.activeUserAmount);
					arr3[0].push(e.perPv);
					xlist.push(e.countDate);
				});
				data.provData.forEach(e => {
					arr1[1].push(e.pv);
					arr2[1].push(e.activeUserAmount);
					arr3[1].push(e.perPv);
				});
				data.cityData.forEach(e => {
					arr1[2].push(e.pv);
					arr2[2].push(e.activeUserAmount);
					arr3[2].push(e.perPv);
				});
				
				if(xlist.length == 0){
					this.noData = true;
					return;
				}
				
				this.xlist = xlist;
			   	this.list = [];
			   	this.list.push(arr1);
			   	this.list.push(arr2);
			   	this.list.push(arr3);
			    this.$nextTick(() => {
			    	this.$refs.line[this.active].initDefault(this.list[this.active]);
			    });
			    this.noData = false;
			}).catch(err => {
				this.noData = true;
			  	console.log(err);
			});
	    },
	    getMT(){
    		if(this.monthType === 'day') return 'D';
    		if(this.monthType === 'month') return 'M';
    		if(this.monthType === 'week') return 'W';
    		if(this.monthType === 'sevenDay') return 'W';
    		return this.monthType;
	    },
	    isCen(areaCode){
        	let code = areaCode.slice(0,2);
        	return code == '11' || code == '12' || code == '31' || code == '50';
        },
	    notEmpty(arg){
        	if(arg === undefined || arg === '' || arg == null){
        		return false;
        	}else{
        		return true;
        	}
        },
        convertToName(arg){
        	return this.notEmpty(arg) ? arg : '其他';
        },
        convertToSafe(arg){
        	return this.notEmpty(arg) ? arg : '-';
        },
        convertToRate(arg){
        	return this.notEmpty(arg) ? (arg * 100).toFixed(2) : '-';
        },
        convertToW(arg){
        	return this.notEmpty(arg) ? Math.round(arg / 10000) : '-';
        },
	},
	created() {
		let method = 'closeUseTrendDialog' + this.monthType;
		window[method] = () => {
			this.closeDialog();
		};
		let m = 'goBack2' + this.monthType;
		window[m] = () => {
	        if (this.show) {
	        	Emp.execute('goBack()');
	            return;
	        }
	    };
	},
	mounted() {
		if(this.show && this.month){
			this.initData();
		}
	},
    template: `
    	<div>
			<div>
				<div style="height:0.1rem;background-color:#F6F6F6;"></div>
				<div style="background-color:#FFF;height:1.25rem;padding:0.1rem 0.15rem;position:relative;">
					<div style="display:flex;justify-content: space-between;">
						<div class="changeTarget" style="width: 1rem;">
							<el-select v-model="option" placeholder="" @change="lvchanged">
							    <el-option
							    	v-for="item in options"
							    	:key="item.value"
							    	:label="item.label"
							    	:value="item"
							    	>
							    </el-option>
							</el-select>
						</div>
						<div class="changeDate" @click="changeDate()">
							<span class="textNormal">{{month}}</span>
							<img style="width:0.18rem;height:0.18rem;" src="../../image/icon_calendar_green.png"/>
						</div>
					</div>
					<div style="display:flex;justify-content: space-between;margin-top:0.1rem;">
						<div style="display:flex;width:100%;height:0.8rem;">
							<div class="cardLeft" style="background-color:#00A0E9;"></div>
							<div class="cardRight" style="background:#F1F4FB;padding-left:0.12rem;">
								<p class="textCard">总访问量</p>
								<p style="font-size:1px;margin-top:0.08rem;">
									<span class="textCardNum">{{convertToSafe(headerData.zfwl)}}</span>
									<span class="textCardUnit">次</span>
								</p>
							</div>
						</div>
						<div style="display:flex;width:100%;height:0.8rem;margin-left:0.08rem;">
							<div class="cardLeft" style="background-color:#14A496;"></div>
							<div class="cardRight" style="background-color:#F4FBF1;padding-left:0.2rem;position:relative;">
								<span class="textCard">活跃用户</span>
								<img style="width:0.16rem; height:0.16rem;position:absolute;top: 0.17rem;left: 0.71rem;" src="../../image/technologyPower/icon_tip_blue.png" @click="activeUserDescClick"/>
								<p style="font-size:1px;margin-top:0.08rem;">
									<span class="textCardNum">{{convertToSafe(headerData.hyyh)}}</span>
									<span class="textCardUnit">个</span>
								</p>
							</div>
						</div>
						<div style="display:flex;width:100%;height:0.8rem;margin-left:0.08rem;">
							<div class="cardLeft" style="background-color:#FD8B42;"></div>
							<div class="cardRight" style="background-color:#FBF6F1;padding-left:0.08rem;position:relative;">
								<span class="textCard">人均日访问量</span>
								<img style="width:0.16rem; height:0.16rem;position:absolute;top: 0.17rem;left: 0.82rem;" src="../../image/technologyPower/icon_tip_blue.png" @click="usePerDescClick"/>
								<p style="font-size:1px;margin-top:0.08rem;">
									<span class="textCardNum">{{convertToSafe(headerData.rjrfwl)}}</span>
									<span class="textCardUnit">次/人/日</span>
								</p>
							</div>
						</div>
						
					</div>
				</div>
				<div v-show="!noData">
					<div style="background: #F6F6F6;">
						<div style="height:0.62rem;position:relative;">
							<div style="width:100%;height:100%;position:absolute;top:0.1rem;background-color:#FFF;"></div>
							<div style="width:100%;height:100%;display:flex;position:absolute;top:0.03rem;">
								<div v-for="(e,i) in tabs" :style="{width:i==0?'45%':i==1?'50%':'55%',textAlign:'center',}">
									<img :style="{visibility: active == i ? 'visible' : 'hidden'}" class="arrowDown" src="../../image/arrow_down_green.png"/>
									<span :class="[active == i ? 'tabSelected' : 'tabUnselected']" @click="selectTab(i)">{{e}}</span>
								</div>
							</div>
						</div>
					</div>
					<div v-for="(e,i) in tabs" v-show="i == active">
						<line-box
							ref="line"
							:xlist="xlist"
							:legend="legend"
							:value-name="valueName[i]"
							:colors="colors"
							:tooltip-prefix="e"
							>
						</line-box>
					</div>
					<xk-dialog @func="closeDialog" :visible='isShowDialog' :title="dialogTitle" :data-list="dialogList"></xk-dialog>
				</div>
				<div v-if="noData" class="noData">
					<img src="../../image/nodata.png" alt="暂无数据"/>
					<h3>暂无数据</h3>
				</div>
			</div>
    	</div>
    `,
};