var red = {
    components: {
    },
    props: ['show','month','monthType','productType','scopeServices','keyareaId','sendProvCode','sumLevel','dataDate','dateType','businessType'],
    data(){
        return {
            noData:false,
            tablecolumn: [],
            list: [],
            specialName: [],
            redBy: null,
        };
    },
    watch: {
        show: function(val){
            if(this.show && this.list.length == 0){
                this.initData();
            }
        },
        month: function(val, oldVal){
            this.initData();
        },
    },
    computed: {
        tableHeight: function(){
            let w = document.documentElement.clientWidth || document.body.clientWidth;
            let h = document.documentElement.clientHeight || document.body.clientHeight;
            return h;
        },
    },
    methods: {
        /*特快60%以上绿，40%以下红，快包55%以上绿，35%以下红*/
        initRedBy(){
            if(this.productType == "B"){
                this.redBy = {
                    min: 40,
                    max: 60,
                };
            }else if(this.productType == "K"){
                this.redBy = {
                    min: 35,
                    max: 55,
                };
            }
        },
        initData(){
            this.initRedBy();
            let params = {
               /* dateType: this.getMT(),
                countDate: this.month,
                scopeServices: this.scopeServices,
                keyareaId: this.keyareaId,*/

                /*  sendProvCode: '000000',
                    sumLevel:       '1',
                    dataDate:       '2021-04-19',
                    dateType:       'D',
                    businessType:   'B',                    */
                sendProvCode: this.sendProvCode,
                sumLevel:     this.sumLevel,
                dataDate:     this.dataDate,
                dateType:     this.dateType,
                businessType: this.businessType,
            }
            requestImpRed(params).then(({data}) => {
                console.log(data,'-----------------');
                if(!data){
					this.noData = true;
					return;
				}
			
			
            let json = JSON.parse(data);
            let imp = json.recvData;
            let exp = json.sendData;
            let d = json.data;
            console.log(json)
            let cols = [];
            cols.push({
                label: '进出口',
                key: 'name',
                width: 70,
                fixed: false,
            });
            /*imp.push({
                recvCode:  '100000',
                recvName: '进口汇总',
            });
            exp.push({
                sendCode:  '100000',
                sendName: '出口汇总',
            });*/
            imp.forEach((e,i) => {
                let c = {};
            c.label = this.convertToName(e.recvName);
            c.key = e.recvCode;
            c.width = c.label.length <= 5 ? 70 : 70 + (c.label.length - 5) * 12,
                c.isRate = true,
                cols.push(c);
        })
            this.tablecolumn = cols;

            let list = [];
            let temp;
            exp.forEach((it,i)=> {
                let row = {};
            row.name = it.sendName;
            row.code = it.sendCode;

            imp.forEach((e,j)=> {
			//  row[e.recvCode] = this.convertToRate(d[i][e.recvCode]);
			temp = d[i][e.recvCode];
            // console.log(i +" " + e.recvCode);
            if(Object.prototype.toString.call(temp) === '[object Object]'){
                if (temp) {
                    row[e.recvCode] = {
                        color: temp.chartColor,
                        value: this.convertToRate(temp.limitOntimerate),
                    };
                }
            }else{
                row[e.recvCode] = this.convertToRate(d[i][e.recvCode]);
            }
        });
            list.push(row);
        });
            this.list = list;
            this.noData = false;
        }).catch(err => {
                this.noData = true;
            console.log(err);
        });
        },
        getMT(){
            if(this.monthType === 'day') return 'D';
            if(this.monthType === 'month') return 'M';
            if(this.monthType === 'week') return 'W';
            if(this.monthType === 'sevenDay') return 'W';
            return this.monthType;
        },
        notEmpty(arg){
            if(arg === undefined || arg === '' || arg == null){
                return false;
            }else{
                return true;
            }
        },
        convertToName(arg){
            return this.notEmpty(arg) ? arg : '其他';
        },
        convertToRate(arg){
            return this.notEmpty(arg) ? (arg * 1).toFixed(2) : '-';
        },
        convertToW(arg){
            return this.notEmpty(arg) ? Math.round(arg / 10000) : '-';
        },
    },
    created() {
    },
    mounted() {
        if(this.show && this.month){
            this.initData();
        }
    },
    template: `
    	<div>
			<div v-show="!noData">
				<drill-down-box
					ref="table"
					class="red"
					:list="list"
					:tablecolumn="tablecolumn"
					:table-height="tableHeight"
					:special-name="specialName"
					red-by="true"
					is-border="true"
                    :businessType="businessType"
                    :dateType="dateType"
                    :dataDate="dataDate"
                    :sumLevel="sumLevel"
                    :initSendCode="sendProvCode"
					/>
			</div>
			<div class="noData" v-if="noData">
				<img src="../../image/nodata.png" alt="暂无数据"/>
				<h3>暂无数据</h3>
			</div>
    	</div>
    `,
};
