var baseCompent = {
	props: ['noData','dataList','timeList','echartType'],
	data() {
		return {
			tipShow: false,
            show:true
		}
	},
	template: `<div class="echart" style="width: 100%;height: 100%;" ref="echart"></div>`,
	watch: {
		noData(val) {
			this.tipShow = val;
		},
		dataList(val) {
			if (val) {
				this.setData();
			}
		},
	
	},
	methods: {
		// 数据处理
		setData() {
            
			var dataList = this.dataList
            var timeList = this.timeList
            // console.log('dataList',dataList)
            // this.handleEchart(dataList)
            // console.log(timeList)
            var barJson = {
                yName: "实际值(%)",
                isDataZoom: true,
                xValue: timeList,
                yValue: dataList
            }
           if(dataList && timeList){
            	//开始渲染数据 echarts
			    this.renderPage(barJson);
           }else{
                this.show = false
           }
		

			// 缓存数据
			// this.cacheData[this.areaCode] = {
			// 	"beforeAreaCode": this.beforeAreaCode,
			// 	"tableData": params.data,
			// 	"barJson": params.barJson
			// }

		},
		// 渲染页面
		renderPage(barJson) {
         
                myChart = echarts.init(this.$refs.echart);
            
                // console.log(this.$refs.echart)
              
                // let option = averageBarOption(json);
                var color = {
                    'bar':'#0197FF',
                    'line':'#4CD997'
                }   
              
                
                var echartType = this.echartType
                var limits = {}   
                if(echartType == 'line'){
                    console.log(' json.yValue', barJson.yValue)
                    if(barJson.yValue.length>1){
                        limits['min'] = Math.min.apply(null, barJson.yValue)
                        limits['max'] = Math.max.apply(null, barJson.yValue)
                    }else{
                        limits['min'] = 0
                        limits['max'] = Math.max.apply(null, barJson.yValue)
                    }
                   
                }else{
                    limits['min'] = null
                    limits['max'] = null
                }
                let option = this.getBarOption(color, barJson ,echartType,limits);
               
                myChart.setOption(option, true);
          
		},
		// 处理柱状图
        getBarOption(color, json,echartType,limits) {
           
            return {
                color: color[echartType],
                tooltip: {
					trigger: 'axis',
					confine: true,
					axisPointer: {            // 坐标轴指示器，坐标轴触发有效
						type: 'shadow'        // 默认为直线，可选为：'line' | 'shadow'
					}
					
				},
                legend: {
                    top: 10,
                    right: 5,
                    data: json.legend
                },
                grid: {
                    top: 45,
                    left: 16,
                    right: 16,
                    containLabel: true
                },
                xAxis: {
                    type: 'category',
                    axisLabel: {
                        color: '#666666',
                        interval: 0,
                        rotate: 45,
                        textStyle: {
                            color: '#666666'
                        }
                        // formatter: function (value, index) {
                        //     return value.length > 4 ? value.substring(0, 4) + '...' : value;
                        // }
                    },
                    axisLine: {
                        lineStyle: {color: "#979797"}
                    },
                    axisTick: {
                        show: false
                    },
                    data: json.xValue
                },
                yAxis:[{
                        type: 'value',
                        name: json.yName,
                        nameTextStyle: {
                            color: "#666666",
                            fontSize: 12,
                            padding:[0,0,5,0]
                        },
                        min: limits['min'],
	                    max: limits['max'],
                        axisLine: {
                            show: false
                        },
                        axisTick: {
                            show: false
                        },
                        axisLabel: {
                            color: '#666666',
                            textStyle: {
                                color: '#666666'
                            }
                        },
                    }
                ],
                dataZoom: [{
                    show: true,
                    xAxisIndex: [0],
                    height: 30,
                    bottom: 10,
                    startValue: 0,
                    endValue: json.xValue.length > 6 ? 6 : json.xValue.length - 1,
                    maxValueSpan: 6,
                    mixValueSpan: 6,
                    handleIcon: 'path://M306.1,413c0,2.2-1.8,4-4,4h-59.8c-2.2,0-4-1.8-4-4V200.8c0-2.2,1.8-4,4-4h59.8c2.2,0,4,1.8,4,4V413z',
                    handleSize: '110%',
                    handleStyle: {color: "#d3dee5"},
                    textStyle: {color: "#0199FF"},
                    borderColor: "#90979c"
                }, {
                    "type": "inside"
                }],
                series: [{
                    data: json.yValue,
                    type: echartType,
                    barWidth : 30,//柱图宽度
                    label: {
                        show: true,
                        color: "#363636",
                        position: 'top'
                    },
                }]
            }
        }
	},
	mounted() {
        this.setData();
	}

};
