var cardA = {
    data() {
        return {
        	normalColor: '#333',
            upColor: '#009900',
            downColor: '#FA2525',
        }
    },
    props: {
    	item:{
    		Object,
    		default: () => {
    			return {
    				desc: '指标描述',
    				name: '全程时限达成率',
    				image: '../../image/timeLimit/icon_csj.png',
    				sjz: 0,
    				mbz: 0,
    				hb: 0,
    				zjmc: '-',
    				zj: 0,
    				rank: '',
    				tip62: '',
    			};
    		},
    	},
    },
    computed: {
    },
    methods: {
    	descClick(){
    		this.$emit('desc-click',this.item);
    	},
    	itemClick(){
    		this.$emit('item-click',this.item);
    	},
		getColorByTrend(arg){
			if(arg){
				let i = arg;
				if(i > 0){
					return '#009900';
				}else if(i < 0){
					return '#FA2525';
				}
			}
			return null;
		},
		getRankName(){
        	let lv = getLevelFromPermission(1);
        	if(lv == 2) return '全网';
        	if(lv == 3) return '全省';
        	if(lv == 4) return '全市';
        	return '';
        },
		notEmpty(arg){
        	if(arg === undefined || arg === '' || arg == null){
        		return false;
        	}else{
        		return true;
        	}
        },
        convertToName(arg){
        	return this.notEmpty(arg) ? arg : '其他';
        },
        convertToRate(arg){
        	return this.notEmpty(arg) ? (arg * 1).toFixed(2) + '%' : '-';
        },
        convertToW(arg){
        	return this.notEmpty(arg) ? Math.round(arg / 10000) + '万元' : '-';
        },
    },
    mounted() {

    },
    template: `
    	<div style="background:#FFF;padding:0px 8px 6px 8px;margin-bottom: 0.12rem;border-radius:5px;" @click.stop="itemClick">
    		<div style="display:flex;flex-direction:row;justify-content: space-between;height:0.36rem;">
				<div>
	    			<span style="font-size:0.16rem;font-weight: bold;">{{this.convertToName(item.name)}}</span>
	    			<span style="padding:0px 6px;" @click.stop="descClick">
		    			<img style="width:0.16rem; height:0.16rem" src="../../image/description_icon.png"/>
	    			</span>
				</div>
    			<span v-show="item.rank" style="float:right;display: flex;align-items: center;height:0.2rem;line-height:0.2rem;margin-top:0.06rem;background: #F9F6F4;border-radius: 0.1rem 0 0 0.1rem;">
	                <img style="width:0.12rem; height:0.12rem;margin-left:0.08rem" src="../../image/trophy.png" >    
	                <span style="font-size: 0.12rem;line-height:0.2rem;color:#9F7933;font-weight: 400;margin:0 0.06rem 0 0.02rem;">{{getRankName() + '第' + item.rank + '名'}}</span>
	            </span>
				<div style="display:flex;justify-content: space-evenly;align-items: center;background:#ECF7FF;margin-top:0.07rem;width:0.76rem;height: 0.22rem;border-radius: 0.11rem;">
		    		<img style="width:0.14rem; height:0.14rem" src="../../image/timeLimit/icon_red.png"/>
	    			<span style="font-size:0.12rem;color: #FA2525;font-weight: 400;">红图展示</span>
				</div>
			</div>
    		<div style="display:flex;">
    			<div>
    				<img style="width: 0.79rem;height: 0.79rem;" v-bind:src="item.image"/>
    			</div>
    			<div style="display:flex;flex-direction:column;margin-left:0.16rem;width:100%">
	    			<div style="display:flex;height:0.51rem;">
		    			<div style="width:40%;display:flex;flex-direction:column;justify-content:space-evenly;align-items:center;">
							<p style="font-size: 0.12rem;color: #333;">实际值</p>
							<p style="font-size: 0.18rem;color: #3377FF;font-weight: bold;">{{this.convertToRate(item.sjz)}}</p>
						</div>
						<div style="width:50%;display:flex;flex-direction:column;justify-content:space-evenly;align-items:center;">
							<p style="font-size: 0.12rem;color: #333;">环比</p>
							<p :style="{marginTop:'0.04rem',fontSize: '0.18rem',fontWeight: 'bold',color: getColorByTrend(item.hb)}">{{this.convertToRate(item.hb)}}</p>
						</div>
	    			</div>
	    			<p style="line-height:0.28rem;font-size: 0.12rem;">
						<span style="color: #666;">全网最佳：</span>
						<span style="font-weight: bold;color: #333;">{{this.convertToName(item.zjmc)}}</span>
						<span style="font-weight: bold;color: #009900;">{{this.convertToRate(item.zj)}}</span>
	    			</p>
	    			<div v-if="item.tip62" style="width:100%;height:0.5px;background:#E1E4EB"></div>
	    			<p v-if="item.tip62" style="line-height:0.12rem;font-size: 0.12rem;margin-top:0.07rem;">
						<span style="font-weight: 400;color: #FF7D00;">{{item.tip62}}</span>
	    			</p>
    			</div>
    		</div>
    	</div>
    `,
};