var cardB = {
    data() {
        return {
        	normalColor: '#333333',
            upColor: '#009900',
            downColor: '#FA2525',
        }
    },
    props: {
    	item:{
    		Object,
    		default: () => {
    			return {
    				desc: '指标描述',
    				name: '全程时限达成率',
    				image: '../../image/timeLimit/icon_csj.png',
    				fwfw: '(ABC-ABC)',
    				sjz: 0,
    				hb: 0,
    				zjmc: '-',
    				zj: 0,
    				fwfw2: '(ABCD-ABCD)',
    				sjz2: 0,
    				hb2: 0,
    				zjmc2: '-',
    				zj2: 0,
    			};
    		},
    	},
    },
    computed: {
    },
    methods: {
    	descClick(){
    		this.$emit('desc-click',this.item);
    	},
    	itemClick(){
    		this.$emit('item-click',this.item);
    	},
		getColorByTrend(arg){
			if(arg){
//				let i = Number(arg.split('%')[0]);
				let i = arg;
				if(i > 0){
					return '#009900';
				}else if(i < 0){
					return '#FA2525';
				}
			}
			return null;
		},
		notEmpty(arg){
        	if(arg === undefined || arg === '' || arg == null){
        		return false;
        	}else{
        		return true;
        	}
        },
        convertToName(arg){
        	return this.notEmpty(arg) ? arg : '其他';
        },
        convertToRate(arg){
        	return this.notEmpty(arg) ? (arg * 1).toFixed(2) + '%' : '-';
        },
        convertToW(arg){
        	return this.notEmpty(arg) ? Math.round(arg / 10000) + '万元' : '-';
        },
    },
    mounted() {

    },
    template: `
    	<div style="background:#FFF;padding:0px 8px 9px 8px;margin-bottom: 0.12rem;border-radius:5px;" @click.stop="itemClick">
    		<div style="display:flex;flex-direction:row;justify-content: space-between;height:0.36rem;">
    			<div>
	    			<span style="font-size:0.16rem;font-weight: bold;">{{this.convertToName(item.name)}}</span>
	    			<span @click.stop="descClick">
		    			<img style="margin-top:0.03rem;width:0.16rem; height:0.16rem" src="../../image/description_icon.png"/>
	    			</span>
    			</div>
    			<div style="display:flex;justify-content: space-evenly;align-items: center;background:#ECF7FF;margin-top:0.07rem;width:0.76rem;height: 0.22rem;border-radius: 0.11rem;">
		    		<img style="width:0.14rem; height:0.14rem" src="../../image/timeLimit/icon_red.png"/>
	    			<span style="font-size:0.12rem;color: #FA2525;font-weight: 400;">红图展示</span>
				</div>
    		</div>
    		<div style="display:flex;flex-direction:row;">
    			<div style="display:flex;;align-items:center;">
	    			<img style="width: 0.79rem;height: 0.79rem;" v-bind:src="item.image"/>
    			</div>
    			<div style="display:flex;flex-direction:column;margin-left:0.16rem;width:100%">
	    			<div style="display:flex;height:0.51rem;">
		    			<div style="width:40%;display:flex;flex-direction:column;justify-content:space-evenly;align-items:center;">
							<p style="font-size: 0.12rem;color: #333;">实际值</p>
							<p style="font-size: 0.18rem;color: #3377FF;font-weight: bold;">{{this.convertToRate(item.sjz2)}}</p>
						</div>
						<div style="width:50%;display:flex;flex-direction:column;justify-content:space-evenly;align-items:center;">
							<p style="font-size: 0.12rem;color: #333;">环比</p>
							<p :style="{marginTop:'0.04rem',fontSize: '0.18rem',fontWeight: 'bold',color: getColorByTrend(item.hb2)}">{{this.convertToRate(item.hb2)}}</p>
						</div>
	    			</div>
	    			<p style="line-height:0.28rem;font-size: 0.12rem;">
						<span style="color: #666;">全网最佳：</span>
						<span style="font-weight: bold;color: #333;">{{this.convertToName(item.zjmc2)}}</span>
						<span style="font-weight: bold;color: #009900;">{{this.convertToRate(item.zj2)}}</span>
	    			</p>
	    			<div v-if="item.tip62" style="width:100%;height:0.5px;background:#E1E4EB"></div>
	    			<p v-if="item.tip62" style="line-height:0.12rem;font-size: 0.12rem;margin-top:0.07rem;">
	    				<span style="font-weight: 400;color: #FF7D00;">{{item.tip62}}</span>
	    			</p>
				</div>
    		</div>
    	</div>
    `,
};