/**
 * yy
 * 这个表包含：
 * 1：折线图 
 * 2.柱状图，值大于折线图值的为绿色，小于折线图值的为红色
 */
Vue.component('lineBarBox', {
    data() {
        return {
        }
    },
    props: {
    	list: {
            Array,
	        default: () => {
	            return [{
	            	name: 'x轴名称',
	            	value: '折线图',
	            	value2: '柱状图',
	            }];
	        }
	    },
        specialName: {
            Array,
            default: () => {
                return ['总计']
            }
        },
        legend: [],
        valueName:{
	        Array,
	        default: () => {
	            return ['增幅(%)']
	        }
	    },
        echartName:'',
        colorT:{
        	String,
            default: () => {
               return '#00C482';
            }
        },
        colorY:{
        	String,
            default: () => {
               return '#F74627';
            }
        },
    },
    computed: {
    },
    methods: {
    	initDefault() {
            document.documentElement.scrollIntoView();
            const newList = this.list.sort((i, n) => {
                return Number(i.countDate.replace(/-/g,'')) - Number(i.countDate.replace(/-/g,''))
            });
            console.log("arrrr",newList)
            // const arr = newList.filter(e => this.specialName.indexOf(e.name) < 0)
            // console.log("arrrr",arr)
            const xData = [];
            const lineData = [];
            const yData = [];
            const y1Data = [];
            const y2Data = [];
            newList.map((e,i) => {
            	xData.push(e.countDate.replace(/-/g,''));
            	lineData.push(e.value2);
            	yData.push(e.value2);
                y1Data.push(e.value2);
                y2Data.push('-');
            	
            	// if(e.value <= e.value2){
            	// 	y1Data.push(e.value2);
            	// 	y2Data.push('-');
            	// }else{
            	// 	y1Data.push('-');
            	// 	y2Data.push(e.value2);
            	// }
            });
            
            this.initEcharts(xData, lineData, yData, y1Data, y2Data);
        },
        initEcharts(xData, lineData, yData, y1Data, y2Data) {
            const _this = this;
            let mychart = echarts.init(_this.$refs.chart);
            //解决title超长覆盖图例的问题
            const w = document.documentElement.clientWidth || document.body.clientWidth;
            let s = w * 0.37 / _this.echartName.length.toFixed(0);
            s = s >= 17 ? 17 : s;
            s = s <= 8 ? 8 : s;
            let option = {
                title: {
                    text: _this.echartName,
                    textStyle: {
                        fontSize: s,
                    },
                },
                color: ['#0199FF'],
                tooltip: {
                    trigger: 'axis',
                    axisPointer: { // 坐标轴指示器，坐标轴触发有效
                        type: 'shadow' // 默认为直线，可选为：'line' | 'shadow'
                    },
                    formatter:function(param){
                    	let arr = param.filter(e => {
                    		return (e.value || e.value == 0) && e.value != '-' && e.seriesName != '辅助';
                    	});
                    	if(!arr || arr.length <= 0){
                    		 return '';
                    	}
                    	let x = arr[0].name;
                    	if(x){
                    		let n9 = Math.floor(x.length / 9);
                    		for(let n=n9;n>0;n--){
                    			x = x.slice(0, n*9) + '<br/>' + x.slice(n*9);
                    		}
                    		//如果是整倍数，需要移除最后一个换行符...
                    		if(x.substr('<br/>'.length * -1) == '<br/>'){
                    			x = x.slice(0,x.length - '<br/>'.length);
                    		}
                    	}
                    	arr.forEach((e,i) => {
                    		let unit;
                    		let v = _this.valueName[0];
                    		//隐藏某个图例后，valueName数组和param的数组索引不会对应
                    		_this.valueName.forEach(it => {
                    			if(it.indexOf(e.seriesName) >= 0){
                    				v = it;
                    			}
                    		});
                        	let l = v.indexOf('(');
                        	let r = v.indexOf(')');
                        	if(l + r > 1){
                        		unit = v.substring(l+1,r);
                        	}
                    		x += '<br/>' + e.marker + e.seriesName + ' : ' + e.value;
                    		if(unit){
                    			x += unit;
                    		}
                    	});
                    	return x;
                    },
                },
                legend: {
                	data: _this.legend,
                	right: 10,
                },
                grid: {
                    top: '20%',
                    left: '4%',
                    right: '4%',
                    bottom: '15%',
                    containLabel: true
                },
                xAxis: [{
                    type: 'category',
                    nameGap: 30,
                    data: xData,
                    axisLine: {
                        lineStyle: {
                            color: '#90979c'
                        }
                    },
                    splitLine: {
                        show: false
                    },
                    axisTick: {
                        show: false
                    },
                    splitArea: {
                        show: false
                    },
                    axisLabel: {
                        interval: 0,
                        rotate: 40,
                        formatter: (val) => {
                            if (val.length > 8) return val.substring(0, 8) + '...'
                            else return val
                        }

                    }
                }],
                yAxis: [{
                    type: 'value',
                    name: _this.valueName[0],
                    nameTextStyle: {
                    	fontSize: 11,
                    	padding: [0, 0, 10, 30],
                    },
                    axisLine: {
                        show: false
                    },
                    axisTick: {
                        show: false
                    },
                    axisLabel: {
                        formatter: (val) => {
                            if (Number(val) >= 10000) return (Number(val) / 10000).toFixed(1) + '万'
                            else return val
                        }
                    }
                }],
                dataZoom: [{
                    show: true,
                    height: 30,
                    xAxisIndex: [
                        0
                    ],
                    bottom: 10,
                    startValue: 0,
                    endValue: yData.length > 6 ? 6 : yData.length - 1,
                    maxValueSpan: 6,
                    mixValueSpan: 6,
                    handleIcon: 'path://M306.1,413c0,2.2-1.8,4-4,4h-59.8c-2.2,0-4-1.8-4-4V200.8c0-2.2,1.8-4,4-4h59.8c2.2,0,4,1.8,4,4V413z',
                    handleSize: '110%',
                    handleStyle: {
                        color: "#d3dee5",
                    },
                    textStyle: {
                        color: "#0199FF"
                    },
                    borderColor: "#90979c"
                }, {
                    type: "inside",
                    show: true,
                    height: 15,
                    start: 1,
                    end: 0
                }],
                series: [
					{
					    name: '辅助',
					    type: 'line',
					    symbolSize: 0, // symbol的大小设置为0
					    showSymbol: false, // 不显示symbol
					    yAxisIndex: 0,
					    lineStyle: {
					        width: 0, // 线宽是0
					        color: 'rgba(0, 0, 0, 0)' // 线的颜色是透明的
					    },
					    data: yData,
					},{
	                    name: _this.legend[0].name,
	                    type: 'bar',
	                    stack: 1,
	                    barWidth: 30,
	                    barGap: 20,
	                    color: this.colorT,
	                    yAxisIndex: 0,
	                    label: {
	                        show: true,
	                        position: 'inside',
	                        rotate: 0,
                            fontSize: 10,
	                    },
	                    data: y1Data,
	                },{
	                    name: _this.legend[0].name,
	                    type: 'bar',
	                    stack: 1,
	                    barWidth: 30,
	                    barGap: 20,
	                    color:this.colorY,
	                    yAxisIndex: 0,
	                    label: {
	                        show: true,
	                        position: 'inside',
	                        rotate: 0,
                            fontSize: 10,
	                    },
	                    data: y2Data,
	                },
                ],
            }
            mychart.setOption(option, true);
            mychart.on('legendselectchanged', function (params) {
				let option = this.getOption();
				let name = params.name;
                if (!params.selected[name]) {
                    // false 的时候
                    let isTure = [];
                    for(var item in params.selected){
                        if (params.selected[item]) {
                            isTure.push(item)
                        };
                    }
                    if (isTure.length > 0) {
                        option.legend[0].selected[name] = false;
                    } else {
                        option.legend[0].selected[name] = true;
                    }
                } else {
                    // true 的时候
                    option.legend[0].selected[name] = true;
				}
//				if (name == '实际值' && option.legend[0].selected['实际值']) {
//					option.legend[0].data[0].icon = 'image://data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAFAAAAAoAQMAAABTru9CAAAABlBMVEUAxIL3RidNALHZAAAAE0lEQVQY02NgAIH/IMAwyhw6TABNs8c5rOzZTgAAAABJRU5ErkJggg==';
//				} else if (name == '实际值' && !option.legend[0].selected['实际值']) {
//					option.legend[0].data[0].icon = 'image://data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAFAAAAAoAQMAAABTru9CAAAABlBMVEXMzMzv7++Y3rQzAAAAE0lEQVQY02P4DwL2IIJhlDl0mADDfHCAiQlelgAAAABJRU5ErkJggg==';
//				}
                this.setOption(option);
            });
        },
    },
    mounted() {
        const h = document.documentElement.clientHeight || document.body.clientHeight;
        this.$refs.chart.style.height = h / 2 + 'px';
    },
    template: `<div style="padding: 10px 5px; position: relative">
					<div ref="chart" style="background-color: #FFF; width: 100%"></div>
	           </div>`
});