var trend = {
	components: {
		'line-box': lineBox,
		'run-text': runText,
	},
	props: ['show','active','m','mt','productType','scopeServices'],
	data(){
		return {
			month: '',
			monthType: '',
		    runShow: false,
		    runMsg: '当前日期的数据暂未更新呢！',
		   	noData:false,
		   	list: [],
		   	list2: [],
		   	tablecolumn: [],
		   	legend: [
		   	         "长三角全程时限达成率",
		   	         "省内互寄次日递率",
		   	         "62城市次日递率",
		   	         ],
		   	legendSimple: [
		   	               '长三角',
		   	               '省内互寄',
		   	               ],
		   	valueName: '实际完成(%)',
		   	nameMap: {
		   		'A01': '长三角全程时限达成率',
		   		'A02': '长三角全程时限达成率',
		   		'A03': '华北区域全程时限达成率',
		   		'A04': '华北区域全程时限达成率',
		   		'A05': '华南区域全程时限达成率',
		   		'A06': '华南区域全程时限达成率',
		   		'A07': '东北区域全程时限达成率',
		   		'A08': '东北区域全程时限达成率',
		   		'A09': '西南区域全程时限达成率',
		   		'A10': '西南区域全程时限达成率',
		   		'A11': '中部区域全程时限达成率',
		   		'A12': '中部区域全程时限达成率',
		   		'A13': '西北区域全程时限达成率',
		   		'A14': '西北区域全程时限达成率',
		   		'A15': '省内互寄次日递率',
		   		'A16': '省内互寄次日递率',
		   		'A20': '62城市次日递率',
		   	},
		   	nameMapSimple: {
		   		'A01': '长三角    ',
		   		'A02': '长三角    ',
		   		'A03': '华北区域',
		   		'A04': '华北区域',
		   		'A05': '华南区域',
		   		'A06': '华南区域',
		   		'A07': '东北区域',
		   		'A08': '东北区域',
		   		'A09': '西南区域',
		   		'A10': '西南区域',
		   		'A11': '中部区域',
		   		'A12': '中部区域',
		   		'A13': '西北区域',
		   		'A14': '西北区域',
		   		'A15': '省内互寄',
		   		'A16': '省内互寄',
		   		'A20': '62城市  ',
		   	},
		   	adaptA: ['A20','A15','A16'],
		   	fwfwMap: {
		   		'A': "(ABC-ABC)",
		   		'B': "(ABCD-ABCD)",
		   	},
		};
	},
	watch: {
		show: function(val){
			if(this.show){
				//子页面各自维护日期，切换时将这个日期显示到标题栏
				try{
		       		Emp.execute("setDefaultData('" + this.month + "','" + this.monthType + "')");
		       	}catch(error){
		       	}
			}
			if(this.show && (this.list.length == 0 || this.noData)){
				this.initData();
			}
			this.runShow = this.noData && this.show;
		},
		m: function(){
			if(!this.m){
				return;
			}
			this.month = this.m;
			this.monthType = this.mt;
		},
		month: function(val,oldVal){
			if(!oldVal && val){
				//4.26开始第一次请求不用传日期，返参中给日期赋值，所以空->值时不加载
				return;
			}
			if(!this.show){
				this.list = [];
				return;
			}
			if(oldVal){
				this.initData();
			}
		},
		noData: function(){
			this.runShow = this.noData && this.show;
		},
	},
	methods: {
	    closeRun(){
	    	this.runShow = false;
	    },
	    switchScope: function(i){
			this.$emit('switchScope',i);
		},
	    initData: function(){
	    	this.noData = false;
 	    	let params = {
 	 	    	dateType: this.getMT(),
 	 	    	countDate: this.month,
 	 	    	businessTypes: this.productType,
 	 	    	scopeServices: this.scopeServices,
 	 	    	keyareaId: '',
 	 	    	keyareaName: '',
 	 	    	areaLevel: 1,
 	 	    	areaCode: '',
 			}
 	    	requestImportantUpTrend(params).then(({data}) => {
 			   	if(!data){
 			   		this.noData = true;
 					return;
 			   	}
 	    		
 	    		//根据返参生成table的列
 	    		let cols = [];
 	    		cols.push({
		    		label: '区域',
		    	    key: 'name',
		    	    fixed: true,
		    	    align: 'left',
		    	    width: 108,
 	    		});
 	    		
 	    		//辅助解析数据的数组
 	    		let column = [];
 	    		let row = [];
 	    		let columnJson = {};
 	    		let rowJson = {};
 	    		
 	    		let res = JSON.parse(data);
 	    		let latestMonth = '';
 			   	let latestMonthType = '';
 	    		res.forEach(e => {
 	    			if(!latestMonth){
 			   			latestMonth = e.countDateStr;
 			   			latestMonthType = this.getMTR(e.dateType);
 			   		}else{
 			   			let ifThan = new Date(latestMonth) > new Date(e.countDateStr);
 			   			latestMonth = ifThan ? latestMonth : e.countDateStr;
 			   		}
 	    			
 	    			if(this.scopeServices === e.scopeServices || this.adaptA.indexOf(e.keyareaId) >= 0){
 	    				if(column.indexOf(e.countDate) < 0){
 	    					column.push(e.countDate);
 	    				}
 	    				
 	    				if(row.indexOf(e.keyareaId) < 0){
 	    					if(e.keyareaId != 'A15' && e.keyareaId != 'A16'){
 	    						row.push(e.keyareaId);
 	    					}
 	    				}
 	    				
 	    				if(!columnJson[e.keyareaId]){
 	    					columnJson[e.keyareaId] = {};
 	    				}
 	    				columnJson[e.keyareaId][e.countDate] = e.limitOntimerate;
 	    				
 	    				if(!rowJson[e.countDate]){
 	    					rowJson[e.countDate] = {};
 	    				}
 	    				rowJson[e.countDate][e.keyareaId] = e.limitOntimerate;
 	    			}
 	    		});
 	    		
 	    		if(!this.month){
 		       		this.month = latestMonth;
 		       		this.monthType = this.getMTR(latestMonthType);
 		       	}
 	    		column = column.sort((i, n) => {
 	                return i.localeCompare(n);
 	            });
 	    		
// 	    		console.log(column)
// 	    		console.log(row)
// 	    		console.log(columnJson)
// 	    		console.log(rowJson)
 	    		
 	    		//表格数据
 	    		let list = [];
 	    		//折线图x轴数据
 	    		let list2 = [];
 	    		//折线图y轴数据,arr是二维数组，每一个元素数组是一个图例的数据，length=日期数
 	    		let arr = [];
 	    		let legend = [];
 	    		let legendSimple = [];
 	    		
 	    		row.forEach(r => {
 	    			let it = {};
 	    			it.name = this.nameMap[r];
 	    			it.nameCode = r;
 	    			
 	    			let k = [];
 	    			column.forEach(c => {
 	    				it[c] = this.convertToRate2(columnJson[r][c]);
 	    				k.push(this.convertToRate(columnJson[r][c]));
 	    			});
 	    			list.push(it);
 	    			arr.push(k);
 	    			legend.push(this.nameMap[r]);
 	    			legendSimple.push(this.nameMapSimple[r]);
 	    		});
 	    		column.forEach(c => {
 	    			cols.push({
	    				label: c,
	    				key: c,
	    				width: column.length <= 2 ? null : 82,
	    				align: 'right',
	    				paddingRight: 5,
				    	isNumber: true,
	    			});
 	    			list2.push({
 	    				name: c,
 	    				nameCode: c,
 	    			});
 	    		});
 	    		
 	    		this.tablecolumn = cols;
 	    		this.list = list;
 	    		this.legend = legend;
 	    		this.legendSimple = legendSimple;
 	    		this.list2 = list2;
 		    	this.$nextTick(() => {
 		    		this.$refs.line.initDefault(arr);
		        });
 			   	this.noData = false;
 			}).catch(err => {
 				console.log(err);
 			  	this.noData = true;
 			});
	    	
	    },
	    getMT(){
    		if(this.monthType === 'day') return 'D';
    		if(this.monthType === 'month') return 'M';
    		if(this.monthType === 'week') return 'W';
    		if(this.monthType === 'sevenDay') return 'W';
    		return this.monthType;
	    },
	    getMTR(arg){
	    	if(arg === 'D') return 'day';
	    	if(arg === 'M') return 'month';
	    	if(arg === 'W') return 'week';
	    	if(arg === 'W') return 'sevenDay';
	    	return arg;
	    },
        notEmpty(arg){
        	if(arg === undefined || arg === '' || arg == null){
        		return false;
        	}else{
        		return true;
        	}
        },
        convertToName(arg){
        	return this.notEmpty(arg) ? arg : '其他';
        },
        convertToRate(arg){
        	return this.notEmpty(arg) ? (arg * 1).toFixed(2): '';
        },
        convertToRate2(arg){
        	return this.notEmpty(arg) ? (arg * 1).toFixed(2) + '%' : '-';
        },
        convertToW(arg){
        	return this.notEmpty(arg) ? Math.round(arg / 10000) : '-';
        },
	},
	created() {
	},
	mounted() {
		let w = document.documentElement.clientWidth || document.body.clientWidth;
		let h = document.documentElement.clientHeight || document.body.clientHeight;
		this.$refs.pTrend.style.height = (h - (w*100) / 375 * 0.4) + 'px';
		
		this.month = this.m;
		this.monthType = this.mt;
		
		if(this.show){
			this.initData();
		}
	},
    template: `
    	<div>
			<div ref="pTrend" v-show="!noData" style="overflow-y:auto;background:#FFF;">
				<div style="position: relative;">
					<line-box
						ref="line"
						:list="list2"
						:legend="legend"
						:legend-simple="legendSimple"
						:value-name="valueName"
						ismaxmin-y=true
						/>
	    			<img v-show=false style="width:0.2rem; height:0.36rem;position:absolute;top: 1.4rem;" src="../../image/timeLimit/line_left.png" @click="switchScope(0)"/>
	    			<img v-show=false style="width:0.2rem; height:0.36rem;position:absolute;top: 1.4rem;right: 0rem" src="../../image/timeLimit/line_right.png" @click="switchScope(1)"/>
				</div>
				<div>
					<drill-down-box
						ref="table"
						:list="list"
						:tablecolumn="tablecolumn"
						/>
				</div>
			</div>
			<div v-if="noData || runShow">
				<run-text img-url="../../" :msg="runMsg" :is-show="runShow" @close="closeRun"></run-text>
				<div class="noData" v-if="noData">
					<img src="../../image/nodata.png" alt="暂无数据" />
					<h3>暂无数据</h3>
				</div>
			</div>
    	</div>
    `,
};