var imp = {
	components: {
	},
	props: ['show','month','monthType','scopeServices','productType','type'],
	data(){
		return {
		   	noData:false,
		   	list: [],
		   	specialName: [],
		   	tablecolumn: [],
		};
	},
	watch: {
		show: function(val){
			if(this.show && (this.list.length == 0 || this.noData)){
				this.initData();
			}
		},
		month: function(){
			this.initData();
		},
	},
	computed: {
    	tableHeight: function(){
    		let w = document.documentElement.clientWidth || document.body.clientWidth;
    		let h = document.documentElement.clientHeight || document.body.clientHeight;
        	return h - (w*100) / 375 * 0.8;
    	},
	},
	methods: {
		initColumn(){
			let w = document.documentElement.clientWidth || document.body.clientWidth;
			w -= 4;
			w /= 10;
			this.tablecolumn = [
					             {
						             	label: '城市',
						             	key: 'name',
						             	width: w * 3,
						             },
						             {
						             	label: '时限准时率(%)',
						             	key: 'sxzsl',
						             	width: w * 4,
								    	sortable: true,
								    	align: 'right',
								    	isNumber: true,
						             },
						             {
						             	label: '环比(%)',
						             	key: 'hb',
						             	width: w * 3,
								    	sortable: true,
								    	align: 'right',
								    	isNumber: true,
								    	subByZero: true,
						             },
						         ];
		},
	    initData(){
 	    	if(this.type == 'imp'){
 	    		//进口
 	    		this.initImpData();
 	    	}else if(this.type == 'exp'){
 	    		//出口
 	    		this.initExpData();
 	    	}
	    },
	    initImpData(){
 	    	let params = {
 	    			dateType: this.monthType,
 	    			countDate: this.month,
 	    			scopeServices: this.scopeServices,
 	    			baseProductCode:this.productType
 			}
 	    	requestCitiesSIB(params).then(({data}) => {
 	 			   	if(!data){
 	 			   		this.noData = true;
 	 					return;
 	 			   	}
 	 			   	let list = JSON.parse(data);
 	 			   	list.forEach(e => {
 	 			   		e.name = this.convertToName(e.importCityName);
 	 			   		e.sxzsl = this.convertToRate(e.limitOntimerate);
 	 			   		e.hb = this.convertToRate(e.roundRate);
 	 			   	});
 	 			   	
 	 			   	this.list = list;
 	 			   	this.noData = false;
 	 			}).catch(err => {
 	 			  	this.noData = true;
 	 			  	console.log(err);
 	 			});
	    },
	    initExpData(){
 	    	let params = {
 	    			dateType: this.monthType,
 	    			countDate: this.month,
 	    			scopeServices: this.scopeServices,
 	    			baseProductCode:this.productType
 			}
 	    	requestCitiesSLDB(params).then(({data}) => {
 	 			   	if(!data){
 	 			   		this.noData = true;
 	 					return;
 	 			   	}
 	 			   	let list = JSON.parse(data);
 	 			   	list.forEach(e => {
 	 			   		e.name = this.convertToName(e.exportCityName);
 	 			   		e.sxzsl = this.convertToRate(e.limitOntimerate);
 	 			   		e.hb = this.convertToRate(e.roundRate);
 	 			   	});
 	 			   	
 	 			   	this.list = list;
 	 			   	this.noData = false;
 	 			}).catch(err => {
 	 			  	this.noData = true;
 	 			  	console.log(err);
 	 			});
	    },
        notEmpty(arg){
        	if(arg === undefined || arg === '' || arg == null){
        		return false;
        	}else{
        		return true;
        	}
        },
        convertToName(arg){
        	return this.notEmpty(arg) ? arg : '其他';
        },
        convertToRate(arg){
        	return this.notEmpty(arg) ? (arg * 1).toFixed(2) : '-';
        },
        convertToW(arg){
        	return this.notEmpty(arg) ? Math.round(arg / 10000) : '-';
        },
	},
	created() {
	},
	mounted() {
		this.initColumn();
		if(this.show){
			this.initData();
		}
	},
    template: `
    	<div>
			<div v-show="!noData">
				<drill-down-box
					ref="table"
					:list="list"
					:tablecolumn="tablecolumn"
					:special-name="specialName"
					:table-height="tableHeight"
					/>
			</div>
			<div class="noData" v-if="noData">
				<img src="../../image/nodata.png" alt="暂无数据"/>
				<h3>暂无数据</h3>
			</div>
    	</div>
    `,
};