var impExportTab = {
	props: ['show', 'month', 'monthType', 'productType', 'scopeServices'],
	data() {
		return {
			active: 0,
			activeBtn: {},
			tabBtn: [
				{
					id: 1,
					name: "红图",
					type: 'red',
				}, {
					id: 2,
					name: "进口",
					type: 'imp',
				}, {
					id: 3,
					name: "出口",
					type: 'exp',
				}
			],
		};
	},
	components: {
		'tab-btn-box': tabBtnBox,
	},
	watch: {
		show: function (val) {
			if (val && !this.activeBtn && !this.activeBtn.type) {
				this.active = 0;
				this.activeBtn = {
					id: 1,
					name: "红图",
					type: 'red'
				}
			}
		},
	},
	methods: {
		chooseTabBtn: function (item) {
			if (!item || !item.type) {
				item = this.tabBtn[0];
			}
			this.activeBtn = item;
			this.active = item.id - 1;
		},
	},
	created() {
	},
	mounted() {
	},
	template: `
    	<div style="background: #FFF;">
			<div style="height:0.4rem;background:#FFF;box-shadow: 0px 1px 4px 0px rgba(187, 182, 182, 0.5);">
				<tab-btn-box :tab-btn="tabBtn" @choose-tab-btn="chooseTabBtn"></tab-btn-box>
			</div>
			<div class="tab">
					<red
						ref="red"
						:show="show && active == 0"
					    v-if="show && active==0"
						:month="month"
						:month-type="monthType"
						:scope-services="scopeServices"
						:product-type="productType"
					>
					</red>

					<imp
						ref="imp"
						v-show="show && active==1"
						:show="show && active == 1"
						:month="month"
						:month-type="monthType"
						:scope-services="scopeServices"
						:product-type="productType"
						type="imp"
					/>
				
					<imp
						ref="exp"
						v-show="show && active==2"
						:show="show && active == 2"
						:month="month"
						:month-type="monthType"
						:scope-services="scopeServices"
						:product-type="productType"
						type="exp"
					/>
			</div>
    	</div>
    `,
};

