var red = {
	components: {
	},
	props: ['show','month','monthType','scopeServices','productType'],
	data(){
		return {
		   	noData:false,
		   	tablecolumn: [],
		   	list: [],
		   	specialName: [],
		   	redBy: null,
		    type:"B"
		};
	},
	watch: {
		show: function(val){
			if(this.show && (this.list.length == 0 || this.noData)){
				this.initData();
			}
		},
		month: function(){
			this.initData();
		},
	},
	computed: {
    	tableHeight: function(){
    		let w = document.documentElement.clientWidth || document.body.clientWidth;
    		let h = document.documentElement.clientHeight || document.body.clientHeight;
        	return h - (w*100) / 375 * 0.8;
    	},
	},
	methods: {
		/*特快60%以上绿，40%以下红，快包55%以上绿，35%以下红*/
		initRedBy(){
    		if(this.productType == "B"){
    			this.redBy = {
    				min: 40,
    				max: 60,
    			};
    		}else if(this.productType == "K"){
    			this.redBy = {
    				min: 35,
    				max: 55,
    			};
    		}
    	},
	    initData(){
    		this.type=this.productType;
    		this.initRedBy();
 	    	let params = {
 	     	    dateType: this.monthType,
 	     	    countDate: this.month,
 	     	    scopeServices: this.scopeServices,
 	     	    baseProductCode:this.productType
 			}
 	    	//alert(this.monthType+"-"+this.month+"-"+this.scopeServices+"-"+this.productType)
 	    	requestCitiesSURF(params).then(({data}) => {
 	    		
 	    		if(!data){
 			   		this.noData = true;
 					return;
 			   	}
 	    		let json = JSON.parse(data);
 			   	let imp = json.importCityData;
 			   	let exp = json.exportCityData;
 			   	let d = json.data;
 			   	
 			   	let cols = [];
      	    	cols.push({
      	    		label: '进出口',
      	    		key: 'name',
      	    		width: 70,
      	    		fixed: false,
      	    	});
      	    	imp.unshift({
      	    		importCityCode:  '100000',
 			   		importCityName: '进口汇总',
 			   	});
      	    	exp.unshift({
 			   		exportCityCode:  '100000',
 			   		exportCityName: '出口汇总',
 			   	});
      	    	imp.forEach((e,i) => {
      	    		let c = {};
      	    		c.label = e.importCityName;
          	    	c.key = e.importCityCode;
          	    	c.width = 70,
          	    	c.isRate = true,
      	    		cols.push(c);
      	    	})
      	    	this.tablecolumn = cols;
      	    
      	    	let list = [];
      	    	exp.forEach((it,i)=> {
            		let row = {};
            		row.name = it.exportCityName;
            		imp.forEach((e,j)=> {
            			row[e.importCityCode] = this.convertToRate(d[i][e.importCityCode]);
            		});
            		list.push(row);
                });
      	    	this.list = list;
 			   	this.noData = false;
            }).catch(err => {
            	this.noData=true;
        		
            });
	    },
        notEmpty(arg){
        	if(arg === undefined || arg === '' || arg == null){
        		return false;
        	}else{
        		return true;
        	}
        },
        convertToName(arg){
        	return this.notEmpty(arg) ? arg : '其他';
        },
        convertToRate(arg){
        	return this.notEmpty(arg) ? (arg * 1).toFixed(2) : '-';
        },
        convertToW(arg){
        	return this.notEmpty(arg) ? Math.round(arg / 10000) : '-';
        },
	},
	created() {
	},
	mounted() {
		if(this.show){
			this.initData();
		}
	},
    template: `
    	<div>
			<div v-show="!noData">
				<drill-down-box
					ref="table"
					is-border="true"
				    :class="[type=='B' ? 'red' : 'red1']"
					:list="list"
					:tablecolumn="tablecolumn"
					:table-height="tableHeight"
					:special-name="specialName"
					:red-by="redBy"
					/>
			</div>
			<div class="noData" v-if="noData">
				<img src="../../image/nodata.png" alt="暂无数据"/>
				<h3>暂无数据</h3>
			</div>
    	</div>
    `,
};