var panelBox = {
	props: ['dateType', 'countDate', 'type', 'panelArr', 'isShow'],
	data() {
		return {
			tipShow: false,
			msg: '当前日期的数据暂未更新呢！',
			noData: false,
			//弹框 
			isShowDialog: false,
			dialogTitle: '',
			dialogList: {},
			//数据
			userLevel: '',
			panelData: {},
		}
	},
	template: `
		<div class="panelBoxDiv">
			<div v-if="!noData" class="panelBox body-bg">
				<div class="panel" 
					v-for="(item, index) in panelArr" :key="index"
				>
					<p>
						<span>{{item.title}}</span>
						<span v-if="item.isDate" class="date">({{countDate}})</span> 
						<img src="../../image/description_icon.png" :alt="item.title" @click="openDialog(item)" />
						<span class="rangking" v-if="item.title !== '邮航航班正常率' && userLevel > 2 && panelData[item.dataKey]">
							<img src="../../image/trophy.png" />
							<span v-if="item.title !== '邮车运行准点率' && item.title !== '分拣准确率'">
								全网第{{panelData[item.dataKey].ranking}}名
							</span>
							<span v-if="item.title == '邮车运行准点率'">
								<p>一干:全网第{{panelData[item.dataKey].firstRanking}}名</p>
								<p>二干:全网第{{panelData[item.dataKey].secondRanking}}名</p>
							</span>
							<span v-if="item.title == '分拣准确率'">
								<p>进口:全网第{{panelData[item.dataKey].inRanking}}名</p>
								<p>出口:全网第{{panelData[item.dataKey].outRanking}}名</p>
							</span>
						</span>
					</p>
					<div @click="goToDetail(item.title)">
						<img :src="'../../image/timeLimit/' + item.imgUrl" :alt="item.title" />
						<div class="dataBox">
							<div v-for="(data, index) in item.data" :class="data.type">
								<div v-if="data.type == 'classData' && data.left">
									<p class="classTitle">{{data.left.title}}</p>
									<p class="classDataNum">{{formatNum(panelData[item.dataKey], data.left.data)}}</p>
									<p v-if="data.left.rate" class="textLeft">
										<span>环比:</span>
										<span :class="formatRate(panelData[item.dataKey], data.rate.data)">{{formatNum(panelData[item.dataKey], data.left.rate)}}</span>
									</p>
									<p v-if="data.left.area" class="textLeft">全网最佳:</p>
									<p v-if="data.left.area">
										<span class="area">{{formatNum(panelData[item.dataKey], data.left.area.name)}}</span>
										<span class="upData">{{formatNum(panelData[item.dataKey], data.left.area.data)}}</span>
									</p>
								</div>
								<div v-if="data.type == 'classData' && data.right">
									<p class="classTitle">{{data.right.title}}</p>
									<p class="classDataNum">{{formatNum(panelData[item.dataKey], data.right.data)}}</p>
									<p v-if="data.right.rate" class="textLeft">
										<span>环比:</span>
										<span :class="formatRate(panelData[item.dataKey], data.right.rate)">{{formatNum(panelData[item.dataKey], data.right.rate)}}</span>
									</p>
									<p v-if="data.right.area" class="textLeft">全网最佳:</p>
									<p v-if="data.right.area">
										<span class="area">{{formatNum(panelData[item.dataKey], data.right.area.name)}}</span>
										<span class="upData">{{formatNum(panelData[item.dataKey], data.right.area.data)}}</span>
									</p>
								</div>

								<div v-if="data.type == 'rateData' && data.rate">
									<span>环比:</span>
									<span :class="formatRate(panelData[item.dataKey], data.rate.data)">{{formatNum(panelData[item.dataKey], data.rate.data)}}</span>
								</div>
								<div v-if="data.type == 'rateData' && data.area">
									<span :class="data.type == 'rateData' && data.rate ? 'paddingLeft10' : ''">全网最佳:</span>
									<span class="area">{{formatNum(panelData[item.dataKey], data.area.name)}}</span>
									<span class="upData">{{formatNum(panelData[item.dataKey], data.area.data)}}</span>
								</div>
							</div>
						</div>
					</div>
				</div>
				<xk-dialog @func="closeDialog" :visible='isShowDialog' :title="dialogTitle" :data-list="dialogList"></xk-dialog>
			</div>
			<!-- 暂无数据 -->
			<div v-if="noData">
				<run-text img-url="../../" :msg="msg" :is-show="tipShow" @close="close"></run-text>
				<div class="noData">
					<img src="../../image/nodata.png" alt="暂无数据" />
					<h3>暂无数据</h3>
				</div>
			</div>
		</div>
	`,
	watch: {
		// 监控当时间变化时, 重新请求
		countDate: function(val) {
        	if (val) {
				if (!this.userLevel) {
					this.userLevel = getAccountLevel();
				}
                this.getData();
            }
        },
		isShow: function(val) {
			if(val) {
				this.tipShow = false;
				this.$nextTick(() => {
					this.tipShow = this.noData;
				})
			}
		}
	},
	mounted() {
		// 第一次显示的时候
		if (this.countDate) {
			this.getData();
		}
	},
	methods: {
		// 获取数据
		getData() {
			let countDate = this.dateType == 'W' ? this.countDate.split('-')[0] + this.countDate.split(' ')[1] : this.countDate;
			let params = {
				dateType: this.dateType,
				countDate: countDate,
				businessTypes: this.type
			}
			getLinkBoardStatics(params).then(({data}) => {
				this.setData(data);
			}).catch(err => {
				this.noData = true;
				this.tipShow = true;
			})
		},
		// 整理数据
		setData(data) {
			if(!data || data == '[]' ) {
				this.noData = true;
				this.tipShow = true;
				return;
			}
			data = JSON.parse(data);
			// 如果
			if(!data.postTimelyData && !data.handleTimelyData && !data.mailCarData && !data.deliveredTimelyData) {
				this.noData = true;
				this.tipShow = true;
				return;
			}
			this.noData = false;
			this.tipShow = false;
			this.panelData = data;
		},
		// 数据格式化
		formatNum(data, key) {
			let nameArr = ['bestName', 'firstBestName', 'secondBestName', 'inBestName', 'outBestName'];
			if ( nameArr.indexOf(key) !== -1) {
				return data ? data[key] : '';
			} else {
				return data ? (data[key] ? Number(data[key]*100).toFixed(2) + "%" : '--%') : '--%';
			}
		},
		// 环比颜色
		formatRate(data, key) {
			return data ? (data[key] ? (Number(data[key]*100).toFixed(2) > 0 ? 'upData' : 'downData') : 'downData') : 'downData';
		},
		// 跳转到详情页
		goToDetail(title) {
			let param = {
				pageTitle: title,
				dateType: this.dateType,
				countDate: this.countDate,
				businessTypes: this.type,
			};
			param = JSON.stringify(param);
			Emp.execute('gotoLinkDetail('+param+')');	
		},
		// 打开注释弹框
		openDialog(item) {
			this.dialogTitle = item.title;
			this.dialogList = item.dialog;
			this.isShowDialog = true;
		},
		// 关闭注释弹框
		closeDialog() {
			this.isShowDialog = false;
		},
		// 关闭提示
		close() {
			this.tipShow = false;
		}
	}

};