var barBox = {
    data() {
        return {
            total: 0
        }
    },
    props: {
        echartName: {
            String,
            default: ''
        },
        boxHeight: {
            String,
            default: '130px',
        },
        // marginTop: {
        //     Number,
        //     default: 0,
        // },


    },
    mounted() {

    },
    methods: {
        initEcharts(josn) {

            if (!josn) {
                return;
            }
            this.initPie(josn);
        },
        initPie(josn) {
            // console.log('name'+ josn.barTitle.length)
            // console.log( 'num'+josn.barNum.length)
            // const _this = this;
            // let colors = ['#0197FF','#65E6F1','#FF6834','#FEC441','#2AF5BC','#FFF46B'];
            // let map = {};
            // var aa=0;
            // data.forEach((e,i) => {
            //     aa=aa+Number(e.openNum);
            //     e.color = colors[i];
            //     map[e.name] = e.value + '%';
            // });
            // let huizo=aa;
            // let colorData = [];
            let mychart = echarts.init(this.$refs.bar);
            var option = {
                color: '#0197FF',
                tooltip: {
                    confine: true,
                    trigger: 'axis',
                    axisPointer: {
                        // 坐标轴指示器，坐标轴触发有效
                        type: 'shadow' // 默认为直线，可选为：'line' | 'shadow'
                    }
                },
                grid: {
                    left: '3%',
                    right: '4%',
                    bottom: '20%',
                    containLabel: true
                },
                xAxis: [
                    {
                        type: 'category',
                        data: josn.barTitle,
                        axisTick: {
                            show: false,
                            alignWithLabel: true
                        },
                        axisLine:{
                            show: false
                        }
                    }
                ],
                yAxis: [
                    {
                        type: 'value',
                        name: josn.Yname,
                        axisLabel: {
                            color: '#333333',
                            formatter: function (value) {
                                return value.length > 4 ? value.substring(0, 3) + '...' : value;
                                // return value + ""
                            }
                        },
                        axisTick: {
                            show: false,
                        },
                        axisLine:{
                            show: false
                        }
                    },
                    
                ],
                dataZoom: [
                    {
                        show: true,
                        xAxisIndex: [0],
                        height: 30,
                        bottom: 10,
                        startValue: 0,
                        endValue: josn.barNum.length > 4 ? 4 : josn.barNum.length - 1,
                        maxValueSpan: 6,
                        mixValueSpan: 6,
                        handleIcon:
                            'path://M306.1,413c0,2.2-1.8,4-4,4h-59.8c-2.2,0-4-1.8-4-4V200.8c0-2.2,1.8-4,4-4h59.8c2.2,0,4,1.8,4,4V413z',
                        handleSize: '110%',
                        handleStyle: { color: '#d3dee5' },
                        textStyle: { color: '#0199FF' },
                        borderColor: '#90979c',
                        filterMode: josn.filterMode ? josn.filterMode : 'filter'
                    },
                    {
                        type: 'inside',
                        filterMode: josn.filterMode ? josn.filterMode : 'filter'
                    }
                ],
                series: [
                    {
                        name: josn.name,
                        type: 'bar',
                        barWidth: 30,
                        barCategoryGap: 18,
                        data: josn.barNum
                    },
                    // {
                    //   name: josn.barName,
                    //   type: 'bar',
                    //   barWidth: 16,
                    //   barCategoryGap: 18,
                    //   label: {
                    //     show: true,
                    //     position: 'inside',
                    //     fontSize: 6
                    //   },

                    //   itemStyle: {
                    //     normal: {
                    //       color: function (params) {
                    //         return '#F74627';
                    //       }
                    //     }
                    //   },
                    //   data: josn.num
                    // }
                ]
            }
            mychart.setOption(option, true);
        },
    },
    template: `
        <div  style="width:100%">
            <div id="chartLine" ref="bar" :style="{'width': '100%', 'height': boxHeight}"></div>
        </div>
    `,
};

// 双值柱状图

// 平均值柱状图
// let josn = {
//     title: '全国',
//      subtext:'袋'
//     xValue: ['北京', '天津', '河北', '河南', '黑龙江', '辽宁'],
//     barValueName:""   第1条数据名称     
//     barValue: [20, 30, 50, 60, 80, 70],
//     barValue2: [50, 50, 50, 50, 50, 50]
//  barValueName:""   第2条数据名称
// };
var doubleBar = {
    data() {
        return {
            total: 0
        }
    },
    props: {
        echartName: {
            String,
            default: ''
        },
        boxHeight: {
            String,
            default: '130px',
        },
        // marginTop: {
        //     Number,
        //     default: 0,
        // },


    },
    mounted() {
    },
    methods: {
        initEcharts(josn) {
            if (!josn) {
                return;
            }
            this.initPie(josn);
        },
        initPie(josn) {
            let mychart = echarts.init(this.$refs.bar);
            var option = {
                title: {
                    text: josn.title,
                    padding: [15, 0, 0, 10],
                    // subtext: josn.subtext,
                    textStyle: {
                        // fontSize: josn.titleTextSize,
                        // fontWeight: 'bold'
                        color: '#333333',
                        fontWeight: 'bold',
                        fontSize: 16
                    }
                },
                tooltip: {
                    trigger: 'axis',
                    axisPointer: {
                        type: 'shadow'
                    }
                },
                legend: {
                    top: 10,
                    right: 5
                    // data: josn.legendData
                },
                grid: {
                    top: josn.title ? 90 : 75,
                    // left: 16,
                    // right: 16,
                    // containLabel: true,
                    left: '3%',
                    right: '4%',
                    bottom: '12%',
                    containLabel: true
                },
                // xAxis: {
                //   type: 'category',
                //   data: ['Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat', 'Sun']
                // },
                xAxis: {
                    type: 'category',
                    axisLabel: {
                        color: '#666666',
                        interval: 0,
                        rotate: 45,
                        // formatter: function (value, index) {
                        //     return value.length > 4 ? value.substring(0, 3) + '...' : value;
                        // }
                    },
                    axisLine: {
                        // lineStyle: { color: '#979797' }
                    },
                    axisTick: {
                        show: false
                    },
                    data: josn.xValue
                },
                axisPointer: {
                    // 坐标轴指示器，坐标轴触发有效
                    type: 'shadow' // 默认为直线，可选为：'line' | 'shadow'
                },
                yAxis: {
                    type: 'value',
                    name: '单位：%',
                    nameTextStyle: {
                        color: '#666666',
                        fontSize: 12,
                        padding:josn.barValue.length == 0 ? [0,0,0,85] : [0,0,0,25],
                    },
                    axisLine: {
                        show: false
                    },
                    axisTick: {
                        show: false
                    },
                    axisLabel: {
                        color: '#333333',
                        formatter: function (value) {
                            return value.length > 4 ? value.substring(0, 3) + '...' : value;
                            // return value + ""
                        }
                    }
                },
                dataZoom: [
                    {
                        show: true,
                        xAxisIndex: [0],
                        height: 30,
                        bottom: 10,
                        startValue: 0,
                        endValue: josn.barValue.length > 4 ? 4 : josn.barValue.length - 1,
                        maxValueSpan: 6,
                        mixValueSpan: 6,
                        handleIcon:
                            'path://M306.1,413c0,2.2-1.8,4-4,4h-59.8c-2.2,0-4-1.8-4-4V200.8c0-2.2,1.8-4,4-4h59.8c2.2,0,4,1.8,4,4V413z',
                        handleSize: '110%',
                        handleStyle: { color: '#d3dee5' },
                        textStyle: { color: '#0199FF' },
                        borderColor: '#90979c',
                        filterMode: josn.filterMode ? josn.filterMode : 'filter'
                    },
                    {
                        type: 'inside',
                        filterMode: josn.filterMode ? josn.filterMode : 'filter'
                    }
                ],
                series: [
                    {
                        name: josn.barValueName,
                        type: 'bar',
                        barWidth: 16,
                        barCategoryGap: 18,
                        data: josn.barValue,
                        itemStyle: {
                            normal: {
                                color: '#0197FF'
                            }
                        }
                    },
                    {
                        name: josn.barValueName2,
                        type: 'bar',
                        barWidth: 16,
                        barCategoryGap: 18,
                        data: josn.barValue2,
                        itemStyle: {
                            normal: {
                                color: '#FF7D00'
                            }
                        }
                    }
                ]
            };
            mychart.setOption(option, true);
        },
    },
    template: `
        <div  style="width:100%">
            <div id="chartLine" ref="bar" :style="{'width': '100%', 'height': boxHeight}"></div>
        </div>
    `,
}