var pieBox = {
	data() {
		return {
			total: 0
		}
	},
	
	props: {
		echartName: {
			String,
			default: ''
		},
		boxHeight: {
			String,
			default: '130px',
		},
		marginTop: {
			Number,
			default: 0,
		},
	},
	mounted() {

		//	    	let list = [
		//	    	            {
		//	    	            	name: "A",
		//	    	            	value: 5,
		//	    	            },
		//	    	            {
		//	    	            	name: "B",
		//	    	            	value: 3,
		//	    	            }
		//	    		];
	},
	methods: {
		initEcharts(list) {
			if (!list) {
				return;
			}
			this.initPie(list);
		},
		initPie(data = []) {
			const _this = this;
			let colors = ['#0197FF', '#65E6F1', '#FF6834', '#FEC441', '#2AF5BC', '#FFF46B'];
			let map = {};
			var aa = 0;
			data.forEach((e, i) => {
				aa = aa + Number(e.bagNum);
				e.color = colors[i];
				map[e.name] = e.value + '%';
			});
			let huizo = aa;
			let colorData = [];
			let mychart = echarts.init(this.$refs.pie);
			var option = {
				legend: {
					type: 'scroll',
					orient: 'vertical',
					top: 'middle',
					right: 12,
					padding: [8, 25, 1, 5],
					data: data.map((e) => {
						colorData.push(e.color)
						return e.name
					}),
					formatter: function (name) {
						//	                        return name + " " + map[name];
						return name;
					},
				},
				tooltip: {
					trigger: 'item',
					confine: true,
					formatter: function (val) {
						let a = val;
						let b = a.data.workSectName;
						//	                    	'{b}: {c}%<br>袋数：'
						// return b + "</br>" + "件数：" + a.data.openNum + "</br>" + "袋数：" + a.data.sumBag + "</br>" + "重量(吨)：" + a.data.sumWeight;
						return b + "</br>" + "袋数：" + a.data.bagNum + "</br>" + "重量(吨)：" + a.data.bagWeight ;
					},
				},
				//	                graphic: [ //为环形图中间添加文字
				//	                           {
				//	                             type: "text",
				//	                             left:"center",
				//	                             top: "42%",
				//	                             style: {
				//	                               text: 437280,
				//	                               textAlign: "center",
				//	                               fill: "#1e97f3",
				//	                               fontSize: 14,
				//	                             },
				//	                           },
				//	                           {
				//	                             type: "text",
				//	                             left: "21%",
				//	                             top: "52%",
				//	                             style: {
				//	                               text: "总数",
				//	                               textAlign: "center",
				//	                               fill: "#999999",
				//	                               fontSize: 12,
				//	                             },
				//	                           },
				//	                         ],
				series: [{
					name: '',
					type: 'pie',
					labelLine: {
						show: false
					},
					label: {
						normal: {
							show: true,
							position: 'center',
							color: '#4c4a4a',
							formatter: '\n\r' + '{total|' + huizo + '}' + '\n\r' + '{active|总件数}',
							rich: {
								total: {
									fontSize: 14,
									fontFamily: "微软雅黑",
									top: 50,
									color: '#1e97f3'
								},
								active: {
									fontFamily: "微软雅黑",
									fontSize: 12,
									color: '#999999',
									lineHeight: 25,
								},
							}
						},
					},
					radius: ['40%', '80%'],
					center: ['25%', '50%'],
					color: colorData,
					data: data,
				}]
			};
			mychart.setOption(option, true);
		},
	},
	template: `
		    <div  style="width:100%">
		    	<div id="chartLine" ref="pie" :style="{'width': '100%', 'height': boxHeight}"></div>
		    </div>
		`,
};