var secondaryPage = {
	props: [ 'tableColumnList', 'tableHeight', 'yName', 'dataList', 'dataListto', 'isMaxLevel',  'isSetting','areaCode', 'countDate', 'iszxt', 'islb'],
	data() {
		return {
			tipShow: false,
			msg: '当前日期的数据暂未更新呢！',
			areaLevel: '',
			beforeAreaCode: '',
			tableData: [],
			// 缓存数据
			cacheData: {},
		}
	},
	template: `
		<div>
	      <p v-if="islb" style="font-size:0.16rem;margin-bottom:0.1rem;margin-left:0.08rem;font-weight: bold;">设备运行情况</p>
			<div v-if="iszxt" class="echart" ref="echart" style=" margin-bottom: 0.12rem;"></div>
			
			<table-box
			ref="tableBox"
			:table-column-list="tableColumnList"
			:table-data="tableData"
			:table-height="tableHeight"
			:is-setting="isSetting"
			:divide-code="areaCode"
			:divide-code-level="areaLevel"
			:is-max-level="isMaxLevel"
			:provided-drill-down="providedDrillDown"
			@change-table-column="changeTableColumn"
			@sort-list="sortTableData"
			>
			</table-box>
		</div>
	`,
	watch: {
		noData(val) {
			this.tipShow=false;
			this.tipShow = val;
			if (val) {
				this.beforeAreaCode = '';
			}
		},
		dataList(val) {
			if (val) {
				this.setData();
			}
		},
		dataListto(val) {
			if (val) {
				this.setData();
			}
		}
	},
	mounted() {
		//this.tableColumnList[0].label = getNameFromPermission(this.level,false);
	},
	methods: {
		// 数据处理
		setData() {
			let zxt=this.iszxt;
			let ab=this.islb;
			// 数据预处理
			let sortData = JSON.parse(this.dataList);
			let sortObj = {};
			this.tableColumnList.forEach(columnItem => {
				if (columnItem.isProgress) {
					// 从小到大排序
					sortData.sort((a, b) => {
						return Number(a[columnItem.prop]) - Number(b[columnItem.prop]);
					})
					sortObj[columnItem.prop] = {
						min: sortData[0][columnItem.prop] ? sortData[0][columnItem.prop] : 0,
						max: sortData[sortData.length-1][columnItem.prop] ? sortData[sortData.length-1][columnItem.prop] : 0
					}
				}
			})
			// echart相关
			let average = 0;
			let barJson = {
				yName: this.yName,
				xValue: [],
				barValue: [],
				lineValue: [],
				titleTextSize : 14
			};
			// 数据判空
			let data = JSON.parse(this.dataList);
			data.forEach((item, index) => {
				if(this.isCen(item.areaCode) && item.regionalLevel == 4) {
					item.level = 3;
				} else {
					item.level = item.regionalLevel;
				}
				
				this.tableColumnList.forEach(columnItem => {
					if (columnItem.children) {
						columnItem.children.forEach(child => {
							let childProp = child.prop;
							item[childProp] = item[childProp] === null ? '' : ((item[childProp] ? item[childProp] : 0) * 100).toFixed(2);
						})
					}
					let prop = columnItem.prop;
					// 填充数据
					if (columnItem.isProgress) {
						if (item[prop] > 0) {
							item[prop + 'Progress'] = (sortObj[prop].max && sortObj[prop].max != 0) ? ((item[prop] / sortObj[prop].max) * 100).toFixed(0) == 0 ? 1 : ((item[prop] / sortObj[prop].max) * 100).toFixed(0) : 0;
						} else {
							item[prop + 'Progress'] = (sortObj[prop].min && sortObj[prop].min != 0 && item[prop] != 0) ? ((item[prop] / sortObj[prop].min) * 100).toFixed(0)  == 0 ? 1 : ((item[prop] / sortObj[prop].min) * 100).toFixed(0) : 0;
						}
					}
					if(prop == 'areaName') {
						item[prop] = item[prop] ? item[prop] : '其它';
					}else if(prop == 'accuracyTotal') {
						item[prop] = item[prop] === null ? '' : ((item[prop] ? item[prop] : 0) * 1);
					} else {
//						item[prop] = item[prop] === null ? '' : ((item[prop] ? item[prop] : 0) * 1).toFixed(2);
						item[prop] = item[prop] === null ? '' : ((item[prop] ? item[prop] : 0) * 1);
					}
					
				})
				if (index==0) {
					//平均值直线
//					barJson.average = item.target;
					this.areaLevel = item.level;
//					barJson.title = item.orgName;
					this.beforeAreaCode = item.parentOrg ? item.parentOrg : '999999';
				} else {
					
//					//平均值直线
//					barJson.average = item.target;
//					//x轴
//					barJson.xValue.push(item.orgName);
//					//年平均值
//					barJson.barValue.push(item.accuracyRate);
//					
////					barJson.lineValue.push(barJson.average);
				}
			})
			if(this.dataListto){
				let datato = JSON.parse(this.dataListto);
				datato.forEach((item, index) => {
//					if (index==0) {
						//平均值直线
//						barJson.average = item.target;
//						barJson.title = item.areaName;
//					} else {
						//平均值直线
//						barJson.average = item.target;
					    barJson.title = '分拣效率';
						//x轴
						barJson.xValue.push(item.dataDate);
						//年平均值
						if(item.workEffic){
							barJson.lineValue.push(item.workEffic);
						}
						
						
//					}
				})
				this.renderPage(data, barJson);
			}else{
				this.renderPage(data);
			}
			
//			this.renderPage(data, barJson);
		},
		// 渲染页面
		renderPage(data, barJson) {
			// 表格
			this.tableData = data;
			this.$refs.tableBox.$refs.table.clearSort();
			// 柱状图
			this.$nextTick(() => {
				this.getBarChart(barJson);
			});
		},
		// 表格下钻
        providedDrillDown(row) {
			Emp.execute("goToSort('" + row.areaName + "')");
			let areaCode = row.areaCode;
			let areaLevel = row.level;
			const cacheData = this.cacheData[areaCode + this.countDate + areaLevel];
			// 获取数据，重新渲染页面
			if(cacheData) {
				this.beforeAreaCode = cacheData.beforeAreaCode;
				this.areaLevel = cacheData.areaLevel;
				//alert("888"+this.areaLevel);
				this.$emit('change-level', row, false);
				this.renderPage(cacheData.tableData, cacheData.barJson);
			} else {
				this.beforeAreaCode = this.areaCode;
				//alert("999"+this.beforeAreaCode);
				this.$emit('change-level', row, true);
			}
			this.$refs.tableBox.$refs.table.clearSort();
		},
		// 返回上一层
		upLevel() {
			// 如果没有，应该去取另外一个tab里的beforeAreaCode
			if(!this.beforeAreaCode){
				let pageTab = this.$parent.$parent.$refs.pageTab;
				for(var i = 0; i < pageTab.length; i++) {
					if (pageTab[i].$refs.page.beforeAreaCode) {
						this.areaCode = pageTab[i].$refs.page.beforeAreaCode;
						this.areaLevel = pageTab[i].$refs.page.areaLevel - 1;
						break;
					}
				}
				this.getCacheData();
			} else {
				this.areaCode = this.beforeAreaCode;
				this.areaLevel = this.areaLevel - 1;
				//alert("99"+this.areaLevel);
				this.getCacheData();
			}
		},
		getCacheData() {
			const cacheData = this.cacheData[this.areaCode + this.countDate + this.areaLevel];
			// 获取数据，重新渲染页面
			if(cacheData) {
				this.beforeAreaCode = cacheData.beforeAreaCode;
				this.areaLevel = cacheData.areaLevel;
				//alert("88a"+this.areaLevel);
				this.$emit('change-area-code', this.areaCode, false);
				this.renderPage(cacheData.tableData, cacheData.barJson);
			} else {
				//alert("88b"+this.areaCode);
				this.beforeAreaCode = this.areaCode;
				this.$emit('change-area-code', this.areaCode, true);
			}
			this.$refs.tableBox.$refs.table.clearSort();
		},
		// 表格数据排序
		sortTableData(data) {
			this.tableData = data;
		},
		// 表格列表设置
		changeTableColumn(data) {
			this.tableColumnList = data;
			this.$emit("change-table-column", data);
		},
		// 柱状图
        getBarChart(data) {
			let json = {
				title: data.title,
//				legendData: [
//				{
//					name: '目标值'
//				}, {
//					name: '实际值',
////					icon: 'image://data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAFAAAAAoAQMAAABTru9CAAAABlBMVEUAxIL3RidNALHZAAAAE0lEQVQY02NgAIH/IMAwyhw6TABNs8c5rOzZTgAAAABJRU5ErkJggg=='
//				}],
				yName: data.yName,
				average: data.average,
				xValue: data.xValue,
				barName: '实际值',
				barValue: data.barValue,
				lineName: '分拣效率',
				lineValue: data.lineValue,
				titleTextSize :data.titleTextSize
			};
			
			if(json.title.length >12){
				json.titleTextSize = 10.5;
				let txt=data.title.substring(0,10);
				let txtt=data.title.substring(10,data.title.lengt);
				json.title=txt+'\n'+txtt;
			}
			if(this.iszxt==true){
				let myChart = echarts.init(this.$refs.echart);
				let option = averageBarOption(json);
				  myChart.setOption(option, true);
		            myChart.on('legendselectchanged', function (params) {
						let option = this.getOption();
						let name = params.name;
		                if (!params.selected[name]) {
		                    // false 的时候
		                    let isTure = [];
		                    for(var item in params.selected){
		                        if (params.selected[item]) {
		                            isTure.push(item)
		                        };
		                    }
		                    if (isTure.length > 0) {
		                        option.legend[0].selected[name] = false;
		                    } else {
		                        option.legend[0].selected[name] = true;
		                    }
		                } else {
		                    // true 的时候
		                    option.legend[0].selected[name] = true;
						}
//						if (name == '实际值' && option.legend[0].selected['实际值']) {
////							option.legend[0].data[1].icon = 'image://data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAFAAAAAoAQMAAABTru9CAAAABlBMVEUAxIL3RidNALHZAAAAE0lEQVQY02NgAIH/IMAwyhw6TABNs8c5rOzZTgAAAABJRU5ErkJggg==';
//						} else if (name == '实际值' && !option.legend[0].selected['实际值']) {
////							option.legend[0].data[1].icon = 'image://data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAFAAAAAoAQMAAABTru9CAAAABlBMVEXMzMzv7++Y3rQzAAAAE0lEQVQY02P4DwL2IIJhlDl0mADDfHCAiQlelgAAAABJRU5ErkJggg==';
//						}
		                this.setOption(option)
		            });
			}
			

          
		},
		// 关闭提示
		close() {
			this.tipShow = false;
		},
		// 是否为直辖市
		isCen(areaCode){
			let code = areaCode.slice(0,2);
			return code == '11' || code == '12' || code == '31' || code == '50';
		}
	}

};