Vue.component('my-table', {
    props: {
        //表格合并策略方法
        spanMethod: {
            type: Function,
            default: () => {}
        },
        tableHeight: {
            String,
            default: () => {
                // 获取页面高度
                const h = document.documentElement.clientHeight || document.body.clientHeight
                // 减去上方区域
                return h;
            }
        },
        //表格数据
        tableData: Array,
        //表格数据
        tableDate: Array,
        //表头配置
        tableColumn: Array,
        notDrillDown: {
            type: Array,
            default: () => {
                return {}
            }
        }
    },
    data() {
        return {
            tableData_copy: [],
            num: 0,
        }
    },
    // watch: {
    //     tableData:{
    //         handler(newValue,oldValue){
    //             this.num++
    //             if(this.num == 1){
    //                 this.tableData_copy=[...newValue]
    //                 // console.log(this.tableData_copy)
    //             }

    //         },
    //         immediate: false
    //     }

    // },

    methods: {
        // 换行时间
        // dealTime(val) {
        //     if (!val) return '--'
        //     const arr = val.split(' ')
        //     return arr.join('<br>')
        // },
        dealTime(str, n) {
            // alert(str,n)
            console.log('444444444444')
            var len = str.length; //获取字符的长度  
            var strTemp = '';
            if (len > n) { //如果字符的长度大于指定的长度  
                strTemp = str.substring(0, n); //那么截取指定长度的字符串  
                str = str.substring(n, len); //截取剩余的字符串  
                //在截取的指定长度的字符串添加<br />标签实现换行并返回  
                return strTemp + '<br />' + insertEnter(str, n);
            } else {
                return str;
            }
        },
        //表头下钻方法
        headDrillDown(col) {
            if (col.headDrillDown) {
                this.$emit('head-drill-down', col)
            }

        },
        //列下钻方法
        drillDown(col, row) {
            // console.log(col,row)
            if (col.isDrillDown) {
                this.$emit('drill-down', {
                    row,
                    key: col.key
                })
            }
        },
        //设置颜色
        setColor(key, row) {
            // console.log(key)
            if (this.notDrillDown[key]) {
                // console.log('aaa');
                if (this.notDrillDown[key].includes(row[key])) return ''
            }
            if (!this.notDrillDown[key]) {

                if (row[key] == '0') {
                    return ''
                }

            }
            return 'blue';

        },
        //设置增减颜色

        setColor2(key, row) {
            // console.log(parseInt(row[key]) < 0)

            if (row[key] < 0 && row[key] != '-') {
                return 'red'
            }
            if (parseFloat(row[key]) < 0 && row[key] != '-' ) {
                return 'red'
            }
            if (key.indexOf('rate') != -1 || key.indexOf('ring') != -1 || key == 'scoreDisparity' || key == 'rankDisparity' || key == 'chainRate' || key == 'dalayType' ) {
                if (row[key] > 0 && row[key] != '-') {
                    return 'green'
                }
            }
            if (key.indexOf('rate') != -1 || key.indexOf('ring') != -1 || key == 'scoreDisparity'  || key == 'rankDisparity' || key == 'chainRate' || key == 'dalayType'  || key == 'scoreDisparity' ) {
                if (parseFloat(row[key]) > 0 && row[key] != '-') {
                    return 'green'
                }
            }
            return ''

        },
        sortByData(column) {
            console.log(this.tableData)
            if (column instanceof Object) {
                let key = column.prop
                let orderBy = column.order
                let filterColumn = this.tableData.filter(e => e.enterprise == '行业' || e.enterprise == '全国')
                let newTableData = this.tableData.filter(e => e.enterprise != '行业' && e.enterprise != '全国')
                console.log('eeeeeeee0', newTableData)
                let arr_list = newTableData.filter(z => z[key] == '-')
                let arr_list1 = newTableData.filter(z => z[key] != '-')
                if (orderBy == 'ascending') {
                    // debugger
                    // let arr_list=this.tableData.filter( z=> z[key] =='-')
                    // let arr_list1=this.tableData.filter( z=> z[key] !='-')
                    arr_list1.sort((a, b) => {
                        return (Number(b[key]) - Number(a[key]))
                    })
                    this.tableData = [...filterColumn, ...arr_list1, ...arr_list]
                    console.log(this.tableData)
                } else if (orderBy == 'descending') {
                    arr_list1.sort((a, b) => {
                        return (Number(a[key]) - Number(b[key]))
                    })
                    this.tableData = [...filterColumn, ...arr_list1, ...arr_list]
                    //   this.tableData = arr_list1.concat(arr_list)
                } else {
                    this.tableData = this.tableDate
                }
            }
        }
    },
    template: `
        <el-table
                :data="tableData"
                :span-method="spanMethod"
                :highlight-current-row="false"
                border
                :header-cell-style="{background:'#0199FF',color:'#FFF', 'height': '30px', 'justify-content': 'center'}"
                :row-style="{height:'40px'}"
                :max-height="tableHeight"
                @sort-change='sortByData'
                style="margin-top: 10px;"
        >
            <el-table-column
                    v-for="column in tableColumn.filter(i => i.isShow !== false)"
                    :prop="column.key"
                    :align="column.align ? column.align : 'center'"
                    :width="column.width"
                    :fixed="column.fixed"
                    :sortable="column.isSort ? 'custom' : false"
            >
                <template slot="header" slot-scope="scope">
                    <span 
                        :style="{textDecoration: column.headDrillDown ? 'underline' : 'none'}"
                        @click="headDrillDown(column)"
                    >
                        <img src="./img/icon_column_setting.png" style="width: 15px; height: 11px; margin-right: 5px" alt="" v-if="column.key=='setting'"/>
                        {{column.label}}
                    </span>
                </template>
                <template slot-scope="scope">
                    <span v-if="column.isDrillDown" :style="{color: column.isDrillDown ? setColor(column.key, scope.row) : ''}" @click="drillDown(column, scope.row)">{{scope.row[column.key]}}</span>
                    <span v-else :style="{color: setColor2(column.key, scope.row) }">{{scope.row[column.key]}}</span>
                   
                </template>
               
               
                <el-table-column
                        v-if="column.multiseriate && col.isShow !== false"
                        v-for="col in column.columns"
                        :prop="col.key"
                        :sortable="col.isSort ? 'custom' : false"
                        align="center"
                >
                    <template slot="header" slot-scope="scope">
                         <div class="table-sort">
                            <span v-html="col.label" style="line-height:20px"
                                :style="{textDecoration: col.headDrillDown ? 'underline' : 'none'}"
                                @click="headDrillDown(col)">
                            </span>
                        </div>
                    </template>
                    <template slot-scope="scope">
                        <span v-if="col.isDrillDown" :style="{color: col.isDrillDown ? setColor(col.key, scope.row) : ''}" @click="drillDown(col, scope.row)">{{scope.row[column.key]}}</span>
                        <span v-else  :style="{color: setColor2(col.key, scope.row) }">{{scope.row[col.key]+'%'}}</span>
                    </template>
                    <el-table-column
                        v-if="col.multiseriate && col1.isShow !== false"
                        v-for="col1 in col.columns"
                        :prop="col1.key"
                        :width="col1.width"
                        :sortable="col1.isSort ? 'custom' : false"
                        align="center"
                    >
                        <template slot="header" slot-scope="scope">
                            <div class="table-sort">
                                <span v-html="col1.label" style="line-height:20px"></span>    
                            </div>
                        </template>                        
                        <template slot-scope="scope">
                            <span v-if="col1.isDrillDown" :style="{color: col1.isDrillDown ?  setColor(col.key, scope.row) : ''}" @click="drillDown(col1, scope.row)">{{scope.row[col1.key]}}</span>
                            <span v-else :style="{color: setColor2(col1.key, scope.row) }">{{scope.row[col1.key]}}</span>
                        </template>
                        <el-table-column
                            v-if="col1.multiseriate && col2.isShow !== false"
                            v-for="col2 in col1.columns"
                            :prop="col2.key"
                            :sortable="col2.isSort ? 'custom' : false"
                            align="center"
                        >
                            <template slot="header" slot-scope="scope">
                                <div class="table-sort">
                                    <span v-html="col2.label" style="line-height:20px"></span>    
                                </div>
                            </template>                            
                            <template slot-scope="scope">
                                <span v-if="col2.isDrillDown" :style="{color: col2.isDrillDown ? setColor(col2.key, scope.row) : ''}" @click="drillDown(col2, scope.row)">{{scope.row[col2.key]}}</span>
                                <span v-else :style="{color: setColor2(col2.key, scope.row) }">{{scope.row[col2.key]}}</span>
                            </template>
                            <el-table-column
                                v-if="col2.multiseriate && col3.isShow !== false"
                                v-for="col3 in col2.columns"
                                :prop="col3.key"
                                :sortable="col3.isSort ? 'custom' : false"
                                align="center"
                            >
                                <template slot="header" slot-scope="scope">
                                    <div class="table-sort">
                                        <span v-html="col3.label" style="line-height:20px"></span>    
                                    </div>
                                </template>                                
                                <template slot-scope="scope">
                                    <span v-if="col3.isDrillDown"  :style="{color: col3.isDrillDown ? setColor(col3.key, scope.row) : ''}" @click="drillDown(col3, scope.row)">{{scope.row[col3.key]}}</span>
                                    <span v-else :style="{color: setColor2(col3.key, scope.row) }">{{scope.row[col3.key]}}</span>
                                </template>
                            </el-table-column>
                        </el-table-column>
                    </el-table-column>
                </el-table-column>
            </el-table-column>
        </el-table>
    `
});


Vue.component('table-sort', {
    data() {
        return {
            sorttemp: null,
            sortobj: null,
            sortdata: null,
            list: [],
            list_copy: [],
            num: 0,
        }
    },
    watch: {
        //监听表头变化
        sourceList: {
            handler(newVal) {
                console.log('数据更新了');
                console.log(newVal);
                this.list = newVal.map((item, index) => {
                    let columns = null;
                    if (item.columns) {
                        columns = item.columns.map((a, b) => {
                            return {
                                id: index + '-' + b,
                                ...a,
                                isShow: a.isShow !== undefined ? a.isShow : true,
                                index: b
                            }
                        })
                    }
                    return {
                        ...item,
                        columns: columns,
                        id: index,
                        isShow: item.isShow !== undefined ? item.isShow : true,
                        index: index
                    }
                }).filter(a => (a.key != 'setting'));
                console.log(this.list);
                this.$nextTick(() => {
                    this.initTable()
                })

            },
            deep: true
        },
        sourceList1: {
            handler(newVal) {
                console.log('数据更新了2');
                console.log(newVal);
                this.list_copy = newVal.map((item, index) => {
                    let columns = null;
                    if (item.columns) {
                        columns = item.columns.map((a, b) => {
                            return {
                                id: index + '-' + b,
                                ...a,
                                isShow: a.isShow !== undefined ? a.isShow : true,
                                index: b
                            }
                        })
                    }
                    return {
                        ...item,
                        columns: columns,
                        id: index,
                        isShow: item.isShow !== undefined ? item.isShow : true,
                        index: index
                    }
                }).filter(a => (a.key != 'setting'));

            },
            deep: true
        }
    },
    props: {
        show: {
            type: Boolean,
            default: true
        },
        sourceList: {
            type: Array,
            default: () => []
        },
        sourceList1: {
            type: Array,
            default: () => []
        }
    },
    mounted() {
        // console.log(this.list)
        // this.list_copy=JSON.parse(JSON.stringify(this.list))
    },
    filters: {
        limitLen(val) {
            if (val.length > 27) {

                return val.substr(0, 27) + '...';
            } else if (val.indexOf('<br>') != -1) {

                return val.split('<br>').join('')
            } else {

                return val
            }
        }
    },
    methods: {
        //重置表头
        reSet() {
            console.log('555')
            console.log(this.list_copy)
            const arr = JSON.parse(JSON.stringify(this.list_copy));
            console.log(arr)
            // this.$nextTick(()=>{
            //     this.list=[...arr]
            //     // this.initTable()
            // })
            const test = () => {
                return Promise.resolve(
                    this.list = []
                )
            };
            try {
                test().then(() => {
                    this.list = arr
                    this.$nextTick(() => {
                        this.initTable()
                    })
                })
            } catch (e) {
                console.log(e);
            }
            // this.$emit('finished')
            // arr.forEach(a=>{
            //     a.isShow=true;
            //     if(a.columns){
            //         a.columns.forEach(b=>{
            //             b.isShow=true
            //         })
            //     }
            // })

        },
        //表头修改后的回调确认按钮
        finished() {
            const arr = JSON.parse(JSON.stringify(this.list));
            arr.forEach(item => {
                if (item.columns) {
                    item.columns.sort((a, b) => a.index - b.index)
                }
            })
            arr.sort((a, b) => a.index - b.index)
            console.log('5555555')
            this.$emit('finished', arr)
        },
        fatherChange(val) {
            console.log(val);
            if (val && val.columns) {
                val.columns.forEach(i => i.isShow = val.isShow)
            }
        },
        childChange(item) {

            console.log(item)
            let i = 0
            item.columns.forEach((a, b) => {
                if (a.isShow) {
                    item.isShow = true
                } else {
                    i++;
                    console.log(i)
                    if (i == item.columns.length) {
                        item.isShow = false
                    }
                }

            })
        },
        //初始化Sortable
        initTable() {
            // console.log();
            const _this = this;
            this.sortobj = new Sortable(_this.$refs.sortbox, {
                group: 'sortabledemo',
                animation: 150,
                ghostClass: 'blue-background-class-box',
                dataIdAttr: 'data-id',
                handle: '.dragbutton',
                filter: '.bg-red',
                direction: 'vertical',
                store: {
                    get: function (e) {
                        const order = _this.sortdata;
                        console.log(order)
                        return order ? order.split('|') : [];
                    },
                    set: function (e) {
                        const order = e.toArray();
                        console.log('调用了sortobj', order);
                        _this.list.forEach((el, i) => {
                            el.index = order.findIndex(a => a == el.id)
                        })
                    }
                },
                onUpdate: function (e) {

                }
            });
            console.log(this.$refs.smallbox);
            _this.list.forEach((ele, i) => {
                new Sortable(_this.$refs.smallbox[i], {
                    group: ele.id,
                    animation: 150,
                    ghostClass: 'blue-background-class',
                    dataIdAttr: 'data-id',
                    handle: '.dragbutton',
                    filter: '.bg-red',
                    direction: 'vertical',
                    scroll: false,
                    store: {
                        get: function (e) {
                            const order = _this.sortdata;

                            return order ? order.split(',') : [];
                        },
                        set: function (e) {
                            const order = e.toArray();

                            console.log(order)
                            console.log(_this.sorttemp)
                            _this.list.forEach((el, i) => {
                                if (el.id == _this.sorttemp) {
                                    _this.list[i].columns.forEach((item, num) => {
                                        item.index = order.indexOf(item.id)
                                    })
                                }
                            })
                            console.log(_this.list)
                            _this.sortdata = order.join('|');
                            console.log(_this.sortdata)
                            console.log(order)
                        }
                    },
                    onStart: function (e) {
                        _this.sorttemp = e.item.dataset.id.split("-")[0];
                    }
                })
            });
        },
    },
    template: `<div class="sort-table" :class="{'sort-table-begin': show, 'sort-table-end': !show}">
                    <div style="height: 10vh; padding: 0 10px; display: flex; align-items: center; width: 100%; justify-content: space-between">
                        <span>名称</span>
                        <div style="display: flex">
                            <span style="display: block; margin-right: 15px">显示/隐藏</span>   
                            <span>拖动排序</span>               
                        </div>
                    </div>
                    <div id="sortbox" ref="sortbox" class="sortbox" style="overflow: auto; height: 80vh; padding: 0 10px">
                        <div v-for="(item,index) in list"
                             :data-id="item.id" class="board-block">
                            <div style="display: flex; border-bottom: 1px solid #666666; align-items: center; justify-content: space-between; height: 50px">
                                {{item.label | limitLen}}
                                <div style="display: flex; height: 100%; align-items: center">
                                    <el-switch
                                        style="margin-right: 47px;"
                                        @change="fatherChange(item)"
                                      v-model="item.isShow"
                                      active-color="#13ce66"
                                      inactive-color="#ff4949">
                                    </el-switch>
                                    <span class="dragbutton" :style="{visibility: !item.fixed ? 'visible' : 'hidden'}"></span>
                                </div>
                            </div>
                            <div class="dragbox" ref="smallbox" v-show="item.columns" style="background-color: #F5F5F5">
                                <div v-for="(value,i) in item.columns"
                                      :data-id="value.id" style="display: flex; border-bottom: 1px solid #666666; align-items: center; justify-content: space-between; height: 50px">
                                    <span style="margin-left: 25px">{{value.label | limitLen}}</span>
                                    <div style="display: flex; height: 100%; align-items: center">
                                        <el-switch
                                            style="margin-right: 47px"
                                            @change="childChange(item)"
                                          v-model="value.isShow"
                                          active-color="#13ce66"
                                          inactive-color="#ff4949">
                                        </el-switch>
                                        <span class="dragbutton"></span>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="btns">
                        <button @click="reSet">重置</button>
                        <button @click="finished">完成</button>
                    </div>
                </div>`
})