//环节标准
Vue.component('linkStandard', {
    data() {
        return {}
    },
    props: {
        data: Object
    },
    methods: {},
    template: `<main-box :title="data.title" style="margin-bottom: 15px">
                    <slot></slot>
               </main-box>`
});

//环节标准--收寄频次维护情况
Vue.component('sjpcwhqk', {
    data() {
        return {
            objList: {

            },
            idName: "sjpc",
            requestParams: {}
        }
    },
    props: {
        data: Object,
        level: Number || String,
        code: Number || String,
    },
    methods: {
        chartinit() {
            console.log('11111');
            this.$refs.sjpc_whqk.chartinit(this.objList)
        },
        drillDown() {
            if (!this.objList.timeLimit || this.objList.timeLimit =='--') return;
            const params = {
                ...this.requestParams,
                barType: 'posting',
                barName: '收寄频次维护情况',
                code: this.code,
            };
            console.log(params);
            try {
                Emp.execute(`standardDrillDown('${JSON.stringify(params)}')`)
            } catch (e) {

            }
        }
    },
    created() {

    },
    mounted() {
        this.requestParams = {
            dataDate: dayjs().subtract(1, 'day').format('YYYYMMDD'),
            dateType: 'D',  // D：日（默认）W：周M：M
            sumFg: '1', // 1为数据总览2为数据下钻
            sumLevel: this.level,
            provCode: this.level == 2 ? this.code : '',
            cityCode: this.level == 3 ? this.code : '',
            countyCode: this.level == 4 ? this.code : '',
        };
        console.log('收寄频次', this.requestParams);
        dpkPostFrequencyInfoPc(this.requestParams).then(resp => {
            if (!resp.data) throw new Error('无数据');

            const data = resp.data[0];
            this.objList = {
                title: '符合机构数 ' + data.orgNum,
                theBestRate: data.allOptimalRate,
                theBestName: data.allOptimalName,
                theWorstRate: data.allWorstRate,
                theWorstName: data.allWorstName,
                targetRate: data.targetNum,
                timeLimit: data.postRate,
                timeLimitHb: data.orgRing,
                issure: true,
                jd2: data.targetNum * 1 / 100,
            }
            console.log(this.objList);
        }).catch(err => {
            console.log(err);
            this.objList = {
                title: '符合机构数',
                theBestRate: '--',
                theBestName: '--',
                theWorstRate: '--',
                theWorstName: '--',
                targetRate: '--',
                timeLimit: '--',
                timeLimitHb: '--',
                issure: true,
                jd2: 0
            }
        }).finally(() => {
            console.log(this.objList);
            this.$nextTick(() => {
                this.chartinit()
            })
        })
    },
    template: `<base-box :title="data.title" :is-show-bottom="false">
                       <gauge-board
                            ref="sjpc_whqk"
                            :idName="idName"
                            :list="objList"
                            @drilldown="drillDown"
                       />
                </base-box>
              `
});

//环节标准-----投递频次维护情况
Vue.component('tdpcwhqk', {
    data() {
        return {
            objList: {

            },
            idName: "tdpc",
            requestParams: {}
        }
    },
    props: {
        data: Object,
        level: Number || String,
        code: Number || String,
    },
    methods: {
        chartinit() {
            this.$refs.tdpc_whqk.chartinit(this.objList)
        },
        drillDown() {
            if (!this.objList.timeLimit || this.objList.timeLimit =='--') return;
            const params = {
                ...this.requestParams,
                barType: 'deliver',
                barName: '投递频次维护情况',
                code: this.code,
            };
            console.log(params);
            try {
                Emp.execute(`standardDrillDown('${JSON.stringify(params)}')`)
            } catch (e) {
            }
        }
    },
    created() {

    },
    mounted() {
        this.requestParams = {
            dataDate: dayjs().subtract(1,'day').format('YYYYMMDD'),
            dateType: 'D',  // D：日（默认）W：周M：M
            sumFg: '1', // 1为数据总览2为数据下钻
            sumLevel: this.level,
            provCode: this.level == 2 ? this.code : '',
            cityCode: this.level == 3 ? this.code : '',
            countyCode: this.level == 4 ? this.code : '',
        };
        console.log('投递频次', this.requestParams);
        dpkDevFrequencyInfoPc(this.requestParams).then(resp => {
            console.log(resp);
            if (!resp.data) throw new Error('无数据')
            const data = resp.data[0];
            this.objList = {
                title: '符合机构数 ' + data.orgNum,
                theBestRate: data.allOptimalRate,
                theBestName: data.allOptimalName,
                theWorstRate: data.allWorstRate,
                theWorstName: data.allWorstName,
                targetRate: data.targetNum,
                timeLimit: data.devRate,
                timeLimitHb: data.devRing,
                issure: true,
                jd2: data.targetNum * 1 / 100
            }
        }).catch(err => {
            console.log(err);
            this.objList = {
                title: '符合机构数',
                theBestRate: '--',
                theBestName: '--',
                theWorstRate: '--',
                theWorstName: '--',
                targetRate: '--',
                timeLimit: '--',
                timeLimitHb: '--',
                issure: true,
                jd2: 0
            }
        }).finally(() => {
            this.chartinit()
        });
    },
    template: `<base-box 
                :title="data.title" 
                :is-show-bottom="false">
                       <gauge-board
                            ref="tdpc_whqk"
                            :idName="idName"
                            :list="objList"
                            @drilldown="drillDown"
                       />
                </base-box>
              `
});
//环节标准---运输频次标准情况
Vue.component('yspcbzqk', {
    data() {
        return {
            objList: {
                title: '符合机构数 --',
                thebestnum: '--',
                thebest_city: '--',
                theworstnum: '--',
                theworst_city: '--',
                aimnum: '--',
                relaitynum: '--',
                huanbi: '--',
                issure: true,
                jd2: 0
            },
            idName: "yspc",
            drillLeft: [
                {
                    value: 0,
                    name: '市趟'
                },
                {
                    value: 1,
                    name: '市场'
                },
            ],
            defalutLeftLabel: '市趟',
            drillRight: [
                {
                    value: 0,
                    name: '上行维护达标率'
                },
                {
                    value: 1,
                    name: '下行维护达标率'
                },
            ],
            defalutRightLabel: '上行维护达标率',
            styTitle: {
                width: '100px',
                minHeight: '40px',
                lineHeight: '20px'
            },
        }
    },
    props: {
        data: Object
    },
    methods: {
        chartinit() {
            this.$refs.yspc_bzqk.chartinit(this.objList)
        },
        getRightVal(val) {
            const arr = ['上行维护达标率', '下行维护达标率']
            this.defalutRightLabel = arr[Number(val)]
        },
        getLeftVal(val) {
            const arr = ['市趟', '市场']
            this.defalutLeftLabel = arr[Number(val)]
        },
        drillDown() {
            console.log(789)
        }
    },
    mounted() {
        this.chartinit()
    },
    template: `<drill-box
                
                :title="data.title" 
                :is-show-right="true"
                :is-show-left="true"
                :drill-right="drillRight"
                :drill-left="drillLeft"
                :defalut-right-label="defalutRightLabel"
                :defalut-left-label="defalutLeftLabel"
                @getrightval="getRightVal"
                @getleftval="getLeftVal"
                back-color="#ffffff"
                :titleSty="styTitle"
                :is-one-title="false"
                >
                <div style="width:100%; border-bottom:1px solid #e6e6e6"></div>
                       <gauge-board
                           
                            ref="yspc_bzqk"
                            :idName="idName"
                            :list="objList"
                            @drilldown="drillDown"
                       />
                </drill-box>
              `
});
//线路标准
Vue.component('lineStandard', {
    data() {
        return {}
    },
    props: {
        data: Object
    },
    methods: {},
    template: `<main-box :title="data.title" style="margin-bottom: 15px">
                    <slot></slot>
               </main-box>`
});
//线路标准--计划编制完成情况
Vue.component('jhbzwcqk', {
    data() {
        return {
            drillRight: [
                {
                    value: 1,
                    name: '省际进口'
                },
                {
                    value: 2,
                    name: '省际出口'
                },
                {
                    value: 3,
                    name: '省内互寄'
                }
            ],
            defalutRightLabel: '省际进口',
            dataList: [
                {
                    name: '应串联局对数',
                    value: '30000',
                    isStrong: true,
                    isGray: true,
                },
                {
                    name: '未串联局对数',
                    value: '5000',
                    isStrong: true,
                    isGray: true,
                },
            ],
            requestParams: {}
        }
    },
    methods: {
        //接口调用
        getData() {
            this.requestParams = {
                distCode: this.code,
                dataDate: dayjs().subtract(1, 'day').format('YYYYMMDD'), //20200909
                countRange: '', //1-省际进口2-省际出口3-省内互寄
                sumLevel: this.level,
                sumFg: '1' // 1-汇总2-下钻
            };
            console.log('线路标准', this.requestParams);
            queryPlanningIntegrity(this.requestParams).then(resp => {
                console.log(resp);
                if (!resp.data) throw new Error('无数据');
                const countRange = this.drillRight.find(item => item.name === this.defalutRightLabel).value;
                const data = resp.data.find(item => item.countRange == countRange);
                this.dataList[0].value = data ? data.seriesYes : '--';
                this.dataList[1].value = data ? data.seriesNo : '--';
            }).catch(err => {
                console.log(err);
                this.dataList[0].value = '--';
                this.dataList[1].value = '--';
            })
        },
        //下钻
        drillDown(index) {
            console.log('下钻');
            if (this.dataList[0].value == '--' && this.dataList[1].value=='--') return
            const params = {
                ...this.requestParams,
                countRange: this.drillRight.find(item => item.name === this.defalutRightLabel).value,
                barName: '计划编制完成情况' + '-' + this.defalutRightLabel,
                barType: 'planIntegrity',
                code: this.code,
            };
            console.log(params);
            try {
                Emp.execute(`standardDrillDown('${JSON.stringify(params)}')`)
            } catch (e) {

            }
        },
        getRightVal(val) {
            const arr = this.drillRight.map(item => item.name);
            this.defalutRightLabel = arr[Number(val) - 1];
            this.getData()
        },

    },
    created() {
        this.getData()
    },
    mounted() {

    },
    props: {
        data: Object,
        level: Number || String,
        code: Number || String,
    },
    template: `
                <drill-box 
                    :title="data.title" 
                    :is-show-right="true"
                    :drill-right="drillRight"
                    :defalut-right-label="defalutRightLabel"
                    @getrightval="getRightVal"
                >
                    <base-box 
                        is-show-title="false"
                        :list="dataList" 
                        @drilldown="drillDown"
                    />
                </drill-box>`
});
//线路标准-计划N日递率

Vue.component('jhnrdl', {
    data() {
        return {
            drillRight: [
                {
                    value: 0,
                    name: '特快'
                },
                {
                    value: 1,
                    name: '快包'
                },
            ],
            defalutRightLabel: '特快',
            contains: {
                height: '100px',
                width: '70%',
                'max-width': '150px'
            }
        }
    },
    props: {
        data: Object
    },
    methods: {
        getRightVal(val) {
            const arr = ['特快', '快包']
            this.defalutRightLabel = arr[Number(val)]
        },
        initLiquid() {
            this.$refs.jhnrdl_0.initLiquid(0, '#1D95F4')
            this.$refs.jhnrdl_1.initLiquid(0, '#4CD997')
            this.$refs.jhnrdl_2.initLiquid(0, '#F19147')
            this.$refs.jhnrdl_3.initLiquid(0, '#006BBD')
            this.$refs.jhnrdl_4.initLiquid(0, '#00A546')
        },
        drillDownCcl() {
            console.log('差错率');
        },
        drillDownSrl() {
            console.log('收容率');
        }
    },
    mounted() {
        this.initLiquid()
    },
    template: `<drill-box 
                :title="data.title" 
                :is-show-right="true"
                :drill-right="drillRight"
                :defalut-right-label="defalutRightLabel"
                @getrightval="getRightVal"
               >
                    <div style="display: flex;">
                        <div style="width: 100%;">
                            <div style=" text-align: center"><p>T+0</p></div>
                            <liquid-box 
                                ref="jhnrdl_0"
                                :id-name="'jhnrdl_0'"
                            ></liquid-box>
                        </div>
                        <div style="width: 100%;">
                            <div style="text-align: center; "><p>T+1</p></div>
                            <liquid-box 
                                ref="jhnrdl_1"
                                :id-name="'jhnrdl_1'"
                            ></liquid-box>
                        </div>
                        <div style="width: 100%;">
                            <div style="text-align: center; "><p>T+2</p></div>
                            <liquid-box 
                                ref="jhnrdl_2"
                                :id-name="'jhnrdl_2'"
                            ></liquid-box>
                        </div>
                    </div>
                    <div style="display: flex;">
                        <div style="width: 100%;">
                            <div style=" text-align: center"><p>T+3</p></div>
                            <liquid-box 
                                :contains="contains"
                                ref="jhnrdl_3"
                                :id-name="'jhnrdl_3'"
                            ></liquid-box>
                        </div>
                        <div style="width: 100%;">
                            <div style="text-align: center; "><p>T+4</p></div>
                            <liquid-box 
                                :contains="contains"
                                ref="jhnrdl_4"
                                :id-name="'jhnrdl_4'"
                            ></liquid-box>
                        </div>
                    </div>
               </drill-box>`
});
