
// 水球图
function initLiquid(id, data, color) {
	var chart = new G2.Chart({
	    container: id,
	    forceFit: true,
	    height: 100,
	    padding: 0
	});
	chart.source(data, {
	    value: {
	        min: 0,
	        max: 100
	    }
	});
	chart.legend(false);
	chart.axis(false);  //轴线
	chart.interval().position('gender*value').color(color)
	    .shape('liquid-fill-gauge').style({
	    lineWidth: 2,
	    opacity: .5
	});

	data.forEach(function(row) {
	    chart.tooltip(false);
	    chart.guide().text({
	        top: true,
	        position: {
	            gender: row.gender,
	            value: 50
	        },
	        content: row.value + '%',
	        style: {
	            opacity: 0.9,
	            fontSize: '17',
	            textAlign: 'center',
	            fill: row.value >= 60 ? '#FFF' : '#000'
	        }
	    });
	});
	
	chart.render();
}
//水球图2
function initLiquid_2(id, data, color) {
	var chart = new G2.Chart({
	    container: id,
	    forceFit: true,
	    height: 100,
	    padding: 0
	});
	chart.source(data, {
	    value: {
	        min: 0,
	        max: 100
	    }
	});
	chart.legend(false);
	chart.axis(false);
	chart.interval().position('gender*value').color(color)
	    .shape('liquid-fill-gauge').style({
	    lineWidth: 6,
	    opacity: 0.5
	});
	
	console.log(data);
	
	data.forEach(function(row) {
	    chart.tooltip(false);
	    chart.guide().text({
	        top: true,
	        position: {
	            gender: row.gender,
	            value: 50
	        },
	        content: row.value + '%',
	        style: {
	            opacity: 0.75,
	            fontSize: '17',
	            textAlign: 'center',
	            fill: row.value >= 60 ? '#FFF' : '#000'
	        }
	    });
	});
	
	chart.render();
}
//折线图
function initLine(id, legend, xData, series) {
	var mychart2 = echarts.init(document.getElementById(id))
	var option2 = {
		tooltip: {
			trigger: 'axis',
			axisPointer: {
				type: 'shadow'
			}
		},
		legend: {
			data: legend,
			bottom: 10,
			itemGap: 20,
			textStyle: {
				fontSize: 15
			}
		},
		grid: {
			top: '13%',
			left: '4%',
			right: '4%',
			bottom: '18%',
			containLabel: true
		},
		xAxis: [{
			type: 'category',
			data: xData,
			'axisLine': {
				lineStyle: {
					color: '#90979c',

				}
			},

			'splitLine': {
				'show': false
			},
			'axisTick': {
				'show': true
			},
			'splitArea': {
				'show': false
			},
			'axisLabel': {
				'interval': 0,
				'fontSize': 12,
				'fontWeight': 'bold',
				'color': "#000000"
			}
		}],
		yAxis: [{
			name: '/万件',
			type: 'value',
			nameTextStyle: {
				fontSize: 15
			},
			axisLine: {
				show: false
			},
			'axisTick': {
				'show': false
			},
			axisLabel: {
				margin: -5,
				formatter: function(value, index) {
					if (value >= 10000 && value < 10000000) {
						value = value / 10000 + '万'
					} else if (value >= 10000000) {
						value = value / 10000000 + '千万'
					}
					return value
				}
			}
		}],

		series: series
	}

	mychart2.setOption(option2)
}
//千位分隔符
function toThousands(num) {
	return (num || 0).toString().replace(/(\d)(?=(?:\d{3})+$)/g, '$1,');
}
