Vue.component('cllxq',{
    data:function(){
        return {
            title:'处理量详情'
        }
    },
    
    mounted:function(){
        // 地图
        this.makeCllxqMap()
    },
    methods:{
        // 处理量详情-地图
        makeCllxqMap() {
            var randomValue = function() {
                return Math.round(Math.random()*100);
            }
            var cllxq_data_list = [
            {name:"南海诸岛",value:0},
            {name: '北京', value: randomValue()},
            {name: '天津', value: randomValue()},
            {name: '上海', value: randomValue()},
            {name: '重庆', value: randomValue()},
            {name: '河北', value: randomValue()},
            {name: '河南', value: randomValue()},
            {name: '云南', value: randomValue()},
            {name: '辽宁', value: randomValue()},
            {name: '黑龙江', value: randomValue()},
            {name: '湖南', value: randomValue()},
            {name: '安徽', value: randomValue()},
            {name: '山东', value: randomValue()},
            {name: '新疆', value: randomValue()},
            {name: '江苏', value: randomValue()},
            {name: '浙江', value: randomValue()},
            {name: '江西', value: randomValue()},
            {name: '湖北', value: randomValue()},
            {name: '广西', value: randomValue()},
            {name: '甘肃', value: randomValue()},
            {name: '山西', value: randomValue()},
            {name: '内蒙古', value: randomValue()},
            {name: '陕西', value: randomValue()},
            {name: '吉林', value: randomValue()},
            {name: '福建', value: randomValue()},
            {name: '贵州', value: randomValue()},
            {name: '广东', value: randomValue()},
            {name: '青海', value: randomValue()},
            {name: '西藏', value: randomValue()},
            {name: '四川', value: randomValue()},
            {name: '宁夏', value: randomValue()},
            {name: '海南', value: randomValue()},
            {name: '台湾', value: randomValue()},
            {name: '香港', value: randomValue()},
            {name: '澳门', value: randomValue()}
        ]
            var cllxqChartMap = echarts.init(document.getElementById('cclxq-map'));
            // 指定图表的配置项和数据
            var option = {
                tooltip: {
                    trigger: 'item'
                },
                series: [{
                    name:'处理量',
                    type: 'map',
                    map:'china',
                    geoIndex: 0,
                    data:cllxq_data_list
                }],
                // 视觉映射组件
                visualMap: {
                    
                    type: 'piecewise', // 类型为分段型。
                    splitNumber : '4', // 段数
                    align:'top',
                    pieces: [
                        { min:0, max:10, label: '≤10万', color: '#71C1FF',align:'left'},
                        { min:10, max:30,  label: '10-30万', color: '#38A0FF',align:'right'},
                        { min:30, max:60, label: '30-60万', color: '#1180EC',align:'top'},
                        { min:60, label: '≥60万', color: '#0153B7',align:'left'},
                    ],
                    itemWidth: '15%',
                    itemHeight: '10',
                    orient: 'vertical', // 水平（'horizontal'）或者竖直（'vertical'）
                    bottom: '10',
                    left:'10',
                    selectedMode:'multiple', // 'multiple'（多选）,'single'（单选）
                    inRange: {
                        color: ['#121122', 'rgba(3,4,5,0.4)', 'red'],
                        symbolSize: [30, 100]
                    }
                },
               
            };

            // 使用刚指定的配置项和数据显示图表。
            cllxqChartMap.setOption(option);
        }
    },
  
    template: `   
<div class="sortbox">
    <div class="module-title is-b">
        处理量详情
    </div>
    <div class="module-content">
       <div id="cclxq-map" class="content-charts"></div>
       <div class="content-data">
            <!-- 第一行 -->
           <div class="content-data-1">
               <div class="sszl-l fl is-b">
                   <div class="color-blue">实时总量</div>
                   <div class="color-red">1,000,000</div>
               </div>
               <div class="sszl-r fl">
                   <ul class="content-data-items">
                       <li>
                           <div>同比</div>
                           <div class="is-up">4,567</div>
                       </li>
                       <li>
                            <div>同比率</div>
                            <div class="is-down">15%</div>
                        </li>
                       <li>
                           <div>昨日通期量</div>
                           <div class="is-b">900,000</div>
                       </li>
                       <li>
                            <div>昨日通期量</div>
                            <div class="is-b">900,000</div>
                       </li>
                   </ul>
               </div>
            </div>
            <!-- 第二行 -->
           <div class="content-data-2">
               <div class="content-data-2-item" style="border-right: 1px solid #deebf4;">
                   <ul class="content-data-items">
                       <li style="border-right: none;">
                            <div class="color-blue is-b">散件外走量</div>
                            <div class="color-red is-b">500,00</div>
                        </li>
                        <li>
                            <div class="is-up">4,567</div>
                            <div class="is-up">15%</div>
                        </li>
                        <li>
                            <div>昨日同期量</div>
                            <div class="is-b">900,000</div>
                        </li>
                        <li>
                            <div>昨日总量</div>
                            <div class="is-b">900,000</div>
                        </li>
                    </ul>
                </div>
                <div class="content-data-2-item">
                    <ul class="content-data-items">
                        <li style="border-right: none;">
                            <div class="color-blue is-b">散件外走量</div>
                            <div class="color-green is-b">4,567</div>
                         </li>
                         <li>
                            <div class="is-down">15%</div>
                            <div class="is-down">15%</div>
                         </li>
                         <li>
                             <div>昨日通期量</div>
                             <div class="is-b">900,000</div>
                         </li>
                         <li>
                             <div>昨日通期量</div>
                             <div class="is-b">900,000</div>
                         </li>
                     </ul>
                 </div>
           </div>
            <!-- 第三行 -->
            <div class="content-data-2">
                <div class="content-data-2-item" style="border-right: 1px solid #deebf4;">
                    <ul class="content-data-items">
                        <li style="border-right: none;">
                             <div class="color-blue is-b">总包经转量</div>
                             <div class="color-red is-b">6500,00</div>
                         </li>
                         <li>
                             <div class="is-up">4,567</div>
                             <div class="is-up">15%</div>
                         </li>
                         <li>
                             <div>昨日同期量</div>
                             <div class="is-b">900,000</div>
                         </li>
                         <li>
                             <div>昨日总量</div>
                             <div class="is-b">900,000</div>
                         </li>
                     </ul>
                 </div>
                 <div class="content-data-2-item">
                     <ul class="content-data-items">
                         <li style="border-right: none;">
                             <div class="color-blue is-b">人工填报量</div>
                             <div class="color-green is-b">100,000</div>
                          </li>
                          <li>
                             <div class="is-down">1,463</div>
                             <div class="is-down">15%</div>
                          </li>
                          <li>
                              <div>昨日通期量</div>
                              <div class="is-b">900,000</div>
                          </li>
                          <li>
                              <div>昨日总量</div>
                              <div class="is-b">900,000</div>
                          </li>
                      </ul>
                  </div>
            </div>
       </div>
    </div>
</div>
`

})
