/**
 * 分类菜单-右侧页面-默认
 * @author qs
 * @time 20201201
 */
Vue.component('category-right-default',{
  data() {
    return {}
  },
  props:{
    // 选中菜单节点数据
    menuCheckedData: {
      type: Object,
      default: () => {
         return {}
      }
    },
    // 列数
    columnNum: Number,
    // 图标大小
    iconSize: Number
  },
  created(){

  },
  mounted() {

  },
  methods: {
    // 右侧菜单点击事件
    clickMenu(value) {
      this.$emit('menu-jump',value, 2)
    }
  },
  template: `<div>
  <van-grid 
    :column-num="columnNum"
    :icon-size="iconSize"
    center
    :border="false"
  >
    <van-grid-item 
      v-for="value in menuCheckedData.child"
      :key="value.modularNumber"
      :icon="value.modular_icon"
      :text="value.modularName"
	  :gutter="10"
      @click="clickMenu(value)"
    >
			<span slot="text" style="margin-top:8px;font-size:12px;">{{value.modularName}}</span>
		</van-grid-item>
	
  </van-grid>
   
  </div>`
})



/**
 * 分类菜单-右侧页面3-常用
 * @author qs
 * @time 20210520
 */
Vue.component('category-right-commonly-used',{
  data() {
    return {
      title: ''
    }
  },
  props:{
  
  },
  created(){

  },
  mounted() {

  },
  methods: {

  },
  template: `<div>
	<slot></slot>
</div>`
})


/**
 * 分类菜单-右侧页面-自定义
 * @author qs
 * @time 20201201
 */
Vue.component('category-right-page2',{
  data() {
    return {
      title: '123'
    }
  },
  props:{
    menuCheckedData: {
      type: Object,
      default: () => {
         return {}
      }
    }
  },
  created(){

  },
  mounted() {

  },
  methods: {

  },
  template: `<div>
    我是 - {{menuCheckedData.modularName}} - 菜单
    <br>
    <br>
    这是内容内容内容内容内容内容内容内容内容内容内容内容
    内容内容内容内容内容内容内容内容内容内容内容内容
    内容内容内容内容内容内容内容  
  </div>`
})


//服务库-对标分析
Vue.component('category-right-page1',{
  data() {
    return {}
  },
  props:{
    // 选中菜单节点数据
    menuCheckedData: {
      type: Object,
      default: () => {
         return {}
      }
    },
    // 列数
    columnNum: Number,
    // 图标大小
    iconSize: Number
  },
  created(){
    console.log('this is created')
  },
  mounted() {
    console.log('this is mounted')
    console.log(this.menuCheckedData)
  },
  methods: {
    // 右侧菜单点击事件
    clickMenu(value) {
      console.log(value)
      this.$emit('menu-jump',value, 2)
    }
  },
  template: `<div>
  <van-grid 
    :column-num="columnNum"
    :icon-size="iconSize"
    center
    :border="false"
  >
    <van-grid-item 
      v-for="value in menuCheckedData.child"
      :key="value.modularNumber"
      :icon="value.modular_icon"
      :text="value.modularName"
			:gutter="10"
      @click="clickMenu(value)"
    >
			<span slot="text" style="margin-top:8px;font-size:12px;">{{value.modularName}}</span>
		</van-grid-item>
	
  </van-grid>
   
  </div>`
})

