function init_g2_sbt(id,data,color) {
  var chart = new G2.Chart({
      container: id,
      forceFit: true,
      height: 100,
      padding: 0
  });
  chart.source(data, {
      value: {
          min: 0,
          max: 100
      }
  });
  chart.legend(false);
  chart.axis(false);
  chart.interval().position('gender*value').color(color)
      .shape('liquid-fill-gauge').style({
      lineWidth: 2,
      opacity: .5
  });


  data.forEach(function(row) {
      chart.tooltip(false);
      chart.guide().text({
          top: true,
          position: {
              gender: row.gender,
              value: 50
          },
          content: row.value ? row.value + '%' : '--',
          style: {
              opacity: 0.9,
              fontSize: '17',
              textAlign: 'center',
              fill: row.value >= 60 ? '#FFF' : '#000'
          }
      });
  });
  chart.render();
}
/*
* data数据集
* name当前省市区名称
* splitList分隔区间
* mapType地图渲染的地区
* mapJson地区的json数据集, 全国时不传
* */
function initEcharts(id,data,name,splitList,mapType,mapJson = '') {
  var option = {
      tooltip: {
          textStyle: {color: "#fff"}, //提示标签字体颜色
          formatter: function (value) {
              const val = value.data.value
              return val === 0 ? `${value.seriesName}<br/>${value.data.name}: -` :
                  `${value.seriesName}<br/>${value.data.name}: ${val}`
          }
      },
      visualMap: {
          show: false,
          splitList: splitList,
          bottom: 25,
          left: 'center',
          itemWidth: 50,
          color: ['#0153B7','#1180EC','#38A0FF','#71C1FF'],
          formatter: function(value){ //标签的格式化工具。
              return ''; // 范围标签显示内容。
          },
          align: 'right',
          orient: 'horizontal',
      },
      series: [
          {
              name: name,
              type: 'map',
              mapType: mapType,
              label: {
                  normal: {
                      show: false,//显示省份标签
                  },
                  emphasis: {
                      show: false,//对应的鼠标悬浮效果
                  }
              },
              emphasis: {
                  show: false,
                  //选择区域显示颜色
                  itemStyle: {
                      areaColor: '#fff100'
                  }
              },
              itemStyle: {
                  normal: {
                      borderColor:'#e6e6e6',
                      label: {
                          show: false
                      }
                  },
              },
              top: 10,
              data: data
          }
      ],

  };

  mapJson !== '' ? echarts.registerMap(mapType, mapJson) : '';
  let mychart2 = echarts.init(document.getElementById(id));
  mychart2.setOption(option)
}


function initZheXian(id, legend, xData, series, legendSet = [5,10]) {
    // console.log('ftrvgtrvg',start)
  let mychart2 = echarts.init(document.getElementById(id))
  let option2 = {
      tooltip: {
          trigger: 'axis',
          axisPointer: {
              type: 'line'
          }
      },
      legend: {
          data: legend,
          bottom: legendSet[0],
          itemGap: legendSet[1],
          width: 240
      },
      grid: {
          top: '13%',
          left: '3%',
          right: '4%',
          bottom: '20%',
          containLabel: true
      },
      xAxis: [
          {
              type: 'category',
              data: xData,
              'axisLine': {
                  lineStyle: {
                      color: '#90979c'
                  }
              },
              'splitLine': {
                  'show': false
              },
              'axisTick': {
                  'show': true
              },
              'splitArea': {
                  'show': false
              },
              'axisLabel': {
                  'interval': 0,
                  'rotate': 40
              }
          }
      ],
      yAxis: [
          {
              name: '',
              type: 'value',
              //name: '及时数',
              axisLine: {show: false},
              'axisTick': {
                  'show': false
              },

              axisLabel: {
                  margin: 2,
                  formatter: function (value, index) {
                      if (value >= 10000 && value < 100000000) {
                          value = value / 10000 + '万'
                      } else if (value >= 100000000) {
                          value = value / 100000000 + '亿'
                      }
                      return value
                  }
              }
          }
      ],
      'dataZoom': [{
          'show': true,
          'height': 20,
          bottom: 5,
        //   startValue: 0,
        //   endValue: xData.length > 5 ? 6 : xData.length - 1,
        startValue:splitfun(series[0].data) -5,
            endValue:splitfun(series[0].data),
        //   start:start,
        //   end:end,
          maxValueSpan: 6,
          mixValueSpan: 6,
          handleStyle: {   //滚动条样式
              color: '#d3dee5'
          },
          textStyle: {   //文本提示样式
              color: '#1D95F4'
          },
          borderColor: '#90979c'
      }],
      series: series
  }
  // console.log(22)
  mychart2.setOption(option2)
}
function splitfun(){
	var h = dayjs().get('hour')
	if(h<=5){
		return 5
	}else{
		return h+1
	}
}
function initZheXianTwo(id, legend, xData, series, legendSet = [5,10]) {
    console.log(series, 'serooossssssss')
    let mychart2 = echarts.init(document.getElementById(id))
    let option2 = {
        tooltip: {
            trigger: 'axis',
            axisPointer: {
                type: 'line'
            },
            confine: true,
        },
        legend: {
            data: legend,
            bottom: legendSet[0],
            itemGap: legendSet[1],
            width: 240
        },
        grid: {
            top: '13%',
            left: '3%',
            right: '4%',
            bottom: '20%',
            containLabel: true
        },
        xAxis: [
            {
                type: 'category',
                data: xData,
                'axisLine': {
                    lineStyle: {
                        color: '#90979c'
                    }
                },
                'splitLine': {
                    'show': false
                },
                'axisTick': {
                    'show': true
                },
                'splitArea': {
                    'show': false
                },
                'axisLabel': {
                    'interval': 0,
                    'rotate': 40
                }
            }
        ],
        yAxis: [
            {
                name: '',
                type: 'value',
                //name: '及时数',
                axisLine: {show: false},
                'axisTick': {
                    'show': false
                },
  
                axisLabel: {
                    margin: 2,
                    formatter: function (value, index) {
                        if (value >= 10000 && value < 100000000) {
                            value = value / 10000 + '万'
                        } else if (value >= 100000000) {
                            value = value / 100000000 + '亿'
                        }
                        return value
                    }
                }
            }
        ],
        'dataZoom': [{
            'show': true,
            'height': 20,
            bottom: 5,
            // startValue: 0,
            // endValue: xData.length > 5 ? 6 : xData.length - 1,
            startValue: xData.length > 7 ? xData.length - 7 : 0,
                endValue: xData.length - 1,
            // start:start,
            // end:end,
            maxValueSpan: 6,
            mixValueSpan: 6,
            handleStyle: {   //滚动条样式
                color: '#d3dee5'
            },
            textStyle: {   //文本提示样式
                color: '#1D95F4'
            },
            borderColor: '#90979c'
        }],
        series: series
    }
    // console.log(22)
    mychart2.clear()
    mychart2.setOption(option2)
  }