/**
 * 车辆接发
 * 
 * @author 蔡老师
 * @time 2020.04.13
 */

Vue.component('cljf', {
	data() {
		return {
			module_name: '标题',
			waitNum: '0',
			overTwen: '0',
			sentNum: '0',
			noEntryNum: 0,
			xzqh: '',
			selectType: 4
		}
	},
	filters: {
		// 过滤字符串,每3字符加,
		addSpot(source) {
			if (source.length < 4) return source;
			let arr = [...source];
			let len = arr.length / 3;
			let newArr = [];
			for (let i = 0; i < len; i++) {
				let start = arr.length - 3 * (i + 1)
				let b = []
				if (start < 0) b = arr.slice(0, arr.length % 3);
				else b = arr.slice(start, arr.length - 3 * i);
				newArr.push(b.join(''));
			}
			return newArr.reverse().join(',');
		}
	},
	
	template: `<div>
	        <div class="title" style="position: relative;">
	            {{ module_name }}
	        </div> 
	        <div class="showbox"
		        style=" display: flex; justify-content: space-between;  border: 1px solid #e6e6e6;border-radius: 0 0 10px 10px">
		        <div class="box-total-times" style="height: 60px; border-right: 1px dashed #e6e6e6; font-size: 12px; font-weight: normal" @click="cljfClick(4)">
		            <p style="line-height: 25px;font-size: 13px; font-weight: 700;">入围栏未入局</p>
		            <p style="line-height: 35px; color: #019FE8; font-weight: bold; font-size: 16px">
		                {{ noEntryNum }}</p>
		        </div>
				<div class="box-total-times" style="height: 60px; font-size: 12px; font-weight: normal" @click="cljfClick(5)">
		            <p style="line-height: 25px;font-size: 13px; font-weight: 700;">入局待卸数量</p>
		            <p style="line-height: 35px; color: #019FE8; font-weight: bold; font-size: 16px">
		                {{ waitNum | addSpot}}</p>
		        </div>
		        <div class="box-total-times"  @click="cljfClick(2)"
		            style="height: 60px; border-left: 1px dashed #e6e6e6; border-right: 1px dashed #e6e6e6; font-size: 12px; font-weight: normal">
		            <p style="line-height: 25px;font-size: 13px; font-weight: 700;">已卸数量</p>
		            <p style="line-height: 35px; color: #019FE8; font-weight: bold; font-size: 16px">
		                {{ overTwen | addSpot}}</p>
		        </div>
		        <div class="box-total-times" style="height: 60px;font-size: 12px; font-weight: normal"  @click="cljfClick(3)">
		            <p style="line-height: 25px;font-size: 13px; font-weight: 700;">已发数量</p>
		            <p style="line-height: 35px; color: #019FE8; font-weight: bold; font-size: 16px">
		                {{ sentNum | addSpot}}</p>
		        </div>
		    </div>
	    </div>`,
	methods: {
		querydata: function (msgbody, timestamp) {
			var interface1 = axios.create({
				'Access-Control-Allow-Origin': '*',
				baseURL: board_url,
				timeout: 10000
			});
			interface1.get('dpk/carReceiveDispatchStatisticsPc', {
				params: {
					'sendID': '00000001',
					'timestamp': timestamp,
					'msgBody': msgbody,
					'dataDigest': base64.encode(hex_md5(msgbody + data_key + timestamp))
				}
			}).then(({ data }) => {
				// console.log(data,'车辆接发监控');
				if (JSON.stringify(data) == "{}") {
					this.waitNum = '0';
					this.overTwen = '0';
					this.sentNum = '0';
					this.noEntryNum = '0'
				} else {
					if (data.data[0].unseal == null && data.data[0].sealed == null && data.data[0].depart == null) {
						this.waitNum = '0';
						this.overTwen = '0';
						this.sentNum = '0';
						this.noEntryNum = '0'
					} else {
						this.noEntryNum = String(data.data[0].inFence)
						this.waitNum = String(data.data[0].unsealNum);
						this.overTwen = String(data.data[0].sealed);
						this.sentNum = String(data.data[0].depart);
					}
				}
			}).catch(error => {
				console.log(error + "----车辆调用接口失败");
			})
		},
		initDataCljf(data) {
			for (let key in data) {
				this[key] = data[key]
			}
			const timestamp = dayjs().format('YYYY-MM-DD HH:mm:ss')
			let params = {
				distCode: this.xzqh,
				orgCode: '',
				sumLevel: this.level === '1' || this.level === '2' ? '1' : (Number(this.level) - 1).toString(),
				sumFg: '1',
				dataDate: dayjs().format('YYYY-MM-DD'),
				provCode: '',
				cityCode: '',
				queryType: '',     //  当汇总标识【sumFg】为【2-下钻】时，必填 1-省份 2-地市 3-处理中心（默认）
				queryIndex: this.selectType     // 1-待卸（取消） 2-已卸 3-已发 4-入围栏未入局  5-入局待卸数量
			};
			// console.log(params, 'params--车辆接发监控');
			if( Number(this.level) >= 5 ) return;
			else this.querydata(JSON.stringify(params), timestamp);
		},
		cljfClick(index) {
			switch (index) {
				case 2:
					let str = 2 + '-' +  'yxsl'
					try {
						Emp.execute("toCljfXz('"+ str +"')");
					} catch (e) {}
					break;
				case 3:
					let str1 = 3 + '-' + 'yfsl'
					try {
						Emp.execute("toCljfXz('"+ str1 +"')");
					} catch (e) {}
					break;
				case 4:
					let arg = 4 + '-' +  'wrj'
					try {
						console.log(arg)
						Emp.execute("toCljfXz('"+ arg +"')");
					} catch (e) {}
					break;
				case 5:
					let arg1 = 5 + '-' +  'dxsl'
					try {
						console.log(arg1)
						Emp.execute("toCljfXz('"+ arg1 +"')");
					} catch (e) {}
					break;
			}
		},
	},
})

