/**
 * 处理量详情
 * @author qs + 文杰
 * @time 2020.04.13
 */

Vue.component('item-kk', {
	data() {
		return {
			title: '占位',
			color: 'red',
			value: '1000000',
			isUp: true,
			changeNum: '4632',
			rale: '15%',
			zrtql: '900000',
			zrzl: '900000',
			isBorder: true
		}
	},
	filters: {
		// 过滤字符串,每3字符加,
		addSpot(source) {
			if (source.length < 4) return source;
			let newNumber;
			if (Number(source) < 0) {
				newNumber = source.substring(1);
			} else {
				newNumber = source;
			}
			let arr = [...newNumber];
			let len = arr.length / 3;
			let newArr = [];
			for (let i = 0; i < len; i++) {
				let start = arr.length - 3 * (i + 1)
				let b = []
				if (start < 0) b = arr.slice(0, arr.length % 3);
				else b = arr.slice(start, arr.length - 3 * i);
				newArr.push(b.join(''));
			}
			let newSource;
			if (Number(source) < 0) {
				newSource = "-" + newArr.reverse().join(',');
			} else {
				newSource = newArr.reverse().join(',');
			}
			return newSource;
		}
	},
	methods: {
		initData(data) {
			for (let key in data) {
				this[key] = data[key]
			}
		},
		numColor(a) {
			if (a < 0) {
				return '#F67767'
			} else if (a > 0) {
				return '#4CD997'
			} else {
				return '#000'
			}
		},
		toListView() {
			/* if (this.value == '0') return
			console.log(this.title);
			switch (this.title) {

				case '散件外走量':
					console.log(this.title);
					try{
						Emp.execute(`toClXiazhuan('sjwzl')`)
					}catch (e) {

					}
					break;
				case '分拣封发量':
					try{
						Emp.execute(`toClXiazhuan('fjffl')`)
					}catch (e) {

					}
					break;
				case '总包经转量':
					try{
						Emp.execute(`toClXiazhuan('zbjzl')`)
					}catch (e) {

					}
					break;
				case '人工填报量':
					try{
						Emp.execute(`toClXiazhuan('rgtbl')`)
					}catch (e) {

					}
					break;
			}
*/
		}
	},
	template: `<div class="box_item" style="border-left:1px solid rgb(230, 230, 230);border-right:1px solid rgb(230, 230, 230);">
                <div class="box_item_div" style="border-top: none;">
                    <div class="box_item_title" style="padding: 10px 4px">
                        <span class="title_font">{{title}}</span>
                        <p :style="{color: color}">{{ value | addSpot }}</p>
                    </div>
                    <div class="box_item_title" :style="{color: numColor(changeNum)}" style="font-size: 11px;padding: 10px 4px">
                        <span>
                            <i :class="isUp ? 'el-icon-caret-top' : 'el-icon-caret-bottom'"></i>
                            {{changeNum | addSpot}}
                        </span>
                        <p><i :class="isUp ? 'el-icon-caret-top' : 'el-icon-caret-bottom'"></i>{{rale}}</p>
                    </div>
                </div>
                <div class="box_item_div">
                    <div class="box_item_div_item" style="border-right: 1px dashed #E6E6E6;">
                        <p>昨日同期量</p>
                        <p style="font-weight: bold; font-size: 12px">{{zrtql | addSpot}}</p>
                    </div>
                    <div class="box_item_div_item">
                        <p>昨日总量</p>
                        <p style="font-weight: bold; font-size: 12px">{{zrzl | addSpot}}</p>
                    </div>
                </div>
            </div>`
});

var timestamp = dayjs().format('YYYY-MM-DD HH:mm:ss')
var num_arr = []; // 存放数值
var data_map = [];

var arr = [];
var splitListData = []
// 千位分隔符
function toThousands(num) {
	return (num || 0).toString().replace(/(\d)(?=(?:\d{3})+$)/g, '$1,');
}
Vue.component('cllxq', {
	data() {
		return {
			module_name: '',
			title: '实时总量',
			value: "0",
			color: '#F67767',
			tb: '0',
			tbl: '0',
			isUp: true,
			zrtql: '0',
			zrzl: '0',
			colors: ['#71C1FF', '#38A0FF', '#1180EC', '#0153B7'],
			splitList: [],
			statisticsMenu: '总量',
			items: [],
			// xzqh: '000000',
			// level: '1',
			// xzqhName: '',
			queryType: '00',
			list1: [],
			maxInNumbers: 0,
			result: [],
		}
	},
	methods: {
		// 00总量；05特快；06快包；07普包；09挂刷'
		clickMunu1(params) {
			let name = ['总量', '特快', '快包', '普包', '挂刷'];
			this.statisticsMenu = name[parseInt(params) - 1];
			switch (params) {
				case '1':
					this.queryType = '00';
					break;
				case '2':
					this.queryType = '05';
					break;
				case '3':
					this.queryType = '06';
					break;
				case '4':
					this.queryType = '07';
					break;
				case '5':
					this.queryType = '09';
					break;
				default:
					this.queryType = '00';
			}
			this.initData();

		},

		numColor(a) {
			if (a < 0) {
				return '#F67767'
			} else if (a > 0) {
				return '#4CD997'
			} else {
				return '#000'
			}
		},
		querydata() {
			// 实时总量查询参数  
			let new_level;
			if ((this.xzqh.substr(0, 2) == '11' || this.xzqh.substr(0, 2) == '12' || this.xzqh.substr(0, 2) == '31' || this.xzqh.substr(0, 2) == '50')) {
				new_level = this.level
			} else new_level = Number(this.level) >= 6 ? 4 : (this.level == '1' || this.level == '2') ? '1' : this.level - 1;
			let paramsbody = {
				distCode: this.xzqh,
				sumLevel: new_level,
				provCode: "",
				cityCode: "",
				orgCode: "",
				sumFg: "2", // 统计标识
				dataDate: dayjs().format('YYYY-MM-DD'),
				businessType: this.queryType,
			}
			getTotalData(paramsbody).then(({
				data
			}) => {
				data_map = [];
				num_arr = [];
				this.list1 = [];
				console.log(paramsbody, '地图data')
				console.log(data, "totalData");
				let removeTotalData = data.filter(i => i.distName !== '合计') // 去掉合计行数据
				if (removeTotalData.length !== 0) this.isShow = true
				var num = 0;
				for (var i = 0; i < removeTotalData.length; i++) {
					var item = {};
					if (this.level === '1' || this.level === '2') {
						item.name = removeTotalData[i].distName.replace(/省|市|自治区|壮族|回族|维吾尔/g, ''); // 去掉省市自治区的后缀
						item.code = removeTotalData[i].provCode;
					}
					if (this.level === '3') {
						item.name = removeTotalData[i].cityName
						item.code = removeTotalData[i].cityCode;
					}
					if (this.level === '4') {
						item.name = removeTotalData[i].cityOrgName
						item.code = removeTotalData[i].cityOrgCode;
					}
					item.value = removeTotalData[i].processNum;
					data_map.push(item)
					num_arr.push(removeTotalData[i].processNum)
					num = num + Number(removeTotalData[i].processNum)
				}
				this.value = String(num)
				this.maxInNumbers = Math.max.apply(Math, num_arr);
				// console.log(this.maxInNumbers, 'maxInNumbers')
				splitListData = [];
				this.splitList = []
				const splitListFun = (max) => {
					const pjz = parseInt(max / 4)
					const tt = Math.pow(10, Number(pjz.toString().length - 2))
					let new_value = 0;
					if (pjz % tt === 0) {
						const next = Number(pjz.toString().substring(1, 2))
						if (0 < next && next < 5) {
							new_value = (Number(pjz.toString().substring(0, 2)) + 5 - next) * tt
						} else if (5 < next) {
							new_value = (Number(pjz.toString().substring(0, 2)) + 10 - next) * tt
						} else {
							new_value = pjz
						}
					} else {
						const next = pjz.toString().substring(1, 2)
						if (next < 5) {
							new_value = (Number(pjz.toString().substring(0, 2)) + 5 - next) * tt
						} else {
							new_value = (Number(pjz.toString().substring(0, 2)) + 10 - next) * tt
						}
					}
					return new_value
				};
				const maxVal = data_map.reduce((a, b) => {
					return Number(a.value) > Number(b.value) ? a.value : b.value
				}, 0);
				const avg = Number(splitListFun(Number(this.maxInNumbers))).toString() === 'NaN' ? '0' : Number(splitListFun(Number(this.maxInNumbers)))
				// console.log(avg, 'avg')
				let avg_new = Math.ceil(avg)
				this.list1 = [{
						start: 0,
						end: avg_new
					},
					{
						start: avg_new,
						end: 2 * avg_new
					},
					{
						start: 2 * avg_new,
						end: 3 * avg_new
					},
					{
						start: 3 * avg_new
					}
				]
				const list2 = [avg_new, 2 * avg_new, 3 * avg_new, 4 * avg_new]
				this.splitList = list2
				splitListData = this.list1
				data_map.splice(6, 1)
				const newmap = {}
				data_map.map(i => {
					newmap[i.code] = i.name
				})
				if (this.level === '1' || this.level === '2') {
					const dataMap = [{
							name: '北京',
							value: '0'
						}, {
							name: '天津',
							value: 0
						},
						{
							name: '上海',
							value: 0
						}, {
							name: '重庆',
							value: 0
						},
						{
							name: '河北',
							value: 0
						}, {
							name: '河南',
							value: 0
						},
						{
							name: '云南',
							value: 0
						}, {
							name: '辽宁',
							value: 0
						},
						{
							name: '黑龙江',
							value: 0
						}, {
							name: '湖南',
							value: 0
						},
						{
							name: '安徽',
							value: 0
						}, {
							name: '山东',
							value: 0
						},
						{
							name: '新疆',
							value: 0
						}, {
							name: '江苏',
							value: 0
						},
						{
							name: '浙江',
							value: 0
						}, {
							name: '江西',
							value: 0
						},
						{
							name: '湖北',
							value: 0
						}, {
							name: '广西',
							value: 0
						},
						{
							name: '甘肃',
							value: 0
						}, {
							name: '山西',
							value: 0
						},
						{
							name: '内蒙古',
							value: 0
						}, {
							name: '陕西',
							value: 0
						},
						{
							name: '吉林',
							value: 0
						}, {
							name: '福建',
							value: 0
						},
						{
							name: '贵州',
							value: 0
						}, {
							name: '广东',
							value: 0
						},
						{
							name: '青海',
							value: 0
						}, {
							name: '西藏',
							value: 0
						},
						{
							name: '四川',
							value: 0
						}, {
							name: '宁夏',
							value: 0
						},
						{
							name: '海南',
							value: 0
						}, {
							name: '台湾',
							value: 0
						},
						{
							name: '南海诸岛',
							value: 0
						}
					];
					dataMap.forEach(i => {
						for (let j = 0; j < data_map.length; j++) {
							if (data_map[j].name === i.name) {
								i.value = data_map[j].value;
								break;
							}
						}
					})
					initEcharts('中国', dataMap);
				} else {
					let url = ''
					if (this.level === '3') url = `../js/sj_board/json/100000/${this.xzqh}.js`
					if (this.level === '4') {
						console.log(this.xzqh, 'mmmmmmmmm')
						url =
							`../js/sj_board/json/100000/${this.xzqh.substring(0, 2) + '0000'}/${this.xzqh}.js`
					}

					if (this.level === '5') url =
						`../js/sj_board/json/100000/${this.xzqh.substring(0, 2) + '0000'}/${this.xzqh.substring(0, 4) + '00'}.js`
					// 初始化数据
					let listdata = [];
					const testFun = (path, callback) => {
						var head = document.getElementsByTagName('head')[0];
						var script = document.createElement('script');
						script.type = 'text/javascript';
						script.src = path;
						head.appendChild(script);
						if (! /*@cc_on!@*/ false) {
							script.onload = function () {
								// console.log("非ie");
								callback();
							}
						} else {
							script.onreadystatechange = function () {
								if (script.readystate === "loaded" || script.readState === 'complate') {
									// console.log("ie");
									callback();
								}
							}
						}
					}
					const _this = this
					testFun(url, function () {
						// console.log("已经加载完成")
						mapobj.features.forEach(i => {
							// 替换了北京110100，天津120100，上海310100，重庆500100等4个直辖市的地图json，
							// 其中新地图json中中不包含adcode字段，但其中的id与原地图中的adcode含义一致，
							// 为防止字段找不到而报错，因此转换字段
							i.properties.adcode = i.properties.adcode ? i.properties.adcode : i.properties.id

							listdata.push({
								name: i.properties.name,
								value: 0,
								code: i.properties.adcode.toString()
							})
						});
						listdata.forEach(i => {
							for (let j = 0; j < data_map.length; j++) {
								if (data_map[j].code === i.code) {
									i.value = data_map[j].value
									break;
								}
							}
						});
						// console.log(listdata);
						initEcharts(_this.xzqhName, listdata, _this.xzqhName, mapobj);
					});
				}
			}).catch((err) => {
				console.log(err + "调用接口失败");
			})
		},
		// 昨日同期量  昨日总量
		initRationData() {
			let new_level;
			if ((this.xzqh.substr(0, 2) == '11' || this.xzqh.substr(0, 2) == '12' || this.xzqh.substr(0, 2) == '31' || this.xzqh.substr(0, 2) == '50')) {
				new_level = this.level
			} else new_level = Number(this.level) >= 6 ? 4 : (this.level == '1' || this.level == '2') ? '1' : this.level - 1;
			let paramsbody = {
				distCode: this.xzqh,
				sumLevel: new_level,
				provCode: "",
				cityCode: "",
				orgCode: "",
				sumFg: "1", // 统计标识
				dataDate: dayjs().subtract(2, 'day').format('YYYY-MM-DD'),
				businessType: this.queryType,
			}
			getRationData(paramsbody).then(({
				data
			}) => {
				console.log(paramsbody, '同比！')
				console.log(data, "Data");
				if (data.length !== 0) this.isShow = true
				let tbNum = Number(data[0].processNum - data[0].yesProcessNum) // 同比
				let tbRation = parseFloat(data[0].yesProcessRatio) // 同比率
				let yesNum = Number(data[0].yesProcessNum) // 昨日同期量
				let yesSum = Number(data[0].yesProcessSum) // 昨日总量
				// 同比、同比率颜色配置 增红减绿
				let isUp1 = tbNum;
				if (isUp1 > 0) {
					this.isUp = true
				} else {
					this.isUp = false
				}
				this.tb = String(tbNum)
				this.tbl = tbRation.toFixed(2)
				this.zrtql = String(yesNum)
				this.zrzl = String(yesSum)
			}).catch((err) => {
				console.log(err + "调用接口失败");
			})
		},
		initCllxqData() {
			const path = "dpk/queryPcWorkColumSum"; //  pcsWorkloadHsfPc
			let new_level;
			if ((this.xzqh.substr(0, 2) == '11' || this.xzqh.substr(0, 2) == '12' || this.xzqh.substr(0, 2) == '31' || this.xzqh.substr(0, 2) == '50')) {
				new_level = this.level
			} else new_level = Number(this.level) >= 6 ? 4 : (this.level == '1' || this.level == '2') ? '1' : this.level - 1;
			let params = {
				DistCode: this.xzqh,
				OrgCode: '',
				SumFg: '1',
				SumLevel: new_level,
				DataDate: dayjs().format('YYYY-MM-DD'),
				businessType: this.queryType,
			};
			const msgbody1 = JSON.stringify(params)
			console.log(params, "params")
			var interface1 = axios.create({
				'Access-Control-Allow-Origin': '*',
				baseURL: board_url,
				timeout: 10000
			});
			interface1.get(path, {
				params: {
					'sendID': '00000001',
					'timestamp': timestamp,
					'msgBody': msgbody1,
					'dataDigest': base64.encode(hex_md5(msgbody1 + data_key + timestamp))
				}
			}).then(({
				data
			}) => {
				this.result = [];
				console.log(data, "data3333333333")
				// let fata1 = {
				// 	title: '散件外走量',
				// 	color: '#F67767',
				// 	value: '0',
				// 	isUp: true,
				// 	changeNum: '0',
				// 	rale: '0%',
				// 	zrtql: '0',
				// 	zrzl: '0',
				// };
				// let fata2 = {
				// 	title: '分拣封发量',
				// 	color: '#4CD997',
				// 	value: '0',
				// 	isUp: false,
				// 	changeNum: '0',
				// 	rale: '0%',
				// 	zrtql: '0',
				// 	zrzl: '0',
				// };
				// let fata3 = {
				// 	title: '总包经转量',
				// 	color: '#4CD997',
				// 	value: '0',
				// 	isUp: false,
				// 	changeNum: '0',
				// 	rale: '0%',
				// 	zrtql: '0',
				// 	zrzl: '0',
				// };
				// let fata4 = {
				// 	title: '人工填报量',
				// 	color: '#F67767',
				// 	value: '--',
				// 	isUp: true,
				// 	changeNum: '--',
				// 	rale: '--',
				// 	zrtql: '--',
				// 	zrzl: '--',
				// };

				if (data.resCode === 'C00001' && data.data !== 'null' && data.data.length > 0) {
					this.result = data.data[0];
					// fata1.value = this.result.outgoingParts ? this.result.outgoingParts : '-';  // 散件外走量
					// fata1.zrtql = this.result.yesOutgoingParts ? this.result.yesOutgoingParts : '-';
					// fata1.zrzl = this.result.yesOutgoPartsSum !== 'null' ? this.result.yesOutgoPartsSum : '-';
					// fata1.changeNum = Number(this.result.outgoingParts) - Number(this.result.yesOutgoingParts) + '';
					// fata1.isUp = Number(fata1.changeNum) > 0 ? true : false;
					// fata1.color = Number(this.result.outgoingParts - this.result.yesOutgoingParts) > 0 ? '#4CD997' : '#F67767';
					// fata1.rale = ((accDiv(fata1.changeNum, this.result.yesOutgoingParts) * 100).toFixed(2) + '%') !== 'NaN%'
					// 			 && ((accDiv(fata1.changeNum, this.result.yesOutgoingParts) * 100).toFixed(2) + '%') !== 'Infinity%'
					// 		     ? (accDiv(fata1.changeNum, this.result.yesOutgoingParts) * 100).toFixed(2) + '%' : '-';

					// fata2.value = this.result.sortingVolume ? this.result.sortingVolume : '-';  // 分拣分发量
					// fata2.zrtql = this.result.yesSortingVolume ? this.result.yesSortingVolume : '-';
					// fata2.zrzl = this.result.yesSortVoluSum !== 'null' ? this.result.yesSortVoluSum : '-';
					// fata2.color = Number(this.result.sortingVolume - this.result.yesSortingVolume) > 0 ? '#4CD997' : '#F67767';
					// fata2.changeNum = Number(this.result.sortingVolume) - Number(this.result.yesSortingVolume) + '';
					// fata2.isUp = Number(fata2.changeNum) > 0 ? true : false;
					// fata2.rale = ((accDiv(fata2.changeNum, this.result.yesSortingVolume) * 100).toFixed(2) + '%') !== 'NaN%'
					// 			 && ((accDiv(fata2.changeNum, this.result.yesSortingVolume) * 100).toFixed(2) + '%') !== 'Infinity%'
					// 			 ? (accDiv(fata2.changeNum, this.result.yesSortingVolume) * 100).toFixed(2) + '%' : '-';

					// fata3.value = this.result.totalTurnover ? this.result.totalTurnover : '-'; // 总包经转量
					// fata3.zrtql = this.result.yesTotalTurnover ? this.result.yesTotalTurnover : '-';
					// fata3.zrzl = this.result.yesTotTurnoverSum !== 'null' ? this.result.yesTotTurnoverSum : '-';
					// fata3.color = Number(this.result.totalTurnover - this.result.yesTotalTurnover) > 0 ? '#4CD997' : '#F67767';
					// fata3.changeNum = Number(this.result.totalTurnover) - Number(this.result.yesTotalTurnover) + '';
					// fata3.isUp = Number(fata3.changeNum) > 0 ? true : false;
					// fata3.rale = ((accDiv(fata3.changeNum, this.result.yesTotalTurnover) * 100).toFixed(2) + '%') !== 'NaN%' 
					// 			 && ((accDiv(fata3.changeNum, this.result.yesTotalTurnover) * 100).toFixed(2) + '%') !== 'Infinity%'
					// 			 ? (accDiv(fata3.changeNum, this.result.yesTotalTurnover) * 100).toFixed(2) + '%' : '-';
				}
				// this.$refs.data4.initData(fata4)
				this.$nextTick(() => {
					vant.Toast.clear();
					// this.$refs.data1.initData(fata1);
					// this.$refs.data2.initData(fata2);
					// this.$refs.data3.initData(fata3);
				})
			}).catch(err => {
				console.log(err);
			}).finally(() => {

			})
		},
		toSecond() {
			console.log("sonEvent")
			setTimeout(() => {
				Emp.execute(`go_ahead('${this.queryType}')`)
			}, 100)

		},
		initData(data) {
			// console.log(data);
			for (let key in data) {
				this[key] = data[key]
			}
			let level = this.level === '1' || this.level === '2' ? '1' : (Number(this.level) - 1).toString()
			/*const zxsXzqh = ['110000','120000','500000','310000'];
			if (zxsXzqh.indexOf(this.xzqh) !==  -1) level = Number(level) + 1*/

			let params = {
				"distOrgCode": this.xzqh,
				"seekLevel": level.toString(),
				"orgCode": "",
				"gatherSign": "2",
				"dateHour": dayjs().format('YYYY-MM-DD')
				// "dateHour": '2020-04-23'
			};
			console.log(params);
			this.querydata();
			this.initCllxqData();
			this.initRationData();
		},
	},

	mounted() {},
	filters: {
		addSpot(source) {
			if (source.length < 4) return source;
			let arr = [...source];
			let len = arr.length / 3;
			let newArr = [];
			for (let i = 0; i < len; i++) {
				let start = arr.length - 3 * (i + 1)
				let b = []
				if (start < 0) b = arr.slice(0, arr.length % 3);
				else b = arr.slice(start, arr.length - 3 * i);
				newArr.push(b.join(''));
			}
			return newArr.reverse().join(',');
		},
		addW(val) {
			if (Number(val) >= 10000) {
				return '<' + (Number(val) / 10000) + '万'
			} else return '<' + val
		}
	},
	// 	<div class="item_son">
	// 	<div class="box_item">
	// 		<item-kk  ref="data1"></item-kk>
	// 	</div>
	// 	<div class="box_item">
	// 		<item-kk  ref="data2"></item-kk>
	// 	</div>
	// </div>

	// <div class="item_son">
	// 	<div class="box_item">
	// 		<item-kk  ref="data3"></item-kk>
	// 	</div>
	// 	<div class="box_item">
	// 	</div>
	// </div>
	// </div>
	template: `<div>
            <div class="title" style="border-radius: 10px 10px 0 0;">
                {{ module_name }}
					<el-dropdown @command="clickMunu1" :trigger="'click'" ref="lll" style="position: absolute; right: 30px; top: 0px;">
						<span class="el-dropdown-link">
							{{ statisticsMenu }}
							<i class="el-icon-caret-bottom" style="margin-top: -13px"></i>
						</span>
						<el-dropdown-menu slot="dropdown">
							<el-dropdown-item command="1">总量</el-dropdown-item>
							<el-dropdown-item command="2">特快</el-dropdown-item>
							<el-dropdown-item command="3">快包</el-dropdown-item>
							<el-dropdown-item command="4">普包</el-dropdown-item>
							<el-dropdown-item command="5">挂刷</el-dropdown-item>
						</el-dropdown-menu>
					</el-dropdown>
            </div>
            <div style=" width: 100%; border-right: 1px solid #e6e6e6">
                <div id="chart_cllxq" class="content" style="border-left: 1px solid #e6e6e6; margin-bottom: 20px;"></div>
                <div style="margin-top: -40px; margin-bottom: 10px">
                    <div style="width: 280px; margin: 0 auto; display: flex; justify-content: space-between; ">
                        <div v-for="(i,index) in splitList" style="width: 55px; margin: 5px; text-align: center; font-size: 12px">
                            <div style="width: 100%; height: 10px" :style="{'background-color': colors[index]}"></div>
                            {{i | addW}}
                        </div>
                    </div>
                </div>
                <div>
                    <div style="display: flex; justify-content: space-between; border: 1px solid #E9E9E9; border-right: none">
                        <div class="box_item" >
                            <div style="text-align: center; line-height: 35px; margin-top: 40px" @click="toSecond()">
                                <p style="color: #4495D4; font-weight: bold; font-size: 18px">{{ title }}</p>
                                <p :style="{color: numColor(tb)}" style="font-size: 19px; font-weight: bold">{{value | addSpot}}</p>
                            </div>
                        </div>
                        <div class="box_item" >
                            <div class="box_item_div" style="border-top: none">
                                <div class="box_item_div_item" style="border-right: 1px dashed #E6E6E6;border-left: 1px solid #E6E6E6;">
                                    <p style=" font-size: 12px">同比 <i :style="{color: numColor(tb)}" style="font-weight: bold; font-size: 12px" :class="isUp ? 'el-icon-caret-top' : 'el-icon-caret-bottom'"></p>
                                    <p :style="{color: numColor(tb)}" style="font-weight: bold; font-size: 12px">
                                        </i>
										{{ toThousands(tb)  }}
                                    </p>
                                </div>
                                <div class="box_item_div_item">
                                    <p style=" font-size: 12px">同比率<i :style="{color: numColor(tbl)}" style="font-weight: bold; font-size: 12px" :class="isUp ? 'el-icon-caret-top' : 'el-icon-caret-bottom'"></i></p>
                                    <p :style="{color: numColor(tbl)}" style="font-weight: bold; font-size: 12px">
                                        {{ tbl }}%
                                    </p>
                                </div>
                            </div>
                            <div class="box_item_div">
                                <div class="box_item_div_item" style="border-right: 1px dashed #E6E6E6;border-left: 1px solid #E6E6E6;">
                                    <p>昨日同期量</p>
                                    <p style="font-weight: bold; font-size: 12px">{{ zrtql | addSpot}}</p>
                                </div>
                                <div class="box_item_div_item">
                                    <p>昨日总量</p>
                                    <p style="font-weight: bold; font-size: 12px">{{ zrzl | addSpot}}</p>
                                </div>
                            </div>
                        </div>
                    </div>
                   
            </div>
        </div>`
});


// 初始化地图
function initEcharts(name, data, mapType = 'china', mapJson = '') {
	var option = {
		visualMap: {
			show: false,
			splitList: splitListData,
			bottom: 100,
			left: 'center',
			itemWidth: 70,
			color: ['#0153B7', '#1180EC', '#38A0FF', '#71C1FF'],
			formatter: function (value) { // 标签的格式化工具。
				return ''; // 范围标签显示内容。
			},
			align: 'right',
			orient: 'horizontal',
		},
		tooltip: {
			textStyle: {
				color: "#fff"
			}, // 提示标签字体颜色
			formatter: function (value) {
				const val = value.data.value
				return val === 0 ? `${value.seriesName}<br/>${value.data.name}: -` :
					`${value.seriesName}<br/>${value.data.name}: ${val}`
			}
		},

		series: [{
			name: name,
			type: 'map',
			mapType: mapType,
			label: {
				normal: {
					show: false, // 显示省份标签
				},
				emphasis: {
					show: false, // 对应的鼠标悬浮效果
				}
			},
			emphasis: {
				show: false,
				// 选择区域显示颜色
				itemStyle: {
					areaColor: '#fff100'
				}
			},
			itemStyle: {
				normal: {
					borderColor: '#e6e6e6',
					label: {
						show: false
					},
					normal: {
						label: {
							show: true
						}
					},
					emphasis: {
						label: {
							show: true
						}
					}
				},
			},
			data: data,
		}]
	};

	mapJson !== '' ? echarts.registerMap(mapType, mapJson) : '';
	let mychart2 = echarts.init(document.getElementById('chart_cllxq'));
	mychart2.setOption(option);

}