/**
 * 带运量
 * @author 蔡老师
 * @time 2021.07
 */

Vue.component('yjjsl', {
    data() {
        return {
            module_name: '运输量统计',
            data: [{
                value: 0,
                name: '邮航',
                itemStyle: {
                    color: "#0099FF"
                },
            }, {
                value: 0,
                name: '民航',
                itemStyle: {
                    color: "#EEEE11"
                },
            }, ],
            transport_menu: '带运量',
            total: 0,
            result: [],
            transport: 1
        }
    },
    props: {
        dataType: {
            Number,
            default: 1
        },
        dataType1: {
            Number,
            default: 1
        },
        dataLevel: {
            Number,
            default: 1
        }
    },

    template: `
    <div>
        <div class="" style="position: relative;height: 38px;
        width: calc(100% -10px);
        color:#2991E6;
        font-weight: bold;
        margin:0 auto;
        box-shadow: 0 1px 4px 0 rgba(207, 205, 205, 0.50);
        background: #D1EAFE;
        font-size:14px;
        line-height: 38px;
        border-left: 1px solid #e5e5e5;border-right: 1px solid #e5e5e5;
        display:-webkit-flex;
        display: flex;
        justify-content: space-around
        border-bottom-right-radius: 0;
        border-bottom-left-radius: 0" >
		    {{ module_name }}
		    <div style="position: absolute; right: 15px; top: 0">
                <el-dropdown @command="clickTransport" :trigger="'click'">
                    <span class="el-dropdown-link">
                        {{ transport_menu }}
                        <i class="el-icon-caret-bottom"
                            style="margin-top: -12px; margin-left: -3px;"></i>
                    </span>
                    <el-dropdown-menu slot="dropdown">
                        <el-dropdown-item command="1">带运量</el-dropdown-item>
                        <el-dropdown-item command="2">带运重量</el-dropdown-item>
                    </el-dropdown-menu>
                </el-dropdown>
		    </div>
		</div>
        <div class="showbox" style="display: flex;justify-content: space-around; align-items: center;border: 1px solid #e6e6e6;">
            <div @click="toXiazuan(2)" id="chart_yjjsl" class="" style="width: 60%; height: 200px;"></div>
            <div style="margin-left:20px;width: 40%;">
                <div v-for="(i,index) in data">
                    <div
                        style="margin:33px 0; display: flex;align-items: center; justify-content: space-between;" @click="toXiazuan(index)">
                             <div class="box1" :style="{'background-color':i.itemStyle.color}" ></div>
                             <div style=" width: 100%;height: 50px;line-height: 25px; margin-left: 15px;display: flex;align-items: flex-start; flex-direction: column;">
                                 <div style="color:black; font-size: 13px; font-weight: bold;">{{i.name}}</div>
                                        <div style="color:#0099FF; font-size: 13px; font-weight: bold;">{{transport_menu == "带运量" ? newAddSpot(i.value) + '袋/件' : conversionFun(i.value) + '吨'}}
                                 </div>
                             </div>
                     </div>


                </div>
            </div>
        </div>
    </div>
    `,
    methods: {
        clickTransport(key) {
            this.transport = key;
            let name = ['带运量', '带运重量']
            this.transport_menu = name[parseInt(key) - 1]
            if (key == 1) {
                if (this.result.length !== 0) {
                    if (this.result[0] == undefined) {
                        this.data[0].value = 0;
                    } else {
                        this.data[0].value = this.result[0].packNum == undefined ? 0 : this.result[0].packNum;
                    }
                    if (this.result[1] == undefined) {
                        this.data[1].value = 0;
                    } else {
                        this.data[1].value = this.result[1].packNum == undefined ? 0 : this.result[1].packNum;
                    }
                    this.total = (Number(this.data[0].value) + Number(this.data[1].value))
                    initEcharts1(this.data, this.total, '带运量')
                } else initEcharts1(this.data, 0, '带运量')
            } else {
                if (this.result.length !== 0) {
                    if (this.result[0] == undefined) {
                        this.data[0].value = 0;
                    } else {
                        this.data[0].value = this.result[0].weight == undefined ? 0 : this.result[0].weight;
                    }
                    if (this.result[1] == undefined) {
                        this.data[1].value = 0;
                    } else {
                        this.data[1].value = this.result[1].weight == undefined ? 0 : this.result[1].weight;
                    }
                    this.total = (Number(this.data[0].value) + Number(this.data[1].value))
                    initEcharts1(this.data, this.total, '带运重量')
                } else initEcharts1(this.data, 0, '带运重量')
            }
        },
        // 运输量接口
        init_yjjsl(xzqh, level) {
            let sumLevel = level === '1' || level === '2' ? 1 : level = Number(level) - 1
            let params = {
                sumLevel: sumLevel, //	M	1：全国 2：省 3：市，4：区县，5-机构
                sumFg: '1', //	M	1汇总  2下钻
                distCode: level === '1' || level === '2' ? '000000' : xzqh, // 	M	
                transType: `5`, //	M	1-汽车2-火车3-邮航4-民航
                routeType: "1", //	C	1-一干2-二干（transType = 1时，必传）
                orgCode: sumLevel == '5' ? xzqh : "", //	机构登陆时必传   packNum：带运量  weight： 重量
            }
            let res = [];
            getTranspostNum(params).then(({
                data
            }) => {
                // console.log(params, '运输量统计')
                console.log(data.postalAirTransportMail.length, '运输量统计data')
                let civilAviationTransportMail = data.postalAirTransportMail.length == 0 ? "0" : data.postalAirTransportMail;
                let postalAirTransportMail = data.civilAviationTransportMail.length == 0 ? "0" : data.civilAviationTransportMail
                res = [...postalAirTransportMail, ...civilAviationTransportMail]
                console.log(res, 'lllll')
                if (res.length !== 0) {
                    this.result = [...res];
                    if (data.civilAviationTransportMail.length == 0) {
                        this.data[1].value = 0;
                    } else {
                        this.data[1].value = res[1].packNum == undefined ? "0" : res[1].packNum;
                    }
                    if (data.postalAirTransportMail.length == 0) {
                        this.data[0].value = 0;
                    } else {
                        this.data[0].value = res[0].packNum == undefined ? "0" : res[0].packNum;
                    }
                    this.total = (Number(this.data[0].value) + Number(this.data[1].value))
                    console.log(this.data[0].value, this.data[1].value, '------------------------')
                    initEcharts1(this.data, this.total, "带运量")
                } else {
                    this.data[0].value = 0;
                    this.data[1].value = 0;
                    this.result = [];
                    this.total = 0;
                    initEcharts1(this.data, this.total, "带运量")
                }
            }).catch(err => {
                console.log(err, 'err')
                this.result = [];
                initEcharts1(this.data, this.total, "带运量")
            });
        },
        toXiazuan(index) {
            console.log(index)
            switch (index) {
                case 0:
                    if (this.transport_menu == '带运量') this.drillDown('post_air_dyl')
                    else if (this.transport_menu == '带运重量') this.drillDown('post_air_dyzl')
                    break;
                case 1:
                    if (this.transport_menu == '带运量') this.drillDown('civil_air_dyl')
                    else if (this.transport_menu == '带运重量') this.drillDown('civil_air_dyzl')
                    break;
            }
        },
        // 下钻方法
        drillDown(key) {
            console.log(key, 'key')
            try {
                Emp.execute(`to_yskb_xz('${key}')`)
            } catch (err) {
                console.log(err)
            }
        },
    },
    filters: {}
});

// 千位分隔符
function toThousands(num) {
    return (num || 0).toString().replace(/(\d)(?=(?:\d{3})+$)/g, '$1,');
}
// 初始化地图
function initEcharts1(datas, total, dataType1) {
    console.log(datas, total, dataType1, 'msmmsmsmsmsmsms')
    let mychart = echarts.init(document.getElementById('chart_yjjsl'));
    let option = {
        graphic: [{
                type: 'text',
                left: 'center',
                top: '110',
                style: {
                    text: dataType1,
                    textAlign: 'center',
                    // color: '#000',
                    fill: 'black',
                    width: 50,
                    height: 50,
                    fontSize: 13,
                    fontWeight: 700
                }
            },
            {
                type: 'text',
                left: 'center',
                top: '90',
                style: {
                    text: dataType1 == "带运量" ? newAddSpot(total) + '袋/件' : conversionFun(total) + '吨',
                    textAlign: 'center',
                    // color: '#000',
                    fill: '#0099FF',
                    width: 50,
                    height: 50,
                    fontSize: 13,
                    fontWeight: 700,
                }
            }
        ],
        title: {
            left: 'center'
        },
        tooltip: {
            trigger: 'item',
            confine: true,
            formatter: function (params) {
                if (dataType1 == "带运量") {
                    return `<div style="z-index: 999">
                                <div>${params.name + '：' + newAddSpot(params.value) + '袋/件'}</div>
                                <div style="display: flex; justify-content: space-between">占比：${params.percent + '%'}</div>               
                            </div>`
                } else {
                    return `<div style="z-index: 999">
                                <div>${params.name + '：' + newAddSpot(conversionFun(params.value)) + '吨'}</div>
                                <div style="display: flex; justify-content: space-between">占比：${params.percent + '%'}</div>           
                            </div>`
                }
            }
        },
        series: [{
            name: '运输量统计',
            type: 'pie',
            radius: ['60%', '85%'],
            // center: ['30%', '50%'],
            label: {
                show: false,
                position: 'outside',
            },
            labelLine: {
                show: false
            },
            data: datas,
        }]
    }
    mychart.setOption(option)
}
// 正常率
Vue.component('zcl-compoent', {
    data() {
        return {}
    },
    methods: {//x_data,
        initzcl( x_data,ywlRecvData, ywlProData,time_menu, ) {
            console.log( x_data,ywlRecvData, ywlProData,time_menu,'ywlRecvData, ywlProData,time_menuywlRecvData, ywlProData,time_menu')
            let legend = ['邮航正常率', '邮航载运率'];
            let xData = x_data
            // .length > 0 ? x_data :
            //     ['00:00', '01:00', '02:00', '03:00', '04:00', '05:00', '06:00', '07:00', '08:00', '09:00', '10:00', '11:00',
            //         '12:00', '13:00', '14:00', '15:00', '16:00', '17:00', '18:00', '19:00', '20:00', '21:00', '22:00', '23:00', '24:00']
            let series = [];
            legend.forEach((e, index) => {
                let setting = {
                    type: 'line',
                    // data: [1],
                    symbolSize: 10,
                    symbol: 'circle',
                    itemStyle: {
                        normal: {
                            color: '#1D95F4',
                            barBorderRadius: 1,
                            borderColor: '#fff',
                            borderWidth: 2
                        }
                    },
                    lineStyle: {
                        normal: {
                            color: '#1D95F4',
                            width: 2
                        }
                    },
                    smooth: true
                }
                setting.name = e;
                if (index === 0) {
                    if (ywlRecvData != null) {
                        setting.data = ywlRecvData
                    } else {
                        setting.data = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
                    }
                    setting.itemStyle.normal.color = '#1D95F4';
                    setting.lineStyle.normal.color = '#1D95F4';
                }
                if (index === 1) {
                    if (ywlProData != null) {
                        setting.data = ywlProData
                    } else {
                        setting.data = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
                    }
                    setting.itemStyle.normal.color = '#1AE54B';
                    setting.lineStyle.normal.color = '#1AE54B';
                }
                series.push(setting);
            })
            initzclLine('chart_zcl', legend, xData, series);
        },

    },
    props: {
        title: {
            type: String,
            required: true
        },
        id_name: {
            type: String,
            required: true
        }
    },
    mounted() {},
    template: `
	<div>
        <div class="">
            {{ title }}
            <div style="position: relative;">
                <slot></slot>
            </div>
        </div>
		<div id="chart_zcl" class="" style="height:330px;border:1px solid #E6E6E6;"></div>
	</div>
	`
});

// 正常率折线图
function initzclLine(chart_zcl, legend, xData, series) {
    console.log(series[1].data,series[0].data,'=====legend, xData, series')
    var mychart2 = echarts.init(document.getElementById(chart_zcl));
    mychart2.clear();
    let option2 = {
        tooltip: {
            trigger: 'axis',
            axisPointer: {
                type: 'line'
            },
            textStyle: {
                align: 'left'
            }
        },
        legend: {
            data: legend,
            x: 'center',
            y: 'bottom',
            itemGap: 10,
        },
        grid: {
            top: '13%',
            left: '3%',
            right: '4%',
            bottom: '20%',
            containLabel: true
        },
        xAxis: [
            {
                type: 'category',
                data: xData,
                'axisLine': {
                    lineStyle: {
                        color: '#90979c'
                    }
                },
                'splitLine': {
                    'show': false
                },
                'axisTick': {
                    'show': true
                },
                'splitArea': {
                    'show': false
                },
                'axisLabel': {
                    'interval': 0,
                    'rotate': 40
                }
            }
        ],
        yAxis: [
            {
                name: '',
                type: 'value',
                axisLine: { show: false },
                'axisTick': {
                    'show': false
                },
                axisLabel: {
                    margin: 5,
                    formatter: function (value, index) {
                        if (value >= 10000 && value < 100000000) {
                            value = value / 10000 + '万'
                        } else if (value >= 100000000) {
                            value = value / 100000000 + '亿'
                        }else if(value <=100){
                            value = value +'%'
                        }
                        return value
                    }
                }
            }
        ],
        dataZoom: [{
            type: "slider", // 类型
            xAxisIndex: 0, // 对应的轴
            bottom: "30", // 位置，定位
            // startValue: 0,
			// endValue: xData.length > 7 ? 8 : xData.length - 1,
            startValue: xData.length > 7 ? xData.length - 7 :0,
                endValue:xData.length - 1 ,
            handleStyle: { // 手柄的样式
                color: "#40bcf9",
                borderColor: "#1fb2fb"
            },
            backgroundColor: "#e2f3ff", // 背景
            dataBackground: { // 数据背景
                lineStyle: {
                    color: "#000000"
                },
                areaStyle: {
                    color: "#d4d9dd"
                }
            },
            fillerColor: "rgba(31,178,251,0.2)", // 被start和end遮住的背景*/
        }],
        series: // series,
        [{
            data:  series[0].data,// series[0].data,
            type: 'line',
            itemStyle: series[0].itemStyle,
            lineStyle: series[0].lineStyle,
            name: series[0].name,
            smooth: true,
            symbol: "circle",
            symbolSize: 10,
        }, {
            data:  series[1].data,// series[1].data,
            type: 'line',
            itemStyle: series[1].itemStyle,
            lineStyle: series[1].lineStyle,
            name: series[1].name,
            smooth: true,
            symbol: "circle",
            symbolSize: 10,
        }],
    };
    mychart2.setOption(option2);
}