/**
 * 服务处理环节
 * @author 李超
 * @time 2021.01.25
 */

var timestamp = dayjs().format('YYYY-MM-DD HH:mm:ss')
var num_arr = []; // 存放数值
var data_map = [];
var numbers;
var maxInNumbers;

var arr = [];
var splitListData = []
// 千位分隔符
function toThousands(num) {
	return (num || 0).toString().replace(/(\d)(?=(?:\d{3})+$)/g, '$1,');
}
Vue.component('serveLineMap', {
	data() {
		return {
			// level:'',
			module_name: '',
			title: '实时总量',
			value: "0",
			color: '#F67767',
			tb: '0',
			tbl: '0',
			isUp: true,
			zrtql: '0',
			zrzl: '0',
			colors: ['#71C1FF', '#38A0FF', '#1180EC', '#0153B7'],
			splitList: [],
			items: [],
			// xzqh: '000000',
			level: '1',
			// xzqhName: '',
			datePick: '',
			list1:''
		}
	},
	methods: {
		// 获取挑战值，预警值、达标值
        initLinkInfos() {
            vant.Toast.loading({
                message: '加载中...',
                forbidClick: true,
                duration: 10000
            });
            this.alertScore = "";
            this.standScore = "";
            this.challScore = "";
            this.list1 = []
            getLinkInfos().then(({ data }) => {
                console.log( "各环节信息",data )
				// alert(JSON.stringify(data))
                if(data.length !== 0) {
                    this.alertScore = data[0].alertScore;
                    this.standScore = data[0].standScore;
                    this.challScore = data[0].challScore;
                    this.list1 = [
                        { min: 0, max: 1 * this.alertScore, label: '<' + 1 * this.alertScore + '分', color: '#eb0000',},
                        { min: 1 * this.alertScore, max: 1 * this.standScore, label: '<' + 1 * this.standScore + '分', color: '#ffdb27', },
                        { min: 1 * this.standScore, max: 1 * this.challScore, label: '<' + 1 * this.challScore + '分', color: '#05c917', },
                        { min: 1 * this.challScore, label: '>=' + 1 * this.challScore + '分', color: '#187b28', }
                    ]
                } else {
                    this.alertScore = "_";
                    this.standScore = "_";
                    this.challScore = "_";
                    this.list1 = [
                        { min: 0, max: 1 * this.alertScore, label: '<_分', color: '#eb0000',},
                        { min: 1 * this.alertScore, max: 1 * this.standScore, label: '<_分', color: '#ffdb27', },
                        { min: 1 * this.standScore, max: 1 * this.challScore, label: '<_分', color: '#05c917', },
                        { min: 1 * this.challScore, label: '>=_分', color: '#187b28', }
                    ]
                }
                vant.Toast.clear()
            }).catch(err => {
                console.log(err)
            })
        },
		numColor(a) {
			// const num = a - b
			// alert(num)
			if (a > 0) {
				return '#F67767'
			} else if (a < 0) {
				return '#4CD997'
			} else {
				return '#000'
			}
		},
		//地图
		querydata(data) {
			// 实时总量查询参数
			let paramsbody = {
				distCode: data.level=='3'?data.xzqh.substr(0,2)+'0000':data.xzqh,
				provCode: data.level=='3'?data.xzqh.substr(0,2)+'0000':data.xzqh,
				cityCode: "",
				orgCode: "",
				linkCode: data.linkNum,
				sumLevel: data.level=='3'?'2':data.level,
				dateType: data.dateType,
				beginDate: data.datePick ? data.datePick : dayjs().format('YYYY-MM-DD').split('-').join(''),
				endDate: data.datePick ? data.datePick : dayjs().format('YYYY-MM-DD').split('-').join(''),
				sumFg: "2"
			}
			// alert(JSON.stringify(paramsbody), '地图参数');
			getTotalDataMap(paramsbody).then(({ data }) => {
				console.log(data, "地图");
				if (data.length !== 0) this.isShow = true
				var num = 0;
				data_map=[]
				// alert(this.level)
				// console.log('d-1');
				for (var i = 0; i < data.length; i++) {
					var item = {};
					if (this.level === '1') {
						item.name = data[i].provName // 去掉省市自治区的后缀
						item.code = data[i].provCode;
					}
					if (this.level === '3' || this.level === '2') {
						item.name = data[i].cityName
						item.code = data[i].cityCode;
					}
					if (this.level === '4') {
						item.name = data[i].orgName
						item.code = data[i].orgCode;
					}
					// console.log('d-2');
					item.value = data[i].score;
					data_map.push(item)

					num_arr.push(data[i].score)
					num = num + Number(data[i].score)
				}
				// console.log('D011111111111111111111111111111');

				this.value = String(num)
				numbers = num_arr;
				maxInNumbers = Math.max.apply(Math, numbers);
				splitListData = [];
				this.splitList = []
				// console.log('D1');

				// data_map.splice(6, 1)
				// console.log(data_map, '1111111111111')
				const newmap = {}
				// console.log(data_map,'data_M');
				data_map.map(i => {
					newmap[i.code] = i.name
				})
				if (this.level == '1') {
					// alert(1)
					const dataMap = [
						{ name: '北京', value: '0' }, { name: '天津', value: 0 },
						{ name: '上海', value: 0 }, { name: '重庆', value: 0 },
						{ name: '河北', value: 0 }, { name: '河南', value: 0 },
						{ name: '云南', value: 0 }, { name: '辽宁', value: 0 },
						{ name: '黑龙江', value: 0 }, { name: '湖南', value: 0 },
						{ name: '安徽', value: 0 }, { name: '山东', value: 0 },
						{ name: '新疆', value: 0 }, { name: '江苏', value: 0 },
						{ name: '浙江', value: 0 }, { name: '江西', value: 0 },
						{ name: '湖北', value: 0 }, { name: '广西', value: 0 },
						{ name: '甘肃', value: 0 }, { name: '山西', value: 0 },
						{ name: '内蒙古', value: 0 }, { name: '陕西', value: 0 },
						{ name: '吉林', value: 0 }, { name: '福建', value: 0 },
						{ name: '贵州', value: 0 }, { name: '广东', value: 0 },
						{ name: '青海', value: 0 }, { name: '西藏', value: 0 },
						{ name: '四川', value: 0 }, { name: '宁夏', value: 0 },
						{ name: '海南', value: 0 }, { name: '台湾', value: 0 },
						{ name: '南海诸岛', value: 0 }
					];
					dataMap.forEach(i => { 
						for (let j = 0; j < data_map.length; j++) {
							if (data_map[j].name === i.name) {
								i.value = data_map[j].value;
								break
							}
						}
					})
					// console.log(dataMap,'全国');
					initEcharts('全国', dataMap,'china','',this.list1);
				} else {
					// alert('2')
					let url = ''
					if (this.level == '3' || this.level == '2') url = `../../js/sj_board/json/100000/${this.xzqh.substr(0,2)+'0000'}.js`
					if (this.level == '4') url =
						`../../js/sj_board/json/100000/${this.xzqh.substring(0, 2) + '0000'}/${this.xzqh}.js`
					if (this.level == '5') url =
						`../../js/sj_board/json/100000/${this.xzqh.substring(0, 2) + '0000'}/${this.xzqh.substring(0, 4) + '00'}.js`
					// 初始化数据
					let listdata = [];
					const testFun = (path, callback) => {
						var head = document.getElementsByTagName('head')[0];
						var script = document.createElement('script');
						script.type = 'text/javascript';
						script.src = path;
						head.appendChild(script);
						if (! /*@cc_on!@*/ false) {
							script.onload = function () {
								// console.log("非ie");
								callback();
							}
						} else {
							script.onreadystatechange = function () {
								if (script.readystate === "loaded" || script.readState === 'complate') {
									// console.log("ie");
									callback();
								}
							}
						}
					}
					const _this = this
					testFun(url, function () {
						// console.log("已经加载完成")
						mapobj.features.forEach(i => {
							// 替换了北京110100，天津120100，上海310100，重庆500100等4个直辖市的地图json，
							// 其中新地图json中中不包含adcode字段，但其中的id与原地图中的adcode含义一致，
							// 为防止字段找不到而报错，因此转换字段
							i.properties.adcode = i.properties.adcode ? i.properties.adcode : i.properties.id
							listdata.push({
								name: i.properties.name,
								value: 0,
								code: i.properties.adcode.toString()
							})
						});
						// console.log(data_map);
						listdata.forEach(i => {
							for (let j = 0; j < data_map.length; j++) {
								if (data_map[j].code === i.code) {
									i.value = data_map[j].value
									break;
								}
							}
						});
						// console.log(listdata, mapobj, 'k');
						initEcharts(_this.xzqhName, listdata, _this.xzqhName, mapobj,_this.list1);
					});
				}
				// console.log(JSON.stringify(newmap));
			}).catch((err) => {
				console.log(err + "调用接口失败");
			})
		},
		initCllxqData() {
			const path = "dpk/queryPcWorkColumSum";
			let params = {
				DistCode: this.xzqh,
				OrgCode: '',
				SumFg: '1',
				/*ProvCode: this.level === '3' ? this.xzqh : '',
					CityCode: this.level === '4' ? this.xzqh : '',
					CountyCode: this.level === '5' ? this.xzqh : '',*/
				SumLevel: this.level === '1' || this.level === '2' ? '1' : Number(this.level) - 1,
				DataDate: dayjs().format('YYYY-MM-DD')
			};
			const msgbody1 = JSON.stringify(params)
			// alert(msgbody1)
			var interface1 = axios.create({
				'Access-Control-Allow-Origin': '*',
				baseURL: board_url,
				timeout: 10000
			});
			interface1.get(path, {
				params: {
					'sendID': '00000001',
					'timestamp': timestamp,
					'msgBody': msgbody1,
					'dataDigest': base64.encode(hex_md5(msgbody1 + data_key + timestamp))
				}
			}).then(({ data }) => {
				// console.log(data,"data3333333333")
				// alert(JSON.stringify(data))
				let fata1 = {
					title: '散件外走量',
					color: '#F67767',
					value: '0',
					isUp: true,
					changeNum: '--',
					rale: '--%',
					zrtql: '0',
					zrzl: '0',
				};
				let fata2 = {
					title: '分拣封发量',
					color: '#4CD997',
					value: '0',
					isUp: false,
					changeNum: '--',
					rale: '--%',
					zrtql: '0',
					zrzl: '0',
				};
				let fata3 = {
					title: '总包经转量',
					color: '#4CD997',
					value: '0',
					isUp: false,
					changeNum: '--',
					rale: '--%',
					zrtql: '0',
					zrzl: '0',
				};
				let fata4 = {
					title: '人工填报量',
					color: '#F67767',
					value: '--',
					isUp: true,
					changeNum: '--',
					rale: '--',
					zrtql: '--',
					zrzl: '--',
				};

				if (data.resCode === 'C00001' && data.data !== null && data.data.length > 0) {
					fata1.value = data.data[0].outgoingParts;
					fata1.zrtql = data.data[0].yesOutgoingParts;
					fata1.zrzl = data.data[0].yesOutgoPartsSum;
					fata2.value = data.data[0].sortingVolume;
					fata2.zrtql = data.data[0].yesSortingVolume;
					fata2.zrzl = data.data[0].yesSortVoluSum;
					fata3.value = data.data[0].totalTurnover;
					fata3.zrtql = data.data[0].yesTotalTurnover;
					fata3.zrzl = data.data[0].yesTotTurnoverSum;
					// fata4.value = data.data[0].reportAmount;
				}
				this.$refs.data1.initData(fata1)
				this.$refs.data2.initData(fata2)
				this.$refs.data3.initData(fata3)
				this.$refs.data4.initData(fata4)
			}).catch(err => {
				console.log(err);
			});
		},

		toSecond() {
			// console.log("sonEvent")
			this.$emit('click')
		},
		initData(data) {
			this.level = data.level
			// console.log(data, '参数');
			for (let key in data) {
				this[key] = data[key]
			}
			let level = this.level 
			/*const zxsXzqh = ['110000','120000','500000','310000'];
			if (zxsXzqh.indexOf(this.xzqh) !==  -1) level = Number(level) + 1*/

			let params = {
				"distOrgCode": this.xzqh,
				"seekLevel": level.toString(),
				"orgCode": "",
				"gatherSign": "2",
				"dateHour": dayjs().format('YYYY-MM-DD')
				// "dateHour": '2020-04-23'
			};
			// console.log(params);
			this.initLinkInfos()
			setTimeout(() => {
				
				this.querydata(data);
			}, 500);
			// this.initCllxqData();
			// 调用两次问题
			// this.initRationData();
		},
	},
	mounted() { },
	filters: {
		addSpot(source) {
			if (source.length < 4) return source;
			let arr = [...source];
			let len = arr.length / 3;
			let newArr = [];
			for (let i = 0; i < len; i++) {
				let start = arr.length - 3 * (i + 1)
				let b = []
				if (start < 0) b = arr.slice(0, arr.length % 3);
				else b = arr.slice(start, arr.length - 3 * i);
				newArr.push(b.join(''));
			}
			return newArr.reverse().join(',');
		},
		addW(val) {
			if (Number(val) >= 10000) {
				return '<' + (Number(val) / 10000) + '万'
			} else return '<' + val
		}
	},

	template: `<div>
            <div class="title" style="border-radius: 10px 10px 0 0;position: relative;">
				{{module_name}}
				<div style="position: absolute; right: 8px; top: 0">
		       		<slot></slot>
		    	</div>
            </div>
            <div style=" width: 100%; border: 1px solid #e6e6e6;border-radius: 0 0 10px 10px;">
                <div id="chart_cllxq" class="content" ></div>
                <div style="margin-top: -40px; margin-bottom: 10px">
                    <div style="width: 280px; margin: 0 auto; display: flex; justify-content: space-between; ">
                        <div v-for="(i,index) in splitList" style="width: 55px; margin: 5px; text-align: center; font-size: 12px">
                            <div style="width: 100%; height: 10px" :style="{'background-color': colors[index]}"></div>
                            {{i | addW}}
                        </div>
                    </div>
                </div>
                <div>
                    
                </div>
            </div>
        </div>`
});


// 初始化地图
function initEcharts(name, data, mapType = 'china', mapJson = '',config) {
	// alert(config)
	var option = {
		visualMap: {
			show: false,
			splitList: splitListData,
			bottom: 10,
			left: 'center',
			itemWidth: 50,
			color: ['#0153B7', '#1180EC', '#38A0FF', '#71C1FF'],
			formatter: function (value) { 	// 标签的格式化工具。
				return ''; // 范围标签显示内容。
			},
			align: 'right',
			orient: 'horizontal',
		},
		tooltip: {
			textStyle: {
				color: "#fff"
			}, // 提示标签字体颜色
			formatter: function (value) {
				const val = value.data.value
				// alert(JSON.stringify(value))
				return val === 0 ? `${value.seriesName}<br/>${value.data.name}: -` :
					`${value.seriesName}<br/>${value.data.name}: ${val}`
			},
			confine: true,
		},

		series: [{
			name: name,
			type: 'map',
			mapType: mapType,
			label: {
				normal: {
					show: false, // 显示省份标签
				},
				emphasis: {
					show: false, // 对应的鼠标悬浮效果
				}
			},
			emphasis: {
				show: false,
				// 选择区域显示颜色
				itemStyle: {
					areaColor: '#fff100'
				}
			},
			itemStyle: {
				normal: {
					borderColor: '#e6e6e6',
					label: {
						show: false
					}
				},
			},
			top: 10,
			data: data 
		}],
		// 视觉映射组件
		visualMap: {
			type: 'piecewise', // 类型为分段型。
			splitNumber: '4', // 段数
			align: 'left',         
			pieces: config,
			itemWidth: '15%',
			itemHeight: '10',
			orient: 'horizontal', // 水平（'horizontal'）或者竖直（'vertical'）
			bottom: '30',
			left: 'center',
			selectedMode: 'multiple', // 'multiple'（多选）,'single'（单选）
			inRange: {
				color: ['#121122', 'rgba(3,4,5,0.4)', 'red'],
				symbolSize: [30, 100]
			}
		},
	};
	mapJson !== '' ? echarts.registerMap(mapType, mapJson) : '';
	let mychart2 = echarts.init(document.getElementById('chart_cllxq'));
	mychart2.setOption(option)

}
