// 统计指标
Vue.component('tjzb-component', {
	data() {
		return {

		}   
	},
	methods: {
		// 统计指标数据请求
		// 集包情况
		packageSituation(level, xzqh) {
			// 全量集包
			let paramsFullCollection = {
				sumLevel: level === '1' || level === '2' ? '1' : Number(level) - 1,
				distCode: xzqh,
				sumFg: '1',
				dataDate: dayjs().subtract(1, 'day').format('YYYY-MM-DD'),
				provCode: '',
				cityCode: '',
				orgCode: ''
			};
			// 应急必集
			let paramsEmergency = {
				sumLevel: level === '1' || level === '2' ? '1' : Number(level) - 1,
				distCode: xzqh,
				sumFg: '1',
				dataDate: dayjs().subtract(1, 'day').format('YYYY-MM-DD'),
				orgCode: '',
			}
			Promise.all([getFullCollectionData(paramsFullCollection), getEmergencyData(paramsEmergency) ]).then(res => {
				console.log(res, "res0000")
				if (res[0].resCode !== 'z00003') {
					if (res[0].data.length === 0) {
						initLiquid('box_1', [{
							gender: 'male',
							value: [0]
						}], '#F662FF');
					} else {
						initLiquid('box_1', [{
							gender: 'male', 
							value: [Number(res[0].data[0].collectRate.toFixed(1))]
						}], '#F662FF');
					}
				} else {
					initLiquid('box_1', [{
						gender: 'male',
						value: [0]
					}], '#F662FF');
				}
				if (res[1].data !== null) {
					if (res[1].data.length === 0) {
						initLiquid('box_2', [{
							gender: 'male',
							value: [0]
						}], '#4CD997');
					} else {
						initLiquid('box_2', [{
							gender: 'male',
							value: [Number(accMul(res[1].data[0].collectRate, 1).toFixed(1))]
						}], '#4CD997');
					}
				} else {
					initLiquid('box_2', [{
						gender: 'male',
						value: [0]
					}], '#4CD997');
				}
			}).catch(err => {
				console.log(err);
			})
		},
		processingTimeRate(level, xzqh) {
			// 特快
			let paramsExpress = {
				"businessTypes": "B",
				"dataType": "D",
				"countDate": dayjs().subtract(2, 'day').format('YYYYMMDD'),
				"areaCode": level === '1' || level === '2' ? "999999" : xzqh,
				"superiorAreaName": "",
				"regionalLevel": level === '1' || level === '2' ? '1' : Number(level) - 1
			}
			// 快包
			let paramsQuickPackage = {
				businessTypes: "K",
				dataType: "D",
				countDate: dayjs().subtract(2, 'day').format('YYYYMMDD'),
				areaCode: level === '1' || level === '2' ? "999999" : xzqh,
				superiorAreaName: "",
				regionalLevel: level === '1' || level === '2' ? '1' : Number(level) - 1,
			};
			Promise.all([getProcessingTimeRate(paramsExpress), getProcessingTimeRate(paramsQuickPackage),  ]).then(res => {
				console.log(res, "res")
				if (res[0].resCode !== 'z00003') {
					if (res[0].data.length === 0) {
						initLiquid('box_4', [{
							gender: 'male',
							value: [0]
						}], '#F662FF');
					} else {
						initLiquid('box_4', [{
							gender: 'male',
							value: [Number((res[0].data[0].timeLimit * 100).toFixed(1))]
						}], '#F662FF');
					}
				} else {
					initLiquid('box_4', [{
						gender: 'male',
						value: [0]
					}], '#F662FF');
				}
				if (res[1].resCode !== 'z00003') {
					if (res[1].data.length === 0) {
						initLiquid('box_5', [{
							gender: 'male',
							value: [0]
						}], '#4CD997');
					} else {
						initLiquid('box_5', [{
							gender: 'male',
							value: [Number((res[1].data[0].timeLimit * 100).toFixed(1))]
						}], '#4CD997');
					}
				} else {
					initLiquid('box_5', [{
						gender: 'male',
						value: [0]
					}], '#4CD997');
				}
			}).catch(err => {
				console.log(err);
			})
		},
		init_tjzb(level, xzqh) {
			document.getElementById("box_1").innerHTML = "";
			document.getElementById("box_2").innerHTML = "";
			document.getElementById("box_4").innerHTML = "";
			document.getElementById("box_5").innerHTML = "";
			// 水球图数据
			// 集包情况
			this.packageSituation(level, xzqh)
			// 内部处理
			this.processingTimeRate(level, xzqh);
		},

	},

	template:
		`
	<div style="width: 100%; margin-top: 15px; margin-bottom: 10px;">
            <div class="" style="text-align: center;font-size: 16px;
								 font-weight: 700;height:40px;line-height: 40px;
								 box-sizing: border-box;border-bottom: 1px solid #deebf4;
								 background-color: #deebf4;border-radius: 6px 6px 0 0;" >
                统计指标
            </div>
            <slot></slot>      
    </div>`
})

// 水球图
function initLiquid(id, data, color) {
	// console.log(data)
	var chart = new G2.Chart({
		container: id,
		forceFit: true,
		height: 100,
		padding: 0
	});
	chart.source(data, {
		value: {
			min: 0,
			max: 100
		}
	});
	chart.legend(false);
	chart.axis(false);  // 轴线
	chart.interval().position('gender*value').color(color)
		.shape('liquid-fill-gauge').style({
			lineWidth: 2,
			opacity: .5
		});

	data.forEach((row) => {
		chart.tooltip(false);
		chart.guide().text({
			top: true,
			position: {
				gender: row.gender,
				value: 50
			},
			content: row.value ? row.value + '%' : '--',
			style: {
				opacity: 0.9,
				fontSize: '17',
				textAlign: 'center',
				fill: row.value >= 60 ? '#FFF' : '#000'
			}
		});
	});
	chart.render();
}


