// 业务量
Vue.component('ywl-compoent', {
	data() {
		return {}
	},
	// ywlRecvData, ywlSendData
	methods: {
		// time(){

		// },
		init_ywl(x_data, ywlRecvData, ywlProData, ) {

			// let legend = ['接收量', '处理量', '发运量'];
			let legend = ['今日量', '昨日量'];
			let xData = x_data.length > 0 ? x_data : ['00:00', '01:00', '02:00', '03:00', '04:00', '05:00', '06:00', '07:00', '08:00', '09:00', '10:00', '11:00',
				'12:00', '13:00', '14:00', '15:00', '16:00', '17:00', '18:00', '19:00', '20:00', '21:00', '22:00', '23:00', '24:00'
			]
			let series = [];
			legend.forEach((e, index) => {
				let setting = {
					type: 'line',
					// data: [1],
					symbolSize: 10,
					symbol: 'circle',
					// hoverAnimation: false,
					itemStyle: {
						normal: {
							color: '#1D95F4',
							barBorderRadius: 1,
							borderColor: '#fff',
							borderWidth: 2
						}
					},
					lineStyle: {
						normal: {
							color: '#1D95F4',
							width: 2
						}
					},
					smooth: true
				}
				setting.name = e;
				if (index === 0) {
					if (ywlRecvData != null) {
						console.log(ywlRecvData, "昨日量");
						setting.data = ywlRecvData
					} else {
						setting.data = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
					}
					setting.itemStyle.normal.color = '#1D95F4';
					setting.lineStyle.normal.color = '#1D95F4';
				}
				if (index === 1) {
					if (ywlProData != null) {
						console.log(ywlProData, "今日量");
						setting.data = ywlProData
					} else {
						setting.data = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
					}
					setting.itemStyle.normal.color = '#1AE54B';
					setting.lineStyle.normal.color = '#1AE54B';
				}
				series.push(setting);
			})
			initLine('chart_ywl', legend, xData, series);
		},

	},
	props: {
		title: {
			type: String,
			required: true
		},
		id_name: {
			type: String,
			required: true
		}
	},
	mounted() {},
	template: `
	<div>
		<div  class="title">
            {{ title }}
			<div style="position: relative;">
		        <slot></slot>
		    </div>
        </div>
        <div id="chart_ywl" class="border-echaers" style="height:340px"></div>
	</div>
        `
});
//折线图
function initLine(chart_ywl, legend, xData, series) {
	console.log(series, "serios")
	var mychart2 = echarts.init(document.getElementById(chart_ywl));
	let option2 = {
		tooltip: {
			trigger: 'axis',
			axisPointer: {
				type: 'line'
			}
		},
		legend: {
			data: legend,
			x: 'center',
			y: 'bottom',
			itemGap: 30,
		},
		grid: {
			top: '13%',
			left: '3%',
			right: '4%',
			bottom: '20%',
			containLabel: true
		},
		xAxis: [{
			type: 'category',
			data: xData,
			'axisLine': {
				lineStyle: {
					color: '#90979c'
				}
			},
			'splitLine': {
				'show': false
			},
			'axisTick': {
				'show': true
			},
			'splitArea': {
				'show': false
			},
			'axisLabel': {
				'interval': 0,
				'rotate': 40
			}
		}],
		yAxis: [{
			name: '',
			type: 'value',
			// name: '及时数',
			axisLine: {
				show: false
			},
			'axisTick': {
				'show': false
			},

			axisLabel: {
				margin: 2,
				formatter: function (value, index) {
					if (value >= 10000 && value < 100000000) {
						value = value / 10000 + '万'
					} else if (value >= 100000000) {
						value = value / 100000000 + '亿'
					} else if (value <= -10000 && value > -100000000) {
						value = value / 10000 + '万'
					} else if (value <= -100000000) {
						value = value / 100000000 + '亿'
					}
					return value
				}
			}
		}],
		dataZoom: [{
			type: "slider", // 类型
			xAxisIndex: 0, // 对应的轴
			bottom: "30", // 位置，定位
			startValue: 0,
			endValue: xData.length > 7 ? 8 : xData.length - 1,
			start: dateStr / 24 * 100,
			end: dateStr / 24 * 100 + 16.6,
			/*maxValueSpan: 6,
			mixValueSpan: 6,*/
			// handleIcon: "M0,0 v9.7h5 v-9.7h-5 Z",
			handleStyle: { // 手柄的样式
				color: "#40bcf9",
				borderColor: "#1fb2fb"
			},
			backgroundColor: "#e2f3ff", // 背景
			dataBackground: { // 数据背景
				lineStyle: {
					color: "#000000"
				},
				areaStyle: {
					color: "#d4d9dd"
				}
			},
			fillerColor: "rgba(31,178,251,0.2)", // 被start和end遮住的背景*/
		}],
		series: series
		// [{
		//     data: series[0].data.length === undefined ? ['0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0'] : series[0].data,
		//     type: 'line',
		// 	color: '#1AE54B'
		// }],
	};
	mychart2.setOption(option2);
}

//千位分隔符
function toThousands(num) {
	return (num || 0).toString().replace(/(\d)(?=(?:\d{3})+$)/g, '$1,');
}

	var date = new Date();
	var year = date.getFullYear();
	var month = date.getMonth() + 1 > 9 ? date.getMonth() + 1 : "0" +
		(date.getMonth() + 1);
	var day = date.getDate() > 9 ? date.getDate() : "0" + date.getDate();
	var hour = date.getHours() > 9 ? date.getHours() : "0" +
		date.getHours();
	var minute = date.getMinutes() > 9 ? date.getMinutes() : "0" +
		date.getMinutes();
	var seconds = date.getSeconds() > 9 ? date.getSeconds() : "0" +
		date.getSeconds();

	var strDate = year + "-" + month + "-" + day + " " + hour + ":" +
		minute + ":" + seconds;
	var dateStr = hour - 1;