/**
 * 逾限量
 * @author 蔡老师
 * @time 2020.04.13
 */

Vue.component('yxl', {
    data() {
        return {
            module_name: '标题',
            data: [{
                    value: 0,
                    name: '已配发未封车',
                    itemStyle: {
                        color: "#299BE8"
                    },
                }, {
                    value: 0,
                    name: '已进局未解车',
                    itemStyle: {
                        color: "#CC7033"
                    },
                }, {
                    value: 0,
                    name: '已解车未扫描',
                    itemStyle: {
                        color: "#4A9393"
                    },
                },
                {
                    value: 0,
                    name: '已扫描未配发',
                    itemStyle: {
                        color: "#363C52"
                    },
                }
            ]
        }
    },
    template: `
    <div>
        <div class="title">
            {{module_name}}
        </div>
        <div >
            <div id="chart3" class="demoblocktwo" ></div>
        </div>
    </div>
    `,
    methods: {
        initData(data) {
            for (let key in data) {
                this[key] = data[key]
            }
            initEcharts3(this.data)

        },
    },

})

function initEcharts3(data = []) {
    // console.log(data, 'ssssssssssssss')
    let obj = {}
    data.forEach(e => {
        obj[e.name] = true
    });
    let nameData = [];
    let valueData = [];
    let dictData = [];
    let colorData = [];
    let mychart = echarts.init(document.getElementById('chart3'));
    var option = {
        legend: {
            orient: 'horizontal',
            left: 75,
            bottom: 10,
            itemGap: 20,
            // left: 'center',
            data: nameData,
            color: colorData,
            selected: obj,
            itemWidth: 10,
            itemHeight: 10,
            icon: "rect",
            data: data.map((e) => {

                nameData.push(e.name);
                valueData.push(e.value)
                colorData.push(e.itemStyle.color)
                valueData.forEach(e => {
                    this.number += e;
                });
                return e.name

            }),

        },

        graphic: [{
            type: 'text',
            left: 'center',
            top: '105',
            style: {
                text: '--',
                textAlign: 'center',
                fill: '#0099FF',
                // fill: 'rgb(149,162,255)',
                width: 30,
                height: 30,
                fontSize: 20,
                fontWeight: 700,

            }
        }, {
            type: 'text',
            left: 'center',
            top: '130',
            style: {
                text: '总量',
                textAlign: 'center',
                fill: '#000',
                // fill: 'rgb(149,162,255)',
                width: 30,
                height: 30,
                fontSize: 13,
                fontWeight: 700

            }
        }],
        tooltip: {
            trigger: 'item',
            confine: true,
            formatter: '{a} <br/>{b}: {c} ({d}%)'
        },
        series: [{
            name: '逾限量',
            type: 'pie',
            radius: ['50%', '60%'],
            center: ['50%', '40%'],
            label: {
                show: true,
                position: 'outside',
            },
            color: colorData,
            data: data,
            itemStyle: {
                labelLine: {
                    show: true
                },
                normal: {
                    label:{
                        textStyle: {
                            // color: 'black',
                            fontSize: 14,
                            fontWeight:600
                        },
                        labelLine: {
                            lineStyle: {
                                color: 'black'
                            }
                        },
                        formatter: (param) => {
                            let font = param.data.name;
                            let list = font.split('');
                            if (list.length <= 3) return list.join('') + '\n' + param.data.value;
                            else {
                                let list1 = []
                                let num = list.length / 3
                                for (let i = 0; i < num; i++) {
                                    list1.push(list.splice(0, 3).join(''))
                                }
                                return list1.join('\n') + '\n' + param.data.value;
                            }
                        },
                    },
                    // textStyle: {
                    //     color: 'black',
                    //     fontSize: 14,
                    //     fontWeight:700
                    // },
                    // labelLine: {
                    //     lineStyle: {
                    //         color: 'black'
                    //     }
                    // }
                },

                emphasis: {
                    itemStyle: {
                        shadowBlur: 10,
                        shadowOffsetX: 0,
                        shadowColor: 'rgba(0, 0, 0, 0.5)'
                    }
                }
            },
        }]
    };
    mychart.setOption(option);
}