/**2020/12/23
 * 作者: LWJ
 * 功能: 自定义指令
 * 指令说明:
 *      infinite-scroll:
 *          ->与el-table结合使用
 *          -> el-table必须设置固定高度，否则默认400高度
 */

function scroll_fun(e, binding) {
    function scrollEnd() {
        const ele = e;
        if (ele.offsetHeight + ele.scrollTop >= ele.scrollHeight){
            console.log('到底了');
            binding.value();
        }
    }
    return scrollEnd
}
Vue.directive('infinite-scroll', {
    inserted: (el, binding, vnode, oldVnode) => {
        const scrollElem = el.querySelector('.el-table__body-wrapper');
        if (!scrollElem) {
            throw '不存在'
        }
        scrollElem.style.overflowY = 'auto';
        if (!el.style.height) {
            scrollElem.style.height = '400px';
        }
        scrollElem.addEventListener('touchend', scroll_fun(scrollElem, binding));
    },
    unbind: (el, binding, vnode, oldVnode) => {
        const scrollElem = el.querySelector('.el-table__body-wrapper');
        if (!scrollElem) {
            throw '不存在'
        }
        scrollElem.removeEventListener('touchend', scroll_fun)
    }
});
