Vue.component('order_tj', {
    data() {
        return {
            isUp: true,
            color: 'green',
            rale: '80',
            title: '80%单位数',
            fontColor: '#FF7362',
            orderNum: '1000000',
            tbNum: '4520'
        }
    },
    methods: {
        init_data(data) {
            for (let key in data) {
                this[key] = data[key]
            }
        }
    },
    filters: {
        addSpot(source) {
            if (source.length < 4) return source;
            let arr = [...source];
            let len = arr.length / 3;
            let newArr = [];
            for (let i = 0; i < len; i++) {
                let start = arr.length - 3 * (i + 1)
                let b = []
                if(start < 0) b = arr.slice(0,arr.length % 3);
                else b = arr.slice(start,arr.length-3*i);
                newArr.push(b.join(''));
            }
            return newArr.reverse().join(',');
        }
    },
    template: `<div>
        <div class="progress_com">
            <div class="progress_com_item_2 order_title">
                <div style="height: 45px; line-height: 20px; text-align: center">
                    <p>订单量</p>
                    <p style="font-weight: bold; font-size: 18px; line-height: 25px" :style="{color: fontColor}">{{orderNum | addSpot}}</p>
                </div>
            </div>
            <div class="progress_com_item_2">
                <div style="position: relative; ">
                    <svg viewBox="0 0 100 100" style="max-height: 100px; margin-top: 13px;">
                        <path d="
                M 50 50
                m 0 -44
                a 44 44 0 1 1 0 88
                a 44 44 0 1 1 0 -88
                " stroke="#e5e9f2" stroke-width="11.9" fill="none"
                              style="stroke-dasharray: 276.46px, 276.46px; stroke-dashoffset: 2px;"></path>
                        <path d="
                M 50 50
                m 0 -44
                a 44 44 0 1 1 0 88
                a 44 44 0 1 1 0 -88
                " :stroke="color" fill="none" stroke-linecap="round" stroke-width="11.9" class="aaa"
                              :style="{'stroke-dasharray': (276.46 * rale / 100).toFixed(3) + 'px, 276.46px'}"></path>
                    </svg>
                    <div class="cale" :style="{color: fontColor}">
                        <i :class="isUp ? 'el-icon-caret-top' : 'el-icon-caret-bottom'"></i>{{rale}}%
                    </div>
                </div>
            </div>
            <div class="progress_com_item_2 order_title">
                <div style="height: 40px; line-height: 20px; text-align: center">
                    <p>同比</p>
                    <p style="font-weight: bold; font-size: 18px; line-height: 25px" :style="{color: fontColor}">{{tbNum | addSpot}}</p>
                </div>
            </div>   
        </div>
        <div style="text-align: center; font-weight: bold; margin-top: -5px" :style="{color: color}">
            {{title}}
        </div>
    </div>`
})

Vue.component('order_bfb', {
    data() {
        return {
            list: [
                {
                    num: '10000',
                    title: '菜鸟',
                    rale: '30%'
                },
                {
                    num: '15000',
                    title: '拼多多',
                    rale: '40%'
                }
            ]
        }
    },
    methods: {
        init_data(data) {
            for (let key in data) {
                this[key] = data[key]
            }
        }
    },
    filters: {
        addSpot(source) {
            if (source.length < 4) return source;
            let arr = [...source];
            let len = arr.length / 3;
            let newArr = [];
            for (let i = 0; i < len; i++) {
                let start = arr.length - 3 * (i + 1)
                let b = []
                if(start < 0) b = arr.slice(0,arr.length % 3);
                else b = arr.slice(start,arr.length-3*i);
                newArr.push(b.join(''));
            }
            return newArr.reverse().join(',');
        }
    },
    template: `<div>
        <div v-for="(i,index) in list" :key="index"
             style="display: flex; justify-content: space-between; width: 100%; font-size: 13px; color: #666666">
            <div style="width: 20%; padding: 0 7px">
                <p>{{i.title}}</p>
            </div>
            <div style="width: 80%; display: flex; align-items: center">
                <div style="width: 70%; height: 20px; display: flex; padding: 2px; border-radius: 5px">
                    <div class="dct_item">
                        <div style="height: 100%;" :style="{width: i.rale, 'background-color': index % 2 === 0 ? '#48DCF1' : '#1D95F4'}">

                        </div>
                    </div>
                </div>
                <div style="width: 30%; text-align: right; padding: 0 7px">
                    <p>{{i.num | addSpot}}</p>
                </div>
            </div>
        </div>
    </div>`
});


Vue.component('ddltj-component',{
    data(){
        return{

        }
    },
    methods:{
    	init_data(){
            let jrssl1 = {
                isUp: true,
                color: '#1D95F4',
                rale: '75',
                title: '今日实时量',
                fontColor: '#FF7362',   // isUp ? '#FF7362' : '#4CD998'
                orderNum: '1000000',
                tbNum: '4520'
            }
            let jrssl2 = {
                isUp: false,
                color: '#1D95F4',
                rale: '15',
                title: '协议客户订单量',
                fontColor: '#4CD998',   // isUp ? '#FF7362' : '#4CD998'
                orderNum: '650000',
                tbNum: '4520'
            }
            let jrssl3 = {
                isUp: false,
                color: '#1D95F4',
                rale: '15',
                title: '散户订单量',
                fontColor: '#4CD998',   // isUp ? '#FF7362' : '#4CD998'
                orderNum: '650000',
                tbNum: '4520'
            }
            this.$refs.jrssl1.init_data(jrssl1)
            this.$refs.xykhddl1.init_data(jrssl2)

            let list = [{
                num: '100000',
                title: '菜鸟',
               	rale: '30%'
            },
            {
                num: '150000',
                title: '拼多多',
                rale: '40%'
            },
            {
                num: '50000',
                title: '速卖通',
                rale: '35%'
            },
            {
                num: '100000',
                title: '京东',
                rale: '60%'
            },
            {
                num: '150000',
                title: '客户直连',
                rale: '50%'
            },
            {
                num: '100000',
                title: '其他',
                rale: '70%'
            }]
            this.$refs.xykhdd2.list = list

            this.$refs.shddl1.init_data(jrssl3);

            let list2 = [{
                num: '100000',
                title: '包裹柜下单',
                rale: '70%'
            },
            {
                num: '150000',
                title: '自提点下单',
                rale: '75%'
            },
            {
                num: '50000',
                title: '互联网渠道',
                rale: '35%'
            },
            {
                num: '100000',
                title: '客服下单',
                rale: '60%'
            },
            {
                num: '150000',
                title: '随机订单',
                rale: '50%'
            },
            {
                num: '100000',
                title: '其他',
                rale: '70%'
            }]	
           
            this.$refs.shddl2.list = list2
        },
    },
    template: `<div style="border-radius: 15px; width: 100%; margin-top: 15px; margin-bottom: 10px; border: 1px solid #E6E6E6; border-top: none">
            <div class="title">
                订单量统计
            </div>
            <slot></slot>
        </div>`
})


Vue.component('zxt-compoent',{
    data() {
        return {

        }
    },
    methods: {
    	init_jrddl() {
            let legend = ['今日', '昨日'];
            let xData = ['00:00', '01:00', '02:00', '03:00', '04:00', '05:00', '06:00', '07:00', '08:00', '09:00', '10:00', '11:00', '12:00', '13:00', '14:00', '当前']
            let series = [];
            legend.forEach((e, index) => {
                let setting = {
                    name: '收入',
                    type: 'line',
                    data: [20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 29, 28, 27, 26, 25, 24, 23, 23, 21, 21, 22, 23, 24],
                    symbolSize: 10,
                    symbol: 'circle',
                    itemStyle: {
                        normal: {
                            color: '#1D95F4',
                            barBorderRadius: 1,
                            borderColor: '#fff',
                            borderWidth: 2
                        }
                    },
                    lineStyle: {
                        normal: {
                            color: '#1D95F4',
                            width: 2
                        }
                    },
                    smooth: true
                }
                setting.name = e;

                if (index === 0) {
                    setting.data = [20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 29, 28, 27, 26, 25, 24, 23, 23, 21, 21, 22, 23, 24]
                    setting.itemStyle.normal.color = '#1D95F4';
                    setting.lineStyle.normal.color = '#1D95F4'
                }
                if (index === 1) {
                    setting.data = [19, 18, 17, 16, 15, 24, 25, 26, 24, 25, 26, 27, 28, 29, 28, 27, 26, 25, 24, 23, 22, 24, 21, 26]
                    setting.itemStyle.normal.color = '#1AE54B';
                    setting.lineStyle.normal.color = '#1AE54B'
                }
                series.push(setting)
            })
            console.log(series);
            initTodayZheXian('chart2', legend, xData, series)
        },
        init_lsddl() {
            let legend2 = ['总量'];
            let xData2 = ['1月','2月','3月','4月','5月','6月','7月','8月','9月','10月','11月','12月'];
            let series2 = [];
            legend2.forEach((e, index) => {
                let setting = {
                    name: '收入',
                    type: 'line',
                    data: [],
                    symbolSize: 10,
                    symbol: 'circle',
                    itemStyle: {
                        normal: {
                            color: '#1D95F4',
                            barBorderRadius: 1,
                            borderColor: '#fff',
                            borderWidth: 2
                        }
                    },
                    lineStyle: {
                        normal: {
                            color: '#1D95F4',
                            width: 2
                        }
                    },
                    smooth: true
                }
                setting.name = e;

                if (index === 0) {
                    setting.data = [216, 221, 234, 265, 102, 22, 26, 121, 134, 165, 112, 132]
                    setting.itemStyle.normal.color = '#1D95F4';
                    setting.lineStyle.normal.color = '#1D95F4'
                }
               /*
				 * if (index === 1) { setting.data = [265, 102, 22, 26, 121, 42,
				 * 216, 221, 234, 265, 102, 182] setting.itemStyle.normal.color =
				 * '#1AE54B'; setting.lineStyle.normal.color = '#1AE54B' } if
				 * (index === 2) { setting.data = [121, 42, 216, 221, 234, 42,
				 * 26, 21, 23, 65, 12, 82] setting.itemStyle.normal.color =
				 * '#1E1F89'; setting.lineStyle.normal.color = '#1E1F89' } if
				 * (index === 4) { setting.data = [121, 123, 165, 121, 182, 142,
				 * 126, 121, 123, 165, 121, 182] setting.itemStyle.normal.color =
				 * '#CD01FF'; setting.lineStyle.normal.color = '#CD01FF' } if
				 * (index === 5) { setting.data = [42, 26, 21, 23, 65, 242, 226,
				 * 212, 223, 265, 122, 282] setting.itemStyle.normal.color =
				 * '#01A572'; setting.lineStyle.normal.color = '#01A572' }
				 */
                series2.push(setting)
            });
            initHisZheXian('chart3', legend2, xData2, series2)
        },
    },
    props: {
        title: {
            type: String,
            required: true
        },
        id_name: {
            type: String,
            required: true
        }
    },
    mounted(){
    },
    template: `<div style="border-radius: 15px; width: 100%; margin-top: 15px; margin-bottom: 10px">
            <div class="title" style="position: relative;" >
                {{title}}
                <div style="position: absolute; right: 15px; top: 0">
                    <slot>
                        <p></p>
                    </slot>
                </div>
            </div>
            <div :id="id_name" class="content border_echaers"></div>
        </div>`
});

Vue.component('tjzb-component',{
    data(){
        return{

        }
    },
    methods:{
        init_data(){
        }
    },
    template: `<div style="border-radius: 15px; width: 100%; margin-top: 15px; margin-bottom: 10px; border: 1px solid #E6E6E6; border-top: none">
            <div class="title">
                统计指标
            </div>
            <slot></slot>
        </div>`
})

Vue.component('ycjk-component',{
    data(){
        return{
            ycjk: {
            	rale: 80,
                yslszl: '500000'
            }
        }
    },
    methods: {
        init_data(data) {
            for (let key in data) {
                this[key] = data[key]
            }
        }
    },
    filters: {
        addSpot(source) {
            if (source.length < 4) return source;
            let arr = [...source];
            let len = arr.length / 3;
            let newArr = [];
            for (let i = 0; i < len; i++) {
                let start = arr.length - 3 * (i + 1)
                let b = []
                if(start < 0) b = arr.slice(0,arr.length % 3);
                else b = arr.slice(start,arr.length-3*i);
                newArr.push(b.join(''));
            }
            return newArr.reverse().join(',');
        }
    },
    template: `<div
	style="border-radius: 15px; width: 100%; margin-top: 15px; margin-bottom: 10px; border: 1px solid #E6E6E6; border-top: none">
	<div class="title">异常监控</div>
	<div
		style="display: flex; justify-content: space-between; padding: 15px 8px">
		<div class="yccl" style="margin-top: 10px;">
			<div style="position: relative;">
				<svg viewBox="0 0 100 100" style="height: 110px">
                <defs>
                    <linearGradient id="blue" x1="0%"
						y1="0%" x2="100%" y2="0%">
                        <stop offset="0%"
						style="stop-color:rgb(255,51,51);  stop-opacity:1"></stop>
                        <stop offset="50%"
						style="stop-color:rgb(255,179,0);stop-opacity:1"></stop>
                        <stop offset="100%"
						style="stop-color:rgb(76,217,152);stop-opacity:1"></stop>
                    </linearGradient>
                </defs>
                <path
						d="
    M 50 50
    m 0 -44
    a 44 44 0 1 1 0 88
    a 44 44 0 1 1 0 -88
    "
						stroke="#e5e9f2" stroke-width="11.9" fill="none"
						style="stroke-dasharray: 276.46px, 276.46px; stroke-dashoffset: 2px;"></path>
                <path
						d="
    M 50 50
    m 0 -44
    a 44 44 0 1 1 0 88
    a 44 44 0 1 1 0 -88
    "
						stroke="url(#blue)" fill="none" stroke-linecap="round"
						stroke-width="11.9" class="aaa"
						:style="{'stroke-dasharray': (276.46 * ycjk.rale / 100).toFixed(3) + 'px, 276.46px'}"></path>
            </svg>
				<img src="../css/jinbao.png" alt=""
					style="position: absolute; width: 25px; top: 37%; left: 50%; transform: translate3d(-50%, -50%, 0);">
				<div class="cale" style="top: 60%; color: #000; font-size: 15px">{{ycjk.yslszl
					| addSpot}}</div>
			</div>
			<p style="color: #000; font-size: 15px; font-weight: normal;">应揽未揽总量</p>
		</div>
		<div class="yccl">
			<div style="height: 60px">
				<p
					style="color: #000; font-size: 18px; line-height: 30px; text-align: left; margin-left: 8px">协议客户量</p>
				<div style="display: flex; margin-top: 5px">
					<div v-for="i in 5" :key="i"
						style="width: 20px; height: 30px; background-color: red; margin-left: 5px; line-height: 30px">
						<span style="font-weight: bold; font-size: 16px">{{i}}</span>
					</div>
				</div>
			</div>
			<div style="height: 60px; margin-top: 5px">
				<p
					style="color: #000; font-size: 18px; line-height: 30px; text-align: left; margin-left: 8px">散户量</p>
				<div style="display: flex; margin-top: 5px">
					<div v-for="i in 4" :key="i"
						style="width: 20px; height: 30px; background-color: red; margin-left: 5px; line-height: 30px">
						<span style="font-weight: bold; font-size: 16px">{{i}}</span>
					</div>
				</div>
			</div>
		</div>
	</div>
</div>`
})
