Vue.component('worknum', {
  props: ['data'],
  data() {
    return {
      todaydownpartmenu: '总量',
      queryType: '1',
      colors: ['#71C1FF', '#38A0FF', '#1180EC', '#0153B7'],
      splitList: [
        '0-10',
        '10-30',
        '30-60',
        '≥60'
      ],
      recvNum: '0', //投递解车量
      yesRecvNum: '0', //投递解车量昨日同期
      yesRecvSum: '0', //投递解车量做日总量
      yesRecvNio: '0', //投递解车量昨日同比
      depoNum: '0', //存局量
      yesDepoNum: '0', //存局量昨日同期
      yesDepoSum: '0', //存局量昨日总量
      yesDepoNio: '0', //存局量昨日同比
      hypoNum: '0', //下段量
      yesHypoNum: '0', //下段量昨日同期
      yesHypoSum: '0', //下段量昨日总量
      yesHypoNio: '0', //下段量昨日同比
      turnbackNum: '0', //转退量
      yesTurnbackNum: '0', //转退量昨日同期
      yesTurnbackSum: '0', //转退量昨日总量
      yesTurnbackNio: '0', //转退量昨日同比
      propVoteNum: '0', //妥投量
      yesPropVoteNum: '0', //妥投量昨日同期
      yesPropVoteSum: '0', //妥投量昨日总量
      yesPropVoteNio: '0', //妥投量昨日同比
      notPropVoteNum: '0', //未妥投量
      yesNotPropVoteNum: '0', //未妥投量总日同期
      yesNotPropVoteSum: '0', //未妥投量昨日总量
      yesNotPropVoteNio: '0', //未妥投量昨日总量
      notFeedbackNum: '0', //已下段未反馈量
      yesNotFeedbackNum: '0', //已下段未反馈量昨日同期
      yesNotFeedbackSum: '0', //已下段未反馈量昨日总量
      yesNotFeedbackNio: '0', //已下段未反馈量昨日同比
      notHandNum: '0', //已解车未下段量
      yesNotHandNum: '0', //已解车未下段昨日同期
      yesNotHandSum: '0', //已解车未下段昨日总量
      yesNotHandNio: '0', //已解车未下段昨日同比

	  frequency: '', // 频次，优化后端加载速度的字段
    }
  },
  filters: {
    addSpot(source) {

      return Number(source).toLocaleString()
    },
    addW(val) {
      if (Number(val) >= 10000) {
        return '<' + (Number(val) / 10000).toFixed(1) + '万'
      } else return '<' + val
    }
  },
  methods: {
    clickMunu(params) {
      console.log(params);
      let name = ['总量', '特快', '快包', '普邮', '国际']
      this.todaydownpartmenu = name[parseInt(params) - 1]
      this.queryType = params;
      this.queryWorkDlvNumMap();
      // 传递 name 至父组件
      this.$emit('func', params)
      // 更新父组件数据
      this.$parent.queryWorkDlvNum();

    },
    init_data(data) {
      for (let key in data) {
        this[key] = data[key]
      }
      // this.queryWorkDlvNum()
      this.queryWorkDlvNumMap()
    },
    init_data2(data) {
      for (let key in data) {
        this[key] = data[key]
      }

    },
    tolist(a) {
      // alert('sssssssss')
      if (this.level > 5) {
        return
      }
      var mem = a + "-workdlv" + "-" + this.queryType + "-" + this.frequency;
      console.log(mem)
	  
	  
	  
      try {
        Emp.execute("toworkdlvlist('" + mem + "')");
      } catch (error) {
        console.error(error)
      }
    },
    init_table() {
      console.log(this.yesPropVoteio)

    },

    queryWorkDlvNumMap() {
      console.log(this.level, 'this.level')
      var new_level;
      if ((this.xzqh.substr(0, 2) == '11' || this.xzqh.substr(0, 2) == '12' || this.xzqh.substr(0, 2) == '31' || this.xzqh.substr(0, 2) == '50')) {
        new_level = this.level
        if (this.level == '4') {
          new_level = '3'
          this.xzqh = this.xzqh.substr(0, 2) + '0000';
        }
      } else new_level = Number(this.level) >= 6 ? 4 : (this.level == '1' || this.level == '2') ? '1' : this.level - 1;

      let param = {
        // 需增加产品类别代码字段
        distCode: this.xzqh,
        sumLevel: new_level, // this.level=='1'||this.level=='2'?'1':this.level-1,
        sumFg: '2',
        dataDate: '',
        mailType: this.queryType,
		frequency: '', // 频次
      }
      let msgbody1 = JSON.stringify(param)
      interface1.get('dpk/queryWorkDlvNumPc', {
        params: {
          'sendID': '00000001',
          'timestamp': timestamp,
          'msgBody': msgbody1,
          'dataDigest': base64.encode(hex_md5(msgbody1 + data_key + timestamp))
        }
      }).then(({
        data
      }) => {
        console.log(param, "param55555555555555")
        console.log(data, "request mapData-----")
        var mem = data.data;

        this.memArray = []
        mem.forEach(ele => {
          if (this.level === '1' || this.level === '2') {
            this.memArray.push({
              name: ele.distName.replace(/省|市|自治区|壮族|回族|维吾尔/g, ''),
              value: ele.recvNum.toString(),
              // value2:ele.notPropVoteNum.toString()
            })

          } else {

            this.memArray.push({
              name: ele.distName,
              value: ele.recvNum.toString(),
              // value2:ele.propVoteNum.toString()
            })

          }
        })
        this.init_echartsMap(this.level, this.xzqh, this.xzqhName)
      })
    },
    init_echartsMap(levels = 1, xzqh = '000000', xzqhName = '中国') {


      const dataMap = [{
          name: '北京',
          value: '0'
        }, {
          name: '天津',
          value: '0'
        },
        {
          name: '上海',
          value: '0'
        }, {
          name: '重庆',
          value: '0'
        },
        {
          name: '河北',
          value: '0'
        }, {
          name: '河南',
          value: '0'
        },
        {
          name: '云南',
          value: '0'
        }, {
          name: '辽宁',
          value: '0'
        },
        {
          name: '黑龙江',
          value: '0'
        }, {
          name: '湖南',
          value: '0'
        },
        {
          name: '安徽',
          value: '0'
        }, {
          name: '山东',
          value: '0'
        },
        {
          name: '新疆',
          value: '0'
        }, {
          name: '江苏',
          value: '0'
        },
        {
          name: '浙江',
          value: '0'
        }, {
          name: '江西',
          value: '0'
        },
        {
          name: '湖北',
          value: '0'
        }, {
          name: '广西',
          value: '0'
        },
        {
          name: '甘肃',
          value: '0'
        }, {
          name: '山西',
          value: '0'
        },
        {
          name: '内蒙古',
          value: '0'
        }, {
          name: '陕西',
          value: '0'
        },
        {
          name: '吉林',
          value: '0'
        }, {
          name: '福建',
          value: '0'
        },
        {
          name: '贵州',
          value: '0'
        }, {
          name: '广东',
          value: '0'
        },
        {
          name: '青海',
          value: '0'
        }, {
          name: '西藏',
          value: '0'
        },
        {
          name: '四川',
          value: '0'
        }, {
          name: '宁夏',
          value: '0'
        },
        {
          name: '海南',
          value: '0'
        }, {
          name: '台湾',
          value: 0
        }, {
          name: '南海诸岛',
          value: 0
        }
      ];

      const obj = {};
      this.memArray.forEach(ele => {
        obj[ele.name] = ele
      })
      // console.log(obj)
      var num_arr = []
      var maxInNumbers

      if (this.level == '1' || this.level == '2') {

        dataMap.forEach(ele => {
          if (obj[ele.name]) {
            ele.value = obj[ele.name].value,
              ele.code = obj[ele.name].distCode
            num_arr.push(ele.value)
          }
        })
        maxInNumbers = Math.max.apply(Math, num_arr)
        var avg = this.$parent.splitListFun(maxInNumbers).toString() == 'NaN' ? '0' : this.$parent.splitListFun(maxInNumbers)

        this.splitList = ['<' + (avg > 9999 ? avg / 10000 + '万' : avg), '<' + (2 * avg > 9999 ? 2 * avg / 10000 + '万' : 2 * avg), '<' + (3 * avg > 9999 ? 3 * avg / 10000 + '万' : 3 * avg), '<' + (4 * avg > 9999 ? 4 * avg / 10000 + '万' : 4 * avg)]
      }
      var numpjz = this.$parent.splitListFun(maxInNumbers) || 0

      var splitList = [{
          start: numpjz * 3
        },
        {
          start: numpjz * 2,
          end: numpjz * 3
        },
        {
          start: numpjz,
          end: numpjz * 2
        }, {
          start: 0,
          end: numpjz
        },
      ]



      const shengNames = {
        "110000": "北京",
        "120000": "天津",
        "130000": "河北",
        "140000": "山西",
        "150000": "内蒙古",
        "210000": "辽宁",
        "220000": "吉林",
        "230000": "黑龙江",
        "310000": "上海",
        "320000": "江苏",
        "330000": "浙江",
        "340000": "安徽",
        "350000": "福建",
        "360000": "江西",
        "370000": "山东",
        "410000": "河南",
        "420000": "湖北",
        "430000": "湖南",
        "440000": "广东",
        "450000": "广西",
        "460000": "海南",
        "500000": "重庆",
        "510000": "四川",
        "520000": "贵州",
        "530000": "云南",
        "540000": "西藏",
        "610000": "陕西",
        "620000": "甘肃",
        "630000": "青海",
        "640000": "宁夏",
        "650000": "新疆"
      }
      const code = xzqh || '000000';
      let name = shengNames[xzqh.toString()] || 'china'
      const level = Number(levels) || 1;
      let url = ''
      // alert(level)
      if (level < 3 || !level) {
        //中国地图
        name = '中国'
        if (!vm.isload) {
          vm.isload = true
        }
        initEcharts('chartworknum', dataMap, name, splitList, 'china')
        return
      }
      if (level === 3) url = `./js/sj_board/json/100000/${code}.js`
      if (level === 4) url = `./js/sj_board/json/100000/${code.substring(0, 2) + '0000'}/${code}.js`
      let listdata = [];
      const testFun = (path, callback) => {
        console.log(123)
        var head = document.getElementsByTagName('head')[0];

        if (!document.getElementById(hex_md5(path))) {
          var script = document.createElement('script');
          script.type = 'text/javascript';
          script.id = hex_md5(path);
          script.src = path;
          console.log(path)
          head.appendChild(script);

          if (! /*@cc_on!@*/ false) {
            script.onload = function () {
              console.log("非ie");
              callback();
            }
          } else {
            script.onreadystatechange = function () {
              if (script.readystate === "loaded" || script.readState === 'complate') {
                console.log("ie");
                callback();
              }
            }
          }
        } else {
          callback();
        }
      }
      testFun(url, () => {
        console.log('load over')
        mapobj.features.forEach(i => {
          // 替换了北京110100，天津120100，上海310100，重庆500100等4个直辖市的地图json，
          // 其中新地图json中中不包含adcode字段，但其中的id与原地图中的adcode含义一致，
          // 为防止字段找不到而报错，因此转换字段
          i.properties.adcode = i.properties.adcode ? i.properties.adcode : i.properties.id
          listdata.push({
            name: i.properties.name,
            code: i.properties.adcode,
            value: 0
          })
        })
        console.log(listdata)
        if (!vm.isload) {
          vm.isload = true
        }
        // initEcharts('chartworknum',listdata, name, splitList, name, mapobj)
        listdata.forEach(ele => {
          if (obj[ele.name]) {
            ele.value = obj[ele.name].value
            num_arr.push(ele.value)
          }
        })
        maxInNumbers = Math.max.apply(Math, num_arr)
        var avg = this.$parent.splitListFun(maxInNumbers).toString() == 'NaN' ? '0' : this.$parent.splitListFun(maxInNumbers)
        this.splitList = ['<' + (avg > 9999 ? avg / 10000 + '万' : avg), '<' + (2 * avg > 9999 ? 2 * avg / 10000 + '万' : 2 * avg), '<' + (3 * avg > 9999 ? 3 * avg / 10000 + '万' : 3 * avg), '<' + (4 * avg > 9999 ? 4 * avg / 10000 + '万' : 4 * avg)]
        numpjz = this.$parent.splitListFun(maxInNumbers) || 0
        splitList = [{
            start: numpjz * 3
          },
          {
            start: numpjz * 2,
            end: numpjz * 3
          },
          {
            start: numpjz,
            end: numpjz * 2
          }, {
            start: 0,
            end: numpjz
          },
        ]
        //console.log('....................',name);
        initEcharts('chartworknum', listdata, xzqhName, splitList, null, mapobj)

      })

    },
    toxiazuan(e) {
      console.log(e)
    },

  },
  mounted() {
    // this.init_echartsMap()
  },
  template: `<div id="worknum" class="b-s-gray br-10 m-b-10">
  <div class="charttitle">
    作业量统计
    <div style="position: absolute; right: 15px; top: 0">
      <el-dropdown @command="clickMunu" :trigger="'click'" ref="lll">
          <span class="el-dropdown-link">
              {{todaydownpartmenu}}<i class="el-icon-caret-bottom" style="margin-top: -13px"></i>
          </span>
          <el-dropdown-menu slot="dropdown">
              <el-dropdown-item command="1">总量</el-dropdown-item>
              <el-dropdown-item command="2">特快</el-dropdown-item>
              <el-dropdown-item command="3">快包</el-dropdown-item>
              <el-dropdown-item command="4">普邮</el-dropdown-item>
              <el-dropdown-item command="5">国际</el-dropdown-item>
          </el-dropdown-menu>
      </el-dropdown>
  </div>
  </div>
  <div id=chartworknum></div>
  <div style="border-left: 1px solid #e6e6e6; margin-top: -50px; margin-bottom: 10px">
    <div style="width: 280px; margin: 0 auto; display: flex; justify-content: space-between; ">
      <div v-for="(i,index) in splitList" style="width: 55px; margin: 5px; text-align: center; font-size: 12px">
        <div style="width: 100%; height: 10px" :style="{'background-color': colors[index]}"></div>
        {{i}}
      </div>
    </div>
  </div>
  <div class="content-data">
    <!-- 第一行 -->
    <div class="content-data-1">
      <div class="sszl-l fl is-b" @click="">
        <div class="color-blue" >投递解车实时量</div>
        <div :class="recvNum - yesRecvNum<0?'color-red':'color-green'" @click="tolist('recvNum')">
        {{recvNum | addSpot}}
        </div>
      </div>
      <div class="sszl-r fl">
        <ul class="content-data-items">
          <li>
            <div>
              同比
              <span  :class="recvNum - yesRecvNum>=0?'is-up':'is-down'"></span>
            </div>
            <div class="is-b" :class="recvNum - yesRecvNum<0?'color-red':'color-green'">
            {{(recvNum - yesRecvNum) | addSpot}}
            </div>
          </li>
          <li>
            <div>
              同比率
              <span :class="yesRecvNio >=0?'is-up':'is-down'"></span>
            </div>
            <div  class="is-b" :class="yesRecvNio <0?'color-red':'color-green'">{{yesRecvNio+'%'}}</div>
        
          </li>
          <li>
            <div>昨日同期量</div>
            <div class="is-b" v-text="$options.filters.addSpot( yesRecvNum)">
            
            </div>
          </li>
          <li>
            <div>昨日总量</div>
            <div class="is-b" v-text="$options.filters.addSpot(yesRecvSum)"></div>
          </li>
        </ul>
      </div>
    </div>
    <!-- 第二行 -->
    <div class="content-data-2">
      <div class="content-data-2-item" style="border-right: 1px solid #cccccc;">
        <div class="color-blue is-b table-title-s">留存量</div>
        <ul class="content-data-items">
          <li style="border-right: none;">
            
            <div :class="yesDepoNio>=0?'color-red':'color-green'" 
              v-text="$options.filters.addSpot (depoNum)" @click="tolist('depoNum')" class="is-b"></div>
          </li>
          <li>
            <div :class="yesDepoNio>=0?'is-up-color':'is-down-color'">{{(depoNum - yesDepoNum) | addSpot}}</div>
            <div :class="yesDepoNio>=0?'is-up-color':'is-down-color'">{{yesDepoNio+'%'}}</div>
          </li>
          <li>
            <div>昨日同期量</div>
            <div class="is-b">{{yesDepoNum | addSpot}}</div>
          </li>
          <li>
            <div>昨日总量</div>
            <div class="is-b">{{yesDepoSum | addSpot}}</div>
          </li>
        </ul>
      </div>
      <div class="content-data-2-item">
        <div class="color-blue is-b table-title-s">下段量</div>
        <ul class="content-data-items">
          <li style="border-right: none;">
            
            <div class=" is-b" :class="yesHypoNio<0?'color-red':'color-green'"
              @click="tolist('hypoNum')">{{hypoNum | addSpot}}</div>
          </li>
          <li>
            <div :class="yesHypoNio>=0?'is-up':'is-down'">{{(hypoNum-yesHypoNum) | addSpot}}</div>
            <div :class="yesHypoNio>=0?'is-up':'is-down'">{{yesHypoNio+'%'}}</div>
          </li>
          <li>
            <div>昨日同期量</div>
            <div class="is-b">{{yesHypoNum | addSpot}}</div>
          </li>
          <li>
            <div>昨日总量</div>
            <div class="is-b">{{yesHypoSum | addSpot}}</div>
          </li>
        </ul>
      </div>
    </div>
    <!-- 第三行 -->
    <div class="content-data-2">
      <div class="content-data-2-item" style="border-right: 1px solid #cccccc;">
        <div class="color-blue is-b table-title-s">转退量</div>  
        <ul class="content-data-items">
          <li style="border-right: none;">
           
            <div class=" is-b" :class="turnbackNum - yesTurnbackNum>=0?'color-red':'color-green'"
            @click="tolist('turnbackNum')">{{turnbackNum | addSpot}}</div>
          </li>
          <li>
          <div :class="yesTurnbackNio>=0?'is-up-color':'is-down-color'">{{(turnbackNum-yesTurnbackNum) | addSpot}}</div>
          <div :class="yesTurnbackNio>=0?'is-up-color':'is-down-color'">{{yesTurnbackNio+'%'}}</div>
          </li>
          <li>
            <div>昨日同期量</div>
            <div class="is-b">{{yesTurnbackNum | addSpot}}</div>
          </li>
          <li>
            <div>昨日总量</div>
            <div class="is-b">{{yesTurnbackSum | addSpot}}</div>
          </li>
        </ul>
      </div>
      <div class="content-data-2-item">
        <div class="color-blue is-b table-title-s">妥投量</div>
          <ul class="content-data-items">
            <li style="border-right: none;">
              
              <div class=" is-b" :class="yesPropVoteNio<0?'color-red':'color-green'"
                @click="tolist('propVoteNum')">{{propVoteNum | addSpot}}</div>
            </li>
            <li>
              <div :class="yesPropVoteNio>=0?'is-up':'is-down'">{{(propVoteNum-yesPropVoteNum) | addSpot}}</div>
              <div :class="yesPropVoteNio>=0?'is-up':'is-down'">{{yesPropVoteNio+'%'}}</div>
            </li>
            <li>
              <div>昨日同期量</div>
              <div class="is-b">{{yesPropVoteNum | addSpot}}</div>
            </li>
            <li>
              <div>昨日总量</div>
              <div class="is-b">{{yesPropVoteSum | addSpot}}</div>
            </li>
          </ul>
        </div>
      </div> 
      <!-- 第四行 -->
    <div class = "content-data-2">
      <div class="content-data-2-item" style="border-right: 1px solid #cccccc;">
        <div class="color-blue is-b table-title-s">未妥投量</div>  
        <ul class="content-data-items">
          <li style="border-right: none;">
          
          <div class=" is-b" :class="notPropVoteNum - yesNotPropVoteNum>=0?'color-red':'color-green'"
          @click="tolist('notPropVoteNum')">{{notPropVoteNum | addSpot}}</div>
          </li>
          <li>
          <div :class="yesNotPropVoteNio>=0?'is-up-color':'is-down-color'">{{(notPropVoteNum-yesNotPropVoteNum) | addSpot}}</div>
          <div :class="yesNotPropVoteNio>=0?'is-up-color':'is-down-color'">{{yesNotPropVoteNio+'%'}}</div>
          </li>
          <li>
          <div>昨日同期量</div>
          <div class="is-b">{{yesNotPropVoteNum | addSpot}}</div>
          </li>
          <li>
          <div>昨日总量</div>
          <div class="is-b">{{yesNotPropVoteSum | addSpot}}</div>
          </li>
        </ul>
      </div>
      <div class="content-data-2-item"></div>
    </div>
  </div>
    
</div>
</div>`,


});


Vue.component('delivernum', {
  props: ['data'],
  data() {
    return {
      isinit: false,
      isdelivered: true,
      ispipexpress: 1,
      colors: ['#71C1FF', '#38A0FF', '#1180EC', '#0153B7'],
      splitList: [

      ],

      names: [
        ['本人签收', '需再投'],
        ['他人代收', '待退回'],
        ['自提点代收', '自取'],
        ['单位收发室签收', '撤回'],
        ['投包裹柜', '改址'],
        ['其他']
      ],
      propVoteNum: '0', //妥投量总量
      yesPropVoteNum: '0', //妥投量总量昨日同期
      yesPropVoteSum: '0', //妥投量总量昨日总量
      yesPropVoteio: '0', //妥投量总量昨日同比
      selfNum: '0', //妥投量本人签收
      yesSelfNum: '0', //妥投量本人签收昨日同期
      yesSelfSum: '0', //妥投量本人签收昨日总量
      yesSelfio: '0', //妥投量本人签收昨日同比
      otherPeopleNum: '0', //妥投量他人代收
      yesOtherPeopleNum: '0', //妥投量他人代收昨日同期
      yesOtherPeopleSum: '0', //妥投量他人代收昨日总量
      yesOtherPeopleio: '0', //妥投量他人代收昨日同比
      selfPickupNum: '0', //妥投量自提点代收
      yesSelfPickupNum: '0', //妥投量自提点代收昨日同期
      yesSelfPickupSum: '0', //妥投量自提点代收昨日总量
      yesSelfPickupio: '0', //妥投量自提点代收昨日同比
      mailRoomNum: '0', //妥投量单位收发室签收
      yesMailRoomNum: '0', //妥投量单位收发室签收昨日同期
      yesMailRoomSum: '0', //妥投量单位收发室签收昨日总量
      yesMailRoomio: '0', //妥投量单位收发室签收昨日同比
      parcelCabinetNum: '0', //妥投量投包裹柜
      yesParcelCabinetNum: '0', //妥投量投包裹柜昨日同期
      yesParcelCabinetSum: '0', //妥投量投包裹柜昨日总量
      yesParcelCabinetio: '0', //妥投量投包裹柜昨日同比
      dlvOtherNum: '0', //妥投量其他
      yesDlvOtherNum: '0', //妥投量其他昨日同期
      yesDlvOtherSum: '0', //妥投量其他昨日总量
      yesDlvOtherio: '0', //妥投量其他昨日同比
      notPropVoteNum: '0', //未妥投量总量
      yesNotPropVoteNum: '0', //未妥投量总量昨日同期
      yesNotPropVoteSum: '0', //未妥投量总量昨日总量
      yesNotPropVoteio: '0', //未妥投量总量昨日同比
      nedDlvNum: '0', //未妥投量需再投
      yesNedDlvNum: '0', //未妥投量需再投昨日同期
      yesNedDlvSum: '0', //未妥投量需再投昨日总量
      yesNedDlvio: '0', //未妥投量需再投昨日同比
      waitReturn: '0', //未妥投量待退回
      yesWaitReturn: '0', //未妥投量待退回昨日同期
      yesWaitReturnSum: '0', //未妥投量待退回昨日总量
      yesWaitReturnio: '0', //未妥投量待退回昨日同比
      reqCollectNum: '0', //未妥投量自取
      yesReqCollectNum: '0', //未妥投量自取昨日同期
      yesReqCollectSum: '0', //未妥投量自取昨日总量
      yesReqCollectio: '0', //未妥投量自取昨日同比
      retreNum: '0', //未妥投量撤回
      yesRetreNum: '0', //未妥投量撤回昨日同期
      yesRetreSum: '0', //未妥投量撤回昨日总量
      yesRetreio: '0', //未妥投量撤回
      chgAddress: '0', //未妥投量改址
      yesChgAddress: '0', //未妥投量改址昨日同期
      yesChgAddressSum: '0', //未妥投量改址昨日总量
      yesChgAddressio: '0', //未妥投量改址昨日同比
      notVoteOther: '0', //未妥投量其他总量
      yesNotVoteOther: '0', //未妥投量其他总量昨日同期
      yesNotVoteOtherSum: '0', //未妥投量其他总量昨日总量
      yesNotVoteOtherio: '0', //未妥投量其他总量昨日同比
      memArray: [],
	   frequency: '', // 频次，优化后端加载速度的字段
    }
  },
  filters: {
    addSpot(source) {

      return Number(source).toLocaleString()
    },
    addW(val) {
      if (Number(val) <= 10000) {
        return '<' + (Number(val) / 10000).toFixed(1) + '万'
      } else return '<' + val
    }
  },
  methods: {
    tolist(a) {
      if (this.level > 5) {
        return
      }
      console.log(a, "6656656565656")
      var mem = a + "-" + this.ispipexpress + '-' + this.frequency
	  
	  
	  
      try {
        Emp.execute("todlvlist('" + mem + "')");
      } catch (error) {
        console.error(error)
      }
    },
    init_echartsMap(levels = 1, xzqh = '000000', xzqhName) {
      const flag = this.isdelivered

      const dataMap = [{
          name: '北京',
          value: '0'
        }, {
          name: '天津',
          value: '0'
        },
        {
          name: '上海',
          value: '0'
        }, {
          name: '重庆',
          value: '0'
        },
        {
          name: '河北',
          value: '0'
        }, {
          name: '河南',
          value: '0'
        },
        {
          name: '云南',
          value: '0'
        }, {
          name: '辽宁',
          value: '0'
        },
        {
          name: '黑龙江',
          value: '0'
        }, {
          name: '湖南',
          value: '0'
        },
        {
          name: '安徽',
          value: '0'
        }, {
          name: '山东',
          value: '0'
        },
        {
          name: '新疆',
          value: '0'
        }, {
          name: '江苏',
          value: '0'
        },
        {
          name: '浙江',
          value: '0'
        }, {
          name: '江西',
          value: '0'
        },
        {
          name: '湖北',
          value: '0'
        }, {
          name: '广西',
          value: '0'
        },
        {
          name: '甘肃',
          value: '0'
        }, {
          name: '山西',
          value: '0'
        },
        {
          name: '内蒙古',
          value: '0'
        }, {
          name: '陕西',
          value: '0'
        },
        {
          name: '吉林',
          value: '0'
        }, {
          name: '福建',
          value: '0'
        },
        {
          name: '贵州',
          value: '0'
        }, {
          name: '广东',
          value: '0'
        },
        {
          name: '青海',
          value: '0'
        }, {
          name: '西藏',
          value: '0'
        },
        {
          name: '四川',
          value: '0'
        }, {
          name: '宁夏',
          value: '0'
        },
        {
          name: '海南',
          value: '0'
        }, {
          name: '台湾',
          value: '0'
        },
        {
          name: '南海诸岛',
          value: '0'
        }
      ];
      const obj = {}
      this.memArray.forEach(ele => {
        obj[ele.name] = ele
      })
      var num_arr = []
      var maxInNumbers
      if (this.level == '1' || this.level == '2') {

        dataMap.forEach(ele => {
          if (obj[ele.name]) {
            ele.value = flag ? obj[ele.name].value : obj[ele.name].value2,
              ele.code = obj[ele.name].distCode
            num_arr.push(ele.value)
          }
        })
        maxInNumbers = Math.max.apply(Math, num_arr)
        var avg = this.$parent.splitListFun(maxInNumbers).toString() == 'NaN' ? '0' : this.$parent.splitListFun(maxInNumbers)

        this.splitList = ['<' + (avg > 9999 ? avg / 10000 + '万' : avg), '<' + (2 * avg > 9999 ? 2 * avg / 10000 + '万' : 2 * avg), '<' + (3 * avg > 9999 ? 3 * avg / 10000 + '万' : 3 * avg), '<' + (4 * avg > 9999 ? 4 * avg / 10000 + '万' : 4 * avg)]
      }
      var numpjz = this.$parent.splitListFun(maxInNumbers) || 0

      var splitList = [{
          start: numpjz * 3
        },
        {
          start: numpjz * 2,
          end: numpjz * 3
        },
        {
          start: numpjz,
          end: numpjz * 2
        }, {
          start: 0,
          end: numpjz
        },
      ]

      const shengNames = {
        "110000": "北京",
        "120000": "天津",
        "130000": "河北",
        "140000": "山西",
        "150000": "内蒙古",
        "210000": "辽宁",
        "220000": "吉林",
        "230000": "黑龙江",
        "310000": "上海",
        "320000": "江苏",
        "330000": "浙江",
        "340000": "安徽",
        "350000": "福建",
        "360000": "江西",
        "370000": "山东",
        "410000": "河南",
        "420000": "湖北",
        "430000": "湖南",
        "440000": "广东",
        "450000": "广西",
        "460000": "海南",
        "500000": "重庆",
        "510000": "四川",
        "520000": "贵州",
        "530000": "云南",
        "540000": "西藏",
        "610000": "陕西",
        "620000": "甘肃",
        "630000": "青海",
        "640000": "宁夏",
        "650000": "新疆"
      }
      const code = xzqh || '000000';
      let name = shengNames[xzqh.toString()] || 'china'
      const level = Number(levels) || 1;
      if (level < 3 || !level) {
        //中国地图
        name = '中国'

        initEcharts('chartdelivernum', dataMap, name, splitList, 'china')
        return
      }
      if (level === 3) url = `./js/sj_board/json/100000/${code}.js`
      if (level === 4) url = `./js/sj_board/json/100000/${code.substring(0, 2) + '0000'}/${code}.js`
      var listdata = [];
      const testFun = (path, callback) => {
        var head = document.getElementsByTagName('head')[0];

        if (!document.getElementById(hex_md5(path))) {
          var script = document.createElement('script');
          script.type = 'text/javascript';
          script.id = hex_md5(path);
          script.src = path;
          head.appendChild(script);


          if (! /*@cc_on!@*/ false) {
            script.onload = function () {
              console.log("非ie");
              callback();
            }
          } else {
            script.onreadystatechange = function () {
              if (script.readystate === "loaded" || script.readState === 'complate') {
                console.log("ie");
                callback();
              }
            }
          }
        } else {
          callback();
        }
      }
      testFun(url, () => {
        console.log('load over')
        mapobj.features.forEach(i => {
          // 替换了北京110100，天津120100，上海310100，重庆500100等4个直辖市的地图json，
          // 其中新地图json中中不包含adcode字段，但其中的id与原地图中的adcode含义一致，
          // 为防止字段找不到而报错，因此转换字段
          i.properties.adcode = i.properties.adcode ? i.properties.adcode : i.properties.id
          listdata.push({
            code: i.properties.adcode,
            name: i.properties.name,
            value: 0
          })



        })

        if (!vm.isload) {
          vm.isload = true
        }
        listdata.forEach(ele => {
          if (obj[ele.name]) {
            ele.value = flag ? obj[ele.name].value : obj[ele.name].value2
            num_arr.push(ele.value)
          }
        })
        maxInNumbers = Math.max.apply(Math, num_arr)
        var avg = this.$parent.splitListFun(maxInNumbers).toString() == 'NaN' ? '0' : this.$parent.splitListFun(maxInNumbers)

        this.splitList = ['<' + (avg > 9999 ? avg / 10000 + '万' : avg), '<' + (2 * avg > 9999 ? 2 * avg / 10000 + '万' : 2 * avg), '<' + (3 * avg > 9999 ? 3 * avg / 10000 + '万' : 3 * avg), '<' + (4 * avg > 9999 ? 4 * avg / 10000 + '万' : 4 * avg)]
        numpjz = this.$parent.splitListFun(maxInNumbers) || 0
        splitList = [{
            start: numpjz * 3
          },
          {
            start: numpjz * 2,
            end: numpjz * 3
          },
          {
            start: numpjz,
            end: numpjz * 2
          }, {
            start: 0,
            end: numpjz
          },
        ]
        initEcharts('chartdelivernum', listdata, xzqhName, splitList, null, mapobj)

      })


    },
    choseexpress(a) {
      this.ispipexpress = a
      this.$forceUpdate()
      this.querydeliverStatis()
      this.querydeliverStatisMap()
    },
    choseisdelivered(e) {
      // alert(e)
      this.isdelivered = e
      this.$forceUpdate()
      this.querydeliverStatisMap()
    },
    init_data(data) {
      for (let key in data) {
		
        this[key] = data[key]
      }
      this.querydeliverStatis()
      this.querydeliverStatisMap()
    },
    init_data2(a) {
		console.log('mmmmmmmmmmmm')
      for (let key in a) {
		  console.log(key+":"+a[key])
        this[key] = a[key]
      }
    },
    querydeliverStatis() {
      var new_level;
      // 直辖市的code、level不做处理
      if ((this.xzqh.substr(0, 2) == '11' || this.xzqh.substr(0, 2) == '12' || this.xzqh.substr(0, 2) == '31' || this.xzqh.substr(0, 2) == '50')) {
        new_level = this.level
        if (this.level == '4') {
          new_level = '3'
          this.xzqh = this.xzqh.substr(0, 2) + '0000';
        }
      } else new_level = Number(this.level) >= 6 ? 4 : (this.level == '1' || this.level == '2') ? '1' : this.level - 1;
      let param = {
        distCode: this.xzqh,
        sumLevel: new_level, // this.level=='1'||this.level=='2'?'1':this.level-1,
        mailType: this.ispipexpress,
        sumFg: '1',
        dataDate: ''
      }
      let msgbody1 = JSON.stringify(param)
      interface1.get('dpk/queryDeliveryStatisData', {
        params: {
          'sendID': '00000001',
          'timestamp': timestamp,
          'msgBody': msgbody1,
          'dataDigest': base64.encode(hex_md5(msgbody1 + data_key + timestamp))
        }
      }).then(({
        data
      }) => {
        // console.log(data, 'data')
        var mem = data.data[0];
        this.init_data2(mem)
      }).catch(err => {
        console.log(err);

      });
    },
    querydeliverStatisMap() {
      var new_level;
      // 直辖市的code、level不做处理
      if ((this.xzqh.substr(0, 2) == '11' || this.xzqh.substr(0, 2) == '12' || this.xzqh.substr(0, 2) == '31' || this.xzqh.substr(0, 2) == '50')) {
        new_level = this.level
        if (this.level == '4') {
          new_level = '3'
          this.xzqh = this.xzqh.substr(0, 2) + '0000';
        }
      } else new_level = Number(this.level) >= 6 ? 4 : (this.level == '1' || this.level == '2') ? '1' : this.level - 1;
      let param = {
        distCode: this.xzqh,
        sumLevel: new_level, // this.level=='1'||this.level=='2'?'1':this.level-1,
        mailType: this.ispipexpress,
        sumFg: '2',
        dataDate: ''
      }
      let msgbody1 = JSON.stringify(param)
      interface1.get('dpk/queryDeliveryStatisData', {
        params: {
          'sendID': '00000001',
          'timestamp': timestamp,
          'msgBody': msgbody1,
          'dataDigest': base64.encode(hex_md5(msgbody1 + data_key + timestamp))
        }
      }).then(({
        data
      }) => {
        console.log('paramsssss')
        console.log(data, '---妥投量----未妥投量----')
        var mem = data.data;

        this.memArray = []
        mem.forEach(ele => {

          if (this.isdelivered) {
            if (this.level === '1' || this.level === '2') {

              this.memArray.push({
                name: ele.distName.replace(/省|市|自治区|壮族|回族|维吾尔/g, ''),
                value: ele.propVoteNum.toString(),
                value2: ele.notPropVoteNum.toString()
              })

            } else {

              this.memArray.push({
                name: ele.distName,
                value: ele.propVoteNum.toString(),
                value2: ele.propVoteNum.toString()
              })

            }

          } else {
            if (this.level === '1' || this.level === '2') {

              this.memArray.push({
                name: ele.distName.replace(/省|市|自治区|壮族|回族|维吾尔/g, ''),
                value: ele.propVoteNum.toString(),
                value2: ele.notPropVoteNum.toString()
              })

            } else {


              this.memArray.push({
                name: ele.distName,
                value: ele.propVoteNum.toString(),
                value2: ele.notPropVoteNum.toString()
              })
            }
          }


        })
        this.init_echartsMap(this.level, this.xzqh, this.xzqhName)
      }).catch(err => {
        console.log(err);

      });
    }
  },
  mounted() {
    // this.init_echartsMap()
  },
  template: `
  <div id="delivernum" class="br-10 m-b-10 b-s-gray">
    <div class="charttitle">
      投递量统计
    </div>
  <div v-show='false' class="item-box">
      <div class="color-gray bold bg-pda fontsize-16 w-50">
        <div class="p-t-10 fontsize-14">
          PDA登录数
        </div>
        <div class="color-blue bold">
          -
        </div>
      </div>
      <div class="color-gray bold bg-deliver fontsize-16 w-50">
        <div class="p-t-10 fontsize-14">
          人均投递量
        </div>
        <div class="color-blue bold">
          -
        </div>
      </div>
    </div>
    <div class="item-box">
      <div class="w-50 bg-deepblue  fontsize-16 color-white h-40 lh-40"
        :class="isdelivered ? 'chosed':''" @click="choseisdelivered(true)">
        妥投量
      </div>
      <div class="w-50 bg-deepblue fontsize-16 color-white h-40 lh-40"
      :class="isdelivered ? '':'chosed'" @click="choseisdelivered(false)">
        未妥投量
      </div>
    </div>
    <div class="item-box">
      <div class="w-50 bg-gray color-gray fontsize-16 h-40 lh-40"
        :class="ispipexpress==1 ? 'chosed2':''" @click="choseexpress(1)">
        特快
      </div>
      <div class="w-50 bg-gray color-gray fontsize-16 h-40 lh-40"
      :class="ispipexpress==1 ? '':'chosed2'" @click="choseexpress(2)">
        快包
      </div>
    </div>
    <div id="chartdelivernum"></div>
    <div style="border-left: 1px solid #e6e6e6; margin-top: -50px; margin-bottom: 10px">
      <div style="width: 280px; margin: 0 auto; display: flex; justify-content: space-between; ">
        <div v-for="(i,index) in splitList" style="width: 55px; margin: 5px; text-align: center; font-size: 12px">
          <div style="width: 100%; height: 10px" :style="{'background-color': colors[index]}"></div>
          {{i}}
        </div>
      </div>
    </div>
    <div class="content-data">
    <!-- 第一行 -->
    <div class="content-data-1" v-if="isdelivered">
      <div class="sszl-l fl is-b" @click='tolist("propVoteNum")'>
        <div class="color-blue">总量</div>
        <div :class="yesPropVoteio<=0 ?'color-red':'color-green'">{{propVoteNum | addSpot}}</div>
      </div>
      <div class="sszl-r fl">
        <ul class="content-data-items">
          <li>
            <div>
              同比
              <span :class="propVoteNum - yesPropVoteNum>=0 ?'is-up' : 'is-down'"></span>
            </div>
            <div class="is-b" :class="propVoteNum - yesPropVoteNum<=0 ?'color-red' : 'color-green'">
              {{(propVoteNum - yesPropVoteNum) | addSpot}}
            </div>
          </li>
          <li>
            <div>
              同比率
              <span :class="yesPropVoteio>=0 ?'is-up': 'is-down'"></span>
            </div>
            <div class="is-b" :class="yesPropVoteio<=0 ?'color-red': 'color-green'">
              {{yesPropVoteio+'%'}}
            </div>
          </li>
          <li>
            <div>昨日同期量</div>
            <div class="is-b">{{yesPropVoteNum| addSpot}}</div>
          </li>
          <li>
            <div>昨日总量</div>
            <div class="is-b">{{yesPropVoteSum| addSpot}}</div>
          </li>
        </ul>
      </div>
    </div>
    <div class="content-data-1" v-if="!isdelivered">
      <div class="sszl-l fl is-b" @click="tolist('notPropVoteNum')">
        <div class="color-blue">总量</div>
        <div :class="yesNotPropVoteio>0?'color-red':'color-green'" >{{notPropVoteNum| addSpot}}</div>
      </div>
      <div class="sszl-r fl">
        <ul class="content-data-items">
          <li>
            <div>
              同比
              <span :class="notPropVoteNum - yesNotPropVoteNum>=0?'is-up-color':'is-down-color'"></span>
            </div>
            <div :class="notPropVoteNum - yesNotPropVoteNum>0?'color-red':'color-green'">
              {{(notPropVoteNum - yesNotPropVoteNum)| addSpot}}
            </div>
          </li>
          <li>
            <div>
              同比率
              <span :class="yesNotPropVoteio >=0 ?'is-up-color':'is-down-color'"></span>
            </div>
            <div :class="yesNotPropVoteio >0 ?'color-red':'color-green'">
              {{yesNotPropVoteio+'%'}}
            </div>
          </li>
          <li>
            <div>昨日同期量</div>
            <div class="is-b">{{yesNotPropVoteNum| addSpot}}</div>
          </li>
          <li>
            <div>昨日总量</div>
            <div class="is-b">{{yesNotPropVoteSum| addSpot}}</div>
          </li>
        </ul>
      </div>
    </div>
    <!-- 第二行 -->
    <div class="content-data-2">
      <div class="content-data-2-item" style="border-right: 1px solid #cccccc;">
        <div class="color-blue is-b table-title-s" v-text="isdelivered?names[0][0]:names[0][1]"></div>
        <ul class="content-data-items" v-if="isdelivered">
          <li style="border-right: none;"@click="tolist('selfNum')">
            
            <div class=" is-b" :class="yesSelfio<=0?'color-red':'color-green'">{{selfNum| addSpot}}</div>
          </li>
          <li>
            <div :class="selfNum -yesSelfNum>=0 ?'is-up':'is-down'">{{(selfNum -yesSelfNum)| addSpot }}</div>
            <div :class="yesSelfio>=0 ? 'is-up':'is-down'">{{yesSelfio+'%'}}</div>
          </li>
          <li>
            <div>昨日同期量</div>
            <div class="is-b">{{yesSelfNum| addSpot}}</div>
          </li>
          <li>
            <div>昨日总量</div>
            <div class="is-b">{{yesSelfSum| addSpot}}</div>
          </li>
        </ul>
        <ul class="content-data-items" v-if="!isdelivered">
          <li style="border-right: none;"@click="tolist('nedDlvNum')">
            
            <div class=" is-b" :class="yesNedDlvio>0?'color-red':'color-green'">{{nedDlvNum| addSpot}}</div>
          </li>
          <li>
            <div :class="nedDlvNum - yesNedDlvNum>=0?'is-up-color':'is-down-color'">
              {{(nedDlvNum - yesNedDlvNum)| addSpot}}
            </div>
            <div :class="yesNedDlvio>=0?'is-up-color':'is-down-color'">{{yesNedDlvio+'%'}}</div>
          </li>
          <li>
            <div>昨日同期量</div>
            <div class="is-b">{{yesNedDlvNum| addSpot}}</div>
          </li>
          <li>
            <div>昨日总量</div>
            <div class="is-b">{{yesNedDlvSum| addSpot}}</div>
          </li>
        </ul>
      </div>
      <div class="content-data-2-item">
        <div class="color-blue is-b table-title-s" v-text="isdelivered?names[1][0]:names[1][1]"></div>
        <ul class="content-data-items" v-if="isdelivered">
          <li style="border-right: none;"@click="tolist('otherPeopleNum')">
            
            <div class=" is-b" :class="yesOtherPeopleio<=0?'color-red':'color-green'">{{otherPeopleNum| addSpot}}</div>
          </li>
          <li>
            <div :class="otherPeopleNum - yesOtherPeopleNum>=0 ?'is-up':'is-down'">
              {{(otherPeopleNum - yesOtherPeopleNum)| addSpot}}
            </div>
            <div :class="yesOtherPeopleio >=0?'is-up':'is-down'">{{yesOtherPeopleio+'%'}}</div>
          </li>
          <li>
            <div>昨日同期量</div>
            <div class="is-b">{{yesOtherPeopleNum| addSpot}}</div>
          </li>
          <li>
            <div>昨日总量</div>
            <div class="is-b">{{yesOtherPeopleSum| addSpot}}</div>
          </li>
        </ul>
        <ul class="content-data-items" v-if="!isdelivered">
          <li style="border-right: none;"@click="tolist('waitReturn')">
            
            <div class=" is-b" :class="yesWaitReturnio>0?'color-red':'color-green'">{{waitReturn| addSpot}}</div>
          </li>
          <li>
            <div :class="waitReturn-yesWaitReturn >=0?'is-up-color':'is-down-color'">
              {{(waitReturn-yesWaitReturn)| addSpot}}
            </div>
            <div :class="yesWaitReturnio>=0?'is-up-color':' is-down-color'">{{yesWaitReturnio+'%'}}</div>
          </li>
          <li>
            <div>昨日同期量</div>
            <div class="is-b">{{yesWaitReturn| addSpot}}</div>
          </li>
          <li>
            <div>昨日总量</div>
            <div class="is-b">{{yesWaitReturnSum| addSpot}}</div>
          </li>
        </ul>
      </div>
    </div>
    <!-- 第三行 -->
    <div class="content-data-2">
      <div class="content-data-2-item" style="border-right: 1px solid #cccccc;">
        <div class="color-blue is-b table-title-s" v-text="isdelivered?names[2][0]:names[2][1]"></div> 
        <ul class="content-data-items" v-if="isdelivered">
          <li style="border-right: none;"@click="tolist('selfPickupNum')">
           
            <div class=" is-b" :class="yesSelfPickupio<0?'color-red':'color-green'">{{selfPickupNum| addSpot}}</div>
          </li>
          <li>
            <div :class="selfPickupNum - yesSelfPickupNum >0?'is-up':'is-down'">
              {{(selfPickupNum - yesSelfPickupNum)| addSpot}}
            </div>
            <div :class="yesSelfPickupio>0?'is-up':'is-down'">{{yesSelfPickupio+'%'}}</div>
          </li>
          <li>
            <div>昨日同期量</div>
            <div class="is-b">{{yesSelfPickupNum| addSpot}}</div>
          </li>
          <li>
            <div>昨日总量</div>
            <div class="is-b">{{yesSelfPickupSum| addSpot}}</div>
          </li>
        </ul>
        <ul class="content-data-items" v-if="!isdelivered">
          <li style="border-right: none;"@click="tolist('reqCollectNum')">
           
            <div class=" is-b" :class="yesReqCollectio>0?'color-red':'color-green'">{{reqCollectNum| addSpot}}</div>
          </li>
          <li>
            <div :class="reqCollectNum-yesReqCollectNum>0?'is-up-color':'is-down-color'">{{(reqCollectNum-yesReqCollectNum)| addSpot}}</div>
            <div :class="yesReqCollectio>0?'is-up-color':'is-down-color'">{{yesReqCollectio+'%'}}</div>
          </li>
          <li>
            <div>昨日同期量</div>
            <div class="is-b">{{yesReqCollectNum| addSpot}}</div>
          </li>
          <li>
            <div>昨日总量</div>
            <div class="is-b">{{yesReqCollectSum| addSpot}}</div>
          </li>
        </ul>
      </div>
      <div class="content-data-2-item">
        <div class="color-blue is-b table-title-s" v-text="isdelivered?names[3][0]:names[3][1]"></div>
        <ul class="content-data-items" v-if="isdelivered">
          <li style="border-right: none;"@click="tolist('mailRoomNum')">
            
            <div class=" is-b" :class="yesMailRoomio<0?'color-red':'color-green'">{{mailRoomNum| addSpot}}</div>
          </li>
          <li>
            <div :class="mailRoomNum-yesMailRoomNum >0?'is-up':'is-down'">
              {{(mailRoomNum-yesMailRoomNum)| addSpot}}
            </div>
            <div :class="yesMailRoomio>0?'is-up':'is-down'">{{yesMailRoomio+'%'}}</div>
          </li>
          <li>
            <div>昨日同期量</div>
            <div class="is-b">{{yesMailRoomNum| addSpot}}</div>
          </li>
          <li>
            <div>昨日总量</div>
            <div class="is-b">{{yesMailRoomSum| addSpot}}</div>
          </li>
        </ul>
        <ul class="content-data-items" v-if="!isdelivered">
          <li style="border-right: none;"@click="tolist('retreNum')">
            
            <div class=" is-b" :class="yesRetreio>0?'color-red':'color-green'">{{retreNum| addSpot}}</div>
          </li>
          <li>
            <div :class="retreNum-yesRetreNum>0?'is-up-color':'is-down-color'">
              {{(retreNum-yesRetreNum)| addSpot}}
            </div>
            <div :class="yesRetreio>0?'is-up-color':'is-down-color'">{{yesRetreio+'%'}}</div>
          </li>
          <li>
            <div>昨日同期量</div>
            <div class="is-b">{{yesRetreNum| addSpot}}</div>
          </li>
          <li>
            <div>昨日总量</div>
            <div class="is-b">{{yesRetreSum| addSpot}}</div>
          </li>
        </ul>
      </div>
    </div>
    <!-- 第四行 -->
    <div class="content-data-2">
      <div class="content-data-2-item" style="border-right: 1px solid #cccccc;">
        <div class="color-blue is-b table-title-s" v-text="isdelivered?names[4][0]:names[4][1]"></div>
        <ul class="content-data-items" v-if="isdelivered">
          <li style="border-right: none;"@click="tolist('parcelCabinetNum')">
           
            <div class=" is-b" :class="yesParcelCabinetio<0?'color-red':'color-green'">{{parcelCabinetNum| addSpot}}</div>
          </li>
          <li>
            <div :class="parcelCabinetNum- yesParcelCabinetNum>=0?'is-up':'is-down'">
              {{(parcelCabinetNum- yesParcelCabinetNum)| addSpot}}
            </div>
            <div :class="yesParcelCabinetio>=0?'is-up':'is-down'">
              {{yesParcelCabinetio+'%'}}
            </div>
          </li>
          <li>
            <div>昨日同期量</div>
            <div class="is-b">{{yesParcelCabinetNum| addSpot}}</div>
          </li>
          <li>
            <div>昨日总量</div>
            <div class="is-b">{{yesParcelCabinetSum| addSpot}}</div>
          </li>
        </ul>
        <ul class="content-data-items" v-if="!isdelivered">
          <li style="border-right: none;"@click="tolist('chgAddress')">
           
            <div class=" is-b" :class="yesChgAddressio>=0?'color-red':'color-green'">{{chgAddress| addSpot}}</div>
          </li>
          <li>
            <div :class="chgAddress-yesChgAddress>=0?'is-up-color':'is-down-color'">{{(chgAddress-yesChgAddress)| addSpot}}</div>
            <div :class="yesChgAddressio>=0?'is-up-color':'is-down-color'">{{yesChgAddressio+'%'}}</div>
          </li>
          <li>
            <div>昨日同期量</div>
            <div class="is-b">{{yesChgAddress| addSpot}}</div>
          </li>
          <li>
            <div>昨日总量</div>
            <div class="is-b">{{yesChgAddressSum| addSpot}}</div>
          </li>
        </ul>
      </div>
      <div class="content-data-2-item">
        <div class="color-blue is-b table-title-s" 
          v-text="names[5][0]" v-if="isdelivered"></div>
        <ul class="content-data-items" v-if="isdelivered">
          <li style="border-right: none;"@click="tolist('dlvOtherNum')">
          
            <div class="is-b" :class="yesDlvOtherio<0?'color-red':'color-green'">{{dlvOtherNum| addSpot}}</div>
          </li>
          <li>
            <div :class="dlvOtherNum-yesDlvOtherNum>=0?'is-up':'is-down'">{{(dlvOtherNum-yesDlvOtherNum)| addSpot}}</div>
            <div :class="yesDlvOtherio>=0?'is-up':'is-down'">{{yesDlvOtherio+'%'}}</div>
          </li>
          <li>
            <div>昨日同期量</div>
            <div class="is-b">{{yesDlvOtherNum| addSpot}}</div>
          </li>
          <li>
            <div>昨日总量</div>
            <div class="is-b">{{yesDlvOtherSum  | addSpot}}</div>
          </li>
        </ul>
        <div class="color-blue is-b table-title-s" 
          v-text="names[5][0]" v-if="!isdelivered"></div>
        <ul class="content-data-items" v-if="!isdelivered">
          <li style="border-right: none;"@click="tolist('notVoteOther')">
          
            <div class=" is-b" :class="yesNotVoteOtherio>=0?'color-red':'color-green'">{{notVoteOther| addSpot}}</div>
          </li>
          <li>
            <div :class="notVoteOther-yesNotVoteOther>=0?'is-up-color':'is-down-color'">{{(notVoteOther-yesNotVoteOther)| addSpot}}</div>
            <div :class="yesNotVoteOtherio>=0?'is-up-color':'is-down-color'">{{yesNotVoteOtherio+'%'}}</div>
          </li>
          <li>
            <div>昨日同期量</div>
            <div class="is-b">{{yesNotVoteOther| addSpot}}</div>
          </li>
          <li>
            <div>昨日总量</div>
            <div class="is-b">{{yesNotVoteOtherSum| addSpot}}</div>
          </li>
        </ul>
      </div>
    </div>
  </div>
  </div>
  `,
});

Vue.component('todaydownpart', {
  props: ['data'],
  data() {
    return {
      todaydownpartmenu: '总量',
      queryType: '1',
      level: '',
      xzqh: '',
      // 左侧下拉框新加字段
      businessVolume: '解车量',
      selectBusinessType: '1',
    }
  },
  filters: {
    addSpot(source) {
      if (source.length < 4) return source;
      let arr = [...source];
      let len = arr.length / 3;
      let newArr = [];
      for (let i = 0; i < len; i++) {
        let start = arr.length - 3 * (i + 1)
        let b = []
        if (start < 0) b = arr.slice(0, arr.length % 3);
        else b = arr.slice(start, arr.length - 3 * i);
        newArr.push(b.join(''));
      }
      return newArr.reverse().join(',');
    }
  },
  methods: {
    // dataDates() {
    //   var date = new Date();
    //   var hour = date.getHours() > 9 ? date.getHours() : "0" +
    //     date.getHours();
    //   var dateStr = hour - 3;
    //   return dateStr
    // },
    init_data(data) {
      for (let key in data) {
        this[key] = data[key]
      }
      this.init_jrxdl();

    },
    // 左侧筛选框
    clickMunuLeft(params) {
      console.log(params);
      let name = ['解车量', '下段量', '投递量'] // 解车量、下段量、投递量（妥投量+未妥投）
      this.businessVolume = name[parseInt(params) - 1]
      this.selectBusinessType = params;
      this.init_jrxdl();
    },
    // 右侧筛选框
    clickMunu(params) {
      console.log(params);
      let name = ['总量', '特快', '快包', '普邮', '国际']
      this.todaydownpartmenu = name[parseInt(params) - 1]
      this.queryType = params;
      this.init_jrxdl();
    },
    init_jrxdl() {
      let path = "dpk/queryPcHypomereNum";
      let new_level = Number(this.level) >= 6 ? 4 : this.level == '1' || this.level == '2' ? '1' : this.level - 1;
      let params = {
        distCode: this.xzqh,
        orgCode: '',
        sumLevel: new_level,
        sumFg: '1',
        queryType: this.queryType,
        dataDate: dayjs().format('YYYY-MM-DD'),
        indexType: this.selectBusinessType // 选择左侧下拉框菜单
      };
      console.log(params, 'params')
      const msgbody1 = JSON.stringify(params)
      //alert(msgbody1)
      interface1.get(path, {
        params: {
          'sendID': '00000001',
          'timestamp': timestamp,
          'msgBody': msgbody1,
          'dataDigest': base64.encode(hex_md5(msgbody1 + data_key + timestamp))
        }
      }).then(({
        data
      }) => {
        var todayArray = [];
        var yesArray = [];
        var result = data.data;
        console.log('结果1pppppppppp', data)
        // console.log(data);
        let todayObj = {}
        let yestodayObj = {}
        let times = [];
        let t = '';
        if (data.resCode === 'C00001' && result[0].dpkHypomereDto.length > 0) {
          if (result[0].lineType === '1' && result[0].dpkHypomereDto[0].dataDateStr != '') {
            var today = result[0].dpkHypomereDto;
            today.forEach(e => {
              if (e.dataDateStr != '') {
                if (dayjs().subtract(1, 'day').format("YYYY-MM-DD") ==
                  e.dataDateStr) {
                  t = 0
                } else if (dayjs().format("YYYY-MM-DD") ==
                  e.dataDateStr) {
                  t = (parseInt(e.frequency) + 1).toString();
                }
                times.push(t);
                // console.log( 'times',times)
                todayObj[t] = this.getNeedData(e)
              }
            });
            //console.log(result[0].dpkHypomereDto)
          }
          if (result[1].lineType === '2' && result[1].dpkHypomereDto[0].dataDateStr != '') {
            var yestoday = result[1].dpkHypomereDto;
            yestoday.forEach(e => {
              if (e.dataDateStr != '') {
                if (dayjs().subtract(2, 'day').format("YYYY-MM-DD") ==
                  e.dataDateStr) {
                  t = 0
                } else if (dayjs().subtract(1, 'day').format("YYYY-MM-DD") ==
                  e.dataDateStr) {
                  t = (parseInt(e.frequency) + 1).toString();
                }
                times.push(t);
                yestodayObj[t] = this.getNeedData(e)
              }
            });
            //console.log(result[1].dpkHypomereDto)
          }
        }
        var len = 0;
        var index = 0;
        let filterTime = new Set(times);
        for (var i = 0; i < filterTime.length; i++) {
          if (i == filterTime.legnth - 1) {
            return;
          }
          if (Number(filterTime[i + 1]) - Number(filterTime[i]) > 1) {
            len = Number(filterTime[i + 1]) - Number(filterTime[i]);
            index = i + 1;
            return;
          }
        }
        for (var y = 0; y < len; y++) {
          filterTime.splice(index + y, 0, filterTime[index + y] + 1 + '')
        }
        const dayTimes = ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '10', '11',
          '12', '13', '14', '15', '16', '17', '18', '19', '20', '21', '22', '23', '24'
        ];
        //const sortTimes = [...filterTime].sort((a,b) => Number(a) - Number(b))
        dayTimes.forEach(e => {
          if (todayObj[e] === undefined) todayObj[e] = 0
          if (yestodayObj[e] === undefined) yestodayObj[e] = 0
        });
        let xData = Object.keys(todayObj)
        const todayYdata = Object.values(todayObj)
        const yestodayYdata = Object.values(yestodayObj);
        const x_data = xData.map(e => {
          if (e.length === 1) return `0${e}:00`
          else return `${e}:00`
        })
        // console.log(todayYdata)
        // console.log(x_data)
        // console.log(yestodayYdata)
        this.init_jrsjl(x_data, todayYdata, yestodayYdata);
      }).catch(err => {
        console.log(err);
        this.init_jrsjl([], [], [])
      });

    },
    getNeedData(e) {
      if (this.queryType === '1') {
        return e.total
      } else if (this.queryType === '2') {
        return e.superfastNum
      } else if (this.queryType === '3') {
        return e.quickpackNum
      } else if (this.queryType === '4') {
        return e.generpostNum
      } else if (this.queryType === '5') {
        return e.internNum
      }

    },
    init_jrsjl(x_data, todayArray, yesArray) {
      let legend = ['今日', '昨日'];
      let xData = x_data.length > 0 ? x_data : ['00:00', '01:00', '02:00', '03:00', '04:00', '05:00', '06:00', '07:00', '08:00', '09:00', '10:00', '11:00',
        '12:00', '13:00', '14:00', '15:00', '16:00', '17:00', '18:00', '19:00', '20:00', '21:00', '22:00', '23:00', '24:00'
      ];
      let series = [];
      legend.forEach((e, index) => {
        let setting = {
          name: '收入',
          type: 'line',
          data: [0, 0, 0, 0, 0, 0, 0],
          symbolSize: 10,
          symbol: 'circle',
          itemStyle: {
            normal: {
              color: '#1D95F4',
              barBorderRadius: 1,
              borderColor: '#fff',
              borderWidth: 2
            }
          },
          lineStyle: {
            normal: {
              color: '#1D95F4',
              width: 2
            }
          },
          smooth: true
        }
        setting.name = e;

        if (index === 0) {
          setting.data = todayArray.length > 0 ? todayArray : [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
          setting.itemStyle.normal.color = '#1D95F4';
          setting.lineStyle.normal.color = '#1D95F4'
        }
        if (index === 1) {
          setting.data = yesArray.length > 0 ? yesArray : [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
          setting.itemStyle.normal.color = '#1AE54B';
          setting.lineStyle.normal.color = '#1AE54B'
        }
        series.push(setting)
      })
      // let start = this.dataDates() / 24 * 100;
      // let end = this.dataDates() / 24 * 100 + 16.6;
      initZheXian('charttodaydownpart', legend, xData, series, [35, 45])
    },
  },
  mounted() {
    // this.init_jrsjl();
    // this.init_jrxdl();
  },
  template: `
  <div id="todaydownpart" class="br-10 m-b-10 b-s-gray">
  <div class="charttitle">
    今日业务量
    <div style="position: absolute; left: 15px; top: 0">
        <el-dropdown @command="clickMunuLeft" :trigger="'click'" ref="lll">
            <span class="el-dropdown-link">
                {{ businessVolume }}<i class="el-icon-caret-bottom" style="margin-top: -13px"></i>
            </span>
            <el-dropdown-menu slot="dropdown">
                <el-dropdown-item command="1">解车量</el-dropdown-item>
                <el-dropdown-item command="2">下段量</el-dropdown-item>
                <el-dropdown-item command="3">投递量</el-dropdown-item>
            </el-dropdown-menu>
        </el-dropdown>
    </div>
    <div style="position: absolute; right: 15px; top: 0">
      <el-dropdown @command="clickMunu" :trigger="'click'" ref="lll">
          <span class="el-dropdown-link">
              {{todaydownpartmenu}}<i class="el-icon-caret-bottom" style="margin-top: -13px"></i>
          </span>
          <el-dropdown-menu slot="dropdown">
              <el-dropdown-item command="1">总量</el-dropdown-item>
              <el-dropdown-item command="2">特快</el-dropdown-item>
              <el-dropdown-item command="3">快包</el-dropdown-item>
              <el-dropdown-item command="4">普邮</el-dropdown-item>
              <el-dropdown-item command="5">国际</el-dropdown-item>
          </el-dropdown-menu>
      </el-dropdown>
  </div>
  </div>
  <div id="charttodaydownpart"></div>

</div>
  `
})

Vue.component('historydownpart', {
  props: ['data'],
  data() {
    return {
      historydownpartmenu: '7日内',
      level: '',
      xzqh: '',
      lineType: '1',
      xDataArray: [],
      xDataArray_x: [],
      totalArray: [],
      superFastArray: [],
      quickPackArray: [],
      generPostArray: [],
      internetArray: [],
      todaydownpartmenu: '总量',
      queryType: '0'
    }
  },
  methods: {
    init_data(data) {
      for (let key in data) {
        this[key] = data[key]
      }
      this.init_lsxdl();
    },
    clickMunu(params) {
      console.log(params);
      let name = ['7日内', '30日内', '12周内', '12月内']
      this.historydownpartmenu = name[parseInt(params) - 1]
      this.lineType = params;
      this.totalArray = [];
      this.superFastArray = [];
      this.quickPackArray = [];
      // this.generPostArray = [];
      // this.internetArray = [];
      this.init_lsxdl();
    },
    // 右侧筛选框
    clickMunuRifgt(params) {
      // console.log(params);
      let name = ['总量', '特快', '快包', '普邮', '国际']
      this.todaydownpartmenu = name[parseInt(params) - 1]
      this.queryType = params - 1;
      this.init_lsxdl();
    },
    init_lsxdl() {
      let path = "";
      if (this.lineType === '1') {
        path = "dpk/pcHypomereCdpSevenDay";
      } else if (this.lineType === '2') {
        path = "dpk/pcHypomereCdpDay";
      } else if (this.lineType === '3') {
        path = "dpk/pcHypomereCdpWeek";
      } else if (this.lineType === '4') {
        path = "dpk/pcHypomereCdpMonth";
      }
      let new_level = Number(this.level) >= 6 ? 4 : this.level == '1' || this.level == '2' ? '1' : this.level - 1;
      let params = {
        distCode: this.xzqh,
        orgCode: '',
        sumLevel: new_level, // this.level === '1' || this.level === '2' ? '1' : Number(this.level) - 1
        //SumFg : '1',
        lineType: this.lineType,
        dataDate: dayjs().format('YYYY-MM-DD'),
        businessType: this.queryType
      };
      console.log('fsg', params)
      const msgbody1 = JSON.stringify(params)
      //alert(msgbody1)
      interface1.get(path, {
        params: {
          'sendID': '00000001',
          'timestamp': timestamp,
          'msgBody': msgbody1,
          'dataDigest': base64.encode(hex_md5(msgbody1 + data_key + timestamp))
        }
      }).then(({ data }) => {
        this.xDataArray = [];
        this.superFastArray = [];
        this.quickPackArray = [];
        this.totalArray = []
        console.log('结果', data.data);
        if (data.resCode === 'C00001' && data.data.dismissTheCar.length > 0 && data.data.lowerVolume.length > 0 && data.data.delivery.length > 0) {
          if (this.lineType == '1' || this.lineType == '2') {
            data.data.dismissTheCar.sort((a, b) => { // 解车量
              return new Date(a['dataDateStr']) - new Date(b['dataDateStr'])
            })
            data.data.lowerVolume.sort((a, b) => {
              return new Date(a['dataDateStr']) - new Date(b['dataDateStr'])
            })
            data.data.delivery.sort((a, b) => {
              return new Date(a['dataDateStr']) - new Date(b['dataDateStr'])
            })
            var dismissTheCar = data.data.dismissTheCar
            dismissTheCar.forEach(e => {
              var time = e.dataDateStr.substring(5, 11)
              this.xDataArray.push(time)
              this.totalArray.push(e.total)
            })
            var lowerVolume = data.data.lowerVolume;
            lowerVolume.forEach(e => {
              var time = e.dataDateStr.substring(5, 11)
              this.xDataArray.push(time)
              this.superFastArray.push(e.total)
            })
            var delivery = data.data.delivery;
            delivery.forEach(e => {
              var time = e.dataDateStr.substring(5, 11)
              this.xDataArray.push(time)
              this.quickPackArray.push(e.total)
            })

            const arr_new = (arr) => {
              //Set数据结构，它类似于数组，其成员的值都是唯一的
              return Array.from(new Set(arr)); // 利用Array.from将Set结构转换成数组
            }
            this.xDataArray = arr_new(this.xDataArray)
          } else if (this.lineType == '3') {
            data.data.dismissTheCar.sort((a, b) => { // 解车量
              return new Date(a['dataDate']) - new Date(b['dataDate'])
            })
            data.data.lowerVolume.sort((a, b) => {
              return new Date(a['dataDate']) - new Date(b['dataDate'])
            })
            data.data.delivery.sort((a, b) => {
              return new Date(a['dataDate']) - new Date(b['dataDate'])
            })
            var dismissTheCar = data.data.dismissTheCar
            dismissTheCar.forEach(e => {
              var time = e.dataDate
              this.xDataArray.push(time)
              this.totalArray.push(e.total)
            })
            var lowerVolume = data.data.lowerVolume;
            lowerVolume.forEach(e => {
              var time = e.dataDate
              this.xDataArray.push(time)
              this.superFastArray.push(e.total)
            })
            var delivery = data.data.delivery;
            delivery.forEach(e => {
              var time = e.dataDate
              this.xDataArray.push(time)
              this.quickPackArray.push(e.total)
            })
            const arr_new = (arr) => {
              return Array.from(new Set(arr)); // 利用Array.from将Set结构转换成数组
            }
            this.xDataArray = arr_new(this.xDataArray)
          } else if (this.lineType == '4') {
            data.data.dismissTheCar.sort((a, b) => { // 解车量
              return new Date(a['dataDate']) - new Date(b['dataDate'])
            })
            data.data.lowerVolume.sort((a, b) => {
              return new Date(a['dataDate']) - new Date(b['dataDate'])
            })
            data.data.delivery.sort((a, b) => {
              return new Date(a['dataDate']) - new Date(b['dataDate'])
            })
            var dismissTheCar = data.data.dismissTheCar
            dismissTheCar.forEach(e => {
              var time = e.dataDate
              this.xDataArray.push(time)
              this.totalArray.push(e.total)
            })
            var lowerVolume = data.data.lowerVolume;
            lowerVolume.forEach(e => {
              var time = e.dataDate
              this.xDataArray.push(time)
              this.superFastArray.push(e.total)
            })
            var delivery = data.data.delivery;
            delivery.forEach(e => {
              var time = e.dataDate
              this.xDataArray.push(time)
              this.quickPackArray.push(e.total)
            })
            const arr_new = (arr) => {
              return Array.from(new Set(arr)); // 利用Array.from将Set结构转换成数组
            }
            this.xDataArray = arr_new(this.xDataArray)
          }
        }
        this.init_lssjl();
      }).catch(err => {
        console.log(err);
        this.init_lssjl();
      });
    },
    init_lssjl() {
      let legend2 = ['解车量', '下段量', '投递量', ];
      let sevenData = [dayjs().subtract(7, 'day').format('MM-DD'), dayjs().subtract(6, 'day').format('MM-DD'), dayjs().subtract(5, 'day').format('MM-DD'), dayjs().subtract(4, 'day').format('MM-DD'), dayjs().subtract(3, 'day').format('MM-DD'), dayjs().subtract(2, 'day').format('MM-DD'), dayjs().subtract(1, 'day').format('MM-DD')]
      let xData2 = this.xDataArray.length > 0 ? this.xDataArray : sevenData;
      let series2 = [];
      legend2.forEach((e, index) => {
        let setting = {
          name: '收入',
          type: 'line',
          data: [0, 0, 0, 0, 0],
          symbolSize: 10,
          symbol: 'circle',
          itemStyle: {
            normal: {
              color: '#1D95F4',
              barBorderRadius: 1,
              borderColor: '#fff',
              borderWidth: 2
            }
          },
          lineStyle: {
            normal: {
              color: '#1D95F4',
              width: 2
            }
          },
          smooth: true
        }
        setting.name = e;

        if (index === 0) {
          setting.data = this.totalArray.length > 0 ? this.totalArray : [0, 0, 0, 0, 0, 0, 0]
          // setting.data = this.totalArray.length;
          setting.itemStyle.normal.color = '#1D95F4';
          setting.lineStyle.normal.color = '#1D95F4'
        }
        if (index === 1) {
          setting.data = this.superFastArray.length > 0 ? this.superFastArray : [0, 0, 0, 0, 0, 0, 0]
          // setting.data = this.superFastArray;
          setting.itemStyle.normal.color = '#1AE54B';
          setting.lineStyle.normal.color = '#1AE54B'
        }
        if (index === 2) {

          setting.data = this.quickPackArray.length > 0 ? this.quickPackArray : [0, 0, 0, 0, 0, 0, 0]
          // setting.data = this.quickPackArray;
          setting.itemStyle.normal.color = '#1E1F89';
          setting.lineStyle.normal.color = '#1E1F89'
        }
        series2.push(setting)
      });
      // let start = 0;
      // let end = 99;
      initZheXianTwo('charthistorydownpart', legend2, xData2, series2, [35, 10])
    }
  },
  mounted() {
    // this.init_lssjl()
    // this.init_lsxdl();
  },
  template: `
  <div id="historydownpart" class="br-10 m-b-10 b-s-gray">
  <div class="charttitle">
    历史业务量
    <div style="position: absolute; left: 15px; top: 0">
      <el-dropdown @command="clickMunu" :trigger="'click'" ref="lll">
          <span class="el-dropdown-link">
              {{historydownpartmenu}}<i class="el-icon-caret-bottom" style="margin-top: -13px"></i>
          </span>
          <el-dropdown-menu slot="dropdown">
              <el-dropdown-item command="1">7日内</el-dropdown-item>
              <el-dropdown-item command="2">30日内</el-dropdown-item>
              <el-dropdown-item command="3">12周内</el-dropdown-item>
              <el-dropdown-item command="4">12月内</el-dropdown-item>
          </el-dropdown-menu>
      </el-dropdown>
    </div>
    <div style="position: absolute; right: 15px; top: 0">
    <el-dropdown @command="clickMunuRifgt" :trigger="'click'" ref="lll">
        <span class="el-dropdown-link">
            {{todaydownpartmenu}}<i class="el-icon-caret-bottom" style="margin-top: -13px"></i>
        </span>
        <el-dropdown-menu slot="dropdown">
            <el-dropdown-item command="1">总量</el-dropdown-item>
            <el-dropdown-item command="2">特快</el-dropdown-item>
            <el-dropdown-item command="3">快包</el-dropdown-item>
            <el-dropdown-item command="4">普邮</el-dropdown-item>
            <el-dropdown-item command="5">国际</el-dropdown-item>
        </el-dropdown-menu>
    </el-dropdown>
</div>
  </div>
  <div id="charthistorydownpart"></div>

  </div>
  `
})
Vue.component('downpartstatist', {
  props: ['data'],
  data() {
    return {
      num1: '--',
      num2: '--',
      num3: '--',
    }
  },
  template: `
  <div v-show='false' id="downpartstatist" class="br-10 m-b-10 b-s-gray">
    <div class="charttitle">
      下段量统计
    </div>
    <div class="normalbox b-s-b-gray">
      <div class="centerbox">
        <p class="fontsize-24 bold color-blue">{{num1}}</p>
        <p class="fontsize-14 bold">司法专递邮件</p>
      </div> 
      <div id="chartdownpartstatist1"></div>
    </div> 
    <div class="normalbox  b-s-b-gray">
      <div class="centerbox">
        <p class="fontsize-24 bold color-blue">{{num2}}</p>
        <p class="fontsize-14 bold">增值服务邮件</p>
      </div> 
      <div id="chartdownpartstatist2"></div>
    </div> 
    <div class="normalbox">
      <div class="centerbox">
        <p class="fontsize-24 bold color-blue">{{num3}}</p>
        <p class="fontsize-14 bold">特殊产品邮件</p>
      </div> 
      <div id="chartdownpartstatist3"></div>
    </div> 
  </div>
  `,
  beforeMount() {},
  mounted() {
    var option = [];
    this.data.list.forEach((element, index) => {
      option[index] = {
        legend: {
          // orient: 'vertical',
          left: 'center',
          bottom: 10,
          data: element.map((e) => {
            return e.name
          }),

        },
        series: [{
          name: 'chart' + index,
          type: 'pie',
          radius: ['45%', '55%'],
          center: ['50%', '40%'],
          label: {
            show: true,
            position: 'outside',
            formatter: '{b}\n{c}',
          },
          labelLine: {
            show: true
          },
          data: element
        }]
      };
    });
    var chart1 = echarts.init(document.getElementById('chartdownpartstatist1'));
    var chart2 = echarts.init(document.getElementById('chartdownpartstatist2'));
    var chart3 = echarts.init(document.getElementById('chartdownpartstatist3'));
    chart1.setOption(option[0]);
    chart2.setOption(option[1]);
    chart3.setOption(option[2]);
  }

})


Vue.component('item-prgress', {
  data() {
    return {
      color: 'green',
      rale: 50,
      num: '100',
      title: '80%-90%单位数'
    }
  },

  methods: {
    init_data(data) {
      for (let key in data) {
        this[key] = data[key]
      }
    }
  },
  template: `<div>
                  <div style="position: relative;">
                          <svg viewBox="0 0 100 100" style="height: 60px">
                              <path d="
              M 50 50
              m 0 -44
              a 44 44 0 1 1 0 88
              a 44 44 0 1 1 0 -88
              " stroke="#e5e9f2" stroke-width="5.9" fill="none"
                                    style="stroke-dasharray: 276.46px, 276.46px; stroke-dashoffset: 2px;"></path>
                              <path d="
              M 50 50
              m 0 -44
              a 44 44 0 1 1 0 88
              a 44 44 0 1 1 0 -88
              " :stroke="color" fill="none" stroke-linecap="round" stroke-width="11.9" class="aaa"
                                    :style="{'stroke-dasharray': (276.46 * rale / 100).toFixed(3) + 'px, 276.46px'}"></path>
                          </svg>
                          <div class="cale" :style="{color: color}">{{num}}</div>
                   </div>
                  <div style="text-align: center; margin-top: 8px">
                      <p>{{title}}</p>
                  </div> 
          </div>`
});


Vue.component('statisttarget', {
  data() {
    return {
      countryType: '城市',
      level: '',
      xzqh: '',
      count_date: '',
    }
  },
  props: ['data'],
  template: `
  <div id="statisttarget" class="br-10 m-b-10 b-s-gray">
    <div class="charttitle">
      统计指标
    </div>
    <div v-show='false' class="deliversubtitle">及时下段率</div>
    <div v-show='false'  class="progress_com" style="margin-top: -15px">
      <div class="progress_com_item_2" style="height: 100px; padding: 0">
        <div id="sbt1" ></div>
      </div>
      <div class="progress_com_item_2" style="padding: 0">
        <div id="sbt2"></div>
      </div>
      <div class="progress_com_item_2" style="padding: 0">
        <div id="sbt3" ></div>
      </div>
    </div>
    <div  style="margin-top: -45px; display: flex; justify-content: space-between">
      <div style="text-align: center; line-height: 30px; width: 100%; font-size: 14px">
        综合率
      </div>
      <div style="text-align: center; line-height: 30px; width: 100%; font-size: 14px">
        特快
      </div>
      <div style="text-align: center; line-height: 30px; width: 100%; font-size: 14px">
        快包
      </div>
    </div>
    <div v-show='false' class="progress_com">  
      <div class="progress_com_item_2">
        <item-prgress ref="lsjsl1"/>
      </div>
      <div class="progress_com_item_2">
        <item-prgress ref="lsjsl2"/>
      </div>
      <div class="progress_com_item_2">
        <item-prgress ref="lsjsl3"/>
      </div>
      <div class="progress_com_item_2">
        <item-prgress ref="lsjsl4"/>
      </div>
    </div>
    <div class="deliversubtitle b-s-t-gray" style="position:relative; margin-top:10px; border-top:0;font-size:17px">及时妥投率
	    <div style="display:none;position: absolute; right: 15px; top: 0">
		    <el-dropdown @command="clickMenu" :trigger="'click'" ref="lll">
		        <span class="el-dropdown-link">
		            {{countryType}}<i class="el-icon-caret-bottom" style="margin-top: -13px"></i>
		        </span>
		        <el-dropdown-menu slot="dropdown">
		            <el-dropdown-item command="1">城市</el-dropdown-item>
		            <el-dropdown-item command="2">农村</el-dropdown-item>
		        </el-dropdown-menu>
		    </el-dropdown>
		</div>
	</div>
    <div class="progress_com" style="margin-top: -2px">
      <div class="progress_com_item_2" style="display:none;height: 100px; padding: 0" @click="toXiaZuan('sbta1')">
        <div id="sbta1" ></div>
      </div>
      <div class="progress_com_item_2" style="padding: 10px" @click="toXiaZuan('sbta2')">
        <div id="sbta2"></div>
      </div>
      <div class="progress_com_item_2" style="padding: 10px" @click="toXiaZuan('sbta3')">
        <div id="sbta3" ></div>
      </div>
    </div>
    <div  style="margin-top: -45px; display: flex; justify-content: space-between">
      <div style="display:none;text-align: center; line-height: 30px; width: 100%; font-size: 14px">
        综合率
      </div>
      <div style="margin-top:15px;text-align: center; line-height: 30px; width: 100%; font-size: 14px">
        特快
      </div>
      <div style="margin-top:15px;text-align: center; line-height: 30px; width: 100%; font-size: 14px">
        快包
      </div>
    </div>
    <div style="font-size: 12px;color: #989898;text-align: center; margin: 6px 0;">
						                                     备注：及时妥投率指标数据日期为{{count_date}}。
						                </div>
    <div v-show='false'  class="progress_com">  
      <div class="progress_com_item_2">
        <item-prgress ref="lsjsla1"/>
      </div>
      <div class="progress_com_item_2">
        <item-prgress ref="lsjsla2"/>
      </div>
      <div class="progress_com_item_2">
        <item-prgress ref="lsjsla3"/>
      </div>
      <div class="progress_com_item_2">
        <item-prgress ref="lsjsla4"/>
      </div>
    </div>
    <div v-show='false' class="deliversubtitle b-s-t-gray">环节平均时长</div>
    <div  v-show='false' class="item-box">
      <div class="b-d-t-gray w-33 p-t-15 p-b-15">
        <p style="font-size: 12px">平均总时长</p>
        <p class="color-blue bold" style="font-size: 20px;">--</p>
      </div>
      <div class="b-d-t-gray w-33 p-t-15 p-b-15 b-d-l-gray">
        <p style="font-size: 12px;">解车-下段平均时长</p>
        <p class="color-blue bold" style="font-size: 20px;">--</p>
      </div>
      <div class="b-d-t-gray w-33 p-t-15 p-b-15 b-d-l-gray">
        <p style="font-size: 12px;">下段-投递平均时长</p>
        <p class="color-blue bold" style="font-size: 20px;">--</p>
      </div>
    </div>
  </div>
  `,
  methods: {
    init_data(data) {
      for (let key in data) {
        this[key] = data[key]
      }
      this.initTtl();

    },
    clickMenu(params) {
      console.log(params);
      let name = ['城市', '农村']
      this.countryType = name[parseInt(params) - 1];
      this.initTtl();
    },
    toXiaZuan(param) {
      if (this.level > 5) {
        return
      }
      console.log(param, 'lll');
      this.goToJsttl(param)
      // var type = '';
      // if(this.countryType === "城市"){
      // 	type = '1';
      //   }else{
      //   	type = '2';
      //   }
      // Emp.execute("toTtlXiaZuan('"+type+"','"+param+"')");
    },
    goToJsttl(param) {
      if (this.level > 3) {
        vant.Toast('该机构不支持下钻');
        return
      }
      let now = new Date(new Date() - 2 * 24 * 60 * 60 * 1000)
      let y = now.getFullYear()
      let m = now.getMonth() + 1
      let d = now.getDate()
      let date = y + "." + (m < 10 ? "0" + m : m) + "." + (d < 10 ? "0" + d : d)
      // var obj = {
      var obj = {
        name: '及时妥投率',
        key: '7',
        dateType: "D",
        date: date,
        product: param == 'sbta2' ? "B" : "K",
        // tabPage: tabPage
        // xzqh: xzqh,
        // level: level
      }
      Emp.execute("toJsttlList('" + JSON.stringify(obj) + "')");
    },
    init_tjzb() {
      //this.initTtl();
      let tjzb1 = {
        color: '#F25267',
        rale: 0,
        num: '--',
        title: '80%以下单位数'
      }
      let tjzb2 = {
        color: '#F19147',
        rale: 0,
        num: '--',
        title: '80%-90%单位数'
      }
      let tjzb3 = {
        color: '#019FE8',
        rale: 0,
        num: '--',
        title: '90%-95%单位数'
      }
      let tjzb4 = {
        color: '#F7EA00',
        rale: 0,
        num: '--',
        title: '95%以上单位数'
      }
      init_g2_sbt(sbt1, [{
        gender: 'male',
        value: "0" * 1
      }], '#F662FF');
      init_g2_sbt(sbt2, [{
        gender: 'male',
        value: "0" * 1,
      }], '#00A0E8');
      init_g2_sbt(sbt3, [{
        gender: 'male',
        value: "0" * 1
      }], '#4CD997');

      this.$refs.lsjsl1.init_data(tjzb1)
      this.$refs.lsjsl2.init_data(tjzb2)
      this.$refs.lsjsl3.init_data(tjzb3)
      this.$refs.lsjsl4.init_data(tjzb4)



      this.$refs.lsjsla1.init_data(tjzb1)
      this.$refs.lsjsla2.init_data(tjzb2)
      this.$refs.lsjsla3.init_data(tjzb3)
      this.$refs.lsjsla4.init_data(tjzb4)
    },
    initTtl() {
      //alert(this.level);
      document.getElementById('sbta1').innerHTML = '';
      document.getElementById('sbta2').innerHTML = '';
      document.getElementById('sbta3').innerHTML = '';
      let path = "";
      path = "bsv/dpkfourlibrary/findDlvTimelyList";
      let params = {
        businessTypes: "B",
        dataType: 'D',
        countDate: dayjs().subtract(2, 'day').format('YYYYMMDD'),
        areaCode: this.xzqh === '000000' ? '999999' : this.xzqh,
        superiorAreaName: '',
        regionalLevel: this.level == 1 || this.level == 2 ? '1' : Number(this.level) - 1
      };
      const msgbody1 = JSON.stringify(params)
      //alert(msgbody1)
      interface1.get(path, {
        params: {
          'sendID': '00000001',
          'timestamp': timestamp,
          'msgBody': msgbody1,
          'dataDigest': base64.encode(hex_md5(msgbody1 + data_key + timestamp))
        }
      }).then(({
        data
      }) => {
        console.log(data, 'zxcvbn');
        if (data.data === null) {
          init_g2_sbt(sbta1, [{
            gender: 'male',
            value: 0
          }], '#F662FF');
          init_g2_sbt(sbta2, [{
            gender: 'male',
            value: 0,
          }], '#00A0E8')
          //     init_g2_sbt(sbta3,[{
          //     gender: 'male',
          //     value: 0
          // }],'#4CD997')
          return;
        }
        data.data.length !== 0 ?
          init_g2_sbt(sbta1, [{
            gender: 'male',
            value: Number(Number(data.data[0].rate).toFixed(1))
          }], '#F662FF') : init_g2_sbt(sbta1, [{
            gender: 'male',
            value: 0
          }], '#F662FF');
        data.data.length !== 0 ?
          init_g2_sbt(sbta2, [{
            gender: 'male',
            value: Number(Number(data.data[0].timeLimit * 100).toFixed(1)),
          }], '#00A0E8') : init_g2_sbt(sbta2, [{
            gender: 'male',
            value: 0,
          }], '#00A0E8')
        // data.data.length !== 0
        // ? init_g2_sbt(sbta3,[{
        //     gender: 'male',
        //     value: Number(Number(data.data[0].timeLimit*100).toFixed(0))
        // }],'#4CD997') : init_g2_sbt(sbta3,[{
        //     gender: 'male',
        //     value: 0
        // }],'#4CD997')
      }).catch(err => {
        console.log(err);

      });
      //快包
      let params2 = {
        businessTypes: "K",
        dataType: 'D',
        countDate: dayjs().subtract(2, 'day').format('YYYYMMDD'),
        areaCode: this.xzqh === '000000' ? '999999' : this.xzqh,
        superiorAreaName: '',
        regionalLevel: this.level == 1 || this.level == 2 ? '1' : Number(this.level) - 1
      };
      const msgbody12 = JSON.stringify(params2)
      // alert(msgbody12)
      interface1.get(path, {
        params: {
          'sendID': '00000001',
          'timestamp': timestamp,
          'msgBody': msgbody12,
          'dataDigest': base64.encode(hex_md5(msgbody12 + data_key + timestamp))
        }
      }).then(({
        data
      }) => {
        console.log(data, 'zxcvbn');
        if (data.data === null) {
          init_g2_sbt(sbta1, [{
            gender: 'male',
            value: 0
          }], '#F662FF');
          // init_g2_sbt(sbta2,[{
          //         gender: 'male',
          //         value: 0,
          //     }],'#00A0E8')
          init_g2_sbt(sbta3, [{
            gender: 'male',
            value: 0
          }], '#4CD997')
          return;
        }
        data.data.length !== 0 ?
          init_g2_sbt(sbta1, [{
            gender: 'male',
            value: Number(Number(data.data[0].rate).toFixed(1))
          }], '#F662FF') : init_g2_sbt(sbta1, [{
            gender: 'male',
            value: 0
          }], '#F662FF');
        // data.data.length !== 0
        // ? init_g2_sbt(sbta2,[{
        //     gender: 'male',
        //     value: Number(Number(data.data[0].timeLimit*100).toFixed(0)),
        // }],'#00A0E8') : init_g2_sbt(sbta2,[{
        //     gender: 'male',
        //     value: 0,
        // }],'#00A0E8')
        data.data.length !== 0 ?
          init_g2_sbt(sbta3, [{
            gender: 'male',
            value: Number(Number(data.data[0].timeLimit * 100).toFixed(1))
          }], '#4CD997') : init_g2_sbt(sbta3, [{
            gender: 'male',
            value: 0
          }], '#4CD997')
      }).catch(err => {
        console.log(err);

      });
    },
  },
  mounted() {
    this.count_date = dayjs().subtract(2, 'day').format('YYYY-MM-DD')
    this.init_tjzb();
  }
})

// 屏蔽异常监控模块
// Vue.component('errormonitor',{
//   props:['data'],
//   data(){
//     return{
//       recvNum:'0',//投递解车量
//       yesRecvNum:'0',//投递解车量昨日同期
//       yesRecvSum:'0',//投递解车量做日总量
//       yesRecvNio:'0',//投递解车量昨日同比
//       depoNum:'0',//存局量
//       yesDepoNum:'0',//存局量昨日同期
//       yesDepoSum:'0',//存局量昨日总量
//       yesDepoNio:'0',//存局量昨日同比
//       hypoNum:'0',//下段量
//       yesHypoNum:'0',//下段量昨日同期
//       yesHypoSum:'0',//下段量昨日总量
//       yesHypoNio:'0',//下段量昨日同比
//       turnbackNum:'0',//转退量
//       yesTurnbackNum:'0',//转退量昨日同期
//       yesTurnbackSum:'0',//转退量昨日总量
//       yesTurnbackNio:'0',//转退量昨日同比
//       propVoteNum:'0',//妥投量
//       yesPropVoteNum:'0',//妥投量昨日同期
//       yesPropVoteSum:'0',//妥投量昨日总量
//       yesPropVoteNio:'0',//妥投量昨日同比
//       notPropVoteNum:'0',//未妥投量
//       yesNotPropVoteNum:'0',//未妥投量总日同期
//       yesNotPropVoteSum:'0',//未妥投量昨日总量
//       yesNotPropVoteNio:'0',//未妥投量昨日总量
//       notFeedbackNum:'0',//已下段未反馈量
//       yesNotFeedbackNum:'0',//已下段未反馈量昨日同期
//       yesNotFeedbackSum:'0',//已下段未反馈量昨日总量
//       yesNotFeedbackNio:'0',//已下段未反馈量昨日同比
//       notHandNum:'0',//已解车未下段量
//       yesNotHandNum:'0',//已解车未下段昨日同期
//       yesNotHandSum:'0',//已解车未下段昨日总量
//       yesNotHandNio:'0',//已解车未下段昨日同比
//     }
//   },
//   methods:{
//     tolist(a){
//       var mem = a+"-workdlv"
//       try {
//         Emp.execute("toworkdlvlist('"+mem+"')");
//       } catch (error) {
//         console.error(error)
//       }
//     },

//     init_data(data){
//       for (let key in data) {
//         this[key] = data[key]
//       }
//     }
//   },
//   template:`
//   <div id="errormonitor" class="br-10 m-b-10 b-s-gray">
//     <div class="charttitle">
//       异常监控
//     </div>
//     <div class="block-list">
//       <div class="listitem">已解车未下段总量<span  @click="tolist('notHandNum')">{{notHandNum}}</span></div>
//       <div   v-show='false'class="listitem listitem-b">有信息无实物（少件）<span style="color: #ff3333;">--</span></div>
//       <div class="listitem b-d-t-gray">已下段未投递量<span @click="tolist('notFeedbackNum')">{{notFeedbackNum}}</span></div>
//       <div  v-show='false' class="listitem b-d-t-gray">已投递未反馈<span>--</span></div>
//       <div  v-show='false' class="listitem b-d-t-gray">逾限邮件接收量<span>--</span></div>
//       <div  v-show='false' class="listitem error b-d-t-gray">已超进口能力机构数<span>--</span></div>
//       <div  v-show='false' class="listitem warning b-d-t-gray">预计超进口能力机构数<span>--</span></div>
//     </div>
//     <div  v-show='false' class="deliversubtitle b-s-t-gray">投递逾限量</div>
//     <div  v-show='false' class="item-box">
//       <div class="b-d-t-gray w-33 p-t-15 p-b-15">
//         <p style="font-size: 14px;">总量</p>
//         <p class="color-blue bold" style="font-size: 20px;">--</p>
//       </div>
//       <div class="b-d-t-gray w-33 p-t-15 p-b-15 b-d-l-gray">
//         <p style="font-size: 14px;">超12小时</p>
//         <p class="color-yellow bold" style="font-size: 20px;">--</p>
//       </div>
//       <div class="b-d-t-gray w-33 p-t-15 p-b-15 b-d-l-gray">
//         <p style="font-size: 14px;">超24小时</p>
//         <p class="color-error bold" style="font-size: 20px;">--</p>
//       </div>
//     </div>
//   </div>
//   `
// })
Vue.component('unloadnumratio', {
  props: ['data'],
  template: `
  <div v-show='false' id="unloadnumratio" class="br-10 m-b-10 b-s-gray">
    <div class="charttitle">
    解车量同比
    </div>
    <div class="deliversubtitle">投递解车量突增</div>
    <div class="progress_com">  
      <div class="progress_com_item_2">
        <item-prgress ref="lsjsl1"/>
      </div>
      <div class="progress_com_item_2">
        <item-prgress ref="lsjsl2"/>
      </div>
      <div class="progress_com_item_2">
        <item-prgress ref="lsjsl3"/>
      </div>
    </div>
    
  </div>
  `,
  methods: {
    init_data(data) {
      for (let key in data) {
        this[key] = data[key]
      }
    },
    init_tjzb() {
      let tjzb1 = {
        color: '#F25267',
        rale: 0,
        num: '--',
        title: '80%以下单位数'
      }
      let tjzb2 = {
        color: '#F19147',
        rale: 0,
        num: '--',
        title: '80%-90%单位数'
      }
      let tjzb3 = {
        color: '#019FE8',
        rale: 0,
        num: '--',
        title: '90%-95%单位数'
      }
      this.$refs.lsjsl1.init_data(tjzb1)
      this.$refs.lsjsl2.init_data(tjzb2)
      this.$refs.lsjsl3.init_data(tjzb3)

    }
  },
  mounted() {
    this.init_tjzb()
  }

})