/*
* data数据集
* name当前省市区名称
* splitList分隔区间
* mapType地图渲染的地区
* mapJson地区的json数据集, 全国时不传
* */
function initEcharts(data,name,splitList,mapType,mapJson = '') {
    var option = {
        tooltip: {
            textStyle: {color: "#fff"}, //提示标签字体颜色
            formatter: function (value) {
            	//alert(JSON.stringify(value))
                const val = value.data.value
                return val === '0' ? `${value.seriesName}<br/>${value.data.name}: -` :
                    `${value.seriesName}<br/>${value.data.name}: ${val}`
            }
        },
        visualMap: {
            show: false,
            splitList: splitList,
            bottom: 25,
            left: 'center',
            itemWidth: 50,
            color: ['#0153B7','#1180EC','#38A0FF','#71C1FF'],
            formatter: function(value){ //标签的格式化工具。
                return ''; // 范围标签显示内容。
            },
            align: 'right',
            orient: 'horizontal',
        },
        series: [
            {
                name: name,
                type: 'map',
                mapType: mapType,
                label: {
                    normal: {
                        show: false,//显示省份标签
                    },
                    emphasis: {
                        show: false,//对应的鼠标悬浮效果
                    }
                },
                emphasis: {
                    show: false,
                    //选择区域显示颜色
                    itemStyle: {
                        areaColor: '#fff100'
                    }
                },
                itemStyle: {
                    normal: {
                        borderColor:'#e6e6e6',
                        label: {
                            show: false
                        }
                    },
                },
                top: 10,
                data: data
            }
        ],

    };

    mapJson !== '' ? echarts.registerMap(mapType, mapJson) : '';
    let mychart2 = echarts.init(document.getElementById('chart1'));
    mychart2.setOption(option)
}
function initbt(data){
	let myChart = echarts.init(document.getElementById('bt'));
	myChart.setOption({
		tooltip: {
			trigger: 'item',
		},
		legend: {
			show: false
		},
		color: ['#59b3ff', '#e6d831', '#ff7362', '#4bda98', '#f19049', '#8956a1','#0000c7','#009f00','#45d1d1'],
		series: [{
				//name: '访问来源',
				type: 'pie',
				hoverAnimation:false,
				radius: [0, '25%'],

				label: {
					show: false,
					position: 'inner'
				},
				labelLine: {
					show: false
				},
				
				data: data,
			},
			{
				//name: '访问来源',
				type: 'pie',
				radius: ['35%', '50%'],
				hoverAnimation:true,
				label: {
					/*formatter: '{b|{b}} \n {c|{c}件}',
					padding: [0, -20],
					rich:{
						
						b:{
							 fontSize: 13,
							 fontWeight:'bold',
						},
						c:{
							fontSize: 13,
							fontWeight:'bold',
						}
					},*/
					
					normal:{
						fontSize: 13,
						fontWeight:'bold',
						padding: [0, -5],
		                formatter(v) {
		                    let text = v.name
		                    return text.length <= 5 ? `${text}\n${v.value}件` : `${text.slice(0,5)}\n${text.slice(5)}\n${v.value}件`
		                }
		            } 
				},
				 labelLine: {
		                normal: {
		                    length: 10,
		                    //length2: 70,
		                    lineStyle: {
		                        //color: '#333'
		                    }
		                }
		 
		            },
				data: data
			}
		]
	});
	
	
}
function initZx(legend, xData, series){
	console.log('seriesseries',xData)
	let myChart = echarts.init(document.getElementById('zx'));
	let option2 = {
		tooltip: {
			trigger: 'axis',
			axisPointer: {
				type: 'line'
			}
		},
		legend:
			[{
				data: legend,
				bottom: 5,
				itemGap: 10,
				x:'center'
			},
			/*{
				data: legend.slice(4,legend.length),
				bottom: 10,
				itemGap: 10,
				x:'center'	
			},*/],
		grid: {
			top: '13%',
			left: '3%',
			right: '4%',
			bottom: '20%',
			containLabel: true
		},
		xAxis: [{
			type: 'category',
			data: xData,
			'axisLine': {
				lineStyle: {
					color: '#90979c'
				}
			},
			'splitLine': {
				'show': false
			},
			'axisTick': {
				'show': true
			},
			'splitArea': {
				'show': false
			},
			'axisLabel': {
				'interval': 0,
				'rotate': 40 
			}
		}],
		yAxis: [{
			name: '',
			type: 'value',
			//name: '及时数',
			axisLine: {
				show: false
			},
			'axisTick': {
				'show': false
			},

			axisLabel: {
				margin: 2,
				formatter: function(value, index) {
					if (value >= 10000 && value < 10000000) {
						value = value / 10000 + '万'
					} else if (value >= 10000000) {
						value = value / 100000000 + '亿'
					}
					return value
				}
			}
		}],
		dataZoom: [{
	       	 "show": true,
	            "height": 30,
	            "xAxisIndex": [
	                0
	            ],
	            bottom: 30,
	            // startValue: 0,
	            // endValue:  xData.length > 5 ? 6 : xData.length - 1,
				startValue:xData.length > 7 ? xData.length - 7 : 0,
            	endValue:xData.length -1,
				// start:dateStrs()/ 24 * 100,
            	// end:dateStrs() / 24 * 100 + 46,
	            // maxValueSpan: 6,
	            // mixValueSpan: 6,
	            // handleIcon: "M0,0 v9.7h5 v-9.7h-5 Z",
	            handleStyle: { // 手柄的样式
	                color: "#40bcf9",
	                borderColor: "#1fb2fb"
	            },
	            backgroundColor: "#e2f3ff", // 背景
	            dataBackground: { // 数据背景
	                lineStyle: {
	                    color: "#000000"
	                },
	                areaStyle: {
	                    color: "#d4d9dd"
	                }
	            },
	            fillerColor: "rgba(31,178,251,0.2)", // 被start和end遮住的背景*/
	        }, {
	            "type": "inside",
	            "show": true,
	            "height": 15,
	            "start": 1,
	            "end": 0
	       }],
		 
		series:series,
	}
	myChart.setOption(option2)

	
}
// function splitfun(){
// 	var h = dayjs().get('hour')
// 	if(h<=5){
// 		return 5
// 	}else{
// 		return h+1
// 	}
// }
function dateStrs(){

    var date = new Date();
    // var year = date.getFullYear();
    // var month = date.getMonth() + 1 > 9 ? date.getMonth() + 1 : "0" +
    //     (date.getMonth() + 1);
    // var day = date.getDate() > 9 ? date.getDate() : "0" + date.getDate();
    var hour = date.getHours() > 9 ? date.getHours() : "0" +
        date.getHours();
    // var minute = date.getMinutes() > 9 ? date.getMinutes() : "0" +
    //     date.getMinutes();
    // var seconds = date.getSeconds() > 9 ? date.getSeconds() : "0" +
    //     date.getSeconds();
    
    // var strDate = year + "-" + month + "-" + day + " " + hour + ":" +
    //     minute + ":" + seconds;
    var dateStr = hour +3;
	console.log('dcscdf',dateStr)
    return dateStr
}