Vue.component('item-kk', {
    data() {
        return {
            title: '今日实时量',
            color: 'red',
            value: '0',
            isUp: true,
            changeNum: '0',
            rale: '0%',
            zrtql: '0',
            zrzl: '0',
            isBorder: true
        }
    },
    props: ['level'],
    filters: {
        //过滤字符串,每3字符加,
        addSpot(source) {
            if (source.length < 4) return source;
            let arr = [...source];
            let len = arr.length / 3;
            let newArr = [];
            for (let i = 0; i < len; i++) {
                let start = arr.length - 3 * (i + 1)
                let b = []
                if (start < 0) b = arr.slice(0, arr.length % 3);
                else b = arr.slice(start, arr.length - 3 * i);
                newArr.push(b.join(''));
            }
            return newArr.reverse().join(',');
        }
    },
    methods: {
        initData(data) {
            for (let key in data) {
                this[key] = data[key]
            }
        },
        toListView() {
            if (this.value == '0') return;
            console.log('xiazuanle1----');
            switch (this.title) {
                case '特快收寄量':
                    try {
                        Emp.execute(`toSjXiazhuan('bksjl')`)
                    } catch (e) {

                    }
                    break;
                case '快包收寄量':
                    try {
                        Emp.execute(`toSjXiazhuan('kbsjl')`)
                    } catch (e) {

                    }
                    break;
                case '普邮收寄量':
                    try {
                        Emp.execute(`toSjXiazhuan('pysjl')`)
                    } catch (e) {

                    }
                    break;
                case '国际收寄量':
                    try {
                        Emp.execute(`toSjXiazhuan('gjsjl')`)
                    } catch (e) {

                    }
                    break;
            }

        }
    },
    template: `<div class="box_item">
                <div class="box_item_div" style="border-top: none;">
                    <div class="box_item_title" @click="toListView">
                        <span class="title_font">{{title}}</span>
                        <p :style="{color: changeNum <= 0 ? '#F67767' : '#4CD997'}">{{value | addSpot}}</p>
                    </div>
                    <div class="box_item_title" :style="{color: changeNum <= 0 ? '#F67767' : '#4CD997'}">
                        <span style="font-size:12px">
                            <i :class="!isUp ? 'el-icon-caret-top' : 'el-icon-caret-bottom'"></i>
                            {{changeNum}}
                        </span>
                        <p style="font-size:12px"><i :class="!isUp ? 'el-icon-caret-top' : 'el-icon-caret-bottom'"></i>{{rale}}</p>
                    </div>
                </div>
                <div class="box_item_div">
                    <div class="box_item_div_item" style="border-right: 1px dashed #E6E6E6;">
                        <p>昨日同期量</p>
                        <p style="font-weight: bold; font-size: 12px">{{zrtql | addSpot}}</p>
                    </div>
                    <div class="box_item_div_item">
                        <p>昨日总量</p>
                        <p style="font-weight: bold; font-size: 12px">{{zrzl | addSpot}}</p>
                    </div>
                </div>
            </div>`
});


Vue.component('item-prgress', {
    data() {
        return {
            color: 'green',
            rale: 0,
            title: '80%-90%单位数',
            num: '0%'
        }
    },

    methods: {
        init_data(data) {
            for (let key in data) {
                this[key] = data[key]
            }
        }
    },
    template: `<div>
                    <div style="position: relative;">
                            <svg viewBox="0 0 100 100" style="height: 60px">
                                <path d="
                M 50 50
                m 0 -44
                a 44 44 0 1 1 0 88
                a 44 44 0 1 1 0 -88
                " stroke="#e5e9f2" stroke-width="11.9" fill="none"
                                      style="stroke-dasharray: 276.46px, 276.46px; stroke-dashoffset: 2px;"></path>
                                <path d="
                M 50 50
                m 0 -44
                a 44 44 0 1 1 0 88
                a 44 44 0 1 1 0 -88
                " :stroke="color" fill="none" :stroke-linecap="rale !== 0 ? 'round' : ''" stroke-width="11.9" class="aaa"
                                      :style="{'stroke-dasharray': (276.46 * rale / 100).toFixed(3) + 'px, 276.46px'}"></path>
                            </svg>
                            <div class="cale" :style="{color: color}">{{num}}</div>
                     </div>
                    <div style="text-align: center; margin-top: 8px">
                        <p>{{title}}</p>
                    </div> 
            </div>`
});

Vue.component('sjltz', {
    data() {
        return {
            list: []
        }
    },
    methods: {
        init_data(data) {
            for (let key in data) {
                this[key] = data[key]
            }
        }
    },
    filters: {},
    template: `<div >
                    <div v-for="(item,index) in list" :key="index"
                         style="margin-top: 5px; display: flex; justify-content: space-between; height: 35px; width: 100%; font-size: 14px; color: #666666">
                        <div style="width: 30%; line-height: 35px; text-align: left; padding: 0 5px">
                            <p>{{item.title}}</p>
                        </div>
                        <div style="width: 70%; display: flex; align-items: center">
                            <div :style="{border: item.borderColor}"
                                 style="width: 70%; height: 25px; display: flex; padding: 2px; border-radius: 5px">
                                <div v-for="i in item.rale" :style="{background: item.color}" class="dct_item"></div>
                                <div class="dct_item">
                                    <div style="height: 100%" :style="{width: item.rale_s, background: item.color}"></div>
                                </div>
                                <div v-for="i in (9 - item.rale)" class="dct_item"></div>
                            </div>
                            <div style="width: 30%; text-align: left; font-size: 16px" :style="{color: item.color}">
                                <p>&nbsp;&nbsp;{{item.num}}</p>
                            </div>
                        </div>
                    </div>
                </div>`
})


Vue.component('order_tj', {
    data() {
        return {
            isUp: true,
            color: 'green',
            rale: '80',
            title: '80%单位数',
            fontColor: '#FF7362',
            orderNum: '1000000',
            tbNum: '4520'
        }
    },
    methods: {
        init_data(data) {
            for (let key in data) {
                this[key] = data[key]
            }
        }
    },
    filters: {
        addSpot(source) {
            if (source.length < 4) return source;
            let arr = [...source];
            let len = arr.length / 3;
            let newArr = [];
            for (let i = 0; i < len; i++) {
                let start = arr.length - 3 * (i + 1)
                let b = []
                if (start < 0) b = arr.slice(0, arr.length % 3);
                else b = arr.slice(start, arr.length - 3 * i);
                newArr.push(b.join(''));
            }
            return newArr.reverse().join(',');
        }
    },
    template: `<div>
        <div class="progress_com">
            <div class="progress_com_item_2 order_title">
                <div style="height: 45px; line-height: 20px; text-align: center">
                    <p>订单量</p>
                    <p style="font-weight: bold; font-size: 18px; line-height: 25px" :style="{color: fontColor}">{{orderNum | addSpot}}</p>
                </div>
            </div>
            <div class="progress_com_item_2">
                <div style="position: relative; ">
                    <svg viewBox="0 0 100 100" style="max-height: 100px; margin-top: 13px;">
                        <path d="
                M 50 50
                m 0 -44
                a 44 44 0 1 1 0 88
                a 44 44 0 1 1 0 -88
                " stroke="#e5e9f2" stroke-width="11.9" fill="none"
                              style="stroke-dasharray: 276.46px, 276.46px; stroke-dashoffset: 2px;"></path>
                        <path d="
                M 50 50
                m 0 -44
                a 44 44 0 1 1 0 88
                a 44 44 0 1 1 0 -88
                " :stroke="color" fill="none" stroke-linecap="round" stroke-width="11.9" class="aaa"
                              :style="{'stroke-dasharray': (276.46 * rale / 100).toFixed(3) + 'px, 276.46px'}"></path>
                    </svg>
                    <div class="cale" :style="{color: fontColor}">
                        <i :class="isUp ? 'el-icon-caret-top' : 'el-icon-caret-bottom'"></i>{{rale}}%
                    </div>
                </div>
            </div>
            <div class="progress_com_item_2 order_title">
                <div style="height: 40px; line-height: 20px; text-align: center">
                    <p>同比</p>
                    <p style="font-weight: bold; font-size: 18px; line-height: 25px" :style="{color: fontColor}">{{tbNum | addSpot}}</p>
                </div>
            </div>   
        </div>
        <div style="text-align: center; font-weight: bold; margin-top: -20px" :style="{color: color}">
            {{title}}
        </div>
    </div>`
})

Vue.component('order_bfb', {
    data() {
        return {
            list: [
                {
                    num: '10000',
                    title: '菜鸟',
                    rale: '30%'
                },
                {
                    num: '15000',
                    title: '拼多多',
                    rale: '40%'
                }
            ]
        }
    },
    methods: {
        init_data(data) {
            for (let key in data) {
                this[key] = data[key]
            }
        }
    },
    filters: {
        addSpot(source) {
            if (source.length < 4) return source;
            let arr = [...source];
            let len = arr.length / 3;
            let newArr = [];
            for (let i = 0; i < len; i++) {
                let start = arr.length - 3 * (i + 1)
                let b = []
                if (start < 0) b = arr.slice(0, arr.length % 3);
                else b = arr.slice(start, arr.length - 3 * i);
                newArr.push(b.join(''));
            }
            return newArr.reverse().join(',');
        }
    },
    template: `<div>
        <div v-for="(i,index) in list" :key="index"
             style="display: flex; justify-content: space-between; width: 100%; font-size: 13px; color: #666666">
            <div style="width: 20%; padding: 0 7px">
                <p>{{i.title}}</p>
            </div>
            <div style="width: 80%; display: flex; align-items: center">
                <div style="width: 70%; height: 20px; display: flex; padding: 2px; border-radius: 5px">
                    <div class="dct_item">
                        <div style="height: 100%;" :style="{width: i.rale, 'background-color': index % 2 === 0 ? '#48DCF1' : '#1D95F4'}">

                        </div>
                    </div>
                </div>
                <div style="width: 30%; text-align: right; padding: 0 7px">
                    <p>{{i.num | addSpot}}</p>
                </div>
            </div>
        </div>
    </div>`
});


Vue.component('sjltj', {
    data() {
        return {
            value: '0',
            color: '#F67767',
            tb: '0',
            tbl: '0%',
            isUp: true,
            zrtql: '0',
            zrzl: '0',
            colors: ['#71C1FF', '#38A0FF', '#1180EC', '#0153B7'],
            splitList: [],
			showMap: true, // 是否显示地图
        }
    },
    props: ['level'],
	created() {
		
	},
    methods: {
        init_data(data) {
            for (let key in data) {
                this[key] = data[key]
            }
        },
        init_echartsMap(xzqh, levels, xzqhName, obj={}) {
			console.log(levels)
            if (Number(levels) > 6) {
                return
            }
            let sumLevel;
            if((xzqh.substr(0, 2) == '11' || xzqh.substr(0, 2) == '12' || xzqh.substr(0, 2) == '31' || xzqh.substr(0, 2) == '50')) {
                xzqh = xzqh.substr(0, 2) + '0000'
                sumLevel = levels
            } else {
                sumLevel = levels === '1' || levels === '2' ? '1' : Number(levels) - 1
            }
			
			var provCode = '';
			var cityCode = '';
			var countyCode = '';
			var orgCode = '';
			
			if(levels == '1' || levels == '2'  ) {
				// 全国账户
			} else if(levels == '3' ) {
				provCode = xzqh
			} else if(levels == '4' ) {
				provCode = xzqh.substr(0, 2) + '0000'
				cityCode = xzqh
			} else if(levels == '5' ){
				provCode = xzqh.substr(0, 2) + '0000'
				cityCode = xzqh.substr(0, 4) + '00'
				countyCode = xzqh
			}else if(levels == '6') {
				 provCode = obj.proCode;
				 cityCode = obj.cityCode;
				 countyCode = obj.countyCode;
				 orgCode = obj.orgCode;
			}
			
			
			// provCode = '320000'
			// cityCode = '320100'
			// countyCode = '320106'
			// orgCode = '21003722'
			// sumLevel = '5'
			
			let date = dayjs().format('YYYY-MM-DD')
			// let date = '2021-08-24'
            let params = {
                distCode: xzqh,
                sumLevel: sumLevel,
                sumFg: '1',
				date: date,
				provCode ,
				cityCode,
				countyCode,
                orgCode,
            };
            this.getMapData(JSON.stringify({
                distCode: xzqh,
                sumLevel: sumLevel,
                sumFg: '2',
                date: date,
				provCode ,
				cityCode,
				countyCode,
                orgCode,
				
            }), {
                xzqh: xzqh, levels: levels, xzqhName: xzqhName
            });
            const msgbody1 = JSON.stringify(params);
            var interface1 = axios.create({
                'Access-Control-Allow-Origin': '*',
                baseURL: board_url,
                timeout: 10000
            });
            interface1.get('dpk/queryPcPostNumInfo', {
                params: {
                    'sendID': '00000001',
                    'timestamp': timestamp,
                    'msgBody': msgbody1,
                    'dataDigest': base64.encode(hex_md5(msgbody1 + data_key + timestamp))
                }
            }).then(({ data }) => {
                if (data.resCode !== 'R00001') {
                    initData()
                } else {
                    const sumVal = data.data[0];
                    const tk = Number(sumVal.superfastNum);
                    const tkzrz = Number(sumVal.yestSuperfastNum);
                    const changeNum = tk - tkzrz;
                    let fata = {
                        title: '特快收寄量',
                        color: '#F67767',
                        value: tk.toString(),
                        isUp: changeNum <= 0 ? true : false,
                        changeNum: changeNum.toString(),
                        rale: tkzrz == 0 ? '0%' : (changeNum / tkzrz * 100).toFixed(2) + '%',
                        zrtql: tkzrz.toString(),
                        zrzl: sumVal.yestSuperfastTotal.toString(),
                    };
                    const kb = Number(sumVal.quickpackNum);
                    const kbzrz = Number(sumVal.yestQuickpackNum);
                    const kbchangeNum = kb - kbzrz;
                    let fata2 = {
                        title: '快包收寄量',
                        color: '#F67767',
                        value: kb.toString(),
                        isUp: kbchangeNum <= 0 ? true : false,
                        changeNum: kbchangeNum.toString(),
                        rale: kbzrz == 0 ? '0%' : (kbchangeNum / kbzrz * 100).toFixed(2) + '%',
                        zrtql: kbzrz.toString(),
                        zrzl: sumVal.yestQuickpackTotal.toString(),
                    };
                    const py = Number(sumVal.generpostNum);
                    const pyzrz = Number(sumVal.yestGenerpostNum);
                    const pychangeNum = py - pyzrz;
                    let fata3 = {
                        title: '普邮收寄量',
                        color: '#F67767',
                        value: py.toString(),
                        isUp: pychangeNum <= 0 ? true : false,
                        changeNum: pychangeNum.toString(),
                        rale: pyzrz == 0 ? '0%' : (pychangeNum / pyzrz * 100).toFixed(2) + '%',
                        zrtql: pyzrz.toString(),
                        zrzl: sumVal.yestGenerpostTotal.toString(),
                    };
                    const gj = Number(sumVal.internNum);
                    const gjzrz = Number(sumVal.yestInternNum);
                    const gjchangeNum = gj - gjzrz;
                    let fata4 = {
                        title: '国际收寄量',
                        color: '#F67767',
                        value: gj.toString(),
                        isUp: gjchangeNum <= 0 ? true : false,
                        changeNum: gjchangeNum.toString(),
                        rale: gjzrz == 0 ? '0%' : (gjchangeNum / gjzrz * 100).toFixed(2) + '%',
                        zrtql: gjzrz.toString(),
                        zrzl: sumVal.yestInternTotal.toString(),
                    };
                    this.value = sumVal.postNum.toString();
                    const tbvalue = (Number(sumVal.postNum) - Number(sumVal.yestPostNum));
                    this.tb = tbvalue.toString();
                    this.tbl = sumVal.yestPostNumRate.toString() + '%';
                    this.isUp = tbvalue <= 0 ? true : false
                    this.zrtql = sumVal.yestPostNum.toString();
                    this.zrzl = sumVal.yestPostNumTotal.toString();
                    fata.value = sumVal.superfastNum.toString()
                    fata2.value = sumVal.quickpackNum.toString()
                    fata3.value = sumVal.generpostNum.toString()
                    fata4.value = sumVal.internNum.toString()
                    this.$refs.bksjl.initData(fata)
                    this.$refs.kbsjl.initData(fata2)
                    this.$refs.pysjl.initData(fata3)
                    this.$refs.gjsjl.initData(fata4)
                }
            });
        },
        getMapData(params, xzqhData) {
            var interface1 = axios.create({
                'Access-Control-Allow-Origin': '*',
                baseURL: board_url,
                timeout: 10000
            });
            interface1.get('dpk/queryPcPostNumInfo', {
                params: {
                    'sendID': '00000001',
                    'timestamp': timestamp,
                    'msgBody': params,
                    'dataDigest': base64.encode(hex_md5(params + data_key + timestamp))
                }
            }).then(({ data }) => {
               
                this.init_map(data.data, xzqhData)
            })
        },
        init_map(data, { xzqh, levels, xzqhName }) {
            const splitListFun = (max) => {
                const pjz = parseInt(max / 4)
                const tt = Math.pow(10, Number(pjz.toString().length - 2))
                let new_value = 0;
                if (pjz % tt === 0) {
                    const next = Number(pjz.toString().substring(1, 2))
                    if (0 < next && next < 5) {
                        new_value = (Number(pjz.toString().substring(0, 2)) + 5 - next) * tt
                    } else if (5 < next) {
                        new_value = (Number(pjz.toString().substring(0, 2)) + 10 - next) * tt
                    } else {
                        new_value = pjz
                    }

                } else {
                    const next = pjz.toString().substring(1, 2)
                    if (next < 5) {
                        new_value = (Number(pjz.toString().substring(0, 2)) + 5 - next) * tt
                    } else {
                        new_value = (Number(pjz.toString().substring(0, 2)) + 10 - next) * tt
                    }
                }
                return new_value
            };
            const dataMap = [
                { name: '北京', value: '0' }, { name: '天津', value: 0 },
                { name: '上海', value: 0 }, { name: '重庆', value: 0 },
                { name: '河北', value: 0 }, { name: '河南', value: 0 },
                { name: '云南', value: 0 }, { name: '辽宁', value: 0 },
                { name: '黑龙江', value: 0 }, { name: '湖南', value: 0 },
                { name: '安徽', value: 0 }, { name: '山东', value: 0 },
                { name: '新疆', value: 0 }, { name: '江苏', value: 0 },
                { name: '浙江', value: 0 }, { name: '江西', value: 0 },
                { name: '湖北', value: 0 }, { name: '广西', value: 0 },
                { name: '甘肃', value: 0 }, { name: '山西', value: 0 },
                { name: '内蒙古', value: 0 }, { name: '陕西', value: 0 },
                { name: '吉林', value: 0 }, { name: '福建', value: 0 },
                { name: '贵州', value: 0 }, { name: '广东', value: 0 },
                { name: '青海', value: 0 }, { name: '西藏', value: 0 },
                { name: '四川', value: 0 }, { name: '宁夏', value: 0 },
                { name: '海南', value: 0 }, { name: '台湾', value: 0 }, { name: '南海诸岛', value: 0 }
            ];
            const shengNames = {
                "110000": "北京",
                "120000": "天津",
                "130000": "河北",
                "140000": "山西",
                "150000": "内蒙古",
                "210000": "辽宁",
                "220000": "吉林",
                "230000": "黑龙江",
                "310000": "上海",
                "320000": "江苏",
                "330000": "浙江",
                "340000": "安徽",
                "350000": "福建",
                "360000": "江西",
                "370000": "山东",
                "410000": "河南",
                "420000": "湖北",
                "430000": "湖南",
                "440000": "广东",
                "450000": "广西",
                "460000": "海南",
                "500000": "重庆",
                "510000": "四川",
                "520000": "贵州",
                "530000": "云南",
                "540000": "西藏",
                "610000": "陕西",
                "620000": "甘肃",
                "630000": "青海",
                "640000": "宁夏",
                "650000": "新疆"
            }
            let splitList = [
                { start: 400 },
                { start: 200, end: 400 },
                { start: 100, end: 200 }, { start: 0, end: 100 },
            ];
            this.splitList = [
                '0-100',
                '100-200',
                '200-400',
                '>400'
            ];

            const code = xzqh;
            //const code = '350000';
            const level = Number(levels);
            //const level = 3;
            let url = '';
            if (level < 3) {
                //中国地图
                if (data.length === 0) initEcharts(dataMap, '中国', splitList, 'china')
                else {
                    let realmap = [{ name: '台湾', value: 0 }, { name: '南海诸岛', value: 0 }]
                    let numberlist = []
                    for (const key in shengNames) {
                        const item = data.find(e => e.distCode === key)
                        if (item === undefined) realmap.push({ name: shengNames[key], value: '0' })
                        else {
                            realmap.push({ name: shengNames[key], value: item.postNum })
                            numberlist.push(Number(item.postNum))
                        }
                    }
                    const maxVal = Math.max.apply(Math, numberlist)
                    const avgVal = splitListFun(maxVal);

                    splitList = [
                        { start: avgVal * 3 },
                        { start: avgVal * 2, end: avgVal * 3 },
                        { start: avgVal, end: avgVal * 2 }, { start: 0, end: avgVal },
                    ];
                    maxVal < 10000 ? 
                    this.splitList = [
                        `<${(avgVal / 10000).toFixed(1)}`,
                        `<${(avgVal * 2 / 10000).toFixed(1)}`,
                        `<${(avgVal * 3 / 10000).toFixed(1)}`,
                        `<${(avgVal * 4 / 10000).toFixed(1)}`
                    ] : this.splitList = [
                        `<${(avgVal / 10000).toFixed(1)}万`,
                        `<${(avgVal * 2 / 10000).toFixed(1)}万`,
                        `<${(avgVal * 3 / 10000).toFixed(1)}万`,
                        `<${(avgVal * 4 / 10000).toFixed(1)}万`
                    ]
                    initEcharts(realmap, '中国', splitList, 'china')
                }
                return
            }
            if (level === 3) url = `../js/sj_board/json/100000/${code}.js`;
            if (level === 4) url = `../js/sj_board/json/100000/${code.substring(0, 2) + '0000'}/${code}.js`;
            if (level === 5) url = `../js/sj_board/json/100000/${code.substring(0, 2) + '0000'}/${code.substring(0, 4) + '00'}.js`
            
			
			//初始化数据
            let listdata = [];

            const testFun = (path, callback) => {
                var head = document.getElementsByTagName('head')[0];
                var script = document.createElement('script');
                script.type = 'text/javascript';
                script.src = path;
                head.appendChild(script);
                if (!/*@cc_on!@*/false) {
                    script.onload = function () {
                        console.log("非ie");
                        callback();
                    }
                } else {
                    script.onreadystatechange = function () {
                        if (script.readystate === "loaded" || script.readState === 'complate') {
                            console.log("ie");
                            callback();
                        }
                    }
                }
            }
            const _this = this;
			
			if(level >= 5){
				this.showMap = false
				return true
			} 
			this.showMap = true
			
			
            testFun(url, function () {
                console.log("已经加载完成")
                if (data.length === 0 || data.length === 1) {
					
                    mapobj.features.forEach(i => {
                        // i.properties.adcode
                        listdata.push({
                            name: i.properties.name,
                            value: 0
                        })
                    });
                    initEcharts(listdata, xzqhName, splitList, name, mapobj)
                } else {
					
                    let numberlist = []
					console.log('111111111111111111111111111')
					console.log(data)
                    mapobj.features.forEach(i => {
						console.log(i.properties.adcode)
                        // i.properties.adcode
						// 替换了北京110100，天津120100，上海310100，重庆500100等4个直辖市的地图json，
						// 其中新地图json中中不包含adcode字段，但其中的id与原地图中的adcode含义一致，
						// 为防止字段找不到而报错，因此转换字段
						i.properties.adcode = i.properties.adcode ? i.properties.adcode : i.properties.id
                        // const item = data.find(e => e.distCode === i.properties.adcode.toString())
						const item = data.find(e => {
							
							if(level == 5 && e.countyCode == i.properties.adcode.toString()) {
								console.log(i)
								console.log('level:'+level)
								console.log('e.cityName:'+e.cityName)
								// 区县下机构数据时,展示当前区县的数据
								// 例如 唐山市古冶区账号查看，数据获取的是该区下的机构数据，但是显示唐山地图，数据汇总显示本区数据
								xzqhName = e.cityName
								return true
							}
							
							if(e.distCode === i.properties.adcode.toString()) {
								return true
							}
						})
						
						
							console.log(item)
                        if (item === undefined){
							console.log(11)
							listdata.push({ name: i.properties.name, value: '0' })
                        } else {
							console.log(222)
                            listdata.push({ name: i.properties.name, value: item.postNum })
                            numberlist.push(Number(item.postNum))
                        }
                    });

                    const maxVal = Math.max.apply(Math, numberlist)
                    const avgVal = splitListFun(maxVal);
                    splitList = [
                        { start: avgVal * 3 },
                        { start: avgVal * 2, end: avgVal * 3 },
                        { start: avgVal, end: avgVal * 2 }, { start: 0, end: avgVal },
                    ];
					
					let unit = ''
					if(maxVal >= 10000) {
						unit = '万'
					}
                    _this.splitList = [
                        `<${(avgVal / 10000).toFixed(1)}${unit}`,
                        `<${(avgVal * 2 / 10000).toFixed(1)}${unit}`,
                        `<${(avgVal * 3 / 10000).toFixed(1)}${unit}`,
                        `<${(avgVal * 4 / 10000).toFixed(1)}${unit}`
                    ];
					
					console.log(listdata)
					console.log(mapobj)
					
					
					
					
					
                    initEcharts(listdata, xzqhName, splitList, xzqhName, mapobj)
                }
            });
        },
        init_sjltj(xzqh, level, xzqhName, obj={}) {
            //initEcharts();
            this.init_echartsMap(xzqh, level, xzqhName, obj)

        },
        toListView() {
            if (this.value == '0') return
			if (this.level  == '06') return
			if (this.level * 1 >= 6) return
            try {
                Emp.execute(`toSjXiazhuan('jrssl')`)
            } catch (e) {

            }
        }
    },
    filters: {
        addSpot(source) {
            if (source.length < 4) return source;
            let arr = [...source];
            let len = arr.length / 3;
            let newArr = [];
            for (let i = 0; i < len; i++) {
                let start = arr.length - 3 * (i + 1)
                let b = []
                if (start < 0) b = arr.slice(0, arr.length % 3);
                else b = arr.slice(start, arr.length - 3 * i);
                newArr.push(b.join(''));
            }
            return newArr.reverse().join(',');
        }
    },

    template: `<div>
            <div class="sj_title">
                收寄量统计
            </div>
            <div style=" width: 100%; border-left: 1px solid #e6e6e6; border-right: 1px solid #e6e6e6; box-sizing: border-box">
                <div v-show="showMap" id="chart1" class="content"></div>
                <div v-show="showMap" style="margin-top: -40px; margin-bottom: 10px">
                    <div style="width: 280px; margin: 0 auto; display: flex; justify-content: space-between; ">
                        <div v-for="(i,index) in splitList" style="width: 55px; margin: 5px; text-align: center; font-size: 12px">
                            <div style="width: 100%; height: 10px" :style="{'background-color': colors[index]}"></div>
                            {{i}}
                        </div>
                    </div>
                </div>
                <div>
                    <div style="display: flex; justify-content: space-between; border: 1px solid #E9E9E9; border-left: none; border-right: none">
                        <div class="box_item" style="border-right: 1px solid #e6e6e6">
                            <div style="text-align: center; line-height: 35px; margin-top: 28px; " @click="toListView">
                                <p style="color: #4495D4; font-weight: bold; font-size: 18px">今日实时量</p>
                                <p :style="{color: tb <= 0 ? '#F67767' : '#4CD997'}" style="font-size: 19px; font-weight: bold">{{value |
                                    addSpot}}</p>
                            </div>
                        </div>
                        <div class="box_item">
                            <div class="box_item_div" style="border-top: none; ">
                                <div class="box_item_div_item" style="border-right: 1px dashed #E6E6E6;">
                                    <p>同比<i :class="!isUp ? 'el-icon-caret-top' : 'el-icon-caret-bottom'" :style="{color: tb <= 0 ? '#F67767' : '#4CD997'}"></i></p>
                                    <p :style="{color: tb <= 0 ? '#F67767' : '#4CD997'}" style="font-weight: bold; font-size: 12px">
                                        {{tb}}
                                    </p>
                                </div>
                                <div class="box_item_div_item">
                                    <p>同比率<i :class="!isUp ? 'el-icon-caret-top' : 'el-icon-caret-bottom'" :style="{color: tb <= 0 ? '#F67767' : '#4CD997'}" ></i></p>
                                    <p :style="{color: tb <= 0 ? '#F67767' : '#4CD997'}" style="font-weight: bold; font-size: 12px">
                                        {{tbl}}
                                    </p>
                                </div>
                            </div>
                            <div class="box_item_div">
                                <div class="box_item_div_item" style="border-right: 1px dashed #E6E6E6;">
                                    <p>昨日同期量</p>
                                    <p style="font-weight: bold; font-size: 12px">{{zrtql | addSpot}}</p>
                                </div>
                                <div class="box_item_div_item">
                                    <p>昨日总量</p>
                                    <p style="font-weight: bold; font-size: 12px">{{zrzl | addSpot}}</p>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div style="display: flex">
                        <div style="border-bottom: 1px solid #e6e6e6; width: 100%; border-right: 1px solid #e6e6e6">
                            <div class="box_item" style="border-bottom: 1px solid #e6e6e6">
                                <item-kk  ref="bksjl" :level="level"></item-kk>
                            </div>
                            
                            <div class="box_item">
                                <item-kk  ref="pysjl" :level="level"></item-kk>
                            </div>
                        </div>
    
                        <div style="border-bottom: 1px solid #e6e6e6; width: 100%">
                            <div class="box_item" style="border-bottom: 1px solid #e6e6e6">
                                <item-kk  ref="kbsjl" :level="level"></item-kk>
                               
                            </div>
                            <div class="box_item">
                                <item-kk  ref="gjsjl" :level="level"></item-kk>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>`
});


Vue.component('zxt-compoent', {
    data() {
        return {
            xDataArray: [],
            totalArray: [],
            superFastArray: [],
            quickPackArray: [],
            generPostArray: [],
            internetArray: [],
        }
    },
    methods: {
         dateStrs(){
            var date = new Date();
            var hour = date.getHours() > 9 ? date.getHours() : "0" +
                date.getHours();
            var dateStr = hour - 3;
            return dateStr
        },
       
        init_jrsjl(xzqh, level, menu) {
            let path = "dpk/queryPcPostNum";
            let params = {
                distCode: xzqh,
                orgCode: '',
                sumLevel: level === '1' || level === '2' ? '1' : Number(level) - 1,
                sumFg: '1',
                dataDate: dayjs(new Date()).format('YYYY-MM-DD'),
            };
            //console.log(xzqh)
            const msgbody1 = JSON.stringify(params)
            var interface1 = axios.create({
                'Access-Control-Allow-Origin': '*',
                baseURL: board_url,
                //baseURL: 'https://211.156.195.17/bsv-app/',
                timeout: 10000
            });
            //console.log(msgbody1)
            interface1.get(path, {
                params: {
                    'sendID': '00000001',
                    'timestamp': timestamp,
                    'msgBody': msgbody1,
                    'dataDigest': base64.encode(hex_md5(msgbody1 + data_key + timestamp))
                }
            }).then(({ data }) => {
                console.log('datadata',data)
                var todayArray = [];
                var yesArray = [];
                var result = data.data;

                let todayObj = {}
                let yestodayObj = {}
                let times = [];
                let t = '';
                if (data.resCode === 'R00001') {
                    if (result[0].lineType === '1' && result[0].dpkPostLineDto.length > 0) {
                        var today = result[0].dpkPostLineDto;
                        today.forEach(e => {
                            if (e.dataDateStr != '') {
                                if (dayjs().subtract(1, 'day').format("YYYY-MM-DD")
                                    == e.dataDateStr) {
                                    t = 0
                                } else if (dayjs().format("YYYY-MM-DD")
                                    == e.dataDateStr) {
                                    t = (parseInt(e.frequency) + 1).toString();
                                }
                                times.push(t);
                                todayObj[t] = this.getNeedData(e, menu)
                            }
                        });
                        //console.log(result[0].dpkPostLineDto)
                    }
                    if (result[1].lineType === '2' && result[1].dpkPostLineDto.length > 0) {
                        var yestoday = result[1].dpkPostLineDto;
                        yestoday.forEach(e => {
                            if (e.dataDateStr != '') {
                                if (dayjs().subtract(2, 'day').format("YYYY-MM-DD")
                                    == e.dataDateStr) {
                                    t = 0
                                } else if (dayjs().subtract(1, 'day').format("YYYY-MM-DD")
                                    == e.dataDateStr) {
                                    t = (parseInt(e.frequency) + 1).toString();
                                }
                                times.push(t);
                                yestodayObj[t] = this.getNeedData(e, menu)
                            }
                        });
                        //console.log(result[1].dpkPostLineDto)
                    }
                }

                const dayTimes = ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '10', '11',
                    '12', '13', '14', '15', '16', '17', '18', '19', '20', '21', '22', '23', '24'];
                //const sortTimes = [...filterTime].sort((a,b) => Number(a) - Number(b))
                dayTimes.forEach(e => {
                    if (todayObj[e] === undefined) todayObj[e] = 0
                    if (yestodayObj[e] === undefined) yestodayObj[e] = 0
                });
                let xData = Object.keys(todayObj)
                const todayYdata = Object.values(todayObj)
                const yestodayYdata = Object.values(yestodayObj);
                const x_data = xData.map(e => {
                    if (e.length === 1) return `0${e}:00`
                    else return `${e}:00`
                })
                this.init_jrsjl_charts(x_data, todayYdata, yestodayYdata);
            }).catch(err => {
                console.log(err);
                this.init_jrsjl_charts([], [], [])
            });
        },
        getNeedData(e, menu) {
            if (menu === '总量') {
                return e.total
            } else if (menu === '特快') {
                return e.superfastNum
            } else if (menu === '快包') {
                return e.quickpackNum
            } else if (menu === '普邮') {
                return e.generpostNum
            } else if (menu === '国际') {
                return e.internNum
            }

        },
        init_jrsjl_charts(x_data, todayArray, yesArray) {
            let legend = ['今日', '昨日'];
            let xData = x_data.length > 0 ? x_data : ['00:00', '01:00', '02:00', '03:00', '04:00', '05:00', '06:00', '07:00', '08:00', '09:00', '10:00', '11:00',
                '12:00', '13:00', '14:00', '15:00', '16:00', '17:00', '18:00', '19:00', '20:00', '21:00', '22:00', '23:00', '24:00'];
            let series = [];
            
            legend.forEach((e, index) => {
                let setting = {
                    name: '收入',
                    type: 'line',
                    data: [22, 26, 121, 134, 165, 112, 132],
                    symbolSize: 10,
                    symbol: 'circle',
                    itemStyle: {
                        normal: {
                            color: '#1D95F4',
                            barBorderRadius: 1,
                            borderColor: '#fff',
                            borderWidth: 2
                        }
                    },
                    lineStyle: {
                        normal: {
                            color: '#1D95F4',
                            width: 2
                        }
                    },
                    smooth: true
                }
                setting.name = e;

                if (index === 0) {
                    setting.data = todayArray.length > 0 ? todayArray : [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
                    setting.itemStyle.normal.color = '#1D95F4';
                    setting.lineStyle.normal.color = '#1D95F4'
                }
                if (index === 1) {
                    setting.data = yesArray.length > 0 ? yesArray : [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
                    setting.itemStyle.normal.color = '#1AE54B';
                    setting.lineStyle.normal.color = '#1AE54B'
                }
                series.push(setting)
            })
            let start = this.dateStrs()/24*100;
            let end = this.dateStrs()/24*100+16.6;

            initZheXian(this.id_name, legend, xData, series,start,end, [35, 45])
        },
        init_lssjl(xzqh, level, menu, menu_right) {
            console.log(xzqh, level, menu, menu_right, '下拉选项---');
            var lineType = '';
            this.xDataArray = [];
            this.totalArray = [];
            this.superFastArray = [];
            this.quickPackArray = [];
            this.generPostArray = [];
            this.internetArray = [];
            if (menu === '7日内') {
                lineType = '1'
            } else if (menu === '30日内') {
                lineType = '2'
            } else if (menu === '12周内') {
                lineType = '3'
            } else if (menu === '12月内') {
                lineType = '4'
            }
            let path = "";
            if (lineType === '1') {
                path = "dpk/pcPostCdpSevenDay";
            } else if (lineType === '2') {
                path = "dpk/pcPostCdpDay";
            } else if (lineType === '3') {
                path = "dpk/pcPostCdpWeek";
            } else if (lineType === '4') {
                path = "dpk/pcPostCdpMonth";
            }
            let params = {
                distCode: xzqh,
                orgCode: '',
                sumLevel: level === '1' || level === '2' ? '1' : Number(level) - 1,
                lineType: lineType,
                sumFg: '1',
                dataDate: dayjs(new Date()).format('YYYY-MM-DD'),
            };
            var interface1 = axios.create({
                'Access-Control-Allow-Origin': '*',
                baseURL: board_url,
                //baseURL: 'https://211.156.195.17/bsv-app/',
                timeout: 10000
            });
            const msgbody1 = JSON.stringify( params)
            interface1.get(path, {
                params: {
                    'sendID': '00000001',
                    'timestamp': timestamp,
                    'msgBody': msgbody1,
                    'dataDigest': base64.encode(hex_md5(msgbody1 + data_key + timestamp))
                }
            }).then(({ data }) => {
                console.log('msgbody1',msgbody1)
                if (data.resCode === 'R00001' && data.data.length > 0) {
                    if (lineType == '1' || lineType == '2') {
                        data.data.sort((a, b) => {
                            return new Date(a['dataDateStr']) - new Date(b['dataDateStr'])
                        })
                        console.log('七日',data.data)
                        this.xDataArray = data.data.map((i) => { return i.dataDateStr.substring(5, 11) });
                    } else if (lineType == '3' || lineType == '4') {
                        data.data.sort((a, b) => {
                            return a['dataDate'] - b['dataDate']
                        })
                        //console.log(data.data)
                        this.xDataArray = data.data.map((i) => { return i.dataDate });//.substring(4,6)+'周'
                    }
                    switch (menu_right) {
                        case '总量':
                            this.totalArray = data.data.map((i) => { return i.total });
                            console.log('1rrr');
                            break;
                        case '特快':
                            // this.totalArray = data.data.map((i) => { return i.total });

                            this.superFastArray = data.data.map((i) => { return i.superfastNum });
                            console.log('2rrr');
                            break;
                        case '快包':
                            // this.totalArray = data.data.map((i) => { return i.total });

                            this.quickPackArray = data.data.map((i) => { return i.quickpackNum });

                            console.log('2rrr');
                            break;
                        case '普邮':
                            // this.totalArray = data.data.map((i) => { return i.total });

                            this.generPostArray = data.data.map((i) => { return i.generpostNum });

                            console.log('2rrr');
                            break;
                        case '国际':
                            // this.totalArray = data.data.map((i) => { return i.total });

                            this.internetArray = data.data.map((i) => { return i.internNum });

                            console.log('2rrr');
                            break;
                        default:
                            break;
                    }
                    // this.quickPackArray = data.data.map((i) => { return i.quickpackNum });
                    // this.generPostArray = data.data.map((i) => { return i.generpostNum });
                    // this.internetArray = data.data.map((i) => { return i.internNum });
                    this.init_lssjl_charts(menu_right);
                }
            }).catch(err => {
                console.log(err);
                this.init_lssjl_charts(menu_right);
            });
        },

        init_lssjl_charts(menu_right) {
            let legend2 = [];
            legend2.push(menu_right)
            let xData2 = this.xDataArray.length > 0 ? this.xDataArray : ['09-01', '09-02', '09-03', '09-04', '09-05'];
            let series2 = [];
            legend2.forEach((e, index) => {
                let setting = {
                    name: '收入',
                    type: 'line',
                    data: [0, 0, 0, 0, 0],
                    symbolSize: 10,
                    symbol: 'circle',
                    itemStyle: {
                        normal: {
                            color: '#1D95F4',
                            barBorderRadius: 1,
                            borderColor: '#fff',
                            borderWidth: 2
                        }
                    },
                    lineStyle: {
                        normal: {
                            color: '#1D95F4',
                            width: 2
                        }
                    },
                    smooth: true
                }
                setting.name = e;

                if (menu_right === '总量') {
                    console.log(this.totalArray, '总量折线');
                    setting.data = this.totalArray.length > 0 ? this.totalArray : [0, 0, 0, 0, 0]
                    setting.itemStyle.normal.color = '#1D95F4';
                    setting.lineStyle.normal.color = '#1D95F4'
                }
                if (menu_right === '特快') {
                    console.log(this.superFastArray, '特快折线');
                    setting.data = this.superFastArray.length > 0 ? this.superFastArray : [0, 0, 0, 0, 0]
                    setting.itemStyle.normal.color = '#1AE54B';
                    setting.lineStyle.normal.color = '#1AE54B'
                }
                if (menu_right === '快包') {

                    setting.data = this.quickPackArray.length > 0 ? this.quickPackArray : [0, 0, 0, 0, 0]
                    setting.itemStyle.normal.color = '#1E1F89';
                    setting.lineStyle.normal.color = '#1E1F89'
                }
                if (menu_right === '普邮') {

                    setting.data = this.generPostArray.length > 0 ? this.generPostArray : [0, 0, 0, 0, 0]
                    setting.itemStyle.normal.color = '#CD01FF';
                    setting.lineStyle.normal.color = '#CD01FF'
                }
                if (menu_right === '国际') {

                    setting.data = this.internetArray.length > 0 ? this.internetArray : [0, 0, 0, 0, 0]
                    setting.itemStyle.normal.color = '#01A572';
                    setting.lineStyle.normal.color = '#01A572'
                }
                series2.push(setting)
            });
            // let start = 0;
            // let end = 99;
            initZheXianTwo(this.id_name, legend2, xData2, series2, [25, 10])
        }
    },
    props: {
        title: {
            type: String,
            required: true
        },
        id_name: {
            type: String,
            required: true
        }
    },
    mounted() {
    },
    template: `<div style="width: 100%; margin-top: 15px; margin-bottom: 10px">
            <div class="sj_title" style="position: relative;" >
                {{title}}
                <div style="position: absolute; left: 15px; top: 0">
                    <slot name="left-title">
                    </slot>
                </div>
                <div style="position: absolute; right: 15px; top: 0">
                    <slot name="right-title">
                    </slot>
                </div>
            </div>
            <div class="border_echaers">
            <div :id="id_name" class="content"></div>
</div>
        </div>`
});

Vue.component('zyltj-component', {
    data() {
        return {
            zyltj: {
                ffl: '0',
                fyl: '0'
            }
        }
    },
    methods: {
        init_data(data) {
            for (let key in data) {
                this.zyltj[key] = data[key]
            }
        },
        toXiaZuan(index) {
            switch (index) {
                //收寄封发量下钻
                case 1:
                    if (this.zyltj.ffl === '0') return;
                    try {
                        Emp.execute("toSjXiazhuan('zyltjffl')");
                    } catch (e) {

                    }
                    break
                //收寄发运量下钻
                case 2:
                    if (this.zyltj.fyl === '0') return;
                    try {
                        Emp.execute("toSjXiazhuan('zyltjfyl')");
                    } catch (e) {

                    }
                    break
            }
        }
    },
    filters: {
        addSpot(source) {
            if (source.length < 4) return source;
            let arr = [...source];
            let len = arr.length / 3;
            let newArr = [];
            for (let i = 0; i < len; i++) {
                let start = arr.length - 3 * (i + 1)
                let b = []
                if (start < 0) b = arr.slice(0, arr.length % 3);
                else b = arr.slice(start, arr.length - 3 * i);
                newArr.push(b.join(''));
            }
            return newArr.reverse().join(',');
        }
    },
    template: `<div style="width: 100%; margin-top: 15px; margin-bottom: 10px">
            <div class="sj_title">
                作业量统计
            </div>
            <div class="item_son"
                 style="min-height: 60px; border-radius: 0 0 10px 10px; border-left: 1px solid #e6e6e6; border-right: 1px solid #e6e6e6">
                <div class="zyltj" style="border-right: 1px solid #E6E6E6;" @click="toXiaZuan(1)">
                    <p>收寄封发量</p>
                    <p style="color: #4495D4; font-size: 22px">{{zyltj.ffl | addSpot}}</p>
                </div>
                <div class="zyltj" @click="toXiaZuan(2)">
                    <p>收寄发运量</p>
                    <p style="color: #4495D4; font-size: 22px">{{zyltj.fyl | addSpot}}</p>
                </div>
            </div>
        </div>`
});


Vue.component('tjzb-component', {
    data() {
        return {}
    },
    props: {
        level: String || Number
    },
    methods: {
        init_data(index, data) {
            switch (index) {
                case 1:
                    this.$refs.tjzb1.init_data(data)
                    break;
                case 2:
                    this.$refs.tjzb2.init_data(data)
                    break;
                case 3:
                    this.$refs.tjzb3.init_data(data)
                    break;
                case 4:
                    this.$refs.tjzb4.init_data(data)
                    break;
            }
            ;

        },
        toFyjslXz(index) {
            if (this.level == 5) return;
            switch (index) {
                case 4:
                    try {
                        Emp.execute("toSjXiazhuan('fyjsl3')");
                    } catch (e) {

                    }
                    break
                case 5:
                    try {
                        Emp.execute("toSjXiazhuan('fyjsl4')");
                    } catch (e) {

                    }
                    break
                case 6:
                    try {
                        Emp.execute("toSjXiazhuan('fyjsl5')");
                    } catch (e) {

                    }
                    break
                case 7:
                    try {
                        Emp.execute("toSjXiazhuan('fyjsl6')");
                    } catch (e) {

                    }
                    break
            }
        },
        toXiazhuan() {
            try {
                Emp.execute("toSjXiazhuan('fyjsl')");
            } catch (err) {

            }
        }
    },
    template: `
            <div>
                <div id="chart4" class="content" style="height: 300px;" @click="toXiazhuan()"></div>
                <div class="progress_com" style="margin-top: -25px">
                    <div class="progress_com" style="margin-top: -5px">
                        <div class="progress_com_item_2" @click="toFyjslXz(4)">
                            <item-prgress ref="tjzb1" />
                        </div>
                        <div class="progress_com_item_2" @click="toFyjslXz(5)">
                            <item-prgress ref="tjzb2"/>
                        </div>
                        <div class="progress_com_item_2" @click="toFyjslXz(6)">
                            <item-prgress ref="tjzb3"/>
                        </div>
                        <div class="progress_com_item_2" @click="toFyjslXz(7)">
                            <item-prgress ref="tjzb4"/>
                        </div>
                    </div>
                </div>
                <slot></slot>
            </div>
            
       `
})

Vue.component('ycjk-component', {
    data() {
        return {
            ycjk: {
                ycg: '--',
                wcg: '--',
                yxl: '--'
            }
        }
    },
    methods: {
        init_data(data) {
            for (let key in data) {
                this[key] = data[key]
            }
        }
    },
    filters: {
        addSpot(source) {
            if (source == '--') return '--';
            if (source.length < 4) return source;
            let arr = [...source];
            let len = arr.length / 3;
            let newArr = [];
            for (let i = 0; i < len; i++) {
                let start = arr.length - 3 * (i + 1)
                let b = []
                if (start < 0) b = arr.slice(0, arr.length % 3);
                else b = arr.slice(start, arr.length - 3 * i);
                newArr.push(b.join(''));
            }
            return newArr.reverse().join(',');
        }
    },
    template: `<div style="width: 100%; margin-top: 15px; ">
            <div class="sj_title">
                异常监控
            </div>
            <div style="display: flex; justify-content: space-between; padding: 15px 8px; 
                border-left: 1px solid #e6e6e6; border-right: 1px solid #e6e6e6">
                <div class="yccl">
                    <div>
                        <p style="margin-top: 10px">已超过出口能力揽投部</p>
                        <p style="font-size: 20px; line-height: 25px">{{ycjk.ycg | addSpot}}</p>
                    </div>
                </div>
                <div class="yccl" style="background-color: #4AA2EC;">
                    <div>
                        <p style="margin-top: 10px">预计超过出口能力揽投部</p>
                        <p style="font-size: 20px; line-height: 25px">{{ycjk.wcg | addSpot}}</p>
                    </div>
                </div>
                <div class="yccl" style="background-color: #33D2B4;">
                        <p style="margin-top: 10px; height: 38px">揽投部逾限量<br></p>
                        <p style="font-size: 20px; line-height: 25px">{{ycjk.yxl | addSpot}}</p>
                </div>
            </div>
            <slot></slot>
        </div>`
})


Vue.component('sorttable-component', {
    props: {
        list: {
            type: Array,
        },
        sortdata: ''
    },
    data() {
        return {
            /*list: [
                {
                    id: 'sjltj',
                    title: '收寄量统计',
                    isdelete: false,
                    isshow: true,
                    isarrival: false,
                }, {
                    id: 'jrsjl',
                    title: '今日收寄量',
                    isdelete: false,
                    isshow: true,
                    isarrival: false,
                }, {
                    id: 'lssjl',
                    title: '历史收寄量',
                    isshow: true,
                    isdelete: false,
                    isarrival: false,
                }, {
                    id: 'zyltj',
                    title: '作业量统计',
                    isshow: true,
                    isdelete: false,
                    isarrival: false,
                }, {
                    id: 'tjzb',
                    title: '统计指标',
                    isshow: true,
                    isdelete: false,
                    isarrival: false,
                    list: [
                        {
                            id: 'hjpjsj',
                            title: '环节平均时长',
                            isdelete: false,
                            isarrival: false,
                        },
                        {
                            id: 'lsjsl',
                            title: '揽收及时率',
                            isdelete: false,
                            isarrival: false,
                        }
                    ]
                }, {
                    id: 'ycjk',
                    title: '异常监控',
                    isshow: true,
                    isdelete: false,
                    isarrival: false,
                    list: [
                        {
                            id: 'yswfl',
                            title: '揽收部有收无发量',
                            isdelete: false,
                            isarrival: false,
                        },
                        {
                            id: 'sjltz',
                            title: '收寄量突增',
                            isdelete: false,
                            isarrival: false,
                        }
                    ]
                }
            ]*/
        }
    },
    methods: {
        init_data(data) {
            for (let key in data) {
                this[key] = data[key]
            }
        },
        deletebtn: function (x, i) {
            if (i === undefined) {
                x.isdelete = !x.isdelete;
                if (x.list !== undefined) {

                    x.list.forEach(el => {
                        el.isdelete = x.isdelete;
                    })
                }
            } else {
                x.list[i].isdelete = !x.list[i].isdelete;
                //const list = x.list.filter(item => item.isdelete === false);
            }
        },
        showbtn(x) {
            x.isshow = !x.isshow;
        }
    },
    mounted: function () {
        const _this = this
        sortobj = new Sortable(sortbox, {
            group: 'sortabledemo',
            animation: 150,
            ghostClass: 'blue-background-class-box',
            dataIdAttr: 'data-id',
            handle: '.noedit',
            filter: '.bg-red',
            direction: 'vertical',
            store: {
                get: function (e) {
                    var order = _this.sortdata;
                    return order ? order.split('|') : [];
                },
                set: function (e) {
                    var order = e.toArray();
                    vm.list.forEach((el, i) => {
                        el.index = order.indexOf(el.id)
                    })
                    _this.sortdata = e.options.group.name, order.join('|');

                }
            },
            onUpdate: function (e) {


            }
        });
        this.list.forEach((ele, i) => {
            new Sortable(this.$refs.smallbox[i], {
                group: ele.id,
                animation: 150,
                ghostClass: 'blue-background-class',
                dataIdAttr: 'data-id',
                filter: '.bg-red',
                direction: 'vertical',
                scroll: false,
                store: {
                    get: function (e) {
                        var order = _this.sortdata;
                        return order ? order.split('|') : [];
                    },
                    set: function (e) {
                        var order = e.toArray();
                        vm.list.forEach((el, i) => {
                            if (el.id == sorttemp) {
                                var tempindex = i;
                                vm.list[i].list.forEach((item, num) => {
                                    item.index = order.indexOf(item.id)
                                })
                            }
                        })
                        _this.sortdata = e.options.group.name, order.join('|');
                    }
                },
                onStart: function (e) {
                    sorttemp = e.item.dataset.id.split("_")[0];
                }
            })
        });
    },
    template: `<div id="sortbox" class="sortbox">
        <div v-for="(item,index) in list"
             :data-id="item.id" class="board-block">
            <div class="noedit">
                {{item.title}}
                <span class="edit-button" :class='!item.isdelete ? "openeye" : "closeeye" '
                      @click="deletebtn(item)"></span>
            </div>
            <div class="dragbox" ref="smallbox" v-show="item.isshow">
                <div v-for="(value,i) in item.list"
                     class="board-block-son" :data-id="value.id">
            <span class="edit-button bg-red" :class='!value.isdelete && !item.isdelete ? "openeye" : "closeeye" '
                  @click="deletebtn(item,i)"></span>
                    {{value.title}}
                </div>
            </div>
            <div class="isshowbox" v-if="item.list" @click="showbtn(item)">
                <img :src="item.isshow? '../css/up.png' : '../css/down.png' " alt="">
            </div>
        </div>
    </div>`
});
