

function init_echarts(id,data,msg = {
    ssl: '2232.51',
    ssldw: '万件',
    title: '实时订单量',
    color: ['#FADB89', '#62CEFF', '#FC595A', '#85ECA5']
}) {
    console.log(data);
    const lefts = {
        1: 13,
        2: 27,
        3: 37,
        4: 47,
        5: 60,
        6: 70,
        7: 80
    };

    let mychart = echarts.init(document.getElementById(id));
    let option = {
        tooltip: {
            trigger: 'item',
            show: true,
            formatter: (data) => {
                const total = Number(data.data.value);
                const val = (total / 10000).toFixed(2)
                return total > 10000 ? `${data.data.name}: ${val}万件` : `${data.data.name}: ${total}件`
            }
        },

        graphic: [
            {
                type: 'group',
                left: 'center',
                top: '120',
                children: [
                    {
                        type: 'text',
                        z: 100,
                        style: {
                            fill: '#000',
                            text: msg.ssl,
                            fontSize: 20,
                            fontWeight: 'bold'
                        }
                    },
                    {
                        type: 'text',
                        z: 100,
                        top: 8,
                        left: lefts[msg.ssl.length],
                        style: {
                            fill: '#000',
                            text: msg.ssldw,
                            font: '10px Microsoft YaHei'
                        }
                    }
                ],
            },
            {
                type: 'group',
                left: 'center',
                top: '70',
                children: [
                    {
                        type: 'rect',
                        z: 100,
                        left: 'center',
                        top: 'middle',
                        shape: {
                            width: 70,
                            height: 30
                        },
                        style: {
                            fill: '#01C482',

                        }
                    },
                    {
                        type: 'text',
                        z: 100,
                        left: 'center',
                        top: 'middle',
                        style: {
                            fill: '#FFF',
                            text: msg.title,
                            fontSize: 12
                        }
                    }
                ]
            }
        ],
        series: [
            {
                name: '访问来源',
                type: 'pie',
                hoverAnimation:false,
                radius: ['70%', '90%'],
                center: ['50%', '50%'],
                itemStyle: {
                    normal: {
                        borderColor: '#eee',
                        borderWidth: 2
                    }
                },
                label: {
                    show: false,
                    position: 'outside',

                },
                labelLine: {
                    show: false
                },
                color: msg.color,
                data: data
            }
        ]
    };
    mychart.setOption(option);
}

function filterNum(val) {
    const value = Number(val)
    if (value > 10000) return (value / 10000).toFixed(2) + '万件'
    else return value + '件'
}

function filterNum2(val) {
    const value = Number(val)
    if (value > 10000) return (value / 10000).toFixed(2)
    else return value
}
