// tostr方法验证对象类型

const tostr = Function.prototype.call.bind(Object.prototype.toString)
// isblank()传入判断对象为空返回true否则为false
const isblank = (a) => {
  const objstr = tostr(a);
  switch (objstr) {
    case "[object String]":
      if (a === '' || a === 'null' || a === 'undefined') {
        return true
      } else {
        return false
      }
    case ("[object Number]"):
      return false
    // Object类型判断
    case ("[object Object]"):
      if (Object.keys(a).length) {
        return false
      } else {
        return true
      }
    case "[object Null]":
      return true
    case "[object Undefined]":
      return true
    case "[object Date]":
      return false
    case "[object Array]":
      if (a.length) {
        return false
      } else {
        return true
      }
    default:
      break;
  }

}
// 加减法  传入加法的值即可  减法传入减数为负值即可
const accAdd = (arg1, arg2) => {
  var r1, r2, m;
  try { r1 = arg1.toString().split(".")[1].length } catch (e) { r1 = 0 }
  try { r2 = arg2.toString().split(".")[1].length } catch (e) { r2 = 0 }
  m = Math.pow(10, Math.max(r1, r2))
  return (arg1 * m + arg2 * m) / m
}
// 乘法
const accMul = (arg1, arg2) => {
	var m =0,s1=0,s2 = 0
	isblank(arg1) ? arg1 = 0:arg1

  m = 0, s1 = arg1.toString(), s2 = arg2.toString();
  try { m += s1.split(".")[1].length } catch (e) { }
  try { m += s2.split(".")[1].length } catch (e) { }
  return Number(s1.replace(".", "")) * Number(s2.replace(".", "")) / Math.pow(10, m)

}
// 除法  参数一是被除数  参数二是除数
const accDiv = (arg1, arg2) => {
  var t1 = 0, t2 = 0, r1, r2;
  try { t1 = arg1.toString().split(".")[1].length } catch (e) { }
  try { t2 = arg2.toString().split(".")[1].length } catch (e) { }
  with (Math) {
    r1 = Number(arg1.toString().replace(".", ""))
    r2 = Number(arg2.toString().replace(".", ""))
    return (r1 / r2) * pow(10, t2 - t1);
  }

}

//格式化不规则JSON   参数为不管规则JSON
const parseObject = (resp) => {
  const reg = new RegExp('"\\{', "g");
  const reg2 = new RegExp('}"', 'g');
  return JSON.parse(resp.replace(reg, '{').replace(reg2, '}'))
};
// 千分位添加符号
function newAddSpot(a) {
	if (a === '' || a === 'null' || a === 'undefined' || a === "_" || a === "-") return "-"
  	return Number(a).toLocaleString()
}


// 以下为新增函数 20210715

// 打印函数
function printQS(...arg){
	console.log('============================');
	
	for(let i in arg){
		console.log(`第${i * 1 + 1}个：`);
		if(arg[i] == ''){
			console.log('空字符串');
		} else {
			console.log(arg[i]);
		}
		// 参数分割线
		if(i != arg.length - 1){
			console.log('--------');
		}
	}
	console.log('============================');
}

// 格式化字符串到日期格式
// 例如： 20210721 => 2021.07.21
function formateStrToDate(value, mark = '.') {
	value = value + ''; // 转换字符串
	if (value.length == 8) {
		const y = value.slice(0,4);
		const m = value.slice(4,6);
		const d = value.slice(6,8);
		return y + mark + m + mark + d;
	} else if (value.length == 6) {
		const y = value.slice(0,4);
		const m = value.slice(4,6);
		return y + mark + m;
	} else {
		return ''
	}
}

// 格式化日期格式到字符串
// 例如： 2021.07.21 => 20210721 
function formateDateToStr(value, oldMark = '.', newMark = '') {
	value += ' ' 
	return value.split(oldMark).join(newMark)
}

// 获取起止时间
// 入参 time 形如： 2021.07.23
// 返回 形如 {'s': '20210723' ,'e':'20210723'}
function makeStartOrEndDate(time, type="D") {
	let s = '';
	let e = '';
	if(time){
		let chooseDate = time.split(".").join("/");
		let date = new Date(chooseDate)
		let year = date.getFullYear();
		let month = date.getMonth();
		let day = date.getDate();
		
		month = month + 1
		
		if (month < 10) {
			month = '0' + month
		}
		
		if(type == "D") {
			s = "" + year + month + "01";
			e = "" + year + month + day;
		} else if(type == 'M') {
			s = '' + year + '01'
			e = '' + year + month
		} else if(type == 'W') {

		} else {
			
		}
	}
	
	return {s, e}
}


// 获取往月的起止时间
function makeLastMonth(time, type="D"){
	
		let s = '';
		let e = '';
		if(time){
			let chooseDate = time.split(".").join("/");
			let date = new Date(chooseDate)
			let year = date.getFullYear();
			let month = date.getMonth();
			if (month == 0) {
				year = year - 1;
				month = 12;
			}
			if (month < 10) {
				month = '0' + month
			}
			
			if(type == "D") {
				s = '' + year + month
				e = '' + year + month
			} else if(type == 'M') {
				s = '' + year + '01'
				e = '' + year + month
			} else if(type == 'W') {

			} else {
				
			}
		}
		
		return {s, e}
	
}

Number.prototype.toFixed = function (d){
		var num =  Math.round((this + Number.EPSILON) * Math.pow(10,d)) / Math.pow(10,d);
		num = num.toString()
		var arr  = num.split('.')
		if(arr[1]){
			if(arr[1].length <d){
				var len = arr[1].length
				arr[1]+='0'.repeat(d-len)
				return arr[0]+'.'+arr[1]
			}else{
				return arr[0]+'.'+arr[1]
			}
		}else if(d==0){
			return arr[0]
		
		}else{
			return arr[0]+'.'+'0'.repeat(d)
		}
};
