//带下拉的盒子
Vue.component('drillBoxReal', {
    data() {
        return {}
    },
    props: {
        isShowLeft: {
            Boolean,
            default: false
        },
        isShowRight: {
            Boolean,
            default: false
        },
        title: String,
        drillLeft: {
            Array,
            default: () => {
                return []
            }
        },
        drillRight: {
            Array,
            default: () => {
                return []
            }
        },
        defalutLeftLabel: {
            String,
            default: '默认值'
        },
        defalutRightLabel: {
            String,
            default: '默认值'
        },
        backColor: {
            String,
            default: '#D1EAFE'
        },
        boder: {
            Boolean,
            default: false
        },
        isOneTitle: {
            Boolean,
            default: false
        },
        titleSty: {
            Object,
            default: () => {
                return {

                    minHeight: '40px',
                    lineHeight: '20px'
                }
            }
        },
        tipContent: {
            String,
            default: ''
        }
    },
    methods: {
        clickLeftMunu(val) {
            this.$emit('getleftval', val)
        },
        clickRightMunu(val) {
            this.$emit('getrightval', val)
        }
    },
    template: `<div>
                    <div 
                            :class="['drill-box',isOneTitle === false ? 'is-two-title' : 'is-one-title']" 
                            :style="{'background-color': backColor}"
                            style="display: flex; justify-content: center"
                    >
                        <div :style="titleSty" style="display: flex; align-items: center; justify-content: center">
                             <span :style="{'font-weight': 'bold', fontSize: '16px'}">{{title}}&nbsp;</span>
                             <el-tooltip class="item" effect="light" :content="tipContent" placement="bottom">
                                <i class="el-icon-info" style="color: #f0c78a"></i>
                             </el-tooltip>
                        </div>
                        <div style="position: absolute; left: 10px; top: 0" v-if="isShowLeft">
                            <el-dropdown @command="clickLeftMunu" :trigger="'click'" ref="lll">
                                <span class="el-dropdown-link">
                                    {{defalutLeftLabel}}<i class="el-icon-caret-bottom" style="margin-top: -13px"></i>
                                </span>
                                <el-dropdown-menu slot="dropdown">
                                    <el-dropdown-item v-for="i in drillLeft" :command="i.value">
                                        {{i.name}}
                                    </el-dropdown-item>
                                </el-dropdown-menu>
                            </el-dropdown>
                        </div>
                        <div style="position: absolute; right: 5px; top: 0" v-if="isShowRight">
                            <slot name="right"></slot>
                        </div>
                    </div>
                    <div :class="{ 'base-box': boder }">
                        <slot></slot>    
                    </div>
               </div>`
});


//折线图
Vue.component('lineBoxReal', {
    data() {
        return {
            total: 0
        }
    },
    methods: {
        initBar(data = {
            xData: ['80%', '90%', '100%', '110%', '120%', '130%', '140%'],
            legend: ['已达标', '未达标'],
            values: [[220, 182, 191, null, null, null, null], [null, null, 191, 234, 290, 330, 310]],
            unit: '万件',
            colors: ['rgba(57,115,253,1)', 'rgba(244,134,131,1)'],
            exist: true
        }) {
            const _this = this;
            let mychart = echarts.init(document.getElementById(_this.idName));
            var option = {
                tooltip: {
                    trigger: 'axis',
                    formatter: (val) => {
                        const seri = val[0];
                        const seri2 = val[1];
                        const rate = seri.axisValue.split('%')[0]
                        if (!data.exist && seri.axisValue === '100%') return  null;
                        if (Number(rate) > 100) return `${seri2.seriesName}<br>${seri2.marker}${seri2.axisValue}：${seri2.data}${data.unit}`
                        else return `${seri.seriesName}<br>${seri.marker}${seri.axisValue}：${seri.data}${data.unit}`
                    }
                },
                dataZoom: [{
                    type: "slider", // 类型
                    xAxisIndex: 0, // 对应的轴
                    bottom: "0", // 位置，定位
                    start: 0, // 开始
                    end: 100, // 结束
                    // handleIcon: "M0,0 v9.7h5 v-9.7h-5 Z",
                    handleStyle: { // 手柄的样式
                        color: "#40bcf9",
                        borderColor: "#1fb2fb"
                    },
                    backgroundColor: "#e2f3ff", // 背景
                    dataBackground: { // 数据背景
                        lineStyle: {
                            color: "#000000"
                        },
                        areaStyle: {
                            color: "#d4d9dd"
                        }
                    },
                    fillerColor: "rgba(31,178,251,0.2)", // 被start和end遮住的背景*/
                }],
                legend: {
                    top: '5%',
                    right: '5%',
                    textStyle: {
                        color: '#90979c',
                    },
                    selectedMode: false,
                    data: data.legend
                },
                grid: {
                    left: '3%',
                    right: '4%',
                    bottom: '13%',
                    containLabel: true
                },
                xAxis: {
                    type: 'category',
                    data: data.xData,
                    boundaryGap: false,
                    axisLine: {
                        show: true,
                        lineStyle: {
                            color: ['#90979c']
                        }
                    }
                },
                yAxis: {
                    name: data.unit,
                    nameTextStyle: {
                        color: '#90979c'
                    },
                    type: 'value',
                    axisLine: {
                        show: false
                    },
                    axisTick: {
                        show: false
                    },
                    splitLine: {
                        show: true,
                        lineStyle: {
                            type: 'dashed',
                            color: ['#000'],
                            opacity: 0.06,
                        }
                    },
                    axisLabel: {
                        interval: 0,
                        color: '#90979c',
                        formatter: (val) => {
                            if (val >= 10000) return (val / 10000).toFixed(2) + '万'
                            else return val
                        }
                    },
                },
                series: [
                    {
                        name: data.legend[0],
                        type: 'line',
                        itemStyle: {
                            color: data.colors[0],
                        },
                        markLine: {
                            symbol: 'none',
                            label: {show: false},
                            lineStyle: {
                                type: 'dashed',
                                color: '#FEACA8',
                                width: 1.5
                            },
                            data: [
                                {xAxis: '100%'},
                            ]
                        },
                        data: data.values[0],
                        areaStyle: { //区域填充样式
                            normal: {
                                color: new echarts.graphic.LinearGradient(0, 0, 0, 1, [{
                                    offset: 0,
                                    color: data.colors[0]
                                },
                                    {
                                        offset: 1,
                                        color: 'rgba(228, 244, 255,0)'
                                    }
                                ], false),
                                shadowBlur: 0
                            }
                        },
                    },
                    {
                        name: data.legend[1],
                        type: 'line',
                        itemStyle: {
                            color: data.colors[1]
                        },
                        data: data.values[1],
                        areaStyle: { //区域填充样式
                            normal: {
                                color: new echarts.graphic.LinearGradient(0, 0, 0, 1, [{
                                    offset: 0,
                                    color: data.colors[1]
                                },
                                    {
                                        offset: 1,
                                        color: 'rgba(228, 244, 255,0)'
                                    }
                                ], false),
                                shadowBlur: 0
                            }
                        },
                    }
                ]
            };
            mychart.setOption(option, true);
        }
    },
    props: {
        idName: String,
        title: {
            String,
            default: ''
        }
    },
    template: `<div style="min-height: 100px; ">
                    <div style="display: flex; justify-content: center; padding: 0 5px">
                        <div :id="idName" style="width: 100%; height: 300px;"></div>
                    </div>
                    <p>{{title}}</p>
                </div>`
});

//柱形图
Vue.component('barBoxReal', {
    data() {
        return {
            total: 0
        }
    },
    methods: {
        initBar(data = {
            xData: ['收寄', '市趟上行', '出口地市', '地市上行', '出口处理'],
            legend: ['数量', '总量'],
            values: [[27, 23, 93, 88, 20],[73, 76, 7, 12, 80]],
            colors: ["#9198FF", "#55A8FF"],
            total: [],
            nums: [2121,2121,424,543,654]
        }) {
            const _this = this;
            let mychart = echarts.init(document.getElementById(_this.idName));
            mychart.off('click');
            var option = {
                tooltip: {
                    trigger: "axis",
                    axisPointer: { // 坐标轴指示器，坐标轴触发有效
                        type: 'shadow' // 默认为直线，可选为：'line' | 'shadow'
                    },
                    formatter: (val) => {
                        const params = {
                            key: val[0].dataIndex,
                            name: val[0].name,
                            values: data.values,
                            total: data.total,
                            nums: data.nums
                        };
                        return _this.formatterfun(params)
                        /*if (this.formatterFont){
                            return `${val[0].name}<br>总量：${data.total[val[0].dataIndex]} <br>未达标：${data.nums[val[0].dataIndex]}(${val[0].data}%)`
                        }else{
                            return `${val[0].name}<br>${val[0].seriesName}: ${val[0].value}%<br>${val[1].seriesName}: ${val[1].value}%`
                        }*/
                    }
                },
                grid: {
                    borderWidth: 0,
                    top: 50,
                    left: '15%',
                    bottom: '25%',
                    textStyle: {
                        color: "#fff"
                    }
                },
                legend: {
                    top: '5%',
                    right: '5%',
                    textStyle: {
                        color: '#90979c',
                    },
                    selectedMode: false,
                    data: data.legend
                },
                dataZoom: [{
                    type: "slider", // 类型
                    xAxisIndex: 0, // 对应的轴
                    bottom: "0", // 位置，定位
                    startValue: 0, // 开始
                    endValue: data.xData.length < 5 ? data.xData.length - 1 : 4, // 结束
                    // handleIcon: "M0,0 v9.7h5 v-9.7h-5 Z",
                    handleStyle: { // 手柄的样式
                        color: "#40bcf9",
                        borderColor: "#1fb2fb"
                    },
                    backgroundColor: "#e2f3ff", // 背景
                    dataBackground: { // 数据背景
                        lineStyle: {
                            color: "#000000"
                        },
                        areaStyle: {
                            color: "#d4d9dd"
                        }
                    },
                    fillerColor: "rgba(31,178,251,0.2)", // 被start和end遮住的背景*/
                }],
                xAxis: [{
                    type: "category",
                    axisLine: {
                        show: false,
                        lineStyle: {
                            color: '#90979c'
                        }
                    },
                    splitLine: {
                        show: false
                    },
                    axisTick: {
                        show: false
                    },
                    splitArea: {
                        show: false
                    },
                    axisLabel: {
                        interval: 0
                    },
                    data: data.xData,
                }],
                yAxis: [{
                    name: '%',
                    max: 100,
                    type: "value",
                    axisLine: {
                        show: false
                    },
                    axisTick: {
                        show: false
                    },
                    splitLine: {
                        show: true,
                        lineStyle: {
                            type: 'dashed',
                            color: ['#000'],
                            opacity: 0.06,

                        }
                    },
                    axisLabel: {
                        interval: 0,
                        color: '#90979c'
                    },
                }],
                series: [{
                    name: data.legend[0],
                    type: "bar",
                    stack: data.legend[0],
                    barMaxWidth: 35,
                    barGap: "10%",
                    itemStyle: {
                        normal: {
                            color: data.colors[0],
                            label: {
                                show: this.showLabel,
                                textStyle: {
                                    color: "#fff"
                                },
                                position: "inside",
                                formatter: function (p) {
                                    return data.nums[p.dataIndex]
                                }
                            }
                        }
                    },
                    data: data.values[0],
                }, {
                    name: data.legend[1],
                    type: "bar",
                    stack: data.legend[0],
                    itemStyle: {
                        normal: {
                            color: data.colors[1],
                            label: {
                                show: this.showLabel,
                                position: "insideTop",
                                formatter: function (p) {
                                    return data.total[p.dataIndex];
                                }
                            }
                        }
                    },
                    data: data.values[1]
                }]
            };
            mychart.setOption(option, true);
            mychart.on('click', function(param) {
                _this.$emit('drilldown', param)
            });
        }
    },
    props: {
        idName: String,
        title: {
            String,
            default: ''
        },
        showLabel: {
            Boolean,
            default: true
        },
        formatterFont: {
            Boolean,
            default: true
        },
        formatterfun: Function
    },
    template: `<div style="min-height: 100px; ">
                    <div style="display: flex; justify-content: center; padding: 0 5px">
                        <div :id="idName" style="width: 100%; height: 300px;"></div>
                    </div>
                    <p>{{title}}</p>
                </div>`
});


//柱形图
Vue.component('barBoxDoubleReal', {
    data() {
        return {
            total: 0
        }
    },
    mounted() {
    },
    methods: {
        initBar(data = {
            xData: [],
            legend: [],
            values: [[],[]],
            colors: [],
            unit: '件',
            ratio: []
        }) {
            const _this = this;
            let markLineData = [];
            if (_this.targetNum !== '' && _this.targetNum !== undefined) {
                markLineData.push({
                    name: '标准时长',
                    xAxis: Math.round(Number(_this.targetNum)).toString(),
                    lineStyle: {
                        normal: {
                            type: 'solid',
                            color: '#0f77e9',
                        },
                    },
                })
            }
            if (_this.hyTime && _this.hyTime !== undefined) {
                markLineData.push({
                    name: '行业时长',
                    xAxis: Math.round(Number(_this.hyTime)).toString(),
                    lineStyle: {
                        normal: {
                            type: 'solid',
                            color: 'red',
                        },
                    },
                })
            }

            let mychart = echarts.init(document.getElementById(_this.idName));
            mychart.off('click');
            var option = {
                tooltip: {
                    trigger: 'axis',
                    axisPointer: { // 坐标轴指示器，坐标轴触发有效
                        type: 'shadow' // 默认为直线，可选为：'line' | 'shadow'
                    },
                    formatter: (val) => {
                        // console.log(data)
                        // console.log(val)
                        return _this.formatterfun([{
                            name : data.xData[val[0].dataIndex] ,
                            value : data.values[0][val[0].dataIndex],
                            ratio : data.ratio[val[0].dataIndex],
                        }]);
                        // console.log(val)
                        // return _this.formatterfun(val)
                    }
                },
                grid: {
                    left: '5%',
                    right: '10%',
                    bottom: '15%',
                    top: '15%',
                    containLabel: true,
                },
                legend: {//图例组件，颜色和名字
                    right: '5%',
                    top: '5%',
                    itemGap: 16,
                    itemWidth: 18,
                    itemHeight: 10,
                    selectedMode: false,
                    data: data.legend,
                    textStyle: {
                        color: '#a8aab0',
                        fontStyle: 'normal',
                        fontFamily: '微软雅黑',
                        fontSize: 12,
                    }
                },
                xAxis: [
                    {
                        name: _this.xName,
                        type: 'category',
                        data: data.xData,
                        axisLine: {
                            show: true,
                            lineStyle: {
                                color: ['#90979c']
                            }
                        }
                    }
                ],
                yAxis: {
                    name: data.unit,
                    nameTextStyle: {
                        color: '#90979c',
                    },
                    type: 'value',
                    splitNumber: 5,
                    axisLine: {
                        show: false
                    },
                    axisTick: {
                        show: false
                    },
                    splitLine: {
                        show: true,
                        lineStyle: {
                            type: 'dashed',
                            color: ['#000'],
                            opacity: 0.06,
                        }
                    },
                    axisLabel: {
                        interval: 0,
                        color: '#90979c',
                        formatter: (val) => {
                            if (val >= 10000) return (val / 10000).toFixed(2) + '万'
                            else return val
                        }
                    },
                },
                dataZoom: [{
                    type: "slider", // 类型
                    xAxisIndex: 0, // 对应的轴
                    bottom: "0", // 位置，定位
                    startValue: 0, // 开始
                    endValue: data.xData.length <= this.num ? data.xData.length - 1 : this.num, // 结束
                    // handleIcon: "M0,0 v9.7h5 v-9.7h-5 Z",
                    handleStyle: { // 手柄的样式
                        color: "#40bcf9",
                        borderColor: "#1fb2fb"
                    },
                    backgroundColor: "#e2f3ff", // 背景
                    dataBackground: { // 数据背景
                        lineStyle: {
                            color: "#000000"
                        },
                        areaStyle: {
                            color: "#d4d9dd"
                        }
                    },
                    fillerColor: "rgba(31,178,251,0.2)", // 被start和end遮住的背景*/
                }],
                series: data.legend.map((item,index) => {
                    return {
                        name: item,
                        itemStyle: {
                            normal: {
                                color: (params) => {
                                    if (this.doubleColor){
                                        const rate = Number(params.name);
                                        if (rate <= Number(_this.targetNum)) return 'green';
                                        else return 'red'
                                    }return data.colors[index]
                                }
                            }
                        },
                        type: 'bar',
                        data: data.values[index],
                        barWidth: 20,
                        markLine: !_this.showMarkLine ? null : {
                            symbol: 'circle',
                            label: {
                                normal: {
                                    fontWeight: 'bold',
                                    padding: 2,
                                    fontSize: 14,
                                    fontFamily: 'Microsoft YaHei',
                                    formatter: function(params) {
                                        return params.name == '标准时长' ? `标准时长(${_this.targetNum}) ` : `行业时长(${_this.hyTime}) `;
                                    },
                                },
                            },
                            data: markLineData,
                        },
                    }
                })
            };
            mychart.setOption(option, true);
            mychart.on('click', function(param) {
                _this.$emit('drilldown', param)
            });
        }
    },
    props: {
        idName: String,
        title: {
            String,
            default: ''
        },
        num: {
            Number,
            default: 3
        },
        doubleColor: {
            Boolean,
            default: false
        },
        formatterfun: Function,
        xName: {
            String,
            default: '%'
        },
        targetNum: {
            Number,
            default: 100
        },
        showMarkLine: {
            Boolean,
            default: false
        },
        hyTime: {
            String,
            default: ''
        }
    },
    template: `<div style="min-height: 100px; ">
                    <div style="display: flex; justify-content: center; padding: 0 5px">
                        <div :id="idName" style="width: 100%; height: 300px;"></div>
                    </div>
                    <p>{{title}}</p>
                </div>`
});


//横向柱形图
Vue.component('transverseBarBoxReal', {
    data() {
        return {
            containsHeight: '',
            isExtends: false
        }
    },
    props: {
        targeNum: Number,
        list: {
            Array,
            default: () => {
                return [
                    {
                        name: '福建',
                        value: 100
                    }
                ]
            }
        },
        title: {
            String,
            default: '指标名称'
        },
        xName: {
            String,
            default: '%'
        },
        xMax: {
            Number,
            default: null
        },
        thridColor: {
            Boolean,
            default: false
        }
    },
    computed: {
        arrList() {
            const arr = JSON.parse(JSON.stringify(this.list));
            if (this.list.length < 6) return arr;
            else return arr.splice(0,5)
        }
    },
    methods: {
        initLine(data = this.arrList) {
            const _this = this;
            _this.isExtends = false;
            _this.containsHeight = data.length === 1 ? '100px' : data.length * 40 + 'px';
            const getColor = (i) => {
                if (this.thridColor){
                    if (i < 10) return 'red';
                    else if (i > 21) return 'green';
                    else return 'blue'
                }else return 'red'
            };
            const dataList = data.map((i,index) => {
                return {
                    value: i.value,
                    itemStyle: {
                        normal: {
                            color: getColor(index),
                            shadowBlur: 0
                        }
                    }
                }
            });
            const provRank = data.map(i => i.name);
            const markLine = this.targeNum === undefined ? null : {
                symbol: "none",
                silent: true,
                lineStyle: {
                    normal: {
                        type: "solid"
                    }
                },
                label: {
                    position: "start"
                },
                data: [{
                    xAxis: this.targeNum,
                    lineStyle: {
                        width: 1.6560000000000001,
                        color: "red"
                    },
                    label: {
                        show: true,
                        position: '',
                    }
                }]
            };
            const mychart = echarts.init(this.$refs.chart2);
            mychart.off('click');
            mychart.resize({height: this.containsHeight});
            let option = {
                grid: {
                    top: '10',
                    left: '6%',
                    right: this.xName.length * 2 + 10 + '%',
                    bottom: '10',
                    containLabel: true
                },
                xAxis: {
                    name: _this.xName,
                    max: _this.xMax,
                    type: 'value',
                    position: 'top',
                    axisTick: {
                        show: true
                    },
                    axisLabel: {
                        show: true,
                        rotate: -60,
                        formatter: (val) => {
                            if (val >= 10000) return (val / 10000).toFixed(2) + '万';
                            else return val
                        },

                    },
                    splitLine: {
                        show: false
                    },
                    axisLine: {
                        show: true,
                        lineStyle: {
                            color: ['#90979c']
                        }
                    }
                },
                yAxis: {
                    type: 'category',
                    boundaryGap: true,
                    inverse: true, //反向
                    axisLine: {
                        show: true,
                        lineStyle: {
                            color: ['#90979c']
                        }
                    },
                    axisTick: {
                        show: false
                    },
                    data: provRank
                },
                series: [{
                    name: _this.title,
                    barWidth: '18px',
                    itemStyle: {
                        normal: {
                            //barBorderRadius: [0, 30, 30, 0]
                        },
                    },
                    type: 'bar',
                    label: {
                        normal: {
                            show: true,
                            formatter: (val) => {
                                return val.value
                            },
                            textStyle: {
                                color: '#FFF'
                            }
                        }
                    },
                    markLine: markLine,
                    data: dataList
                }]
            };
            mychart.setOption(option, true);
            mychart.on('click', function(param) {
                _this.$emit('drilldown', param)
            });
        },
        extendsMore() {
            if (this.isExtends) {
                this.initLine(this.arrList);
                this.isExtends = false;

            }
            else {
                this.initLine(this.list);
                this.isExtends = true
            }
            this.$refs.chart2.scrollIntoView({behavior: 'smooth'})
        }
    },
    mounted(){
        //this.initLine()
    },
    template: `<div style="height: 100%; background-color: white; width: 100%">
                    <div ref="chart2" style="background-color: #FFF; width: 100%" :style="{height: containsHeight}"></div>
                    <div @click="extendsMore"
                         style="display: flex; justify-content: center; font-size: 25px; line-height: 30px; font-weight: bold"><i
                            :class="[isExtends ? 'el-icon-arrow-up' : 'el-icon-arrow-down']"></i></div>
                </div>`
});



