function initBar(id, legend, xData, series, Yname = '%', legendSet = [5, 10]) {
    // console.log('xxx-------------', id, legend, xData, series, Yname = '%', legendSet = [5, 10])
    let mychart2 = echarts.init(document.getElementById(id));
    let option2 = {
        tooltip: {
            trigger: 'axis',
            axisPointer: {
                type: 'line'
            },
            confine: true
        },
        legend: {
            data: legend,
            top: legendSet[0],
            itemGap: legendSet[1],
            selectedMode: false,
            width: 240,
            left: '3%'
        },
        grid: {
            top: '15%',
            left: '3%',
            right: '3%',
            bottom: '10%',
            containLabel: true
        },
        xAxis: [
            {
                type: 'category',
                data: xData,
                'axisLine': {
                    lineStyle: {
                        color: '#90979c'
                    }
                },
                'splitLine': {
                    'show': false
                },
                'axisTick': {
                    'show': true
                },
                'splitArea': {
                    'show': false
                },
                'axisLabel': {
                    'interval': 0,
                    'rotate': 40
                }
            }
        ],
        yAxis: [
            {
                type: 'value',
                // name: ''业务量同比增幅(%)'',
                nameTextStyle: {
                    // align: '10%',
                    fontSize: 10
                },
                "axisLine": {
                    show: false,
                    lineStyle: {
                        color: '#000',
                    }
                },
                "splitLine": {
                    "show": true
                },
                "axisTick": {
                    "show": false
                },
                "splitArea": {
                    "show": false
                },
                axisLabel: {
                    margin: 2,
                    formatter: function (value, index) {
                        if (value >= 10000 && value < 100000000) {
                            value = value / 10000 + '万'
                        } else if (value >= 100000000) {
                            value = value / 100000000 + '亿'
                        }
                        return value
                    }
                }
            }
        ],
        'dataZoom': [{
            'show': true,
            'height': 20,
            bottom: 5,
            startValue: xData.length > 7 ? xData.length - 7 : 0,
            endValue: xData.length - 1,
            maxValueSpan: 6,
            mixValueSpan: 6,
            handleStyle: { // 手柄的样式
                color: "#40bcf9",
                borderColor: "#1fb2fb"
            },
            textStyle: {
                color: '#40bcf9'
            },
            backgroundColor: "#e2f3ff", // 背景
            dataBackground: { // 数据背景
                lineStyle: {
                    color: "#000000"
                },
                areaStyle: {
                    color: "#d4d9dd"
                }
            },
            fillerColor: "rgba(31,178,251,0.2)", // 被start和end遮住的背景*/
        }],
        series: series
    };
    console.log('options', option2)
    mychart2.setOption(option2)
}

function initScaleBar(id, xData, valueData, valueData2) {
    console.log(id, xData, valueData, valueData2)
    let mychart2 = echarts.init(document.getElementById(id));
    let option2 = {
        legend: { 
            // data: valueData2 !== undefined ? ['业务量同比增幅(%)', '业务量同比增幅差(%)'  ] : ['业务量同比增幅(%)'], 
            selectedMode: true,
            left: '3%'
        },
        tooltip: {
            trigger: 'axis',
            axisPointer: {
                type: 'line'
            },
            confine: true,
        },
        grid: {
            top: '15%',
            left: '3%',
            right: '3%',
            bottom: '10%',
            containLabel: true
        },
        xAxis: [{
            type: 'category',
            nameGap: 30,
            data: xData,
            'axisLine': {
                lineStyle: {
                    color: '#90979c'
                }
            },
            "splitLine": {
                "show": false
            },
            "axisTick": {
                "show": true
            },
            "splitArea": {
                "show": false
            },
            "axisLabel": {
                interval: 0,
                rotate: 40,
                color: '#000',
                formatter: (val) => {
                    // if (val.length > 6) return val.substring(0, 6) + '...'
                    // else 
                    return val
                }
            }
        }],
        yAxis: [{
            type: 'value',
            // name: ''业务量同比增幅(%)'',
            nameTextStyle: {
                // align: '10%',
                fontSize: 10
            },
            "axisLine": {
                show: false,
                lineStyle: {
                    color: '#000',
                }
            },
            "splitLine": {
                "show": true
            },
            "axisTick": {
                "show": false
            },
            "splitArea": {
                "show": false
            },
            axisLabel: {
                formatter: (val) => {
                    return val
                }
            }
        },],
        "dataZoom": [{
            'show': true,
            'height': 20,
            bottom: 5,
            startValue: xData.length > 7 ? xData.length - 7 : 0,
            endValue: xData.length - 1,
            maxValueSpan: 6,
            mixValueSpan: 6,
            handleStyle: { // 手柄的样式
                color: "#40bcf9",
                borderColor: "#1fb2fb"
            },
            textStyle: {
                color: '#40bcf9'
            },
            backgroundColor: "#e2f3ff", // 背景
            dataBackground: { // 数据背景
                lineStyle: {
                    color: "#000000"
                },
                areaStyle: {
                    color: "#d4d9dd"
                }
            },
            fillerColor: "rgba(31,178,251,0.2)", // 被start和end遮住的背景*/
        }],
        series: [{
            type: 'bar',
            name: ['业务量同比增幅(%)'], // id == 'lineId' ? ['业务量同比增幅(%)'] : 
            data: valueData,
            barWidth: 25,
            label: {
                show: true,
				position: 'top',
                // rotate: 45,
                fontSize: 10,
                color: "#000000"
            },
            itemStyle: {
                color: function(params) {
                    if(params.data < 0) return '#0199ff'
                    else return '#0199ff'   // 红色：#f74627 橙色：#ff7d00
                },
            },
        }, {
            type: 'line',
            name: valueData2 !== undefined ? "与业务量同比增幅差(%)" : "",
            data: valueData2,
            label: {
                show: true,
                fontSize: 10,
                color: "#f74627"
            },
            itemStyle: {
               
            },
        }]
    }
    mychart2.setOption(option2, true);
}

function initEcharts2(id, x_data, value_data ) { // 行业库柱状图
    let mychart2 = echarts.init(document.getElementById(id));
    let option2 = {
        'title': {
            text: '行业库',
            textStyle: {
                color: 'black',
                fontSize: 12,
                fontWeight: 'bold'
            }
        },
        color: ['#1fb2fb'],
        tooltip: {
            trigger: 'axis',
            axisPointer: { // 坐标轴指示器，坐标轴触发有效
                type: 'shadow' // 默认为直线，可选为：'line' | 'shadow'
            },
            formatter: '{b}<br>赶超线路占比(%): {c}',
        },
        grid: {
            top: '15%',
            left: '4%',
            right: '4%',
            bottom: '15%',
            containLabel: true
        },
        xAxis: [{
            type: 'category',
            nameGap: 30,
            data: x_data,
            "axisLine": {
                lineStyle: {
                    color: '#000'
                }
            },
            "splitLine": {
                "show": false
            },
            "axisTick": {
                "show": false
            },
            "splitArea": {
                "show": false
            },
            "axisLabel": {
                "interval": 0,
                rotate: 40
            }
        }],
        yAxis: [{
            type: 'value',
            axisLine: { show: true },
            axisTick: { show: false },
            axisLabel: {
                show: true,
                color: '#000',
                fontSize: 12,
                formatter: function (params, ticket, callback) {
                    // console.log(params)
                    if (params >= 10000) {
                        // console.log(params)
                        return params / 10000 + '万'
                    } else {
                        return params
                    }
                }
            }
        }],
        legend: {
            selectedMode: false,
            // data: ['赶超线路占比(%)' ]
        },
        "dataZoom": [{
            "show": true,
            "height": 30,
            "xAxisIndex": [0],
            bottom: 10,
            startValue: 0,
            endValue: value_data.length > 5 ? 6 : value_data.length - 1,
            // maxValueSpan: 6,
            mixValueSpan: 6,
            handleIcon: 'path://M306.1,413c0,2.2-1.8,4-4,4h-59.8c-2.2,0-4-1.8-4-4V200.8c0-2.2,1.8-4,4-4h59.8c2.2,0,4,1.8,4,4V413z',
            handleSize: '100%',
            handleStyle: { color: "#d3dee5", },
            textStyle: { color: "#0199FF" },
            borderColor: "#000"
        }, {
            type: 'slider',
            show: true,
            height: 25,
            xAxisIndex: [0],
            start: 1,
            end: this.end
        }
        ],
        series: [
            {
                // name: '赶超线路占比(%)',
                type: 'bar',
                barWidth: 25,
                barGap: 30,
                color: '#0199FF',
                data: value_data,
                label: {
                    normal: {
                        show: 'true',
                        position: 'inside',
                        // position:'top',
                        rotate: 45,
                        fontSize: 12,
                        color: "#000000"
                    }
                },
            }
        ],
    }
    mychart2.setOption(option2, true);
}

const tableColumnPro = [{ //   全部优势线路表头配置
    name: '序号',
    sort: false,
    width: '40px',
    fixed: 'left',
    key: 'no',
    align: 'center'
}, {
    name: '省份',
    width: '70px',
    sort: false,
    fixed: 'left',
    key: 'name',
    align: 'center'
}, {
    name: '连续三个月优势线路',
    key: 'advantageRoute',
    align: 'center',
    fontSize: "12px",
    children: [{
        name: '线路数',
        width: '70px',
        sort: false,
        align: 'center',
        key: 'currentLine',
        filter: (val) => {
            return val
        },
        fontColor: (row) => {
            // return row.currentLine * 1 > 0 ? '#0000FF' : ''
        }
    }, {
        name: '业务量',
        width: '90px',
        sort: false,
        align: 'center',
        key: 'currentBusinessVolume',
        filter: (val) => {
            // if (Number(val) > 10000) {
            //     return (val / 10000)
            // } else {
                return val
            // }
        }
    }, {
        name: '业务量同<br>比增幅(%)',
        width: '100px',
        align: 'center',
        sort: false,
        key: 'increBusinessVolume',
        filter: (val) => {
            return val 
        },
    }, {
        name: '业务量环<br>比增幅(%)',
        width: '100px',
        sort: false,
        align: 'center',
        sortType: 0,
        key: 'ringBusinessVolume',
        filter: (val) => {
            return val 
        },
    }, {
        name: '与总业务量同<br>比增幅差(%)',
        width: '100px',
        align: 'center',
        sort: false,
        sortType: 0,
        key: 'lackTotalVolume',
        filter: (val) => {
            return val 
        },
    }, {
        name: '与总业务量环<br>比增幅差(%)',
        width: '100px',
        align: 'center',
        sort: false,
        sortType: 0,
        key: 'lackTotalRing',
        filter: (val) => {
            return val 
        },
    }]
}, {
    name: '当月新增优势线路',
    key: 'newAdvantage',
    align: 'center',
    fontSize: "12px",
    children: [{
        name: '线路数',
        width: '70px',
        sort: false,
        align: 'center',
        key: 'newLine',
        filter: (val) => {
            return val
        },
        fontColor: (row) => {
            // return row.newLine * 1 > 0 ? '#0000FF' : ''
        }
    }, {
        name: '月业务量(件)',
        width: '90px',
        sort: false,
        key: 'newBusinessVolume',
        align: 'center',
        filter: (val) => {
            // if (Number(val) > 10000) {
            //     return (val / 10000)
            // } else 
            return val
        }
    }, {
        name: '业务量同<br>比增幅(%)',
        width: '100px',
        sort: false,
        key: 'newBusinessDiff',
        align: 'center',
        filter: (val) => {
            return val 
        },
    }]
}]

const tableColumnLine = [{ // 当月优势线路、新增优势线路下钻表格配置
    name: '序号',
    sort: false,
    width: '40px',
    fixed: 'left',
    key: 'no',
    align: 'center'
}, {
    name: '连续三个月<br>优势线路',
    sort: false,
    width: '100px',
    fixed: 'left',
    key: 'advantageLine',
    align: 'center'
}, {
    name: '月业务量<br>(件)',
    sort: false,
    width: '120px',
    key: 'advBusinVoLine',
    align: 'center'
}, {
    name: '业务量<br>同比增幅(%)',
    sort: false,
    width: '120px',
    key: 'yoIncrease',
    align: 'center',
    filter: (val) => {
        return val 
    },
}, {
    name: '业务量<br>环比增幅(%)',
    sort: false,
    width: '120px',
    key: 'ringIncrease',
    align: 'center',
    filter: (val) => {
        return val 
    },
}, {
    name: '与总业务量同<br>比增幅差(%)',
    sort: false,
    width: '120px',
    key: 'lackTotalVolume',
    align: 'center',
    filter: (val) => {
        return val 
    },
}, {
    name: '与总业务量环<br>比增幅差(%)',
    sort: false,
    width: '120px',
    key: 'lackRingVolume',
    align: 'center',
    filter: (val) => {
        return val 
    },
}]

const newTableColumnLine = [{ // 新增优势线路下钻表格配置
    name: '序号',
    sort: false,
    width: '45px',
    key: 'no',
    align: 'center'
}, {
    name: '当月新增优<br>势线路',
    sort: false,
    width: '80px',
    key: 'advantageLine',
    align: 'center'
}, {
    name: '业务量(件)',
    sort: false,
    width: '80px',
    key: 'advBusinVoLine',
    align: 'center'
}, {
    name: '业务量同<br>比增幅(%)',
    sort: false,
    width: '90px',
    key: 'yoIncrease',
    align: 'center',
    filter: (val) => {
        return val 
    },
}]
const tableColumnScale = [{ // 规模优势线路表格配置
    name: '序号',
    sort: false,
    width: '50px',
    fixed: 'left',
    key: 'no',
    align: 'center'
}, {
    name: '省份',
    sort: false,
    width: '90px',
    fixed: 'left',
    key: 'name',
    align: 'center'
}, {
    name: '规模优势<br>线路数',
    sort: false,
    width: '110px',
    key: 'scaleAdvantLine',
    align: 'center',
}, {
    name: '规模优势线路<br>日均业务量(件)',
    sort: false,
    width: '120px',
    key: 'scaleAdvantVolumn',
    align: 'center',
    filter: (val) => {
        // if (Number(val) > 10000) {
        //     return (val / 10000)
        // } else 
        return val;
    },
}, {
    name: '规模优势线路业务<br>量同比增幅(%)',
    sort: false,
    width: '120px',
    key: 'scaleAdvantageIncre',
    align: 'center',
    filter: (val) => {
        return val 
    },
}, {
    name: '规模优势线路业务<br>量环比增幅(%)',
    sort: false,
    width: '120px',
    key: 'scaleAdvantageRing',
    align: 'center',
    filter: (val) => {
        return val 
    },
}]

const tableColumnScaleLine = [{ // 规模优势线路下钻配置
    name: '序号',
    sort: false,
    width: '50px',
    fixed: 'left',
    key: 'no',
    align: 'center'
}, {
    name: '规模优势线路',
    sort: false,
    width: '90px',
    fixed: 'left',
    key: 'scaleAdnantLineRoute',
    align: 'center'
}, {
    name: '线路属性',
    sort: false,
    width: '90px',
    key: 'scaleAdvantLineType',
    align: 'center'
}, {
    name: '规模优势线路<br>日均业务量(件)',
    sort: false,
    width: '110px',
    key: 'scaleAdvantVolumn',
    align: 'center',
    filter: (val) => {
        return val
    },
}, {
    name: '规模优势线路业务<br>量同比增幅(%)',
    sort: false,
    width: '110px',
    key: 'scaleAdvantageIncre',
    align: 'center',
    filter: (val) => {
        return val 
    },
}, {
    name: '规模优势线路业务<br>量环比增幅(%)',
    sort: false,
    width: '110px',
    key: 'scaleAdvantageRing',
    align: 'center',
    filter: (val) => {
        return val 
    },
}]


