function initBar(id, legend, xData, series, Yname='%',legendSet = [5,10] ) {
    console.log('xxx',xData)
    let mychart2 = echarts.init(document.getElementById(id));
    let option2 = {
        tooltip: {
            trigger: 'axis',
            axisPointer: { 
                type: 'line'
            },
            confine: true
        },
        legend: {
            data: legend,
            top: legendSet[0],
            itemGap: legendSet[1],
            selectedMode: false,
            width: 240
        },
        grid: {
            top: '20%',
            left: '3%',
            right: '4%',
            bottom: '10%',
            containLabel: true
        },
        xAxis: [
            {
                type: 'category',
                data: xData,
                'axisLine': {
                    lineStyle: {
                        color: '#90979c'
                    }
                },
                'splitLine': {
                    'show': false
                },
                'axisTick': {
                    'show': true
                },
                'splitArea': {
                    'show': false
                },
                'axisLabel': {
                    'interval': 0,
                    'rotate': 40
                }
            }
        ],
        yAxis: [
            {
                name: Yname,
                type: 'value',
                //name: '及时数',
                axisLine: {show: false},
                'axisTick': {
                    'show': false
                },

                axisLabel: {
                    margin: 2,
                    formatter: function (value, index) {
                        if (value >= 10000 && value < 100000000) {
                            value = value / 10000 + '万'
                        } else if (value >= 100000000) {
                            value = value / 100000000 + '亿'
                        }
                        return value
                    }
                }
            }
        ],
        'dataZoom': [{
            'show': true,
            'height': 20,
            bottom: 5,
            startValue: 0,
            endValue: 6,
            maxValueSpan: 6,
            mixValueSpan: 6,
            handleStyle: { // 手柄的样式
                color: "#40bcf9",
                borderColor: "#1fb2fb"
            },
            textStyle: {
                color: '#40bcf9'
            },
            backgroundColor: "#e2f3ff", // 背景
            dataBackground: { // 数据背景
                lineStyle: {
                    color: "#000000"
                },
                areaStyle: {
                    color: "#d4d9dd"
                }
            },
            fillerColor: "rgba(31,178,251,0.2)", // 被start和end遮住的背景*/
        }],
        series: series
    };
    console.log('options',option2)
    mychart2.setOption(option2)
}

