function initBar(id, legend, xData, series, Yname = '%', legendSet = [5, 10]) {
    console.log('xxx', xData)

    let mychart2 = echarts.init(document.getElementById(id));
    let option2 = {
        tooltip: {
            trigger: 'axis',
            axisPointer: {
                type: 'line'
            },
            confine: true
        },
        legend: {
            data: legend,
            top: legendSet[0],
            itemGap: legendSet[1],
            selectedMode: false,
            width: 240
        },
        grid: {
            top: '20%',
            left: '3.5%',
            right: '4%',
            bottom: '10%',
            containLabel: true
        },
        xAxis: [
            {
                type: 'category',
                data: xData,
                'axisLine': {
                    lineStyle: {
                        color: '#90979c'
                    }
                },
                'splitLine': {
                    'show': false
                },
                'axisTick': {
                    'show': true
                },
                'splitArea': {
                    'show': false
                },
                'axisLabel': {
                    'interval': 0,
                    'rotate': 45
                }
            }
        ],
        yAxis: [
            {
                name: Yname,
                type: 'value',
                max: 100,
                interval: 20,
                //name: '及时数',
                axisLine: { show: false },
                'axisTick': {
                    'show': false
                },

                axisLabel: {
                    margin: 2,
                    formatter: function (value, index) {
                        if (value >= 10000 && value < 100000000) {
                            value = value / 10000 + '万'
                        } else if (value >= 100000000) {
                            value = value / 100000000 + '亿'
                        }
                        return value
                    }
                }
            },
            
        ],
        'dataZoom': [{
            'show': true,
            'height': 20,
            bottom: 5,
            startValue:  0,
            endValue: xData.length>6?6:xData.length-1,
            maxValueSpan: 6,
            mixValueSpan: 6,
            handleStyle: { // 手柄的样式
                color: "#40bcf9",
                borderColor: "#1fb2fb"
            },
            textStyle: {
                color: '#40bcf9'
            },
            backgroundColor: "#e2f3ff", // 背景
            dataBackground: { // 数据背景
                lineStyle: {
                    color: "#000000"
                },
                areaStyle: {
                    color: "#d4d9dd"
                }
            },
            fillerColor: "rgba(31,178,251,0.2)", // 被start和end遮住的背景*/
        }],
        series: series
    };
    if(id=='chart_lineAndBar'){
    	option2.yAxis = [],
        option2.yAxis.push(
    		{
                name: '实际值:(%)',
                nameTextStyle: {
                    padding: [0, 0, 0, 10]    // 四个数字分别为上右下左与原位置距离
                },
                type: 'value',
                min: 0,
                max: 100,
                //name: '及时数',
                interval: 20,
                axisLine: { show: false },
                'axisTick': {
                    'show': false
                },
                data: series[1].data,
            },
            {
                name: '环比:(%)',
                nameTextStyle: {
                    padding: [0, 10, 0, 0]    // 四个数字分别为上右下左与原位置距离
                },
                type: 'value',
                min: Math.floor(Math.min.apply(null, series[0].data)).toFixed(0),
                max: Math.ceil(Math.max.apply(null, series[0].data)).toFixed(0),
                //name: '及时数',
                axisLine: { show: false },
                'axisTick': {
                    'show': false
                },
                data: series[0].data,
            },
        ),
        option2.series = [
                 {
                     name: '实际值',
                     type: 'bar',
                     itemStyle:{
                         normal:{
                             color:'#1FB2FB',
                         }
                     },
                     barWidth: 27,
                     data: series[1].data
                 },
                 {
                     name: '环比',
                     type: 'line',
                     yAxisIndex: 1,
                     symbol:'circle',
                     symbolSize: 8,
                     itemStyle:{
                         normal:{
                             color:'#F70908',
                             borderColor:'#F70908',  //拐点边框颜色
                         }
                     },
                     data: series[0].data
                 }
             ]
    }
    if(id=='chart_lineAndBar' && series[0].name == '出口环比'){
    	option2.yAxis = [],
        option2.yAxis.push(
    		{
                name: '出口实际值:(%)',
                nameTextStyle: {
                    padding: [0, 0, 0, 10]    // 四个数字分别为上右下左与原位置距离
                },
                type: 'value',
                min: 0,
                max: 100,
                //name: '及时数',
                interval: 20,
                axisLine: { show: false },
                'axisTick': {
                    'show': false
                },
                data: series[1].data,
            },
            {
                name: '出口环比:(%)',
                nameTextStyle: {
                    padding: [0, 10, 0, 0]    // 四个数字分别为上右下左与原位置距离
                },
                type: 'value',
                min: Math.floor(Math.min.apply(null, series[0].data)).toFixed(0),
                max: Math.ceil(Math.max.apply(null, series[0].data)).toFixed(0),
                //name: '及时数',
                axisLine: { show: false },
                'axisTick': {
                    'show': false
                },
                data: series[0].data,
            }
        ),
        option2.series = [
                 {
                     name: '出口实际值',
                     type: 'bar',
                     itemStyle:{
                         normal:{
                             color:'#1FB2FB',
                         }
                     },
                     barWidth: 27,
                     data: series[1].data
                 },
                 {
                     name: '出口环比',
                     type: 'line',
                     yAxisIndex: 1,
                     symbol:'circle',
                     symbolSize: 8,
                     itemStyle:{
                         normal:{
                             color:'#F70908',
                             borderColor:'#F70908',  //拐点边框颜色
                         }
                     },
                     data: series[0].data
                 }
             ]
    }
    if(id=='chart_lineAndBar2' && series[0].name == '进口环比'){
    	option2.yAxis = [],
        option2.yAxis.push(
    		{
                name: '进口实际值:(%)',
                nameTextStyle: {
                    padding: [0, 0, 0, 10]    // 四个数字分别为上右下左与原位置距离
                },
                type: 'value',
                min: 0,
                max: 100,
                //name: '及时数',
                interval: 20,
                axisLine: { show: false },
                'axisTick': {
                    'show': false
                },
                data: series[1].data,
            },
            {
                name: '进口环比:(%)',
                nameTextStyle: {
                    padding: [0, 10, 0, 0]    // 四个数字分别为上右下左与原位置距离
                },
                type: 'value',
                min: Math.floor(Math.min.apply(null, series[0].data)).toFixed(0),
                max: Math.ceil(Math.max.apply(null, series[0].data)).toFixed(0),
                //name: '及时数',
                axisLine: { show: false },
                'axisTick': {
                    'show': false
                },
                data: series[0].data,
            },
        ),
        option2.series = [
                 {
                     name: '进口实际值',
                     type: 'bar',
                     itemStyle:{
                         normal:{
                             color:'#1FB2FB',
                         }
                     },
                     barWidth: 27,
                     data: series[1].data
                 },
                 {
                     name: '进口环比',
                     type: 'line',
                     yAxisIndex: 1,
                     symbol:'circle',
                     symbolSize: 8,
                     itemStyle:{
                         normal:{
                             color:'#F70908',
                             borderColor:'#F70908',  //拐点边框颜色
                         }
                     },
                     data: series[0].data
                 }
             ]
    }
    console.log('options', option2)
    mychart2.setOption(option2)
}

