var imp = {
	components: {
	},
	props: ['show','month','monthType','scopeServices','productType','type','keyareaId', 'dataDate', 'dateType'], 
	data(){
		return {
		   	noData:false,
		   	list: [],
		   	specialName: ['合计', '其他'],
		   	tablecolumn: [],
		};
	},
	watch: {
		show: function(val){
			if(this.show && (this.list.length == 0 || this.noData)){
				this.initData();
			}
		},
		month: function(val,oldVal){
			if(oldVal){
				this.initData();
			}
		},
	},
	computed: {
    	tableHeight: function(){
    		let w = document.documentElement.clientWidth || document.body.clientWidth;
    		let h = document.documentElement.clientHeight || document.body.clientHeight;
    		return h - (w*100) / 375 * 0.4;
    	},
	},
	methods: {
		initColumn(){
			let w = document.documentElement.clientWidth || document.body.clientWidth;
			w -= 4;
			w /= 10;
			this.tablecolumn = [
					             	 {
						             	label: '城市',
						             	key: 'name',
						             	width: w * 1.8,
						             },
						             {
						             	label: '62城市|时限达|成率(%)',
						             	key: 'sxdcl',
						             	width: w * 2.2,
								    	sortable: 'custom',
								    	align: 'center',
								    	isNumber: true,
						             },
						             {
						             	label: '环比|(%)',
						             	key: 'hb',
						             	width: w * 1.8,
								    	sortable: 'custom',
								    	align: 'center',
								    	isNumber: true,
								    	subByZero: true,
						             },
						             {
							            label: '全国平|均值(%)',
							            key: 'qgpjz',
							            width: w * 2.2,
									    sortable: false,
									    align: 'center',
									    isNumber: true,
							        },
							        {
								         label: '与全国|平均值|差值(%)',
								         key: 'qgpjzcz',
								         width: w * 2.2,
										 sortable: false,
										 align: 'center',
										 isNumber: true,
										 subByZero: true,
								    },
						         ];
		},
	    initData(){
 	    	if(this.type == 'imp'){
 	    		//进口
 	    		this.initImpData();
 	    	}else if(this.type == 'exp'){
 	    		//出口
 	    		this.initExpData();
 	    	}
	    },
	    initImpData(){
 	    	let params = {
 	    			dateType: this.getMT(),
 	    			countDate: this.month,
 	    			scopeServices: this.scopeServices,
 	    			keyareaId: this.keyareaId,
 			}
	    	requestImportantUpImp(params).then(({data}) => {
 	 			   	if(!data){
 	 			   		this.noData = true;
 	 					return;
 	 			   	}
 	 			   	let list = JSON.parse(data);
 	 			   	console.log(list)
 	 			   	list.forEach(e => {
 	 			   		e.name = this.convertToName(e.importCityName);
						e.nameCode = e.importCityCode == null ? 'total' : e.importCityCode;
 	 			   		e.sxdcl = this.convertToRate(e.limitOntimerate);
 	 			   		e.hb = this.convertToRate(e.roundRate);
 	 			   		e.qgpjz = this.convertToRate(e.nationAvg);
 	 			   		e.qgpjzcz = this.convertToRate(e.nationAvgDiff);
 	 			   	});
 	 			   	
 	 			   	this.list = list;
 	 			   	this.noData = false;
 	 			}).catch(err => {
 	 			  	this.noData = true;
 	 			  	console.log(err);
 	 			});
	    },
	    initExpData(){
 	    	let params = {
 	    			dateType: this.getMT(),
 	    			countDate: this.month,
 	    			scopeServices: this.scopeServices,
 	    			keyareaId: this.keyareaId,
 			}
	    	requestImportantUpExp(params).then(({data}) => {
 	 			   	if(!data){
 	 			   		this.noData = true;
 	 					return;
 	 			   	}
 	 			   	let list = JSON.parse(data);
 	 			   	console.log(list)
 	 			   	list.forEach(e => {
 	 			   		e.name = this.convertToName(e.exportCityName);
						e.nameCode = e.exportCityCode == null ? 'total' : e.exportCityCode;
 	 			   		e.sxdcl = this.convertToRate(e.limitOntimerate);
 	 			   		e.hb = this.convertToRate(e.roundRate);
 	 			   		e.qgpjz = this.convertToRate(e.nationAvg);
 	 			   		e.qgpjzcz = this.convertToRate(e.nationAvgDiff);
 	 			   	});
 	 			   	
 	 			   	this.list = list;
 	 			   	this.noData = false;
 	 			}).catch(err => {
 	 			  	this.noData = true;
 	 			  	console.log(err);
 	 			});
	    },
	    getMT(){
    		if(this.monthType === 'day') return 'D';
    		if(this.monthType === 'month') return 'M';
    		if(this.monthType === 'week') return 'W';
    		if(this.monthType === 'sevenDay') return 'W';
    		return this.monthType;
	    },
        notEmpty(arg){
        	if(arg === undefined || arg === '' || arg == null){
        		return false;
        	}else{
        		return true;
        	}
        },
        convertToName(arg){
        	return this.notEmpty(arg) ? arg : '其他';
        },
        convertToRate(arg){ 
        	return this.notEmpty(arg) ? (arg * 1).toFixed(2) : '-';
        },
        convertToW(arg){
        	return this.notEmpty(arg) ? Math.round(arg / 10000) : '-';
        },
		// 排序
		sortList(list) {
			// console.log(list)
			
			this.list = list
			this.$nextTick(()=>{
				
				// this.list.push({})
			})
		},
	},
	created() {
		
	},
	mounted() {
		this.initColumn();
		if(this.show){
			this.initData();
		}
	},
    template: `
    	<div>
			<div v-show="!noData">
				<drill-down-box
					ref="table"
					:list="list"
					:tablecolumn="tablecolumn"
					:special-name="specialName"
					:table-height="tableHeight"
					
					@sort-list="sortList"
					/>
			</div>
			
			<div class="noData" v-if="noData">
				<img src="./image/nodata.png" alt="暂无数据"/>
				<h3>暂无数据</h3>
			</div>
    	</div>
    `,
};