var impExportTab = {
	props: ['show', 'month', 'monthType', 'productType', 'scopeServices', 'keyareaId', 'sendProvCode', 'sumLevel', 'dataDate', 'dateType', 'businessType'],
	data() {
		return {
			active: 0,
			services: '',
			activeBtn: {},
			tabBtn: [
				{
					id: 1,
					name: "红图",
					type: 'red',
				}, {
					id: 2,
					name: "出口",
					type: 'exp',
				}, {
					id: 3,
					name: "进口",
					type: 'imp',
				}
			],
		};
	},
	components: {
		'red': red,
		'imp': imp,
		'tab-btn-box': tabBtnBox,
	},
	watch: {
		show: function (val) {
			if (this.show && !this.activeBtn && !this.activeBtn.type) {
				this.chooseTabBtn();
			}
		},
		scopeServices: {
			handler(val) {
				this.services = val
			},
			immediate: true
		}
	},
	methods: {
		chooseTabBtn: function (item) {
			if (!item || !item.type) {
				item = this.tabBtn[0];
			}
			this.activeBtn = item;
			this.active = item.id - 1;
		}
	},
	created() {
	},
	mounted() {
		console.log(this.scopeServices)
		if (this.scopeServices == "C") {
			this.active = 1
			this.tabBtn = [
				{
					id: 2,
					name: "出口",
					type: 'exp',
				}, {
					id: 3,
					name: "进口",
					type: 'imp',
				}
			]
		}
		if (this.show) {
			this.chooseTabBtn();
		}
	},
	template: ` 
    	<div style="background: #FFF;">
			<div style="height:0.4rem;background:#FFF;box-shadow: 0px 1px 4px 0px rgba(187, 182, 182, 0.5);">
				<tab-btn-box :tab-btn="tabBtn" @choose-tab-btn="chooseTabBtn"></tab-btn-box>
			</div>
			<div class="tab">
				<van-tabs v-model="active">
					<van-tab>
						<red
							v-if="show && active == 0"
							:show="show && active == 0"
							:month="month"
							:month-type="monthType"
							:scope-services="scopeServices"
							:product-type="productType"
							:keyarea-id="keyareaId"
							:send-prov-code="sendProvCode"
							:sum-level="sumLevel"
							:data-date="dataDate"
							:date-type="dateType"
							:business-type="businessType"
							/>
					</van-tab>
					<van-tab>
						<imp
							v-if="show && active == 1"
							:show="show && active == 1"
							:month="month"
							:month-type="monthType"
							:scope-services="scopeServices"	
							:product-type="productType"
							:keyarea-id="keyareaId"
							type="exp"
							/>
					</van-tab>
					<van-tab>
						<imp
							v-if="show && active == 2"
							:show="show && active == 2"
							:month="month"
							:month-type="monthType"
							:scope-services="scopeServices"
							:product-type="productType"
							:keyarea-id="keyareaId"
							type="imp"
							/>
					</van-tab>
				</van-tabs>
			</div>
    	</div>
    `,
};