var red = {
	components: {
	},
	props: ['show','month','monthType','productType','scopeServices','keyareaId','sendProvCode','sumLevel','dataDate','dateType','businessType'],
	data(){
		return {
		   	noData:false,
		   	tablecolumn: [],
		   	list: [],
		   	specialName: [],
		   	redBy: null,
		};
	},
	watch: {
		show: function(val){
			if(this.show && this.list.length == 0){
				this.initData();
			}
		},
		month: function(val, oldVal){
			this.initData();
		},
	},
	computed: {
    	tableHeight: function(){
    		let w = document.documentElement.clientWidth || document.body.clientWidth;
    		let h = document.documentElement.clientHeight || document.body.clientHeight;
    		return h - 50;
    	},
	},
	methods: {
		/*特快60%以上绿，40%以下红，快包55%以上绿，35%以下红*/
		initRedBy(){
    		if(this.productType == "B"){
    			this.redBy = {
    				min: 40,
    				max: 60,
    			};
    		}else if(this.productType == "K"){
    			this.redBy = {
    				min: 35,
    				max: 55,
    			};
    		}
    	},
	    initData(){
    		this.initRedBy();
 	    	let params = {
 	     	    dateType: this.getMT(),
 	     	    countDate: this.month,
 	     	    scopeServices: this.scopeServices,
 	     	    keyareaId: this.keyareaId,

				// sendProvCode: this.sendProvCode,
                // sumLevel:     this.sumLevel,
                
 			}
 	    	requestImportantUpRed(params).then(({data}) => {
 			   	if(!data){
 			   		this.noData = true;
 					return;
 			   	}
 			   	let json = JSON.parse(data);
 			   	console.log('json', json)
 			   	let imp = json.importCityData;
 			   	let exp = json.exportCityData;
 			   	let d = json.data;
 			   	let fir = d.shift();
 			   	d.push(fir);
 			   	let cols = [];
      	    	cols.push({
      	    		label: '进出口',
      	    		key: 'name',
      	    		width: 70,
      	    		fixed: false,
      	    	});
      	    	imp.push({
      	    		importCityCode:  '100000',
 			   		importCityName: '出口汇总',
 			   	});
      	    	exp.push({
 			   		exportCityCode:  '100000',
 			   		exportCityName: '进口汇总',
 			   	});
      	    	imp.forEach((e,i) => {
      	    		let c = {};
      	    		c.label = this.convertToName(e.importCityName);
          	    	c.key = e.importCityCode;
          	    	c.width = c.label.length <= 5 ? 70 : 70 + (c.label.length - 5) * 12,
          	    	c.isRate = true,
      	    		cols.push(c);
      	    	})
      	    	this.tablecolumn = cols;
      	    	let list = [];
      	    	let temp;
      	    	exp.forEach((it,i) => {
            		let row = {};
            		row.name = it.exportCityName;
					row.code = it.exportCityCode;
            		imp.forEach((e,j)=> {
           			// row[e.importCityCode] = this.convertToRate(d[i][e.importCityCode]);
            			temp = d[i][e.importCityCode];
            			if(temp){
                			row[e.importCityCode] = {
                    			color: temp.chartColor,
                    			value: this.convertToRate(temp.limitOntimerate),
                    		};
            			}else{
               			// console.log(d[i]);
               			// console.log(it)
               			// console.log(e)
            			}
            		});
            		list.push(row);
                });
      	    	this.list = list;
 			   	this.noData = false;
 			}).catch(err => {
 			  	this.noData = true;
 			  	console.log(err);
 			});
	    },
	    getMT(){
    		if(this.monthType === 'day') return 'D';
    		if(this.monthType === 'month') return 'M';
    		if(this.monthType === 'week') return 'W';
    		if(this.monthType === 'sevenDay') return 'W';
    		return this.monthType;
	    },
        notEmpty(arg){
        	if(arg === undefined || arg === '' || arg == null){
        		return false;
        	}else{
        		return true;
        	}
        },
        convertToName(arg){
        	return this.notEmpty(arg) ? arg : '其他';
        },
        convertToRate(arg){
        	return this.notEmpty(arg) ? (arg * 1).toFixed(2) : '-';
        },
        convertToW(arg){
        	return this.notEmpty(arg) ? Math.round(arg / 10000) : '-';
        },
	},
	created() {
	},
	mounted() {
		if(this.show && this.month){
			this.initData();
		}
	},
    template: `
    	<div>
			<div v-show="!noData">
				<div style="font-size:12px;color:#ff0000;padding-left:8px">备注：点击省际线路可下钻查看各环节时限达成率</div>
				<drill-down-box
					ref="table"
					class="red" 
					:list="list"
					:tablecolumn="tablecolumn"
					:table-height="tableHeight"
					:special-name="specialName"
					red-by="true"
					is-border="true"
                    :businessType="businessType"
                    :dateType="dateType"
                    :dataDate="dataDate"
                    :initSendCode="sendProvCode"
                    :sumLevel="sumLevel"
					/>
			</div>
			<div class="noData" v-if="noData">
				<img src="./image/nodata.png" alt="暂无数据"/>
				<h3>暂无数据</h3>
			</div>
    	</div>
    `,
};