var tabNavBox = {
    data() {
        return {
			// 当前被选中的导航
			// activeNavId: '1',
			// tab按钮展开状态
            tabNavIsOpen: false,
        }
    },
    props: ['tabNav', 'activeNavId', 'type', 'month', 'columnSetKnown'],
    template: `
    <div class="tabNavBox">
        <!--      切换功能        -->
        <el-row class="tabs">
            <ul class="tabNav">
                <!-- 横向tab -->
                <li v-for="item in tabNav" :key="item.id" 
                    :class="item.id == activeNavId ? 'activeNav' : ''" 
                    @click="switchTabNav(item)" 
                >
                    {{item.name}}
                </li>
            </ul>
            <!-- 右侧按钮 -->
            <div class="tabNavBtn" @click="showAllTab">
                <img :src="tabNavIsOpen ? '../../image/tab_nav_up.png' : '../../image/tab_nav_down.png'" 
                    :alt="tabNavIsOpen ? '收起' : '展开'" />
            </div>
        </el-row>
        
        <!-- 下拉tab -->
        <el-row class="tabNavBtnBox" v-show="tabNavIsOpen" ref="tabNavBtnBox" @click.native="closeAllTab($event)">
            <div>
                <p class="explain">点击可快速进入该菜单!</p>
                <el-button v-for="item in tabNav" :key="item.id" 
                    :class="item.id == activeNavId ? 'activeNavBtn' : ''"
                    @click="switchTabNav(item)"
                >
                    {{item.name}}
                </el-button>
            </div>
        </el-row>
        <!-- 内容 -->
        <div class="tabContent" v-for="item in tabNav" :key="item.id" v-show="item.id == activeNavId" >
            <component ref="tabContent" v-bind:is="item.component" v-bind:isShow="item.id == activeNavId" 
                    v-bind:type="type" v-bind:month="month" :columnSetKnown="columnSetKnown" 
            >
            </component>
        </div>
    </div>`,
    methods: {
        // tab切换
        switchTabNav(item) {
            this.activeNavId = item.id;
            this.$emit('change', item.id);

            this.tabNavIsOpen = false;
             // 等待页面重绘
            this.$nextTick(()=>{
                // 选中的tab显示在页面中间
                let tabNav = document.getElementsByClassName('tabNav')[0];
                let activeNav = document.getElementsByClassName('activeNav')[0];
                let bodyWidth = document.body.clientWidth;

                if (activeNav.offsetWidth + activeNav.offsetLeft >= bodyWidth) {
                    tabNav.scrollLeft = activeNav.offsetLeft - (bodyWidth - activeNav.offsetWidth) / 2;
                } else {
                    tabNav.scrollLeft = 0;
                }
            })
        },
        // 收起展开tab按钮
        showAllTab() {
            this.tabNavIsOpen = !this.tabNavIsOpen;
        },
        // 关闭tab按钮
        closeAllTab(event) {
            let el = event.target ||event.srcElement;
            if (el.className == "tabNavBtnBox el-row") {
                this.showAllTab()
            };
        }
    }
};
// 按钮切换
/**
 * 需引入 fiveSystemKanban/css/tabNav.css文件
 * // data
    tabBtn:[{
        id: 1,  //tab的唯一标识，作为循环key
        name: "占比" //tab的名称
    }]
 */
var tabBtnBox = {
    props: {
        tabBtn: {
            Array
        },
        activeBtnId: {
            String,
            default: '1'
        },
    },
    template: `
    <div class="tabNavBtnBox tabBtnBox">
        <el-button v-for="item in tabBtn" :key="item.id"
            :class="item.id == activeBtnId ? 'activeNavBtn' : ''"
            @click="switchTabBtn(item)"
        >
            {{item.name}}
        </el-button>
    </div>
    `,
    methods: {
        // 选择tabBtn
        switchTabBtn(item) {
            this.activeBtnId = item.id;
            this.$emit('choose-tab-btn', item);
        }
    }
}