/**
 * yy
 * 这个表包含：
 * 1：折线图 
 */
Vue.component('lineBarBox', {
    data() {
        return {
        
        }
    },
    props: {
    	list: {
            Array,
	        default: () => {
	            return [{
	            	name: 'x轴名称',
	            	value: '折线图',
	            	value2: '柱状图',
	            }];
	        }
	    },
        specialName: {
            Array,
            default: () => {
                return ['总计']
            }
        },
        legend: [],
        valueName:{
	        Array,
	        default: () => {
	            return ['增幅(%)']
	        }
	    },
        echartName:'',
        color1:{
	        String,
	        default: "#F74627"
	    },
    },
    computed: {
    	
    },
    methods: {
    	getColor(d){
    		alert()
    	},
    	initDefault() {
            document.documentElement.scrollIntoView();
            const newList = this.list.sort((i, n) => {
                return Number(i.nameCode) - Number(n.nameCode)
            });
            const arr = newList.filter(e => this.specialName.indexOf(e.name) < 0)
            const xData = [];
            const lineData = [];
            const yData = [];
            const y1Data = [];
            const y2Data = [];
            arr.map((e,i) => {
            	let a={};
            	xData.push(e.name);
            	lineData.push(e.value);
            	yData.push(e.value2);
            	a.value=e.value2;
            	a.itemStyle={color: e.color};
            	
            	if(Number(e.value) <= Number(e.value2)){
            		y1Data.push(a);
            		y2Data.push('-');
            	}else{
            		y1Data.push('-');
            		y2Data.push(a);
            	}
            });
            
            this.initEcharts(xData, lineData, yData, y1Data, y2Data);
        },
        initEcharts(xData, lineData, yData, y1Data, y2Data) {
            const _this = this;
            let mychart = echarts.init(_this.$refs.chart);
            //解决title超长覆盖图例的问题
            const w = document.documentElement.clientWidth || document.body.clientWidth;
            let s = w * 0.37 / _this.echartName.length.toFixed(0);
            s = s >= 17 ? 17 : s;
            s = s <= 8 ? 8 : s;
            let option = {
                title: {
                    text: _this.echartName,
                    textStyle: {
                        fontSize: s,
                    },
                },
                color: ['#0199FF'],
                tooltip: {
                    position: ['30%', '30%'],
                    trigger: 'axis',
                    axisPointer: { // 坐标轴指示器，坐标轴触发有效
                        type: 'shadow' // 默认为直线，可选为：'line' | 'shadow'
                    },
                    formatter:function(param){
                    	let arr = param.filter(e => {
                    		return (e.value || e.value == 0) && e.value != '-' && e.seriesName != '辅助';
                    	});
                    	if(!arr || arr.length <= 0){
                    		 return '';
                    	}
                    	let x = arr[0].name;
                    	if(x){
                    		// let n9 = Math.floor(x.length / 9);
                    		// for(let n=n9;n>0;n--){
                    		// 	x = x.slice(0, n*9) + '<br/>' + x.slice(n*9);
                    		// }
                    		// //如果是整倍数，需要移除最后一个换行符...
                    		// if(x.substr('<br/>'.length * -1) == '<br/>'){
                    		// 	x = x.slice(0,x.length - '<br/>'.length);
                    		// }
                    	}
                    	arr.forEach((e,i) => {
                    		let unit;
                    		let v = _this.valueName[0];
                    		//隐藏某个图例后，valueName数组和param的数组索引不会对应
                    		_this.valueName.forEach(it => {
                    			if(it.indexOf(e.seriesName) >= 0){
                    				v = it;
                    			}
                    		});
                        	/*let l = v.indexOf('(');
                        	let r = v.indexOf(')');
                        	if(l + r > 1){
                        		unit = v.substring(l+1,r);
                        	}*/
                        	unit=v;
                    		x += '<br/>' + '处理量'+ ' : ' + e.value +"件";
                    		if(unit){
                    			x += unit;
                    		}
                    	});
                    
                    	return x;
                    },
                },
                legend: {
                	show:false,
                	data: _this.legend,
                	orient: 'vertical',
                	left:10
                },
                grid: {
                    top: '15%',
                    left: '4%',
                    right: '4%',
                    bottom: '15%',
                    containLabel: true
                },
                xAxis: [{
                    type: 'category',
                    nameGap: 30,
                    data: xData,
                    axisLine: {
                        lineStyle: {
                            color: '##666666'
                        }
                    },
                    splitLine: {
                        show: false
                    },
                    axisTick: {
                        show: false
                    },
                    splitArea: {
                        show: false
                    },
                    axisLabel: {
                        interval: 0,
                        rotate: 40,
                        color: '#666666',
                        formatter: (val) => {
                            if (val.length > 8) return val.substring(0, 8) + '...'
                            else return val
                        }

                    }
                }],
                yAxis: [{
                    type: 'value',
                    name: "处理量：(件)",
                    nameTextStyle: {
                    	fontSize: 13,
                    	padding: [0, 0, 10, 0],
                    	color:'#666666',
                    },
                    axisLine: {
                        show: false
                    },
                    axisTick: {
                        show: false
                    },
                    axisLabel: {
                    	color: '#666666',
                        formatter: (val) => {
                            if (Number(val) >= 10000) return (Number(val) / 10000).toFixed(1) + '万'
                            else return val
                        }
                    }
                }],
                dataZoom: [{
                    show: true,
                    height: 25,
                    xAxisIndex: [
                        0
                    ],
                    bottom: 10,
                    startValue: yData.length > 4 ? yData.length - 5:0,
                    endValue: yData.length - 1,
                    maxValueSpan: 5,
                    mixValueSpan: 5,
                    handleIcon: 'path://M306.1,413c0,2.2-1.8,4-4,4h-59.8c-2.2,0-4-1.8-4-4V200.8c0-2.2,1.8-4,4-4h59.8c2.2,0,4,1.8,4,4V413z',
                    handleSize: '110%',
                    handleStyle: {
                        color: "#d3dee5",
                    },
                    textStyle: {
                        color: "#0199FF"
                    },
                    borderColor: "#90979c"
                }, {
                    type: "inside",
                    show: true,
                    height: 15,
                    start: 1,
                    end: 0
                }],
                series: [
					{
					    name: '辅助',
					    type: 'line',
					    symbolSize: 0, // symbol的大小设置为0
					    showSymbol: false, // 不显示symbol
					    yAxisIndex: 0,
					    lineStyle: {
					        width: 0, // 线宽是0
					        color: 'rgba(0, 0, 0, 0)' // 线的颜色是透明的
					    },
					    data: yData,
					},{
	                    name: _this.legend[0].name,
	                    type: 'line',
	                    barWidth: 30,
	                    barGap: 20,
	                    color: '#0197FF',
	                    data: lineData,
	                    yAxisIndex: 0,
	                    label: {
	                        normal: {
	                            show: false,
	                            position: 'top',
	                            fontSize: 10,
	                            rotate: 0,
	                        }
	                    },
	                },
                ],
            }
            
            mychart.setOption(option, true);
            mychart.on('legendselectchanged', function (params) {
				let option = this.getOption();
				let name = params.name;
                if (!params.selected[name]) {
                    // false 的时候
                    let isTure = [];
                    for(var item in params.selected){
                        if (params.selected[item]) {
                            isTure.push(item)
                        };
                    }
                    if (isTure.length > 0) {
                        option.legend[0].selected[name] = false;
                    } else {
                        option.legend[0].selected[name] = true;
                    }
                } else {
                    // true 的时候
                    option.legend[0].selected[name] = true;
				}
				if (name == '实际值' && option.legend[0].selected['实际值']) {
					option.legend[0].data[1].icon = 'image://data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAFAAAAAoAQMAAABTru9CAAAABlBMVEUAxIL3RidNALHZAAAAE0lEQVQY02NgAIH/IMAwyhw6TABNs8c5rOzZTgAAAABJRU5ErkJggg==';
				} else if (name == '实际值' && !option.legend[0].selected['实际值']) {
					option.legend[0].data[1].icon = 'image://data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAFAAAAAoAQMAAABTru9CAAAABlBMVEXMzMzv7++Y3rQzAAAAE0lEQVQY02P4DwL2IIJhlDl0mADDfHCAiQlelgAAAABJRU5ErkJggg==';
				}
                this.setOption(option);
            });
        },
    },
    mounted() {
        const h = document.documentElement.clientHeight || document.body.clientHeight;
        this.$refs.chart.style.height = h / 2 + 'px';
    },
    template: `<div style="">
					<div ref="chart" style="background-color: #FFF; width: 100%"></div>
	           </div>`
});