/**
 * 文字跑马灯提示组件
 * @author baixueru
 * @desc 非本人不允许修改及复制
 * @time  2020-12-15
 */
/**
 * imgUrl:h5页面到/src/fiveSystemKanban/image文件夹的相对路径 
 * msg: 要显示的字符串
 * isShow：true/false 是否显示
 * close方法：控制isShow
 * 例子：
 * /src/fiveSystemKanban/costingSystem/index.htm页面引用
 * <run-text img-url="../" msg="少时诵诗书所所所所" :is-show="isShow" @close="close"></run-text>
 * isShow: true
 * close(){
 *      this.isShow = false;
 * }
 */
var runText = {
    props: ['imgUrl', 'msg', 'isShow'],
    template: `
    <div>
        <div class="runTextBox" v-if="isShow">
            <img :src="imgUrl + 'image/horn.png'" alt="喇叭" />
            <marquee scrollamount=5>{{msg}}</marquee>
            <img @click="closeTextBox" :src="imgUrl + 'image/close.png'" alt="X" />
        </div>
    </div>`,
    methods: {
        closeTextBox() {
            this.$emit('close');
        }
    }
};
