/**
 * yy
 */
var mapBox = {
	data() {
	    return {
	    	myChart: null,
	    }
	},
    props: {
    	list: {
        	Array,
         	default: () => {
         		return [{name:'北京',value: 0}];
        	}
        },
     	boxHeight: {
            String,
            default: '100%',
        },
        mapName: {
            String,
        	default: 'china',
        },
        valueName: {
        	String,
    		default: '',
        },
        zoomControl: false,
    },
    methods: {
        zoomIncClick: function(){
        	if(!myChart)return;
    		let o = myChart.getOption();
    		if(o.geo[0].zoom > 3){
    			return;
    		}
    		o.geo[0].zoom += 0.4;
    		myChart.setOption(o);
    	},
    	zoomDecClick: function(){
    		if(!myChart)return;
    		let o = myChart.getOption();
    		if(o.geo[0].zoom < 1){
    			return;
    		}
    		o.geo[0].zoom -= 0.4;
    		myChart.setOption(o);
    	},
    	init: function(data){
    		let minVal = 0;
    		let maxVal = 0;
    		let temp;
    		data.forEach(e => {
    			temp = e.value ? Number(e.value) : 0;
   				minVal = minVal > temp ? temp : minVal;
   				maxVal = maxVal < temp ? temp : maxVal;
    		});
    		
			this.initEcharts(data,minVal,maxVal);
		},
		initEcharts: function(data,minVal,maxVal){
			let option = {
			        tooltip: {
			            trigger: 'item',
			            formatter: function(p){
			            	let tip = p.name + '<br/>' + p.seriesName + ': ';
			            	tip += (p.value || p.value === 0) ? p.value : '-';
	                    	return tip;
			            },
			        },
			        grid: {
						top: 5,
						bottom: 5,
						containLabel: true,
					},
					visualMap: {
						show: true,
						type: 'continuous',
						align: 'left',
						bottom: '10',
						left: '15',
						min: minVal,
						max: maxVal,
						range: [
						        minVal,
						        maxVal
						        ],
						calculable: true,
						precision: 2,
						inverse: false,
						inRange: {
							color: [
								'#98BC7D',
								'#0A4174',
							],
							symbol: 'circle',
						},
						orient: 'vertical',
						showLabel: true,
						itemWidth: 13,
						itemHeight: 88,
						itemGap: 5,
						padding: 1,
						textStyle: {
							fontSize: 12,
							color: '#666666'
						},
					},
					geo: {
						map: this.mapName,
						roam: true, //缩放和平移
						zoom: 1.15, //视角缩放比例
						top: '13%',
						left: '18%',
						label: {
							normal: {
								show: true,
								fontSize: '8',
								color: '#FFF',
								position: 'right',
							},
							emphasis: {
								show: false,
							}
						},
						itemStyle: {
							normal: {
								borderColor: '#0A4174'
							},
							emphasis: {
								areaColor: '#C7FEFD', //鼠标选择区域颜色
							}
						}
					},
			        series: [
			            {
			            	name: this.valueName,
			                type: 'map',
			                geoIndex: 0,
			                label: {
			                    show: true
			                },
			                data: data,
			            }
			        ]
			    };
			myChart = echarts.init(this.$refs.refChart);
            myChart.setOption(option, true);
		},
    },
    mounted() {
//		const h = document.documentElement.clientHeight || document.body.clientHeight;
//		this.tableHeight = h / 2 + 'px';
    },
    template: `<div style="padding: 0px 0px;position: relative;">
					<div ref="refChart" :style="{width: '100%',height: boxHeight}"></div>
					<img v-if="zoomControl" style="width:0.16rem; height:0.16rem;padding:5px;position:absolute;right:0.15rem;top:1.5rem;" src="../../image/technologyPower/icon_decrease.png" @click="zoomDecClick"/>
					<img v-if="zoomControl" style="width:0.16rem; height:0.16rem;padding:5px;position:absolute;right:0.15rem;top:1.8rem;" src="../../image/technologyPower/icon_increase.png" @click="zoomIncClick"/>
	           </div>`
};