/**
 * yy 散点图
 */
var scatterBox = {
	data() {
	    return {
	    }
	},
    props: {
    	minx: {
    		Number,
    		default: ()=> {
    			return 0;
    		}
    	},
    	maxx: {
    		Number,
			default: ()=> {
				return 0;
			}
		},
    	miny: {
    		Number,
			default: ()=> {
				return 0;
			}
		},
    	maxy: {
    		Number,
			default: ()=> {
				return 0;
			}
		},
    	list: {
        	Array,
         	default: () => {
         		return [[0,0]];
        	}
        },
     	boxHeight: {
            String,
            default: '100%',
        },
        legend: {
        	Array,
        	default: () => {
        		return [''];
        	}
        },
        reversey: {
        	Boolean,
        	default: () => {
        		return false;
        	}
        },
    },
    methods: {
    	init: function(data){
			this.initEcharts(data);
		},
		initEcharts: function(data){
			let option = {
				    grid: {
				    	top: '8%',
				        left: '5%',
				        right: '10%',
				        bottom: '8%',
				        containLabel: true
				    },
				    tooltip: {
				    	show: false,
				    },
				    splitLine: {
				    	show: false,
				    },
				    axisLabel: {
				    	show: false,
				    },
				    xAxis: [
				        {
				        	show: true,
				            type: 'value',
				            scale: true,
				            splitLine: {
				                show: false
				            },
				            axisLine: {
				            	show: true,
				            	symbol: 'none',
				            	symbolSize: [6,9],
				            },
				            axisTick: {
				            	show: false,
				            },
				            min: this.minx,
				            max: this.maxx,
				        }
				    ],
				    yAxis: [
				        {
				        	show: true,
				            type: 'value',
				            inverse: this.reversey,
				            scale: true,
				            splitLine: {
				                show: false
				            },
				            axisLine: {
				            	show: true,
				            	symbol: 'none',
				            	symbolSize: [6,9],
				            },
				            axisTick: {
				            	show: false,
				            },
				            min: this.miny,
				            max: this.maxy,
				        }
				    ],
				    series: [
				        {
				            type: 'scatter',
				            data: data,
				            color: '#00c482',
				            symbolSize: 4,
				        },
				    ]
				};
			let myChart = echarts.init(this.$refs.refChart);
            myChart.setOption(option, true);
		},
    },
    mounted() {
//		let w = document.documentElement.clientWidth || document.body.clientWidth;
//		let h = document.documentElement.clientHeight || document.body.clientHeight;
//		this.$refs.refChart.style.height = w + 'px';
    },
    template: `<div style="padding: 0px 0px;position: relative;">
					<div ref="refChart" :style="{width: '100%',height: boxHeight}"></div>
	           </div>`
};