var secondaryPage = {
	props: ['noData', 'areaCode', 'isMaxLevel','type', 'tableColumnList', 'isSetting', 'dataList','indexType'],
	data() {
		return {
			tipShow: false,
			msg: '当前日期的数据暂未更新呢！',
			beforeAreaCode: '',
			tableData: [],
            tableHeight:null,
            specialName: [],
			// 缓存数据
            cacheData: {},
            tableSortCache: {},
            isLoadMore:true,
            isNo:true,
            isLoadMoreState: [
                 {pageNo:1,pageSize:50,count:0},
                 {pageNo:1,pageSize:50,count:0}
            ],//分页情况
            level:1,
		}
	},
	template: `
		<div>
			<div v-show="!noData"  >
			    <drill-down-box
					ref="tableBox"
					:list="tableData"
					:tablecolumn="tableColumnList"
					:table-height="tableHeight"
					:special-name="specialName"
                    :is-load-more="isLoadMore"
					@load-more="loadMore"
					@sort-list="sortList"
					@sort-change="sortChange"
                    :id="indexType"
                    :is-no="isNo"
					>
				</drill-down-box>
			</div>
			<!-- 暂无数据 -->
			<div v-show="noData">
				<run-text img-url="../../" :msg="msg" :is-show="tipShow" @close="close"></run-text>
				<div class="noData">
					<img src="../../../image/nodata.png" alt="暂无数据" />
					<h3>暂无数据</h3>
				</div>
			</div>
		</div>
	`,
	watch: {
		noData(val) {
			this.tipShow = val;
		},
		dataList(val) {
			if (val) {
				this.setData();
			}
		}
	},
    mounted() {
        this.handleScroll();

    },
	methods: {
        // 表格组件排序变化
        sortChange(data) {
            console.log(data, 'tableSortCache');
            this.tableSortCache = data || {};
        },
        tableSortCac () {
            const {
                prop,
                order
            } = this.tableSortCache;
            if (prop && order) {
                this.$refs.tableBox.$refs.tableActive.sort(prop, order);
            }
        },
        sortList(list) {
            this.tableData = list;
        },
		// 监控页面滚动体
        handleScroll() {
           /* console.log("滚动监听")
            window.onscroll = () => {
                let windowHeight = document.documentElement.clientHeight || document.body.clientHeight;
                let dom2 = document.getElementById('tabArea');
                let scrollTop2 = dom2.getBoundingClientRect().top;
                if(scrollTop2<1){
                    alert()
                }
               
            } */
            let windowHeight = document.documentElement.clientHeight || document.body.clientHeight;
            this.tableHeight = windowHeight-40;
        },
		// 清除列表
		clear() {
        	let windowHeight = document.documentElement.clientHeight || document.body.clientHeight;
        	let top =windowHeight-200;
            window.scrollTo({
                top: top,
                behavior:'smooth'
            })
            this.tableData=[];
		},
        // 关闭提示
        close() {
            this.tipShow = false;
        },
        //下拉分页
        loadMore(){
            console.log("加载更多..."+this.indexType);
            if(this.indexType==0){
            	// alert(this.isLoadMoreState[0].count>this.isLoadMoreState[0].pageNo)
            	if(this.isLoadMoreState[0].count>this.isLoadMoreState[0].pageNo){
            		// alert(this.$parent.rowItem)
            		// this.$refs.tableBox.clearSort();
            		this.$refs.tableBox.$refs.tableActive.clearSort()
            		this.isLoadMoreState[0].pageNo++;
            		// alert(this.$parent.rowItem)
            	/*	this.$emit('getBusinessCustomerList',this.pageNo) */
            		this.$emit('loadmore',this.isLoadMoreState[0].pageNo,1)
            	}else{
            		// alert("无最新数据");
                    console.log('无最新数据');
            	}
            }else{
            	if(this.isLoadMoreState[1].count>this.isLoadMoreState[1].pageNo){
            		this.$refs.tableBox.$refs.tableActive.clearSort()
            		this.isLoadMoreState[1].pageNo++;
            		this.$emit('loadmore',this.isLoadMoreState[1].pageNo,2)
            	}else{
            		//alert("无最新数据");
            	}
            }

        },
        setData(a){
        	console.log(a)
            if(this.indexType == 0){
                this.isLoadMoreState[0].count = Math.ceil(a.total/a.pageSize);
                this.isLoadMoreState[0].pageNo=a.pageNum;
                a.rows.forEach((e,index) => {
                    e.areaName = e.cityName;
                    e.income=Number(e.income);
                    e.incomeRate=Number(e.incomeRate).toFixed(2);
                    e.incomeYear=Number(e.incomeYear).toFixed(2);
                    e.incomeRateYear=Number(e.incomeRateYear).toFixed(2);
                    e.incomeRateMonth=Number(e.incomeRateMonth).toFixed(2);
                    e.incomeMonth=Number(e.incomeMonth).toFixed(2);
                    // 排序完毕恢复原样
                    e.nameCode = Number(('' + a.pageNum + index));
                    //alert(this.type)
                    if(this.type==0 && e.incomeRate>0){
                        e.maintainState=-1;
                        e.maintainStateType="-"
                    }else{
                        if(e.maintainState==1){
                            e.maintainStateType="已跟进"
                        }else{
                            e.maintainStateType="未跟进"
                        }
                    }
                })
                this.$nextTick(() => {
                    if(this.isLoadMoreState[0].pageNo == 1){
                        this.tableData = a.rows;
                        //首次加载主动重绘解决表格错位
                    //    this.$refs.tableBox.$refs.table.doLayout();
                    }else{
                        this.tableData.push(...a.rows);
                        this.tableSortCac();
                    }
                });
                //console.log(this.tableData);
            }else if(this.indexType == 1){
                this.isLoadMoreState[1].count = Math.ceil(a.total/a.pageSize);
                this.isLoadMoreState[1].pageNo=a.pageNum;
                 a.rows.forEach((e,index) => {
                    e.incomeRate=Number(e.incomeRate);
                    e.incomeYear=Number(e.incomeYear).toFixed(2);
                    e.incomeRateYear=Number(e.incomeRateYear).toFixed(2);
                    e.incomeMonth=Number(e.incomeMonth).toFixed(2);
                    e.incomeRateMonth=Number(e.incomeRateMonth).toFixed(2);
                    if(a.areaLevel==1){
                        e.nameCode=Number(e.province);
                        e.aName = e.provinceName;
                     }else if(a.areaLevel==2){
                        e.nameCode=Number(e.city);
                        e.aName = e.cityName;
                     }else if(a.areaLevel==3){
                        e.nameCode=Number(e.county);
                        e.aName = e.countyName;
                     }else{
                        e.nameCode=Number(e.organizeCode);
                        e.aName = e.orgName;
                     }
                     // 排序完毕恢复原样
                     e.nameCode = index;
                     if(this.type==0 && e.incomeRate>0){
                        e.maintainState=-1;
                        e.maintainStateType="-"
                     }else{
                        if(e.maintainState==1){
                            e.maintainStateType="已跟进"
                        }else{
                            e.maintainStateType="未跟进"
                        }
                     }
                })
                this.$nextTick(() => {
                    if(this.isLoadMoreState[1].pageNo == 1||this.isLoadMoreState[1].pageNo == -1){
                        this.tableData = a.rows;
                    }else{
                        this.tableData.push(...a.rows);
                    }
                    // console.log(this.tableData, '111');
                });
            }

        }
	},
};
