// 期外欠费tab
var unscheduledOwe = {
    components: {
        'tab-btn-box': tabBtnBox
    },
    props: ['isShow', 'type', 'month'],
    data() {
        return {
            // 当前页面地区
            areaCode: '',
            // 上一级页面地区
            beforeAreaCode: '',
            // 页面层级 1-全国 2-省/市 3-市/区
            level: 1,
            maxLevel: 3,
            // 无数据
            noData:false,
			// tabBtn
			tabBtn:[
				{
					id: 1,
                    name: "占比",
                    barYName: "占比(%）",
                    barY: ["账期外占比", "账期内占比"],
                    barKey: ["outRatio", "inRatio"]
				},
				{
					id: 2,
					name: "欠费额",
                    barYName: "欠费额(万元）",
                    barY: ["账期外欠费额", "账期内欠费额"],
                    barKey: ["outArrearsBalance", "inArrearsBalance"]
				}
            ],
            // 当前选中的tabBtn
            activeBtn: {},
            // -------柱状图数据
            barKey: ["outRatio", "inRatio", "outArrearsBalance", "inArrearsBalance"],
            xValue:[],
            barObj: {},
            // -------表格相关
            tableHeight: null,
            // 第一列名称
            title: '省份',
            // 表头
            tableColumn: [
                {
                    label: '欠费余额(万元)',
                    key: 'outArrearsBalance',
                    sortable: 'custom',
                    isDrillDown: false,
                    isNumber: true,
                    align: 'right'
                },
                {
                    label: '占比总欠费(%)',
                    key: 'outRatio',
                    sortable: 'custom',
                    isDrillDown: false,
                    isNumber: true,
                    align: 'right'
                }
            ],
            // 表格数据
            tableData:[],
            // 缓存数据
            cacheData: {}
        }
    },
    template: `
    <div>
        <div v-if="!noData">
            <tab-btn-box :tab-btn="tabBtn" @choose-tab-btn="chooseTabBtn"></tab-btn-box>
            <div class="chart" ref="bar"></div>
            <drill-down-box 
                id="oweTable1"
                ref="echarts"
                :tableHeight="tableHeight"
                :is-no="false"
                :list="tableData"
                :title="title" 
                :is-drill-down="isDrillDown"
                :divideCode="areaCode" 
                :tablecolumn="tableColumn"
                @sortList="sortTableData"
                @drilldown="drillDown" />
        </div>

        <div class="noData" v-if="noData">
            <img src="../../image/nodata.png" alt="暂无数据" />
            <h3>暂无数据</h3>
        </div>
    </div>
    `,
    watch: {
    	// 监控是否显示
        isShow: function (val, oldVal) {
            if (val && this.month && this.tableData.length == 0) {
                this.title = getNameFromPermission(this.level, false);
                this.getData();
                this.handleScroll();
            }
        },
        month: function(val, oldVal) {
        	if (val && this.isShow) {
                this.getData();
                this.handleScroll();
            }
        },
        level: function(val) {
            this.title = getNameFromPermission(val, false);
        }
    },
    computed: {
        isDrillDown: function(){
            return Number(this.level) < Number(this.maxLevel);
        }
    },
    mounted() {
        this.activeBtn = this.tabBtn[0];
    },
    methods: {
        handleScroll() {
            let dom = document.getElementsByClassName('tabContent')[1];
            let tabsHeight = document.getElementsByClassName('tabs')[0].clientHeight;
            let topHeight = document.getElementById('oweTable1').getBoundingClientRect().top - tabsHeight;
            let windowHeight = (document.documentElement.clientHeight || document.body.clientHeight) - tabsHeight;
            // 滚动监控
            dom.addEventListener('scroll', () => {
                let scrollTop = dom.scrollTop;
                if (Math.floor(scrollTop) >= Math.floor(topHeight)) {
                    dom.scrollTop = topHeight;
                    this.tableHeight = windowHeight;
                } else if (Math.floor(scrollTop) < Math.floor(topHeight)) {
                    this.tableHeight = null;
                }
            })
        },
        // 选择btn
        chooseTabBtn: function (item) {
            this.activeBtn = item;
            //柱状图
            let json = {
                name: "期外费用",
                xValue: this.barObj[this.activeBtn.barKey[0]+'_x'],
                yName: this.activeBtn.barYName,
                stack: this.activeBtn.name,
                yValue: [
                    {
                        name: this.activeBtn.barY[0],
                        value: this.barObj[this.activeBtn.barKey[0]]
                    },
                    {
                        name: this.activeBtn.barY[1],
                        value: this.barObj[this.activeBtn.barKey[1]]
                    }
                ]
            }
            this.getBarChart('bar', json);
        },
        // 获取数据
        getData: function() {
            let params = {
                statMonth: this.month,
                productType: this.type,
                areaLevel: String(this.level),
                areaCode: this.areaCode
            };

            queryOutArrearsBalance(params).then(({data}) => {
                if(!data || data == '[]' ) {
                    this.noData = true;
                    return;
                }
                this.noData = false;
                data = JSON.parse(data);
                // 数据排序
                let sortData = {
                    outRatio: [],
                    outArrearsBalance: []
                };
                data = data.sort((a, b) => {
                    return a['areaCode'] - b['areaCode'];
                })
                data.forEach((item, index) => {
                    item.outRatio = item.outRatio === null ? '' : Math.round(item.outRatio * 100);
                    item.inRatio = item.inRatio === null ? '' : Math.round(item.inRatio * 100);

                    item.outArrearsBalance = item.outArrearsBalance === null ? '' : Math.round(item.outArrearsBalance / 10000);
                    item.inArrearsBalance = item.inArrearsBalance === null ? '' : Math.round(item.inArrearsBalance / 10000);
                    if(index > 0) {
                        item.outRatio === '' ? '' : sortData.outRatio.push(item.outRatio);
                        item.outArrearsBalance === '' ? '' : sortData.outArrearsBalance.push(item.outArrearsBalance);
                    }
                })
                sortData.outRatio = sortData.outRatio.length > 5 ? sortData.outRatio.sort((a,b) => b-a).slice(0,5) : sortData.outRatio;
                sortData.outArrearsBalance = sortData.outArrearsBalance.length > 5 ? sortData.outArrearsBalance.sort((a,b) => b-a).slice(0,5) : sortData.outArrearsBalance;

                // 整理数据
                let tableData = [];
                data.forEach((item,index) => {
                    item.areaName = item.areaSname ? item.areaSname : (item.areaName ? item.areaName : '其他');
                    item.name = item.areaName;
                    item.value = item.areaName;

                    if(index > 0) {
                        let outRatioIsTop5  = sortData.outRatio.indexOf(item.outRatio);
                        if (outRatioIsTop5 > -1) {
                            item.outRatioIsTop5 = true;
                            sortData.outRatio.splice(outRatioIsTop5,1);
                        } else {
                            item.outRatioIsTop5 = false;
                        }

                        let outArrearsBalanceIsTop5  = sortData.outArrearsBalance.indexOf(item.outArrearsBalance);
                        if (outArrearsBalanceIsTop5 > -1) {
                            item.outArrearsBalanceIsTop5 = true;
                            sortData.outArrearsBalance.splice(outArrearsBalanceIsTop5,1);
                        } else {
                            item.outArrearsBalanceIsTop5 = false;
                        }
                    }

                    if(index == 0) {
                        this.areaCode = this.areaCode ? this.areaCode : item.areaCode;
                        this.beforeAreaCode = item.pAreaCode ? item.pAreaCode : '100000';
                    }

                    tableData.push(item);
                })

                // 柱状图排序
                this.xValue = [];
                this.barObj = {};
                let filterData = data.filter(item => {
                    if(item.areaCode != this.areaCode || data.length == 1) {
                        return item;
                    }
                });
                
                filterData = this.filterData(filterData, 'outArrearsBalance');
                this.barObj['outArrearsBalance_x'] = this.getMappingValueArrayOfKey(filterData, 'areaName');
                this.barObj['outArrearsBalance'] = this.getMappingValueArrayOfKey(filterData, 'outArrearsBalance');
                this.barObj['inArrearsBalance'] = this.getMappingValueArrayOfKey(filterData, 'inArrearsBalance');

                filterData = this.filterData(filterData, 'outRatio');
                this.barObj['outRatio_x'] = this.getMappingValueArrayOfKey(filterData, 'areaName');
                this.barObj['outRatio'] = this.getMappingValueArrayOfKey(filterData, 'outRatio');
                this.barObj['inRatio'] = this.getMappingValueArrayOfKey(filterData, 'inRatio');

                this.renderPage(tableData);
                // 存储数据
                if(Object.keys(this.cacheData).length > 10) {
                    this.cacheData.shift();
                }
                this.cacheData[this.areaCode] = {
                    "beforeAreaCode": this.beforeAreaCode,
                    "tableData": tableData,
                    "xValue": this.xValue,
                    "barObj": this.barObj
                }

            }).catch(err => {
                this.noData = true;
            })
        },
        // 渲染页面
        renderPage(tableData) {
            // 表格
            this.tableData = tableData;
            this.$refs.echarts.$refs.tableOwe.clearSort();

            //柱状图
            let json = {
                name: "期外费用",
                xValue: this.barObj[this.activeBtn.barKey[0]+'_x'],
                yName: this.activeBtn.barYName,
                stack: this.activeBtn.name,
                yValue: [
                    {
                        name: this.activeBtn.barY[0],
                        value: this.barObj[this.activeBtn.barKey[0]]
                    },
                    {
                        name: this.activeBtn.barY[1],
                        value: this.barObj[this.activeBtn.barKey[1]]
                    }
                ]
            }
            this.$nextTick(() => {this.getBarChart('bar', json)});
        },
        // 柱状图
        getBarChart: function (refs, json) {
            let myChart = echarts.init(this.$refs[refs]);
            let option = stackBarOption(["#F74627", "#00C482"], json);
            myChart.setOption(option, true);
            myChart.on('legendselectchanged', function (params) {
                let option = this.getOption();
                if (!params.selected[params.name]) {
                    // false 的时候
                    let isTure = [];
                    for(var item in params.selected){
                        if (params.selected[item]) {
                            isTure.push(item)
                        };
                    }
                    if (isTure.length > 0) {
                        option.legend[0].selected[params.name] = false;
                    } else {
                        option.legend[0].selected[params.name] = true;
                    }
                } else {
                    // true 的时候
                    option.legend[0].selected[params.name] = true;
                }
                this.setOption(option)
            });
        },
        // 下钻接口
        drillDown: function (data){
            const item = data.item;
            this.areaCode = item.areaCode;
            this.level = this.level + 1;
            const cacheData = this.cacheData[item.areaCode];
            // 获取数据，重新渲染页面
            if(cacheData) {
                this.beforeAreaCode = cacheData.beforeAreaCode;
                this.xValue = cacheData.xValue;
                this.barObj = cacheData.barObj;
                this.renderPage(cacheData.tableData);
            } else {
                this.getData();
            }
        },
        // 返回上一级
        upLevel() {
            if (this.level == 1) {
                Emp.execute("goBack()");
            } else {
                this.level = this.level - 1;
                this.areaCode = this.beforeAreaCode;
                const cacheData = this.cacheData[this.areaCode];
                // 获取数据，重新渲染页面
                if(cacheData) {
                    this.beforeAreaCode = cacheData.beforeAreaCode;
                    this.xValue = cacheData.xValue;
                    this.barObj = cacheData.barObj;
                    this.renderPage(cacheData.tableData);
                } else {
                    this.getData();
                }
            }
        },
        // 表格数据排序
        sortTableData(data) {
            this.tableData = data;
        },
        filterData(data, key) {
            let filterData = [];
            filterData = data.sort((a, b) => {
                let aVal = a[key];
                let bVal = b[key];
                return bVal - aVal;
            })
            return filterData;
        },
        getMappingValueArrayOfKey(array,keyName) {
            if(Object.prototype.toString.call(array)=='[object Array]'){
                return array.map(item => {
                    return item[keyName]
                })
            }
            return '';
        }
    } 
};