var activeByIndustry = {
	data(){
		return {
			noData: false,
			activeBtn: {},
			tabBtn:[
					{
						id: 1,
	                    name: "新增+存量",
	                    type: 'A',
					},{
						id: 2,
	                    name: "新增",
	                    type: 'Z',
					},{
						id: 3,
	                    name: "存量",
	                    type: 'C',
					},
	        ],
	        active2: 0,
	        list: [],
	        pie1List: [],
	        pie2List: [],
			global: {},
	        tablecolumn:this.initColumn(),
		}
	},
	components: {
		'tab-btn-box': tabBtnBox,
		'pie-box': pieBox,
	},
	props: ['show','month'],
    watch: {
        month: function(val, oldVal) {
	    	this.chooseTabBtn(this.activeBtn);
        },
        show: function(){
        	if(this.show && (this.list.length == 0 || this.noData)){
        		this.chooseTabBtn();
        	}
        },
        noData: function(){
        	if(noData){
        		this.list = [];
        		this.pie1List = [];
        		this.pie2List = [];
        	}
        },
    },
	methods:{
		toGlobal(){
			var url = "/fiveSystemKanban/marketSystem/marketingResults/globalDetail.html";
			var p = {
				month: this.month,
				industryCode: '0',
				classify: this.activeBtn.type,
			};
         	Emp.execute("$M.page.goTo('"+url+"','"+JSON.stringify(p)+"', false)");
		},
		chooseTabBtn: function (item) {
			if(!item || !item.type){
				item = this.tabBtn[0];
			}
			this.activeBtn = item;
			this.initGlobalData();
			this.initTableData();
	    },
	    vantRender(name,title){
			if(name == 1){
				this.$refs.pie2.initEcharts(this.pie2List);
			}else{
				this.$refs.pie1.initEcharts(this.pie1List);
			}
	    },
        drillDown: function (data){
        	let url = "/fiveSystemKanban/marketSystem/marketingResults/industryDrill.html";
			let p = {
				month: this.month,
				industryCode: data.row.nameCode,
				industryName: data.row.name,
				classify: this.activeBtn.type,
			};
         	Emp.execute("$M.page.goTo('"+url+"','"+JSON.stringify(p)+"', false)");
        },
	    toPieDetail1(){
        	let url = "/fiveSystemKanban/marketSystem/marketingResults/industrySummary.html";
			let p = {
				month: this.month,
				type: 'number',
				classify: this.activeBtn.type,
			};
         	Emp.execute("$M.page.goTo('"+url+"','"+JSON.stringify(p)+"', false)");
	    },
	    toPieDetail2(){
			let url = "/fiveSystemKanban/marketSystem/marketingResults/industrySummary.html";
			let p = {
				month: this.month,
				type: 'income',
				classify: this.activeBtn.type,
			};
         	Emp.execute("$M.page.goTo('"+url+"','"+JSON.stringify(p)+"', false)");
	    },
	    initColumn(){
	    	return [
	    	 	{
		    		label: '行业',
		    	    key: 'name',
		    	    fixed: true,
		    	    width: 80,
		    	    isDrillDown: true,
		    	},{
		    		label: '客户数|(个)',
		    	    key: 'khs',
		    	    width: 90,
		    	    sortable: true,
		    	    align: 'right',
		    	    isNumber: true,
		    	},{
		    		label: '客户数增量|(个)',
		    	    key: 'khszl',
		    	    width: 106,
		    	    sortable: true,
		    	    align: 'right',
		    	    isNumber: true,
		    	    subByZero: true,
		    	},{ 
		    		label: '业务收入|(万元)',
		    	    key: 'ywsr',
		    	    sortable: true,
		    	    width: 96,
		    	    align: 'right',
		    	    isNumber: true,
		    	},{
		    		label: '收入增幅|(%)',
		    	    key: 'srzf',
		    	    sortable: true,
		    	    width: 106,
		    	    align: 'right',
		    	    isNumber: true,
		    	    subByZero: true,
		    	},{
		    		label: '全网最佳|(%)',
		    	    key: 'qwzj',
		    	    sortable: true,
		    	    width: 106,
		    	    align: 'right',
		    	    isNumber: true,
		    	    subByZero: true,
		    	},{
		    		label: '全网最差|(%)',
		    	    key: 'qwzc',
		    	    sortable: true,
		    	    width: 106,
		    	    align: 'right',
		    	    isNumber: true,
		    	    subByZero: true,
		    	},
	    	]
	    },
	    initTableData(){
	    	this.noData = false;
	    	let params = {
            	statDate: this.month,
            	industryGrade: '1',
            	classify: this.activeBtn.type,
		    }
	    	requestActivePieTableByIndustry(params).then(({data}) => {
		       	if(!data){
		       		this.noData = true;
		       		return;
		       	}
		       	let json = JSON.parse(data);
		       	let pie1 = json.distributeData;
		       	let pie2 = json.incomeData;
		       	let table = json.tableData;
		       	
		       	if((!pie1 || pie1.length == 0) && (!pie2 || pie2.length == 0) && (!table || table.length == 0)){
		       		this.noData = true;
		       		return;
		       	}
		       	
		       	if(pie1){
		       		pie1.forEach(e => {
		       			e.name = e.industryName;
		       			e.value = e.customAmountRate.split('%')[0];
		       		});
		       	}
		       	
		       	if(pie2){
		       		pie2.forEach(e => {
		       			e.name = e.industryName;
		       			e.value = e.customIncomeRate.split('%')[0];
		       		});
		       	}
		       	
		       	if(table){
		       		table.forEach(e => {
		       			e.name = e.industryName;
		       			e.nameCode = e.industryCode;
			    		e.khs = e.curMonthTotalCustomer;
			    		e.khszl = e.curMonthTotalCustomerIncrement;
			    		e.ywsr = this.notEmpty(e.curMonthTotalBusinessIncome) ? Math.round(e.curMonthTotalBusinessIncome / 10000) : '';
			    		e.srzf = this.notEmpty(e.curMonthTotalIncomeRate) ? (e.curMonthTotalIncomeRate * 100).toFixed(2) : '';
			    		e.qwzj = this.notEmpty(e.wholeNetBest) ? (e.wholeNetBest * 100).toFixed(2) : '';
			    		e.qwzc = this.notEmpty(e.wholeNetWorst) ? (e.wholeNetWorst * 100).toFixed(2) : '';
		       		});
		       	}
		    	this.$nextTick(() => {
			    	this.list = table;
			    	this.pie1List = pie1;
			    	this.pie2List = pie2;
			    	this.$refs.pie1.initEcharts(pie1);
			    	if(this.$refs.pie2){
			    		this.$refs.pie2.initEcharts(pie2);
			    	}
		        });
		    	this.noData = false;
		    }).catch(err => {
		    	this.noData = true;
		    });
	    },
	    initGlobalData(){
            let params = {
            		statDate: this.month,
            		classify: this.activeBtn.type,
		    }
            requestActiveGlobal(params).then(({data}) => {
		       	if(!data){
		       		this.global = {};
		       		this.global.khs = '-';
		       		this.global.khszl = '-';
		       		this.global.ywsr = '-';
		       		this.global.srzf = '-';
		       		this.global.zjzf = '-';
		       		this.global.zjmc = '-';
		       		this.global.zczf = '-';
		       		this.global.zcmc = '-';
		       		this.global.pm = '-';
		       		this.global.rankView = false;
		       		return;
		       	}
		       	let e = JSON.parse(data);
		       	if(e){
		       		this.global = {};
		       		this.global.khs = e.curMonthTotalCustomer ? e.curMonthTotalCustomer + '个' : '-';
		       		this.global.khszl = e.curMonthTotalCustomerIncrement ? e.curMonthTotalCustomerIncrement + '个' : '-';
		       		this.global.ywsr = this.notEmpty(e.curMonthTotalBusinessIncome) ? Math.round(e.curMonthTotalBusinessIncome / 10000) + '万元' : '-';
		       		this.global.srzf = this.notEmpty(e.curMonthTotalIncomeRate) ? (e.curMonthTotalIncomeRate * 100).toFixed(2) + '%' : '-';
		       		this.global.zjzf = this.notEmpty(e.bestRate) ? (e.bestRate * 100).toFixed(2) + '%' : '-';
		       		this.global.zjmc = e.bestProv ? e.bestProv : '-';
		       		this.global.zczf = this.notEmpty(e.worstRate) ? (e.worstRate * 100).toFixed(2) + '%' : '-';
		       		this.global.zcmc = e.worstProv ? e.worstProv : '-';
		       		this.global.pm = e.ranking;
		    		this.global.rankView = getLevelFromPermission(1) >= 2;
		    		this.global.rankName = this.getRankName();
		       	}
		    }).catch(err => {
		    	this.global = {};
	       		this.global.khs = '-';
	       		this.global.khszl = '-';
	       		this.global.ywsr = '-';
	       		this.global.srzf = '-';
	       		this.global.zjzf = '-';
	       		this.global.zjmc = '-';
	       		this.global.zczf = '-';
	       		this.global.zcmc = '-';
	       		this.global.pm = '-';
	       		this.global.rankView = false;
		    });
	    },
        notEmpty(arg){
        	if(arg === undefined || arg === '' || arg == null){
        		return false;
        	}else{
        		return true;
        	}
        },
        getRankName(){
        	let lv = getLevelFromPermission(1);
        	if(lv == 2) return '全网';
        	if(lv == 3) return '全省';
        	if(lv == 4) return '全市';
        },
	},
	created(){
	},
	mounted(){
		if(this.show && this.month){
			this.chooseTabBtn();
		}
	},
	template: `
    <div>
		<div style="height:0.4rem;background:#FFF;box-shadow: 0px 1px 4px 0px rgba(187, 182, 182, 0.5);">
			<tab-btn-box :tab-btn="tabBtn" @choose-tab-btn="chooseTabBtn"></tab-btn-box>
		</div>
		<div v-show="!noData">
			<div style="height: 1.4rem;margin-top: 0.06rem;background:#FFF;box-shadow: 0px 1px 4px 0px rgba(187, 182, 182, 0.5);">
				<div style="height:0.4rem;text-align:right;position: relative;" @click="toGlobal()">
					<span style="display: flex;align-items: center;line-height:0.4rem;position:absolute;left:0.12rem;">
						<span style="font-size: 0.16rem;font-weight: 600;color: #333333;">总体概况</span>
		                <span v-show="global.rankView" style="display: flex;align-items: center;height:0.2rem;line-height:0.2rem;background: #F9F6F4;border-radius: 0.1rem;margin-left:0.07rem;">
		                    <img style="width:0.12rem; height:0.12rem;margin-left:0.08rem" src="../../image/trophy.png" >    
		                    <span style="font-size: 0.12rem;line-height:0.2rem;color:#9F7933;font-weight: 400;margin:0 0.06rem 0 0.02rem;">增幅{{global.rankName}}第{{global.pm}}名</span>
		                </span>
					</span>
					<span style="font-size: 0.12rem;font-weight: 400;color: #0692EF;">查看详情</span>
					<img style="width:0.13rem; height:0.13rem;margin-right:0.13rem;margin-top:0.07rem;" src="../../image/arrow_right.png"> 
				</div>
				<div style="height: 1px;background:#E4E4E4;"></div>
				<div style="display:flex;height:0.76rem;padding: 0.1rem 0.1rem;">
					<div style="display:flex;width:100%;">
						<div style="width:0.76rem">
							<span class="globalKey">客户数:</span>
							<span class="globalKey">客户数增量:</span>
							<span class="globalKey">活跃最佳:</span>
						</div>
						<div>
							<span class="globalValue globalKey">{{global.khs}}</span>
							<span class="globalValue globalKey">{{global.khszl}}</span>
							<div style="line-height:0.15rem;">
								<span class="globalValue" style="line-height: 0.12rem">{{global.zjmc}} </span>
								<span class="globalValue" style="color: #009900">{{global.zjzf}}</span>
							</div>
						</div>
					</div>
					<div style="display:flex;width:100%;padding-left:0.1rem;">
						<div style="width:0.6rem">
							<span class="globalKey">业务收入:</span>
							<span class="globalKey">收入增幅:</span>
							<span class="globalKey">活跃最差:</span>
						</div>
						<div>
							<span class="globalValue globalKey">{{global.ywsr}}</span>
							<span class="globalValue globalKey">{{global.srzf}}</span>
							<div style="line-height:0.15rem;">
								<span class="globalValue" style="line-height: 0.12rem">{{global.zcmc}} </span>
								<span class="globalValue" style="color: #FA2525">{{global.zczf}}</span>
							</div>
						</div>
					</div>
				</div>
			</div>
			<div class="pieTabs" style="margin-top: 0.06rem;background:#FFF;box-shadow: 0px 1px 4px 0px rgba(187, 182, 182, 0.5);">
				<van-tabs class="blue-van-tabs" v-model="active2" swipeable @rendered="vantRender">
					<van-tab title="行业客户数量占比">
						<div>
							<div style="height:0.3rem;text-align:right;" @click="toPieDetail1()">
								<span style="font-size: 0.12rem;font-weight: 400;color: #0692EF;">查看表格汇总详情</span>
								<img style="width:0.13rem; height:0.13rem;margin-right:0.13rem;margin-top:0.07rem;" src="../../image/arrow_right.png"> 
							</div>
							<pie-box
								ref="pie1"
								box-height="140px"
								echart-name="客户数量"
							>
							</pie-box>
						</div>
					</van-tab>
					<van-tab title="行业客户收入占比">
						<div>
							<div style="height:0.3rem;text-align:right;" @click="toPieDetail2()">
								<span style="font-size: 0.12rem;font-weight: 400;color: #0692EF;">查看表格汇总详情</span>
								<img style="width:0.13rem; height:0.13rem;margin-right:0.13rem;margin-top:0.07rem;" src="../../image/arrow_right.png"> 
							</div>
							<pie-box
								ref="pie2"
								box-height="140px"
								echart-name="客户收入"
							>
							</pie-box>
						</div>
					</van-tab>
				</van-tabs>
			</div>
			<div style="background:#FFF;margin-top:0.06rem;">
				<drill-down-box 
				ref="echarts"
				:list="list"
				:tablecolumn="tablecolumn"
				@drilldown="drillDown"
				/>
			</div>
		</div>	
        <div class="noData" v-if="noData">
            <img src="../../image/nodata.png" alt="暂无数据"/>
            <h3>暂无数据</h3>
        </div>
    </div>
    `,
}