var industryDrill = {
	data(){
		return {
			noData: false,
	        list: [],
	        barList: [],
	        legend: ['增幅', '客户数'],
			valueName: ['增幅(%)','客户数(万)'],
			echartsName: '',
			tablecolumn: [
			 	    	 	{
			 		    		label: '二级行业',
			 		    	    key: 'name',
			 		    	    fixed: true,
			 		    	    width: 162,
			 		    	},{
			 		    		label: '活跃客户|数(个)',
			 		    	    key: 'khs',
			 		    	    width: 100,
			 		    	    sortable: true,
			 		    	    align: 'right',
			 		    	    isNumber: true,
			 		    	},{
			 		    		label: '活跃客户|增幅(%)',
			 		    	    key: 'khzf',
			 		    	    width: 100,
			 		    	    sortable: true,
			 		    	    align: 'right',
			 		    	    isNumber: true,
			 		    	    subByZero: true,
			 		    	},{ 
			 		    		label: '客户收入|(万元)',
			 		    	    key: 'khsr',
			 		    	    sortable: true,
			 		    	    width: 100,
			 		    	    align: 'right',
			 		    	    isNumber: true,
			 		    	},{
			 		    		label: '收入增幅|(%)',
			 		    	    key: 'srzf',
			 		    	    sortable: true,
			 		    	    width: 106,
			 		    	    align: 'right',
			 		    	    isNumber: true,
			 		    	    subByZero: true,
			 		    	}
			 	    	],
		}
	},
	props: ['month','industryCode','industryName','industryLevel','classify'],
    watch: {
        month: function(val, oldVal) {
	    	this.initData();
        },
    },
	methods:{
	    initData(){
        	this.echartsName = this.industryName;
        	
	    	let params = {
	            statDate: this.month,
	            pIndustryCode: this.industryCode,
	            industryGrade: this.industryLevel,
	            classify: this.classify,
			}
	    	requestActiveDrillByIndustry2(params).then(({data}) => {
			   	if(!data || data == '[]'){
			  		this.noData = true;
			   		return;
			   	}
			   	let list = JSON.parse(data);
			   	list.forEach((e,i) => {
		    		e.name = e.industryName;
		    		e.nameCode = e.industryCode;
		    		e.khs = e.curMonthTotalCustomer;
		    		e.khzf = this.notEmpty(e.curMonthTotalCustomerRate) ? (e.curMonthTotalCustomerRate * 100).toFixed(2) : '';
		    		e.khsr = this.notEmpty(e.curMonthTotalBusinessIncome) ? Math.round(e.curMonthTotalBusinessIncome / 10000) : '';
		    		e.srzf = this.notEmpty(e.curMonthTotalIncomeRate) ? (e.curMonthTotalIncomeRate * 100).toFixed(2) : '';
			   	})
			    this.list = list;
			    this.noData = false;
			}).catch(err => {
			   	this.noData = true;
			});
	    	
        	let params2 = {
            	statDate: this.month,
            	industryCode: this.industryCode,
            	classify: this.classify,
            	areaLevel: 1,
            	areaCode: '',
		    }
	    	requestActiveDrillTrendByIndustryPro(params2).then(({data}) => {
	    		if(!data || data == '[]'){
		       		return;
		       	}
	    		let list = JSON.parse(data);
	    		list.forEach(e => {
	    			e.name = e.statDate ? e.statDate : '';
		    		e.value = this.convertToRate(e.curMonthTotalCustomerRate);
		    		e.value2 = this.notEmpty(e.curMonthTotalCustomer) ? (e.curMonthTotalCustomer / 10000).toFixed(2) : '';
	    		})
	    		this.barList = list;
	            this.$nextTick(() => {
	            	this.$refs.linebar2.initDefault();
	            })
		    }).catch(err => {
		    });
	    },
        notEmpty(arg){
        	if(arg === undefined || arg === '' || arg == null){
        		return false;
        	}else{
        		return true;
        	}
        },
        convertToRate(arg){
        	return this.notEmpty(arg) ? (arg * 100).toFixed(2) : '';
        },
        convertToW(arg){
        	return this.notEmpty(arg) ? Math.round(arg / 10000) : '';
        },
	},
	created(){
		window['goBack'] = () => {
			try {
				Emp.execute('goBack()');
	            } catch (e) {
	        }
	    };
	},
	mounted(){
		if(this.month){
			this.initData();
		}
	},
	template: `
    	<div>
			<div v-show="!noData" style="background:#FFF;">
				<div>
					<line-bar-box
					ref="linebar2"
					:list="barList"
					:legend="legend"
					:value-name="valueName"
					:echart-name="echartsName"
					/>
				</div>
				<div>
					<drill-down-box
					ref="table2"
					:list="list"
					:tablecolumn="tablecolumn"
					/>
				</div>
			</div>
			<div class="noData" v-if="noData">
				<img src="../../image/nodata.png" alt="暂无数据" />
				<h3>暂无数据</h3>
			</div>
		</div>
    `,
}