/**
 * yy
 */
//指标下钻
Vue.component('productAnalysis', {
    components:{
        'tab-btn-box': tabBtnBox
    },
    data() {
        return {
            style1: {
                color: '#3377FF'
            },
            style2: {
                color: '#333'
            },
            sortType: true,
            upColor: 'red', // 上升颜色
            downColor: 'green', // 下降颜色
            accountLevel: '',
            activeBtnId: '1'
        }
    },
    props: {
        tablecolumn: {
            Array,
            default: () => {
                return []
            }
        },
        tableHeight: {
        	Number,
        	default: null
        },
        legend: {
        	Object,
            default: () => {
                return {}
            }
        },
        level: {
            Number, 
            default: 1
        },
        title: {
            String,
            default: '省份'
        },
        yName: {
            String,
            default: '月增幅'
        },
        echartsData: {
            Object,
            default: () => {
                return {}
            }
        },
        list: {
            Array,
            default: () => {
                return []
            }
        },
        isDrillDown: {
            Boolean,
            default: true
        },
        isNo: {
            Boolean,
            default: true
        },
        notReverse: {
            Boolean,
            default: true
        },
        defaultSort: {
            Object,
            default: () => {
                return {
                    prop: 'areaCode',
                    order: 'ascending'
                }
            }
        },
        echartName: {
            String,
            default: ''
        },
        isShowLine: {
            Boolean,
            default: false
        },
        valueMax: {
            String,
            default: null
        },
        specialName: {
            Array,
            default: () => {
                return ['总计','其他']
            }
        },
        divideCode: {
            String,
            default: null
        },
        divideCodeLevel: {
            String,
            default: null
        }
    },
    computed: {
        x_data() {
            const newList = this.list.sort((i, n) => {
                return Number(i.locCode) - Number(n.locCode)
            });
            const arr = this.list.filter(e => e.areaName !== '总计')
            return arr.map(i => i.areaName);
        },
        value_data() {
            const newList = this.list.sort((i, n) => {
                return Number(i.locCode) - Number(n.locCode)
            });
            const arr = this.list.filter(e => e.areaName !== '总计')
            return arr.map(i => i.value);
        },
        tabBtn() {
            let accountLevel = getAccountLevel()
            let tabNav = [
                {id:1, name: '业务量'},
                {id:2, name: '业务收入'},
                {id:3, name: '收入增幅'}
            ]
            return tabNav
        },
    },
    methods: {
        getColor(val) {
            if (val === '-' || parseFloat(val) == 0) return '';
            if (this.notReverse) {
                if (parseFloat(val) < 0) return this.downColor;
                if (parseFloat(val) > 0) return this.upColor;
            } else {
                if (parseFloat(val) < 0) return this.upColor;
                if (parseFloat(val) > 0) return this.downColor;
            }
        },
        getValue(val,compareKey,isRate) {
        	let res;
            if (val === undefined || val === '' || val == null) {
            	res = '-'
            }else if(compareKey && compareKey < 0){
            	res = "-" + val;
            } else if (!isRate) {
                res = (val / 10000).toFixed(2);
                if (res == 0) {
                    res = '0.00'
                }
            }
            else if (isRate) {
            	res = val;
            }
            
            return res;
        },
        xiazuan(item, key, index) {
            if (key === 'areaName') {
                if (!this.isDrillDown || !this.filterDrillDown(item.areaName, index)) return;
                this.$emit('drilldown', {
                    item: item,
                    key: key
                })
            } else {
                if (key.isDrillDown && item[key.key] != 0) {
                    this.$emit('drilldown', {
                        item: item,
                        key: key.key
                    })
                }
            }
        },
        sortMethod(a,b,key,compareKey){
        	let l = a[key];
        	let r = b[key];
        	if(l == undefined || l == null || l == ''){
        		l = -100000000;
        	}
        	if(r == undefined || r == null || r == ''){
        		r = -100000000;
        	}
            return r - l;
        },
        
        initDefault() {
            console.log('22222222222')
            this.accountLevel = getAccountLevel()
            document.documentElement.scrollIntoView();
            // this.list.sort((i, n) => {
            //     return i.areaCode.length - n.areaCode.length
            // });
            function compare(p){ //这是比较函数
                return function(m,n){
                    var a = m[p];
                    var b = n[p];
                    return b - a; //升序
                }
            }
            let newList = this.echartsData
            //
            // newList.sort(compare("fRateM"));
            console.log('newList',newList)
            let arr = newList
            let xData = [];
            let valueData1 = [];
            let valueData = []
            let lineData = []
            if (this.activeBtnId == 1) { //业务量
                if (arr.competeAnalysisQuery) {
                    xData = arr.competeAnalysisQuery.competeBusiCnt.map(item=>{
                        return item.competeName
                    })
                    
                    valueData = arr.competeAnalysisQuery.competeBusiCnt.map(item=>{
                        valueData1.push(item.mtBusiCnt);
                        return item.mtBusiCnt
                    })
                    lineData = arr.competeAnalysisQuery.competeBusiCnt.map(item=>{
                        return item.ytBusiCnt
                    })
                }
                console.log(xData, valueData, lineData)
            } else if(this.activeBtnId == 2){ //业务收入
                if (arr.competeAnalysisQuery) {
                    xData = arr.competeAnalysisQuery.competeBusiAmt.map(item=>{
                        return item.competeName
                    })
                    
                    valueData = arr.competeAnalysisQuery.competeBusiAmt.map(item=>{
                        valueData1.push(item.mtAmt);
                        return item.mtAmt
                    })
                   
                    lineData = arr.competeAnalysisQuery.competeBusiAmt.map(item=>{
                        return item.ytAmt
                    })
                }
                console.log(xData, valueData, lineData)
            } else { //收入增幅
                if (arr.competeAnalysisQuery) {
                    
                    xData = arr.competeAnalysisQuery.competeBusiRate.map(item=>{
                        return item.competeName
                    })
                    
                    valueData = arr.competeAnalysisQuery.competeBusiRate.map(item=>{
                        valueData1.push(item.mtM2mRate);
                        return item.mtM2mRate
                    })
                   
                    lineData = arr.competeAnalysisQuery.competeBusiRate.map(item=>{
                        return item.ytY2yRate
                    })
                }
            }
            this.initEcharts2(xData,valueData,lineData);
        },
        initEcharts2(xData,valueData, lineData) {
            const _this = this
            
            setTimeout(()=>{

                let mychart2 = echarts.init(document.getElementById('chart2'));
                console.log(_this.legend)
                let option2 = {
                    color: ['#0199FF'],
                    legend: _this.legend,
                    tooltip: {
                        trigger: 'axis',
                        axisPointer: { // 坐标轴指示器，坐标轴触发有效
                            type: 'shadow' // 默认为直线，可选为：'line' | 'shadow'
                        },
                        formatter: function (param) {
                            let arr = param.filter(e => e.value);
                            if(!arr || arr.length <= 0){
                                 return '';
                            }
                            let x = arr[0].name;
                            if(x){
                                //x轴名称过长时，tootip需要换行显示
                                let n9 = Math.floor(x.length / 9);
                                for(let n=n9;n>0;n--){
                                    x = x.slice(0, n*9) + '<br/>' + x.slice(n*9);
                                }
                                //如果是整倍数，需要移除最后一个换行符
                                if(x.substr('<br/>'.length * -1) == '<br/>'){
                                    x = x.slice(0,x.length - '<br/>'.length);
                                }
                            }
                            // if(x && _this.tooltipSuffix){
                            // 	x += _this.tooltipSuffix;
                            // }
                            arr.forEach((e,i) => {
                                let unit;
                                let v = _this.yName;
                                let l = v.indexOf('(');
                                let r = v.indexOf(')');
                                if(l + r > 1){
                                    unit = v.substring(l+1,r);
                                }
                                x += '<br/>' + e.marker + e.seriesName + ' : ' + e.value;
                                if(unit){
                                    x += unit;
                                }
                            });
                            return x;
                        },
                    },
                    grid: {
                        top: '15%',
                        left: '3%',
                        right: '4%',
                        bottom: '0%',
                        containLabel: true
                    },
                    xAxis: [{
                        type: 'category',
                        nameGap: 30,
                        data: xData,
                        "axisLine": {
                            lineStyle: {
                                color: '#90979c'
                            }
                        },
                        "splitLine": {
                            "show": false
                        },
                        "axisTick": {
                            "show": false
                        },
                        "splitArea": {
                            "show": false
                        },
                        "axisLabel": {
                            interval: 0,
                            rotate: 40,
                            formatter: (val) => {
                                if (val.length > 6) return val.substring(0, 6) + '...'
                                else return val
                            }
    
                        }
                    }],
                    yAxis: [{
                        type: 'value',
                        name: _this.yName,
                        axisLine: {
                            show: false
                        },
                        axisTick: {
                            show: false
                        },
                        axisLabel: {
                            formatter: (val) => {
                                if (Math.abs(Number(val)) >= 10000) return (Number(val) / 10000).toFixed(1) + '万'
                                else return val
                            },
                            textStyle: {
                                color: '#666666'
                            }
    
                        },
                        nameTextStyle: {
                            color:"#333333", 
                            padding: [0, 10, 14, 12]    // 四个数字分别为上右下左与原位置距离
                        }
                    }],
    
                //     "dataZoom": [{
                //         "show": true,
                //         "height": 30,
                //         "xAxisIndex": [
                //             0
                //         ],
                //         bottom: 10,
                //         startValue: 0,
                //         endValue: valueData.length > 6 ? 6 : valueData.length - 1,
                //         // filterMode: 'empty',
                //         maxValueSpan: 6,
                //         mixValueSpan: 6,
                //         handleIcon: 'path://M306.1,413c0,2.2-1.8,4-4,4h-59.8c-2.2,0-4-1.8-4-4V200.8c0-2.2,1.8-4,4-4h59.8c2.2,0,4,1.8,4,4V413z',
                //         handleSize: '110%',
                //         handleStyle: {
                //             color: "#d3dee5",
    
                //         },
                //         textStyle: {
                //             color: "#0199FF"
                //         },
                //         borderColor: "#90979c"
                //     }, {
                //         "type": "inside",
                //         "show": true,
                //         "height": 15,
                //         "start": 1,
                //         "end": 0
                //     }
                // ],
                    series: [
                        {
                            name: _this.legend.data[1],
                            type: 'bar',
                            stack: '竞品分析',
                            barWidth: 30,
                            barGap: 20,
                            color: '#0199FF',
                            data: valueData,
                            label: {
                                normal: {
                                    show: 'true',
                                    // position: 'insideBottom',
                                    rotate: 0,
                                    fontSize: 10,
                                }
                            },
                        },
                        {
                            name: _this.legend.data[0],
                            type: 'bar',
                            stack: '竞品分析',
                            barWidth: 30,
                            barGap: 20,
                            color: '#FFB444',
                            label: {
                                normal: {
                                    show: 'true',
                                    // position: 'insideBottom',
                                    rotate: 0,
                                    fontSize: 10,
                                }
                            },
                            data: lineData,
                        },
                        
                    ],
                }
                mychart2.setOption(option2, true);
                mychart2.on('legendselectchanged', function (params) {
                    let option = this.getOption();
                    if (!params.selected[params.name]) {
                        // false 的时候
                        let isTure = [];
                        for(var item in params.selected){
                            if (params.selected[item]) {
                                isTure.push(item)
                            };
                        }
                        if (isTure.length > 0) {
                            option.legend[0].selected[params.name] = false;
                        } else {
                            option.legend[0].selected[params.name] = true;
                        }
                    } else {
                        // true 的时候
                        option.legend[0].selected[params.name] = true;
                    }
                    this.setOption(option)
                });
            }, 200)
        },
        setWidth() {
            const width = this.title.length > 2 ? 120 : 76;
            if (this.tablecolumn.length === 1) return null;
            else return width
        },
        setColumnWidth(text){
    		if (this.tablecolumn.length < 3) return null;
    		if(!text){
    			return 106;
    		}
    		return 106;
//    		const len = text.length;
//    		if(len <= 2){
//    			return 80;
//    		}else{
//    			return 80 + 12 * (len - 2);
//    		}
        },
        // 对比昨天，获取颜色
        getColorByCompareYest(row, item) {
            // 检验昨日值字段
            if (!item.compareYestKey) {
            	return ''
            }
            if(row[item.compareYestKey] == 0){
            	return ''
            }
            return row[item.compareYestKey] > 0 ? this.upColor : this.downColor
        },
        // 将值分段，赋给不同颜色
        getColorBySub(row, item) {
            // 检验昨日值字段
            if (!item.subKey) {
            	return ''
            }
            if (row[item.key]+'' !='null' && row[item.subKey]+'' !='null') {
                if(Number(row[item.key]) < Number(row[item.subKey])){
                    return '#FA2525'
                }else if (Number(row[item.key]) >= Number(row[item.subKey])) {
                    return '#009900'
                }
            }
        },
        getColorStyle(row, item) {
            if (item.subKey && item.isRate) {
                return this.getColorBySub(row, item)
            } else {
                return this.style2
            }
        },
        getPaddingRight(scope, item) {
        	if(!item.width && item.align == 'right') {
        		let width = (scope.column.realWidth - scope.column.label.length * 12) / 2;
        		if(item.sortable){
        			width += 12;
        		}
            	return width + 'px';
        	} else {
        		if(item.sortable && item.align == 'right' && !item.isRate) {
        			return '20px';
        		} else if (item.sortable && item.align == 'right' && item.isRate){
                    return '42px';
                } else {
                    return '30px';
                }
        		return '0px';
        	}
        },
        // 表头换行
        renderHeader(h, { column, $index }) {
        	var lab = column.label;
        	if(lab.indexOf("|") < 0){
        		return h('span',{},lab)
        	}else{
        		var arr = lab.split('|')
        		const list = [];
        		arr.forEach(item => {
        			list.push(h('span', {}, item));
                    list.push(h('br'));
        		})
        		list.pop()
        		return h('span', {}, list)
        	}
        },
        //特殊名字过滤
        filterDrillDown(name, index){
            if (this.specialName.indexOf(name) < 0 && index) return true;
            else return false
        },
        // 改变表格排序
        changeTableSort({ column,  prop, order}) {
            if(column.sortable !== 'custom') {
                return;
            }
            let orderGroup = [];
            const fieldName = prop;
            const sortingType = order;
            orderGroup = JSON.parse(JSON.stringify(this.list));
            // 先进行地区排序
            console.log('divideCode',this.divideCode)
            if(this.divideCode) {
                // 参与排序的元素
                let divideGroup = orderGroup.filter(item => {
                    console.log('item.areaCode',item.areaCode)
                    return (item.areaCode != this.divideCode)
                })
                // 不参与排序的元素
                let divideItem = orderGroup[0]
                // orderGroup = divideGroup.sort((a, b) => {
                //     return a['areaCode'].length > b['areaCode'].length ? 1 : -1;
                // })
                orderGroup = divideGroup.sort((a, b) => {
                    // if (a['areaCode'].length > b['areaCode'].length) {
                    //     return a['areaCode'].length > b['areaCode'].length ? 1 : -1;
                    // }
                    return a['areaCode'] > b['areaCode'] ? 1 : -1;
                })
                orderGroup.unshift(divideItem)
                // 父级保存数据
                this.$emit('sort-list', orderGroup);
            }
            // 排序
            if (sortingType == 'descending') {
                // 从小到大排序
                console.log('orderGroup',orderGroup)
                this.list = orderGroup.sort((a, b) => {
                    console.log('=======',a.areaCode, this.divideCode)
                    let aVal = a[fieldName];
                    let bVal = b[fieldName];

                    // 让不参与排序的所在行值最小
                    if (a.areaCode == this.divideCode) {
                        aVal = -999999999999;
                    }
                    if (b.areaCode == this.divideCode) {
                        bVal = -999999999999;
                    }
                    if(aVal === undefined || aVal === null || aVal === ''){
                        aVal = -999999999998.9;
                    }
                    if(bVal === undefined || bVal === null || bVal === ''){
                        bVal = -999999999998.9;
                    }
                    return aVal - bVal;
                })
                 // 父级保存数据
                 this.$emit('sort-list', orderGroup);
            }  else if (sortingType == 'ascending') {
                // 从大到小排序
                console.log('orderGroup222',orderGroup)
                this.list = orderGroup.sort((a, b) => {
                    let aVal = a[fieldName]
                    let bVal = b[fieldName]

                    // 让不参与排序的所在行值最大
                    if (a.areaCode == this.divideCode) {
                        console.log(a.areaCode, this.divideCode)
                        aVal = 999999999999;
                    }
                    if (b.areaCode == this.divideCode) {
                        bVal = 999999999999;
                    }
                    if(aVal === undefined || aVal === null || aVal === ''){
                        aVal = -999999999998.9;
                    }
                    if(bVal === undefined || bVal === null || bVal === ''){
                        bVal = -999999999998.9;
                    }
                    return bVal - aVal;
                })
                // 父级保存数据
                this.$emit('sort-list', orderGroup);
            } else {
                this.list = orderGroup;
                this.$refs.table.clearSort();
            }
        },
        changeBtnId(item){
            this.activeBtnId = item.id
            this.$emit('choose-tab-btn', item);
        },
        
    },
    mounted() {
        const h = document.documentElement.clientHeight || document.body.clientHeight;
        setTimeout(() => {
            document.getElementById('chart2').style.height = h / 2 + 'px';
        }, 200);
    },
    template: `<div>
                <div style="box-sizing: border-box">
                    <div v-show = "accountLevel == '01' || accountLevel == '02'">
                        <p class="chartTitle">竞品收入对比分析</p>
                        <tab-btn-box ref="tabNav" :tab-btn="tabBtn" :active-btn-id="activeBtnId" @choose-tab-btn="changeBtnId"  
                        >
                        </tab-btn-box>
                        <div ref="chart2" style="padding: 0 5px; position: relative" v-show="isShowLine">
                            <div id="chart2" style="background-color: #FFF; width: 100%"></div>
                        </div>
                    </div>
                    <div style="padding: 0 2px">
                        <p class="chartTitle">快递行业收入对比分析</p>
                        <el-table
                                ref="table"
                                :data="list"
                                stripe
                                :header-cell-style="{background:'#0199FF',color:'#FFF', height: '34px', 'text-align': 'center', fontSize: '12px', fontWeight: 'normal'}"
                                :row-style="{height:'30px',fontSize: '12px'}"
                                @sort-change="changeTableSort"
                                style="width: 100%"
                                :height="tableHeight"
                        >
                            <el-table-column
                                    v-if="isNo"
                                    type="index"
                                    label="序号"
                                    align="center"
                                    fixed
                                    width="50"
                            >
                            </el-table-column>
                            <el-table-column
                                    prop="areaSname"
                                    :label="title"
                                    fixed
                                    :width="setWidth()"
                                    align="center">
                                <template slot-scope="scope">
                                    <span :style="[isDrillDown && filterDrillDown(scope.row.areaName, scope.$index) ? style1 : style2 ]"
                                          @click="xiazuan(scope.row, 'areaName', scope.$index)">{{scope.row.areaSname}}</span>
                                </template>
                            </el-table-column>
                            <el-table-column
                                    v-for="item in tablecolumn"
                                    :key="item.key"
                                    :prop="item.key"
                                    :label="item.label"
                                    label-class-name="headerClass"
                                    :render-header="renderHeader"
                                    :sortable="item.sortable"
                                    :width="item.width ? item.width : setColumnWidth(item.label)"
                                    :align="!item.align ? 'center' : item.align">
                                <template slot-scope="scope">
                                <!--如果是率-->
                                <span v-if="!item.isDrillDown" :class="item.sortable ? 'paddingR24' : ''" :style="{color: getColorStyle(scope.row,item),fontWeight:item.isNumber ? 600 : 'normal',paddingRight: getPaddingRight(scope, item)}" >
                                    {{getValue(scope.row[item.key],scope.row[item.compareYestKey],item.isRate)}}
                                </span>
                                <!--其他-->
                                <span v-else @click="xiazuan(scope.row, item)" :class="item.sortable ? 'paddingR24' : ''" :style="[item.isDrillDown && scope.row[item.key] != 0 ? style1 : style2 ]">
                                    {{getValue(scope.row[item.key],scope.row[item.compareYestKey])}}
                                </span>
                                </template>
                            </el-table-column>
                        </el-table>
                    </div>
                </div>
</div>`
});