Vue.component('order_tj', {
	data() {
		return {
			isUp: true,
			color: 'green',
			rale: '0',
			title: '',
			fontColor: '#FF7362',
			orderNum: '',
			tbNum: ''
		}
	},
	methods: {
		init_data(data) {
			for (let key in data) {
				this[key] = data[key]
			}
		},
		toXiazuan() {
			this.$emit('click')
		}
	},
	filters: {
		addSpot(source) {
			if (!source) return 0;
			if (source.length < 4) return source;
			if (Number.isInteger(source)) {
				source = source.toString()
			}
			var isMinus = false
			if (source.charAt(0) == '-') {
				isMinus = true
				source = source.slice(1)
			}
			let arr = [...source];
			let len = arr.length / 3;
			let newArr = [];
			for (let i = 0; i < len; i++) {
				let start = arr.length - 3 * (i + 1)
				let b = []
				if (start < 0) b = arr.slice(0, arr.length % 3);
				else b = arr.slice(start, arr.length - 3 * i);
				newArr.push(b.join(''));
			}
			if (isMinus) {
				return '-' + newArr.reverse().join(',');
			}
			return newArr.reverse().join(',');
		}
	},
	template: `<div>
        <div class="progress_com">
            <div class="progress_com_item_2 order_title" @click="toXiazuan()">
                <div style="height: 45px; line-height: 20px; text-align: center" >
                    <p>订单量</p>
                    <p style="font-weight: bold; font-size: 18px; line-height: 25px" :style="{color: fontColor}">{{orderNum | addSpot}}</p>
                </div>
            </div>
            <div class="progress_com_item_2">
                <div style="position: relative; ">
                    <svg viewBox="0 0 100 100" style="max-height: 100px; margin-top: 13px;">
                        <path d="
                M 50 50
                m 0 -44
                a 44 44 0 1 1 0 88
                a 44 44 0 1 1 0 -88
                " stroke="#e5e9f2" stroke-width="11.9" fill="none"
                              style="stroke-dasharray: 276.46px, 276.46px; stroke-dashoffset: 2px;"></path>
                        <path d="
                M 50 50
                m 0 -44
                a 44 44 0 1 1 0 88
                a 44 44 0 1 1 0 -88
                " :stroke="color" fill="none" stroke-linecap="round" stroke-width="11.9" class="aaa"
                              :style="{'stroke-dasharray': (276.46 * Math.abs(rale) / 100).toFixed(3) + 'px, 276.46px'}"></path>
                    </svg>
                    <div class="cale" :style="{color: fontColor}">
                        <i :class="!isUp ? 'el-icon-caret-top' : 'el-icon-caret-bottom'"></i>{{ rale }}%
                    </div>
                </div>
            </div>
            <div class="progress_com_item_2 order_title">
                <div style="height: 40px; line-height: 20px; text-align: center">
                    <p>同比</p>
                    <p style="font-weight: bold; font-size: 18px; line-height: 25px" :style="{color: fontColor}">{{ toThousands(tbNum) }}</p>
                </div>
            </div>   
        </div>
        <div style="text-align: center; font-weight: bold; margin-top: -5px" :style="{color: color}">
            {{title}}
        </div>
    </div>`
})

Vue.component('order_bfb', {
	data() {
		return {
			list: [],
			dd_level: '',
			dd_xzqh: '',
		}
	}, 
	methods: {
		init_data(data) {
			for (let key in data) {
				this[key] = data[key]
			}
			
		},
		init_ddltj_2(dd_xzqh,dd_level) {
			const path = 'dpk/queryPcOrderColum' //	订单量统计接口
			let paramsbody_2 = {
				"distCode": dd_xzqh, //  区域代码 默认为 000000
				"sumLevel": dd_level, //  查询层级
				"orgCode": "", //  机构代码  需判断层级
				"sumFg": "1", //  汇总标识
				// "dataDate": '2020-07-10'
				"dataDate": dayjs().format('YYYY-MM-DD')
			}
			const msgbody_2 = JSON.stringify(paramsbody_2)
			var interface = axios.create({
				'Access-Control-Allow-Origin': '*',
				baseURL: board_url,
				// baseURL: "https://211.156.195.17/bsv-app/",			
				timeout: 10000,
			})
			interface.get(path, {
				params: {
					'sendID': '00000001',
					'timestamp': timestamp,
					'msgBody': msgbody_2,
					'dataDigest': base64.encode(hex_md5(msgbody_2 + data_key + timestamp))
				}
			}).then(({
				data
			}) => {
				if ( data.data.length != 0 && data.data[0].aggOrderSum != 0 ) {
					// console.log(data.data[0].aggCainiaoNum, "菜鸟")
					console.log(data.data[0].aggOrderSum,"总俩个")
					console.log(parseFloat(data.data[0].aggPddNum / data.data[0].aggOrderSum).toFixed(2))
					// console.log(data.data[0].aggCainiaoNum / data.data[0].aggOrderSum)
					let xykhddl2 = [
					    /*{
							num: data.data[0].aggCainiaoNum,
							title: '菜鸟',
							rale: parseFloat(data.data[0].aggCainiaoNum / data.data[0].aggOrderSum).toFixed(2) * 100 + '%'
						},*/
					    {
							num: data.data[0].aggTaobaoNum, //  接口文档上是淘宝
							title: '阿里',
							rale: parseFloat(data.data[0].aggTaobaoNum / data.data[0].aggOrderSum).toFixed(2) * 100 + '%'
						},
						{
							num: data.data[0].aggPddNum,
							title: '拼多多',
							rale: parseFloat(data.data[0].aggPddNum / data.data[0].aggOrderSum).toFixed(2) > 1 ? '100%' : 
								  parseFloat(data.data[0].aggPddNum / data.data[0].aggOrderSum).toFixed(2) * 100 + '%'
						},
						{
							num: data.data[0].aggJdNum,
							title: '京东',
							rale: parseFloat(data.data[0].aggJdNum / data.data[0].aggOrderSum).toFixed(2) * 100 + '%'
						},
						/*{
							num: data.data[0].aggCustOrderNum,
							title: '客户直连',
							rale: parseFloat(data.data[0].aggCustOrderNum / data.data[0].aggOrderSum).toFixed(2) * 100 + '%'
						},*/
						{
							num: data.data[0].aggOtherNum,
							title: '其他',
							rale: parseFloat(data.data[0].aggOtherNum / data.data[0].aggOrderSum).toFixed(2) > 1 ? '100%' : 
								  parseFloat(data.data[0].aggOtherNum / data.data[0].aggOrderSum).toFixed(2) * 100 + '%'
						}
					]
					// xykhddl2[1].rale="92%"
					this.list = xykhddl2
				} else {
					let xykhddl2 = [
					    /*{
							num: '',
							title: '菜鸟',
							rale: '0%'
						},*/
					    {
							num: '0',
							title: '阿里',	//淘宝-->阿里
							rale: '0%'
						},
						{
							num: '0',
							title: '拼多多',
							rale: '0%'
						},
						{
							num: '0',
							title: '京东',
							rale: '0%'
						},
						/*{
							num: '0',
							title: '客户直连',
							rale: '0%'
						},*/
						{
							num: '0',
							title: '其他',
							rale: '0%'
						}
					]
					this.list = xykhddl2
				}
			}).catch(err => {
				console.log(err);
			});
		},
	},
	beforeMount() {
		// this.init_ddltj_2()
	},
	filters: {
		addSpot(source) {
			if (!source) return 0;
			if (source.length < 4) return source;
			if (Number.isInteger(source)) {
				source = source.toString()
			}
			let isMinus = false
			if (source.charAt(0) == '-') {
				isMinus = true
				source = source.slice(1)
			}

			let arr = [...source];
			let len = arr.length / 3;
			let newArr = [];
			for (let i = 0; i < len; i++) {
				let start = arr.length - 3 * (i + 1)
				let b = []
				if (start < 0) b = arr.slice(0, arr.length % 3);
				else b = arr.slice(start, arr.length - 3 * i);
				newArr.push(b.join(''));
			}
			if (isMinus) {
				return '-' + newArr.reverse().join(',');
			}
			return newArr.reverse().join(',');
		}
	},
	template: `<div>
        <div v-for="(i,index) in list" :key="index"
             style="display: flex; justify-content: space-between; width: 100%; font-size: 13px; color: #666666">
            <div style="width: 22%; padding: 0 7px">
                <p>{{i.title}}</p>
            </div>
            <div style="width: 78%; display: flex; align-items: center">
                <div style="width: 70%; height: 20px; display: flex; padding: 2px; border-radius: 5px">
                    <div class="dct_item">
                        <div style="height: 100%;" :style="{width: i.rale, 'background-color': index % 2 === 0 ? '#1D95F4' : '#48DCF1'}">

                        </div>
                    </div>
                </div>
                <div style="width: 30%; text-align: right; padding: 0 7px">
                    <p>{{i.num | addSpot}}</p>
                </div>
            </div>
        </div>
    </div>`
});

Vue.component('orders_bfb', {
	data() {
		return {
			list: [],
			dd_level: '',
			dd_xzqh: '',
		}
	},
	methods: {
		init_data(data) {
			for (let key in data) {
				this[key] = data[key]
			}
			
		},
		init_ddltjs_2(dd_xzqh,dd_level) {
			//alert(this.dd_xzqh)
			const path = 'dpk/queryPcOrderColum' //	订单量统计接口
			let paramsbody_2 = {
				"distCode": dd_xzqh, //  区域代码 默认为 000000
				"sumLevel": dd_level, //  查询层级
				"orgCode": "", //  机构代码  需判断层级
				"sumFg": "1", //  汇总标识
				// "dataDate": '2020-09-15'
				"dataDate": dayjs().format('YYYY-MM-DD')
			}
			const msgbody_2 = JSON.stringify(paramsbody_2)
			var interface = axios.create({
				'Access-Control-Allow-Origin': '*',
				baseURL: board_url,
				// baseURL: "https://211.156.195.17/bsv-app/",			
				timeout: 10000,
			})
			interface.get(path, {
				params: {
					'sendID': '00000001',
					'timestamp': timestamp,
					'msgBody': msgbody_2,
					'dataDigest': base64.encode(hex_md5(msgbody_2 + data_key + timestamp))
				}
			}).then(({
				data
			}) => {
				console.log(data, "包裹等接口")
				if ( data.data.length != 0 && data.data[0].retailOrderSum != 0 ) {
					let shddl2 = [{
							num: data.data[0].retailArkNum,
							title: '包裹柜下单',
							rale: parseFloat(data.data[0].retailArkNum / data.data[0].retailOrderSum).toFixed(2) * 100 + '%'
						},
						{
							num: data.data[0].retailPickupNum,
							title: '自提点下单',
							rale: parseFloat(data.data[0].retailPickupNum / data.data[0].retailOrderSum).toFixed(2) * 100 + '%'
						},
						{
							num: data.data[0].retailInternetNum,
							title: '互联网渠道',
							rale: parseFloat(data.data[0].retailInternetNum / data.data[0].retailOrderSum).toFixed(2) * 100 + '%'
						},
						{
							num: data.data[0].retailServiceNum,
							title: '客服下单',
							rale: parseFloat(data.data[0].retailServiceNum / data.data[0].retailOrderSum).toFixed(2) * 100 + '%'
						},
						{
							num: data.data[0].retailRandomNum,
							title: '随机订单',
							rale: parseFloat(data.data[0].retailRandomNum / data.data[0].retailOrderSum).toFixed(2) * 100 + '%'
						},
						{
							num: data.data[0].retailOtherNum,
							title: '其他',
							rale: parseFloat(data.data[0].retailOtherNum / data.data[0].retailOrderSum).toFixed(2) * 100 + '%'
						}
					]
					this.list = shddl2
				} else {
					let shddl2 = [{
							num: '0',
							title: '包裹柜下单',
							rale: '0%'
						},
						{
							num: '0',
							title: '自提点下单',
							rale: '0%'
						},
						{
							num: '0',
							title: '互联网渠道',
							rale: '0%'
						},
						{
							num: '0',
							title: '客服下单',
							rale: '0%'
						},
						{
							num: '0',
							title: '随机订单',
							rale: '0%'
						},
						{
							num: '',
							title: '其他',
							rale: '0%'
						}
					]
					this.list = shddl2
				}
			}).catch(err => {
				console.log(err);
			});
		},
	},
	beforeMount() {
		// this.init_ddltjs_2()
	},
	filters: {
		addSpot(source) {
			if (!source) return 0;
			if (source.length < 4) return source;
			if (Number.isInteger(source)) {
				source = source.toString()
			}
			var isMinus = false
			if (source.charAt(0) == '-') {
				isMinus = true
				source = source.slice(1)
			}

			let arr = [...source];
			let len = arr.length / 3;
			let newArr = [];
			for (let i = 0; i < len; i++) {
				let start = arr.length - 3 * (i + 1)
				let b = []
				if (start < 0) b = arr.slice(0, arr.length % 3);
				else b = arr.slice(start, arr.length - 3 * i);
				newArr.push(b.join(''));
			}
			if (isMinus) {
				return '-' + newArr.reverse().join(',');
			}
			return newArr.reverse().join(',');
		}
	},
	template: `<div>
        <div v-for="(i,index) in list" :key="index"
             style="display: flex; justify-content: space-between; width: 100%; font-size: 13px; color: #666666">
            <div style="width: 22%; padding: 0 7px">
                <p>{{i.title}}</p>
            </div>
            <div style="width: 78%; display: flex; align-items: center">
                <div style="width: 70%; height: 20px; display: flex; padding: 2px; border-radius: 5px">
                    <div class="dct_item">
                        <div style="height: 100%;" :style="{width: i.rale, 'background-color': index % 2 === 0 ? '#1D95F4' : '#48DCF1'}">

                        </div>
                    </div>
                </div>
                <div style="width: 30%; text-align: right; padding: 0 7px">
                    <p>{{i.num | addSpot}}</p>
                </div>
            </div>
        </div>
    </div>`
});


Vue.component('ddltj-component', {
	data() {
		return {

		}
	},
	methods: {
		init_data() {
			// let jrssl1 = {
			//     isUp: true,
			//     color: '#1D95F4',
			//     rale: '75',
			//     title: '今日实时量',
			//     fontColor: '#FF7362',   // isUp ? '#FF7362' : '#4CD998'
			//     orderNum: '1000000',
			//     tbNum: '4520'
			// }
			// let jrssl2 = {
			//     isUp: false,
			//     color: '#1D95F4',
			//     rale: '15',
			//     title: '协议客户订单量',
			//     fontColor: '#4CD998',   // isUp ? '#FF7362' : '#4CD998'
			//     orderNum: '650000',
			//     tbNum: '4520'
			// }
			// let jrssl3 = {
			//     isUp: false,
			//     color: '#1D95F4',
			//     rale: '15',
			//     title: '散户订单量',
			//     fontColor: '#4CD998',   // isUp ? '#FF7362' : '#4CD998'
			//     orderNum: '650000',
			//     tbNum: '4520'
			// }
			// this.$refs.jrssl1.init_data(jrssl1)
			// this.$refs.xykhddl1.init_data(jrssl2)

			// let list = [{
			//     num: '100000',
			//     title: '菜鸟',
			//    	rale: '30%'
			// },
			// {
			//     num: '150000',
			//     title: '拼多多',
			//     rale: '40%'
			// },
			// {
			//     num: '50000',
			//     title: '淘宝',
			//     rale: '35%'
			// },
			// {
			//     num: '100000',
			//     title: '京东',
			//     rale: '60%'
			// },
			// {
			//     num: '150000',
			//     title: '客户直连',
			//     rale: '50%'
			// },
			// {
			//     num: '100000',
			//     title: '其他',
			//     rale: '70%'
			// }]
			// this.$refs.xykhdd2.list = list

			// this.$refs.shddl1.init_data(jrssl3);

			// let list2 = [{
			//     num: '100000',
			//     title: '包裹柜下单',
			//     rale: '70%'
			// },
			// {
			//     num: '150000',
			//     title: '自提点下单',
			//     rale: '75%'
			// },
			// {
			//     num: '50000',
			//     title: '互联网渠道',
			//     rale: '35%'
			// },
			// {
			//     num: '100000',
			//     title: '客服下单',
			//     rale: '60%'
			// },
			// {
			//     num: '150000',
			//     title: '随机订单',
			//     rale: '50%'
			// },
			// {
			//     num: '100000',
			//     title: '其他',
			//     rale: '70%'
			// }]	

			// this.$refs.shddl2.list = list2

		},
	},
	template: `<div style="border-radius: 15px; width: 100%; margin-top: 15px; margin-bottom: 10px; border: 1px solid #E6E6E6; border-top: none">
            <div class="dd_title">
                订单量统计
            </div>
            <slot></slot>
        </div>`
})


Vue.component('zxt-compoent',{
    data() {
        return {

        }
    },
    methods: {
    	init_jrddl(x_data, todayYdata, yestodayYdata) {
				console.log(x_data, todayYdata, yestodayYdata,"x_data, todayYdata, yestodayYdata11");
            let legend = ['今日', '昨日'];
			let timeList = [];
        	let totalList = [];
        	let totalYesList = [];
        	console.log(x_data); //x轴
            console.log(todayYdata);  //今日
            console.log(yestodayYdata);  //昨日
            let xData = x_data.length>0 ? x_data:
            	['00:00', '01:00', '02:00', '03:00', '04:00', '05:00', '06:00', '07:00', '08:00', '09:00', '10:00', '11:00', 
            	 '12:00', '13:00', '14:00', '15:00', '16:00', '17:00', '18:00', '19:00', '20:00', '21:00', '22:00', '23:00', '24:00']
        	let series = [];
            legend.forEach((e, index) => {
                let setting = {
                    name: '收入',
                    type: 'line',
                    data: [20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 29, 28, 27, 26, 25, 24, 23, 23, 21, 21, 22, 23, 24],
                    symbolSize: 10,
                    symbol: 'circle',
                    itemStyle: {
                        normal: {
                            color: '#1D95F4',
                            barBorderRadius: 1,
                            borderColor: '#fff',
                            borderWidth: 2
                        }
                    },
                    lineStyle: {
                        normal: {
                            color: '#1D95F4',
                            width: 2
                        }
                    },
                    smooth: true
                }
                setting.name = e;
				if (index === 0) {
					// setting.data = todayYdata.length > 0 ? todayYdata:[0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
        	 setting.data = todayYdata		
					setting.itemStyle.normal.color = '#1D95F4';
        			setting.lineStyle.normal.color = '#1D95F4';
        		}
        		if (index === 1) {
        			// setting.data = yestodayYdata.length > 0 ? yestodayYdata:[0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
							setting.data = yestodayYdata
							setting.itemStyle.normal.color = '#1AE54B';
        			setting.lineStyle.normal.color = '#1AE54B';
        		}
                series.push(setting)
            })
						console.log(series,legend, xData, 'seriesseriesseries33');
						
            initTodayZheXian('chart2', legend, xData, series)
        },
        
        init_lsddl(lsddlList,lsddl_flag) {
            let flag = lsddl_flag;
            let legend2 = ['订单量'];
            let timeList = [];
        	let totalList = [];
        	if(lsddlList != null && lsddlList.length>0){
        		lsddlList.forEach((e,index) =>{
        			timeList.push(e.time);
        			totalList.push(e.total);
        		})
        	}
        	let xData2 = [];
        	if (flag === "7日内") {
        		xData2 = timeList.length > 0 ? timeList:[];
        	}
        	if (flag === "30日内") {
        		xData2 = timeList.length > 0 ? timeList:[];
        	}
        	if (flag === "12周内") {
        		xData2 = timeList.length > 0 ? timeList:[];
        	}
        	if (flag === "12月内") {
        		xData2 = timeList.length > 0 ? timeList:[];
        	}
			let series2 = [];
            legend2.forEach((e, index) => {
                let setting = {
                    name: '收入',
                    type: 'line',
                    data: [],
                    symbolSize: 10,
                    symbol: 'circle',
                    itemStyle: {
                        normal: {
                            color: '#1D95F4',
                            barBorderRadius: 1,
                            borderColor: '#fff',
                            borderWidth: 2
                        }
                    },
                    lineStyle: {
                        normal: {
                            color: '#1D95F4',
                            width: 2
                        }
                    },
                    smooth: true
                }
                setting.name = e;

               if (index === 0 && flag === '7日内') {
                	setting.data = totalList.length > 0 ? totalList:[];
        			setting.itemStyle.normal.color = '#1D95F4';
                    setting.lineStyle.normal.color = '#1D95F4';
                }
                if (index === 0 && flag === '30日内') {
                	setting.data = totalList.length > 0 ? totalList:[];
        			setting.itemStyle.normal.color = '#1D95F4';
                    setting.lineStyle.normal.color = '#1D95F4';
                }
                if (index === 0 && flag === '12周内') {
                	setting.data = totalList.length > 0 ? totalList:[];
        			setting.itemStyle.normal.color = '#1D95F4';
                    setting.lineStyle.normal.color = '#1D95F4';
                }
                if (index === 0 && flag === '12月内') {
                	setting.data = totalList.length > 0 ? totalList:[];
        			setting.itemStyle.normal.color = '#1D95F4';
                    setting.lineStyle.normal.color = '#1D95F4';
                }
               /*
				 * if (index === 1) { setting.data = [265, 102, 22, 26, 121, 42,
				 * 216, 221, 234, 265, 102, 182] setting.itemStyle.normal.color =
				 * '#1AE54B'; setting.lineStyle.normal.color = '#1AE54B' } if
				 * (index === 2) { setting.data = [121, 42, 216, 221, 234, 42,
				 * 26, 21, 23, 65, 12, 82] setting.itemStyle.normal.color =
				 * '#1E1F89'; setting.lineStyle.normal.color = '#1E1F89' } if
				 * (index === 4) { setting.data = [121, 123, 165, 121, 182, 142,
				 * 126, 121, 123, 165, 121, 182] setting.itemStyle.normal.color =
				 * '#CD01FF'; setting.lineStyle.normal.color = '#CD01FF' } if
				 * (index === 5) { setting.data = [42, 26, 21, 23, 65, 242, 226,
				 * 212, 223, 265, 122, 282] setting.itemStyle.normal.color =
				 * '#01A572'; setting.lineStyle.normal.color = '#01A572' }
				 */
                series2.push(setting)
            });
            initHisZheXian('chart3', legend2, xData2, series2, lsddl_flag)
        },
    },
    props: {
        title: {
            type: String,
            required: true
        },
        id_name: {
            type: String,
            required: true
        }
    },
    mounted(){
    },
    template: `<div style="border-radius: 15px; width: 100%; margin-top: 15px; margin-bottom: 10px">
            <div class="dd_title" style="position: relative;" >
                {{title}}
                <div style="position: absolute; right: 15px; top: 0">
                    <slot>
                        <p></p>
                    </slot>
                </div>
            </div>
            <div :id="id_name" class="content border_echaers"></div>
        </div>`
});

Vue.component('tjzb-component', {
	data() {
		return {

		}
	},
	methods: {
		init_data() {}
	},
	template: `<div style="border-radius: 15px; width: 100%; margin-top: 15px; margin-bottom: 10px; border: 1px solid #E6E6E6; border-top: none">
            <div class="dd_title">
                统计指标
            </div>
            <slot></slot>
        </div>`
})

Vue.component('ycjk-component', {
	data() {
		return {
			ycjk: {
				rale: 0,
				yslszl: '--'
			}
		}
	},
	methods: {
		init_data(data) {
			for (let key in data) {
				this[key] = data[key]
			}
		}
	},
	filters: {
		addSpot(source) {
			if (!source) return 0;
			if (source.length < 4) return source;
			if (Number.isInteger(source)) {
				source = source.toString()
			}
			var isMinus = false
			if (source.charAt(0) == '-') {
				isMinus = true
				source = source.slice(1)
			}
			let arr = [...source];
			let len = arr.length / 3;
			let newArr = [];
			for (let i = 0; i < len; i++) {
				let start = arr.length - 3 * (i + 1)
				let b = []
				if (start < 0) b = arr.slice(0, arr.length % 3);
				else b = arr.slice(start, arr.length - 3 * i);
				newArr.push(b.join(''));
			}
			if (isMinus) {
				return '-' + newArr.reverse().join(',');
			}
			return newArr.reverse().join(',');
		}
	},
	template: `<div
	style="border-radius: 15px; width: 100%; margin-top: 15px; margin-bottom: 10px; border: 1px solid #E6E6E6; border-top: none">
	<div class="dd_title">异常监控</div>
	<div
		style="display: flex; justify-content: space-between; padding: 15px 8px">
		<div class="yccl" style="margin-top: 10px;">
			<div style="position: relative;">
				<svg viewBox="0 0 100 100" style="height: 110px">
                <defs>
                    <linearGradient id="blue" x1="0%"
						y1="0%" x2="100%" y2="0%">
                        <stop offset="0%"
						style="stop-color:rgb(255,51,51);  stop-opacity:1"></stop>
                        <stop offset="50%"
						style="stop-color:rgb(255,179,0);stop-opacity:1"></stop>
                        <stop offset="100%"
						style="stop-color:rgb(76,217,152);stop-opacity:1"></stop>
                    </linearGradient>
                </defs>
                <path
						d="
    M 50 50
    m 0 -44
    a 44 44 0 1 1 0 88
    a 44 44 0 1 1 0 -88
    "
						stroke="#e5e9f2" stroke-width="11.9" fill="none"
						style="stroke-dasharray: 276.46px, 276.46px; stroke-dashoffset: 2px;"></path>
                <path
						d="
    M 50 50
    m 0 -44
    a 44 44 0 1 1 0 88
    a 44 44 0 1 1 0 -88
    "
						stroke="url(#blue)" fill="none" stroke-linecap="round"
						stroke-width="11.9" class="aaa"
						:style="{'stroke-dasharray': (276.46 * ycjk.rale / 100).toFixed(3) + 'px, 276.46px'}"></path>
            </svg>
				<img src="../order_css/jingbao.png" alt=""
					style="position: absolute; width: 25px; top: 37%; left: 50%; transform: translate3d(-50%, -50%, 0);">
				<div class="cale" style="top: 60%; color: #000; font-size: 15px">{{ycjk.yslszl
					| addSpot}}</div>
			</div>
			<p style="color: #000; font-size: 15px; font-weight: normal;">应揽未揽总量</p>
		</div>
		<div class="yccl">
			<div style="height: 60px">
				<p
					style="color: #000; font-size: 18px; line-height: 30px; text-align: left; margin-left: 8px">协议客户量</p>
				<div style="display: flex; margin-top: 5px">
					<div v-for="i in 1" :key="i"
						style="width: 20px; height: 30px; background-color: red; margin-left: 5px; line-height: 30px">
						<span style="font-weight: bold; font-size: 16px">--</span><!--{{i}}-->
					</div>
				</div>
			</div>
			<div style="height: 60px; margin-top: 5px">
				<p
					style="color: #000; font-size: 18px; line-height: 30px; text-align: left; margin-left: 8px">散户量</p>
				<div style="display: flex; margin-top: 5px">
					<div v-for="i in 1" :key="i"
						style="width: 20px; height: 30px; background-color: red; margin-left: 5px; line-height: 30px">
						<span style="font-weight: bold; font-size: 16px">--</span>
					</div>
				</div>
			</div>
		</div>
	</div>
</div>`
})
//千位分隔符
function toThousands(num) {
	return (num || 0).toString().replace(/(\d)(?=(?:\d{3})+$)/g, '$1,');
}
