//柱形图
Vue.component('barBox', {
    data() {
        return {
            total: 0
        }
    },
    mounted() {
        // this.initBar()
        console.log(this.idName, '柱状图ID-----------')
    },
    methods: {
        initBar(data = {
            xData: ['2019Q1', '2019Q2', '2019Q3', '2019Q4'],
            legend: '人数',
            values: [40, 80, 20, 16],
            colors: ['#2699F4', '#75C3EC'],
            name: '车辆数',
            xFontSize: 12,
            xRotate: 0
        }) {
            const _this = this;
            let mychart = echarts.init(document.getElementById(_this.idName));
            // let myChart = echarts.init(document.getElementById('barId'));
            let option = {
                grid: {
                 left: '10%',
                 top: '20',
                 right: '30',
                 bottom: '50',
             },
             tooltip: {
                 trigger:'axis',
                 formatter: '{b}<br />{a0}: {c0}%'
             },
             xAxis: [{
                 type: 'category',
                 data: [ 
                     {
                         value: e[0],
                         textStyle: {
                            color: '#000000',  //更改坐标轴文字颜色
                            fontSize : 15      //更改坐标轴文字大小
                          }
                  },e[1],e[2],e[3],e[4]],
                 'axisLine': {
                     lineStyle: {
                         color: '#000000'
                     }
                 },
                 'splitLine': {
                     'show': false
                 },
                 'axisTick': {
                     'show': true
                 },
                 'splitArea': {
                     'show': false
                 },
                 'axisLabel': {
                     'interval': 0,
                     'rotate': 40
                 }
             }],
             yAxis: [{
                 type: 'value'
             }],
             series: [
                 {
                     name:'实际值',
                     type:'bar',
                     barWidth: '60%',
                     data:[72.45, 88.45, 95.25, 99.45, 98.21],
                     /* markPoint : {
                         symbol:'pin',//标记类型
                         symbolSize: 40,//图形大小
                         itemStyle: {
                             normal: {
                                 borderColor: '#fff',
                                 borderWidth: 1,            // 标注边线线宽，单位px，默认为1
                                 label: {
                                     show: true
                                 },
                                 color:'#BD60F6'
                             }
                         },
                         data : [//配置项
                             {value:'55',xAxis:0, yAxis:55},
                                {value:'90',xAxis:1, yAxis:90},
                             {value:'15',xAxis:2, yAxis:15},
                             {value:'20',xAxis:3, yAxis:20},
                             {value:'25',xAxis:4, yAxis:25},                  
                        ]
                     }, */
                     itemStyle:{
                         normal:{
                             color:function(params){
                                 if(params.value >0 && params.value <90){
                                     return "#F57371";
                                 }else{
                                    return "#2BC999";
                                 }
                             },
                             label: {
                                 show: true, //开启显示
                                 position: 'top', //在上方显示
                                 textStyle: { //数值样式
                                     color: 'black',
                                     fontSize: 15
                                 }
                             }
                         }
                     }
                 /* },{
                     name: '目标值',
                     type: 'line',
                     smooth: true,
                     itemStyle: {
                         normal: {
                             color: "#C4352D", //折线点的颜色
                             lineStyle: {
                                 color: "#C4352D" //折线的颜色
                             }
                         }
                     },
                     data: [50, 50, 50, 50, 50] */
                 }
             ]
         };
         // 为echarts对象加载数据 
         myChart.setOption(option);
        }
    },
    props: {
        idName: String,
    },
    template: `<div style="min-height: 100px; ">
                    <div style="display: flex; justify-content: center; padding: 0 5px">
                        <div :id="idName" style="width: 100%; height: 300px;"></div>
                    </div>
                </div>`
});

Vue.component('select-list', {
    model: {
        prop: 'msg',
        event: 'change'
    },
    props: {
        msg: String,
        dropdownlist: {
            Array,
            default: () => {
                return []
            }
        },
        height: '35'
    },
    computed: {
        title() {
            return this.dropdownlist.find(i => i.val === this.msg).name
        }
    },
    methods: {
        handleCommand(command) {
            this.$emit('change', command)
        }
    },
    template: `<div>
                    <el-dropdown trigger="click"  @command="handleCommand">
                        <span class="el-dropdown-link">
                            {{title}}<i class="el-icon-caret-bottom el-icon--right"></i>
                        </span>
                        <el-dropdown-menu :style="{'height': height+'px', 'overflow': (dropdownlist && dropdownlist.length < 8) ? 'hidden' : 'auto'}" class="project-dropdown" slot="dropdown">
                            <el-dropdown-item v-for="item in dropdownlist" :command="item.val">{{item.name}}</el-dropdown-item>
                        </el-dropdown-menu>
                    </el-dropdown>
                </div>`
});
