var red = {
	components: {
	},
	props: ['show','month','monthType','businessType','sumLevel','sendProvCode'],
	data(){
		return {
		   	noData:false,
		   	tablecolumn: [],
		   	list: [],
		   	specialName: [],
		   	redBy: null,
		};
	},
	watch: {
		show: function(val){
			if(this.show && this.list.length == 0){
				this.initData();
			}
		},
		month: function(val, oldVal){
			this.initData();
		},
	},
	computed: {
    	tableHeight: function(){
    		let w = document.documentElement.clientWidth || document.body.clientWidth;
    		let h = document.documentElement.clientHeight || document.body.clientHeight;
        	return h - (w*100) / 375 * 0.1;
    	},
	},
	methods: {
		/*特快60%以上绿，40%以下红，快包55%以上绿，35%以下红*/
		initRedBy(){
    		if(this.businessType == "B"){
    			this.redBy = {
    				min: 40,
    				max: 60,
    			};
    		}else if(this.businessType == "K"){
    			this.redBy = {
    				min: 35,
    				max: 55,
    			};
    		}
    	},
	    initData(){
    		this.initRedBy();
 	    	let params = {
 	    		dateType: this.getMT(),
 	 	     	dataDate: this.month,
 	 	     	sumLevel: this.sumLevel,
 	 	     	businessType: this.businessType,
 	 	     	sendProvCode: this.sendProvCode
 			}
 	    	console.log(params)
 	    	queryMailEachOtherRate(params).then(({data}) => {
 				if(!data){
 		 			this.noData = true;
 		 			return;
 		 		}
 		 		let json = data;
 		 		console.log(data)
 		 		let imp = json.rowHeaders; //列头
 		 		let exp = json.colHeaders; //行头
 		 		let d = json.data;
 		 		console.log(d)
 		 		let cols = [];
 		      	cols.push({
 		      		label: '进出口',
 		      		key: 'name',
 		      		width: 70,
 		      		fixed: false,
 		      	});
      	    	/*imp.unshift({
      	    		importCityCode:  '100000',
 			   		importCityName: '进口汇总',
 			   	});
      	    	exp.unshift({
 			   		exportCityCode:  '100000',
 			   		exportCityName: '出口汇总',
 			   	});*/
 		      	imp.forEach((e,i) => {
 		      		let col = {};
 		      		col.label = e.receiveCityName;
 		      		col.key = e.receiveCityCode;
 		      		col.width = 70,
 		      		col.isRate = true,
 		      		cols.push(col);
 		      	})
 		      	this.tablecolumn = cols;
 		      	
 		      	let list = [];

 		      	for(let z = 0; z < d.length; z ++) {
 		      		let row = {}
 		      		let color = []
 		      		exp.forEach((its,i) => {
 		      			let str = d[z][i] !== null ? d[z][i].split("_")[0] : d[z][i]
 		      		 	row[its.sendCityCode] = this.convertToRate(str) !== "NaN" ? this.convertToRate(str) : '-'
 		      		   	color.push(d[z][i] !== null ? d[z][i].split("_")[1] : d[z][i])
	 		      	})
 		      		//console.log(color, 'color------')
 		      		row['color'] = color
 		      		//console.log(row)
 		      		list.push(row);
 		     	}
 		      	 list.forEach((row,idx) => {
 		      		for (let x = 0; x < exp.length; x++) {
 		      			if (idx === x) {
 		      		   		row.name = exp[x].sendCityName;
 		      		    	break;
 		      			}
 		      		}
 		     	})
 		      	console.log(list)
 		      	this.list = list;
 		 		this.noData = false;
 			}).catch(err => {
 		 		this.noData = true;
 		 		console.log(err);
 		 	});
	    },
	    getMT(){
    		if(this.monthType === 'day') return 'D';
    		if(this.monthType === 'month') return 'M';
    		if(this.monthType === 'week') return 'W';
    		if(this.monthType === 'sevenDay') return 'W';
    		return this.monthType;
	    },
        notEmpty(arg){
        	if(arg === undefined || arg === '' || arg == null){
        		return false;
        	}else{
        		return true;
        	}
        },
        convertToName(arg){
        	return this.notEmpty(arg) ? arg : '其他';
        },
        convertToRate(arg){
        	return this.notEmpty(arg) ? (arg * 1).toFixed(2) : '-';
        },
        convertToW(arg){
        	return this.notEmpty(arg) ? Math.round(arg / 10000) : '-';
        },
	},
	created() {
	},
	mounted() {
		if(this.show && this.month){
			this.initData();
		}
	},
    template: `
    	<div>
			<div v-show="!noData">
				<drill-down-box
					ref="table"
					class="red"
					:list="list"
					:tablecolumn="tablecolumn"
					:table-height="tableHeight"
					:special-name="specialName"
					:red-by="redBy"
					is-border="true"
					/>
			</div>
			<div class="noData" v-if="noData">
				<img src="../../image/nodata.png" alt="暂无数据"/>
				<h3>暂无数据</h3>
			</div>
    	</div>
    `,
};