var panel = {
	props: ['panelArr', 'panelData','isShow','noData','countDate'],
	data() {
		return {
            //弹框
            isShowDialog: false,
            dialogTitle: '',
            dialogList: {},
		}
	},
	template: `
		<div class="topTab">
			<div v-if="!noData" class="panelCardBox">
				<div 
					class="panelCard radiu-shadow"
					v-for="item in panelArr" :key="item.id"
					v-show="panelData[item.dataKey]"
				>
					<p class="panelTitle">
						<img class="titleImg" :src="item.imgUrl" :alt="item.title" />
						<span>{{item.title}}</span>
						<img v-if="item.dialogTitle != ''" src="../../image/description_icon.png" alt="注释"  @click="openDialog(item)" />
					</p>
					<div class="panelContent" @click="goToDetail(item)">
						<div class="panelContentLeft">
							<p class="textCenter color333">当月完成值</p>
							<p class="textCenter ratio">{{formatNum(panelData[item.dataKey], 'comValue',item.dataKey)}} <span class="unit">{{item.unit}}</span> </p>
							<p>环比:
							 <span :class="panelData[item.dataKey].link == null ? 'fontBold color333' : (panelData[item.dataKey].link >= 0 ? 'fontBold colorUp' : 'fontBold colorDown')">{{formatNum(panelData[item.dataKey], 'link',item.dataKey)}}</span> 
							 <span class="unit">{{item.unit}}</span> </p>
							<p>最高:
								<span class="fontBold">{{formatNum(panelData[item.dataKey], 'maxComName',item.dataKey)}}</span>
								<span class="fontBold colorUp">{{formatNum(panelData[item.dataKey], 'maxComValue',item.dataKey)}}</span>
								<span class="unit">{{item.unit}}</span>
							</p>
							<p>最低:
								<span class="fontBold">{{formatNum(panelData[item.dataKey], 'minComName',item.dataKey)}}</span>
								<span class="fontBold colorDown">{{formatNum(panelData[item.dataKey], 'minComValue',item.dataKey)}}</span>
								<span class="unit">{{item.unit}}</span>
							</p>
						</div>
						<div class="panelContentRight">
							<p class="textCenter color333">当年累计值</p>
							<p class="textCenter ratio">{{formatNum(panelData[item.dataKey], 'yearComValue',item.dataKey)}}
							<span class="unit">{{item.unit}}</span>
							</p>
							<p></p>
							<p>最高:
								<span class="fontBold">{{formatNum(panelData[item.dataKey], 'maxYearComName',item.dataKey)}}</span>
								<span class="fontBold colorUp">{{formatNum(panelData[item.dataKey], 'maxYearComValue',item.dataKey)}}</span>
								<span class="unit">{{item.unit}}</span>
							</p>
							<p>最低:
								<span class="fontBold">{{formatNum(panelData[item.dataKey], 'minYearComName',item.dataKey)}}</span>
								<span class="fontBold colorDown">{{formatNum(panelData[item.dataKey], 'minYearComValue',item.dataKey)}}</span>
								<span class="unit">{{item.unit}}</span>
							</p>
						</div>
					</div>
				</div>
				<!-- 注释弹框 -->
				<xk-dialog @func="closeDialog" :visible='isShowDialog' :title="dialogTitle" :data-list="dialogList"></xk-dialog>
			</div>
		</div>
	`,
    watch: {
    },
	methods: {
        // 跳转到详情页
        goToDetail(item) {
            let param = {
                indexType: item.id,
                indexName: item.title,
                countDate: this.countDate
            };
            param = JSON.stringify(param);
            Emp.execute('goToDetail('+param+')');
        },
        // 数据格式化
        formatNum(data, key,indexType) {
            let nameArr = ['maxComName', 'minComName', 'maxYearComName', 'minYearComName','link'];
            if (indexType == 'indexType6'|| indexType == 'indexType7' || indexType == 'indexType8'
                ||indexType == 'indexType9' || indexType == 'indexType10'){
                if (key === 'maxComName' || key === 'minComName' || key === 'maxYearComName' || key === 'minYearComName'){
                    return data[key];
                }
                if (key === 'link'){
                    if(data[key] === '' || data[key] === 'undefined' || data[key] === 'null' || data[key] === '{}' || data[key] === null  || data[key] === undefined){
                        return data ? (data[key] ? Number(data[key] * 1).toFixed(2) + "%" : '--%') : '--%';
                    }else{
                        return (data.link * 1).toFixed(2) + '%';
                    }
                }
                else {
                    return (data[key] * 1).toFixed(2) + '%';
                }
            }
            if (nameArr.indexOf(key) == 4 ){
                if(data.link === '' || data.link === 'undefined' || data.link === 'null' || data.link === '{}' || data.link === null  || data.link === undefined){
                    return data ? (data[key] ? Number(data[key] * 1).toFixed(2) + "" : '--') : '--';
                }else{
                    return (data.link * 1).toFixed(2);
                }
            }
            if ( nameArr.indexOf(key) !== -1) {
                return data ? (data[key]?data[key]:'--') : '--';
            }else{

                return data ? (data[key]  != null  || data[key] != undefined ? Number(data[key]*1).toFixed(2) : '--') : '--';
            }

        },
        // 打开注释弹框
        openDialog(item) {
            this.dialogTitle = item.dialogTitle;
            this.dialogList = item.dialog;
            this.isShowDialog = true;
        },
        // 关闭注释弹框
        closeDialog() {
            this.isShowDialog = false;
        },
	}

};
